<?php
if(!defined('sugarEntry'))define('sugarEntry', true);

require_once('include/entryPoint.php');
require_once('include/OnlineMeetings/OnlineMeetingsFactory.php');

$error = false;

if (! empty($_GET['error'])) {
    $error = $_GET['error_description'] ?? 'Authentication error';
} elseif (! empty($_GET['code'])) {
	$for_company = !empty($_GET['state']) && $_GET['state'] == 'company';

	if (\AppConfig::session_start() && isset($_SESSION['authenticated_user_id'])) {
		$authController = new \AuthenticationController();
		$result = $authController->sessionAuthenticate();
	}

	if ($for_company && !AppConfig::is_admin()) {
		$error = 'Admin only';
	} else {
		try {
			$online_meeting = OnlineMeetingsFactory::getInstance();
		} catch (OnlineMeetingException $e) {
			$error = $e->getMessage();
		}

		if ($online_meeting) {
			try {
				$token = $online_meeting->obtainToken($_GET['code'], $for_company);
				$online_meeting->saveAccessToken($token, $for_company);
				$error = false;
			} catch (Exception $e) {
				$error = $e->getMessage();
			}
		}
	}
} else {
	$error = 'There are some errors during authorization process.';
}
?>
<script>
    var error = "<?php echo $error?>";
    try {
        var error_div = window.opener.document.getElementById('om_error_message');
        var success_div = window.opener.document.getElementById('om_success_message');
        if (error) {
            if (error_div) {
                error_div.style.display = 'block';
                error_div.innerText = error;
            }
            if (success_div) {
                success_div.style.display = 'none';
            }
        } else {
            if (error_div) {
                error_div.style.display = 'none';
            }
            if (success_div) {
                success_div.style.display = 'block';
            }
        }
    } catch (e) {
    }
    window.close();
</script>
