<?php
set_time_limit(0);
ignore_user_abort(true);

define('sugarEntry', true);
define('ONECRM_CSRF_PROTECT', 'none');
include 'include/entryPoint.php';
require_once 'include/SabreDAV/OneCRM/DAV/Auth/DAVAuthenticate.php';

$authController = new AuthenticationController();
$authController->authController = new DAVAuthenticate;

if(! AppConfig::setting('site.features.caldav_sync_enabled'))
	die('CalDAV server is disabled');

$url = parse_url(AppConfig::setting('site.base_url'));
$baseUri = array_get_default($url, 'path', '') . '/caldav.php/';
$baseUri = AppConfig::setting('site.features.caldav_custom_path', $baseUri);
$baseUri = preg_replace('~/+~', '/', $baseUri);

$GLOBALS['log']->debug('CalDAV Sync Request: ' . $baseUri .' From: '. $_SERVER['HTTP_USER_AGENT']);

//Mapping PHP errors to exceptions
/*function exception_error_handler($errno, $errstr, $errfile, $errline ) {
    throw new \ErrorException($errstr, 0, $errno, $errfile, $errline);
}
set_error_handler("exception_error_handler");*/

require_once 'include/SabreDAV/autoload.php';

// Backends
$authBackend  = new OneCRM\DAV\Auth\Backend;
$principalBackend = new OneCRM\DAVACL\PrincipalBackend(true);
$caldavBackend = new OneCRM\CalDAV\Backend;

// Directory structure
$tree = array(
    new \Sabre\CalDAV\Principal\Collection($principalBackend),
    new \Sabre\CalDAV\CalendarRoot($principalBackend, $caldavBackend),
);

$server = new \Sabre\DAV\Server($tree);

if (isset($baseUri))
    $server->setBaseUri($baseUri);

/* Server Plugins */
$authPlugin = new \Sabre\DAV\Auth\Plugin($authBackend);
$server->addPlugin($authPlugin);

//$aclPlugin = new \Sabre\DAVACL\Plugin();
$aclPlugin = new OneCRM\DAVACL\PluginExt();
$aclPlugin->allowUnauthenticatedAccess = false;
$server->addPlugin($aclPlugin);

$caldavPlugin = new \Sabre\CalDAV\Plugin();
$server->addPlugin($caldavPlugin);

// Support for html frontend
$browser = new \Sabre\DAV\Browser\Plugin();
$server->addPlugin($browser);

$sync = new \Sabre\DAV\Sync\Plugin();
$server->addPlugin($sync);

// And off we go!
$server->start();
