<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  Defines the English language pack for the base application.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/
define('sugarEntry', true);
define('ONECRM_CSRF_PROTECT', 'none');
require_once('include/entryPoint.php');

// logic will be added here at a later date to track campaigns
// this script; currently forwards to site_URL variable of $sugar_config
// redirect URL will also be added so specified redirect URL can be used

// additionally, another script using fopen will be used to call this
// script externally

require_once('modules/Campaigns/utils.php');

if(!empty($_REQUEST['identifier'])) {
	$keys = CampaignActivityTracker::log_campaign_activity($_REQUEST['identifier'],'link');
}

if(empty($_REQUEST['track'])) {
	$track = "";
} else {
	$track = $_REQUEST['track'];
}
$row = null;

if(preg_match('^[0-9A-Za-z\-]+$', $track)) {
	$row = ListQuery::quick_fetch_key('Campaign', 'tracker_key', $track, ['refer_url']);
}

if ($row) {
    $redirect_URL = null;
    if (!empty($_GET['_r'])) {
        $redirect_URL = @base64_decode($_GET['_r']);
    }
    if (!$redirect_URL) {
        $redirect_URL = $row->getField('refer_url');
    }
	sugar_cleanup();
	header("Location: $redirect_URL");
} else {
	sugar_cleanup();
}
exit;

