<?php
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  Defines the English language pack for the base application.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/

define('sugarEntry', true);
define('ONECRM_CSRF_PROTECT', 'none');
require_once 'include/entryPoint.php';
require_once 'include/database/ListQuery.php';
require_once 'modules/Campaigns/utils.php';

$GLOBALS['log'] = AppConfig::create_logger('campaign tracker');

$track = (string)array_get_default($_REQUEST, 'track', '');
$identifier = (string)array_get_default($_REQUEST, 'identifier', '');

if (!empty($identifier)) {
	$keys = CampaignActivityTracker::log_campaign_activity($identifier, 'link', true, $track);
} else {
    //if this has no identifier, then this is a web/banner campaign
    //pass in with id set to string 'BANNER'
    $keys = CampaignActivityTracker::log_campaign_activity('BANNER', 'link', true, $track);
}

$row = ListQuery::quick_fetch_row('CampaignTracker', $track);
$msg = '';
if ($row) {
	$redirect_URL = array_get_default($row, 'tracker_url');
	if ($redirect_URL)
		header("Location: $redirect_URL");

	$msg = $row['content'];
}
sugar_cleanup(true, $msg);
