<?php
set_time_limit(0);
ignore_user_abort(true);

define('sugarEntry', true);
define('ONECRM_CSRF_PROTECT', 'none');
include 'include/entryPoint.php';
require_once 'include/SabreDAV/OneCRM/DAV/Auth/DAVAuthenticate.php';

AppConfig::restrict_entry_point();

$authController = new AuthenticationController();
$authController->authController = new DAVAuthenticate;

if(! AppConfig::setting('site.features.carddav_sync_enabled'))
	die('CardDAV server is disabled');

// Make sure this setting is turned on and reflect the root url for your WebDAV server.
// This can be for example the root / or a complete path to your server script
$url = parse_url(AppConfig::setting('site.base_url'));
$baseUri = array_get_default($url, 'path', '') . '/carddav.php/';
$baseUri = AppConfig::setting('site.features.carddav_custom_path', $baseUri);
$baseUri = preg_replace('~/+~', '/', $baseUri);

$GLOBALS['log']->debug('CardDAV Sync Request: ' . $baseUri .' From: '. $_SERVER['HTTP_USER_AGENT']);
//Mapping PHP errors to exceptions
/*function exception_error_handler($errno, $errstr, $errfile, $errline ) {
    throw new ErrorException($errstr, 0, $errno, $errfile, $errline);
}
set_error_handler("exception_error_handler");*/

require_once 'include/SabreDAV/autoload.php';

// Backends
$authBackend = new OneCRM\DAV\Auth\Backend;
$principalBackend = new OneCRM\DAVACL\PrincipalBackend;
$carddavBackend = new OneCRM\CardDAV\Backend;

// Setting up the directory tree //
$nodes = array(
    new Sabre\DAVACL\PrincipalCollection($principalBackend),
    new Sabre\CardDAV\AddressBookRoot($principalBackend, $carddavBackend),
);

// The object tree needs in turn to be passed to the server class
$server = new Sabre\DAV\Server($nodes);
$server->setBaseUri($baseUri);

// Plugins
$server->addPlugin(new Sabre\DAV\Auth\Plugin($authBackend));
$server->addPlugin(new Sabre\DAV\Browser\Plugin());
$server->addPlugin(new Sabre\CardDAV\Plugin());
//$server->addPlugin(new Sabre\DAVACL\Plugin());
$aclPlugin = new OneCRM\DAVACL\PluginExt();
$aclPlugin->allowUnauthenticatedAccess = false;
$server->addPlugin($aclPlugin);
$server->addPlugin(new Sabre\DAV\Sync\Plugin());

// And off we go!
$server->start();
