<?php

define('sugarEntry', 1);
define('ONECRM_CSRF_PROTECT', 'none');

require_once 'include/entryPoint.php';
require_once 'include/chat/ChatAPIServer.php';


$authController = new AuthenticationController();

if(! AppConfig::session_start()) {
	header('HTTP/1.1 503 Service Unavailable');
	die('Error starting session');
}


session_write_close();

$server = new ChatAPIServer;
if($server->authRequired()) {
	$current_user = new User();
	if(empty($_SESSION['authenticated_user_id']))
		$not_auth = true;
	else {
		if(! $authController->sessionAuthenticate()) {
			session_destroy();
			$not_auth = true;
		}
	}

	if(! empty($not_auth)) {
		header('HTTP/1.1 401 Not Authorized');
		die('User is not authenticated');
	}

	if(! AppConfig::check_init_user()) {
		$GLOBALS['log']->warn('Cancel request: user not initialized');
		exit;
	}
}

$server->processRequest();

