{*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************}

<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.01 Strict//EN">
<html {$DIR}>
<head>
{$FAVICON}
<meta http-equiv="Content-Type" content="{$CONTENT_TYPE}">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>{$PAGE_TITLE}</title>
{$HEADER_INCLUDES}
<script type="text/javascript">
SUGAR.themes.imagePath = '{$IMAGE_PATH}';
{if $ONLOAD}
YAHOO.util.Event.onDOMReady(function() {ldelim} {$ONLOAD} {rdelim});
{/if}
{if $hide_side_menu && $hide_side_menu != 'guess'}SUGAR.themes.show_left_col = false;{/if}
YAHOO.util.Event.onDOMReady(SUGAR.themes.initLeftCol);
</script>

{literal}<!--[if lt IE 7]>
<style type="text/css">
	img { behavior:	url("{$STATIC_URL}include/pngbehavior.htc"); }
</style>
<![endif]-->
<!--[if lte IE 7]>
<style type="text/css">
	ul.tabBar li, .menutab, .popupMenuBarOuter { display: inline; }
	.icon-box, .icon-box-default { display:inline; zoom:1; }
	.button, .buttonOn, .button:hover, .button:focus { padding: 0; margin: 0; line-height: auto; }
	button, input[type="button"], input[type="submit"], input[type="reset"] {
		padding: 0; margin: 0; line-height: auto; }
</style>
<![endif]-->
<!--[if lte IE 8]>
<link type="text/css" rel="stylesheet" media="all" href="{/literal}{$CSS_PREFIX}themes/{$THEME}/ie-compat.css{$CSS_SUFFIX}{literal}" />
<![endif]-->{/literal}
</head>

<body class="color-{$current_color_style}{if $texture_enabled} textured{/if}">

	{if ! $disableFloat}
	<div class="floating-tbar" id="tbarDiv">
	<table class="tbar-table" border="0" cellpadding="0" cellspacing="0" width="100%" onclick="window.scroll(0, 0);">
	<tr>
		<td class="tbar-cell app-name" width="50%">
			<a href="{$IAH_INFO_LINK}">{iah_icon_image path="include/images/iah/tlr-mini.png"}&nbsp;{$APP.NTC_APPNAME}{if $LICENSEE}<span class="lic-info">: {$LICENSEE} ({$MAX_USERS}U)</span>{/if}{if $WARN} {$WARN}{/if}</a>
		</td>
		{if $IAH_SEARCH_LINK}
		<td class="tbar-cell">
		<form name='UnifiedSearch' method="GET" autocomplete="off">
			<input type="hidden" name="module" value="Home">
			<input type="hidden" name="action" value="UnifiedSearch">
			<div class="input-complex input-outer input-search tbar-search" id="searchField-input"
				><div class="input-icon icon-search"></div
				><a class="input-icon icon-clear search-clear" style="display: none"></a
				><input type="text" class="input-text input-entry" autocapitalize="off"
					results="9" incremental="false" size="10" name="query_string" id="searchField"
					value="{$SEARCH}" autosave="com.infoathand.crm_search" /></div>
		</form>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.initForm('UnifiedSearch', [
				new SUGAR.ui.SearchInput('searchField-input', {name: 'query_string', onclick: function(evt) { YEvent.stopPropagation(evt); } })
			]);
		{/literal}{/iah_script}
		</td>
		{/if}
		{if $menu_calendar}
		<td class="tbar-cell">
			<a class="box with-popup" href="{$IAH_DAY_LINK}" id='tbar-calendar'>{iah_icon_image name='CalendarDay'}&nbsp;{$DATE}</a>
		</td>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.registerMenuSource('tbar-calendar', {options: {/literal}{$menu_calendar}{literal}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: 'center', outer_margin: 0}});
		{/literal}{/iah_script}
		{/if}
		{if $menu_email}
		<td class="tbar-cell">
			<a class="box with-popup" href="{$IAH_EMAIL_LINK}" id='tbar-email'>{iah_icon_image name='Emails'}&nbsp;<span id="new_emails_counter">{$NEW_EMAILS}</span></a>
		</td>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.registerMenuSource('tbar-email', {options: {/literal}{$menu_email}{literal}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: 'center', outer_margin: 0}});
		{/literal}{/iah_script}
		{/if}
		{if $CURRENT_USER && $menu_system}
		<td class="tbar-cell">
			<a class="box with-popup" style="font-weight: bold" href="{$IAH_PROFILE_LINK}" id='tbar-profile'>{iah_icon_image name='User'}&nbsp;{$CURRENT_USER.first_name|default:$CURRENT_USER.user_name}</a>
		</td>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.registerMenuSource('tbar-profile', {options: {/literal}{$menu_system}{literal}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: 'center', outer_margin: 0}});
		{/literal}{/iah_script}
		{/if}
	</tr>
	</table>
	</div>
	{/if}

	{if $module_tabs.more_tabs}
	<div id="MoreMenu" class="menu" onmouseover="window.clearTimeout(SUGAR.themes.resetSubTabsTimer);" onmouseout="SUGAR.themes.setResetTimer();">
	{foreach from=$module_tabs.more_tabs key=module_key item=tab}
		{if $tab.more}
			<a href="{$tab.url}" class="menuItem" id="{$tab.key}Handle" parentid="MoreMenu" onclick="SUGAR.themes.chooseTab('{$tab.key}'); return true;">{$tab.label}</a>
		{/if}
	{/foreach}
	</div>
	{/if}

	{if $hide_side_menu != 'complete'}
	<div id="HideMenu" class="subDmenu" style="position: absolute; width: 180px; z-index:500; display: none"></div>
	{/if}
	
	{if ! $hide_tab_bar && $module_tabs.use_group_tabs && $module_tabs.tabs}
		{assign var=group_tabs_visible value=1}{/if}

	<div class="headerBg{if $group_tabs_visible} overTabs{/if}">
	<div id="topRight">
		<table border="0" cellpadding="0" cellspacing="0" class="myArea">
		<tr>
			{if $is_demo_site}<td style="padding: 0 1em">{$APP.LBL_DEMO_VERSION}</td>{/if}
			<td id="colorpicker"><ul class="colorpicker">
				{foreach from=$color_styles key=idx item=style}<li onclick="SUGAR.themes.changeColor('{$style.name}');" onmousedown="return false;"><div class="icon-box theme-style" style="margin: 0 3px 0 3px; background-position: {$idx*-15-15}px 0" title="{$style.title}"><img src="{$STATIC_URL}include/images/blank.gif" alt="{$style.name}" border="0" width="15" height="15"></div></li>{/foreach}
				<li onclick="SUGAR.themes.toggleTextures();" onmousedown="return false;"><div class="icon-box theme-style" style="margin: 0 3px 0 3px; background-position: 0 -15px" title="Toggle Background Textures"><img src="{$STATIC_URL}include/images/blank.gif" alt="texture" border="0" width="15" height="15"></div></li>
				{foreach from=$font_styles key=idx item=font}<li onclick="SUGAR.themes.changeFont('{$font.name}');" onmousedown="return false;"><div class="icon-box theme-style" style="margin: 0 3px 0 3px; background-position: {$idx*-15-15}px -15px" title="{$font.title}"><img src="{$STATIC_URL}include/images/blank.gif" alt="{$font.name}" border="0" width="15" height="15"></div></li>{/foreach}
				</ul>
			</td>
			{if $global_links}
			<td>
				<ul class="topMenu">{foreach from=$global_links key=link_id item=link}<li><a href="{$link.url}" {$link.menu}>{$link.label}</a>{$link.menu_arrow}</li>{/foreach}</ul>
			</td>
			{/if}
		</tr>
		</table>
		<img id="tlr-logo" src="{$STATIC_URL}{$THEME_SIDE_LOGO.src}" width="{$THEME_SIDE_LOGO.width}" height="{$THEME_SIDE_LOGO.height}" alt="{$THEME_SIDE_LOGO.alt}" border="0">
	</div>
	<div class="logo">
		<img id="top-logo" src="{$STATIC_URL}{$THEME_TOP_LOGO.src}" width="{$THEME_TOP_LOGO.width}" height="{$THEME_TOP_LOGO.height}" alt="{$THEME_TOP_LOGO.alt}" border="0">
	</div>
	</div>
	
<div id="all-page" style="display: inline-block; min-width: 100%">

{if $group_tabs_visible}
<div id="tabBar">
	<ul id="top-tabBar" class="tabBar">{foreach from=$module_tabs.all_tabs key=tab_name item=tab}<li
		class="menutab-item {if $tab.active}{assign var=active_tab value=$tab}current{/if}"
			><a class="menutab-link" href="{$tab.url}" onclick="SUGAR.themes.chooseTab('{$tab.key}'); return true;"><div class="menutab left"></div><div class="menutab mid">{$tab.label}</div><div class="menutab right"></div></a
		></li
	>{/foreach}</ul>
</div>
{elseif ! $hide_tab_bar}
	{assign var=active_tab value=$module_tabs}
{/if}

{if (! $shortcuts_on_top && $shortcuts.non_list) || ($recent_on_side && $recent_links)}
	{assign var=side_links_visible value=1}{/if}

<table width="100%" cellspacing="0" cellpadding="0" border="0" style="margin-top: 8px">
<tr>
{if $hide_side_menu == 'complete' || (! $active_tab && ! $side_links_visible && ! $new_record_form)}
{else}
	<td valign="top" width="10">
		<div style="cursor: pointer; width: 10px; height: 25px; background-position: {if $hide_side_menu}0 0{else}-10px 0{/if}" id="HideHandle" onclick='SUGAR.themes.toggleLeftCol(); SUGAR.popups.hidePopup();' onmouseover="SUGAR.themes.showHiddenMenu(this)"></div>
	</td>
	<td valign="top" id="leftColumn">
		<div style="display: {if $hide_side_menu}none{else}block{/if}; width: 180px" id="leftCol">			
			{if $active_tab}
				<div id="div_modules" class="subMenuOuter"><ul id="modulesMenu" class="subMenu moduleList"
					>{foreach from=$active_tab.all_tabs key=idx item=tab}{if $tab.active}{assign var=active_mod value=$tab}{/if}<li
					{if $tab.active} class="current"{/if}><a href="{$tab.url}">{iah_icon_image name=$tab.icon|default:$tab.module}&nbsp;{$tab.label}</a></li
					>{if $tab.active && $shortcuts.list && ! $tab.iframe}<div
						class="subMenuOuter"><ul
							>{foreach from=$shortcuts.list key=link_id item=link}<li
							id="{$link_id}_lv"{if $link.active} class="current"{/if}><a href="{$link.url}">{$link.image}&nbsp;{$link.label}</a></li
							>{/foreach}</ul
					></div>{/if}{/foreach}</ul></div>
			{/if}
			{if ! $shortcuts_on_top && $shortcuts.non_list}
				<div id="div_shortcuts">
					<div class="leftColumnModuleHead">
						<div class="leftColumnModuleName">{$SHORTCUTS}</div>
					</div>
					<div class="subMenuOuter">
						<ul class="subMenu" id="subMenu">
							{foreach from=$shortcuts.non_list key=link_id item=link}<li
							id="{$link_id}_lv"><a href="{$link.url}">{$link.image}&nbsp;{$link.label}</a></li>{/foreach}</ul>
					</div>
				</div>
			{/if}
			{if $recent_on_side && $recent_links}
				<div id="div_lastview">
					<div class="leftColumnModuleHead">
						<div class="leftColumnModuleName">{$TITLE_LAST_VIEW}</div>
					</div>
					<div class="subMenuOuter">
						<ul class="subMenu">{foreach from=$recent_links key=link_id item=link}<li
							id="{$link_id}_lv"><a title="[{$APP.LBL_ALT_HOT_KEY}{$link_id}]" accessKey="{$link_id}" href="{$link.url}"
							>{$link.image}&nbsp;{$link.label}</a></li>{/foreach}</ul>
					</div>
				</div>
			{/if}
			{$new_record_form}
		</div>
	</td>
{/if}
	<td style="padding-right: 10px; padding-left: 8px; width: 100%;" valign="top">
	{if (! $recent_on_side && $recent_links) || ($shortcuts_on_top && $shortcuts.non_list)}
		{assign var=menu_bar_visible value=1}
	{else}
		<script type="text/javascript">SUGAR.themes.auto_hide_menu = 'menuBar';</script>
	{/if}
	{if ($active_tab && $hide_side_menu != 'complete') || $menu_bar_visible}
		<div class="popupMenuBarOuter" id="menuBar" {if (! $hide_side_menu || ! $active_tab) && ! $menu_bar_visible}style="display: none"{/if}>
		<table class="popupMenuBar" border="0" cellpadding="0" cellspacing="0">
		<tr>
		<td id="modulesMenuSource" class="popupMenuOuter" {if ! $hide_side_menu}style="display: none"{/if}>
			{if $active_mod}
			<div id="modulesCurrent" class="popupMenuSource no-left" style="margin-left: -1px; border-left: 1px solid transparent">
				<div class="input-arrow">{iah_icon_image name=$active_mod.icon|default:$active_mod.module}&nbsp;{$active_mod.label}</div>
			</div>
			{iah_script priority='foot'}{literal}
				SUGAR.popups.attachPopup('modulesCurrent', 'modulesMenuPopup', {offset: {top:-1, over: true}, delay: 200});
			{/literal}{/iah_script}
			{/if}
			<div id="modulesMenuPopup" class="popupMenu"></div>
		</td>
		{if $shortcuts_on_top && $shortcuts.non_list}
			<td class="popupTitle">{$SHORTCUTS}:</td>
			<td class="popupMenuOuter">
			<div id="shortcutsFirst" class="popupMenuSource">
				<div class="input-arrow">{$shortcuts.non_list.0.image}&nbsp;{$shortcuts.non_list.0.label}</div>
			</div>
			{iah_script priority='foot'}{literal}
				SUGAR.popups.attachPopup('shortcutsFirst', 'shortcutsMenuPopup', {offset: {top:-1, over: true}, delay: 200});
			{/literal}{/iah_script}
			<div id="shortcutsMenuPopup" class="popupMenu">
				<ul class="subMenu">
				{foreach from=$shortcuts.non_list key=link_id item=link}<li><a
					href="{$link.url}">{$link.image}&nbsp;{$link.label}</a
				></li>{/foreach}</ul>
			</div>
			</td>
		{/if}
		{if ! $recent_on_side && $recent_links}
			<td class="popupTitle">{$TITLE_LAST_VIEW}:</td>
			<td class="popupMenuOuter">
			<div id="recentViewFirst" class="popupMenuSource">
				<div class="input-arrow">{$recent_links.0.image}&nbsp;{$recent_links.0.label}</div>
			</div>
			{iah_script priority='foot'}{literal}
				SUGAR.popups.attachPopup('recentViewFirst', 'recentViewMenuPopup', {offset: {top:-1, over: true}, delay: 200});
			{/literal}{/iah_script}
			<div id="recentViewMenuPopup" class="popupMenu">
				<ul class="subMenu">
				{foreach from=$recent_links key=link_id item=link}
				<li><a href="{$link.url}">{$link.image}&nbsp;{$link.label}</a></li>
				{/foreach}
				</ul>
			</div>
			</td>
		{/if}
		</tr>
		</table>
		</div>
	{/if}
