CKEDITOR.dialog.add( 'articlerefDialog', function( editor ) {
	var dialog;
	var findElement = function(selector) {
		return SUGAR.ui.extNode(dialog.parts.contents.$).find(selector)[0];
	};
	return {
		title: 'Reference Properties',
		minWidth: 400,
		minHeight: 100,

		contents: [
			{
				id: 'contentelement',
				elements: [
					{
					    type: 'radio',
					    id: 'article_category',
					    label: 'Insert reference to',
					    items: [ [ 'Article', 'Article' ], [ 'Topic', 'Category' ] ],
						onClick: function() {
					    	var refdiv = findElement('#reference-div');
					        refdiv.innerHTML = '';
					        var slugelement = document.createElement('div');
							slugelement.setAttribute("id", "onecrmdiv");
							slugelement.setAttribute("style", "display:none");
							refdiv.append(slugelement);
					    	
					        if(this.getValue() == 'Article') {
								getHtml(refdiv,false,'article');
					        }
					        else if(this.getValue() == 'Category') {
								getHtml(refdiv,false,'category');
					        }
					    }
					},
					{
						type: 'html',
						id: 'articleref_ref',
						label: app_string('LBL_REF_ARTICLE_TITLE'),
						html: '<form name="reference-form"><div id="reference-div" name="reference-div"></div></form>'
					},
				]
			}
		],

		onShow: function() {
			dialog = this;
			var selection = editor.getSelection();
			var elementselected = selection.getStartElement();
			this.elementselected = elementselected;
			if ( elementselected )
				elementselected = elementselected.getAscendant( 'span', true );

			this.elementselectedref = elementselected;

			this.refdiv = findElement('#reference-div');

			if(this.elementselectedref) {
				var acelement = this.refdiv;
				acelement.innerHTML = '';
				if(elementselected.getHtml().indexOf("onecrm:article") !== -1){
					this.getContentElement( 'contentelement', 'article_category' ).setValue( 'Article' );
					var slugelement = document.createElement('div');
					slugelement.setAttribute("id", "onecrmdiv");
					slugelement.setAttribute("style", "display:none");
					acelement.append(slugelement);

					getHtml(acelement,elementselected,'article');
				}
				else if(elementselected.getHtml().indexOf("onecrm:category") !== -1){
					this.getContentElement( 'contentelement', 'article_category' ).setValue( 'Category' );
					this.getContentElement( 'contentelement', 'article_category' ).disable();
					var slugelement = document.createElement('div');
					slugelement.setAttribute("id", "onecrmdiv");
					slugelement.setAttribute("style", "display:none");
					acelement.append(slugelement);

					getHtml(acelement,elementselected,'category');
				}
			}

		},

		onHide: function() {
			this.elementselectedref = false;
			this.refdiv.innerHTML = '';
		},

		onOk: function() {
			var oncecrm_article = findElement('#onecrmarticle');
			if(oncecrm_article) {
				if(this.elementselected.getAscendant( 'onecrm:article', true )) {
					var onecrmel = this.elementselected.getAscendant( 'onecrm:article', true );
					var abbr = this.elementselected.getAscendant( 'abbr', true );
					onecrmel.setAttribute("id", oncecrm_article.getAttribute('aid'));
					onecrmel.setAttribute("contenteditable", 'false');
					onecrmel.setHtml(oncecrm_article.innerHTML);
					abbr.setAttribute("title", oncecrm_article.getAttribute('title'));
					abbr.setAttribute("contenteditable", "false");
					this.commitContent( abbr );
					this.commitContent( onecrmel );
				}
				else {
					var onecrmel = editor.document.createElement('onecrm:article');
					var abbr = editor.document.createElement('abbr');
					var span = editor.document.createElement('span');
					onecrmel.setAttribute("id", oncecrm_article.getAttribute('aid'));
					onecrmel.setAttribute("contenteditable", 'false');
					onecrmel.setHtml(oncecrm_article.innerHTML);
					onecrmel.appendTo(abbr);
					abbr.setAttribute("title", oncecrm_article.getAttribute('title'));
					abbr.setAttribute("contenteditable", "false");
					abbr.appendTo(span);
					this.commitContent( span );
					editor.insertElement( span );
					editor.insertText( ' ' );
				}
			}

			var oncecrm_category = findElement('#onecrmcategory');
			if(oncecrm_category) {
				if(this.elementselected.getAscendant( 'onecrm:category', true )) {
					var onecrmel = this.elementselected.getAscendant( 'onecrm:category', true );
					var abbr = this.elementselected.getAscendant( 'abbr', true );
					onecrmel.setAttribute("id", oncecrm_category.getAttribute('aid'));
					onecrmel.setAttribute("contenteditable", 'false');
					onecrmel.setHtml(oncecrm_category.innerHTML);
					abbr.setAttribute("title", oncecrm_category.getAttribute('title'));
					abbr.setAttribute("contenteditable", "false");
					this.commitContent( abbr );
					this.commitContent( onecrmel );
				}
				else {
					var onecrmel = editor.document.createElement('onecrm:category');
					var abbr = editor.document.createElement('abbr');
					var span = editor.document.createElement('span');
					onecrmel.setAttribute("id", oncecrm_category.getAttribute('aid'));
					onecrmel.setAttribute("contenteditable", 'false');
					onecrmel.setHtml(oncecrm_category.innerHTML);
					onecrmel.appendTo(abbr);
					abbr.setAttribute("title", oncecrm_category.getAttribute('title'));
					abbr.setAttribute("contenteditable", "false");
					abbr.appendTo(span);
					this.commitContent( span );
					editor.insertElement( span );
					editor.insertText( ' ' );
				}
			}
			editor.getSelection().removeAllRanges();
			this.elementselectedref = false;
			var refdiv = findElement('#reference-div').innerHTML = '';
		}
	};

	function getHtml(articleelement,elementselected=false,mod) {
		var MakeElt = SUGAR.dom.makeElement;
		var row = MakeElt('div.row.col-space-sm.row-data').appendTo(articleelement);

		var modul = '';
		var bean = '';
		var name = '';
		var keyname = '';
		var element = '';
		var lbl = '';

		if(mod == 'article') {
			modul = 'KBArticles';
			bean = 'KBArticle';
			name = 'article_ref';
			keyname = 'article_ref_id';
			element = 'article';
			lbl = 'LBL_REF_ARTICLE_TITLE';
		}
		else if(mod == 'category') {
			modul = 'KBCategories';
			bean = 'KBCategory';
			name = 'category_ref';
			keyname = 'category_ref_id';
			element = 'category';
			lbl = 'LBL_REF_CATEGORY_TITLE';
		}

		var cell = MakeElt('div.column.ref-col').appendTo(row);
		var rel = new SUGAR.ui.RefInput('ref-name', {
							module: modul,
							bean_name: bean,
							name: name,
							key_name: keyname,
						ignore_dirty: true, block: true
					});
		rel.addExtraReturnFields({name: 'name'});
		rel.onchange = function(k, v, passthru) { 
			findElement('#onecrmdiv').innerHTML = '<onecrm:'+element+' contenteditable="false" id="onecrm'+element+'" aid="'+k+'" title="'+v.name+'">'+v.name+'</onecrm:'+element+'>';
		}
		SUGAR.ui.registerInput(articleelement.parentNode, rel);
		cell.append(
					MakeElt('div.tools-row.input-field-pad',
					MakeElt('div.form-label.no-flex', app_string(lbl) + app_string('LBL_SEPARATOR'), nbsp()),
					rel.render()
					));

		if(elementselected) {
			findElement('#onecrmdiv').innerHTML = elementselected.getHtml();
			var selected_article = document.getElementsByTagName('onecrm:'+element)[0];
			if(selected_article)
				rel.update(selected_article.getAttribute('id'), selected_article.innerHTML, true);
		}
		else {
			rel.update('','',true);
		}
			
	}
});	
