CKEDITOR.dialog.add( 'articlerefDialog', function( editor ) {
	return {
		title: 'Reference Properties',
		minWidth: 400,
		minHeight: 200,

		contents: [
			{
				id: 'contentelement',
				elements: [
					{
					    type: 'radio',
					    id: 'article_category',
					    label: 'Reference Type',
					    items: [ [ 'Article', 'Article' ], [ 'Category', 'Category' ] ],
					    onClick: function() {
					    	var category = SUGAR.ui.getFormInput(document.getElementsByName('categoryref-form')[0], 'category_ref');
					    	var article = SUGAR.ui.getFormInput(document.getElementsByName('articleref-form')[0], 'article_ref');
					        if(this.getValue() == 'Article') {
					    		category.update('','');
					        	document.getElementsByName('articleref-form')[0].style.display = 'block';
					        	document.getElementsByName('categoryref-form')[0].style.display = 'none';
					        }
					        else if(this.getValue() == 'Category') {
					    		article.update('','');
					        	document.getElementsByName('articleref-form')[0].style.display = 'none';
					        	document.getElementsByName('categoryref-form')[0].style.display = 'block';
					        }
					        else {
					        	document.getElementsByName('articleref-form')[0].style.display = 'none';
					        	document.getElementsByName('categoryref-form')[0].style.display = 'none';
					        }

					    }
					},
					{
						type: 'html',
						id: 'articleref_ref',
						label: app_string('LBL_REF_ARTICLE_TITLE'),
						html: '<form style="display:none" name="articleref-form"><div id="articleref-div"></div></form>'
					},
					{
						type: 'html',
						id: 'categoryref_ref',
						label: app_string('LBL_REF_CATEGORY_TITLE'),
						html: '<form style="display:none" name="categoryref-form"><div id="categoryref-div"></div></form>'
					},
				]
			}
		],

		onShow: function() {
			var selection = editor.getSelection();
			var elementselected = selection.getStartElement();
			this.elementselected = elementselected;
			if ( elementselected )
				elementselected = elementselected.getAscendant( 'span', true );

			if(!elementselected) {
				var articleelement = SUGAR.ui.extNode(this.parts.contents.$).find('#articleref-div')[0];
				articleelement.innerHTML = '';
				if(!document.getElementById('onecrmarticle')) {
					var slugelement = document.createElement('div');
					slugelement.setAttribute("id", "onecrmdiv");
					slugelement.setAttribute("style", "display:none");
					articleelement.append(slugelement);

					getHtmlArticle(articleelement);
				}

				var categoryelement = SUGAR.ui.extNode(this.parts.contents.$).find('#categoryref-div')[0];
				categoryelement.innerHTML = '';
				if(!document.getElementById('onecrmcategory')) {
					var slugelementc = document.createElement('div');
					slugelementc.setAttribute("id", "onecrmdiv");
					slugelementc.setAttribute("style", "display:none");
					categoryelement.append(slugelementc);

					getHtmlCategory(categoryelement);
				}
			}
			else if(elementselected) {
				this.getContentElement( 'contentelement', 'article_category' ).setValue( 'Article' );

				var articleelement = SUGAR.ui.extNode(this.parts.contents.$).find('#articleref-div')[0];
				articleelement.innerHTML = '';
				//if(elementselected.getHtml().indexOf("onecrm:article") !== -1){
					var slugelement = document.createElement('div');
					slugelement.setAttribute("id", "onecrmdiv");
					slugelement.setAttribute("style", "display:none");
					articleelement.append(slugelement);

					getHtmlArticle(articleelement,elementselected);
				//}

				var categoryelement = SUGAR.ui.extNode(this.parts.contents.$).find('#categoryref-div')[0];
				categoryelement.innerHTML = '';

				//if(elementselected.getHtml().indexOf("onecrm:category") !== -1){
					var slugelementc = document.createElement('div');
					slugelementc.setAttribute("id", "onecrmdiv");
					slugelementc.setAttribute("style", "display:none");
					categoryelement.append(slugelementc);

					getHtmlCategory(categoryelement,elementselected);
				//}

				if(elementselected.getHtml().indexOf("onecrm:category") !== -1) {
					articleelement.innerHTML = '';
				}
				else if(elementselected.getHtml().indexOf("onecrm:article") !== -1) {
					categoryelement.innerHTML = '';
				}
			}
		},

		onOk: function() {
			var category = SUGAR.ui.getFormInput(document.getElementsByName('categoryref-form')[0], 'category_ref');
			var article = SUGAR.ui.getFormInput(document.getElementsByName('articleref-form')[0], 'article_ref');
			var oncecrm_article = document.getElementById('onecrmarticle');
			if(oncecrm_article && article.getValue() != '') {
				if(this.elementselected.getAscendant( 'onecrm:article', true )) {
					var onecrmel = this.elementselected.getAscendant( 'onecrm:article', true );
					var abbr = this.elementselected.getAscendant( 'abbr', true );
					onecrmel.setAttribute("id", oncecrm_article.getAttribute('aid'));
					onecrmel.setAttribute("slug", oncecrm_article.getAttribute('slug'));
					onecrmel.setAttribute("contenteditable", 'false');
					onecrmel.setHtml(oncecrm_article.innerHTML);
					abbr.setAttribute("title", oncecrm_article.getAttribute('title'));
					abbr.setAttribute("contenteditable", "false");
					this.commitContent( abbr );
					this.commitContent( onecrmel );
				}
				else {
					var onecrmel = editor.document.createElement('onecrm:article');
					var abbr = editor.document.createElement('abbr');
					var span = editor.document.createElement('span');
					onecrmel.setAttribute("id", oncecrm_article.getAttribute('aid'));
					onecrmel.setAttribute("slug", oncecrm_article.getAttribute('slug'));
					onecrmel.setAttribute("contenteditable", 'false');
					onecrmel.setHtml(oncecrm_article.innerHTML);
					onecrmel.appendTo(abbr);
					abbr.setAttribute("title", oncecrm_article.getAttribute('title'));
					abbr.setAttribute("contenteditable", "false");
					abbr.appendTo(span);
					this.commitContent( span );
					editor.insertElement( span );
					editor.insertText( ' ' );
				}
			}

			var oncecrm_category = document.getElementById('onecrmcategory');
			if(oncecrm_category && category.getValue() != '') {
				if(this.elementselected.getAscendant( 'onecrm:category', true )) {
					var onecrmel = this.elementselected.getAscendant( 'onecrm:category', true );
					var abbr = this.elementselected.getAscendant( 'abbr', true );
					onecrmel.setAttribute("id", oncecrm_category.getAttribute('aid'));
					onecrmel.setAttribute("slug", oncecrm_category.getAttribute('slug'));
					onecrmel.setAttribute("contenteditable", 'false');
					onecrmel.setHtml(oncecrm_category.innerHTML);
					abbr.setAttribute("title", oncecrm_category.getAttribute('title'));
					abbr.setAttribute("contenteditable", "false");
					this.commitContent( abbr );
					this.commitContent( onecrmel );
				}
				else {
					var onecrmel = editor.document.createElement('onecrm:category');
					var abbr = editor.document.createElement('abbr');
					var span = editor.document.createElement('span');
					onecrmel.setAttribute("id", oncecrm_category.getAttribute('aid'));
					onecrmel.setAttribute("slug", oncecrm_category.getAttribute('slug'));
					onecrmel.setAttribute("contenteditable", 'false');
					onecrmel.setHtml(oncecrm_category.innerHTML);
					onecrmel.appendTo(abbr);
					abbr.setAttribute("title", oncecrm_category.getAttribute('title'));
					abbr.setAttribute("contenteditable", "false");
					abbr.appendTo(span);
					this.commitContent( span );
					editor.insertElement( span );
					editor.insertText( ' ' );
				}
			}
			editor.getSelection().removeAllRanges();
		}
	};

	function getHtmlArticle(articleelement,elementselected=false) {
		var MakeElt = SUGAR.dom.makeElement;
		var row = MakeElt('div.row.col-space-sm.article-row-data').appendTo(articleelement);

		var cell = MakeElt('div.column.articleref-col').appendTo(row);
		var rel = new SUGAR.ui.RefInput('article-name-ref', {
							module: 'KBArticles',
							bean_name: 'KBArticle',
							name: 'article_ref',
							key_name: 'article_ref_id',
						ignore_dirty: true, block: true
					});
		rel.addExtraReturnFields({slug: 'slug', name: 'name'});
		rel.onchange = function(k, v, passthru) { 
			document.getElementById('onecrmdiv').innerHTML = '<onecrm:article contenteditable="false" slug="'+v.slug+'" id="onecrmarticle" aid="'+k+'" title="'+v.name+'">'+v.name+'</onecrm:article>';
		}
		SUGAR.ui.registerInput(articleelement.parentNode, rel);
		cell.append(
					MakeElt('div.tools-row.input-field-pad',
					MakeElt('div.form-label.no-flex', app_string('LBL_REF_ARTICLE_TITLE') + app_string('LBL_SEPARATOR'), nbsp()),
					rel.render()
					));

		if(elementselected) {
			document.getElementById('onecrmdiv').innerHTML = elementselected.getHtml();
			var selected_article = document.getElementsByTagName('onecrm:article')[0];
			if(selected_article)
				rel.update(selected_article.getAttribute('id'), selected_article.innerHTML, true);
		}
		else {
			rel.update('','',true);
		}
			
	}

	function getHtmlCategory(categoryelement,elementselected=false) {
		var MakeElt = SUGAR.dom.makeElement;
		var row = MakeElt('div.row.col-space-sm.category-row-data').appendTo(categoryelement);

		var cell = MakeElt('div.column.categoryref-col').appendTo(row);
		var rel = new SUGAR.ui.RefInput('category-name-ref', {
							module: 'KBCategories',
							bean_name: 'KBCategory',
							name: 'category_ref',
							key_name: 'category_ref_id',
						ignore_dirty: true, block: true
					});
		rel.addExtraReturnFields({slug: 'slug', name: 'name'});
		rel.onchange = function(k, v, passthru) { 
			if(v.slug != '')
				document.getElementById('onecrmdiv').innerHTML = '<onecrm:category slug="'+v.slug+'" id="onecrmcategory" aid="'+k+'" title="'+v.name+'">'+v.name+'</onecrm:category>';
		}
		SUGAR.ui.registerInput(categoryelement.parentNode, rel);
		cell.append(
					MakeElt('div.tools-row.input-field-pad',
					MakeElt('div.form-label.no-flex', app_string('LBL_REF_CATEGORY_TITLE') + app_string('LBL_SEPARATOR'), nbsp()),
					rel.render()
					));

		if(elementselected) {
			document.getElementById('onecrmdiv').innerHTML = elementselected.getHtml();
			var selected_category = document.getElementsByTagName('onecrm:category')[0];
			if(selected_category)
				rel.update(selected_category.getAttribute('id'), selected_category.innerHTML, true);
		}
		else {
			rel.update('','',true);
		}
	}
});	
