CKEDITOR.plugins.add( 'articleref', {
	icons: 'articleref_btn',

	init: function( editor ) {
	
		CKEDITOR.domReady(function()  {
			var h = CKEDITOR.plugins.get("articleref");
			editor.document.appendStyleSheet(CKEDITOR.getUrl(h.path + "dialogs/style.css"));
		});
		editor.addCommand( 'articleref', new CKEDITOR.dialogCommand( 'articlerefDialog' ) );

		editor.ui.addButton( 'articleref_btn', {
			label: 'Reference Article/Topic',
			command: 'articleref'
		});

		editor.on( 'doubleclick', function( evt )
			{
			var element = CKEDITOR.plugins.link.getSelectedLink( editor ) || evt.data.element;
			if ( element.is( 'onecrm:category' ) || element.is( 'onecrm:article' ) )
			{
				evt.data.dialog = 'articlerefDialog';
			}
		 });

		if ( editor.contextMenu ) {
			editor.addMenuGroup( 'abbrGroup' );
			editor.addMenuItem( 'abbrItem', {
				label: 'Edit Reference',
				icon: this.path + 'icons/articleref_btn.png',
				command: 'articleref',
				group: 'abbrGroup'
			});

			editor.contextMenu.addListener( function( element ) {
				if ( element.getAscendant( 'onecrm:article', true ) || element.getAscendant( 'onecrm:category', true ) ) {
					return { abbrItem: CKEDITOR.TRISTATE_OFF };
				}
			});
		}
		CKEDITOR.dialog.add( 'articlerefDialog', this.path + 'dialogs/articleref.js' );
	}
});

