<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  Defines the Account SugarBean Account entity with the necessary
 * methods and variables.
 ********************************************************************************/
require_once('include/CKeditor/ckeditor.php');
class CKeditor_IAH extends CKEditor {

	function __construct() {
		parent::__construct();
		$this->IahDefaults();
 	}
	
	function IahDefaults() {
		$this->basePath = 'include/CKeditor/';
		$this->config['baseHref'] = AppConfig::site_url();
		$this->config['height'] = '400px';
		$this->returnOutput = true;
		
		
		if(isset($_SERVER['PHP_SELF']) && !empty($_SERVER['PHP_SELF'])) {
			$host = preg_replace('/\/(?:[^\/]*\.php)?$/', '', $_SERVER['PHP_SELF']);
		} else {
			$host = AppConfig::site_url();
		}
		
		$ver = js_version_params();
		$this->config["customConfig"] = $host."/include/CKeditor_IAH/myconfig.js?". $ver;
	}
	

	/* overrides this function to remove htmlspecialchars call*/
	function editor($name, $value = "", $config = array(), $events = array()) {
		$special = "#CONTENT#";
		$out = parent::editor($name, $special, $config, $events);
		$out = str_replace($special, $value, $out);
		return $out;
	}
	
	// used by HtmlInput
	function editor2($id, $name, $value, $extra_tags = false) {
		$js = $this->exportIncludes($extra_tags);
		$ret = '<div id="'.to_html($id).'"><textarea name="'.to_html($name).'" rows="8" cols="60">'.$value.'</textarea></div>';
		return $ret . $js;
	}
	
	// init for editor2
	// FIXME AD - when fixing bug #1464, add_js_include was replaced by explicit javasript code.
	// While this basically works, the actual reason why add_js_include did not
	// work should be found and fixed.
	function exportIncludes($extra_tags = false) {
		static $exported;
		if($exported) return '';
		global $pageInstance;
		$jsPath = javascript_escape($this->basePath);
		$config = javascript_escape($this->config["customConfig"]);


		$script = '';
		if ($extra_tags) {
			$script .= 'window.CKEDITOR_extraConfigFunction = function(config) {config.extraAllowedContent = "form[*]; input[*]; select[*]; option[*]; textarea[*]; script[*]; tr[*]; td[*]";};';
		}
		
		// load custom config for CKeditor, function name in the file defined in Configuration under "layout.ckeditor_custom_config" has to be "CKEDITOR_ext" (contributed by visual4)
		$ext_config_path = AppConfig::setting('layout.ckeditor_custom_config');
		if (!empty($ext_config_path) && file_exists($ext_config_path)) {
			$script .= file_get_contents($ext_config_path);
		}

		$script .= "window.CKEDITOR_BASEPATH='$jsPath';window.CKEDITOR_CONFIG='$config';";

		$pageInstance->add_js_literal($script, null, LOAD_PRIORITY_BODY);
		//$pageInstance->add_js_include($this->basePath . 'ckeditor.js', null, LOAD_PRIORITY_BODY);
		$exported = true;
		return '<script type="text/javascript" src="'.$this->basePath.'ckeditor.js"></script><script type="text/javasript">CKEDITOR.env.isCompatible = true;</script>';
	}
}
?>
