<?php

/**
 * Factory class with DetailView managers.
 *
 */
class DetailFactory {

	/**
	 * Main method.
	 *
	 * @param string $type
	 * @return DetailManager
	 */
	public static function getManager($type, $module = null) {
		if (is_string($module)) {
			$def = AppConfig::setting("modinfo.by_name.$module.detail_manager.$type");
			if (is_array($def)) {
				require_once $def['file'];
				return new $def['class'];
			}

		}
		switch ($type){
			case "quick_create": {
				require_once('include/Popups/QuickCreatePopup.php');
				if (!isset($_REQUEST['layout']))
					$_REQUEST['layout'] = 'QuickCreate';
				$manager = new QuickCreatePopup();
				break;
			}
            case "call_logging": {
            	require_once('include/Popups/CallLoggingPopup.php');
                $manager = new CallLoggingPopup();
                break;
            }
			case "standard": {
				if (AppConfig::is_mobile()) {
					require_once('include/DetailView/MobileDetailManager.php');
					$manager = new MobileDetailManager;
				} else {
					require_once('include/DetailView/StandardDetailManager.php');
					$manager = new StandardDetailManager();
				}
				break;
			}
			case "mini": {
				require_once('include/DetailView/MiniDetailManager.php');
				$manager = new MiniDetailManager();
				break;
			}
			default: {
				require_once('include/DetailView/StandardDetailManager.php');
				$manager = new StandardDetailManager();
				break;
			}
		}
		return $manager;
	}
}
?>
