<?php

require_once('include/ListView/ListFormatter.php');
require_once('include/upload_file.php');

class ListCarouselFormatter extends ListFormatter
{
	var $is_images_carousel = true;
	var $listview_primary = true;

	static function create($model = null, $link_name = null, $list_id = null, $context = 'listview', $params = null)
	{
		return new self($model, $link_name, $list_id, $context, $params);
	}

	function setFormat($format = 'html', $context = 'listview')
	{
		parent::setFormat($format, $context);
		$this->format = 'html_images';
	}

	function outputHtmlTable(ListResult &$listResult)
	{
		$this->calcColSpan();
		$style = 'display: grid; grid-template-columns: repeat(3, 1fr); width: 100%;';

		$this->outputCustomOffsetPopup();

		echo '<table id="' . $this->list_id . '-main" class="' . $this->table_class . '" cellpadding="0" cellspacing="0" border="0" width="' . $this->table_width . '" style="' . $style . '">';
		echo '<tbody style="display: contents">';

		$this->outputCarousel($listResult);

		echo '</div>';

		echo '</tbody>';
		echo '</table>';
	}

	function outputCarousel(ListResult &$listResult, $offset_count = 0)
	{
		if ($listResult->failed) return;
		$index = 0;
		$images = [];
		$parentType = htmlspecialchars(array_get_default($_POST, 'parent_type'), ENT_QUOTES, 'UTF-8');
		$parentId = htmlspecialchars(array_get_default($_POST, 'parent_id'), ENT_QUOTES, 'UTF-8');
		$totalCount = $listResult->total_count;
		$limit = $listResult->limit;

		foreach ($listResult->formatted_rows as $row) {
			$images[$index] = [
				'src' => 'download.php?type=Notes&id=' . $row['id'] . '&field=filename&inline=1',
				'title' => basename($row['filename']),
				'id' => $row['id']
			];

			$index++;
		}

		$imagesJson = htmlspecialchars(json_encode($images), ENT_QUOTES, 'UTF-8');

		foreach ($images as $index => $img) {
			echo '<tr class="listViewRow listViewRowCarousel">';
			echo
				'<td>
                <a href="#" onclick="SUGAR.ui.Lightbox.showGallery(' . $imagesJson . ', ' . $index . ', ' . $totalCount . ', \'' . $parentType . '\', \'' . $parentId . '\', ' . $limit . '); return false;" class="tabDetailViewDFLink">
                    <img data-name="' . $img['title'] . '" data-id="' . $img['id'] . '" src="' . $img['src'] . '" class="login-header-image img-carousel" style="max-width:60%;max-height: 60%">
                </a>
            </td>';
			echo '</tr>';
		}
	}
}

?>
