<?php

require_once 'include/ListView/ListViewManager.php';
require_once 'include/ListView/MobileListFormatter.php';


class MobileListManager extends ListViewManager
{
	var $formatter_class = 'MobileListFormatter';
	var $show_mass_update = false;
	var $show_checks = false;
	
	function renderTitle() {
		global $pageInstance, $app_list_strings;
		
		if ($this->context == 'listview') {
			$tabs = $this->getLayoutTabs();
			$mod = $this->module;
			$tab_lbl = $current_tab = '';
			$tab_opts = array('keys' => array(), 'values' => array(), 'icon_key' => 'icon');
			if($tabs) {
				foreach($tabs as $t) {
					if($t['name'] == $this->layout_name) {
						$current_tab = $t;
					}
					if(empty($t['label'])) continue;
					$tab_opts['keys'][] = $t['name'];
					$tab_opts['values'][] = array(
						'label' => $t['label'], 'icon' => array_get_default($t, 'icon'),
						'perform' => "sListView.setLayout('$this->list_id', '{$t['name']}')",
						);
				}
				if($current_tab) {
					if(count($tab_opts['keys']) > 1) {
						$tab_lbl = ': <span id="mobileTabSelector" class="list-edit-value"><div class="input-arrow">' . to_html($current_tab['label']) . '</div></span>';
						$json = getJSONobj();
						$js_opts = $json->encode($tab_opts);
						$pageInstance->add_js_literal("
							SUGAR.ui.registerSelectOptions('Layout-Menu', $js_opts);
							SUGAR.ui.registerMenuSource('mobileTabSelector', {options: 'Layout-Menu', icon_key: 'icon'}, 'FilterForm');
						", null, LOAD_PRIORITY_FOOT);
					} else {
						$tab_lbl = ': <span id="mobileTabSelector">' . to_html($current_tab['label']) . '</span>';
					}
				}
			} 
			echo '<h3 class="moduleTitle">' . array_get_default($app_list_strings['moduleList'], $mod, $mod) . $tab_lbl . '</h3>';
		}
	}
}
