<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');



 /*********************************************************************************
 * $Id: EmailClientPOP3PHP.php 6034 2009-05-04 21:48:09Z andrew $
 ********************************************************************************/

class EmailClientLOCALPHP
{
    var $Params;
    var $mbox;
    var $uids = array();
    var $imapErrors;
    var $lastError;

    function __construct($params)
    {
        $this->Params = $params;
    }

    function connect()
	{
		$this->mbox = fopen($this->Params['host'], 'r');
        return !empty($this->mbox);
    }

    function login()
    {
        return !empty($this->mbox);
    }

    function numMsg($since=null)
	{
		rewind($this->mbox);
		$n = 0;
		while ($this->goToNext()) {
			$n++;
		}
		return $n;
    }

    function disconnect()
    {
        return @fclose($this->mbox);
    }

    function getUID($msgNum)
    {
        return '';
    }

    function getMsg($msgNum)
	{
		rewind($this->mbox);
		while ($msgNum--) {
			if (!$this->goToNext())
				return '';
		}
		$body = '';
		while (!feof($this->mbox)) {
			$str = fgets($this->mbox);
			if (strpos($str, 'FROM ') === 0)
				break;
			$body .= $str;
		}
        return $body;
    }

    function getHeaders($msgNum)
    {
		rewind($this->mbox);
		while ($msgNum--) {
			if (!$this->goToNext())
				return '';
		}
		$body = '';
		while (!feof($this->mbox)) {
			$str = fgets($this->mbox);
			if (rtrim($str, "\r\n") === '')
				break;
			$body .= $str;
		}
        return $body;
    }

    function deleteMsg($msgNum)
    {
        return true;
    }

    function selectBox($boxName)
    {
        return true;
    }

    function getCheckDate()
    {
        return '';
	}

	function goToNext()
	{
		while (!feof($this->mbox)) {
			$str = fgets($this->mbox);
			if (strpos($str, 'FROM ') === 0)
				return true;
		}
		return false;
	}

	function getFolders() {
		return [];
	}
}
