<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');



 /*********************************************************************************
 * $Id: EmailClientPOP3PEAR.php 6034 2009-05-04 21:48:09Z andrew $
 ********************************************************************************/

require_once 'Net/POP3.php';

class EmailClientPOP3PEAR
{
	var $mbox;
    var $Params;
    var $lastError;

    function __construct($params)
    {
        $this->Params = $params;
    }

    function connect()
    {
        $host = $this->Params['host'];
        if ($this->Params['use_ssl']) $host = 'ssl://' . $host;
        $this->mbox = new Net_POP3();
        $ret = $this->mbox->connect($host, $this->Params['port']);
		if(PEAR::isError($ret)) {
			$this->lastError = $ret->getMessage();
			$ret = $this->mbox = null;
			return false;
		}
		return $ret;
    }

    function login()
    {
    	if(! $this->mbox) return false;
        $ret = $this->mbox->login($this->Params['username'], $this->Params['password'], $this->Params['login_method']);
        if(PEAR::isError($ret)) {
        	$this->lastError = $ret->getMessage();
        	return false;
        }
        return $ret;
    }

    function numMsg($since=null)
    {
    	return $this->mbox ? $this->mbox->numMsg() : false;
    }

    function disconnect()
    {
        if($this->mbox) {
        	$ret = $this->mbox->disconnect();
        	$this->mbox = null;
        	return $ret;
        }
    }

    function getUID($msgNum)
    {
    	if(! $this->mbox) return false;
        $uidl = $this->mbox->_cmdUidl($msgNum);
        return empty($uidl['uidl']) ? '' : $uidl['uidl'];
    }

    function getMsg($msgNum)
    {
    	return $this->mbox ? $this->mbox->getMsg($msgNum) : false;
    }

    function getHeaders($msgNum)
    {
        return $this->mbox ? $this->mbox->getRawHeaders($msgNum) : false;
    }

    function deleteMsg($msgNum)
    {
        return $this->mbox ? $this->mbox->deleteMsg($msgNum) : false;
    }

    function selectBox($boxName)
    {
        return true;
    }

    function getCheckDate()
    {
        return '';
    }

	function getFolders() {
		return [];
	}
}
