<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');



 /*********************************************************************************
 * $Id: EmailClientPOP3PHP.php 6034 2009-05-04 21:48:09Z andrew $
 ********************************************************************************/

class EmailClientPOP3PHP
{
    var $Params;
    var $mbox;
    var $uids = array();
    var $imapErrors;
    var $lastError;

    function __construct($params)
    {
        $this->Params = $params;
    }

    function connect()
    {
        $ssl = $this->Params['use_ssl'] ? '/ssl/novalidate-cert' : '/novalidate-cert/notls';
		$conn_timeout = array_get_default($this->Params, 'connect_timeout', AppConfig::setting('email.connect_timeout', 30));
		imap_timeout(IMAP_OPENTIMEOUT, $conn_timeout);
        $this->mbox = @imap_open("{{$this->Params['host']}:{$this->Params['port']}/pop3$ssl}INBOX", $this->Params['username'], $this->Params['password']);
        if(empty($this->mbox))
			$this->lastError = imap_last_error();
        return !empty($this->mbox);
    }

    function login()
    {
        return !empty($this->mbox);
    }

    function numMsg($since=null)
    {
        $this->uids = imap_search ($this->mbox, 'ALL', SE_UID);
        return is_countable($this->uids) ? count($this->uids) : false;
    }

    function disconnect()
    {
    	$this->imapErrors = imap_errors(); // clear any pending errors, including "Mailbox is empty"
        return imap_close($this->mbox, CL_EXPUNGE);
    }

    function getUID($msgNum)
    {
        return $this->uids[$msgNum-1];
    }

    function getMsg($msgNum)
    {
        $body = imap_fetchheader($this->mbox, $msgNum) . imap_body($this->mbox, $msgNum);
        return $body;
    }

    function getHeaders($msgNum)
    {
        $body = imap_fetchheader($this->mbox, $msgNum);
        return $body;
    }

    function deleteMsg($msgNum)
    {
        return imap_delete($this->mbox, $msgNum);
    }

    function selectBox($boxName)
    {
        return imap_reopen($this->mbox, $boxName);
    }

    function getCheckDate()
    {
        return '';
    }

	function getFolders() {
		return [];
	}
}
