<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');


require_once('include/Notify/RecordActionMessage.php');

class ThreadReplyMessage extends RecordActionMessage {
	
	function getReplaceParams() {
		$params = parent::getReplaceParams();
		$params['{THREAD_NAME}'] = $this->getRecordField('thread', '');
		return $params;
	}
	
	function getNotifiedUsers() {
		$this->populateRecords();
		$record = $this->getSingleRecord();
		$ret = array();
		if($record && ($thread_id = $record->getField('thread_id'))) {
			$tg_fields = array(
				'id', 'user_name', 'first_name', 'last_name', 'salutation', 'email1', 'email2',
			);
			$lq = new ListQuery('Thread', $tg_fields, array('link_name' => 'users', 'parent_key' => $thread_id, 'no_default_order_by' => true));
			$targets = $lq->runQuery();
			foreach($targets->getRows() as $targ) {
				if($targ['id'] == $record->getField('created_by'))
					continue;
				$targ['bean_name'] = 'User';
				$ret[] = $targ;
			}
		}
		return $ret;
	}
}

