<?php

abstract class GoToMeeting_Adapter
{
	public static function create()
	{
		if (function_exists('curl_init')) {
			require_once 'include/OnlineMeetings/GoToMeeting/Adapter/CURL.php';
			return new GoToMeeting_Adapter_CURL;
		}
		throw new GoToMeetingException('Failed to create GoToMeeting network adapter. Required PHP module is missing');
	}

	abstract public function get($url, $headers);
	abstract public function post($url, $headers, $postData);
	abstract public function put($url, $headers, $content);
	abstract public function delete($url, $headers);
}

