<?php

require_once 'include/OnlineMeetings/GoToMeeting/Adapter.php';

class GoToMeeting_Adapter_CURL extends GoToMeeting_Adapter
{
	public function __construct()
	{
		
	}

	private function createHandle($url, $headers)
	{
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $url);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
		return $ch;
	}

	public function get($url, $headers)
	{
		$ch = $this->createHandle($url, $headers);
		return $this->request($ch);
	}

	public function delete($url, $headers)
	{
		$ch = $this->createHandle($url, $headers);
		curl_setopt($ch, CURLOPT_CUSTOMREQUEST, 'DELETE');
		return $this->request($ch);
	}


	public function post($url, $headers, $postData)
	{
		$ch = $this->createHandle($url, $headers);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $postData); 
		return $this->request($ch);
	}
	
	public function put($url, $headers, $content)
	{
		$fp = fopen("gtmput://var", "r+");
		fwrite($fp, $content);
		rewind($fp);
		$ch = $this->createHandle($url, $headers);
		curl_setopt($ch, CURLOPT_PUT, 1);
		curl_setopt($ch, CURLOPT_INFILE, $fp);
		curl_setopt($ch, CURLOPT_INFILESIZE, strlen($content));
		$ret = $this->request($ch);
		fclose($fp);
		return $ret;
	}

	private function request($ch)
	{
		$response = curl_exec($ch);
		$errno = curl_errno($ch);
		if ($errno != CURLE_OK) {
			throw new GoToMeetingException(curl_error($ch));
		}
		return $response;
	}

}

class GTM_Var_Stream {
    private $position;
    private $varname;
    private $content;

    function stream_open($path, $mode, $options, &$opened_path)
    {
        $url = parse_url($path);
        $this->varname = $url["host"];
		$this->content = '';
		$this->position = 0;

        return true;
    }

    function stream_read($count)
    {
        $ret = substr($this->content, $this->position, $count);
        $this->position += strlen($ret);
        return $ret;
    }

    function stream_write($data)
    {
        $left = substr($this->content, 0, $this->position);
        $right = substr($this->content, $this->position + strlen($data));
        $this->content = $left . $data . $right;
        $this->position += strlen($data);
        return strlen($data);
    }

    function stream_tell()
    {
        return $this->position;
    }

    function stream_eof()
    {
        return $this->position >= strlen($this->content);
    }

    function stream_seek($offset, $whence)
    {
        switch ($whence) {
            case SEEK_SET:
                if ($offset < strlen($this->content) && $offset >= 0) {
                     $this->position = $offset;
                     return true;
                } else {
                     return false;
                }
                break;

            case SEEK_CUR:
                if ($offset >= 0) {
                     $this->position += $offset;
                     return true;
                } else {
                     return false;
                }
                break;

            case SEEK_END:
                if (strlen($this->content) + $offset >= 0) {
                     $this->position = strlen($this->content) + $offset;
                     return true;
                } else {
                     return false;
                }
                break;

            default:
                return false;
        }
    }

    function stream_metadata($path, $option, $var) 
    {
        if($option == STREAM_META_TOUCH) {
            $url = parse_url($path);
            if(!isset($this->content)) {
                $this->content = '';
            }
            return true;
        }
        return false;
    }
}

stream_wrapper_register("gtmput", "GTM_Var_Stream");

