<?php
require_once('include/Popups/MobilePopupManager.php');
require_once('include/Popups/PopupManager.php');
require_once('include/Popups/AuditPopupManager.php');

class PopupFactory {

    /**
     * @static
     * @param $module
     * @param string $type
     * @return AuditPopupManager|CallLoggingPopup|PopupManager|QuickCreatePopup|MobilePopupManager
     */
	public static function getManager($module, $type = 'standard'){
        if ($module == 'Audit')
            $type = 'audit';

		switch ($type){
			case "audit": {
				$manager = new AuditPopupManager();
				break;
			}
			default: {
				if (AppConfig::is_mobile())
					$manager = new MobilePopupManager();
				else
					$manager = new PopupManager();
				break;
			}
		}

		return $manager;
	}
}
?>
