<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */

class SVGChartData
{
	private $series = array();
	private $labels = array();
	private $series_labels = null;
	private $series_colors = array();
	private $totals = array();
	private $series_vars = array();

	public function addSeries($name, $series)
	{
		$x = array('points' => array());
		$total = 0;
		if(isset($series['points']))
		foreach ($series['points'] as $l => $point) {
			if (!is_array($point)) {
				$point = array('n' => $point);
			}
			if ($point['n'] === '#SKIP#')
				continue;
			if (!is_numeric($point['n']))
				$point['n'] = 0;
			if (!isset($point['s'])) $point['s'] = $point['n'];
			if (!isset($point['c'])) $point['c'] = '';
			$x['points'][$l] = $point;
			$total += $point['n'];
		}
		if (isset($series['n'])) {
			if (!is_numeric($series['n']))
				$series['n'] = 0;
			$x['n'] = $series['n'];
		}
		else $x['n'] = $total;

		if (isset($series['s'])) $x['s'] = $series['s'];
		else $x['s'] = $x['n'];

		$this->series[$name] = $x;
	}

	public function setSeriesVars($vars)
	{
		$this->series_vars = $vars;
	}

	public function setLabels($labels)
	{
		$this->labels = $labels;
	}

	public function getLabels()
	{
		return $this->labels;
	}

	public function getSeriesVars()
	{
		return $this->series_vars;
	}

	public function getSeries()
	{
		return $this->series;
	}

	public function setSeriesLabels($labels)
	{
		$this->series_labels = $labels;
	}

	public function getSeriesLabels()
	{
		$labels = array();
		foreach(array_keys($this->series) as $k)
			$labels[$k] = array_get_default($this->series_labels, $k, $k);
		return $labels;
	}
	
	public function setSeriesColors($colors)
	{
		$this->series_colors = $colors;
	}

	public function getSeriesColors()
	{
		$colors = array();
		if($this->series_colors)
			foreach(array_keys($this->series) as $k)
				$colors[] = array_get_default($this->series_colors, $k);
		return $colors;
	}

	public function setTotalsDisplay($t)
	{
		$this->totals = $t;
	}

	public function getTotalsDisplay()
	{
		return $this->totals;
	}
}

