if (typeof(SVGCHARTDATA) != 'object') {
	SVGCHARTDATA = new function() {
		this.subscriptions = [];
        this.words_in_one_line = 8;
        
		this.emit = function()
		{
			for (var i=0; i < this.subscriptions.length; i++) {
				var s = this.subscriptions[i];
				var method = s[1];
				var id = s[0];
				if (s.length == arguments.length + 2) {
					var match = true;
					for (var j = 0; j < arguments.length; j++) {
						if (arguments[j] != s[j+2] && s[j+2] != null) {
							match = false;
							break;
						}
					}
					if (match) {
						var el = document.getElementById(id);
						if (el) {
							method(el, arguments);
						}
					}
				}
			}
		};

		this.subscribe = function(id, method, event, args)
		{
			var args = Array.prototype.slice.call(arguments);
			this.subscriptions.push(args);
		};

		this.highlight = function(el, args)
		{
			//el.oldW = el.getAttribute('stroke-width');
			//el.setAttribute('stroke-width', 2);
			//el.setAttribute('font-weight', 'bold');
			el.classList.add('active');
			document.documentElement.classList.add('exclusive');
		};
		
		this.unhighlight = function(el, args)
		{
			//el.setAttribute('stroke-width', el.oldW);
			//el.setAttribute('font-weight', '');
			el.classList.remove('active');
			document.documentElement.classList.remove('exclusive');
		};

		this.bringOnTop = function(el, args)
		{
			var p = el.parentElement;
			if (p) {
				p.removeChild(el);
				p.appendChild(el);
			}
		};

		this.statusDefault = function(el, args)
		{
			el.textContent = SVGCHARTDATA.default_status;
		};


		this.statusGroup = function(el, args)
		{
			var count;
			if (typeof(args[3]) == 'undefined') {
				count = '';
			} else {
				count = args[3];
			}
			if (SVGCHARTDATA.series_template != '') {
                el.textContent = '';
				var txt = SVGCHARTDATA.series_template.replace(/\$group1\$/g, args[1]).replace(/\$group2\$/g, args[1]).replace(/\$value\$/g, args[2]).replace(/\$count\$/g, count);
                SVGCHARTDATA.createMultiline(txt, el);
            } else {
				el.textContent = SVGCHARTDATA.default_status;
			}
		};

		this.statusValue = function(el, args)
		{
			var txt, pat, i;
			if (typeof(args[4]) == 'undefined') {
				count = '';
			} else {
				count = args[4];
			}
			rel_val = args[5] || [];
			while(rel_val.length < 5) rel_val.push('');
			if (SVGCHARTDATA.value_template != '') {
				el.textContent = '';
                txt = SVGCHARTDATA.value_template.replace(/\$group1\$/g, args[2]).replace(/\$group2\$/g, args[1]).replace(/\$value\$/g, args[3]).replace(/\$count\$/g, count);
                for(i = 0; i < rel_val.length; i++) {
                	pat = new RegExp("\\$value" + (i+2) + "\\$", "g");
                	txt = txt.replace(pat, rel_val[i]);
                }
                SVGCHARTDATA.createMultiline(txt, el);
			} else {
				el.textContent = SVGCHARTDATA.default_status;
			}
		};

        this.createMultiline = function(text, text_element)
        {
            var svgNS = "http://www.w3.org/2000/svg";
            var words = text.split(' ');
            var tspan_element = document.createElementNS(svgNS, "tspan");
            var text_node = document.createTextNode(words[0]);

            tspan_element.appendChild(text_node);
            text_element.appendChild(tspan_element);

            var first_line_length = words.length;
            var create_second_line = false;
            if (words.length > this.words_in_one_line) {
                first_line_length = this.words_in_one_line;
                create_second_line = true;
            }

            for (var i = 1; i < first_line_length; i++) {
                tspan_element.firstChild.data += " " + words[i];
            }

            if (create_second_line) {
                var new_tspan_element = document.createElementNS(svgNS, "tspan");
                new_tspan_element.setAttributeNS(null, "x", SVGCHARTDATA.width / 2);
                new_tspan_element.setAttributeNS(null, "dy", 18);
                var second_line_text = '';

                for (i = this.words_in_one_line; i < words.length; i++) {
                    second_line_text += " " + words[i];
                }

                text_node = document.createTextNode(second_line_text);
                new_tspan_element.appendChild(text_node);
                text_element.appendChild(new_tspan_element);
            }
        };
    }();
}
