<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */

/* Utility class for generating statement PDFs */
class TallyPDFManager {

	static function handle_request() {
		global $pageInstance;
		$mod = $pageInstance->module;
		$model = AppConfig::module_primary_bean($mod);
		if($model) {
			$pdf = self::load_generator($model);
			if($pdf) {
				$pdf->handle_request();
				return true;
			}
		}
		throw new IAHError("PDF generator not found for model: $model");
	}

	static function load_generator($model) {
		$mgr = AppConfig::setting("display.view.$model.tally_pdf_manager");
		if(! $mgr)
			$mgr = AppConfig::setting("display.view.$model.pdf_manager");
		if($mgr) {
			require_once $mgr['file'];
			return new $mgr['class'];
		}
	}

}

?>
