// vim: set filetype=markdown tw=80:

Add list of related records belonging to specified `model` and `id` via specific `link`.

You can specify related records in 2 ways:

1. Pass an array of related IDs in `records` parameter. This is suitable for
   most links, where you just want to set relationship between records, without
   specifying additional link data. Example: linking Contact to Account.
2. Pass an array of objects with additional data to be inserted into join table
   in `records_with_data` parameter.
   For example, when adding a product to assembly, you want to specify the
   quantity of products in the assembly. Imagine you want to add 5 products with
   ID `3d3e96d1-8d7c-acd6-e338-55b9b0cc5aae`  to assembly with ID 
   `5121670a-9ddb-8330-195d-5979fc9a6906`. Then you POST to
   `/data/Assembly/5121670a-9ddb-8330-195d-5979fc9a6906/products`, and pass the
   following JSON in request body:
   
   
   ```
   {
       "records_with_data": [
           {
               "id": "3d3e96d1-8d7c-acd6-e338-55b9b0cc5aae",
               "quantity" : 5
           }
       ]
   }
   ```


