// vim: set filetype=markdown tw=80:

1CRM API calls are performed as HTTP requests to `{BASEURI}`, with endpoint
appended to it. Note that endpoints listed in this documentation do not
include the base URI `{BASEURI}`. For example, if the documentation says that
to retrieve accounts list, one would send an HTTP GET request to `/data/Account`,
actual request should be made to `{BASEURI}/data/Account`. 

Call parameters can be passed to API in various ways:

*	in endpoint path. Such parameters are listed in this documentation with a colon
	prepended, for example `/data/:model`
*	in query string, for example `/data/Account?limit=10`. Array and
	object parameters can be specified using square brackets:
	
	`/data/Account?object[a][b]=1`
	
	`/data/Account?array[]=1&array[]=2`

*	in request body of POST and PUT requests, formatted as JSON object
*	in HTTP headers. Note that actual header name is derived from param name by
	replacing undersores with hyphens. Header name is case insensitive. For
	example, `CONTENT_TYPE` header parameter should be passed in `Content-Type`
	HTTP header

Requests containing data in the body must include the correct `Content-Length`
header.

Most API responses are formatted as JSON objects. A successful call result is
indicated with `200 OK` HTTP status code. Any response with status code
different from 200 indicates an error, with detailed error information available
in response body.

REST API is only available in Pro and Enterprise editions of 1CRM. Any attempt
to make an API call to Startup or Startup+ edition will result in `403
Forbidden` status code.


Note that the 1CRM API by default will reject any calls made over a non-SSL
connection (`http://`). These connections may be enabled by an option in 
Admin - System Settings.
