// vim: set filetype=markdown tw=80:
A Webhook is an HTTP callback: an HTTP POST that occurs when something happens;
a simple event-notification via HTTP POST.

In 1CRM, 3 types of webhooks are available `create`, `update` and 
`create_update`. Webhook type determines the event that triggers the
notification. `create` webhooks are triggered when a new record is created.
`update` webhooks are triggered when an existing record is updated.
`create_update` webhooks are triggered for both new records and updated records.

When a webhook is triggered, a HTTP POST request is sent to specified URL.
`Content-Type` header is set to `application/json`, and a JSON object is passed
in request body. The object contains the values of record's fields after the
update.

When a record is updated, first all webhooks with corresponding `type` and
`model` are selected. Then each webhook is examined for the user that created it.
If the user has no read access to the updated record, the webhook will be
excluded from further examination. Next, for each webhook, each filter from 
`filters` is examined:

* if `glue` is `and`, and __all__ conditions from `filters` are satisfied, the
  webhook triggers
* if `glue` is `or`, and __at least one__ condition from `filters` is satisfied, the
  webhook triggers

[Click here](?page=filter_examples) to see examples of webhook filters.

