<?php

return [
	'groups' => [
		'general' => [
			'title' => 'General',
			'docs' => '@groups/general',
			'articles' => [
				'connect' => [
					'title' => 'Connecting to 1CRM API',
					'docs' => '@groups/general/connect',
				],
				'override' => [
					'title' => 'HTTP Method override',
					'docs' => '@groups/general/override',
				],
				'codes' => [
					'title' => 'HTTP status codes',
					'docs' => '@groups/general/codes',
				],
				'language' => [
					'title' => 'Language',
					'docs' => '@groups/general/language',
				],
				'legend' => [
					'title' => 'Legend',
					'docs' => '@groups/general/legend',
				],
				'extend' => [
					'title' => 'Extending 1CRM API',
					'page' => 'extend',
				],
			],
		],
		'libraries' => [
			'title' => 'Client libraries',
			'docs' => '@groups/libraries',
			'articles' => [
				'phplib' => [
					'title' => 'PHP',
					'docs' => '@groups/libraries/php',
				],
			],
		],
		'auth' => [
			'title' => 'Authentication',
			'docs' => '@groups/auth',
			'articles' => [
				'basic' => [
					'title' => 'Basic authentication',
					'docs' => '@groups/auth/basic',
				],
				'oauth' => [
					'title' => 'OAuth 2 authentication',
					'docs' => '@groups/auth/oauth',
				],
				'session' => [
					'title' => 'Session authentication',
					'docs' => '@groups/auth/session',
				],
			],
		],
		'types' => ['title' => 'Types'],
		'oauth' => ['title' => 'Authentication'],
		'filters' => [
			'title' => 'List Filters',
			'docs' => '@groups/filters',
			'articles' => [
				'description' => [
					'title' => 'Apply',
					'docs' => '@groups/filters/description',
				],
			],
		],
		'data' => ['title' => 'Working with data'],
		'tally' => ['title' => 'Tally Objects', 'docs' => '@groups/tally'],
		'calendar' => ['title' => 'Working with calendars'],
		'meta' => ['title' => 'Working with metadata'],
		'files' => ['title' => 'Working with files'],
		'webhooks' => ['title' => 'Webhooks', 'docs' => '@groups/webhooks'],
		'portal' => ['title' => 'Portal'],
		'util' => ['title' => 'Utility'],
		'printer' => ['title' => 'Print PDF'],
		'audit' => ['title' => 'Audit'],
		"reports" => ['title' => 'Reports'],
		'layouts' => ['title' => 'Working with list and detail layouts'],
	],


	'types' => [
		'OneCRM\\API\\Types\\BoolType',
		'OneCRM\\API\\Types\\IntType',
		'OneCRM\\API\\Types\\StringType',
		'OneCRM\\API\\Types\\EnumType',
		'OneCRM\\API\\Types\\FloatType',
		'OneCRM\\API\\Types\\ArrayType',
		'OneCRM\\API\\Types\\ObjectType',
		'OneCRM\\API\\Types\\DateType',
		'OneCRM\\API\\Types\\DateTimeType',
		'OneCRM\\API\\Types\\FilenameType',
		'OneCRM\\API\\Types\\OneOfType',
		'OneCRM\\API\\Types\\FilterType',
		'OneCRM\\API\\Types\\StringFilterType',
		'OneCRM\\API\\Types\\NumberFilterType',
		'OneCRM\\API\\Types\\DatetimeFilterType',
		'OneCRM\\API\\Types\\EnumFilterType',
		'OneCRM\\API\\Types\\BoolFilterType',
		'OneCRM\\API\\Types\\WebhookWhenType',
		'OneCRM\\API\\Types\\TestComplexType',
	],

	'endpoints' => [
		'authLoginUser' => [
			'class' => 'OneCRM\\API\\Endpoints\\Auth\\LoginUser',
			'group' => 'oauth',
		],
		'authLoginContact' => [
			'class' => 'OneCRM\\API\\Endpoints\\Auth\\LoginContact',
			'group' => 'oauth',
		],
		'authGrantContact' => [
			'class' => 'OneCRM\\API\\Endpoints\\Auth\\GrantContact',
			'group' => 'oauth',
		],
		'authGrantUser' => [
			'class' => 'OneCRM\\API\\Endpoints\\Auth\\GrantUser',
			'group' => 'oauth',
		],
		'authAuthorizeContact' => [
			'class' => 'OneCRM\\API\\Endpoints\\Auth\\AuthorizeContact',
			'group' => 'oauth',
		],
		'authAuthorizeUser' => [
			'class' => 'OneCRM\\API\\Endpoints\\Auth\\AuthorizeUser',
			'group' => 'oauth',
		],
		'authAccessTokenContact' => [
			'class' => 'OneCRM\\API\\Endpoints\\Auth\\AccessTokenContact',
			'group' => 'oauth',
		],
		'authAccessTokenUser' => [
			'class' => 'OneCRM\\API\\Endpoints\\Auth\\AccessTokenUser',
			'group' => 'oauth',
		],
		'dataFavorites' => [
			'class' => 'OneCRM\\API\\Endpoints\\Data\\Favorites',
			'group' => 'data',
		],
		'dataList' => [
			'class' => 'OneCRM\\API\\Endpoints\\Data\\ListEndpoint',
			'group' => 'data',
		],
		'dataRecord' => [
			'class' => 'OneCRM\\API\\Endpoints\\Data\\Record',
			'group' => 'data',
		],
		'dataRelatedList' => [
			'class' => 'OneCRM\\API\\Endpoints\\Data\\RelatedList',
			'group' => 'data',
		],
		'dataRelatedListItem' => [
			'class' => 'OneCRM\\API\\Endpoints\\Data\\RelatedListItem',
			'group' => 'data',
		],
		'dataLinkedRecords' => [
			'class' => 'OneCRM\\API\\Endpoints\\Data\\LinkedRecords',
			'group' => 'data',
		],
		'dataErasePersonal' => [
			'class' => 'OneCRM\\API\\Endpoints\\Data\\ErasePersonal',
			'group' => 'data',
		],
		'calendarEvents' => [
			'class' => 'OneCRM\\API\\Endpoints\\Calendar\\Events',
			'group' => 'calendar',
		],
		'calendarReminders' => [
			'class' => 'OneCRM\\API\\Endpoints\\Calendar\\Reminders',
			'group' => 'calendar',
		],
		'filesUploadBase64' => [
			'class' => 'OneCRM\\API\\Endpoints\\Files\\UploadBase64',
			'group' => 'files',
		],
		'filesUpload' => [
			'class' => 'OneCRM\\API\\Endpoints\\Files\\Upload',
			'group' => 'files',
		],
		'filesDownload' => [
			'class' => 'OneCRM\\API\\Endpoints\\Files\\Download',
			'group' => 'files',
		],
		'filesInfo' => [
			'class' => 'OneCRM\\API\\Endpoints\\Files\\Info',
			'group' => 'files',
		],
		'metaFields' => [
			'class' => 'OneCRM\\API\\Endpoints\\Meta\\Fields',
			'group' => 'meta',
		],
		'metaLocale' => [
			'class' => 'OneCRM\\API\\Endpoints\\Meta\\Locale',
			'group' => 'meta',
		],
		'metaModules' => [
			'class' => 'OneCRM\\API\\Endpoints\\Meta\\Modules',
			'group' => 'meta',
		],
		'metaListView' => [
			'class' => 'OneCRM\\API\\Endpoints\\Meta\\ListView',
			'group' => 'meta',
		],
		'metaSubPanels' => [
			'class' => 'OneCRM\\API\\Endpoints\\Meta\\SubPanels',
			'group' => 'meta',
		],
		'metaDetailView' => [
			'class' => 'OneCRM\\API\\Endpoints\\Meta\\DetailView',
			'group' => 'meta',
		],
		'metaGeneric' => [
			'class' => 'OneCRM\\API\\Endpoints\\Meta\\GenericModuleLayouts',
			'group' => 'meta',
		],
		'profileMe' => [
			'class' => 'OneCRM\\API\\Endpoints\\Profile\\Me',
			'group' => 'util',
		],
		'utilPublicKey' => [
			'class' => 'OneCRM\\API\\Endpoints\\Util\\PublicKey',
			'group' => 'util',
		],
		'utilVersion' => [
			'class' => 'OneCRM\\API\\Endpoints\\Util\\Version',
			'group' => 'util',
		],
		'utilPushToken' => [
			'class' => 'OneCRM\\API\Endpoints\\Util\\PushToken',
			'group' => 'util',
		],
		'webhooksList' => [
			'class' => 'OneCRM\\API\Endpoints\\Webhooks\\Webhooks',
			'group' => 'webhooks',
		],
		'webhooksRecord' => [
			'class' => 'OneCRM\\API\Endpoints\\Webhooks\\Webhook',
			'group' => 'webhooks',
		],
		'portalAuth' => [
			'class' => 'OneCRM\\API\Endpoints\\Portal\\Auth',
			'group' => 'portal',
		],
		'tallyRecord' => [
			'class' => 'OneCRM\\API\Endpoints\\Tally\\Record',
			'group' => 'tally',
		],
		'printerPdf' => [
			'class' => 'OneCRM\\API\Endpoints\\Printer\\Pdf',
			'group' => 'printer',
		],
		'printerPersonalDataPdf' => [
			'class' => 'OneCRM\\API\Endpoints\\Printer\\PersonalDataPdf',
			'group' => 'printer',
		],
		'auditList' => [
			'class' => 'OneCRM\\API\\Endpoints\\Audit\\ListEndpoint',
			'group' => 'audit',
		],
		'auditRecord' => [
			'class' => 'OneCRM\\API\\Endpoints\\Audit\\Record',
			'group' => 'audit',
		],
		'reportsList' => [
			'class' => 'OneCRM\\API\\Endpoints\\Reports\\ListEndpoint',
			'group' => 'reports',
		],
		'reportsArchivedRuns' => [
			'class' => 'OneCRM\\API\\Endpoints\\Reports\\ArchivedRuns',
			'group' => 'reports',
		],
		'reportsData' => [
			'class' => 'OneCRM\\API\\Endpoints\\Reports\\Data',
			'group' => 'reports',
		],
		'layoutsListView' => [
			'class' => 'OneCRM\\API\\Endpoints\\Layouts\\ListView',
			'group' => 'layouts',
		],
	],
];
