<?php

namespace OneCRM\API\Endpoints\Auth;

class AuthorizeContact extends AuthorizeBase {

	public function endpoint() {
		return '/auth/contact/authorize';
	}

	public function getRouteName($method) {
		if (strtolower($method) === 'get') {
			return 'authorizeContact';
		}
	}

	protected function loginRoutePath($routeParser) {
		return $routeParser->urlFor('loginContact', [], ['redirect' => 'grantContact']);
	}

	protected function grantRoutePath($routeParser) {
		return $routeParser->urlFor('grantContact');
	}

	protected function descriptorGet() {
		$desc = parent::descriptorGet();
		$desc['title'] = 'Authorization request for contact';
		return $desc;
	}

	protected function resourceOwnerType() {
		return 'Contacts';
	}

	protected function isValidScope($id) {
		return $id == 'profile';
	}
}

