<?php

namespace OneCRM\API\Endpoints\Auth;

class AuthorizeUser extends AuthorizeBase {

	public function endpoint() {
		return '/auth/user/authorize';
	}

	public function getRouteName($method) {
		if (strtolower($method) === 'get') {
			return 'authorizeUser';
		}
	}

	protected function loginRoutePath($routeParser) {
		return $routeParser->urlFor('loginUser', [], ['redirect' => 'grantUser']);
	}

	protected function grantRoutePath($routeParser) {
		return $routeParser->urlFor('grantUser');
	}

	protected function descriptorGet() {
		$desc = parent::descriptorGet();
		$desc['title'] = 'Authorization request for user';
		return $desc;
	}

	protected function resourceOwnerType() {
		return 'Users';
	}

	protected function isValidScope($id) {
		return true;
	}

	protected function sessionUseCookies() {
		return true;
	}

}

