<?php

namespace OneCRM\API\Endpoints\Auth;

class GrantContact extends GrantBase {

	public function endpoint() {
		return '/auth/contact/grant';
	}

	public function getRouteName($method) {
		if (strtolower($method) === 'get') {
			return 'grantContact';
		}
	}

	public function allowedMethods() {
		return ['get', 'post'];
	}

	protected function resourceOwnerType() {
		return 'Contacts';
	}

	protected function authRouteName() {
		return 'authorizeContact';
	}

	protected function authRoutePath($routeParser, $random) {
		return $routeParser->urlFor('authorizeContact', [], ['c' => $random]);
	}
}


