<?php

namespace OneCRM\API\Endpoints\Auth;

class GrantUser extends GrantBase {

	public function endpoint() {
		return '/auth/user/grant';
	}

	public function getRouteName($method) {
		if (strtolower($method) === 'get') {
			return 'grantUser';
		}
	}

	public function allowedMethods() {
		return ['get', 'post'];
	}

	protected function resourceOwnerType() {
		return 'Users';
	}

	protected function authRouteName() {
		return 'authorizeUser';
	}

	protected function authRoutePath($routeParser, $random) {
		return $routeParser->urlFor('authorizeUser', [], ['c' =>  $random]);
	}
	protected function sessionUseCookies() {
		return true;
	}
}


