<?php

namespace OneCRM\API\Endpoints\Auth;

trait TemplateTrait {
	abstract protected function resourceOwnerType();
	
	protected function setupTemplate($container) {
		global $app_strings;
		$v = $container->get('view');
		$path = $v->getTemplatePath() . '/' . $this->resourceOwnerType() . '/';
		if ($auth_request = $this->sessionGet('auth_request')) {
			$tplPath = $v->getTemplatePath();
			$client_id = $auth_request->getClient()->getIdentifier();
			$specialPath = $tplPath . '/' . $client_id . '-' . $this->resourceOwnerType() . '/';
			if (is_dir($specialPath))
				$path = $specialPath;
		}
		$v->setTemplatePath($path);

		$edition =  ocrm_e_s();
		$ver = $edition . \AppConfig::version();
		$v->addAttribute('VERSION',  $ver);
		$v->addAttribute('LICENSEE', licensee());
		$v->addAttribute('APPNAME',  str_replace('{VERSION}', $ver, $app_strings['NTC_APPNAME']));
	}
}
