<?php

namespace OneCRM\API\Endpoints\Util;

use OneCRM\API\Endpoint;

class PublicKey extends Endpoint {

	public function endpoint() {
		return '/public_key';
	}

	public function descriptor($method) {
		if ($method == 'get')
			return $this->descriptorGet();
	}

	public function requiredScopes($method) {
		return [];
	}

	public function allowedMethods() {
		return ['get'];
	}

	public function requiresAuthentication() {
		return false;
	}

	private function descriptorGet() {
		static $desc = [
			'title' => 'Get server public key',
			'params' => [
			],
			'return' => [
				'key' => [
					'type' => 'String',
					'docs' => 'Contents of server public key',
					'required' => true,
				],
			]
		];
		return $desc;
	}

	protected function get($input, $res, $req) {
    	$publicKey = \AppConfig::setting('oauth.public_key');
		if (strpos($publicKey, 'file://') === 0) {
			$publicKey = file_get_contents($publicKey);
		}
		$ret = [
			'key' => $publicKey
		];

		return $this->withJson($res, $ret);
	}

}


