<?php

namespace OneCRM\API\Handlers;

use OneCRM\API\Errors\NotAllowed;
use Psr\Http\Message\ResponseInterface as Response;
use Slim\Exception\HttpBadRequestException;
use Slim\Exception\HttpForbiddenException;
use Slim\Exception\HttpNotFoundException;
use Slim\Exception\HttpNotImplementedException;
use Slim\Exception\HttpUnauthorizedException;
use Slim\Exception\HttpMethodNotAllowedException;
use Slim\Handlers\ErrorHandler as SlimErrorHandler;

class ErrorHandler extends SlimErrorHandler
{
	/**
	 * @inheritdoc
	 */
	protected function respond(): Response
	{
		$exception = $this->exception;

		$payload['status'] = $exception->getCode();
		$payload['message'] = $exception->getMessage();

		$response = $this->responseFactory->createResponse();
		$response->getBody()->write(json_encode($payload));
		return $response->withHeader('Content-Type', 'application/json')->withStatus($payload['status']);
	}
}
