<?php

namespace OneCRM\API\Middleware;

use Slim\Psr7\Response;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Server\RequestHandlerInterface as RequestHandler;
use Psr\Http\Message\ResponseInterface;

class RequestUri
{
	public function __invoke(Request $request, RequestHandler $handler): ResponseInterface
	{
		$uri = $request->getUri();
		$path = $uri->getPath();

		if ($path != '/' && substr($path, -1) == '/') {
			$path = rtrim($path, '/');
			$uri = $uri->withPath($path);

			if ($request->getMethod() == 'GET') {

				$response = new Response();
				return $response
					->withHeader('Location', (string) $uri)
					->withStatus(301);
			} else {
				$request = $request->withUri($uri);
			}
		}

		return $handler->handle($request);
	}
}
