<?php

namespace OneCRM\API\Middleware;

use Psr\Http\Message\ResponseInterface;
use Psr\Http\Message\ServerRequestInterface as Request;
use Psr\Http\Server\RequestHandlerInterface as RequestHandler;

class StartOneCRMSession {

	private $use_cookies;

	public function __construct($use_cookies = false) {
		$this->use_cookies = $use_cookies || \AppConfig::setting('site.security.api_session_auth');
	}

	public function __invoke(Request $request, RequestHandler $handler): ResponseInterface {
		if (!$this->use_cookies)
			ini_set('session.use_cookies', 0);
		$lang = $request->getAttribute('onecrm_lang');
		\AppConfig::session_start(null, false, false, ['language' => $lang]);
		\SessionManager::doNotKeepSession();
		return $handler->handle($request);
	}
}

