<?php

namespace OneCRM\API;

abstract class Type {

	protected $name;
	protected $server;

	public function __construct($server, $name) {
		$this->name = $name;
		$this->server = $server;
	}

	public function getName() {
		return $this->name;
	}

	abstract public function parseValue($name, $val, $params = array());
	
	public function parseValueEx($name, $val, $params = array()) {
		if (!$this->isBasic()) {
			$this->expandComplexDef($params);
		}
		return $this->parseValue($name, $val, $params);
	}

	public function getDocs() {
	}

	public function isBasic() {
		return true;
	}

	public function expandComplexDef(&$def) {
	}

}

