<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;

class BoolFilterType extends  ObjectType {

	public function __construct($server, $name = 'BoolFilter') {
		parent::__construct($server, $name);
	}

	public function getDocs() {
		return 'This type represents a webhook filter by a boolean field.';
	}

	public function isBasic() {
		return false;
	}
	public function expandComplexDef(&$def) {
		$def['schema'] = [
			'field' => [
				'type' => 'String',
				'required' => true,
				'docs' => 'Name of the field this filter applies to',
			],
			'filter' => [
				'type' => 'Enum',
				'options' => [
					'is_true',
					'is_false',
				],
				'required' => true,
				'docs' => 'Filter operator',
			],
			'when' => [
				'type' => 'WebhookWhen',
				'required' => true,
				'docs' => 'Type of change',
			],
		];
	}
}


