<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;
use OneCRM\API\Errors;

class BoolType extends Type {

	public function __construct($server, $name = 'Bool') {
		parent::__construct($server, $name);
	}

	public function parseValue($name, $val, $params = array()) {
		if (is_bool($val))
			$val = $val ? 'true' : 'false';
		if (is_string($val) || is_numeric($val))
			$val = strtolower($val);
		switch (true) {
			case $val === '1' || $val === 'yes' || $val === 'true':
				$val = true;
				break;
			case $val === '0' || $val === 'no' || $val === 'false':
				$val = false;
				break;
			default:
				throw new Errors\BadRequest("Param {$name} should be of type Bool");
		}
		return $val;
	}

	public function getDocs() {
		return '@types/bool';
	}
}

