<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;
use OneCRM\API\Errors;

class DateType extends StringType {

	public function __construct($server, $name = 'Date') {
		parent::__construct($server, $name);
	}

	public function parseValue($name, $val, $params = array()) {
		$val = parent::parseValue($name, $val, $params);
		if (!preg_match('/^\d\d\d\d-\d\d-\d\d$/', $val))
			throw new Errors\BadRequest("Param {$name} is not properly formatted as a date");
		return $val;
	}

	public function getDocs() {
		return '@types/date';
	}

	public function isBasic() {
		return false;
	}
}

