<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;

class DatetimeFilterType extends  ObjectType {

	public function __construct($server, $name = 'DatetimeFilter') {
		parent::__construct($server, $name);
	}

	public function getDocs() {
		return '@types/datetime_filter';
	}

	public function isBasic() {
		return false;
	}
	public function expandComplexDef(&$def) {
		$def['schema'] = [
			'field' => [
				'type' => 'String',
				'required' => true,
				'docs' => 'Name of the field this filter applies to',
			],
			'filter' => [
				'type' => 'Enum',
				'options' => [
					'not_empty',
					'empty',
					'before_date',
					'after_date',
					'before_today',
					'after_today',
					'on_date',
					'not_on_date',
					'yesterday',
					'today',
					'tomorrow',
					'period_prev',
					'period_current',
					'period_next',
					'between_dates',
				],
				'required' => true,
				'docs' => 'Filter operator',
			],
			'value' => [
				'type' => 'OneOf',
				'choices' => [
					['type' => 'Date'],
					['type' => 'DateTime'],
				],
				'required' => false,
				'docs' => 'Operand',
			],
			'value2' => [
				'type' => 'OneOf',
				'choices' => [
					['type' => 'Date'],
					['type' => 'DateTime'],
				],
				'required' => false,
				'docs' => 'Second operand',
			],
			'when' => [
				'type' => 'WebhookWhen',
				'required' => true,
				'docs' => 'Type of change',
			],
		];
	}
}


