<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;

class EnumFilterType extends  ObjectType {

	public function __construct($server, $name = 'EnumFilter') {
		parent::__construct($server, $name);
	}

	public function getDocs() {
		return '@types/enum_filter';
	}

	public function isBasic() {
		return false;
	}
	public function expandComplexDef(&$def) {
		$def['schema'] = [
			'field' => [
				'type' => 'String',
				'required' => true,
				'docs' => 'Name of the field this filter applies to',
			],
			'filter' => [
				'type' => 'Enum',
				'options' => [
					'eq',
					'not_eq',
					'any_of',
					'not_any_of',
					'all_of',
					'empty',
					'not_empty',
				],
				'required' => true,
				'docs' => 'Filter operator',
			],
			'value' => [
				'type' => 'OneOf',
				'choices' => [
					['type' => 'String'],
					[
						'type' => 'Array',
						'value_type' => 'String',
					],
				],
				'required' => false,
				'docs' => 'Operand. When filtering on enum fields, pass a string. For multienum fields, pass an array of strings',
			],
			'when' => [
				'type' => 'WebhookWhen',
				'required' => true,
				'docs' => 'Type of change',
			],
		];
	}
}


