<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;
use OneCRM\API\Errors;

class EnumType extends Type {

	public function __construct($server, $name = 'Enum') {
		parent::__construct($server, $name);
	}

	public function parseValue($name, $val, $params = array()) {
		$type = $this->getName();
		if (!is_string($val))
			throw new Errors\BadRequest("Param {$name} should be of type {$type}");
		if (!in_array($val, $params['options'])) {
			throw new Errors\BadRequest("Wrong value for param {$name}");
		}
		return $val;
	}

	public function getDocs() {
		return '@types/enum';
	}
}

