<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;

class FilenameType extends StringType {

	public function __construct($server, $name = 'Filename') {
		parent::__construct($server, $name);
	}

	public function parseValue($name, $val, $params = array()) {
		$val = parent::parseValue($name, $val, $params);
		$norm = str_replace('\\', '/', $val);
		$valid = true;
		$valid = $valid && $norm != '.';
		$valid = $valid && $norm != '..';
		$valid = $valid && (strpos($norm, '/') === false);
		$valid = $valid && (strpos($norm, ':') === false);
		return $val;
	}

	public function getDocs() {
		return '@types/filename';
	}

	public function isBasic() {
		return false;
	}
}

