<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;

class FilterType extends  ObjectType {

	public function __construct($server, $name = 'WebhookFilter') {
		parent::__construct($server, $name);
	}

	public function getDocs() {
		return 'This type represents a webhook filter.';
	}

	public function isBasic() {
		return false;
	}
	public function expandComplexDef(&$def) {
		$def['schema'] = [
			'glue' => [
				'type' => 'Enum',
				'required' => true,
				'options' => ['or', 'and'],
			],
			'conditions' => [
				'docs' => 'Depends',
				'required' => true,
				'type' => [
					'type' => 'Array',
					'element_type' => [
						'type' => 'OneOf',
						'choices' => [
							['type' => 'StringFilter'],
							['type' => 'DatetimeFilter'],
							['type' => 'EnumFilter'],
							['type' => 'NumberFilter'],
							['type' => 'BoolFilter'],
							['type' => 'WebhookFilter'],
						],
					],
				],
			],
		];
	}


}

