<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;
use OneCRM\API\Errors;

class IntType extends Type {

	public function __construct($server, $name = 'Int') {
		parent::__construct($server, $name);
	}

	public function parseValue($name, $val, $params = array()) {
		if (!is_numeric($val))
			throw new Errors\BadRequest("Param {$name} should be of type Int");
		$val = (int)$val;
		if (isset($params['min']) && $val < ($min = $params['min']))
			throw new Errors\BadRequest("Param {$name} should be of at least {$min}, but {$val} was passed");
		if (isset($params['max']) && $val > ($max = $params['max']))
			throw new Errors\BadRequest("Param {$name} should be of at most {$max}, but {$val} was passed");
		return $val;
	}

	public function getDocs() {
		return '@types/int';
	}
}

