<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;

class NumberFilterType extends  ObjectType {

	public function __construct($server, $name = 'NumberFilter') {
		parent::__construct($server, $name);
	}

	public function getDocs() {
		return '@types/number_filter';
	}

	public function isBasic() {
		return false;
	}
	public function expandComplexDef(&$def) {
		$def['schema'] = [
			'field' => [
				'type' => 'String',
				'required' => true,
				'docs' => 'Name of the field this filter applies to',
			],
			'filter' => [
				'type' => 'Enum',
				'options' => [
					'lt',
					'gt',
					'lte',
					'gte',
					'between',
					'empty',
					'not_empty',
					'eq',
					'not_eq',
				],
				'required' => true,
				'docs' => 'Filter operator',
			],
			'value' => [
				'type' => 'Float',
				'required' => false,
				'docs' => 'Operand',
			],
			'value2' => [
				'type' => 'Float',
				'required' => false,
				'docs' => 'Second operand',
			],
			'when' => [
				'type' => 'WebhookWhen',
				'required' => true,
				'docs' => 'Type of change',
			],
		];
	}
}


