<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;

class StringFilterType extends  ObjectType {

	public function __construct($server, $name = 'StringFilter') {
		parent::__construct($server, $name);
	}

	public function getDocs() {
		return '@types/string_filter';
	}

	public function isBasic() {
		return false;
	}
	public function expandComplexDef(&$def) {
		$def['schema'] = [
			'field' => [
				'type' => 'String',
				'required' => true,
				'docs' => 'Name of the field this filter applies to',
			],
			'filter' => [
				'type' => 'Enum',
				'options' => [
					'eq',
					'not_eq',
					'prefix',
					'suffix',
					'like',
					'not_like',
					'empty',
					'not_empty',
				],
				'required' => true,
				'docs' => 'Filter operator',
			],
			'value' => [
				'type' => 'String',
				'required' => false,
				'docs' => 'Operand',
			],
			'when' => [
				'type' => 'WebhookWhen',
				'required' => true,
				'docs' => 'Type of change',
			],
		];
	}
}


