<?php

namespace OneCRM\API\Types;
use OneCRM\API\Type;
use OneCRM\API\Errors;

class StringType extends Type {

	public function __construct($server, $name = 'String') {
		parent::__construct($server, $name);
	}

	public function parseValue($name, $val, $params = array()) {
		$type = $this->getName();
		if (!is_string($val))
			throw new Errors\BadRequest("Param {$name} should be of type {$type}");
		$len = strlen($val);
		if (isset($params['min_len']) && $len < ($min_len = $params['min_len']))
			throw new Errors\BadRequest("Param {$name} should be of at least {$min_len} characters, but passed value is {$len} characters");
		if (isset($params['max_len']) && $len > ($max_len = $params['max_len']))
			throw new Errors\BadRequest("Param {$name} should be of at most {$min_len} characters, but passed value is {$len} characters");
		return $val;
	}

	public function getDocs() {
		return '@types/string';
	}
}

