<?php
/**
 * Created by PhpStorm.
 * User: brafreider
 * Date: 27.07.2016
 * Time: 11:31
 */

namespace v4\oAuth\Repositories;


use League\OAuth2\Server\Entities\AuthCodeEntityInterface;
use League\OAuth2\Server\Repositories\AuthCodeRepositoryInterface;
use v4\oAuth\Entities\AuthCodeEntity;

/**
 * Class AuthCodeRepository
 * AuthCodes werden vom Client an den Auth-Server übermittelt (über einen Redirect des Benutzers nach /authorize),
 * immer wenn beim Client kein, oder ein abgelaufener AccessCode vorhanden ist.
 *
 * Die REvokation scheint aktuell nicht aufgerufen zu werden
 *
 * @package v4\oAuth\Repositories
 */
class AuthCodeRepository implements AuthCodeRepositoryInterface
{
    public function getNewAuthCode()
    {
        return new AuthCodeEntity();
    }

    public function persistNewAuthCode(AuthCodeEntityInterface $authCodeEntity)
    {
        // ggf fürs Logging implementieren
    }

    public function revokeAuthCode($codeId)
    {
        // manuelles Zurückziehen eines AUthcodes?
    }

    public function isAuthCodeRevoked($codeId)
    {
        return false;
    }

}