<?php
/**
 * Created by PhpStorm.
 * User: brafreider
 * Date: 11.08.2016
 * Time: 10:31
 */

namespace v4\utils;


class RememberMeTokenRepository implements RememberMeTokenRepositoryInterface
{

    protected $beanName = 'RememberMeTokenEntity';

    public function getRememberMeTokenById($id)
    {
        $crmToken = \ListQuery::quick_fetch($this->beanName, $id);
        if ($crmToken) {
            $token = new RememberMeTokenEntity();
            $token->setExpires($crmToken->getField('expires'));
            $token->setId($id);
            $token->setToken($crmToken->getField('token'));
            $token->setUserId($crmToken->getField('user_id'));
            $token->setUserType($crmToken->getField('user_type'));
            return $token;
        }
    }

    public function getNewToken()
    {
        return new RememberMeTokenEntity();
    }

    public function invalidateTokensForUser($userId)
    {
        $lq = new \ListQuery($this->beanName);
        $lq->addSimpleFilter('user_id', $userId['id']);
        $lq->addSimpleFilter('user_type', $userId['type']);
        $listResult = $lq->runQuery();
        $rowResults = $listResult->getRowResults();
        foreach($rowResults as $row){
            $update = \RowUpdate::for_result($row);
            $update->deleteRow();
        }
    }

    public function persistToken(RememberMeTokenEntity $token)
    {
        if ($token->getId()){
            $oldToken  = \ListQuery::quick_fetch($this->beanName, $token->getId());
            if ($oldToken){
                $crmToken = \RowUpdate::for_result($oldToken);
            }
        }
        if (empty($crmToken)){
            $crmToken = \RowUpdate::blank_for_model($this->beanName, \AppConfig::setting('oauth.assigned_user_id', 1));
        }
        $crmToken->set(
            [
                'expires' => $token->getExpires(),
                'token'=> $token->getToken(),
                'user_id' => $token->getUserId(),
                'user_type' => $token->getUserType(),
            ]
        );
        if ($crmToken->validate()) {
            $crmToken->save();
            $primaryKeyValue = $crmToken->getPrimaryKeyValue();
            $token->setId($primaryKeyValue);
            return $primaryKeyValue;
        }
        return null;
    }

    public function deleteToken(RememberMeTokenEntity $token)
    {
        $crmToken = \ListQuery::quick_fetch($this->beanName, $token->getId());
        if ($crmToken){
            $update = \RowUpdate::for_result($crmToken);
            $update->deleteRow();
        }
    }


}
