<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */

require_once('include/application/ModuleController.php');

class ClassicController extends ModuleController {
	var $seedBean;
	
	function __construct($mod) {
		parent::__construct($mod);
		//$this->load_bean(); // ajrw - disabled for 7.0. re-enable if still needed
	}
	
	
	function load_bean() {
		global $beanFiles, $beanList;
		$this->seedBean = null;
		if(! isset($beanList[$this->module]))
			return;
		$obj = $beanList[$this->module];
		if(! isset($beanFiles[$obj]))
			return;
		require_once($beanFiles[$obj]);
		$this->seedBean = new $obj();
	}
	
	
	function get_directive() {
		global $current_user;
		$d = parent::get_directive();
		// FIXME - move into a hook in the Emails module
		if($this->module == 'Emails' && ! empty($_REQUEST['massupdate'])) {
			$current_user->invalidate_emails_count();
		}
		return $d;
	}
}

