<?php

class SessionManager extends SessionHandler {
	private const KEEP_KEY_NAME = 'oauth.keep_session';
	private const USER_KEY_NAME = 'authenticated_user_id';

	public static function keepSession() {
		$_SESSION[self::KEEP_KEY_NAME] = true;
	}

	public static function doNotKeepSession() {
		unset($_SESSION[self::KEEP_KEY_NAME]);
	}

	public function write($id, $data): bool {
		$destroy = empty($_SESSION[self::USER_KEY_NAME]) && empty($_SESSION[self::KEEP_KEY_NAME]);
		if ($destroy) return $this->destroy($id);
		return parent::write($id, $data);
	}
}

