<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
?><?php return; ?>

single
	id
		vname: LBL_ID
		vname_module: app
		required: true
		reportable: false
		type: id
		comment: Unique identifier
		editable: false
		module_designer: disabled
	
	name
		vname: LBL_NAME
		required: true
		type: name
		len: 60
		comment: Display name
	
	deleted
		vname: LBL_DELETED
		vname_module: app
		type: bool
		required: true
		default: 0
		editable: false
		reportable: false
		module_designer: disabled
	
	date_entered
		vname: LBL_DATE_ENTERED
		vname_module: app
		type: datetime
		required: true
		editable: false
		module_designer: label_only
	
	date_modified
		vname: LBL_DATE_MODIFIED
		vname_module: app
		type: datetime
		required: true
		editable: false
		module_designer: label_only
	
	assigned_user
		id_name: assigned_user_id
		vname: LBL_ASSIGNED_TO
		vname_list: LBL_LIST_ASSIGNED_USER
		vname_module: app
		type: ref
		bean_name: User
		reportable: true
		audited: true
		comment: User ID assigned to record
		duplicate_merge: false
		massupdate: true
		required: true
		module_designer: label_only
	
	modified_user
		id_name: modified_user_id
		vname: LBL_MODIFIED
		vname_module: app
		type: ref
		bean_name: User
		isnull: false
		reportable: true
		required: true
		comment: User who last modified record
		editable: false
		module_designer: label_only
	
	created_by_user
		id_name: created_by
		vname: LBL_CREATED
		vname_module: app
		type: ref
		bean_name: User
		isnull: false
		comment: User ID who created the record
		editable: false
		module_designer: label_only
	
	currency
		# defined in supported_types
		type: currency_ref
	
	exchange_rate
		# defined in supported_types
		type: exchange_rate
	
	email_recips
		type: text
	
	file_ref
		type: varchar
		len: 255
	
	shared_with
		vname: LBL_SHARED_WITH
		type: enum
		options: shared_with_dom
	personal_info_source
		vname: LBL_PERSONAL_INFO_SOURCE
		type: varchar
		len: 255
multi
	recurrence_fields
		recurrence_of_id
			vname: LBL_RECURRENCE_OF_ID
			type: id
			reportable: false
		recurrence_rule
			vname: LBL_RECURRENCE_RULE
			type: ref
			bean_name: RecurrenceRule
			required: false
			reportable: false
		recurrence_index
			vname: LBL_RECURRENCE_INDEX
			type: int
			default: 0
			required: true
			reportable: false
			ui: false
		recurrence_rules
			vname: LBL_RECURRENCE_RULES
			type: varchar
			len: 255
			required: false
			reportable: false
			source: non-db
			ui: false
		forward_times
			vname: LBL_RECURRENCE_FORWARD_TIMES
			required: false
			type: text
			reportable: false
			ui: false
		recurrence_exception
			type: bool
			ui: false
			reportable: false
		recurrence_start_time
			type: datetime
			reportable: false
			ui: false
