<?php return; ?>
@info
	description: Default localization settings and options

base_language: en_us
defaults
	date_format: Y-m-d
	time_format: H:i
	name_format: s f l
	name_order_by: last_name
	address_format: Britain
	number_format: English
	language: en_us
	use_real_names: false
	timezone: UTC
	holidays: usa
	week_start_day: 0
	currency_source: ECB
	rss_feed
		icon: "http://www.1crm.com/favicon.ico"
		title: 1CRM | Small Business CRM
		url: "http://feeds.feedburner.com/1crm/tVnS"
	weather_cities
		--
			name: Vancouver
			woeid: 6173331
			timezone: America/Vancouver
		--
			name: New York
			woeid: 5128581
			timezone: America/New_York
		--
			name: London
			woeid: 2643743
			timezone: Europe/London
		--
			name: Moscow
			woeid: 524901
			timezone: Europe/Moscow
		--
			name: Canberra
			woeid: 2172517
			timezone: Australia/Sydney
		--
			name: Santiago
			woeid: 3871336
			timezone: America/Santiago
charsets
	BIG-5: BIG-5 (Taiwan and Hong Kong)
	# CP866: CP866 # MS-DOS Cyrillic
	# CP949: CP949 # Microsoft Korean
	CP1251: CP1251 (MS Cyrillic)
	CP1252: CP1252 (MS Western European & US)
	EUC-CN: EUC-CN (Simplified Chinese GB2312)
	EUC-JP: EUC-JP (Unix Japanese)
	EUC-KR: EUC-KR (Korean)
	EUC-TW: EUC-TW (Taiwanese)
	ISO-2022-JP: ISO-2022-JP (Japanese)
	ISO-2022-KR: ISO-2022-KR (Korean)
	ISO-8859-1: ISO-8859-1 (Western European and US)
	ISO-8859-2: ISO-8859-2 (Central and Eastern European)
	ISO-8859-3: ISO-8859-3 (Latin 3)
	ISO-8859-4: ISO-8859-4 (Latin 4)
	ISO-8859-5: ISO-8859-5 (Cyrillic)
	ISO-8859-6: ISO-8859-6 (Arabic)
	ISO-8859-7: ISO-8859-7 (Greek)
	ISO-8859-8: ISO-8859-8 (Hebrew)
	ISO-8859-9: ISO-8859-9 (Latin 5)
	ISO-8859-10: ISO-8859-10 (Latin 6)
	ISO-8859-13: ISO-8859-13 (Latin 7)
	ISO-8859-14: ISO-8859-14 (Latin 8)
	ISO-8859-15: ISO-8859-15 (Latin 9)
	KOI8-R: KOI8-R (Cyrillic Russian)
	KOI8-U: KOI8-U (Cyrillic Ukranian)
	SJIS: SJIS (MS Japanese)
	UTF-8: UTF-8 (Unicode)
map_charsets
	iso-2022-jp: iso-2022-jp-ms
	gb2312: cp936
	ks_c_5601-1987: UHC
currencies
	CAD
		symbol: C$
		name: Canadian Dollar
		rate: 1.30810
		significant_digits: 2
	EUR
		symbol: €
		name: Euro
		rate: 0.94357
		significant_digits: 2
	GBP
		symbol: £
		name: UK Pound
		rate: 0.79963
		significant_digits: 2
	AUD
		symbol: A$
		name: Australian Dollar
		rate: 1.30858
		significant_digits: 2
	JPY
		symbol: ¥
		name: Japanese Yen
		rate: 113.781
		significant_digits: 0
	CNY
		symbol: 元
		name: Chinese Yuan Renminbi
		rate: 6.87859
		significant_digits: 2
	SGD
		symbol: S$
		name: Singapore Dollar
		rate: 1.42438
		significant_digits: 2
	MYR
		symbol: MYR
		name: Malaysian Ringgit
		rate: 4.44899
		significant_digits: 2
	MXN
		symbol: Mex$
		name: Mexican Peso
		rate: 20.3132
		significant_digits: 2
	INR
		symbol: Rs
		name: Indian Rupee
		rate: 66.9954
		significant_digits: 2
	NZD
		symbol: NZ$
		name: New Zealand Dollar
		rate: 1.39502
		significant_digits: 2
	CHF
		symbol: Fr.
		name: Swiss Franc
		rate: 1.00617
		significant_digits: 2
	ZAR
		symbol: R
		name: South African Rand
		rate: 13.3348
		significant_digits: 2
	NGN
		symbol: ₦
		name: Nigerian Naira
		rate: 410.3348
		significant_digits: 2
	TTD
		symbol: TT$
		name: Trinidad and Tobago Dollar
		rate: 0.15
		significant_digits: 2
	AED
		symbol: AED
		name: United Arab Emirates Dirham
		rate: 3.6725
		significant_digits: 2
	PKR
		symbol: ₨
		name: Pakistani Rupee
		rate: 126.85
		significant_digits: 2
	SAR
		symbol: SAR
		name: Saudi Riyal
		rate: 0.26666667
		significant_digits: 2
address_formats
	Britain
		display: "{n}|{d}|{a}|{s}|{c}[, ]{t}[  ]{p}|{o}"
	France # Europe 1
		display: "{n}|{a}|{d}|{s}|{p}[ ]{c}[ ]{t}|{o}"
	Germany # Europe 2
		display: "{a}|{n}|{d}|{s}|{p}[ ]{c}[ ]{t}|{o}"
	#Italy
	#	display: "{a}|{n}|{d}|{s}|{p}-{c} {t}|{o}"
	Japan
		display: "{o}|{p}|{t}[ ]{c}|{s}|{a}|{n}"
	Switzerland
		display: "{a}|{n}|{d}|{s}|{p}[ ]{c}[ / ]{t}|{o}"
number_formats
	English
		grp_sep: ","
		dec_sep: "."
	German # German/Brazilian/Italian/Spanish
		grp_sep: "."
		dec_sep: ","
	French # Czech/French
		grp_sep: " "
		dec_sep: ","
	Swiss
		grp_sep: "'"
		dec_sep: ","
	Swiss Currency
		grp_sep: "'"
		dec_sep: "."
	Plain
		grp_sep: ""
		dec_sep: "."
date_formats
	"Y-m-d": "2006-12-23"
	"m-d-Y": "12-23-2006"
	"d-m-Y": "23-12-2006"
	"Y/m/d": "2006/12/23"
	"m/d/Y": "12/23/2006"
	"d/m/Y": "23/12/2006"
	"Y.m.d": "2006.12.23"
	"d.m.Y": "23.12.2006"
	"m.d.Y": "12.23.2006"
time_formats
	"H:i": "23:00"
	"h:ia": "11:00pm"
	"h:i a": "11:00 pm"
	"h:iA": "11:00PM"
	"h:i A": "11:00 PM"
	"H.i": "23.00"
	"h.ia": "11.00pm"
	"h.i a": "11.00 pm"
	"h.iA": "11.00PM"
	"h.i A": "11.00 PM"
base_currency
	name: US Dollar
	iso4217: USD
	symbol: $
	significant_digits: 2
	space_separate: true
	symbol_place_after: false
list_export_formats
	csv
	tsv
	scsv
	xlscsv
name_display_formats
	- "s f l"
	- "l, s f"
	- "l, f s"
	- "s l f"
currency_sources
	ECB
		url: "https://www.ecb.europa.eu/stats/eurofxref/eurofxref-daily.xml"
	BOC
		url: "https://www.bankofcanada.ca/valet/observations/group/FX_RATES_DAILY/xml"
