<?php return; ?>
@info
	description:
		Settings related to email notifications. May be overridden by database values.

enabled: false
from_address: 1crm@example.com
from_name: 1CRM System
send_by_default: 1
send_from_assigning_user: 0
send_invites_by_default: 0
decorate_sender: true
formatter: default
formatters
	default
		class_name: NotifyFormatter
		path: include/Notify/NotifyFormatter.php
disabled
	Emails: true
messages
	assigned
		required_fields
			- assigned_user_id
	survey
		class: SurveyMessage
		required_fields
			- name
			- case_number
			- cust_contact_id
			- rating
			- assigned_user_id
	invited
		class: InviteMessage
		required_fields
			- assigned_user_id
			- date_start
			- date_entered
	reminder
		class: InviteMessage
		required_fields
			- assigned_user_id
			- date_start
			- date_entered
	report
		class: ReportMessage
		required_fields
			- report_id
			- report
			- name
			- primary_module
			- cache_filename
			- record_count
			- date_entered
			- assigned_user_id
			- sources_spec
			- columns_spec
			- filters_spec
			- filter_values
			- groups
			- description
			report_name: report.name
	thread_reply
		class: ThreadReplyMessage
		required_fields
			- created_by
			- thread
	expire_warn
		class: ExpiryMessage
		required_fields
			- assigned_user_id
	expired
		class: ExpiryMessage
		required_fields
			- assigned_user_id
	overdue
		class: ExpiryMessage
		required_fields
			- assigned_user_id
styles
	body:
		margin: 0;
		padding: 0;
		background-color: #fff;
	outer:
		font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif !important;
		font-size: 12pt;
		line-height: 150%;
		color: #444;
	message_title:
		font-family: Geneva, 'Helvetica Neue', Helvetica, Arial, sans-serif !important;
		color: #333;
	message_title_container:
		border-radius: 1em 1em 0 0;
		border: 0.2em solid;
		border-color: #e1effd;
		background-color: #ebf3ff;
	message_row:
		background-color: #fff;
		border: 0.2em solid #ebedf2;
		border-radius: none;
		border-top: none;
	message_row_last:
		border-radius: 0 0 0.5em 0.5em;
		border-bottom-width: 0.2em;
	prop_name:
		color: #888;
		font-size: 90%;
		padding: 0.4em 0.8em 0 0;
	prop_value:
		padding-top: 0.3em;
	item_number:
		font-family: Monaco, monospace;
		white-space: nowrap;
	badge_active:
		border-color: #6b6;
		color: #595;
	badge_draft:
		color: #b85;
		border-color: #c96;
	badge_neutral: ""
	badge_pending:
		color: #68b;
		border-color: #8ad;
	badge_deferred:
		color: #969;
		border-color: #c8b;
	badge_closed:
		background-color: rgba(130, 130, 130, 0.5);
		border-color: #999;
		color: #fff;
	badge_dead:
		background-color: rgba(170, 170, 170, 0.5);
		border-color: #aaa;
		color: #666;
	badge_warn:
		background-color: rgba(255, 240, 160, 0.5);
		border-color: #b75;
		color: #b65;
	badge_error:
		background-color: rgba(220, 80, 80, 0.5);
		border-color: #a55;
		color: #fff;
	button_normal:
		border: 0.15em solid #57b; background: #59d;
		color: #fff; text-decoration: none; padding: 0.25em 0.5em; margin-left: 0.2em; border-radius: 3px;
	button_default:
		color: #fff; text-decoration: none; padding: 0.25em 0.5em; margin-left: 0.2em; border-radius: 3px;
		border: 0.15em solid #888; background: #aaa;
	text_input:
		font-family: 'Helvetica Neue', Helvetica, Arial, sans-serif;

