<?php return; ?>
@info
	description:
		Settings related to the application itself,
		which don't belong under other categories.

paths
	cache_dir: cache/
	custom_dir: custom/
	files_dir: files/
	backup_dir: files/backups/
	import_dir: cache/import/
	logs_dir: logs/
	pdf_dir: cache/pdf/
	reports_dir: files/reports/
	smarty_dir: cache/smarty/
	upload_dir: files/upload/
	xml_dir: cache/xml/
performance
	read_only: false
	use_php_code_json: true
	dump_slow_queries: false
	slow_query_time_msec: 100
	rss_cache_time: 10800
	vcal_cache_time: 21600
	calculate_response_time: false
	show_page_resources: false
	show_memory_usage: false
	log_included_files: false
	log_all_queries: false
	disable_count_query: false
	static_url: ""
	multiviews: false
	defer_load_list: false
	defer_load_subpanels_count: 5
	status_check_interval: 300000
	disable_status_check: false
	suppress_display_errors: true
	suppress_deprecation_warnings: true
	suppress_strict_warnings: true
	activity_log: true
	upload_expiry_time: 10080
	track_page_stats: false
security
	verify_client_ip: true
	remember_user: true
	default_remember_user: true
	auto_https_redirect: true
	api_enabled: true
	insecure_api_calls: false
	md5_hashed_passwords: false
	email_password_recovery: true
	recovery_timeout_hours: 48
	enforce_login_delay: true
	api_basic_auth: true
    api_session_auth: false
	email_xss
		applet: applet
		base: base
		embed: embed
		form: form
		frame: frame
		frameset: frameset
		iframe: iframe
		import: "\\?import"
		layer: layer
		link: link
		object: object
		script: script
		xmp: xmp
db_defaults
	persistent: true
	autofree: false
	debug: 0
	seqname_format: %s_seq
	portability: 0
	ssl: false
	charset: utf8
	collation: utf8_general_ci
	strict: true
	enum_field_size: 255
session
	name: ""
	dir: ""
user
    activity
        tracker: off
        timeout: 15
        grace: 5
log
	backup_count: 5
	file: site.log
	file_size: 10MB
	level: warn
	memory_usage: false
	stack_trace_errors: false
    clear_activities_interval: 60
history_max_viewed: 10
import
	max_execution_time: 3600
export
	disabled: false
	admin_only: false
features
	require_accounts: true
	enable_timeout_alerts: false
	auto_add_case_line_items: false
	auto_add_project_line_items: false
	update_check_enabled: true
	restrict_case_booking: false
	carddav_sync_enabled: true
	caldav_sync_enabled: true
	extended_text_filter: false
	combined_detail: true
	gotomeeting
		enabled: true
		meeting_url: https://www.gotomeeting.com/join/{ID}
login
	show_nav: false
upload
	maxsize: 20971520
	badext
		- php
		- php3
		- php4
		- php5
		- pl
		- cgi
		- bat
		- exe
		- sh
		- py
		- pyc
		- asp
		- cfm
		- js
		- vbs
		- rb
		- htm
		- html
		- xhtml
top_logo
	login: include/images/iah/1crm-logo.svg
	primary: include/images/iah/1crm-logo.svg
	auto_height: 60
	login_height: 60
side_logo
	primary: ""
	alt: include/images/iah/1crm-logo.svg
	auto_height: 35
reminders
	lookahead_seconds: 14400
csp
	default-src
		- "'self'"
	frame-src
		- https://zapier.com/
	script-src
		- "'self'"
		- "'unsafe-inline'"
		- "'unsafe-eval'"
		- https://zapier.com
		- https://cdn.zapier.com
		- https://maps.googleapis.com
	img-src
		- *
		- data:
	style-src
		- "'self'"
		- "'unsafe-inline'"
		- https://cdn.zapier.com
		- https://fonts.googleapis.com
	base-uri
		- "'self'"
	form-action
		- "'self'"
	connect-src
		- "'self'"
		- https://api.zapier.com
		- https://zapier.com
		- https://maps.googleapis.com
	font-src
		- "'self'"
		- https://fonts.gstatic.com


