<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  is a form helper
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/


function checkRequired($prefix, $required){
	foreach($required as $key){
		if(!isset($_POST[$prefix.$key]) || number_empty($_POST[$prefix.$key])){
			return false;
		}
	}
	return true;
}
// longreach - modified - return a reference
function &populateFromPost($prefix, &$focus){
	global $current_user;
	if(!empty($_REQUEST[$prefix.'record']))
		$focus->retrieve($_REQUEST[$prefix.'record']);
	
	
	// longreach - added - significant change from standard SugarCRM
	// note: this allows numeric fields to be updated in the user's chosen number format
	$focus->format_all_fields();
	
	
	if(isset($_REQUEST[$prefix.'status']) && !empty($_REQUEST[$prefix.'status'])){
			$focus->status = $_REQUEST[$prefix.'status'];	
	}
	$has_assigned = in_array('assigned_user_id', $focus->column_fields);
	if ($has_assigned && !empty($_POST[$prefix.'assigned_user_id']) && ($focus->assigned_user_id != $_POST[$prefix.'assigned_user_id']) && ($_POST[$prefix.'assigned_user_id'] != $current_user->id)) {
		$GLOBALS['check_notify'] = true;
	}
	// longreach - added
	$groups = array();
	 foreach($focus->column_fields as $field)
		{
			if(isset($_POST[$prefix.$field]))
			{
				$fdef = $focus->getFieldDefinition($field);
				if(! is_array($fdef)) $fdef = array();
				if(!empty($fdef['isMultiSelect']) || (array_get_default($fdef, 'type') == 'multienum' && empty($fdef['multi_select_group']))){
					if(!is_array($_POST[$prefix.$field])) {
						$_POST[$prefix.$field] = (array)$_POST[$prefix.$field];
					}
					if(empty($_POST[$prefix.$field][0])){
						unset($_POST[$prefix.$field][0]);
					}
					$_POST[$prefix.$field] = implode('^,^', $_POST[$prefix.$field]);	
				}
				// longreach - start added
				if(!empty($fdef['multi_select_group'])){
					if(!is_array($_POST[$prefix.$field])) {
						$_POST[$prefix.$field] = (array)$_POST[$prefix.$field];
					}
					$values = $_POST[$prefix.$field];
					$group =  $fdef['multi_select_group'];
					if (isset($groups[$group])) continue;
					$groups[$group] = 1;
					$i = 0;
					$flds = $focus->column_fields;
					foreach($flds as $cf) {
						$grpdef = $focus->getFieldDefinition($cf);
						if (isset($grpdef['multi_select_group']) && $grpdef['multi_select_group'] == $group) {
							if (isset($values[$i])) $_POST[$prefix.$cf] = $values[$i];
							else $_POST[$prefix.$cf] = '';
							$focus->$cf = $_POST[$prefix.$cf];
							$i++;
						}
					}
				} else 
				// longreach - end added
				$focus->$field = $_POST[$prefix.$field];
			}
		}
		
		foreach($focus->additional_column_fields as $field)
		{
			if(isset($_POST[$prefix.$field]))
			{
				$value = $_POST[$prefix.$field];
				$focus->$field = $value;
			}
		}
		return $focus;

}

function getPostToForm($ignore=''){
	$fields = '';
	foreach ($_POST as $key=>$value){
		if($key != $ignore)
			$fields.= "<input type='hidden' name='$key' value='$value'>";
	}
	return $fields;

}
function getGetToForm($ignore=''){
	$fields = '';
	foreach ($_GET as $key=>$value){
		if($key != $ignore)
			$fields.= "<input type='hidden' name='$key' value='$value'>";
	}
	return $fields;

}
function getAnyToForm($ignore=''){
	/* longreach - removed
	$fields = getPostToForm($ignore);
	$fields .= getGetToForm($ignore);
	return $fields;
	*/
	// longreach - added
	$arr = array_merge($_POST, $_GET);
	if(is_array($ignore)) {
		foreach($ignore as $i)
			if(isset($arr[$i])) unset($arr[$i]);
	} else
		if(isset($arr[$ignore])) unset($arr[$ignore]);
	$html = formatHiddenFields($arr);
	return $html;
}

function handleRedirect($return_id='', $return_module='')
{
	if(isset($_REQUEST['return_url']) && $_REQUEST['return_url'] != "")
	{
		header("Location: ". $_REQUEST['return_url']);
		exit;
	}

	if(! empty($_REQUEST['return_module']) && $_REQUEST['return_module'] != $return_module)
	{
		$return_module = $_REQUEST['return_module'];
		$return_id = ''; // return_id is expected to be the ID of the object just saved
	}
	
	if(isset($_REQUEST['return_action']) && $_REQUEST['return_action'] != "")
	{
	    
	   //if we are doing a "Close and Create New"
        if($_REQUEST['action'] == "Save" && isset($_REQUEST['isSaveAndNew']) && 
            $_REQUEST['isSaveAndNew'] == 'true')
        {
            $return_action = "EditView";    
            $isDuplicate = "true";        
            $status = "";
            // Meeting Integration
            if(isset($_REQUEST['meetingIntegrationFlag']) && $_REQUEST['meetingIntegrationFlag'] == 1) {
            	$additionalFlags = array('meetingIntegrationShowForm' => '1');
            }
            // END Meeting Integration
        } 
		// if we create a new record "Save", we want to redirect to the DetailView
		else if($_REQUEST['action'] == "Save" 
			&& $_REQUEST['return_module'] != 'Activities'



			&& $_REQUEST['return_module'] != 'Home' 
			&& $_REQUEST['return_module'] != 'Forecasts' 
			&& $_REQUEST['return_module'] != 'Calendar'
			&& $_REQUEST['return_module'] != 'MailMerge'



		) {
			if ($_REQUEST['return_action'] != 'index' || $return_id) {
				$return_action = 'DetailView';
			} else {
				$return_action = 'index';
			}
		} elseif($_REQUEST['return_module'] == 'Activities' || $_REQUEST['return_module'] == 'Calendar') {
			$return_module = $_REQUEST['module'];
			$return_action = $_REQUEST['return_action']; 
			// wp: return action needs to be set for one-click close in task list
		} else {
			// if we "Cancel", we go back to the list view.
			$return_action = $_REQUEST['return_action'];
		}
	}
	else
	{
		$return_action = "DetailView";
	}
	
	if(isset($_REQUEST['return_id']) && $_REQUEST['return_id'] != "")
	{
		$return_id = $_REQUEST['return_id'];
	}
    
	
	// longreach - start added - save and new support
	if(isset($_REQUEST['save_and_new']) && $_REQUEST['save_and_new'] == 'true')
	{
		$return_module = '';
		$return_action = '';
		$return_id = '';
		if(isset($_REQUEST['return_module']))
			$return_module = $_REQUEST['return_module'];
		if(isset($_REQUEST['return_action']))
			$return_action = $_REQUEST['return_action'];
		if(isset($_REQUEST['return_id']))
			$return_id = $_REQUEST['return_id'];
		$return_to = "return_action=$return_action&return_module=$return_module&return_id=$return_id";
		
		$parent_type = '';
		$parent_id = '';
		$parent_name = '';
		if(isset($_REQUEST['parent_type']))
			$parent_type = $_REQUEST['parent_type'];
		if(isset($_REQUEST['parent_id']))
			$parent_id = $_REQUEST['parent_id'];
		if(isset($_REQUEST['parent_name']))
			$parent_name = $_REQUEST['parent_name'];
		$carryover = "parent_type=$parent_type&parent_id=$parent_id&parent_name=$parent_name";
		
		if(isset($_REQUEST['contact_id'])) {
			$carryover .= '&contact_id='.$_REQUEST['contact_id'];
			$carryover .= '&contact_name='.$_REQUEST['contact_name'];
		}

		$module = $_REQUEST['module'];
		header("Location: index.php?module=$module&action=EditView&$return_to&$carryover");
		exit;
	}
	// longreach - end added
	
	
    if (empty($isDuplicate))
    {
        header("Location: index.php?action=$return_action&module=$return_module&record=$return_id&return_module=$return_module&return_action=$return_action");
    } else {
    	$standard = "action=$return_action&module=$return_module&record=$return_id&isDuplicate=true&return_module=$return_module&return_action=$return_action&status=$status";
   		$add = '';

    	if(isset($additionalFlags) && !empty($additionalFlags)) {
    		foreach($additionalFlags as $k => $v) {
    			if(!empty($add)) {
    				$add .= "&";
    			}
    			$add .= "{$k}={$v}";
    		}
    	}
    	if(!empty($add)) {
    		$add = "&" . $add;
    	}
        header("Location: index.php?{$standard}{$add}");
    }
	exit;
}

function getLikeForEachWord($fieldname, $value, $minsize=4){
	$value = trim($value);
	$values = explode(' ',$value);
	$ret = '';
	foreach($values as $val){
		if(strlen($val) >= $minsize){
			if(!empty($ret)){
				$ret .= ' or';
			}
			$ret .= ' '. $fieldname . ' LIKE %'.$val.'%';
		}

	}


}

function formatHiddenFields($fields, $format='htmlentities') {
	$tmp = array();
	foreach($fields as $key => $value) {
		if(isset($value)){
			if (is_array($value)) {
				foreach($value as $valuekey=>$valuevalue) {
					if(is_array($valuevalue)) // skip nested arrays
						continue;
					$tmp["{$key}[{$valuekey}]"] = $valuevalue;
				}
			}
			else
				$tmp[$key] = $value;
		}
	}
	$out = '';
	foreach($tmp as $f => $v) {
		$out .= sprintf('<input type="hidden" name="%s" value="%s" />',
			$format($f), $format($v));
	}
	return $out;
}


?>
