<?php

if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

$module = $_REQUEST['module'];
$module = $module == 'Activities' ? 'Notes' : $module;
$model = AppConfig::module_primary_bean($module);

$parent_model = $_REQUEST['parent_model'];
$parent_module = AppConfig::module_for_model($parent_model);
$parent_id = $_REQUEST['parent_id'];

if ($model !== 'Document' && $model !== 'Note') {
	exit;
}

if(!ACLController::checkAccess($module, 'edit', true)) {
	exit;
}

require_once 'include/database/RowUpdate.php';
require_once 'include/database/ListQuery.php';

$link_name = $model == 'Document' ? 'documents' : 'notes';

$parent = null;
if ($parent_model && $parent_id) {
	$parent = ListQuery::quick_fetch($parent_model, $parent_id);
}

$document = RowUpdate::blank_for_model($model);
$filename_field = $model == 'Document' ? 'revision_filename' : 'filename';
$_REQUEST[$filename_field] = $_POST['file_id'];
$document->request = [
	'filename_field' => $_POST['file_id']
];

$document->loadRequest();
$file = $document->getRelatedFile($filename_field);

$account_fields = ['account_id', 'primary_account_id', 'billing_account_id', 'shipping_account_id'];
$accountId = null;
if ($parent) {
	foreach ($account_fields as $f) {
		$accountId = $parent->getField($f);
		if ($accountId)
			break;
	}
}

if ($model == 'Document') {
	$update = [
		'status_id' => AppConfig::setting('dragdrop.status', 'Draft'),
		'category_id' => AppConfig::setting('dragdrop.category'),
		'department' => AppConfig::setting('dragdrop.department'),
		'active_date' => gmdate("Y-m-d"),
		'document_name' => $file ? $file->original_file_name : 'New Document',
	];
} else {
	$update = [
		'name' => $file ? $file->original_file_name : 'New Document',
		'parent_type' => $parent_module,
		'parent_id' => $parent_id,
		'account_id' => $accountId,
	];
}

$document->set($update);

if ($document->save()) {
	$docId = $document->getField('id');
	if ($parent) {
		$parentUpdate = RowUpdate::for_result($parent);
		$parentUpdate->addUpdateLink($link_name, $docId);
		if ($accountId) {
			$account = ListQuery::quick_fetch('Account', $accountId);
			if ($account) {
				$accountUpdate = RowUpdate::for_result($account);
				$accountUpdate->addUpdateLink($link_name, $docId);
			}
		}
	}
}



exit;

//$module = array_get_gefault(

