<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

if (!function_exists("Detail_php_main")) {
	function Detail_php_main() {
		require_once 'include/utils/misc_functions.php';
		require_once('include/DetailView/DetailFactory.php');
		$GLOBALS['forceFlashMessages'] = true;

		$type = array_get_default($_REQUEST, 'mgr_type', 'standard');

		if (!iml($GLOBALS['module']))
			ACLController::displayNoAccess();

		$mgr = DetailFactory::getManager($type, $GLOBALS['module']);
		$allow_debug = AppConfig::setting('site.allow_debug');
		if($allow_debug)
			$mgr->debug = array_get_default($_REQUEST, 'debug', false);
		$mgr->loadRequest();
		try {
			$mgr->standardInit();
		} catch(IAHLayoutLoadError $e) {
			if($allow_debug) throw $e;
			throw IAHError::withParams('LBL_LAYOUT_LOAD_ERROR', array('redirect_home' => true));
			return;
		}
		$nextAction = $mgr->performUpdate();
		if($nextAction)
			return $nextAction;

		global $pageInstance;
		if($mgr->in_popup)
			$pageInstance->set_title('', true);
		else {
			$t = $mgr->getPageTitle() ?? '';
			if(strlen($t))
				$pageInstance->set_title($t);
		}

		echo $mgr->renderLayout();
	}
}

return Detail_php_main();

?>
