<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point'); 
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  controls which link show up in the upper right hand corner of the app
 ********************************************************************************/
 if(!isset($global_control_links)){
 	$global_control_links = array();
	$sub_menu = array();
 }
$global_control_links['myaccount'] = array(
'linkinfo' => array($app_strings['LBL_MY_ACCOUNT'] => 'index.php?module=Users&action=DetailView&record='.$current_user->id.''),
'submenu' => ''
 );
$global_control_links['directory'] = array(
'linkinfo' => array($app_strings['LBL_DIRECTORY']=> 'index.php?module=Directory&action=index'),
'submenu' => ''
);
if (is_admin($current_user)) $global_control_links['admin'] = array(
'linkinfo' => array($app_strings['LBL_ADMIN'] => 'index.php?module=Administration&action=index'),
'submenu' => ''
);
$global_control_links['about'] = array('linkinfo' => array($app_strings['LNK_ABOUT'] => 'index.php?module=Home&action=About'),
'submenu' => '',
'icon' => 'icon-help',
);
$global_control_links['logout'] = array(
'linkinfo' => array($app_strings['LBL_LOGOUT'] => 'index.php?module=Users&action=Logout'),
'submenu' => ''
);


// this method determines which global link applies to the current page, if any
function currentGlobalLink() {
	global $module, $action, $current_user, $modInvisList;
	// longreach - added
	global $subModuleList;
	$record = isset($_REQUEST['record']) ? $_REQUEST['record'] : '';
	$section = isset($_REQUEST['section']) ? $_REQUEST['section'] : '';
	$current = '';
	if($module == 'Directory')
		$current = 'directory';
	elseif($module == 'Home' && $action == 'About')
		$current = 'about';
	elseif($module == "Users" && $action=="DetailView" && $record == $current_user->id)
		$current = 'myaccount';
	elseif($module == 'HR' || ($module == 'Documents' && $section == 'hr'))
		$current = 'hr';
	elseif($module == 'Home' && $action == 'UnifiedSearch')
		$current = 'search';
	elseif($module == 'Prospects' || $module == 'ProspectLists')
		$current = ''; // otherwise appear in admin
	// longreach - added $subModuleList condition
	elseif($module == 'Users' || $module == 'Administration' || (in_array($module, $modInvisList) && !isset($subModuleList[$module])))
		$current = 'admin';
	return $current;
}
$cur = currentGlobalLink();
if(isset($global_control_links[$cur]))
	// set a flag to be interpreted by the theme
	$global_control_links[$cur]['current'] = true;
if(empty($GLOBALS['current_user']->id)) {
	$about = $global_control_links['about'];
	$global_control_links = array();
	$lbl = translate('LBL_LOGIN_BUTTON_LABEL', 'Users');
	$global_control_links['login'] = array(
		'linkinfo' => array($lbl => 'login.php'),
		'submenu' => '',
		'icon' => 'theme-icon module-ACL',
	);
	$global_control_links['about'] = $about;
}
// longreach - end added


?>
