AppBase.module('asyncLogin').init(function(App) {
	var loginPopup;
    var httpRequest;
    var self = this;
    this.popupEnabled = true;

	return {
		init: function() {
			return this;
		},
        showLoginPopup: function(httpReq) {
            if (httpReq) httpRequest = httpReq;

			var cookie = window.document.cookie || '';
			if (~cookie.indexOf('ANDROID_APP=true')) {
				if (confirm('ANDROID_APP_RELOGIN_REQUEST')) {
					var mock = {
						getResult: function() {return {result: 'ok'};},
					};
					self.loginSuccess.call(mock);
				} else {
					self.loginFailure();
				}
				return;
			}

            loginPopup = new App.ui.Dialog('asyncLogin', { width: '350px', height: '400px', resizable: false, draggable: true, title: app_string('NTC_JS_SESSION_ENDED_SHORT') });
            if (!App.session.user_name) this.popupEnabled = false;

            if (!this.popupEnabled) {
                if(httpRequest) httpRequest.fail(app_string('NTC_JS_SESSION_ENDED'));
                return false;
            }
            loginPopup.ondestroy = function() {
                self.popupEnabled = true;
                loginPopup = null;
                if(httpRequest) httpRequest.fail(app_string('NTC_JS_SESSION_ENDED'));
            }
            var username = html_escape(App.session.user_name || Get_Cookie('ck_login_username'));
            var body = '<form onsubmit="AsyncLogin.doLogin(); return false;" class="card-outer form-outer default-form" autocomplete="off">';
            body += '<div class="card-body form-body">';
            body += '<div class="form-section">';
            body += '<div class="row form-row">'
				+ '<div class="column form-cell">'
					+ '<div class="form-entry">'
						+ '<label class="form-label" for="login_user_name">' + app_string('LBL_USER_NAME') + '</label>'
						+ '<div class="form-value"><input type="hidden" name="user_name" id="login_user_name" value="' + username + '">' +username+ '</div>'
					+ '</div>'
				+ '</div>'
			+ '</div>';
            body += '<div class="row form-row">'
				+ '<div class="column form-cell">'
					+ '<div class="form-entry">'
						+ '<label class="form-label" for="login_user_password">' + app_string('LBL_PASSWORD') + '</label>'
						+ '<div class="form-value"><input type="password" size="20" id="login_user_password" name="user_password" class="input-text input-block" autocomplete="off" value=""></div>'
					+ '</div>'
				+ '</div>'
			+ '</div>';
            body += '<div class="row form-row" id="login_error_row" style="display: none">'
				+ '<div class="column form-cell">'
					+ '<div class="form-entry">'
						+ '<div class="form-value text-error" id="login_error_message"></div>'
					+ '</div>'
				+ '</div>'
			+ '</div>';
			body += '</div></div>';
            body += '<div class="card-footer form-buttons">';
            body += '<div class="row buttons-row">';
            body += '<div class="column buttons-inline align-right">';
            body += '<div class="inline-elt">';
            body += '<button class="input-button" type="button" id="login_cancel_button" name="cancel" onclick="SUGAR.asyncLogin.closeLoginPopup(); return false;"><div class="input-icon icon-cancel left"></div><span class="input-label">' + app_string('LBL_CANCEL_BUTTON_LABEL') + '</span></button>';
            body += '</div><div class="inline-elt">';
            body += '<button class="input-button" type="submit" id="login_button" name="login" onclick="SUGAR.asyncLogin.doLogin(); return false;"><div class="input-icon icon-accept left"></div><span class="input-label">' + app_string('LBL_LOGIN_BUTTON_LABEL') + '</span></button>';
            body += '</div></div></div></div></form>';

            loginPopup.setContent(body);
            loginPopup.render();
            loginPopup.onshow = function() { self.onShowPopup(); }
            loginPopup.show();
            return true;
        },
        showVerifyCodeForm: function() {
            var body = '<form onsubmit="AsyncLogin.verifyCode(); return false;" class="card-outer form-outer default-form" autocomplete="off">';
            body += '<div class="card-body form-body">';
            body += '<div class="form-section">';
            body += '<div class="row form-row">'
                + '<div class="column form-cell">'
                + '<div class="form-entry">'
                + '<label class="form-label" for="login_user_name">' + app_string('LBL_TWO_FA_AUTH_CODE') + '</label>'
                + '<div class="form-value"><input type="text" size="20" id="login_otp" name="otp" class="input-text input-block" autocomplete="off" value=""></div>'
                + '</div>'
                + '</div>'
                + '</div>';
            body += '<div class="row form-row" id="login_error_row" style="display: none">'
                + '<div class="column form-cell">'
                + '<div class="form-entry">'
                + '<div class="form-value text-error" id="login_error_message"></div>'
                + '</div>'
                + '</div>'
                + '</div>';
            body += '</div></div>';
            body += '<div class="card-footer form-buttons">';
            body += '<div class="row buttons-row">';
            body += '<div class="column buttons-inline align-right">';
            body += '<div class="inline-elt">';
            body += '<button class="input-button" type="button" id="login_cancel_button" name="cancel" onclick="SUGAR.asyncLogin.closeLoginPopup(); return false;"><div class="input-icon icon-cancel left"></div><span class="input-label">' + app_string('LBL_CANCEL_BUTTON_LABEL') + '</span></button>';
            body += '</div><div class="inline-elt">';
            body += '<button class="input-button" type="submit" id="login_button" name="login" onclick="SUGAR.asyncLogin.verifyCode(); return false;"><div class="input-icon icon-accept left"></div><span class="input-label">' + app_string('LBL_VERIFY_BUTTON_LABEL') + '</span></button>';
            body += '</div></div></div></div></form>';

            loginPopup.setContent(body);
            loginPopup.render();
            self.onShowOtpPopup();
        },
        onShowPopup: function() {
        	var user = $('login_user_name'), pass = $('login_user_password');
        	if(user.value) pass.focus() && pass.select();
        	else user.focus();
        },
        onShowOtpPopup: function() {
            const otp_elem = $('login_otp');
            if (otp_elem)
                otp_elem.focus();
        },
        closeLoginPopup: function() {
            if(loginPopup) {
                loginPopup.hide();
                loginPopup.destroy();
            }
        },
        doLogin: function() {
            var currentLang = App.session.language || 'en_us';
            var params = {
                'username': $('login_user_name').value,
                'password': $('login_user_password').value,
                'language': currentLang,
                'theme': App.session.theme
            };
            $('login_button').disabled = true;
            var req = new App.conn.JSONRequest('login', {status_msg: app_string('LBL_LOGGING_IN')}, params);
            $('login_user_password').value = '********';
            req.fetch(self.loginSuccess, self.loginFailure);
            return false;
        },
        verifyCode: function() {
            var params = {
                'otp': $('login_otp').value,
            };
            $('login_button').disabled = true;
            var req = new App.conn.JSONRequest('mfa_verify_code', {status_msg: app_string('LBL_LOGGING_IN')}, params);
            req.fetch(self.loginSuccess, self.loginFailure);
            return false;
        },
        loginSuccess: function() {
            var row = this.getResult();
            if(row.result == 'show_multi_fa_code') {
                if (loginPopup) {
                    self.showVerifyCodeForm();
                } else {
                    self.fetchHttpRequest();
                }
            } else if(row.result == 'ok') {
				self.popupEnabled = true;
				if (loginPopup) {
	                loginPopup.ondestroy = function() {};                 
    	            loginPopup.hide();
        	        loginPopup.destroy();
            	    loginPopup = null;
				}
				self.fetchHttpRequest();
            } else {
                self.loginFailure(row.message);
            }
        },
        fetchHttpRequest: function() {
            if(httpRequest) {
                if(httpRequest.async) httpRequest.fetch();
                else httpRequest.fail(app_string('LBL_LOGGED_IN'));
            }
        },
        loginFailure: function(msg) {
            if ($('login_user_password'))
	            $('login_user_password').value = '';
            if ($('login_button'))
	            $('login_button').disabled = false;
            self.showError(msg || app_string('LBL_CONNECTION_FAILED'));
        },
        showError: function(msg) {
            if($('login_error_message'))
	            $('login_error_message').innerHTML = msg;
            App.ui.setDisplayState('login_error_row', true);
        }
	}.init();
});
