DNDUploader = function(options) {

	var extractError = function(response) {
		if (response.files) {
			if (response.files.file) {
				if (response.files.file.error) {
					if (response.files.file.error.length) {
						return response.files.file.error;
					}
				}
			}
		}
	};

	var dropzone = new Dropzone('#' + options.list_id + '-outer', { 
		url: "upload.php?user_id=" + SUGAR.session.user_id,
		clickable: false,
		//maxFiles: 1,
		autoProcessQueue: true,
		previewTemplate: '<div style="display:none"></div>',
		init: function() {
			var nextId = 0;
			var status = {};
			this.on("sending", function(file, xhr, formData) {
				var csrf_cookie = 
					window.document.cookie.split(";")
						.map(function(str) {return str.trim()})
						.map(function(str) {return str.split('=')})
						.find(function(parts) {return parts[0] === 'UNKNOWN'});
				if (csrf_cookie) {
					xhr.setRequestHeader('X-OneCRM-CSRF-Token', csrf_cookie[1]);
				}
			});

			this.on("addedfile", function(file) {
				file.uniqueId = nextId++;
			});

			this.on("complete", function(file) {
				this.removeFile(file);
			});

			this.on("uploadprogress", function(file, progress) {
				var message = file.name + ': ' + parseInt(progress) + '%';
				if (!status[file.uniqueId]) {
					status[file.uniqueId] = new SUGAR.ui.StatusMessage('x');
				}
				status[file.uniqueId].message = message;
				SUGAR.ui.Status.show(status[file.uniqueId]);
			});

			this.on("complete", function(file) {
				SUGAR.ui.Status.remove(status[file.uniqueId]);
				delete status[file.uniqueId];
			});

			this.on("success", function(file, response) {
				var error = extractError(response);
				if (!error) {
					var incoming_id = response.files.file.id;
					if (incoming_id) {
						var vars = {
							module: options.module,
							action: 'DNDUpload',
							parent_id: options.parent_id,
							parent_model: options.parent_model,
							file_id: 'INCOMING~' + incoming_id,
							auto_create_revision: 1
						};
						if (options.list_id) {
							SUGAR.conn.asyncRequest('async.php', {postData: vars},
								function(data) {
    								SUGAR.ui.refreshTarget('subpanel', options.list_id);
								}
							);
						}
					}
				} else {
					SUGAR.ui.Status.show(file.name + ' :' + error, 3000);
				}
			});

			this.on("maxfilesexceeded", function(file) {
			});

		}
	}); 
}

