(function() {
	var Wrap = SUGAR.dom.extNode;
	var ExtNode = SUGAR.dom.ExtNode;
	var ExtNodeList = SUGAR.dom.ExtNodeList;
	var LayoutEditor = function() {
		LE = this;


		LE.sections = {};
		LE.sections_order = [];
		LE.allElements = {};
		this.visible_custom = 0;
		this.visible_standard = 0;
		this.is_custom = {};
		this.hooks = {};
		this.tabGroup = null;

		LE.overTarget = null;

		LE.uid = 0;
		LE.quickEdit = null;


		LE.init = function(sections, slots, fields, default_columns, disabled_fields)
		{
			this.form = $('DetailForm');
			this.allFields = fields;
			var usedNames = {};
			LE.sections_order = [];
			LE.default_columns = default_columns || 2;
			LE.allElements = sections.elements;
			if (typeof(LE.allElements.length) == 'number')
				LE.allElements = {};
			LE.sections = sections.sections;
			var idx = 0;
			for (var i  in LE.sections) {
				var sect = LE.sections[i];
				LE.sections_order[idx++] = i;
				if (i == '_form_header' || i == '_form_subheader') {
					var ddId = 'hdd_' + i;
					if ($(ddId))
						this.makeDraggable(ddId, ddId, {});
				}
				for (var j =0; j < sect.rows_order.length; j++) {
					var row = sect.rows[sect.rows_order[j]];
					for (var k = 0; k < row.length; k++) {
						var id = row[k].id;
						var ddId = 'dd_' + id;
						if ($(ddId))
							this.makeDraggable(ddId, ddId, {});
						if (LE.allElements[row[k].id].name == "") {
						} else {
							usedNames[LE.allElements[row[k].id].name] = true;
						}
					}
				}
			}

			

			var have_custom = false;
			var have_standard = false;

			var div = document.createElement('div');
			div.style.fontWeight = 'bold';
			div.appendChild(document.createTextNode(app_string('LBL_LE_CUSTOM')));
			$('le_fields_content').appendChild(div);
			var div = document.createElement('div');
			div.appendChild(document.createTextNode('<None>'));
			div.id = 'le_custom_none';
			$('le_fields_content').appendChild(div);
			for (var i = 0; i < fields.length; i++) {
				var f = fields[i];
				if (!get_default(f.ui, true))
					continue;
				if (disabled_fields.indexOf(f.name) >= 0)
					continue;
				if (f.source != 'custom_field' && !have_standard) {
					var div = document.createElement('div');
					div.style.fontWeight = 'bold';
					div.appendChild(document.createTextNode(app_string('LBL_LE_STANDARD')));
					$('le_fields_content').appendChild(div);
					have_standard = true;
					var div = document.createElement('div');
					div.appendChild(document.createTextNode('<None>'));
					div.id = 'le_standard_none';
					$('le_fields_content').appendChild(div);
				}
				var div = document.createElement('div');
				div.id = 'newfield_' + f.name;
				div.style.marginBottom = '4px';
				div.fieldLabel = f.label;

				var innerDiv = document.createElement('div');
				innerDiv.className="input-label";
				innerDiv.appendChild(document.createTextNode(f.label));
				div.appendChild(innerDiv);



				div.className = 'input-field input-field-group state-label';
				div.style.display = 'block';
				if (f.source == 'custom_field') this.is_custom[f.name] = true;
				if (usedNames[f.name]) {
					div.style.display = 'none';
				} else {
					if (f.source != 'custom_field') this.visible_standard++;
					else this.visible_custom++;
				}
				this.makeDraggable(div, div);
				$('le_fields_content').appendChild(div);
			}
			if (this.visible_custom > 0) $('le_custom_none').style.display = 'none';
			if (this.visible_standard > 0) $('le_standard_none').style.display = 'none';

			var title = $('le_fields_title');
			if(title) {
				title.onclick = function() { SUGAR.le.toggleFieldsBox(this); return false; }
				title.style.cursor = 'pointer';
			}



			var keys = this.allFields.map(function(f) {return f.name});
			var values = this.allFields.map(function(f) {return f.label});

			var opts = {keys: deep_clone(keys), values: deep_clone(values), width: 300, add_blank: true};
			var options = new SUGAR.ui.SelectOptions(opts);
			SUGAR.ui.registerSelectOptions('__le_fields_with_blank__', options);

			var opts2 = {keys: keys, values: values, width: 300, add_blank: false};
			var options2 = new SUGAR.ui.SelectOptions(opts2);
			SUGAR.ui.registerSelectOptions('__le_fields__', options2);
			
			setTimeout(
				function() { 
					var box = $('le_fields_box');
					LE.makeDraggable(box);
					var region = box.getBoundingClientRect();
					var vp = SUGAR.ui.getViewport();
					LE.desiredFieldsBoxPos = {x: region.left - vp.x, y : region.top - vp.y};
					LE.updateFieldBoxConstraints(); 
					SUGAR.le.updateFieldBoxConstraints(); 
					LE.addHooks();
			}, 1000);

		};

		LE.registerTabGroup = function(tg) {
			this.tabGroup = tg;
		}

		LE.addHooks = function() {
			var $window = Wrap(window);
			this.hooks.resize = (function() { SUGAR.le.updateFieldBoxConstraints(); }).bind(this);
			this.hooks.scroll = (function() { SUGAR.le.updateFieldBoxConstraints(); }).bind(this);
			$window.on('resize', this.hooks.resize);
			$window.on('scroll', this.hooks.scroll);
			SUGAR.ui.onDestroyForm(this.form, function() { SUGAR.le.removeHooks(); });
		};
		
		LE.removeHooks = function() {
			var $window = Wrap(window);
			$window.off('resize', this.hooks.resize);
			$window.off('scroll', this.hooks.scroll);
			this.hooks = {};
		};
		
		LE.addNewField = function(sourceId, targetId) {
			var newFieldName = sourceId.replace(/^newfield_/, '');
			var targetName = targetId.replace(/^d[dt]_/, '');
			var oldFieldName = LE.allElements[targetName] ? LE.allElements[targetName].name : "";
			var groupDiv = document.createElement('div');

			groupDiv.id = targetId.replace(/^(dd|dt)_/, 'lbl_');
			groupDiv.className = 'input-field input-field-group state-label';
			groupDiv.style.display = 'block';
			groupDiv.innerHTML = $(sourceId).innerHTML;
			var targetElt = $('dd_' + targetName);
			SUGAR.ui.clearChildNodes(targetElt);
			targetElt.appendChild(groupDiv);
			var targetVal = $('dv_' + targetName);
			if(targetVal) SUGAR.ui.clearChildNodes(targetVal);

			groupDiv.childNodes[0].onclick = function(e) {
				SUGAR.le.editField(this);
				return false;
			};

			var div = document.createElement('div');
			div.className = 'input-label input-remove';
			div.id = 'del_' + targetName;
			div.style.visibility = 'hidden';
			groupDiv.appendChild(div);
			div.onclick = function() {
				SUGAR.le.clearField(this);
				return false;
			};
			targetElt.onmouseover = function() {
				SUGAR.le.showDelete(this);
			}
			targetElt.onmouseout = function() {
				SUGAR.le.hideDelete(this);
			}
			
			LE.allElements[targetName].name = sourceId.replace(/^newfield_/, '');
			LE.allElements[targetName].label = $(sourceId).fieldLabel;
			var displayOld = $('newfield_' + oldFieldName);
			if (displayOld) {
				displayOld.style.display = 'block';
				if (LE.is_custom[oldFieldName]) LE.visible_custom++;
				else LE.visible_standard++;
			}
			var displayNew = $('newfield_' + newFieldName);
			if (displayNew) {
				displayNew.style.display = 'none';
				if (LE.is_custom[newFieldName]) LE.visible_custom--;
				else LE.visible_standard--;
			}
			$('le_custom_none').style.display =  (LE.visible_custom > 0) ? 'none' : '';
			$('le_standard_none').style.display =  (LE.visible_standard > 0) ? 'none' : '';
			LE.updateFieldBoxConstraints();
		};

		LE.showDelete = function(elt)
		{
			var e = $(elt.id.replace(/^dd_/, 'del_'));
			if (e) e.style.visibility = '';
		};

		LE.hideDelete = function(elt)
		{
			var e = $(elt.id.replace(/^dd_/, 'del_'));
			if (e) e.style.visibility = 'hidden';
		};

		LE.onFieldBoxDragged = function()
		{
			var box = $('le_fields_box');
			var region = box.getBoundingClientRect();
			var vp = SUGAR.ui.getViewport();
			var offset = vp.offset || 0;
			LE.desiredFieldsBoxPos = {x: region.left,  y : region.top};
		};

		LE.updateFieldBoxConstraints = function()
		{
			try {
				var box = $('le_fields_box');
				if (!box) return;
			} catch (e) {
				return;
			}
			var vp = SUGAR.ui.getViewport();
			var region = box.getBoundingClientRect();
			var newY =  LE.desiredFieldsBoxPos.y;
			var newX = LE.desiredFieldsBoxPos.x;
			var offset = 0;
			if (vp.offset) offset = vp.offset;
			if (newX < 0) {
				newX = 0;
			} else if (region.width + newX > vp.width) {
				newX = vp.width - region.width;
			}
			if (newY < offset) {
				newY = offset;
			} else if (region.height + newY >  vp.height + offset) {
				newY = vp.height + offset - region.height;
			}
			box.style.top = '' + newY + 'px';
			box.style.left = '' + newX + 'px';
		}

		LE.toggleFieldsBox = function(im)
		{
			var box = $('le_fields_content'),
				title = $('le_fields_title'),
				shown = toggleDisplay(box) != 'none';
			SUGAR.ui.addRemoveClass(title, 'sectionOpen', ! shown);
			SUGAR.ui.addRemoveClass(title, 'sectionClosed', shown);
			LE.updateFieldBoxConstraints();
		}

		LE.moveField = function(sourceId, targetId)
		{
			this.exchangeNodesContent(sourceId, targetId.replace(/^dt_/, 'dd_'));
			this.exchangeNodesContent(targetId.replace(/^dt_/, 'dv_'), sourceId.replace(/^dd_/, 'dv_'));

			var m = sourceId.match(/^dd_(.*)/);
			var sElId = m[1];
			m = targetId.match(/^d[dt]_(.*)/);
			var dElId = m[1];

			var sName = this.allElements[sElId].name;
			var dName = this.allElements[dElId].name;
			var sLabel = this.allElements[sElId].label;
			var dLabel = this.allElements[dElId].label;
			
			this.allElements[sElId].name = dName;
			this.allElements[dElId].name = sName;
			this.allElements[sElId].label = dLabel;
			this.allElements[dElId].label = sLabel;

			var sDel = $('del_' + sElId);
			var dDel = $('del_' + dElId);
			if (sDel) {
				sDel.id = 'del_' + dElId;
			}
			if (dDel) {
				dDel.id = 'del_' + sElId;
			}

		};

		LE.exchangeNodesContent = function(id1, id2)
		{
			var source = $(id1);
			var target = $(id2);
			if(! source || ! target || source === target) return;
			var elements = [];
			for (var i = 0; i < source.childNodes.length; i++) {
				elements.push(source.childNodes[i]);
			}
			SUGAR.ui.clearChildNodes(source);
			while(target.childNodes.length > 0) {
				source.appendChild(target.childNodes[0]);
			}
			SUGAR.ui.clearChildNodes(target);
			for (i=0; i < elements.length; i++) {
				target.appendChild(elements[i]);
			}
		};

		LE.clearField = function(elt)
		{
			var p = elt.parentNode.parentNode;
			var id = p.id.replace(/^dd_/, '');
			var oldFieldName = this.allElements[id].name;
			var displayOld = $('newfield_' + oldFieldName);
			if (displayOld) {
				displayOld.style.display = 'block';
				if (LE.is_custom[oldFieldName]) LE.visible_custom++;
				else LE.visible_standard++;
			}
			this.allElements[id].name = '';
			p.innerHTML = '&nbsp;';
			var valueOuter = $('dv_' + id);
			if(valueOuter) valueOuter.innerHTML = '&nbsp;';
			$('le_custom_none').style.display =  (this.visible_custom > 0) ? 'none' : '';
			$('le_standard_none').style.display =  (this.visible_standard > 0) ? 'none' : '';
			this.updateFieldBoxConstraints();
		};

		LE.editField = function(elt)
		{
			this.createFieldDialog(elt); return;
			var p = elt.parentNode.parentNode;
			var lid = p.id.replace(/^dd_/, 'lbl_');
			var id = p.id.replace(/^dd_/, '');
			LE.quickEdit = new SUGAR.ui.QuickText()
			LE.quickEdit.init(LE.allElements[id].label, function() {
				var newLabel = LE.quickEdit.getValue();
				SUGAR.ui.setElementText($(lid).childNodes[0], newLabel);
				if (LE.allElements[id].label != newLabel) {
					LE.allElements[id].label = newLabel;
					LE.allElements[id].label_modified = true;
				}
			});
			LE.quickEdit.showPopup(null, elt.parentNode.parentNode);
			var event = SUGAR.event.getEvent();
			if (event) {
				event.preventDefault();
				event.stopPropagation();
			}
			return false;
		};

		LE.moveSection = function (id, delta)
		{
			var sectIdx = -1;
			for (var i = 0; i < this.sections_order.length; i++) {
				if (this.sections_order[i] == id) {
					sectIdx = i;
					break;
				}
			}
			if (sectIdx < 0) return;
			var thisSection = $('le_section_' + id);
			var otherIdx = sectIdx;
			for (;;) {
				otherIdx += delta;
				if (otherIdx < 0 || otherIdx >= this.sections_order.length) return;
				var otherId = this.sections_order[otherIdx];
				var otherSection = $('le_section_' + otherId);
				if (otherSection && otherSection.style.display != 'none') {
					break;
				}
			}
			this.sections_order[sectIdx] = otherId;
			this.sections_order[otherIdx] = id;
			if (delta < 0) {
				var t = id;
				id = otherId;
				otherId = t;
			}
			var toMove = $('le_section_' + otherId);
			var moveAbove = $('le_section_' + id);
			toMove.parentNode.removeChild(toMove);
			moveAbove.parentNode.insertBefore(toMove, moveAbove);
			this.adjustMargins();
		};

		LE.makeUid = function()
		{
			return 'nEwUiD-' + this.uid ++;
		};

		LE.fillForm = function(form)
		{
			var input = $('le_encoded_data');
			if (!input) {
				input = document.createElement('input');
				input.setAttribute('id', 'le_encoded_data');
				input.setAttribute('name', 'le_encoded_data');
				input.setAttribute('type', 'hidden');
				form.appendChild(input);
			}
			input.value = JSON.stringify(
				{
					sections: LE.sections,
					sections_order : LE.sections_order,
					elements: LE.allElements
				}
			);
		};

		LE.deleteRow = function(secId, rowId, bodyId)
		{
			var tableRowId = (bodyId ? bodyId : secId) + '_' + rowId;
			var row = $(tableRowId);
			if (!row) {
				tableRowId = secId + '_' + rowId;
				row = $(tableRowId);
			}
			var table = $('le_section_' + secId) || $(secId);
			var $section = Wrap(table).find('.form-section');
			if ($section.length == 0) {
				$section = Wrap(table);
			}
			var rows = $section.find('.form-row');
			for (var i in rows) {
				if (rows[i] == row) {
					row.parentNode.removeChild(row);
					break;
				}
			}
			var sec = this.sections[secId];
			for (var i = 0; i < sec.rows_order.length; i++) {
				if (sec.rows_order[i] == rowId) {
					sec.rows_order.splice(i, 1);
					for (var j = 0; j < sec.rows[rowId].length; j++) {
						var elId = sec.rows[rowId][j].id;
						var fieldName = this.allElements[elId].name;
						var div = $('newfield_' + fieldName);
						if (div) {
							div.style.display = 'block';
						}
						delete this.allElements[elId];
					}
					delete sec.rows[rowId];
					break;
				}
			}
		};

		LE.addHeaderField = function(secId, btn) {
			var outer = btn.parentNode;
			var eltId = this.makeUid();
				
			var wrapper = document.createElement('div');
			wrapper.className = 'edit_layout_wrapper';
			wrapper.style.display = 'inline-block';
			wrapper.id = 'dd_' + eltId;
			wrapper.innerHTML = '&nbsp;';
			outer.insertBefore(wrapper, btn);
				
			this.allElements[eltId] = {
				name: '',
				label: '',
				section: secId
			};
			this.sections[secId].rows['row_' + secId].push({
				id: eltId
			});

			this.makeDraggable('dd_' + eltId);

		}

		LE.addRow = function(secId, beforeRowId)
		{
			var section = this.sections[secId];
			if(! section) return;
			var table = $(section.table_id || ('le_section_' + secId)) || $(secId);
			var $section = Wrap(table).find('.form-section');
			if ($section.length == 0) {
				$section = Wrap(table);
			}
			var rows = $section.find('.form-row');
			var insertBefore = null;
			var insertIdx = rows.length;
			if (beforeRowId) {
				for (var i =0; i < rows.length; i++) {
					if (rows[i].id == beforeRowId) {
						insertBefore = rows[i];
						insertIdx = i;
						break;
					}
				}
			}
			var rowId = this.makeUid();

			var row = createElement2('div', {className: 'row form-row col-unstack'});
			if (insertBefore) {
				$section.get(0).insertBefore(row, insertBefore);
			} else {
				$section.get(0).appendChild(row);
			}
			row.id = secId + '_' + rowId;
			
			section.rows_order.splice(insertIdx - 1, 0, rowId);
			if (typeof(section.rows.length) == 'number')
				section.rows = {};
			section.rows[rowId] = [];

			var perc =  90 / section.columns;

			for (var i = 0; i < section.columns; i++) {
				var eltId = this.makeUid();
				var cell = createElement2('div', {style: 'flex-basis: '  + perc + '%', className: 'column form-cell span-1'});
				cell.id = 'dt_' + eltId;
				row.appendChild(cell);

				var wrapper = document.createElement('div');
				wrapper.className = 'edit_layout_wrapper';
				wrapper.id = 'dd_' + eltId;
				wrapper.innerHTML = '&nbsp;';
				cell.appendChild(wrapper);

				this.allElements[eltId] = {
					col: i,
					row: insertIdx - 1,
					name: '',
					label: '',
					section: secId
				};
				section.rows[rowId].push({
					id: eltId
				});

				LE.makeDraggable('dd_' + eltId);

			}

			var cell = createElement2('div', {className: 'form-entry'}, null, createElement2('div', {className: 'column form-cell sm-1'}, null, row));
			//row.appendChild(cell);

			var addButton = createElement2('span', {className: 'uii uii-add uii-md active-icon', style: {cursor: 'pointer'}});
			addButton.onclick = function() {
				SUGAR.le.addRow(secId, row.id); return false;
			};
			cell.appendChild(addButton);
			cell.appendChild(nbsp());
			
			var delButton = createElement2('span', {className: 'uii uii-remove uii-md active-icon', style: {cursor: 'pointer'}});
			delButton.onclick = function() {
				SUGAR.le.deleteRow(secId, rowId); return false;
			};
			cell.appendChild(delButton);
		};

		LE.removeSection = function(secId) {
			for (var i = 0; i < this.sections_order.length; i++) {
				if (this.sections_order[i] == secId) {
					for (var j = 0; j < this.sections[secId].rows_order.length; j++) {
						var rowId = this.sections[secId].rows_order[j];
						var row = this.sections[secId].rows[rowId];
						for (var k = 0; k < row.length; k++) {
							var elId = row[k].id;
							var fieldName = this.allElements[elId].name;
							var div = $('newfield_' + fieldName);
							if (div) {
								div.style.display = 'block';
							}
							delete this.allElements[elId];
						}
					}
					delete this.sections[secId];
					this.sections_order.splice(i, 1);
					var table = $('le_section_' + secId);
					if (table) {
						table.parentNode.removeChild(table);
					}
				}
			}
			this.adjustMargins();
		};

		LE.addSection = function() {
			var secId = this.makeUid();
			this.sections_order.push(secId);
			this.sections[secId] = {
				columns: this.default_columns,
				rows: {},
				rows_order: [],
				id : secId,
				title: ''
			};

			if (this.tabGroup) {
				this.sections[secId].tab = this.tabGroup.current_tab;
			}

			var table = createElement2('div', {id : 'le_section_' + secId, className : 'form-section'});

			var header = createElement2('header', {className: 'row form-row form-title'}, null, table);
			var h4 = createElement2('h4', {className: 'column form-cell'}, null, table);
			h4.appendChild(nbsp());
			var upButton = createElement2('div', {className: "input-icon icon-up active-icon"}, null, h4);
			h4.appendChild(nbsp());
			var downButton = createElement2('div', {className: "input-icon icon-down active-icon"}, null, h4);
			h4.appendChild(nbsp());

			var lnk = createElement2('a', {href: "#", className:"tabDetailViewDFLink"}, null, h4);
			createElement2('span', { className: "uii uii-add"}, null, lnk);
			lnk.appendChild(document.createTextNode(mod_string('LBL_LAYOUT_ADD_ROW', 'NewStudio')));
			lnk.onclick = function() {SUGAR.le.addRow(secId); return false;};
			h4.appendChild(nbsp());

			var lnk = createElement2('a', {href: "#", className:"tabDetailViewDFLink"}, null, h4);
			createElement2('span', { className: "uii uii-remove"}, null, lnk);
			lnk.appendChild(document.createTextNode(mod_string('LBL_LAYOUT_REM_SECTION', 'NewStudio')));
			lnk.onclick = function() {SUGAR.le.removeSection(secId); return false; };

			upButton.onclick = function() { SUGAR.le.moveSection(secId, -1); return false; };
			downButton.onclick = function() { SUGAR.le.moveSection(secId, 1); return false; };

			var span = document.createElement('span');
			span.style.cursor = 'pointer';
			span.style.paddingLeft = '4px';
			span.style.paddingRight = '4px';
			span.style.border = '1px dotted green';
			span.id="section-title-" + secId;
			span.onclick = function() {SUGAR.le.editSectionTitle(secId); return false; }
			h4.appendChild(nbsp());
			h4.appendChild(span);
			
			var prev_tbl = null;
			if(this.sections_order.length > 1) {
				var prev_id = this.sections_order[this.sections_order.length - 2];
				prev_tbl = $('le_section_' + prev_id);
			}
			if(prev_tbl)
				prev_tbl.parentNode.insertBefore(table, prev_tbl.nextSibling);
			else
				Wrap('.card-body.form-body').append(table);
			createElement2('div', {className: 'form-section', id: secId + '-0'}, null, table);
			this.addRow(secId);
			this.adjustMargins();
		};
		
		LE.adjustMargins = function() {
			var tbl, fst = 1;
			if($('le_section__summary')) fst = 0;
			for (var i = 0; i < this.sections_order.length; i++) {
				tbl = $('le_section_' + this.sections_order[i]);
				if(tbl) {
					tbl.style.marginTop = fst ? 0 : '0.5em';
					fst = 0;
				}
			}
		};

		LE.editSectionTitle = function(id)
		{
			var display = $('section-title-' + id);
			display.style.display = 'none';
			var edit = document.createElement('input');
			edit.type = 'text';
			edit.className = 'input-text';
			edit.value  = this.sections[id].title;
			display.parentNode.appendChild(edit);
			edit.focus();
			edit.onkeydown = function(evt) { SUGAR.le.titleKeyDown(evt || window.event, id, this); };
			edit.onblur = function() { SUGAR.le.endEditTitle(id, this)};
		};

		LE.titleKeyDown = function(evt, id, edit) {
			if (evt.keyCode == 27) {
				this.endEditTitle(id, edit);
			}
			else if (evt.keyCode == 13) {
				this.endEditTitle(id, edit, edit.value);
			}
		};

		LE.endEditTitle = function(id, edit, value)
		{
			var display = $('section-title-' + id);
			if(! display) return;
			if (value) {
				SUGAR.ui.clearChildNodes(display);
				display.appendChild(document.createTextNode(value));
				this.sections[id].title = value;
				this.sections[id].title_modified = true;
			}
			if(edit && edit.parentNode) {
				edit.onblur = null;
				edit.parentNode.removeChild(edit);
			}
			display.style.display = '';
		};

		LE.createHeaderFieldDialof = function(elt) {
			var sectionId = elt.parentNode.id.replace(/^hdd_/, '');
			
			var select =  new SUGAR.ui.SelectInput('', {
				width: '200px',
				options: '__le_fields_with_blank__',
				mark_blank: true,
				onchange: function() {
					var name = select.getValue();
					var label = select.getOptionValue()
					var existing = Object.keys(this.allElements).find(function(id) {return this.allElements[id].name == name}.bind(this));
					list.insertRow({is_new: true, id: existing ? existing : this.makeUid(), name: name, label: label});
					select.setValue('', true);
				}.bind(this)
			});

			select.render();

			var cols = [
				{
					'name' : 'icon',
					'label' : '',
					'width' : '5%',
					'format' : 'icon'
				},
				{
					'name' : 'label',
					'format' : 'text',
					'editable' : true,
					'label' : mod_string('LBL_EDIT_LABEL', 'NewStudio'),
					'width' : '60%',
				}
			];

			var origRows = this.sections[sectionId].rows['row_' + sectionId].map(function (c) {
				var e = this.allElements[c.id];
				return {
					id: c.id,
					label: e.label || ''
				};
			}.bind(this));
			
			var list = new SUGAR.ui.DynamicList('', {cols: cols, rows: deep_clone(origRows), show_handles: true, depth_attrib: null});
			list.setup();

			var save = function() {
				var origElements = origRows.map( function(r) { return r.id});;
				var rows = list.getRows();
				var newElements = rows.map( function(r) { return r.id});;

				// first, return removed elements to available fields list
				origElements.forEach(function(id) {
					if (!~newElements.indexOf(id)) {
						var fname = this.allElements[id].name;
						this.allElements[id].name = '';
						var div = $('newfield_' + fname);
						if (div)
							div.style.display = 'block';
					};
				}.bind(this));

				// then, remove added elements from available fields and other sections
				// and add them if required
				newElements.forEach(function(id, elementIndex) {
					var row = rows.find(function(r) {return r.id == id});
					var div = $('newfield_' + row.name);
					if (div)
						div.style.display = 'none';
					var div = $('dd_' + row.id);
					if (div)
						div.innerHTML = '';
					if (!~origElements.indexOf(id)) {
						if (this.allElements[id]) {
							var sec = sectionId == '_form_header' ? '_form_subheader' : '_form_header';
							var rows2 = this.sections[sec].rows['row_' + sec];
							var idx = rows2.map(function(e) {return e.id}).indexOf(id);
							if (~idx) {
								rows2.splice(idx, 1);
							}
							if (row.is_new) {
								var newId = this.makeUid();
								this.allElements[id].name = '';
								this.allElements[newId] = deep_clone(this.allElements[id]);
								this.allElements[newId].name = row.name;
								this.allElements[newId].label = row.label;
								this.allElements[newId].label_modified = 1;
								newElements[elementIndex] = newId;
							}
						} else {
							this.allElements[id] = {
								name: row.name,
								label: row.label,
								label_modified: 1
							};
						}
					} else {
						this.allElements[id].label = row.label;
						this.allElements[id].label_modified = 1;
					}
				}.bind(this));
				
				this.sections[sectionId].rows['row_' + sectionId] = rows.map(function(row) {return {id : row.id}});
				SUGAR.popups.close();
				this.renderHeaderFields('_form_header');
				this.renderHeaderFields('_form_subheader');
			}.bind(this);

			list.render();
			var outer = createElement2('form', {onsubmit: function() {return false}, className: 'card-outer form-outer default-form'}, 
				createElement2('div', {className: 'card-body form-body'}, 
					createElement2('div', {className: 'form-section'}, [
						createElement2('div', {className: 'row form-row col-unstack'}, [
							createElement2('div', {className: 'column form-cell sm-12'}, 
								createElement2('div', {className: 'form-entry'}, [
									createElement2('p', {className: 'form-label'}, mod_string('LBL_SELECT_NEW_FIELD', 'NewStudio')),
									createElement2('div', {className: 'form-value'}, select.elt)
								])
							)
						]),
						createElement2('div', {className: 'row form-row col-unstack'}, [
							createElement2('div', {className: 'column form-cell sm-12'}, 
								createElement2('div', {className: 'form-entry'}, [
									createElement2('div', {className: 'form-value'}, list.elt)
								])
							)
						]),
						createElement2('div', {className: 'row form-row col-unstack'}, [
							createElement2('div', {className: 'column form-cell sm-12 buttons-inline'}, [
								createElement2('div', {className: "inline-elt"},
									createElement2('button', {onclick: save, type: 'button', className: "input-button admin-action group-left first"},  [
										createElement2('div', {className: "input-icon left icon-accept"}),
										createElement2('span', {className: "input-label"}, 'Save')
									])
								),
								createElement2('div', {className: "inline-elt"},
									createElement2('button', {onclick: function() {SUGAR.popups.close()}, type: 'button', className: "input-button admin-action group-left first"},  [
										createElement2('div', {className: "input-icon left icon-cancel"}),
										createElement2('span', {className: "input-label"}, 'Cancel')
									])
								)	
							])
						])
					])
				)
			);

			var popup = new SUGAR.ui.Dialog('field_editor', {content_elt: outer, width: '400px', height: '450px', title: mod_string('LBL_EDIT_ELEMENT', 'NewStudio')});
			popup.destroy_on_close = true;
			popup.render();
			popup.show();
		};

		LE.createFieldDialog = function(elt) {

			if ((elt.parentNode.id || '').indexOf('hdd_') === 0) {
				return LE.createHeaderFieldDialof(elt);
			}

			var p = elt.parentNode.parentNode;
			var lid = p.id.replace(/^dd_/, 'lbl_');
			var id = p.id.replace(/^dd_/, '');
			var label = this.allElements[id].label;
			var name = this.allElements[id].name;
			
			var input = new SUGAR.ui.TextInput('', {init_value: label});

			var select =  new SUGAR.ui.SelectInput('', {
				width: '200px',
				options: '__le_fields__',
				init_value: name,
				onchange: function() {
					var name = select.getValue();
					var label = this.allFields.reduce(function(prev, f) { return f.name == name ? f.label : prev }, null);
					if (label)
						input.setValue(label);
				}.bind(this)
			});


			var save = function() {
				if (name)
					Wrap('#newfield_' + name).css('display', 'block');
				var label = input.getValue();
				var field = select.getValue();

				if (field != name) {
					var existing = Object.keys(this.allElements).find(function(el) { return SUGAR.le.allElements[el].name == field});
					if (existing) {
						this.allElements[existing].name = '';
						var $dd = $('dd_' + existing);
						if ($dd) {
							$dd.innerHTML = '&nbsp;';
						}
						var $dv = $('dv_' + existing);
						if ($dv) {
							$dv.innerHTML = '&nbsp;';
						}
						['_form_header', '_form_subheader'].forEach(function(sec) {
							var rows = this.sections[sec].rows['row_' + sec];
							var idx = rows.map(function(e) {return e.id}).indexOf(existing);
							if (~idx) {
								rows.splice(idx, 1);
							}
						}.bind(this));
					}
					this.allElements[id].name = field;
					Wrap('#newfield_' + field).find('.input-label').text(label);
					Wrap('#newfield_' + field).css('display', 'none');
				}
				
				this.allElements[id].label = label;
				this.allElements[id].label_modified = 1;
				elt.innerText = label;
				SUGAR.popups.close();
				this.renderHeaderFields('_form_header');
				this.renderHeaderFields('_form_subheader');
			}.bind(this);

			var outer = createElement2('form', {onsubmit: function() {return false}, className: 'card-outer form-outer default-form'}, 
				createElement2('div', {className: 'card-body form-body'}, 
					createElement2('div', {className: 'form-section'}, [
						createElement2('div', {className: 'row form-row col-unstack'}, [
							createElement2('div', {className: 'column form-cell sm-12'}, 
								createElement2('div', {className: 'form-entry'}, [
									createElement2('p', {className: 'form-label'}, mod_string('LBL_ELEMENT_LABEL', 'NewStudio')),
									createElement2('div', {className: 'form-value'}, input.render())
								])
							)
						]),
						createElement2('div', {className: 'row form-row col-unstack'}, [
							createElement2('div', {className: 'column form-cell sm-12'}, 
								createElement2('div', {className: 'form-entry'}, [
									createElement2('p', {className: 'form-label'}, mod_string('LBL_ELEMENT_FIELD', 'NewStudio')),
									createElement2('div', {className: 'form-value'}, select.render())
								])
							)
						]),
						createElement2('div', {className: 'row form-row col-unstack'}, [
							createElement2('div', {className: 'column form-cell sm-12 buttons-inline'}, [
								createElement2('div', {className: "inline-elt"},
									createElement2('button', {onclick: save, type: 'button', className: "input-button admin-action group-left first"},  [
										createElement2('div', {className: "input-icon left icon-accept"}),
										createElement2('span', {className: "input-label"}, 'Save')
									])
								),
								createElement2('div', {className: "inline-elt"},
									createElement2('button', {onclick: function() {SUGAR.popups.close()}, type: 'button', className: "input-button admin-action group-left first"},  [
										createElement2('div', {className: "input-icon left icon-cancel"}),
										createElement2('span', {className: "input-label"}, 'Cancel')
									])
								)	
							])
						])
					])
				)
			);

			
			var popup = new SUGAR.ui.Dialog('field_editor', {content_elt: outer, width: '400px', height: '450px', title: mod_string('LBL_EDIT_ELEMENT', 'NewStudio')});
			popup.destroy_on_close = true;
			popup.render();
			popup.show();
			input.focus();

		};

		LE.renderHeaderFields = function(sectionId) {
			var wrapper = $('hlw_' + sectionId);
			wrapper.innerText = '';
			this.sections[sectionId].rows['row_' + sectionId].forEach(function (e) {
				var span = createElement2('span', {className: 'edit-layout-header-field'});
				span.innerText = this.allElements[e.id].label;
				wrapper.appendChild(span);
			}.bind(this));
		};
		
		LE.dragFieldToHeader = function(sourceId, sectionId) {
			var element;
			if (sourceId.match(/^newfield_/)) {
				var name = sourceId.replace(/^newfield_/, '');
				label = this.allFields.find(function(f) {return f.name == name}).label;
				element = {name: name, label: label};
				$(sourceId).style.display = 'none';
			} else {
				var eltId = sourceId.replace(/^dd_/, '');
				if (!this.allElements[eltId].name)
					return;
				element = deep_clone(this.allElements[eltId]);
				this.allElements[eltId].name = '';
				$('dd_' + eltId).innerHTML = '&nbsp;';
			}

			var newId = this.makeUid();
			this.allElements[newId] = element;
			this.sections[sectionId].rows['row_' + sectionId].push({
				id: newId
			});
			this.renderHeaderFields(sectionId);

		};

		LE.makeDraggable = function(elt, handle) {
			var target_id = '#' + (elt.id || elt);
			if (typeof elt == 'string') elt = Wrap('#' + elt);
			if (typeof handle == 'string') handle = Wrap('#' + handle);
			new SUGAR.ui.Draggable(elt, {sourceType: 'LayoutEditor', handle: handle, onEnd: this.drag_config.onEnd, onStart: this.drag_config.onStart, values: {target_id: target_id}});
			new SUGAR.ui.DragTarget(elt, this.drag_config);
		};
		

		LE.destroy = function() {
			if (this.DragTarget)
				this.DragTarget.destroy();
		};

		return this;
	};

	SUGAR.le = new LayoutEditor();
	SUGAR.le.drag_config = {
		acceptedSourceTypes: ['LayoutEditor'],
		onStart: function(evt) {
			var data = SUGAR.ui.getDragData(evt);
			if (evt.target.id.indexOf('hdd_') === 0) {
				evt.preventDefault();
				return;
			};
			evt.stopPropagation();
			var draggingEl = evt.target;
			if (draggingEl.id == 'le_fields_box') {
				var values = this.getDragValues();
				var box = evt.target;
				values.boxPos = draggingEl.getBoundingClientRect();
				setTimeout(function() {
					box.style.display = 'none';
				}, 30);
				values.dragStartPos = {x : evt.screenX, y: evt.screenY};
				SUGAR.ui.setDragData(evt, this.getDragTransfer(), values);
			}
		},
		onLeave: function(evt) {
		},
		onEnter: function(evt) {
		},
		onDrop: function(evt, data, index) {
			var draggingEl = Wrap(data.values.target_id).get();
			if (draggingEl.id == 'le_fields_box') {
				var box = $('le_fields_box');
				box.style.display = 'block';
				box.style.left = data.values.boxPos.left - data.values.dragStartPos.x + evt.screenX + 'px';
				box.style.top = data.values.boxPos.top - data.values.dragStartPos.y + evt.screenY + 'px';
				var region = box.getBoundingClientRect();
				var vp = SUGAR.ui.getViewport();
				LE.desiredFieldsBoxPos = {x: region.left - vp.x, y : region.top - vp.y};
				LE.updateFieldBoxConstraints();
				return;
			}
			evt.stopPropagation();
			var sourceId = draggingEl.id;
			var target = evt.target;
			while (target && !(target.id || '').match(/^h?dd_/))
				target = target.parentNode;
			if (!target)
				return;
			var targetId = target.id;
			if (targetId.match(/^hdd_/)) {
				var sectionId = targetId.replace(/^hdd_/, '');
				this.dragFieldToHeader(sourceId, sectionId);
			} else if (sourceId.match(/^newfield_/)) {
				LE.addNewField(sourceId, targetId);
			} else if (sourceId.match(/^dd_/)) {
				LE.moveField(sourceId, targetId);
			}
		},
		onMove: function(evt, data) {
			var draggingEl = Wrap(data.values.target_id).get();
			if (draggingEl.id == 'le_fields_box') {
				;
			} else {
				var target = evt.target;
				while (target && !(target.id || '').match(/^h?dd_/))
					target = target.parentNode;
				ExtNodeList('.edit_layout_wrapper').applyEach(ExtNode.prototype.css, {backgroundColor: ''});
				if (target)
					Wrap(target).css({backgroundColor: '#FCC'});
			}
		},
		onEnd: function(evt, data) {
			ExtNodeList('.edit_layout_wrapper').applyEach(ExtNode.prototype.css, {backgroundColor: ''});
		},
		checkAccept: function(evt, data) {
			return true;
		}
	};
	SUGAR.le.DragTarget = new SUGAR.ui.DragTarget(ExtNode(document.body), SUGAR.le.drag_config);
	setTimeout(function() {
		SUGAR.le.elt = document.body;
	}, 0);
})();
