function initLoginForm(captchaComplexity) {
	var form = document.forms.LoginForm,
		uname = form && form.user_name,
		upass = form && form.user_password,
		mobile = form && form.mobile;
	if(uname) {
		if(uname.value != '')
			upass && upass.focus() && upass.select();
		else uname.focus();
		uname.addEventListener('change', clearLoginError);
		uname.addEventListener('input', clearLoginError);
	}
	if(upass) {
		upass.addEventListener('change', clearLoginError);
		upass.addEventListener('input', clearLoginError);
	}
	if('onpagehide' in window)
		window.addEventListener('pagehide', loginRestore);
	window.addEventListener('unload', loginRestore);
	if(mobile) {
		mobile.addEventListener('change', function() {
			toggleDisplay('theme-outer', ! this.checked);
		});
	}
	focusOtp();
    attachGroupFocus();
	attachScreenSize();
	if (captchaComplexity >= 0) {
		showCaptcha();
	}
}

function attachScreenSize() {
	var Dom = SUGAR.dom,
		Wrap = Dom.elementOrId;
	SUGAR.dom.ExtNode(window).on('resize-safe', function(evt, sz) {
		screenSizeAdjust(sz);
	});
}

function screenSizeAdjust(size) {
	var Dom = SUGAR.dom,
		Wrap = Dom.elementOrId,
		form = document.forms.LoginForm,
		utheme = form && form.user_theme,
		prev_mobile = window.is_mobile,
		mthemes = window.mobile_themes,
		mobile = (size && size.w < 992), // smaller than md
		seltheme, i, t;
	if(mobile !== prev_mobile && utheme && mthemes) {
		seltheme = utheme.value;
		if(mobile) {
			window.prev_theme = seltheme;
			if(! ~mthemes.indexOf(seltheme))
				seltheme = null;
			for(i = 0; i < utheme.options.length; i++) {
				t = utheme.options[i].value;
				if(! seltheme && ~mthemes.indexOf(t)) {
					seltheme = t;
				}
			}
			if(seltheme) {
				utheme.value = seltheme;
				for(i = 0; i < utheme.options.length; i++) {
					t = utheme.options[i].value;
					utheme.options[i].disabled = ! ~mthemes.indexOf(t);
				}
			}
			if(! form.no_persist_theme) {
				var inp = createElement2('input', {type: 'hidden', name: 'no_persist_theme', value: '1'});
				form.appendChild(inp);
			}
		} else {
			for(i = 0; i < utheme.options.length; i++) {
				utheme.options[i].disabled = false;
			}
			if(window.prev_theme)
				utheme.value = prev_theme;
			if(form.no_persist_theme)
				form.no_persist_theme.value = 0;
		}
	}
	window.is_mobile = mobile;
}

function doPreload() {
	var req = new SUGAR.conn.JSONRequest('get_preload_files'), pr;
	req.fetch(function(r) {
		if(! r) return;
		result = r.getResult();
		if(result && result.includes) {
			for(var i = 0; i < result.includes.length; i++) {
				pr = new SUGAR.conn.HTTPRequest(result.includes[i].url);
				pr.fetch();
			}
		}
	});
}

function checkLoginForm(form) {
	var msg = '';
	if(! form) return false;
	if(! form.user_name || ! form.user_name.value.length) {
		msg = app_string('NTC_LOGIN_MESSAGE');
	}
	else if(! form.user_password || ! form.user_password.value.length) {
		msg = app_string('NTC_LOGIN_MESSAGE');
	}
	if(msg) {
		showLoginError(msg);
		return false;
	}
}

function checkRecoverForm(form) {
	
}

function doLogin() {
	var cant = $('cant_login');
	if(cant && cant.value != '')
		return false;
	clearLoginError();
	var viewp = viewportSize(),
		map = {
			'username': 'user_name',
			'password': 'user_password',
			'captcha': 'user_captcha',
			'remember': 'user_remember',
			'language': 'user_language',
			'theme': 'user_theme',
			'login_module': 'login_module',
			'login_action': 'login_action',
			'login_record': 'login_record',
			'login_layout': 'login_layout',
			'mobile': 'mobile',
			'no_persist_theme': 'no_persist_theme'
		},
		form = document.forms.LoginForm,
		check = checkLoginForm(form),
		btn = $('login_button'),
		f, k, params = {
			'res_width': viewp.width,
			'res_height': viewp.height
		};
	if(isdef(check)) return check;
	for(k in map) {
		if( (f = form.elements[map[k]]) ) {
			if((f.type == 'checkbox' || f.type == 'radio') && ! f.checked)
				params[k] = '';
			else
				params[k] = f.value;
		}
	}
	var now = new Date();
	var d1 = new Date(now.getFullYear(), 0, 1, 0, 0, 0);
	d1GMTString = d1.toGMTString();
	var d2 = new Date(d1GMTString.substring(0, d1GMTString.lastIndexOf(' ') - 1));
	params.gmto = (d1 - d2) / (1000 * 60) * -1;
	
	if(btn) btn.disabled = true;
	var req = new SUGAR.conn.JSONRequest('login',
		{status_msg: app_string('LBL_LOGGING_IN')},
		params);
	req.showStatus = showLoginStatus;
	req.hideStatus = clearLoginStatus;
	if(form.user_password.value) form.user_password.value = '********';
	req.fetch(loginReceived, loginError);
	loginSetIcon('hourglass anim-spin');
	return false;
}

function loginRestore() {
	loginEnable(); // fix button state in case user navigates back
	clearLoginStatus();
}

function loginEnable() {
	var btn = $('login_button');
	if(btn) btn.disabled = false;
	loginSetIcon('arrow-right');
}

function loginSetIcon(icon) {
	var btn = $('login_button');
	if(btn) {
		for(var i = 0; i < btn.childNodes.length; i++) {
			if(btn.childNodes[i].tagName == 'SPAN') {
				btn.childNodes[i].className = 'uii uii-'+icon;
				break;
			}
		}
	}
}

function loginReceived() {
	var row = this.getResult();
    if(row.result == 'show_multi_fa_code') {
        showLoginStatus(app_string('LBL_REDIRECTING'));
        loginSetIcon('accept');
        // allow rendering to finish before we redirect
        setTimeout(function() { location.reload(); }, 0);
    } else if(row.result == 'ok') {
		clearLoginError();
		showLoginStatus(app_string('LBL_REDIRECTING'));
		loginSetIcon('accept');
		// allow rendering to finish before we redirect
		setTimeout(function() { location.assign(row.redirect || 'index.php'); }, 0);
	} else {
		loginError(row.message);
		showCaptcha();
	}
}

function focusOtp() {
    const otp_elem = $('login_otp');
    if (otp_elem)
        otp_elem.focus();
}

function verifyCode() {
    clearLoginError();
    let otp = '';
    const otp_elem = $('login_otp');

    if (otp_elem)
    	otp = otp_elem.value;

    const btn = $('login_button');
    if(btn) btn.disabled = true;

    const req = new SUGAR.conn.JSONRequest(
    	'mfa_verify_code',
        {status_msg: app_string('LBL_LOGGING_IN')},
		{otp: otp}
	);

    req.showStatus = showLoginStatus;
    req.hideStatus = clearLoginStatus;

    req.fetch(codeReceived, loginError);
    loginSetIcon('hourglass anim-spin');

    return false;
}

function codeReceived() {
    var row = this.getResult();
    //console.log(row);
    if(row.result == 'error') {
        showLoginStatus(app_string('LBL_REDIRECTING'));
        // allow rendering to finish before we redirect
        setTimeout(function() { location.reload(); }, 0);
    } else if(row.result == 'ok') {
        clearLoginError();
        showLoginStatus(app_string('LBL_REDIRECTING'));
        loginSetIcon('accept');
        // allow rendering to finish before we redirect
        setTimeout(function() { location.assign(row.redirect || 'index.php'); }, 0);
    } else {
        loginError(row.message);
    }
}

function loginReturn() {
	location.assign('login.php');
}

function loginError(msg) {
	var upass = document.forms.LoginForm.user_password;
	if (upass) {
        upass.value = '';
        upass.focus();
    }
	loginEnable();
	showLoginError(msg || app_string('LBL_CONNECTION_FAILED'));
}

function showLoginStatus(msg) {
	var elt = $('login-status'),
		opts = $('login-opts');
	if(elt) {
		elt.innerHTML = msg;
		toggleDisplay('status-outer', true);
		if(opts) opts.style.display = 'none';
	}
}

function clearLoginStatus() {
	toggleDisplay('status-outer', false);
	var opts = $('login-opts');
	if(opts) opts.style.removeProperty('display');
}


function showLoginError(msg) {
	var elt = $('login-error');
	if(elt) {
		elt.innerHTML = msg;
		toggleDisplay('error-outer', true);
	}
}

function clearLoginError() {
	toggleDisplay('error-outer', false);
}

function showCaptcha() {
	var elt = $('captcha-outer');
	elt.classList.add('visible');
	elt = $('captcha-img');
	elt.src = "json.php?action=captcha&_=" + (new Date).valueOf();
	elt = $('login_captcha');
	elt.value = '';
}
