// Removing this comment will break the build process :(
AppBase.module('casesEscalate').moduleRequires('ui-controls').init(function(App) {

	var Dom = App.dom;
	var UI = App.ui;
	var Wrap = Dom.elementOrId;
	var Animation = App.animation.Animation;

	showingSlider = function(name) {
		for (var i in detailSlidersNames) {
			if(detailSlidersNames[i] == name) {
				var slider = document.getElementById('detail_slider_' + name);
				return (slider.style.display != 'none');
			}
		}
	}

	focusSlider = function(name) {
		for (var i in detailSlidersNames) {
			var other = detailSlidersNames[i];
			if (other == name) continue;
			var slider = document.getElementById('detail_slider_' + other);
			if (slider && slider.style.display != 'none') {
				detailSliders[other][1].animate();
			}
		}
		var slider = document.getElementById('detail_slider_' + name);
		var content = document.getElementById('detail_slider_content_' + name);
		if (typeof detailSliders[name] == 'undefined') setDetail();


		return { div: slider, content: content, detail: detailSliders[name] };
	}

	showSlider = function(name) {
		var slider = focusSlider(name);
		if (slider.div.style.display == 'none') {
			slider.div.style.display = '';
			if (slider.content) {
				var height = parseInt(slider.content.clientHeight);
				if (height == 0 || ('' + height == 'NaN')) {
					height = parseInt(slider.content.height);
				}
				slider.detail[0].distribute(20, function(percent) { return {height: height - 1 }});
			}
			slider.detail[0].run('#detail_slider_' + name);
		} else {
			slider.detail[1].run('#detail_slider_' + name);
		}
	}

	setDetail = function() {
		for (var i in detailSlidersNames) {
			var name = detailSlidersNames[i];
			if (typeof(name) == 'function') continue;

			function onComplete(v) {
				document.getElementById(v.target.id).style.height = 'auto';
			}

			function onCompleteClose(v) {
				document.getElementById(v.target.id).style.display = 'none';
			}

			var animOpen = new Animation()
				.distribute(20, function(percent) { return {height: {to: 300} }})
				.duration(0.45)
				.onEnd(onComplete)
			.timing('ease-out')

			var animClose = new Animation()
				.distribute(20, function(percent) { return {height: {to: 1} }})
				.duration(0.45)
				.onEnd(onCompleteClose)
			.timing('ease-out')

			$('detail_slider_' + name).style.overflow = 'hidden';

			detailSliders[name] = [animOpen, animClose];
		}
	}

	updateSlider = function(name)
	{
		var slider = focusSlider(name);
		if (slider.div.style.display == 'none') {
			slider.div.style.display = '';
		}
		if (slider.content) {
			var height = parseInt(slider.content.clientHeight);
			if (height == 0 || ('' + height == 'NaN')) {
				height = parseInt(slider.content.height);
			}
			//slider.detail[0].attributes.height.to = height + 7;
			slider.detail[0].attributes.height.to = height;
		}
		slider.detail[0].animate();
	}

	detailSliders = {};
	detailSlidersNames = [];

	SUGAR.ui.attachInputEvent(window, 'load', setDetail);

});
