<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');


require_once('include/json/iah_jsrd.php');

function json_serialize_object(&$focus, $fields=null) {
	global $output_format;
	if(! is_array($fields))
		$fields = array_merge($focus->column_fields,$focus->additional_column_fields);
	$ret = array();
	foreach($fields as $field) {
		if(isset($focus->$field)) {
			$val = from_html($focus->$field);
			if(empty($_REQUEST['preserve_newlines']) && $output_format != 'jsrd')
				$val = preg_replace('/\r?\n/', '<BR>', $val);
			$ret[$field] = $val;
		}
	}
	return $ret;
}

function json_serialize_list(&$seed, &$list, $fields=null) {
	$ret = array();
	$i=1; // js doesn't like 0 index?
	foreach($list as $obj) {
		$ret[$i] = json_serialize_object($obj, $fields);
		$i++;
	}
	return $ret;
}

function jsrd_serialize_list(&$seed, &$list, $fields=null, $custom=null) {
	global $jsrd_minimal;
	$jsrd = new IAH_JSRD();
	if($custom)
		$jsrd->set_custom($custom);
	$jsrd->set_bean_schema($seed);
	$jsrd->add_bean_rows($list);
	$ret = $jsrd->encode_to_array($jsrd_minimal);
	return $ret;
}

function jsrd_serialize_record(&$focus, $fields=null, $custom=null) {
	global $jsrd_minimal;
	$jsrd = new IAH_JSRD();
	if($custom)
		$jsrd->set_custom($custom);
	$jsrd->set_bean_value($focus);
	$ret = $jsrd->encode_to_array($jsrd_minimal);
	return $ret;
}

function &jsrd_wrap_value($value, $name='return') {
	$jsrd = new IAH_JSRD();
	$jsrd->load_simple_value($name, $value);
	return $jsrd;
}

function jsrd_return_value(&$jsrd) {
	global $jsrd_minimal;
	$ret = $jsrd->encode_to_array($jsrd_minimal);
	if($ret === false)
		return json_server_error();
	json_return_value($ret);
}

?>
