<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

function portal_login_user($portal_auth) {
	if(! isset($portal_auth['user_name']) || ! isset($portal_auth['password']))
		return 'fail';
	$user = new User();
	$user = $user->retrieve_by_string_fields(array(
		'user_name' => $portal_auth['user_name'],
		'user_hash' => $portal_auth['password'],
		'deleted' => 0, 'status' => 'Active',
		'portal_only' => 1,
	));
		
	if($user != null) {
		global $current_user;
		$current_user = $user;
		$_SESSION['authenticated_user_id'] = $user->id;
		return 'success';
	}
	else
		return 'fail';
}

function portal_validate_authenticated() {
	// Initialize session flag
	$valid_session = true;
	// Ensure that variables are valid
	$session_ip = array_get_default($_SESSION, 'ip_address');
	$remote_ip = array_get_default($_SERVER, 'REMOTE_ADDR');
	$session_type = array_get_default($_SESSION, 'type');
	if(!empty($_SESSION['is_valid_session']) && $session_ip == $remote_ip && $valid_session != null
	&& ($session_type == 'contact' || $session_type == 'lead' || $session_type == 'portal')) {
		// Valid session - retrieve the active user
		global $current_user;
		$current_user = new User();
		$current_user->retrieve($_SESSION['authenticated_user_id']);
		return true;
	}
	return false;
}


function get_opportunity_ids() {
	// Get access to the db
	global $db;
	// Initialize the case ids
	$arIds = array();
	// Do we have an account id?
		// Get the list of case ids
	if (!empty($_SESSION['is_partner'])) {
		$partner = " partner_id='" . $db->quote($_SESSION['is_partner']) . "'";
		$strQuery = "SELECT id  from opportunities where $partner AND deleted = 0";
		// Execute the query
		$objResult = $db->query($strQuery);
		// Loop through and process the results
		while (($arRow = $db->fetchByAssoc($objResult)) != null) {
			// Add the case record
			$arIds[$arRow['id']] = $arRow['id'];
		}
	}
	return $arIds;
}

function get_lead_ids() {
	// Get access to the db
	global $db;
	// Initialize the case ids
	$arIds = array();
	// Do we have an account id?
		// Get the list of case ids
	if (!empty($_SESSION['is_partner'])) {
		$partner = " partner_id='" . $db->quote($_SESSION['is_partner']) . "'";
		$strQuery = "SELECT id  from leads where $partner AND deleted = 0";
		// Execute the query
		$objResult = $db->query($strQuery);
		// Loop through and process the results
		while (($arRow = $db->fetchByAssoc($objResult)) != null) {
			// Add the case record
			$arIds[$arRow['id']] = $arRow['id'];
		}
	}
	return $arIds;
}

function get_case_ids() {
	// Get access to the db
	global $db;
	// Initialize the case ids
	$arCaseIds = array();
	// Do we have an account id?
	if (!empty($_SESSION['viewable']['Accounts'])) {
		// Get the list of case ids
		$strQuery = "SELECT id  from cases where account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "') AND deleted = 0";
		// Execute the query
		$objResult = $db->query($strQuery);
		// Loop through and process the results
		while (($arRow = $db->fetchByAssoc($objResult)) != null) {
			// Add the case record
			$arCaseIds[$arRow['id']] = $arRow['id'];
		}
	}
	// Get the cases with the given contact
	$strQuery = "SELECT case_id as id from contacts_cases where contact_id = '".$db->quote($_SESSION['contact_id'])."' AND deleted = 0";
	// Execute the query
	$objResult = $db->query($strQuery);
	// Loop through and process the results
	while (($arRow = $db->fetchByAssoc($objResult)) != null) {
		// Add the case record
		$arCaseIds[$arRow['id']] = $arRow['id'];
	}

	return $arCaseIds;
}

function get_bug_ids() {
	// Get access to the db
	global $db;
	// Initialize the bug ids
	$arBugIds = array();
	// Do we have an account id?
	if (!empty($_SESSION['viewable']['Accounts'])){	
		// Get the list of bug ids
		$strQuery = "SELECT bug_id as id from accounts_bugs where account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "') AND deleted = 0";
		// Execute the query
		$objResult = $db->query($strQuery);
		// Loop through and process the results
		while (($arRow = $db->fetchByAssoc($objResult)) != null) {
			// Add the case record
			$arBugIds[$arRow['id']] = $arRow['id'];
		}
	}
	// First, get the list of IDs.
	$strQuery = "SELECT bug_id as id from contacts_bugs where contact_id = '".$db->quote($_SESSION['contact_id'])."' AND deleted = 0";
	// Execute the query
	$objResult = $db->query($strQuery);
	// Loop through and process the results
	while (($arRow = $db->fetchByAssoc($objResult)) != null) {
		// Add the case record
		$arBugIds[$arRow['id']] = $arRow['id'];
	}
	return $arBugIds;
}

function get_project_ids() {
	// Get access to the db
	global $db;
	// Initialize the bug ids
	$arProjectIds = array();
	// Do we have an account id?
	if (!empty($_SESSION['viewable']['Accounts'])){	
		// Get the list of bug ids
		$strQuery = "SELECT id from project where account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "') AND deleted = 0";
		// Execute the query
		$objResult = $db->query($strQuery);
		// Loop through and process the results
		while (($arRow = $db->fetchByAssoc($objResult)) != null) {
			// Add the case record
			$arProjectIds[$arRow['id']] = $arRow['id'];
		}
	}
	// First, get the list of IDs.
	$strQuery = "SELECT project_id as id from project_relation where relation_id = '".$db->quote($_SESSION['contact_id'])."' AND deleted=0 AND relation_type = 'Contacts'";
	// Execute the query
	$objResult = $db->query($strQuery);
	// Loop through and process the results
	while (($arRow = $db->fetchByAssoc($objResult)) != null) {
		// Add the case record
		$arProjectIds[$arRow['id']] = $arRow['id'];
	}
	return $arProjectIds;
}

function get_quote_ids() {
	// Get access to the db
	global $db;
	// Initialize the bug ids
	$arQuoteIds = array();
	// Do we have an account id?
	if (!empty($_SESSION['viewable']['Accounts'])){	
		// Get the list of bug ids
		$strQuery = "SELECT id FROM quotes WHERE (billing_account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "') OR shipping_account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "')) AND deleted = 0";
		// Execute the query
		$objResult = $db->query($strQuery);
		// Loop through and process the results
		while (($arRow = $db->fetchByAssoc($objResult)) != null) {
			// Add the case record
			$arQuoteIds[$arRow['id']] = $arRow['id'];
		}
	}
	// First, get the list of IDs.
	$strQuery = "SELECT id FROM quotes WHERE (billing_contact_id = '".$db->quote($_SESSION['contact_id'])."' OR shipping_contact_id = '".$db->quote($_SESSION['contact_id'])."') AND deleted = 0";
	// Execute the query
	$objResult = $db->query($strQuery);
	// Loop through and process the results
	while (($arRow = $db->fetchByAssoc($objResult)) != null) {
		// Add the case record
		$arQuoteIds[$arRow['id']] = $arRow['id'];
	}	
	// Return the id string
	return $arQuoteIds;
}

function get_invoice_ids() {
	// Get access to the db
	global $db;
	// Initialize the invoice ids
	$arInvoiceIds = array();
	// Do we have an account id?
	if (!empty($_SESSION['viewable']['Accounts'])){
		$partner = "";
		if (!empty($_SESSION['is_partner'])) {
			$partner = " OR partner_id='" .$db->quote($_SESSION['is_partner']) . "'";
		}
		// Get the list of bug ids
		$strQuery = "SELECT id FROM invoice WHERE (billing_account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "') OR shipping_account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "') $partner) AND deleted = 0";
		// Execute the query
		$objResult = $db->query($strQuery);
		// Loop through and process the results
		while (($arRow = $db->fetchByAssoc($objResult)) != null) {
			// Add the case record
			$arInvoiceIds[$arRow['id']] = $arRow['id'];
		}
	}
	// First, get the list of IDs.
	$strQuery = "SELECT id FROM invoice WHERE (billing_contact_id = '".$db->quote($_SESSION['contact_id'])."' OR shipping_contact_id = '".$db->quote($_SESSION['contact_id'])."') AND deleted = 0";
	// Execute the query
	$objResult = $db->query($strQuery);
	// Loop through and process the results
	while (($arRow = $db->fetchByAssoc($objResult)) != null) {
		// Add the case record
		$arInvoiceIds[$arRow['id']] = $arRow['id'];
	}
	// Return the id string
	return $arInvoiceIds;
}

function get_so_ids() {
	// Get access to the db
	global $db;
	// Initialize the invoice ids
	$arSalesOrderIds = array();
	// Do we have an account id?
	if (!empty($_SESSION['viewable']['Accounts'])){	
		// Get the list of bug ids
		$strQuery = "SELECT id FROM sales_orders WHERE (billing_account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "') OR shipping_account_id IN ('" . implode("','", $_SESSION['viewable']['Accounts']) . "')) AND deleted = 0";
		// Execute the query
		$objResult = $db->query($strQuery);
		// Loop through and process the results
		while (($arRow = $db->fetchByAssoc($objResult)) != null) {
			// Add the case record
			$arSalesOrderIds[$arRow['id']] = $arRow['id'];
		}
	}
	// First, get the list of IDs.
	$strQuery = "SELECT id FROM sales_orders WHERE (billing_contact_id = '".$db->quote($_SESSION['contact_id'])."' OR shipping_contact_id = '".$db->quote($_SESSION['contact_id'])."') AND deleted = 0";
	// Execute the query
	$objResult = $db->query($strQuery);
	// Loop through and process the results
	while (($arRow = $db->fetchByAssoc($objResult)) != null) {
		// Add the case record
		$arSalesOrderIds[$arRow['id']] = $arRow['id'];
	}
	// Return the id string
	return $arSalesOrderIds;
}

function get_project_tasks($project_id)
{
	require_once('modules/ProjectTask/ProjectTask.php');
	require_once('modules/Project/Project.php');
	$query = "SELECT id from project_task where parent_id = '$project_id' AND deleted=0 AND portal_flag = 1";
	$project = new Project;
	$task = new ProjectTask;
	return $project->build_related_list($query, $task);
}

function get_project_documents($project_id)
{
	require_once('modules/Project/Project.php');
	require_once('modules/Documents/Document.php');
	$query = "SELECT DISTINCT document_id AS id from document_relations where relation_id = '$project_id' AND deleted=0 AND relation_type='Project'";
	$project = new Project;
	$doc = new Document;
	$docs = $project->build_related_list($query, $doc);
	foreach ($docs as $i => $d) {
		$docs[$i]->fill_in_additional_detail_fields();
	}
	return $docs;
}

function get_project_contacts($project_id)
{
	require_once('modules/Project/Project.php');
	require_once('modules/Contacts/Contact.php');
	$query = "SELECT relation_id as id from project_relation  where project_id ='" . PearDatabase::quote($project_id) . "' AND deleted=0 AND relation_type='Contacts'";
	$project = new Project;
	$contact = new Contact;
	return $project->build_related_list($query, $contact);
}


function get_related_list($in, $template, $where, $order_by, $row_offset = 0, $limit = ""){
	//bail if the in is empty
	if($in == '()')return array();
	// Return the generated list
	return $template->build_related_list_where('', $template, $where, $in, $order_by, $limit, $row_offset);
}

function get_related_list_size($in, $template, $where) {
	// bail if the in is empty
	if ($in == '()') return 0;
	// Get the list size
	return $template->get_related_list_size('', $template, $where, $in);
}


function get_accounts_from_contact($contact_id, $orderBy = '') {
	// Get access to database
	global $db;
	// First, get the list of IDs.
	$partner = "";
	if (!empty($_SESSION['is_partner'])) {
		$partner = " OR partner_id='" . $_SESSION['is_partner'] . "'";
	}
	$strQuery = "SELECT DISTINCT(accounts.id) as id from accounts LEFT JOIN accounts_contacts ON accounts.id = accounts_contacts.account_id  where ((contact_id='$contact_id'  AND accounts_contacts.deleted=0) $partner )  AND accounts.deleted=0";
	if(!empty($orderBy)){
		$strQuery .= ' ORDER BY ' . $orderBy;
	}

	// Execute the query
	$objResult = $db->query($strQuery);
	// Initialize the accounts list
	$arAccounts = array();
	// Loop through and process the results
	while (($arRow = $db->fetchByAssoc($objResult)) != null) {
		// Add the case record
		$arAccounts[$arRow['id']] = $arRow['id'];
		// Get any accounts that belong to this account - this allows top level accounts to view all details of child accounts
		$strQuery = "
			SELECT
				id
			FROM
				accounts
			WHERE
				parent_id = '{$arRow['id']}'
			AND
				deleted = 0
		";
		// Execute the query
		$objChildren = $db->query($strQuery);
		// Get the child accounts
		while (($arChild = $db->fetchByAssoc($objChildren)) != null) {
			// Add the child account
			$arAccounts[$arChild['id']] = $arChild['id'];
		}
	}
	// Finally, set the viewable set
	$_SESSION['viewable']['Accounts'] = $arAccounts;
}

function get_contacts_from_account($account_id, $orderBy = '') {
	// First, get the list of IDs.
	$query = "SELECT contact_id as id from accounts_contacts where account_id='$account_id' AND deleted=0";
	if(!empty($orderBy)){
		$query .= ' ORDER BY ' . $orderBy;
	}
	$sugar = new Account();
	set_module_in($sugar->build_related_in($query), 'Contacts');
}

function get_module_in($module_name){
	if(!isset($_SESSION['viewable'][$module_name]))
		return array();

    $ids = array_keys($_SESSION['viewable'][$module_name]);
    $mod_in = "('" . join("','", $ids) . "')";
    $_SESSION['viewable'][strtolower($module_name).'_in'] = $mod_in;
    
	return $ids;
}

function set_module_in($arrayList, $module_name) {
	if(!isset($_SESSION['viewable'][$module_name])){
		$_SESSION['viewable'][$module_name] = array();
	}
	foreach($arrayList['list'] as $id){
		$_SESSION['viewable'][$module_name][$id] = $id;
	}
	if($module_name == 'Accounts' && isset($id)){
		$_SESSION['account_id'] = $id;
	}

	if(!empty($_SESSION['viewable'][strtolower($module_name).'_in'])){
		if($arrayList['in'] != '()') {
			$tmpIn = implode('\',\'', $arrayList['list']);
			$_SESSION['viewable'][strtolower($module_name).'_in'] = str_replace(')','', $_SESSION['viewable'][strtolower($module_name).'_in']);
			if ($_SESSION['viewable'][strtolower($module_name).'_in'] != '(') {
				$_SESSION['viewable'][strtolower($module_name).'_in'] .= ',';
			}
			$_SESSION['viewable'][strtolower($module_name).'_in']  .= '\'' . $tmpIn . '\') ';
		}
	}else{
		$_SESSION['viewable'][strtolower($module_name).'_in'] = $arrayList['in'];
	}
}

function get_portal_module_ids($module) {
	global $valid_modules_for_contact, $valid_partner_modules;

    if (! AppConfig::setting("modinfo.by_name.$module", false)) {
		return false;
	}
	// If a lead, only allow lead access
	if($_SESSION['type'] == 'lead' && $module != 'Leads'){
		// Nothing else to do
		return false;
	}
	// Ensure that we're accessing a valid module
	if (($_SESSION['type'] == 'contact') && ! array_key_exists($module, $valid_modules_for_contact)) {
		if (empty($_SESSION['is_partner']) || !isset($valid_partner_modules[$module])) {
			return false;
		}
	}
	
	// Determine the module
	switch ($module) {
		// Cases module
		case 'Cases':
			// If the viewable data isn;t set, get it
			if (! isset($_SESSION['viewable'][$module])) {
				$_SESSION['viewable'][$module] = get_case_ids();
			}
			break;

		// Contacts module
		case 'Contacts':
			// Get the list and total records
			//$get_ids = array($_SESSION['contact_id']);
			break;
	
		case 'Accounts':
			break;


		// Bugs module
		case 'Bugs':
			// If the viewable data isn't set, get it
			if (!isset($_SESSION['viewable']['Bugs'])) {
				// Get cases for contacts and accounts
				$_SESSION['viewable']['Bugs'] = get_bug_ids();
			}
			break;

		// Projects module
		case 'Project':
			// If the viewable data isn't set, get it
			if (!isset($_SESSION['viewable']['Project'])) {
				// Get cases for contacts and accounts
				$_SESSION['viewable']['Project'] = get_project_ids();
			}
			break;

		// Quotes module
		case 'Quotes':
			// If the viewable data isn't set, get it
			if (!isset($_SESSION['viewable']['quotes'])) {
				// Get cases for contacts and accounts
				$_SESSION['viewable']['Quotes'] = get_quote_ids();
			}
			break;

		case 'Opportunities':
			// If the viewable data isn't set, get it
			if (!isset($_SESSION['viewable']['Opportunities'])) {
				$_SESSION['viewable']['Opportunities'] = get_opportunity_ids();
			}
			break;
		
		case 'Leads':
			// If the viewable data isn't set, get it
			if (!isset($_SESSION['viewable']['Leads'])) {
				$_SESSION['viewable']['Leads'] = get_lead_ids();
			}
			break;
		
		// Invoice module
		case 'Invoice':
			// If the viewable data isn't set, get it
			if (!isset($_SESSION['viewable']['Invoice'])) {
				// Get cases for contacts and accounts
				$_SESSION['viewable']['Invoice'] = get_invoice_ids();
			}
			break;
		
		// Sales Order module
		case 'SalesOrders':
			// If the viewable data isn't set, get it
			if (!isset($_SESSION['viewable']['SalesOrders'])) {
				// Get cases for contacts and accounts
				$_SESSION['viewable']['SalesOrders'] = get_so_ids();
			}
			break;
		case 'EventSessions':
			$get_ids = true;
			break;
		
		default:
			// Unsupported module
			return false;
	}
	
	if(empty($get_ids))
		$get_ids = get_module_in($module);
	return $get_ids;
}

function portal_build_relationship_tree($contact) {
	$contact->retrieve($contact->id);

	unset($_SESSION['is_partner']);
	require_once 'modules/Partners/Partner.php';
	$partner = new Partner;
	if ($contact->partner_id) {
		if ($partner->retrieve($contact->partner_id) && !$partner->deleted) {
			$_SESSION['is_partner'] = $partner->id;
		}
	}

	get_accounts_from_contact($contact->id);

	set_module_in(array('list'=>array($contact->id), 'in'=> "('$contact->id')"), 'Contacts');

	if(AppConfig::setting('site.portal_view') != 'single_user'){
		$accounts = $_SESSION['viewable']['Accounts'];
		foreach($accounts as $id){
			get_contacts_from_account($id);
		}
	}
}


function json_convert_bean($objSeed, $select_fields = array())
{
	global $app_list_strings;
	
	if (empty($select_fields)) {
		$select_fields = array_merge($objSeed->column_fields, $objSeed->additional_column_fields);
	}
	$arRow = array();
	// Loop through the requested fields
	foreach ($select_fields as $strField) {
		// Is the field set?
		if (isset($objSeed->$strField)) {
			// Field map set?
			if (!empty($objSeed->field_name_map[$strField]['type']) && ($objSeed->field_name_map[$strField]['type'] == 'enum' || $objSeed->field_name_map[$strField]['type'] == 'status') && !empty($objSeed->field_name_map[$strField]['options']) && !empty($_REQUEST['convert_values'])){
				// Convert the dropdown field
				$arRow[$strField] = $app_list_strings[$objSeed->field_name_map[$strField]['options']][$objSeed->$strField];
			} elseif (isset($objSeed->$strField)) {
				// Add the field to the return array
				$arRow[$strField] = $objSeed->$strField;    			
			}
		}
	}
	// Finally, set the created, modified and assigned names (these are common)
	$arRow['assigned_user_name'] = get_assigned_user_name($objSeed->assigned_user_id);
	$arRow['created_by_name'] = get_assigned_user_name($objSeed->created_by);
	$arRow['modified_by_name'] = get_assigned_user_name($objSeed->modified_user_id);
	// Return the generated row
	return $arRow;
}

function json_convert_bean_list($list, $select_fields = array())
{
	$arRecords = array();
	foreach ($list as $objSeed) {
		if (empty($select_fields)) {
			$select_fields = array_merge($objSeed->column_fields, $objSeed->additional_column_fields);
		}
		$arRecords[] = json_convert_bean($objSeed, $select_fields);
	}
	return $arRecords;
}

?>
