<?php

class TemplateStub {
	var $vars = array();
	var $inc_mgr;
	
	function __construct() {
		global $themeInstance;

		$this->assign('SUGAR_VERSION', js_version_ident());
		$this->assign('JS_CUSTOM_VERSION', AppConfig::js_custom_version());
		$this->assign('JS_PREFIX', js_prefix());
		$this->assign('JS_SUFFIX', js_suffix());
		$this->assign('CSS_PREFIX', css_prefix());
		$this->assign('CSS_SUFFIX', css_suffix());
		$this->assign('STATIC_URL', AppConfig::site_static_url());
		$this->assign('LIST_ADD_HR', ! isset($themeInstance) || $themeInstance->layout_version < 8);
		
		require_once('include/layout/IncludeManager.php');
		$this->inc_mgr = new IncludeManager();
	}
	
	function assign($name, $val) {
		$this->vars[$name] = $val;
	}
	
	function getTemplateVars() {
		return $this->vars;
	}
	
	function export_includes() {
		global $pageInstance;
		if(isset($pageInstance))
			$pageInstance->merge_includes($this->inc_mgr);
	}
	
	function fetch($path) {
		ob_start();
		$tpl_vars = $this->getTemplateVars();
		include($path);
		$str = ob_get_contents();
		ob_end_clean();
		return $str;
	}
}

?>
