<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */


require_once('include/layout/forms/FormSection.php');

class FormTbodySection extends FormSection {
	var $column_titles;
	var $show_descriptions;
	
	function init($params=null, $model=null) {
		parent::init($params, $model);
		$this->column_titles = array_get_default($params, 'column_titles');
		$this->show_descriptions = array_get_default($params, 'show_descriptions');
	}

	function getColumnTitles() {
		return $this->column_titles;
	}
	
	function getShowDescriptions() {
		return $this->show_descriptions;
	}
	
	function createElementType($type, $spec=null) {
		if(! $spec) $spec = array();
		if($this->form_id && ! isset($spec['form_id']))
			$spec['form_id'] = $this->form_id;
		if(! empty($this->skip_field_lookup))
			$spec['skip_field_lookup'] = true;
		if($type == 'static') {
			return new FormElement($spec, $this->model);
		}
		else if($type != 'section') {
			return new FormField($spec, $this->model);
		}
	}
	
	
	function renderCells(HtmlFormGenerator &$gen, RowResult &$row_result, array $parents, array $context) {
		$cells = array();
        $subpath = $parents;
        $subpath[] =& $this;
        $editable = array_get_default($context, 'editable');
        $elts =& $this->getElements();        
        if($elts)
		foreach($elts as $id => $elt) {
			if($elt instanceof FormElement) {
				$mode = $elt->getMode();
				$cell = $elt->getHtmlCell($gen, $row_result, $subpath, $context);
				if(($editable && $mode != 'edit' && $mode != 'any') || (! $editable && $mode == 'edit'))
					continue;
				$cells[] = $cell;
			}
		}
		return $cells;
	}

}

?>
