<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */


require_once('include/layout/forms/FormElement.php');

class CloseActivityInput extends FormElement {

	var $mobile_align = 'right';

	function init($params=null, $model=null) {
        parent::init($params, $model);
	}

	function getRequiredFields() {
        $fields = array('id', 'status');
		return $fields;
	}

    function renderListCell(ListFormatter &$fmt, ListResult &$result, $row_id, $list_params=null) {
    	global $pageInstance;
    	
    	$row = $result->getRowResult($row_id);
    	$model = $row->base_model;
    	$mod = $result->module_dirs[0];
    	if($model == 'Activity') {
    		$qsrc = array_get_default($row->row, 'query_source');
    		if($qsrc == 'calls') $model = 'Call';
    		else if($qsrc == 'meetings') $model = 'Meeting';
    		else if($qsrc == 'tasks') $model = 'Task';
    		$mod = $result->module_dirs[$qsrc];
    	}
    	if($model == 'Meeting' || $model == 'Call') {
    		if($row->getField('status') == 'Planned')
    			$new_status = 'Held';
    	} else if($model == 'Task') {
    		if($row->getField('status') != 'Completed')
    			$new_status = 'Completed';
    	}
    	if(! empty($new_status)) {
    		$attrs = array(
    			'module' => $mod, 'action' => 'EditView', 'record' => $row->getField('id'),
    			'status' => $new_status,
    			'return_module' => $pageInstance->module,
    			'return_action' => $pageInstance->action,
    			'return_record' => $pageInstance->record,
    			'return_layout' => array_get_default($_REQUEST, 'layout'),
    		);
    		$link = javascript_escape('index.php?' . encode_query_string($attrs));
    		$ret = '<a href="#" class="utilsLink" onclick="SUGAR.util.loadUrl(\''.$link.'\', null, true); return false;" style="white-space: nowrap"><div class="input-icon icon-cancel active-icon" style="vertical-align: middle"></div>';
    		if(AppConfig::is_mobile()) {
    			$ret .= '&nbsp;' . translate('LBL_CLOSE_PARTICIPANTS_SCHEDULE', 'Meetings');
    		}
    		$ret .= '</a>';
    	}
        else $ret = '&nbsp;';
        return $ret;
    }
    
    function getWidth() {
    	return 5;
    }
    
    function getLabel($context=null) {
    	$l = parent::getLabel($context);
    	if(! $l)
			return translate('LBL_LIST_CLOSE', 'Meetings');
		return $l;
    }
}
