<?php

require_once 'include/layout/forms/FormField.php';
require_once 'include/database/ListQuery.php';

class InviteesFilter extends FormField implements FilterElement {

    const DEFAULT_VALUE = 'mine';

    public function getFilterClause($filter) {
        $field = strtolower($this->model->name);
        $base_query = "EXISTS (SELECT {$field}_id, user_id FROM {$this->model->table_name}_users jt0  WHERE user_id = '".AppConfig::current_user_id()."' AND {$this->model->table_name}.id=jt0.{$field}_id AND NOT deleted";

        $filter_value = array_get_default($filter, 'any_user_id', self::DEFAULT_VALUE);

        switch ($filter_value) {
            case 'mine':
                $query = $base_query . ')';
                break;
            case 'accepted':
                $query = $base_query . " AND accept_status='accept')";
                break;
            case 'not_accepted':
                $query = $base_query . " AND IFNULL(accept_status,'none') NOT IN ('accept','decline'))";
                break;
            case 'not_invited':
                $query = 'NOT ' . $base_query . ')';
                break;
            case 'all':
            default:
                $query = '(1 = 1)';
                break;
        }

        return $query;
    }

    public function loadFilter(&$filter, $input, $prefix) {}

    /**
     * @param EditableForm $form
     * @param RowResult $result
     * @return mixed
     */
    public function render($form, $result) {
        $spec = array('name' => 'any_user_id', 'options' => 'invitees_filter_dom', 'options_add_blank' => false);
        return $form->renderSelect($spec, $result->getField('any_user_id', self::DEFAULT_VALUE));
    }

}
