<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */


require_once('include/layout/forms/FormElement.php');

// TODO: add ways to dynamically configure list input from function or link data source

class RelatedSelectInput extends FormElement {
	var $module, $width, $list_name;
	var $style, $disabled, $tabindex;
	
	function init($params=null, $model=null) {
		parent::init($params, $model);
		if(is_array($params))
		foreach(array('module', 'width', 'list_name') as $k)
			if(isset($params[$k]))
				$this->$k = $params[$k];
	}
	
	function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context) {
		if(empty($this->name))
			return '';
		if($this->getEditable($context))
			$value = $this->renderHtmlEdit($gen, $row_result, $context);
		else
			$value = '';
		return $value;
	}
	
	function renderHtmlEdit(HtmlFormGenerator $gen, RowResult $row_result, array $context) {
		$form =& $gen->getFormObject();
		if($this->list_name)
			$gen->getLayout()->addScriptInclude('include/javascript/dynamic_list.js');

		$name = $form->getFieldNamePrefix() . $this->name;
		$sel_id = $form->getFieldIdPrefix() . $name.'-input';
		
		$attrs = array(
			'type' => 'ref', 'name' => $this->name, 'id' => $sel_id,
			'bean_name' => AppConfig::module_primary_bean($this->module),
			'module' => $this->module,
			'list_name' => $this->list_name,
			'input_class' => 'RelatedSelectInput');
		foreach(array('style', 'disabled', 'tabindex') as $f)
			if(isset($this->$f) && ($f != 'disabled' || $this->$f))
				$attrs[$f] = $this->$f;
			
		$result = new RowResult();
		$ret = $form->renderRef($result, $attrs);
		
		return $ret;
	}
	
}
