<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */


require_once('include/layout/forms/FormField.php');


class SharedWithInput extends FormField {

	function init($params=null, $model=null) {
		parent::init($params, $model);
		if($this->model && $this->model->getModelName() == 'SavedSearch' && ! AppConfig::is_admin()) {
			$this->hidden = $this->hidden_flag = true;
		}
	}

    function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context) {
    	global $app_list_strings;
		$selected = $row_result->getField($this->name);

    	if(! $this->getEditable($context)) {
    		return to_html(array_get_default($app_list_strings['shared_with_dom'], $selected, $selected));
    	}

    	$opts = array(
    		'' => array(
    			'label' => $app_list_strings['shared_with_dom'][''],
    			'icon' => 'icon-user',
    		),
    		'all' => array(
    			'label' => $app_list_strings['shared_with_dom']['all'],
    			'icon' => 'icon-users',
    		),
    		'teams' => array(
    			'label' => $app_list_strings['shared_with_dom']['teams'],
    			'icon' => 'icon-teams',
    		),
    	);
    	$spec = array(
    		'name' => $this->name,
    		'type' => 'enum',
    		'options' => $opts,
    		'label_key' => 'label',
    		'options_icon' => 'icon',
    	);
		$form = $gen->getFormObject();
		return $form->renderSelect($spec, $selected);
	}

}
