var TemplateDragDropChooser = {

	initialize: function(id) {
		this.id = id;
		this.elt = document.getElementById(id);
		this.makeDragTarget();
	},

    makeDraggable: function(id) {
	    var elt = document.getElementById(id);
        new SUGAR.ui.Draggable(elt, {values: {target_id: id}});
    },

	makeDragTarget: function() {
		var chooser = this;
		this.target = new SUGAR.ui.DragTarget(this.elt, {
			dragListSource: null,
			dragElt: null,
			lastY: 0,
			drop_effect: 'move',
			onEnd: function(evt, data) {
                this.dragElt = document.getElementById(data.values.target_id);

				if (this.dragElt)
					this.dragElt.style.opacity = 1;
				this.dragElt = null;
			},
            onDrop: function(evt, data, index) {
                var cols = chooser.SUGAR_GRID_cols;

                for(var i = 0; i < cols.length; i++) {
                    var listEl = document.getElementById(cols[i].name + '_list');
                    if(! cols[i].field || ! listEl)
                        continue;
                    var ids = [];
                    var items = listEl.getElementsByTagName('li');
                    for(var n = 0; n < items.length; n++)
                        ids.push(items[n].id);
                    document.getElementById(cols[i].field).value = ids.join(', ');
                }

            },
			onMove: function(evt, data) {
                this.dragElt = document.getElementById(data.values.target_id);

				var li = chooser.findItem(evt.target);
				var ul = chooser.findList(li || evt.target);
				if (!ul)
					return;
				var pos = evt.position();
				var delta = parseInt(pos.y) - this.lastY;
				var deltaY = (delta > 0) ? 1 : ((delta < 0) ? -1 : 0);
				this.lastY = parseInt(pos.y);
				this.moveDirection = deltaY;
				if (!this.moveDirection)
					return;
				if (li) {
					var region = SUGAR.ui.getEltRegion(li);
					var center = (region.top + region.bottom) / 2;
					if (pos.y > center) {
						if (li.nextSibling)
							ul.insertBefore(this.dragElt, li.nextSibling);
						else
							ul.appendChild(this.dragElt);
					} else {
						ul.insertBefore(this.dragElt, li);
					}
				} else if (ul.childElementCount < 1 || this.dragElt.parentNode != ul) {
					ul.appendChild(this.dragElt);
				}
			},
			checkAccept: function(evt, data) {
				return true;
			}
		});
	},

	findList: function(el) {
		while (el) {
			if (el.tagName === 'UL' && el.className && el.className.match(/\bdragDropList\b/)) {
				return el;
			}
			el = el.parentNode;
		}
		return null;
	},

	findItem: function(el) {
		while (el) {
			if (el.tagName === 'LI' && el.className && el.className.match(/\bdragDropItem\b/)) {
				return el;
			}
			el = el.parentNode;
		}
		return null;
	}
};
