<?php

function strftime_to_date_format($format) {
	static $map = [
		'd' => 'd',
		'a' => 'D',
		'A' => 'l',
		'e' => 'j',
		'u' => 'N',
		'W' => 'W',
		'b' => 'M',
		'B' => 'F',
		'h' => 'F',
		'm' => 'm',
		'y' => 'y',
		'Y' => 'Y',
		'H' => 'H',
		'k' => 'G',
		'I' => 'h',
		'l' => 'g',
		'M' => 'i',
		'p' => 'A',
		'P' => 'a',
		'r' => '%I:%M:%S %p',
		'R' => '%H:%M',
		'S' => 's',
		'T' => '%H:%M:%S',
	];
	if (!is_string($format))
		return '';
	$output = '';
	$len = strlen($format);
	for($i = 0; $i < $len; $i++) {
		$char = $format[$i];
		if (($char >= 'A' && $char <= 'Z') || ($char >= 'a' && $char <= 'z')) {
			$output .= '\\' . $char;
		} else if ($char === '%') {
			if ($i < $len - 1) {
				$nextChar = $format[$i+1];
				if (isset($map[$nextChar])) {
					$replacement = $map[$nextChar];
					if (strpos($replacement, '%') !== false) {
						$format = $replacement . substr($format, $i + 2);
						$i = -1;
						$len = strlen($format);
						continue;
					}
					$output .= $replacement;
				} else if ($nextChar === '%') {
					$output .= '%';
				} else {
					trigger_error("Unsupported date format specifier: " . $nextChar, E_USER_WARNING);
				}
				$i++;
			}
		} else {
			$output .= $char;
		}
	}
	return $output;
}
