<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');


 /*********************************************************************************
 * $Id: $
 ********************************************************************************/

    function cleanHTML($data, $inline=true, $for_edit=false)
    {
        global $browser, $prefs;

        $phish_warn = false;

        if (($i = stristr($data, '<base ')) && ($i = stristr($i, 'http')) &&
            ($j = strchr($i, '>'))) {
            $base = substr($i, 0, strlen($i) - strlen($j));
            $base = preg_replace('|(http.*://[^/]*/?).*|i', '\1', $base);

            if ($base[strlen($base) - 1] != '/') {
                $base .= '/';
            }

            $base = cleanHTML($base);
        }

        $data = preg_replace('/<!--.*?-->/s', '', $data);

        $data = preg_replace('/&#(x0*20|0*32);?/i', ' ', $data);

        $data = preg_replace('/&#x?0*([9A-D]|1[0-3]);/i', '&nbsp;', $data);
        $data = preg_replace('/&#x?0*[9A-D]([^0-9A-F]|$)/i', '&nbsp\\1', $data);
        $data = preg_replace('/&#0*(9|1[0-3])([^0-9]|$)/i', '&nbsp\\2', $data);
        $data = preg_replace('/&#x?0*[0-9A-F]{6,};?/i', '&nbsp;', $data);

        if ($inline) {
        	$data = preg_replace('/<title[^>]*>(.*?)<\/title[^>]*>/si', '', $data);
            $data = preg_replace('/<(\!DOCTYPE|html|head|body|title)[^>]*>/si', '', $data);
            $data = preg_replace('/<\/(html|head|body|title)[^>]*>/si', '', $data);
        }

        $preg = '/((&#0*61;?|&#x0*3D;?|=)|' .
                '((u|&#0*85;?|&#x0*55;?|&#0*117;?|&#x0*75;?)\s*' .
                '(r|&#0*82;?|&#x0*52;?|&#0*114;?|&#x0*72;?)\s*' .
                '(l|&#0*76;?|&#x0*4c;?|&#0*108;?|&#x0*6c;?)\s*' .
                '(\()))\s*' .
                '(&#0*34;?|&#x0*22;?|"|&#0*39;?|&#x0*27;?|\')?' .
                '[^>]*\s*' .
                '(s|&#0*83;?|&#x0*53;?|&#0*115;?|&#x0*73;?)\s*' .
                '(c|&#0*67;?|&#x0*43;?|&#0*99;?|&#x0*63;?)\s*' .
                '(r|&#0*82;?|&#x0*52;?|&#0*114;?|&#x0*72;?)\s*' .
                '(i|&#0*73;?|&#x0*49;?|&#0*105;?|&#x0*69;?)\s*' .
                '(p|&#0*80;?|&#x0*50;?|&#0*112;?|&#x0*70;?)\s*' .
                '(t|&#0*84;?|&#x0*54;?|&#0*116;?|&#x0*74;?)\s*' .
                '(:|&#0*58;?|&#x0*3a;?)/i';
        $data = preg_replace($preg, '\1\8Cleaned', $data);

        /* Get all on<foo>="bar()". NEVER allow these. */
        $data = preg_replace('/([\s"\']+' .
                             '(o|&#0*79;?|&#0*4f;?|&#0*111;?|&#0*6f;?)' .
                             '(n|&#0*78;?|&#0*4e;?|&#0*110;?|&#0*6e;?)' .
                             '\w+)\s*=/i', '\1Cleaned=', $data);

        /* Remove all scripts since they might introduce garbage if
         * they are not quoted properly. */
        $data = preg_replace('|<script[^>]*>.*?</script>|is', '<Cleaned_script />', $data);

        /* Get all tags that might cause trouble - <object>, <embed>,
         * <base>, etc. Meta refreshes and iframes, too. */
        $malicious = array(
            '/<([^>a-z]*)' .
            '(s|&#0*83;?|&#x0*53;?|&#0*115;?|&#x0*73;?)\s*' .
            '(c|&#0*67;?|&#x0*43;?|&#0*99;?|&#x0*63;?)\s*' .
            '(r|&#0*82;?|&#x0*52;?|&#0*114;?|&#x0*72;?)\s*' .
            '(i|&#0*73;?|&#x0*49;?|&#0*105;?|&#x0*69;?)\s*' .
            '(p|&#0*80;?|&#x0*50;?|&#0*112;?|&#x0*70;?)\s*' .
            '(t|&#0*84;?|&#x0*54;?|&#0*116;?|&#x0*74;?)\s*/i',

            '/<([^>a-z]*)' .
            '(e|&#0*69;?|&#0*45;?|&#0*101;?|&#0*65;?)\s*' .
            '(m|&#0*77;?|&#0*4d;?|&#0*109;?|&#0*6d;?)\s*' .
            '(b|&#0*66;?|&#0*42;?|&#0*98;?|&#0*62;?)\s*' .
            '(e|&#0*69;?|&#0*45;?|&#0*101;?|&#0*65;?)\s*' .
            '(d|&#0*68;?|&#0*44;?|&#0*100;?|&#0*64;?)\s*/i',

            '/<([^>a-z]*)' .
            '(x|&#0*88;?|&#0*58;?|&#0*120;?|&#0*78;?)\s*' .
            '(m|&#0*77;?|&#0*4d;?|&#0*109;?|&#0*6d;?)\s*' .
            '(l|&#0*76;?|&#x0*4c;?|&#0*108;?|&#x0*6c;?)\s*/i',

            '/<([^>a-z]*)' .
            '(b|&#0*66;?|&#0*42;?|&#0*98;?|&#0*62;?)\s*' .
            '(a|&#0*65;?|&#0*41;?|&#0*97;?|&#0*61;?)\s*' .
            '(s|&#0*83;?|&#x0*53;?|&#0*115;?|&#x0*73;?)\s*' .
            '(e|&#0*69;?|&#0*45;?|&#0*101;?|&#0*65;?)\s*' .
            '[^line]/i',

            '/<([^>a-z]*)' .
            '(m|&#0*77;?|&#0*4d;?|&#0*109;?|&#0*6d;?)\s*' .
            '(e|&#0*69;?|&#0*45;?|&#0*101;?|&#0*65;?)\s*' .
            '(t|&#0*84;?|&#x0*54;?|&#0*116;?|&#x0*74;?)\s*' .
            '(a|&#0*65;?|&#0*41;?|&#0*97;?|&#0*61;?)\s*/i',

            '/<([^>a-z]*)' .
            '(j|&#0*74;?|&#0*4a;?|&#0*106;?|&#0*6a;?)\s*' .
            '(a|&#0*65;?|&#0*41;?|&#0*97;?|&#0*61;?)\s*' .
            '(v|&#0*86;?|&#0*56;?|&#0*118;?|&#0*76;?)\s*' .
            '(a|&#0*65;?|&#0*41;?|&#0*97;?|&#0*61;?)\s*/i',

            '/<([^>a-z]*)' .
            '(o|&#0*79;?|&#0*4f;?|&#0*111;?|&#0*6f;?)\s*' .
            '(b|&#0*66;?|&#0*42;?|&#0*98;?|&#0*62;?)\s*' .
            '(j|&#0*74;?|&#0*4a;?|&#0*106;?|&#0*6a;?)\s*' .
            '(e|&#0*69;?|&#0*45;?|&#0*101;?|&#0*65;?)\s*' .
            '(c|&#0*67;?|&#x0*43;?|&#0*99;?|&#x0*63;?)\s*' .
            '(t|&#0*84;?|&#x0*54;?|&#0*116;?|&#x0*74;?)\s*/i',

            '/<([^>a-z]*)' .
            '(f|&#0*70;?|&#0*46;?|&#0*102;?|&#0*66;?)\s*' .
	    '(o|&#0*79;?|&#0*4f;?|&#0*111;?|&#0*6f;?)\s*' .
            '(r|&#0*82;?|&#x0*52;?|&#0*114;?|&#x0*72;?)\s*' .
	    '(m|&#0*77;?|&#0*4d;?|&#0*109;?|&#0*6d;?)\s*/i',
	    
            '/<([^>a-z]*)' .
            '(i|&#0*73;?|&#x0*49;?|&#0*105;?|&#x0*69;?)\s*' .
            '(f|&#0*70;?|&#0*46;?|&#0*102;?|&#0*66;?)\s*' .
            '(r|&#0*82;?|&#x0*52;?|&#0*114;?|&#x0*72;?)\s*' .
            '(a|&#0*65;?|&#0*41;?|&#0*97;?|&#0*61;?)\s*' .
            '(m|&#0*77;?|&#0*4d;?|&#0*109;?|&#0*6d;?)\s*' .
            '(e|&#0*69;?|&#0*45;?|&#0*101;?|&#0*65;?)\s*/i');

        $data = preg_replace($malicious, '<Cleaned_tag ', $data);

        /* Comment out style/link tags. */
        $pattern = array('|<style[^>]*>(?:\s*<\!--)*|i',
                         '|(?:-->\s*)*</style>|i',
                         '|(<link[^>]*>)|i');
        $replace = array('<!--',
                         '-->',
                         '<!-- $1 -->');
        $data = preg_replace($pattern, $replace, $data);

        /* A few other matches. */
        $pattern = array('|<([^>]*)&{.*}([^>]*)>|',
                         '|<([^>]*)mocha:([^>]*)>|i',
                         '|<([^>]*)binding:([^>]*)>|i');
        $replace = array('<&{;}\3>',
                         '<\1Cleaned:\2>',
                         '<\1Cleaned:\2>');
        $data = preg_replace($pattern, $replace, $data);

        /* Attempt to fix paths that were relying on a <base> tag. */
        if (!empty($base)) {
            $pattern = array('|src=(["\'])/|i',
                             '|src=[^\'"]/|i',
                             '|href= *(["\'])/|i',
                             '|href= *[^\'"]/|i');
            $replace = array('src=\1' . $base,
                             'src=' . $base,
                             'href=\1' . $base,
                             'href=' . $base);
            $data = preg_replace($pattern, $replace, $data);
        }

        /* Check for phishing exploits. */
        if (preg_match('/href\s*=\s*["\']?\s*(http|https|ftp):\/\/\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}/i', $data)) {
            /* Check 1: Check for IP address links. */
            $phish_warn = true;
        } elseif (preg_match_all('/href\s*=\s*["\']?\s*(?:http|https|ftp):\/\/([^\s"\'>]+)["\']?[^>]*>\s*(?:(?:http|https|ftp):\/\/)?(.*?)<\/a/is', $data, $m)) {
            /* $m[1] = Link; $m[2] = Target
             * Check 2: Check for links that point to a different host than
             * the target url; if target looks like a domain name, check it
             * against the link. */
            $links = count($m[0]);
            for ($i = 0; $i < $links; $i++) {
                $m[1][$i] = strtolower(urldecode($m[1][$i]));
                $m[2][$i] = strtolower(preg_replace('/^(http|https|ftp):\/\//', '', strip_tags($m[2][$i])));
                if (preg_match('/^[.-_\da-z]+\.[a-z]{2,}/i', $m[2][$i]) &&
                    strpos($m[1][$i], $m[2][$i]) !== 0 &&
                    strpos($m[2][$i], $m[1][$i]) !== 0) {
                    /* Don't consider the link a phishing link if the domain
                     * is the same on both links (e.g. adtracking.example.com
                     * & www.example.com). */
                    preg_match('/\.?([^\.\/]+\.[^\.\/]+)\//', $m[1][$i], $host1);
                    preg_match('/\.?([^\.\/]+\.[^\.\/]+)(\/.*)?$/', $m[2][$i], $host2);
                    if (!(count($host1) && count($host2)) ||
                        strcasecmp($host1[1], $host2[1]) !== 0) {
                        $phish_warn = true;
                    }
                }
            }
        }

        /* Try to derefer all external references. */
        $data = preg_replace_callback('/href\s*=\s*(["\'])?((?(1)[^\1]*?|[^\s]+))(?(1)\1|)/i',
                                      function($m) { return 'href="' . (strlen($m[2]) && $m[2][0] == '#' ? $m[2] : ($m[2] .'" target="_blank')) . '"'; },
                                      $data);

        /* Prepend phishing warning. */
        if ($phish_warn && !$for_edit) {
            $phish_warning = '<div style="color:red">Warning: This message may not be from whom it claims to be. Beware of following any links in it or of providing the sender with any personal information.</div>';
            if (stristr($data, '<body') === false) {
                $data = $phish_warning . $data;
            } else {
                $data = preg_replace('/(.*<body.*?>)(.*)/i', '$1' . $phish_warning . '$2', $data);
            }
        }

        return $data;
    }

    function hide_images($html)
    {
		$callback = function ($m) {
			return $m[1] . "include/images/iah/hidden_image.gif";
		};
        return preg_replace_callback('/(<img[^>]*\s+src\s*=\s*)(["\'])?((?(2)[^\2]*?|[^\s]+))(?(2)\2|)/i', 'callback', $html);
    }

    function remove_images($html, $keep_inline=false)
    {
        return preg_replace_callback('/(<img[^>]*\s+src\s*=\s*)(["\'])?((?(2)[^\2]*?|[^\s]+))(?(2)\2|)[^>]*>/i',
        function($matches) use ($keep_inline) {
        	if($keep_inline && (substr($matches[3], 0, 4) == 'cid:' || substr($matches[3], 0, 5) == 'data:'))
        		return $matches[0];
        	if(preg_match('/alt\s*=\s*(["\'])?((?(1)[^\1]*?|[^\s]+))(?(1)\1|)/i', $matches[0], $m))
        		$alt = $m[2];
        	else
        		$alt = '[IMAGE]';
        	return to_html($alt);
        }, $html);
    }

    function has_remote_content($html)
    {
        $rem = remove_images($html);
        return $rem != $html;
    }

    function make_inline_images($html, &$cids)
	{
		$site_url = preg_quote(AppConfig::site_url(), '/');
        return preg_replace_callback(
        	'/(<img[^>]*\s+src\s*=\s*)"(('. $site_url .'\/)?)(files\/email\/.+)"/iU',
        	function($matches) use ($cids) {
        		return make_inline_image($matches[1], $matches[4], $cids);
        	},
        	$html);
    }

    function make_inline_image($tag_start, $filename, &$cids)
    {
        $variants = glob($filename. '.*');
        if (!empty($variants)) {
            $filename = $variants[0];
        }
        $cid = md5($filename);
        $cids[$cid] = $filename;
        return $tag_start . '"cid:' . $cid . '"';
    }

    function show_inline_images($html, $signed = false) {
		$html = preg_replace('/(<img[^>]*\s+src\s*=\s*)(["\']?)files\/email/i', '\1\2' . preg_quote(AppConfig::site_url()) . '/files/email', $html);
		return preg_replace_callback(
			'/(<img[^>]*\s+src\s*=\s*)(["\'])?(cid:((?(2)[^\2]*?|[^\s]+)))(?(2)\2|)/i',
			function($m) use ($signed) {
				return show_inline_image($m, $signed);
			},
			$html
		);
    }
    
    function remove_tracker_images($html) {
    	$path_pat = preg_quote(AppConfig::host_name()) . '[^>\'"]*\/image.php\?identifier=[^>\'"]*';
    	return preg_replace('/(<img[^>]*\s+src\s*=\s*)(["\']?)[^>\'"]*' . $path_pat . '[^>]*>/i', '', $html);
    }

	function show_inline_image($m, $signed = false) {
		$signature = '';
        $cid = str_replace(array('<', '>'), '', $m[4]);
        $filename = md5($cid);
		$filename = substr($filename, 0, 2) . '/' . substr($filename, 2, 2).  '/' . $filename;
		$prefix = AppConfig::files_dir() . 'email/';
        $variants = glob($prefix . $filename. '.*');
        if (!empty($variants)) {
            $filename = substr($variants[0], strlen($prefix));
		}
		if ($signed) {
			$uid = AppConfig::unique_key();
			$hash = sha1($filename . '/' . $uid);
			$signature = '&g=' . $hash;
		}
        return $m[1]. '"' . AppConfig::site_url() . 'download.php?inline=1&type=email&id=' . $filename . $signature . '"';
        
    }

    
    function html2plaintext($html, $wrap=true)
    {

        static $search = array(
            "/\r/",
            "/[\n\t]+/",
            '/<script\b[^>]*>.*?<\/script>/i',
            '/<style\b[^>]*>.*?<\/style>/i',
            # '/<!-- .* -->/',
            # '/<p[^>]*>/i',
            # '/<br[^>]*>/i',
            '/(<ul\b[^>]*>|<\/ul>)/i',
            '/(<ol\b[^>]*>|<\/ol>)/i',
            '/<li\b[^>]*>/i',
            '/<hr\b[^>]*>/i',
            '/(<table\b[^>]*>|<\/table>)/i',
            '/(<tr\b[^>]*>|<\/tr>)/i',
            '/<td\b[^>]*>(.+?)<\/td>/i',
            '/[ \t]+/',
            '/&nbsp;/i',
            '/&copy;/i',
            '/&trade;/i',
            '/&#8220;/',
            '/&#8221;/',
            '/&#8211;/',
            '/&#8217;/',
            '/&#38;/',
            '/&#169;/',
            '/&#8482;/',
            '/&#151;/',
            '/&#147;/',
            '/&#148;/',
            '/&#149;/',
            '/&reg;/i',
            '/&bull;/i',
            '/&[&;]+;/i',
            '/&mdash;/i',
            '/&#160;/i',
        );
    
        static $replace = array(
            '',
            ' ',
			'',
			'',
            # '',
            # "\n\n\t",
            # "\n",
            "\n\n",
            "\n\n",
            "\t*",
            
                                                    // <a href="">
            "\n-------------------------\n",
            "\n\n",
            "\n",
            "\t\t\\1\n",
            ' ',
            ' ',
            '(c)',
            '(tm)',
            '"',
            '"',
            '-',
            "'",
            '&',
            '(c)',
            '(tm)',
            '--',
            '"',
            '"',
            '*',
            '(R)',
            '*',
            '',
            '--',
            ' ',
        );
        
        $link_count = 1;
        $link_list = array();

        $text = preg_replace($search, $replace, $html);
        $text = preg_replace_callback('/<h[123]\b[^>]*>(.+?)<\/h[123]>/i', function($m) { return mb_strtoupper("\n\n{$m[1]}\n\n"); }, $text);
        $text = preg_replace_callback('/<h[456]\b[^>]*>(.+?)<\/h[456]>/i', function($m) { return ucwords("\n\n{$m[1]}\n\n"); }, $text);
        $text = preg_replace_callback('/<b\b[^>]*>(.+?)<\/b>/i', function($m) { return mb_strtoupper($m[1]); }, $text);
        $text = preg_replace_callback('/<a\b[^>]*\s+href="([^"]+)"[^>]*>(.+?)<\/a>/i', function($m) use (&$link_count, &$link_list) { return _add_link($link_count++, $m[1], $m[2], $link_list); }, $text);
		$text = preg_replace_callback('/<th\b[^>]*>(.+?)<\/th>/i', function($m) { return mb_strtoupper("\t\t{$m[1]}\n"); }, $text);

        $text = strip_tags($text, '<p><br>');
        $text = tags2lines($text);

        $text = preg_replace(
            array(
                '/&quot;/i',
                '/&gt;/i',
                '/&lt;/i',
                '/&amp;/i',
            ),
            array(
                '"',
                '>',
                '<',
                '&',
            ),
            $text
        );
            
            
        $text = preg_replace("/\n[ \t]+\n/", "\n\n", $text);
        $text = preg_replace("/[\n]{4,}/", "\n\n\n", $text);

        if ( !empty($link_list) ) {
            $text .= "\n\n------\n";
            foreach ($link_list as $i => $link) {
                $text .= '[' . ($i+1) . '] ' . $link . "\n";
            }
        }

		if($wrap)
			$text = wordwrap($text);

        return $text;
    }
    
    function tags2lines($text) {
    	$repl = array(
    		'~</p\b[^>]*>(\s*)<p\b[^>]*>~i' => "\n\n",
    		'~^(\s*)<p\b[^>]*>|</p\b[^>]*>(\s*)$~i' => '\1',
    		'~</?p\b[^>]*>~i' => "\n\n",
    		'~<br\b[^>]*>[ \t]*~i' => "\n",
    	);
    	$text = preg_replace(array_keys($repl), array_values($repl), $text);
    	return $text;
    }


    function _add_link($link_count, $link, $text, &$link_list)
    {
        $index = array_search($link, $link_list);
        if ($index === false) {
            //$link_list[] = $link;
            $index = count($link_list) -1;
        }
        $index++;
        return $text. " <$link>";
    }


if(! function_exists('fix_fck_html')) { // fix issue during 7.5.11 upgrade
	function fix_fck_html($str)
	{
		static $cvt = array(
			'&nbsp;' => ' ',
			'&iexcl;' => '¡',
			'&cent;' => '¢',
			'&pound;' => '£',
			'&curren;' => '¤',
			'&yen;' => '¥',
			'&brvbar;' => '¦',
			'&sect;' => '§',
			'&uml;' => '¨',
			'&copy;' => '©',
			'&ordf;' => 'ª',
			'&laquo;' => '«',
			'&not;' => '¬',
			'&shy;' => '­',
			'&reg;' => '®',
			'&macr;' => '¯',
			'&deg;' => '°',
			'&plusmn;' => '±',
			'&sup2;' => '²',
			'&sup3;' => '³',
			'&acute;' => '´',
			'&micro;' => 'µ',
			'&para;' => '¶',
			'&middot;' => '·',
			'&cedil;' => '¸',
			'&sup1;' => '¹',
			'&ordm;' => 'º',
			'&raquo;' => '»',
			'&frac14;' => '¼',
			'&frac12;' => '½',
			'&frac34;' => '¾',
			'&iquest;' => '¿',
			'&times;' => '×',
			'&divide;' => '÷',
			'&fnof;' => 'ƒ',
			'&bull;' => '•',
			'&hellip;' => '…',
			'&prime;' => '′',
			'&Prime;' => '″',
			'&oline;' => '‾',
			'&frasl;' => '⁄',
			'&weierp;' => '℘',
			'&image;' => 'ℑ',
			'&real;' => 'ℜ',
			'&trade;' => '™',
			'&alefsym;' => 'ℵ',
			'&larr;' => '←',
			'&uarr;' => '↑',
			'&rarr;' => '→',
			'&darr;' => '↓',
			'&harr;' => '↔',
			'&crarr;' => '↵',
			'&lArr;' => '⇐',
			'&uArr;' => '⇑',
			'&rArr;' => '⇒',
			'&dArr;' => '⇓',
			'&hArr;' => '⇔',
			'&forall;' => '∀',
			'&part;' => '∂',
			'&exist;' => '∃',
			'&empty;' => '∅',
			'&nabla;' => '∇',
			'&isin;' => '∈',
			'&notin;' => '∉',
			'&ni;' => '∋',
			'&prod;' => '∏',
			'&sum;' => '∑',
			'&minus;' => '−',
			'&lowast;' => '∗',
			'&radic;' => '√',
			'&prop;' => '∝',
			'&infin;' => '∞',
			'&ang;' => '∠',
			'&and;' => '∧',
			'&or;' => '∨',
			'&cap;' => '∩',
			'&cup;' => '∪',
			'&int;' => '∫',
			'&there4;' => '∴',
			'&sim;' => '∼',
			'&cong;' => '≅',
			'&asymp;' => '≈',
			'&ne;' => '≠',
			'&equiv;' => '≡',
			'&le;' => '≤',
			'&ge;' => '≥',
			'&sub;' => '⊂',
			'&sup;' => '⊃',
			'&nsub;' => '⊄',
			'&sube;' => '⊆',
			'&supe;' => '⊇',
			'&oplus;' => '⊕',
			'&otimes;' => '⊗',
			'&perp;' => '⊥',
			'&sdot;' => '⋅',
			'&loz;' => '◊',
			'&spades;' => '♠',
			'&clubs;' => '♣',
			'&hearts;' => '♥',
			'&diams;' => '♦',
			'&quot;' => '"',
			'&circ;' => 'ˆ',
			'&tilde;' => '˜',
			'&ensp;' => ' ',
			'&emsp;' => ' ',
			'&thinsp;' => ' ',
			'&zwnj;' => '‌',
			'&zwj;' => '‍',
			'&lrm;' => '‎',
			'&rlm;' => '‏',
			'&ndash;' => '–',
			'&mdash;' => '—',
			'&lsquo;' => '‘',
			'&rsquo;' => '’',
			'&sbquo;' => '‚',
			'&ldquo;' => '“',
			'&rdquo;' => '”',
			'&bdquo;' => '„',
			'&dagger;' => '†',
			'&Dagger;' => '‡',
			'&permil;' => '‰',
			'&lsaquo;' => '‹',
			'&rsaquo;' => '›',
			'&euro;' => '€',
			'&Agrave;' => 'À',
			'&Aacute;' => 'Á',
			'&Acirc;' => 'Â',
			'&Atilde;' => 'Ã',
			'&Auml;' => 'Ä',
			'&Aring;' => 'Å',
			'&AElig;' => 'Æ',
			'&Ccedil;' => 'Ç',
			'&Egrave;' => 'È',
			'&Eacute;' => 'É',
			'&Ecirc;' => 'Ê',
			'&Euml;' => 'Ë',
			'&Igrave;' => 'Ì',
			'&Iacute;' => 'Í',
			'&Icirc;' => 'Î',
			'&Iuml;' => 'Ï',
			'&ETH;' => 'Ð',
			'&Ntilde;' => 'Ñ',
			'&Ograve;' => 'Ò',
			'&Oacute;' => 'Ó',
			'&Ocirc;' => 'Ô',
			'&Otilde;' => 'Õ',
			'&Ouml;' => 'Ö',
			'&Oslash;' => 'Ø',
			'&Ugrave;' => 'Ù',
			'&Uacute;' => 'Ú',
			'&Ucirc;' => 'Û',
			'&Uuml;' => 'Ü',
			'&Yacute;' => 'Ý',
			'&THORN;' => 'Þ',
			'&szlig;' => 'ß',
			'&agrave;' => 'à',
			'&aacute;' => 'á',
			'&acirc;' => 'â',
			'&atilde;' => 'ã',
			'&auml;' => 'ä',
			'&aring;' => 'å',
			'&aelig;' => 'æ',
			'&ccedil;' => 'ç',
			'&egrave;' => 'è',
			'&eacute;' => 'é',
			'&ecirc;' => 'ê',
			'&euml;' => 'ë',
			'&igrave;' => 'ì',
			'&iacute;' => 'í',
			'&icirc;' => 'î',
			'&iuml;' => 'ï',
			'&eth;' => 'ð',
			'&ntilde;' => 'ñ',
			'&ograve;' => 'ò',
			'&oacute;' => 'ó',
			'&ocirc;' => 'ô',
			'&otilde;' => 'õ',
			'&ouml;' => 'ö',
			'&oslash;' => 'ø',
			'&ugrave;' => 'ù',
			'&uacute;' => 'ú',
			'&ucirc;' => 'û',
			'&uuml;' => 'ü',
			'&yacute;' => 'ý',
			'&thorn;' => 'þ',
			'&yuml;' => 'ÿ',
			'&OElig;' => 'Œ',
			'&oelig;' => 'œ',
			'&Scaron;' => 'Š',
			'&scaron;' => 'š',
			'&Yuml;' => 'Ÿ',
			'&Alpha;' => 'Α',
			'&Beta;' => 'Β',
			'&Gamma;' => 'Γ',
			'&Delta;' => 'Δ',
			'&Epsilon;' => 'Ε',
			'&Zeta;' => 'Ζ',
			'&Eta;' => 'Η',
			'&Theta;' => 'Θ',
			'&Iota;' => 'Ι',
			'&Kappa;' => 'Κ',
			'&Lambda;' => 'Λ',
			'&Mu;' => 'Μ',
			'&Nu;' => 'Ν',
			'&Xi;' => 'Ξ',
			'&Omicron;' => 'Ο',
			'&Pi;' => 'Π',
			'&Rho;' => 'Ρ',
			'&Sigma;' => 'Σ',
			'&Tau;' => 'Τ',
			'&Upsilon;' => 'Υ',
			'&Phi;' => 'Φ',
			'&Chi;' => 'Χ',
			'&Psi;' => 'Ψ',
			'&Omega;' => 'Ω',
			'&alpha;' => 'α',
			'&beta;' => 'β',
			'&gamma;' => 'γ',
			'&delta;' => 'δ',
			'&epsilon;' => 'ε',
			'&zeta;' => 'ζ',
			'&eta;' => 'η',
			'&theta;' => 'θ',
			'&iota;' => 'ι',
			'&kappa;' => 'κ',
			'&lambda;' => 'λ',
			'&mu;' => 'μ',
			'&nu;' => 'ν',
			'&xi;' => 'ξ',
			'&omicron;' => 'ο',
			'&pi;' => 'π',
			'&rho;' => 'ρ',
			'&sigmaf;' => 'ς',
			'&sigma;' => 'σ',
			'&tau;' => 'τ',
			'&upsilon;' => 'υ',
			'&phi;' => 'φ',
			'&chi;' => 'χ',
			'&psi;' => 'ψ',
			'&omega;' => 'ω',
			'&#160;'  => ' ',
		);
		return strtr($str, $cvt);
	}
}
