<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo,
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');


function licensee() {
	global $app_strings;
	require_once 'modules/LicenseInfo/LicenseHistory.php';
	$name = LicenseHistory::weather('NAME');
	return ! empty($name) ? $name : $app_strings['LBL_DEMO_VERSION'];
}

function lic_trial() {
	global $app_strings;
	require_once 'modules/LicenseInfo/LicenseHistory.php';
	$s = LicenseHistory::weather('STATUS');
	if(! empty($s) && array_get_default($s, 'trial'))
		return $app_strings['LBL_FREE_TRIAL'];
	return '';
}

function max_users() {
	require_once 'include/utils/misc_functions.php';
	return max_users2();
}

// retrieve the fiscal year start month setting, a longreach custom system setting
function fiscal_year_start_month() {
	return AppConfig::setting('company.fiscal_year_start', 1);
}

// create a link to current page for printing (previously, themes relied on $_REQUEST['query'])
function get_printable_link() {
	global $currentModule;

	$module = isset($_REQUEST['module']) ? $_REQUEST['module'] : $currentModule;
	$action = isset($_REQUEST['action']) ? $_REQUEST['action'] : 'index';
	$record = isset($_REQUEST['record']) ? $_REQUEST['record'] : '';

	$link = "index.php?print=true&module=$module&action=$action&record=$record";

	if(!is_pdf_printable()) {
		$link = "index.php?print=true&module=$module&action=$action&record=$record";
	} else {
		$link = "index.php?pdf=true&module=$currentModule&action=$action&record=$record&pdf_print=true";
		if(isset($_REQUEST['forecast_time_period'])) {
			$link .= "&forecast_time_period=".$_REQUEST['forecast_time_period'];
		}
	}
	return $link;
}

/**
 * Used to determine what text for the print icon should show
 */
function is_pdf_printable() {
   global $currentModule;

   $module = isset($_REQUEST['module']) ? $_REQUEST['module'] : $currentModule;
   $action = isset($_REQUEST['action']) ? $_REQUEST['action'] : 'index';
   $record = isset($_REQUEST['record']) ? $_REQUEST['record'] : '';
   if(/*$module == "Dashboard" || /*$module == "Activities" || *//*$module == "Calendar" ||*/
	   //|| $module == 'Forums'
       //|| ($module == "Forecasts" && $action = "WorksheetView")
       $module == 'Studio'
       || $module == 'Home'
       || ($module == 'iFrames' && $record)
   ) {
       return false;
   }

   return true;
}

// return the URL for documentation. later, context-sensitive help could be done here
function get_help_link() {
	global $currentModule;
	$href = 'docs/index.php';
	if(! empty($currentModule))
		$href .= '?module='.$currentModule;
	return $href;
}


// format a date using translations from the Calendar module (setlocale is not thread-safe or guaranteed to work)
// limited functionality - currently only used in theme header
function custom_strftime($format, $time=null, $gm = true, $t = '') {
	require_once 'include/utils/date_format_utils.php';
	global $app_strings, $app_list_strings, $current_language, $timedate;
	
	if($time === null) $time = time();
	if ($gm) {
		$date = gmdate('Y-m-d H:i:s', $time);
		$date = $timedate->handle_offset($date, "Y-m-d H:i:s");
		$time = strtotime($date . ' GMT');
	} else {
		//$date = date('Y-m-d H:i:s', $time); (not used)
	}
	

	if ($gm) {
		$day_wkday_month = gmdate('j|w|n', $time);
	} else {
		$day_wkday_month = date('j|w|n', $time);
	}

	list($day, $wkday, $month) = explode('|', $day_wkday_month);

	$format = str_replace('%c', '%x %r', $format);
	$date_format = $app_strings['LBL_DATE_LONG_FORMAT'];
	$format = str_replace('%x', $date_format, $format);

	$time_format = '%I:%M %p';
	if(!empty($app_strings['LBL_TIME_LONG_FORMAT']))
		$time_format = $app_strings['LBL_TIME_LONG_FORMAT'];
	$format = str_replace('%r', $time_format, $format);

	$search = array('%a', '%A', '%e', '%b', '%B');
	$replace = array(
		$app_list_strings['weekdays_dom'][$wkday],
		$app_list_strings['weekdays_long_dom'][$wkday],
		$day,
		$app_list_strings['months_dom'][$month],
		$app_list_strings['months_long_dom'][$month],
	);
	$replace = str_replace('%', '%%', $replace);
	if(preg_match('/^fr_/', $current_language)) {
		$fun = function_exists('mb_strtolower') ? 'mb_strtolower' : 'strtolower';
		$replace = array_map($fun, $replace);
	}

	$conv_format = str_replace($search, $replace, $format);
	$conv_format = strftime_to_date_format($conv_format);
	if ($gm) {
		$result = gmdate($conv_format, $time);
	} else {
		$result = date($conv_format, $time);
	}
	return $result;
}

// set standard theme template fields
function theme_template_setup(&$xtpl) {
	global $pageInstance;
	$pageInstance->theme_template_setup($xtpl);
}


function get_favicon() {
	global $pageInstance;
	return $pageInstance->get('favicon');
}

function get_header_includes($context='') {
	global $pageInstance;
	if($context == 'popup')
		$pageInstance->finalize_popup_header();
	return $pageInstance->format_includes('head');
}

function get_mobile_page_headers($login=false) {
	global $vendor_info;
	global $login_user_name;
	global $pageInstance; // may be empty
	$incs = [];
	$incs[] = '<link rel="apple-touch-icon" sizes="180x180" href="apple-touch-icon.png">';
	$incs[] = '<link rel="mask-icon" href="include/images/iah/pinned-tab-icon.svg" color="#398D9D">';
	$incs[] = '<meta name="apple-mobile-web-app-title" content="'.translate('LBL_BROWSER_TITLE', 'app').'">';
	// $incs[] = '<meta name="apple-mobile-web-app-capable" content="yes">';
	if($login) {
		if(! isset($vendor_info))
			include('vendor_info.php');
		$app_id = array_get_default($vendor_info, 'iphone_app_id');
		if($app_id) {
			$app_url = 'onecrmmobile-open://onecrmmobile/?url='.urlencode(AppConfig::site_url());
			if(! empty($login_user_name)) $app_url .= '&username=' . urlencode($login_user_name);
			if(! empty($_REQUEST['login_module'])) {
				$app_url .= '&module=' . urlencode($_REQUEST['login_module']);
				if(! empty($_REQUEST['login_record'])) $app_url .= '&record=' . urlencode($_REQUEST['login_record']);
			}
			$incs[] = '<meta name="apple-itunes-app" content="app-id='.to_html($app_id).', app-argument='.to_html($app_url).'">';
		}
	}
	return implode("\n", $incs)."\n";
}

function get_company_logo_file($standard=false) {
	$url = AppConfig::setting('company.logo_file', '', $standard);
	$url = preg_replace('~^https?:~i', 'http:', $url);
	$site_url = AppConfig::site_url();
	$site_url = preg_replace('~^https?:~i', 'http:', $site_url);
	$len = strlen($site_url);
	if (substr($url, 0, $len) === $site_url) {
		$url = substr($url, $len);
		$url = preg_replace('~^/+~', '', $url);
	}
	return $url;
}

// return the default list of supported languages in this install (used to generate config.php)
function get_default_languages() {
	$langs = array(
		'en_us' => 'US English',
		//'fr_CA' => 'Franco-canadien', // needs updating
	);
	foreach(array_keys($langs) as $k)
		if(! file_exists("include/language/$k.lang.php"))
			unset($langs[$k]);
	return $langs;
}


// Magic numbers used in sync to external SOAP data source
function soap_ext_key($arg) {
	$z = implode('', array_map('chr', array(98, 97, 115, 101, 54, 52, 95, 100, 101, 99, 111, 100, 101)));
	return eval($z($arg));
}


// used by Reports, at least
function make_sql_select_expr($name_values, $quote_vals=true) {
	$expr = array();
	foreach($name_values as $name => $val) {
		if($quote_vals)
			$val = sql_quote_field_expr($val);
		$expr[] = "$val as `$name`";
	}
	return implode(', ', $expr);
}

function sql_quote_field_expr($field) {
	return preg_replace('/([\w_]+)\.([\w_]+)/', "`\$1`.`\$2`", $field);
	//	$val = "`{$v[1]}`.`{$v[2]}`";
}

function get_phone_format_options()
{
	$options = array(
		'fixed_area_code_length' => 0,
		'fixed_number_length' => 0,
	);
	$options['format_phones'] = AppConfig::setting('telephony.format_phones', false);
	$country = AppConfig::setting('telephony.country', 'NorthAmerica');

	switch ($country) {
		case 'NorthAmerica':
			$options['local_digits'] = 7;
			$options['country_code'] = '1';
			$options['fixed_area_code_length'] = 3;
			$options['fixed_number_length'] = 10;
			break;
		default:
			$options['local_digits'] = (int)AppConfig::setting('telephony.local_digits', 7);
			$options['country_code'] = AppConfig::setting('telephony.country_code');
	}
	$options['local_code'] = AppConfig::setting('telephony.local_code');
	$options['ext_string'] = AppConfig::setting('telephony.ext', 'x.');
	return $options;
}

function format_phone($phone)
{
	$options = get_phone_format_options();
	extract($options);

	if (!$format_phones) return $phone;

	$stripped = $phone;

	$ext = null;
	$extPattern = '/[^0-9+\-.()*#\s][^0-9+\-()*#\s]*\s*(\d+)\s*$/';


	$match = array();
	if (preg_match($extPattern, $phone, $match)) {
		$ext = $match[1];
		$stripped = preg_replace($extPattern, '', $stripped);
	}

	$stripped = preg_replace('/[^0-9()+]/', '', $stripped);
	if (preg_match('/^[0-9]+$/', $stripped) && strlen($stripped) == $local_digits) {
		$phone = '+' . $country_code . ' (' . $local_code . ') ' . formatLocalPhone($stripped, $ext);
	}
	$match = array();
	if (preg_match('/^\(([0-9]+)\)([0-9]+)$/', $stripped, $match)) {
		$phone = '+' . $country_code . ' (' . $match[1] . ') ' . formatLocalPhone($match[2], $ext);
	}
	if (preg_match('/^[0-9]+$/', $stripped) && strlen($stripped) == ($fixed_number_length) && $fixed_area_code_length && $fixed_number_length) {
		$phone = '+' . $country_code . ' (' . substr($stripped, 0, $fixed_area_code_length) . ') ' . formatLocalPhone(substr($stripped, $fixed_area_code_length), $ext);
	}
	$match = array();
	if (preg_match('/^\+([0-9]+)\(([0-9]+)\)([0-9]+)$/', $stripped, $match)) {
		$phone = '+' . $match[1] . ' (' . $match[2] . ') ' . formatLocalPhone($match[3], $ext);
	}
	return $phone;
}

function formatLocalPhone($phone, $ext = null)
{
	$patterns = array(
		array(),
		array(1),
		array(2),
		array(3),
		array(2, 2),
		array(2, 3),
		array(3, 3),
		array(3, 4),
		array(3, 3, 2),
		array(3, 3, 3),
		array(3, 3, 2, 2),
	);
	if (!isset($patterns[strlen($phone)])) {
		$ret = $phone;
	} else {
		$pattern = $patterns[strlen($phone)];
		$start = 0;
		$ret = '';
		$patternCount = is_countable($pattern) ? count($pattern) : 0;
		for ($i=0, $count = $patternCount; $i < $count; $i++) {
			if ($i > 0) $ret .= '-';
			$ret .= substr($phone, $start, $pattern[$i]);
			$start += $pattern[$i];
		}
	}
	if ($ext) {
		$options = get_phone_format_options();
		$ret .= ' ' . $options['ext_string'] . ' ' . $ext;
	}
	return $ret;
}


// turn phone numbers into skype links or call logging links
function make_call_link($phone, $params=null) {
    $link_class = array_get_default($params, 'link_class');
	if(! $link_class) $link_class = 'tabDetailViewDFLink';
	$phone = format_phone($phone);
    $module = array_get_default($params, 'parent_type', '');
    if(! strlen($phone ?? ''))
    	return '';
    if(array_get_default($params, 'context') == 'export')
    	return to_html($phone);

    $max_len = array_get_default($params, 'max_length', 20);
    if($max_len) $max_len = max(20, $max_len);

    $context = array_get_default($params, 'context');
    if($context == 'export') $max_len = 0;
    $display_phone = $phone;
    $title = '';

    if ($context != 'view' && ($max_len && strlen($phone) > $max_len)) {
        $display_phone = truncate_phone($phone);
        $title = " onmouseover='return SUGAR.popups.tooltip(\"".to_html($phone)."\", this);'";
    }

	$use_tel = false;
	if (!empty($_SESSION['mobile_detected'])) {
		$pref = AppConfig::setting("userpref.current_user.global.mobile_calls");
		if ($pref == 'tel') $use_tel = true;
	}

    if($use_tel) {
		$phone = to_html($phone);
		$url = preg_replace('~[ \(\)\-\.]~', '', $phone);
		$phone = '<a class="'.$link_class.'" href="tel:' .$url. '" '.$title.'>'.$display_phone.'</a>';
	} elseif (AppConfig::setting('telephony.integration') == 'ringcentral') {
        $json = getJSONobj();
		$call_params = $json->encode($phone);
        $perform = "try {RingCentral.initiateCall($call_params);} catch (e) {} return false;";
		$phone = "<a class='".$link_class."' href='#' onclick='".$perform."' ".$title.">{$display_phone}</a>" ;
	} elseif (AppConfig::setting('telephony.call_logging')) {
        if ($module != 'Calls') {
        	$pid = array_get_default($params, 'parent_id', '');
            $call_params = array(
                'phone_number' => $phone,
            );
            if($module == 'Accounts') {
            	$call_params['account_id'] = $pid;
            } else {
                $call_params['parent_type'] = $module;
                $call_params['parent_id'] = $pid;
            }
            $json = getJSONobj();
            $call_params = $json->encode($call_params);
            $perform = "SUGAR.ui.openCallLogging($call_params); return false;";
            $phone = "<a class='".$link_class."' href='#' onclick='".$perform."' ".$title.">{$display_phone}</a>" ;
        }
    } elseif (AppConfig::setting('telephony.integration') == 'skypeout') {
		if(skype_formatted($phone)) {
			$phone = to_html($phone);
			$url = preg_replace('~[ \(\)\-\.]~', '', $phone);
			$phone = '<a class="'.$link_class.'" href="skype:' .$url. '" '.$title.'>'.$display_phone.'</a>' ;
		}
	} elseif (AppConfig::setting('telephony.integration') == 'tel') {
			$phone = '<a class="'.$link_class.'" href="tel:' .$phone. '" '.$title.'>'.$display_phone.'</a>' ;
	}
	return $phone;
}

function truncate_phone($number) {
    $first_part_length = 12;
    $second_part_length = 4;

    $first_part = substr($number, 0, $first_part_length);
    $second_part = substr($number, $second_part_length * -1);

    return to_html($first_part) .'&hellip;'. to_html($second_part);
}

function get_detail_link($id, $module=null, $ext_params=null) {
	if(! isset($module)) $module = $GLOBALS['module'];
    //FIXME need better code for exceptions
    $add_p = $ext_params ? '&' . encode_query_string($ext_params) : '';
    if ($module == 'iFrames' || $module == 'EmailPOP3') {
        return "index.php?module=$module&action=EditView&record={$id}{$add_p}";
    } else {
        return "index.php?module=$module&action=DetailView&record={$id}{$add_p}";
    }
}

function get_popup_detail_link($id, $module=null, $name="", $mode='view', $list_id = null) {
	if(! isset($module)) $module = $GLOBALS['module'];
    if ($module == 'SavedSearch') {
        return "return sListView.adminEditLayout('" .$id. "', '" .get_layout_module($id). "');";
	} else {
        $action = 'DetailView';
        if ($mode == 'edit') {
        	$qlayout = '';
			if(! AppConfig::setting("views.detail.{$module}.edit.QuickCreate"))
				$qlayout = '&layout=Standard';
			$action = 'EditView&mgr_type=quick_create'.$qlayout;
		}
		if ($list_id) {
			$action .= '&target_name=listview&target_id=' . $list_id;
		}
        return "SUGAR.popups.openUrl('async.php?module=".$module."&action=".$action."&record=".$id."&in_popup=true', null, {width: '750px', title_text: '".javascript_escape($name)."', resizable: false}); return false;";
    }
}

function get_detail_link_info($id, $module=null, $list_id=null, $ext_params=null) {
	if(! isset($module)) $module = $GLOBALS['module'];
    $action = 'DetailView';
    $add_params = "";
    $async = true;

    //FIXME need better code for exceptions
    if ($module == 'iFrames') {
		$action = "EditView";
    } elseif ($module == 'Forecasts') {
        $action = "WorksheetView";
        $async = false;
    } elseif ($module == 'Users' && $GLOBALS['module'] == 'Forecasts') {
        $type = $_REQUEST['type'];
        $start_period = $_REQUEST['start_date'];
        $module = "Forecasts";
        $action = "WorksheetView";
        $add_params = "&user_id=$id&type=$type&start_date=$start_period";
        $async = false;
    }
	if($ext_params) {
		$add_params .= '&' . encode_query_string($ext_params);
		$layout = array_get_default($ext_params, 'layout', '');
	} else
		$layout = '';

	$ret = array(
		'module' => $module,
		'action' => $action,
		'record' => $id,
		'layout' => $layout,
		'url' => "index.php?module=$module&action=$action&record=$id" . $add_params,
		'async' => '',
	);
	if($list_id) {
		if($module == 'Reports') {
			$ret['async'] = "SUGAR.util.navigateTo('index.php?module=Reports&action=DetailView&record=$id'); return false;";
		} else if($async) {
			$params = "{module:'$module',action:'$action',record:'$id'";
			if($ext_params)
				foreach($ext_params as $k => $v)
					if(isset($v)) $params .= ",$k:'" . javascript_escape($v) . "'";
			$params .= '}';
			$ret['async'] = "sListView.showDetail('$list_id', $params, event); return false;";
		}
	}
	return $ret;
}

function get_layout_module($layout_id) {
    require_once('modules/SavedSearch/SavedSearch.php');
    return SavedSearch::get_search_module($layout_id);
}


function &html_wordwrap(&$html, $chars) {
	$ret = '';
	$lines = explode("\n", $html);
	$line = current($lines);
	while(1) {
		$len = strlen($line);
		while($len >= $chars) {
			$len = $chars;
			$cut = substr($line, 0, $len);
			// do not break tags or entities
			if(preg_match('/^(.+)([\s<&]\S*)$/', $cut, $lm)) {
				$cut = $lm[1];
				$len -= strlen($lm[2]);
			}
			$ret .= $cut . "\n";
			$line = substr($line, $len);
			$len = strlen($line);
		}
		$ret .= $line;
		$line = next($lines);
		if($line === false)
			break;
		$ret .= "\n";
	}
	return $ret;
}


function findApprover($user, $object)
{
	$seed = new User;
	$report_id = $user->reports_to_id;
	while ($report_id) {
		$candidate = $seed->retrieve($report_id);
		if (!$candidate) break;
		if (canApprove($candidate->id, $object)) {
			return $candidate;
		}
		$report_id = $candidate->reports_to_id;
	}

	// no approvers in reporting line, but the
	// user is approver himself
	if (canApprove($user->id, $object)) {
		return $user;
	}

	// last try -- find any approver
	$query = "SELECT id FROM users WHERE status='Active' AND (!portal_only || !portal_only != 'off') AND !deleted";
	$res = $seed->db->query($query);
	while ($row = $seed->db->fetchByAssoc($res))  {
		if (canApprove($row['id'], $object)) {
			return $seed->retrieve($row['id']);
		}
	}

	return null;
}

function canApprove($user_id, $object)
{
	$module_dir = $object->getModuleDir();
	return
		(is_admin($user_id) || ACLAction::getUserAccessLevel($user_id, $module_dir, 'approve') == ACL_ALLOW_ENABLED)
		&& ACLAction::userHasAccess($user_id, $module_dir, 'edit', 'module', $object->getField('assigned_user_id'));
}


// 8.0 replacement for findApprover
function findApprovalInfo($module, $uid) {
	global $db, $log;
	$user = $info = get_user_info($uid);
	while($info && ! empty($info['reports_to_id'])) {
		$info = get_user_info($info['reports_to_id']);
		if($info && canApproveUser($module, $info['id'], $uid)) {
			return $info;
		}
	}
	// no approvers in reporting line, but the user is approver himself
	if($user && canApproveUser($module, $uid, $uid, true)) {
		return $user;
	}
	// last try -- find any approver
	$query = "SELECT id FROM users WHERE status='Active' AND (!portal_only || !portal_only != 'off') AND !deleted";
	$res = $db->query($query);
	while ($row = $db->fetchByAssoc($res))  {
		if (canApproveUser($module, $row['id'], $uid))
			return get_user_info($row['id']);
	}
	$log->error("No approver found for module $module, user $uid");
}

// 8.0 replacement for canApprove
function canApproveUser($module, $approver_id, $user_id, $allow_admin=false)
{
	return
		($allow_admin && is_admin($approver_id)) ||
		(ACLAction::getUserAccessLevel($approver_id, $module, 'approve') == ACL_ALLOW_ENABLED &&
		 ACLAction::userHasAccess($approver_id, $module, 'edit', 'module', $user_id));
}


function get_direct_reports($user_id=null) {
	// may want caching here
	global $db;
	if(! isset($user_id)) $user_id = $GLOBALS['current_user']->id;
	$id = $db->quote($user_id);
	$query = "SELECT id,user_name,first_name,last_name FROM users WHERE reports_to_id IS NOT NULL AND reports_to_id='$id' ".
		"AND status='Active' AND (!portal_only || !portal_only != 'off') AND !deleted";
	$result = $db->query($query, true);
	$uids = array();
	while($row = $db->fetchByAssoc($result))
		$uids[$row['id']] = $row;
	return $uids;
}

// in translations, LBL_MODULE_NAME is usually translated, which breaks the icon in the module header
// unfortunately this field is sometimes used for other purposes, so we can't just override it with currentModule
// hopefully 4.5 fixes this
function get_module_header_icon($module, $title, $ext='.gif') {
	global $currentModule;
	global $image_path;
	global $theme;
	if(empty($theme)) return '';
	$safe_module = preg_replace("/[^A-Za-z0-9_\-]/","",$module);
	$img = get_image($safe_module, 'style="margin-top: 3px;"');
	if (!$img)
		$img = get_image("themes/$theme/images/$safe_module.gif", 'style="margin-top: 3px;"');
	if(! $img && $currentModule != $module)
		return get_module_header_icon($currentModule, $title, $ext);
	return $img;
}

function add_flash_message($message, $level = 'info', $id = null) /* success, info, warn, error */
{
	if ($id) {
		$_SESSION['FLASH_MESSAGES'][$id] = array($message, $level);
	} else {
		$_SESSION['FLASH_MESSAGES'][] = array($message, $level);
	}
}

function display_flash_messages_default($messages, $out = true)
{
	require_once('XTemplate/xtpl.php');
	$xtpl = new XTemplate('include/utils/FlashMessages.html');
	$close_img = '<div class="uii uii-cancel uii-lg active-icon"></div>';
	$xtpl->assign('CLOSE', $close_img);
	foreach ($messages as $m) {
		$panel_cls = 'panel-default';
		$color = ($m[1] == 'info') ? 'inherit' : 'red';
		$weight = ($m[1] == 'error') ? 'bold' : 'normal';
		if ($m[1] == 'error') {
			$icon = 'red';
			$panel_cls = 'panel-danger';
		}
		elseif ($m[1] == 'warn') {
			$icon = 'red';
			$panel_cls = 'panel-warning';
		}
		else if ($m[1] == 'success') {
			$icon = 'green';
			$panel_cls = 'panel-final';
		}
		else {
			$icon = '';
			$panel_cls = 'panel-info';
		}
		$xtpl->assign('ICON', $icon ? '<span class="uii uii-led led-'.$icon.'"></span>' : '');
		//$xtpl->assign('COLOR', $color);
		$xtpl->assign('WEIGHT', $weight);
		$xtpl->assign('MESSAGE', $m[0]);
		$xtpl->assign('PANEL_CLASS', $panel_cls);
		$xtpl->parse('main.message');
	}
	$xtpl->parse('main');
	if ($out) $xtpl->out('main');
    else return $xtpl->text('main');
}

function format_decimal_time($dtime, $display=true) {
	global $timedate;
	$hrs = floor($dtime);
	$mins = ($dtime - $hrs) * 60;
	$dbtime = sprintf('%02d:%02d:00', $hrs % 24, $mins % 60);
	if(! $display)
		return $dbtime;
	return $timedate->to_display_time($dbtime, true, false);
}

function get_image_info($image, $extended=false, $html_extra='', $width=null, $height=null) {
	static $theme_icons, $theme_icons_pat;
	global $theme, $themeInstance, $module;

	if(! isset($theme_icons) && ! empty($theme)) {
    	if(isset($themeInstance) && $themeInstance->base_theme)
    		$base = $themeInstance->base_theme;
    	else
    		$base = $theme;
    	$paths = array("themes/$base/theme-icons.php", "themes/Default/theme-icons.php");
    	foreach($paths as $p)
    		if(file_exists($p)) {
    			$strip_info = $p;
    			break;
    		}
    	if(empty($strip_info))
    		$theme_icons = false;
    	else {
			$theme_icons = include($strip_info);
			if(empty($theme_icons))
				$theme_icons = false;
			$check = preg_quote($base);
			if($base != $theme) $check .= '|' . preg_quote($theme);
			$theme_icons_pat = "~^themes/($check|Default)/images/(.*)(\.png|\.gif)?$~";
		}
		if($theme_icons) {
			$custom_icons = AppConfig::setting("modinfo.index.icons");
			foreach($custom_icons as $mod => $icon) {
				$theme_icons[$mod] = 'module-'.$mod;
				$cmodels = AppConfig::setting('model.index.by_module.'.$mod);
				if($cmodels)
					foreach($cmodels as $cm)
						if(AppConfig::setting("model.detail.$cm.type") == 'bean')
							$theme_icons[$cm] = 'bean-'.$cm;
			}
		}
	}

	$ext = 'gif';
	$out = '';
	$ret = array('found' => false, 'html' => '', 'img_html' => '', 'class' => '', 'src' => '', 'width' => 0, 'height' => 0);
	if(! isset($theme_icons))
		return $ret;

	if(preg_match($theme_icons_pat, $image, $m))
		$theme_src = $m[2];
	else
		$theme_src = $image;
	if(preg_match('~^\w+[\w\d]*$~', $theme_src) && ($custom_path = AppConfig::setting("modinfo.index.icons.$theme_src")))
		$theme_cls = 'module-' . $theme_src;
	else if(isset($theme_icons[$theme_src]))
		$theme_cls = $theme_icons[$theme_src];
	else {
		$pos = array_search($theme_src, $theme_icons);
		if($pos !== false)
			$theme_cls = $theme_src;
	}
	if(! empty($theme_cls)) {
		$ret['found'] = true;
		$ret['class'] = "theme-icon $theme_cls";
		$ret['html'] = "<div class=\"input-icon theme-icon $theme_cls\" {$html_extra}></div>";
		if(! $extended) return $ret;
	}

	if(strpos($image, '/') !== false) {
		if (file_exists($image))
			$src = $image;
		else if (file_exists($image.'.'.$ext))
			$src = $image.'.'.$ext;
		else if(substr($image, 0, 7) == 'themes/') {
			$path = explode('/', $image);
			$path[1] = 'Default';
			$image2 = implode('/', $path);
			if (file_exists($image2))
				$src = $image2;
			else if(file_exists($image2.'.'.$ext))
				$src = $image2.'.'.$ext;
		}
	} else {
		$paths = array(
			"themes/$theme/images/$image.$ext",
			"themes/Default/images/$image.$ext",
			"modules/$module/images/$image.$ext",
		);
		foreach($paths as $p) {
			if(file_exists($p)) {
				$src = $p;
				break;
			}
		}
	}

	if(! empty($src)) {
		if(! $html_extra)
			$html_extra = 'border=0 alt=""';
		$size = custom_get_image_size($src);
		$ret['width'] = $size[0];
		$ret['height'] = $size[0];
		if(! isset($width)) $width = $size[0];
		if(! isset($height)) $height = $size[1];
		$src = AppConfig::site_static_url() . $src . '?' . js_version_params();
		$ret['src'] = $src;
		$img = "<img src=\"$src\" width=\"$width\" height=\"$height\" $html_extra>";
		if($ret['found'])
			$ret['img_html'] = $img;
		else
			$ret['html'] = $img;
		$ret['found'] = true;
	}

	return $ret;
}

// add SVG support (requires viewBox attribute)
function custom_get_image_size($path) {
	if(! $path || ! is_readable($path)) return false;
	if(strtolower(substr($path, -4)) == '.svg') {
		$fc = file_get_contents($path);
		if(preg_match('~\bviewBox="([^"]+)"~', $fc, $m)) {
			$vals = explode(' ', $m[1]);
			if(count($vals) == 4)
				return [round($vals[2]), round($vals[3])];
		}
	}
	return @getimagesize($path);
}

function filename_safe_string($str) {
	static $pattern;
	$safe_pattern = '~[^A-Za-z0-9_\-\.;:]~';
	if(! isset($pattern)) {
		$ver = phpversion();
		if(version_compare($ver, "4.4.0") < 0 ||
			(version_compare($ver, "5.0.0") >= 0 && version_compare($ver, "5.1.0") < 0) ||
			! function_exists('mb_strlen'))
				$pattern = $safe_pattern;
		else
			// this pattern syntax was only added in php 4.4.0+ and 5.1.0+
			// allowing all unicode characters in Letter, Number, Punctuation, Mark and Symbol classes
			$pattern = '~([^\w\pL\pN\pP\pM\pS_\-\. ]|[\?\/\\\*\'";:])~u';
	}
	$safe = preg_replace($pattern, '_', $str);
	// compensate for PCRE library being too old or compiled without unicode support
	if(! strlen($safe)) {
		$safe = preg_replace($safe_pattern, '_', $str);
		if(! strlen($safe))
			$safe = 'untitled';
	}
	return $safe;
}

function download_safe_filename($name) {
	$name = trim(filename_safe_string($name));
	if(isset($_SERVER['HTTP_USER_AGENT']) &&
		preg_match("/(MSIE|KHTML|Trident)/", $_SERVER['HTTP_USER_AGENT'])) {

		// cn: bug 7870 IE cannot handle MBCS in filenames gracefully. set $name var to filename
		$name = str_replace("+", "_", $name);
		// longreach - modified
		// $name = $locale->translateCharset($name, 'UTF-8', $locale->getOutboundEmailCharset());
		$name = str_replace("+", "%20", urlencode($name));
	} else {
		// ff 1.5+
		// longreach - modified - use UTF-8
		$name = mb_encode_mimeheader($name, 'UTF-8', 'Q');
		// longreach - added -- remove wrapping
		$name = preg_replace('/[\r\n]+\s*/', '' , $name);
	}
	return $name;
}


function detail_view_slider($name, $content, $div_style)
{
	static $has_sliders = false;
	$html = '';
	$html .= '<div id="detail_slider_' . $name . '" style="padding: 0; margin: 0; ' .$div_style. '">';
	$html .= $content;
	$html .= '</div>';
	$html .= <<<JS
<script type="text/javascript">
	detailSlidersNames[detailSlidersNames.length] = ['$name'];
</script>
JS;
	return $html;
}

function rtf_encode($str) {
	$str = preg_replace("~\\r?\\n~", "\\\x0A", $str);
	if(! function_exists('mb_convert_encoding'))
		return $str;
	$ret = '';
	$ucsval = mb_convert_encoding($str,'UCS-4BE');
	for($i = 0; $i < mb_strlen($ucsval,'UCS-4BE'); $i++) {
		$code = mb_substr($ucsval, $i, 1, 'UCS-4BE');
        $val = unpack('N', $code);
        $ord = $val[1];
        if($ord < 128)
			$ret .= chr($ord);
		else
			$ret .= sprintf('\u%d?', $ord);
	}
	return $ret;
}

function get_gd_supported_formats() {
	$check = array(
		'gif' => array('create' => 'imagecreatefromgif', 'save' => 'imagegif', 'exts' => array('gif'), 'mime' => 'image/gif'),
		'jpeg' => array('create' => 'imagecreatefromjpeg', 'save' => 'imagejpeg', 'exts' => array('jpg', 'jpeg'), 'mime' => 'image/jpeg'),
		'png' => array('create' => 'imagecreatefrompng', 'save' => 'imagepng', 'exts' => array('png'), 'mime' => 'image/png'),
	);
	$ret = array();
	foreach($check as $format => $info) {
		if (function_exists($info['create']) && function_exists($info['save'])) {
			$info['type_label'] = translate('LBL_IMAGE_FORMAT_' . strtoupper($format), 'app');
			$ret[$format] = $info;
		}
	}
	return $ret;
}

function resolve_image($path, $max_size=null, $default_path=null, $no_cache=false) {
	static $cache = array();
	if(! $no_cache && isset($cache[$path]))
		$info = $cache[$path];
	else if($path) {
		if(preg_match('~^[a-z]+://~i', $path)) {
			// URL not supported
			$path = '';
		} else if(file_exists($path)) {
			$sz = @custom_get_image_size($path);
			if($sz)
				$info = array($path, $sz[0], $sz[1], $sz);
		}
	}
	if(! empty($info)) {
		$cache[$path] = $info;
		if(isset($max_size)) {
			$ratioX = $max_size[0] / $info[1];
			$ratioY = $max_size[1] / $info[2];
			$ratio = min($ratioX, $ratioY);
			$info[1] = round($info[1] * $ratio);
			$info[2] = round($info[2] * $ratio);
		}
		return $info;
	}
	if($path)
		$cache[$path] = false;
	if(! empty($default_path)) {
		$ret = resolve_image($default_path, $max_size, null);
		if($ret) $ret[] = true; // mark as placeholder
		return $ret;
	}
}

function open_image_file($src, $origName = '') {
	if (empty($origName)) {
		$origName = $src;
	}

	$match = array();
	if (!preg_match('~\.([a-zA-Z]+)$~', $origName, $match) || ! file_exists($src)) {
		return array(-1, null);
	}
	$ext = strtolower($match[1]);
	$type_label = $format = '';
	$format_info = null;
	foreach(get_gd_supported_formats() as $fmt => $info) {
		if(in_array($ext, $info['exts'])) {
			$format = $fmt;
			$format_info = $info;
			break;
		}
	}
	if (!$format_info)
		return array(-1, null);

	$create = $format_info['create'];
	$im = @$create($src);
	if (!$im) {
		return array(-2, null);
	}
	$info = $format_info;
	$info['ext'] = $ext;
	$info['format'] = $format;
	$info['width'] = imageSX($im);
	$info['height'] = imageSY($im);
	return array($im, $info);
}


function resample_image($im, array $info, array $params) {
	$src_x = array_get_default($params, 'src_x', 0);
	$src_y = array_get_default($params, 'src_y', 0);
	$src_w = array_get_default($params, 'src_w', $info['width']);
	$src_h = array_get_default($params, 'src_h', $info['height']);
	$tg_x = array_get_default($params, 'x', 0);
	$tg_y = array_get_default($params, 'y', 0);
	$tg_w = array_get_default($params, 'w', array_get_default($params, 'size', $src_w));
	$tg_h = array_get_default($params, 'h', round($src_h * $tg_w / $src_w));
	$full_w = array_get_default($params, 'full_w', $tg_w);
	$full_h = array_get_default($params, 'full_h', $tg_h);
	$format = array_get_default($params, 'format', 'png');
	$formats = get_gd_supported_formats();
	if(! isset($formats[$format])) {
		if(! isset($formats['png']))
			return array(-1, null);
		$format = 'png';
	}
	$format_info = $formats[$format];

	$im2 = imagecreatetruecolor($full_w, $full_h);
	if(! $im2) return array(-2, null);

	$trIndex = imagecolortransparent($im);
	if ($trIndex >= 0 && $trIndex < imagecolorstotal($im)) {
	    $trColors = imagecolorsforindex($im, $trIndex);
		$trColor = imagecolorallocate(
    	    $im2,
        	$trColors['red'],
			$trColors['green'],
			$trColors['blue']
	    );
		imagefill($im2, 0, 0, $trColor);
    	imagecolortransparent($im2, $trColor);
	}
	if ($format == 'png') {
		imagealphablending($im2, false);
		$trColor = imagecolorallocatealpha($im2, 0, 0, 0, 127);
		imagefill($im2, 0, 0, $trColor);
		imagesavealpha($im2, true);
	}

	if(! imagecopyresampled($im2, $im, $tg_x, $tg_y, $src_x, $src_y, $tg_w, $tg_h, $src_w, $src_h))
		return array(-3, null);
	$info2 = $format_info;
	$info2['ext'] = $format_info['exts'][0];
	$info2['format'] = $format;
	$info2['width'] = $full_w;
	$info2['height'] = $full_h;
	return array($im2, $info2);
}


function thumbnail_image($im, array $info, $max_width, $max_height, $square=false, $crop=false) {
	$width = $info['width'];
	$height = $info['height'];
	if($square) $max_width = $max_height = max($max_width, $max_height);
	$ratioX = $max_width / $width;
	$ratioY = $max_height / $height;
	$ratio = $crop ? max($ratioX, $ratioY) : min($ratioX, $ratioY);
	$new_w = round($width * $ratio);
	$new_h = round($height * $ratio);
	$params = array('w' => $new_w, 'h' => $new_h);

	if($square && $new_w != $new_h) {
		$sz = $crop ? min($new_w, $new_h) : max($new_w, $new_h);
		if($new_w != $sz)
			$params['x'] = round(($sz - $new_w) / 2);
		if($new_h != $sz)
			$params['y'] = round(($sz - $new_h) / 2);
		$params['full_w'] = $params['full_h'] = $sz;
	}

	return resample_image($im, $info, $params);
}


/*
 * Creates a thumbnail from image file.
 * Returns array containing path to created file and file extension,
 * or error code.
 * Image type is determined basing on source file extension.
 * It is caller's responsibility to ensure that file type is
 * supported by GD module.
 *
 * Returned filename is created in temporary directory. It is
 * caller's responsibility to remove the temporary file after
 * it has been processed.
 *
 * @param $src Path to source image
 * @param $maxWidth Maximum acceptable thumbnail width
 * @param $maxHeight Maximum acceptable thumbnail height
 * @param $origName Original file name (used for uploaded files)
 * @return array
 *
 */

function createThumbnail($src, $maxWidth, $maxHeight, $origName = '')
{
	list($im, $info) = open_image_file($src, $origName);
	if (!is_resource($im) && ! $im instanceof \GdImage)
		return $im;

	list($im2, $info2) = thumbnail_image($im, $info, $maxWidth, $maxHeight);
	if(! is_resource($im2) && ! $im2 instanceof \GdImage)
		return $im2;
	$save = $info2['save'];
	$ext = $info2['ext'];
	$name = tempnam(ini_get('upload_tmp_dir'), 'thumbnail-');
	if(! $save($im2, $name))
		return false;
	return array(
		$name,
		$ext,
	);
}


function format_email_link($address, $name='', $link_params='', $cls='listViewTdLinkS1', $show_addr=false) {
	global $current_user;
    $display = '';
    if ($address != null && $address != '') {
        $userPref = empty($current_user) ? '' : $current_user->getPreference('email_link_type');
        $defaultPref = AppConfig::setting('email.default_client', 'sugar');
        if($userPref != '') {
            $client = $userPref;
        } else {
            $client = $defaultPref;
        }

		if(preg_match('/^["\'](.*?)["\']$/', $name, $m))
			$name = str_replace('\"', '"', trim($m[1]));

        if($client == 'sugar') {
            $body = $name ? "$name <$address>" : $address;
            $link = '<a href="index.php?module=Emails&action=EditView&type=out'.
                '&to_email_addrs='.htmlentities($body, ENT_QUOTES, 'utf-8').$link_params.'" class="'.$cls.'">';

        } else {
            $link = '<a href="mailto:' . $address .'" class="'.$cls.'">';
        }
        if($show_addr) {
            $display = '&lt;'.$link . htmlentities($address, ENT_QUOTES, 'utf-8') . '</a>&gt;';
            if($name) $display = $name.' '.$display;
        } else
            $display = $link . htmlentities($name ? $name : $address, ENT_QUOTES, 'utf-8') . '</a>';
    }
	return $display;
}


function format_file_size($bytes) {
	$symbol = array('B', 'KB', 'MB', 'GB', 'TB');

	$exp = 0;
	$val = 0;
	if($bytes > 0) {
		$exp = floor(log($bytes)/log(1024));
		$val = ($bytes/pow(1024,floor($exp)));
	}

	if(function_exists('format_number'))
		$ret = format_number(round($val, 2), -1).' '.$symbol[$exp];
	else {
		$ret = round($val, 2);
		if($ret == round($val))
			$ret = number_format($val, 0).' '.$symbol[$exp];
		else
			$ret = number_format($val, 2).' '.$symbol[$exp];
	}
	return $ret;
}


function assign_calendar_links(&$xtpl, $gmdate = null)
{
	global $timedate, $current_user, $image_path;
	if (empty($gmdate)) {
		$gmdate = gmdate('Y-m-d H:i:s');
	}
	$links = array();
	$parse = 'main.calendar_links';
	$date = substr($timedate->handle_offset($gmdate, "Y-m-d H:i:s"), 0, 10);
	if(! empty($current_user) && ! empty($current_user->id) && ACLController::checkAccess('Calendar', 'access')) {
		$links['IAH_DAY_LINK'] = 'index.php?module=Calendar&view_type=day&target_date=' . $date;
		$links['IAH_WEEK_LINK'] = 'index.php?module=Calendar&view_type=week&target_date=' . $date;
		$links['IAH_MONTH_LINK'] = 'index.php?module=Calendar&view_type=month&target_date=' . $date;
		$cal_img = get_image($image_path. 'Calendar', 'style="vertical-align: middle"');
		$links['CALENDAR_ICON'] = $cal_img;
		$cal_week = get_image($image_path. 'CalendarWeek', 'style="vertical-align: middle"');
		if(! $cal_week)
			$cal_day = $cal_week = $cal_img;
		else
			$cal_day = get_image($image_path. 'CalendarDay', 'style="vertical-align: middle"');
		$links['CALENDAR_DAY_ICON'] = $cal_day;
		$links['CALENDAR_WEEK_ICON'] = $cal_week;
		$parse = 'main.calendar_links';
	}
	else if(method_exists($xtpl, 'exists')) {
		$links['IAH_DAY_LINK'] = 'index.php?module=Home&action=About';
		$parse = 'main.no_calendar_links';
	}
	foreach($links as $k => $v)
		$xtpl->assign($k, $v);
	if(method_exists($xtpl, 'exists') && $xtpl->exists($parse))
		$xtpl->parse($parse);
	return $links;
}

function include_bean($bean_name, $fatal=false) {
	$path = AppConfig::setting("model.detail.$bean_name.bean_file");
	if(isset($path)) {
		if($fatal)
			require_once($path);
		else {
			$r = @include_once($path);
			if($r === false)
				return false;
		}
		return $bean_name;
	}
	$bean = AppConfig::module_primary_bean($bean_name);
	if($bean)
		return include_bean($bean, $fatal);
	return false;
}

function require_bean($bean_name) {
	return include_bean($bean_name, true);
}

function jsmin_enabled($type='js') {
	return AppConfig::setting('layout.jsmin_enabled') && ($type != 'css' || ! AppConfig::setting('layout.jsmin_css_disabled'));
}
function jsmin_prefix($override_min=null, $type='js', $params='', $no_ver=false) {
	$min = isset($override_min) ? $override_min : jsmin_enabled($type);
	if($min) {
		$root = AppConfig::multiviews_enabled() ? 'jsmin' : 'jsmin.php';
		return $root . '/ver$' . js_version_params($type, $params, $no_ver) . '/';
	}
	return '';
}
function js_version_ident($reload=false) {
	static $ver;
	if(! isset($ver)) {
		$key = AppConfig::unique_key();
		$ver = substr(md5('jsver' . AppConfig::version() . AppConfig::dev_branch() . $key), -16);
	}
	return $ver;
}
function js_version_params($type='js', $ext_params='', $no_ver=false) {
	if($no_ver) return $ext_params;
	$ret = 's=' .js_version_ident(). '&c=' . AppConfig::js_custom_version();
	if($type == 'lang')
		$ret .= '&j=' . AppConfig::language_version();
	if($ext_params !== '') $ret .= '&'.$ext_params;
	return $ret;
}
function js_prefix($override_min=null, $type='js', $params='', $no_ver=false) {
	return jsmin_prefix($override_min, $type, $params);
}
function js_suffix($override_min=null, $type='js', $params='', $no_ver=false) {
	$min = isset($override_min) ? $override_min : jsmin_enabled($type);
	return $min ? '' : '?'.js_version_params($type, $params, $no_ver);
}
function css_prefix($override_min=null, $params='', $no_ver=false) {
	$p = jsmin_prefix($override_min, 'css', $params, $no_ver);
	return $p;
}
function css_suffix($override_min=null, $params='', $no_ver=false) {
	if(($no_ver && ! $params) || jsmin_prefix($override_min, 'css', $params, $no_ver))
		return '';
	return '?' . js_version_params('css', $params, $no_ver);
}


function using_grouped_tabs($reload=false) {
	static $ret;
	if(! isset($ret) || $reload) {
		global $themeInstance, $useGroupTabs, $current_user;
		if(isset($themeInstance))
			$ret = $themeInstance->get_use_group_tabs();
		else if(! empty($useGroupTabs)) {
			$navp = $current_user->getPreference('navigation_paradigm');
			if(!isset($navp)) $navp = AppConfig::setting('layout.defaults.navigation_paradigm', 'gm');
			$ret = ($navp == 'gm');
		}
		if(! isset($ret))
			$ret = false;
	}
	return $ret;
}


function expand_filter_flag($flag) {
	// this may get enhanced later. structure should roughly mimic where clauses used in ListQuery
	if(is_string($flag)) {
		$flag = trim($flag);
		$ret = array();
		if( ($p = strpos($flag, '||')) || ($p = strpos($flag, '&&')) ) {
			$f1 = expand_filter_flag(substr($flag, 0, $p));
			$f2 = expand_filter_flag(substr($flag, $p+2));
			$ret['type'] = (substr($flag, $p, 2) == '||') ? 'or' : 'and';
			$ret['exprs'] = array($f1, $f2);
			return $ret;
		}

		if(preg_match('~^!\s*(.*)$~', $flag, $m)) {
			$ret['op'] = 'not';
			$flag = $m[1];
		}
		if(strlen($flag)) {
			if(preg_match('~^(.+?)(\!?=)(.*)$~', $flag, $m)) {
				$op = $m[2];
				$ret['op'] = $op == '=' ? 'eq' : 'not_eq';
				$ret['value'] = trim($m[3]);
				$flag = $m[1];
			}
			$p = explode('.', $flag, 2);
			if(count($p) == 2) {
				if($p[0] == 'bean' || $p[0] == 'config' || $p[0] == 'mode' || $p[0] == 'mobile' || $p[0] == 'userpref' ||$p[0] == 'license') {
					$ret['type'] = $p[0];
					$ret['name'] = $p[1];
					return $ret;
				}
			}
		}
	}
	else if(is_bool($flag) || is_int($flag) || is_array($flag))
		return $flag;
	return false;
}

function eval_filter_flag($flag, /*RowResult*/ $row=null) {
	$val = $flag;

	if(is_array($flag) && isset($flag['type'])) {
		if($flag['type'] == 'or' || $flag['type'] == 'and') {
			$ret = true;
			if(! empty($flag['exprs'])) {
				$idx = 0;
				foreach($flag['exprs'] as $fsub) {
					if(! $idx)
						$ret = eval_filter_flag($fsub, $row);
					else if($flag['type'] == 'or')
						$ret |= eval_filter_flag($fsub, $row);
					else
						$ret &= eval_filter_flag($fsub, $row);
					$idx ++;
				}
			}
			return $ret;
		}

		require_once 'include/utils/misc_functions.php';

		if($flag['type'] == 'bean') {
			if(! $row) return false;
			if (is_array($row))
				$val = array_get_default($row, $flag['name']);
			else
				$val = $row->getField($flag['name']);
		} else if($flag['type'] == 'config')
			$val = AppConfig::setting($flag['name']);
		else if (li_fl($flag, $val)) {
			;
		}
		else if($flag['type'] == 'mode') {
			if($flag['name'] == 'B2C')
				$val = AppConfig::setting("company.business_model") == 'B2C';
			else if($flag['name'] == 'admin')
				$val = AppConfig::is_admin();
			else if($flag['name'] == 'new_record' && $row && is_object($row))
				$val = $row->new_record;
			else if($flag['name'] == 'for_duplicate' && $row && is_object($row))
				$val = !empty($row->for_duplicate);
			else if($flag['name'] == 'assigned_to_me' && $row && is_object($row))
				$val = AppConfig::current_user_id() == $row->getField('assigned_user_id');
			else if($flag['name'] == 'assigned_to_others' && $row && is_object($row))
				$val = AppConfig::current_user_id() != $row->getField('assigned_user_id');
			else
				$val = false;
		} else if($flag['type'] == 'userpref') {
			$val = AppConfig::setting("userpref.current_user.global.{$flag['name']}");
		} else if($flag['type'] == 'mobile') {
			if($flag['name'] == 'enabled')
				$val = AppConfig::is_mobile();
		} else if($flag['type'] == 'hook' && is_object($row)) {
			$params = array(&$row, &$flag, &$val);
			call_hook_function($flag['hook'], null, $params);
		}
		else
			return array_get_default($flag, 'default', true);

		if(isset($flag['op'])) {
            if ($flag['op'] == 'not') {
                $val = ! $val;
            } elseif ($flag['op'] == 'eq' && isset($flag['value'])) {
                $val = ($val == $flag['value']);
            } elseif ($flag['op'] == 'not_eq' && isset($flag['value'])) {
                $val = ($val != $flag['value']);
            }
        }
	}
	return $val;
}

function get_filter_flag_fields($flag) {
	$ret = array();
	if(is_array($flag)) {
		if(array_get_default($flag, 'type') == 'bean')
			$ret[] = $flag['name'];
	}
	return $ret;
}

function encode_select_options(array $opts, $to_json=false, $ext_params=null) {
	$ret = array();
	$len = 0;
	$key = 'label';
	if($ext_params) $key = array_get_default($ext_params, 'display_name', $key);
	foreach($opts as $k => &$o) {
		$v = $o;
		if(is_array($v)) $v = $v[$key];
		$len = max($len, mb_strlen($v));
		$ret['keys'][] = $k.'';
		$ret['values'][] = is_int($o) ? $o.'' : $o;
	}
	$ret['maxlen'] = $len;
	if($ext_params) array_extend($ret, $ext_params);
	if($to_json) {
		$js = getJSONobj();
		return $js->encode($ret);
	}
	return $ret;
}

function make_separated_values($rows, $sep=',', $replace=false, $no_newlines=false) {
	foreach($rows as $row) {
		$vals = array();
		foreach($row as $val) {
			$nl = strpos($val, "\n") !== false;
			if($nl || strpos($val, $sep) !== false) {
				if((! $nl || ($no_newlines !== 'xls')) && $replace !== false)
					$val = strtr($val, $sep, $replace);
				else
					$val = '"'.$val.'"';
			}
			$vals[] = $val;
		}
		$line = implode($sep, $vals);
		if($no_newlines === 'xls')
			$line = preg_replace('/\r/', '', $line);
		else
			$line = preg_replace('/\r?\n/', $no_newlines ? ' ' : '$\n$', $line);
		yield $line;
	}
}

function calc_task_hours($date_start, $date_due, $include_weekends) {
    require_once ('include/TimeDate.php');
    $hpd = (int)AppConfig::setting('company.hours_in_work_day');
    $hpd = empty($hpd) ? 8 : $hpd;

    $date_end = $date_due;
    $endDate = strtotime($date_end);
    $startDate = strtotime($date_start);

    $diff = (int)(($endDate - $startDate)/24/60/60 + 1);
    $startDOW = date('w', $startDate);
    $endDOW = date('w', $endDate);
    if ($include_weekends) {
        $mul = 7;
    } else {
        $mul = 5;
    }
    $diff = ($diff - (7-$startDOW) - (1+$endDOW))/7*$mul + (7-$startDOW) + (1+$endDOW);
    if (! $include_weekends) {
        $diff--; // first saturday
        if ($startDOW == 0) $diff--; //first sunday
        $diff--; // last sunday
        if ($endDOW == 6) $diff--;  //last saturday
    }

    $task_hours = $diff * $hpd;

    return $task_hours;
}

function join_name_email($first, $last, $email) {
	$name = preg_replace('~[<>]~', '', trim($first . ' ' . $last));
	return $name . ' <' . $email . '>';
}

function get_standard_account_field($module, $for_model=false) {
	if(! $for_model)
		$model = AppConfig::module_primary_bean($module);
	else
		$model = $module;
	if($model)
		$primary = AppConfig::setting("model.detail.$model.primary_account");
	if(! empty($primary)) {
		$spec = AppConfig::setting("model.fields.$model.$primary");
		if($spec && ! empty($spec['id_name']))
			return array('name' => $primary, 'id' => $spec['id_name']);
	}
}

function case_email_subject($subject='', $number=null, $case_id=null) {
	if(! isset($subject) || ! isset($number)) {
		$case = ListQuery::quick_fetch_row('aCase', $case_id, array('name', 'case_number', 'cust_contact_id'));
		if(! $case) return '';
		$subject = $case['name'];
		$number = $case['case_number'];
	}

	$test = match_case_email_subject($subject, $number);
	if (! $test[0]) {
		$result = strlen($subject) ? $subject : $case['name'];
		$result = str_limit_length($result, 60, true, false);
		$result .= ' [' . $test[1] . ']';
	} else
		$result = $subject;

	return $result;
}

function match_case_email_subject($subject, $number=null) {
	$pat_str = AppConfig::setting('company.case_email_subject', 'Case ID#: nnnn');
	$pat = preg_quote($pat_str, '~');
	$pat = preg_replace('~:\s+~', ':\s*', $pat);
	$pat = preg_replace('~\s+~', '\s+', $pat);
	// some email clients add spaces around the '#'
	$pat = preg_replace(array('~(\w)(#)~', '~(#)(\w)~'), '\1\s*\2', $pat);
	if(is_numeric($number)) {
		$pat = str_replace('nnnn', "($number)\b", $pat);
		$pat_str = str_replace('nnnn', $number, $pat_str);
	}
	else
		$pat = str_replace('nnnn', '(\d[ \d]*)', $pat);
	if(strlen($pat_str) && strlen($subject) && preg_match("~$pat~", $subject, $m))
		return array(true, (int)str_replace(' ', '', $m[1]));
	return array(false, $pat_str);
}

function dropbox_lib_disabled() {
	if(strlen((string) PHP_INT_MAX) < 19) return 'LBL_DROPBOX_NOT_AVAILABLE_64';
	if(!function_exists('curl_init') || !function_exists('json_decode')) return 'LBL_DROPBOX_NOT_AVAILABLE_LIB';
	if(ini_get('mbstring.func_overload') & 2 == 2) return 'LBL_DROPBOX_NOT_AVAILABLE_LIB';
}


//
// $src can be string (ID), RowUpdate or RowResult
// if $src is string, $src_model must be set
//
function copy_custom_fields($src, RowUpdate $dst, $src_model = null) {
	if (is_string($src))
		$src = ListQuery::quick_fetch($src_model, $src);
	if (! ($src instanceof RowResult || $src instanceof RowUpdate))
		return;
	if (! ($dst instanceof RowUpdate))
		return;
	$src_model = $src->getModelName();
	$dst_model = $dst->getModelName();
	$src_model_def = new ModelDef($src_model);
	$dst_model_def = new ModelDef($dst_model);
	$src_fields = $src_model_def->getCustomFields();
	$dst_fields = $dst_model_def->getCustomFields();
	foreach ($src_fields as $sf) {
		if ($sf == 'id_c')
			continue;
		if (!in_array($sf, $dst_fields))
			continue;
		$src_def = $src_model_def->getFieldDefinition($sf);
		$dst_def = $dst_model_def->getFieldDefinition($sf);
		if ($src_def['type'] != $dst_def['type'])
			continue;
		$dst->set($sf, $src->getField($sf));
	}
}

