<?php

function calcf_add() {
    $num_args = func_num_args();
    $result = 0;

    for($i=0; $i < $num_args; $i++) {
    	$a = func_get_arg($i);
        if (is_numeric($a))
            $result += $a;
    }

    return $result;
}

function calcf_subtract() {
    $num_args = func_num_args();
    $result = 0;

    for($i=0; $i < $num_args; $i++) {
    	$a = func_get_arg($i);
        if (is_numeric($a)) {
        	if($i == 0)
        		$result = $a;
            else
                $result -= $a;
        }
    }

    return $result;
}

function calcf_multiply() {
    $num_args = func_num_args();
    $result = null;

    for($i=0; $i < $num_args; $i++) {
    	$a = func_get_arg($i);
        if (is_numeric($a)) {
            if ($result === null) {
                $result = $a;
            } else {
                $result *= $a;
            }
        }
        else if(! isset($a))
        	$result = 0;
    }

    if ($result == null)
        $result = 0;

    return $result;
}

function calcf_divide($a=null, $b=null) {
    $result = 0;
    if(! is_numeric($a)) $a = 0;
    if(! is_numeric($b)) $b = 0;
    if(! $b)
    	$result = null;
    else
		$result = ($a / $b);
    return $result;
}

function calcf_equal($a=null, $b=null) {
    return ($a == $b);
}

function calcf_negate($x=null) {
    $result = 0;
    if (is_numeric($x))
        $result = $x * -1;

    return $result;
}

function calcf_ifElse($c=null, $v1=null, $v2=null) {
    if ($c) {
        return $v1;
    } else {
        return $v2;
    }
}

function calcf_concat() {
    $num_args = func_num_args();
    $result = '';

    for($i=0; $i < $num_args; $i++) {
        $val = (string)func_get_arg($i);
        $result .= $val;
    }

    return $result;
}

function calcf_stringToUpper($str=null) {
    $result = strtoupper(''.$str);
    return $result;
}

function calcf_stringToLower($str=null) {
	$result = strtolower(''.$str);
    return $result;
}

// cannot be done in SQL - depends on current user setting
/*function calcf_numericFormat($num=null, $decimals=null)
{
	return format_number($num, $decimals, $decimals);
}*/

function calcf_strlen($var=null)
{
	return strlen($var);
}

function calcf_substring($var=null, $offs=0, $len=null)
{
	// sql-compatible offset
	if(! $offs) return '';
	$offs = ($offs > 0) ? $offs-1 : $offs;
	if(isset($len)) {
		if($len < 0) return ''; // not supported in SQL
		return substr($var, $offs, $len);
	}
	return substr($var, $offs);
}

function calcf_abs($val=null)
{
	return abs($val);
}

function calcf_log($val=null, $base=M_E)
{
	return log($val, $base);
}

function calcf_pow($val=null, $exp=null)
{
	return pow($val, $exp);
}

function calcf_max()
{
    $num_args = func_num_args();
    $result = 0;

    for($i=0; $i < $num_args; $i++) {
        $val = func_get_arg($i);
        if(! is_numeric($val)) $val = 0;
        $result = max($val, $result);
    }
    
    return $result;
}

function calcf_min()
{
    $num_args = func_num_args();
    $result = 0;

    for($i=0; $i < $num_args; $i++) {
        $val = func_get_arg($i);
        if(! is_numeric($val)) $val = 0;
        $result = min($val, $result);
    }
    
    return $result;
}

function calcf_floor($val=null)
{
	return floor($val);
}

function calcf_ceil($val=null)
{
	return ceil($val);
}

function calcf_round($val=null, $dec=0)
{
	return round($val, $dec);
}

function calcf_ifNull($val=null, $default=null) {
	if(! isset($val)) return $default;
	return $val;
}

?>
