<?php

if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

function zip_supported() {
	return class_exists('ZipArchive');
}

function unzip( $zip_archive, $zip_dir, $die = true )
{
	if( !is_dir( $zip_dir ) ){
		if ($die)
	        die( "Specified directory '$zip_dir' for zip file '$zip_archive' extraction does not exist." );
		else
			return false;
    }
	$zip = new ZipArchive;
	if (!$zip->open($zip_archive)) {
		if ($die)
			die( "Error: " . $zip->getStatusString() );
		else
			return false;
	}
    if( !$zip->extractTo($zip_dir)) {
		if ($die)
			die( "Error: " . $zip->getStatusString() );
		else
			return false;
	}
	return true;
}

function unzip_file( $zip_archive, $archive_file, $to_dir, $die = true){
    if( !is_dir( $to_dir ) ){
        if($die) die( "Specified directory '$to_dir' for zip file '$zip_archive' extraction does not exist." );
        return false;
    }
	$zip = new ZipArchive;
	if(! file_exists($zip_archive) || ! is_readable($zip_archive)) {
		if ($die) die( "File does not exist: $zip_archive" );
		return false;
	}
	if (!$zip->open($zip_archive)) {
		if ($die) die( "Error: " . $zip->getStatusString() );
		else return false;
	}
    if (!$zip->extractTo($to_dir,  $archive_file)) {
		if ($die) die( "Error: " . $zip->getStatusString() );
		else return false;
    }
    return true;
}

function zip_dir( $zip_dir, $zip_archive, $die = true){
	$zip = new ZipArchive;
	if (!$zip->open($zip_archive, ZipArchive::CREATE | ZipArchive::OVERWRITE)) {
		if ($die) die( "Error: " . $zip->getStatusString() );
		else return false;
	}

    _zip_dir($zip, $zip_dir);

    $zip->close();
}

function _zip_dir($zip, $dir, $zipPath = '')
{
	if ($zipPath !== '') {
		$parts = explode('/', $zipPath);
		$path = '';
		foreach ($parts as $part) {
			if ($path !== '') $path .= '/';
			$path .= $part;
			if ($zip->locateName($path) === false) {
				$zip->addEmptyDir($path);
			}
		}
	}

    if ($zipPath !== '') $zipPath .= '/';

    $files = glob($dir . '/*', GLOB_NOSORT);

    foreach ($files as $file) {
        $newZipPath = $zipPath . basename($file);

        if (is_dir($file)) {
            _zip_dir($zip, $dir . '/' . basename($file), $newZipPath);
        } else {
            $zip->addFile($file, $newZipPath);
        }
    }
}
?>
