<?php
/* vim: set foldmethod=marker : */

if (!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once ('include/utils/basic_utils.php');
end_clean_all_buffers();
ob_implicit_flush();

if(isset($_SESSION['setup_db_use_mb_demo_data']))
	$mb_demo_data = $_SESSION['setup_db_use_mb_demo_data'];
else
	$mb_demo_data = AppConfig::setting('install_demo.multibyte_data');

if($mb_demo_data) {
	require_once ('modules/Contacts/contactSeedData_jp.php');
} else {
	require_once ('modules/Contacts/contactSeedData.php');
}

require_once ('include/database/PearDatabase.php');
require_once ('include/database/DBManager.php');
require_once ('include/utils/file_utils.php');
require_once ('include/utils.php');
require_once ('install/demoOptions.php');
require_once ('vendor_info.php');

define('PORTAL_ACCOUNT_ID', 'f3fb0785-84bc-63b8-f2bd-5348cfe4591c');
define('PORTAL_CONTACT_ID', 'a7be92d7-9870-b338-bf04-5348d0b8836f');
define('PORTAL_USER_ID',    'aabd03c5-31ad-aa52-6880-5348d0e11aed');

// switch to selected default language for standard and demo data
// does not affect installer-based language ($mod_strings)
$current_language = $_SESSION['default_language'];

// --
require_once 'modules/Users/User.php';
require_once 'modules/Project/Project.php';
require_once 'modules/Project/ProjectFinancials.php';
require_once 'modules/Documents/Document.php';
require_once 'modules/DocumentRevisions/DocumentRevision.php';
require_once 'modules/TaxCodes/TaxCode.php';

require_once 'include/upload_file.php';
$uploadFile = new UploadFile('');
$demo_dir = 'demodata/';
$project_ids = Array();

require_once 'modules/SubContracts/SubContract.php';
require_once 'modules/MonthlyServices/MonthlyService.php';

session_write_close();

$db = DBManager::getInstance();

AppConfig::load_module_index();

$current_user = new User();
$current_user->retrieve(1);

require_once 'include/ProgressIndicator.php';
$progressIndicator = new ProgressIndicator(AppConfig::setting('install_demo.progress_log'), true, CLI_INSTALLER);


$subcon_ids = Array();
$subcon_accts = Array();
$contract_type_ids = Array();

require_once 'modules/EmailFolders/EmailFolder.php';
$folder_id = EmailFolder::get_std_folder_id(1, STD_FOLDER_INBOX);


require_once 'install/seed_data/basicSeedData.php';
require_once 'modules/Currencies/CurrencyUtils.php';
global $currencies;
$currencies = CurrencyUtils::get_list();
global $first_name_array;
global $last_name_array;
global $company_name_array;
global $street_address_array;
global $city_array;
global $app_list_strings;
$app_list_strings = return_app_list_strings_language($current_language);

// Seed the random number generator with a fixed constant.  This will make all installs of the same code
// have the same seed data.  This facilitates cross database testing..

mt_srand(93285903);

// Set the max time to ~10 minutes (helps Windows load the seed data)
set_time_limit(601);

// ensure we have enough memory
$memory_needed = 108;
$memory_limit = ini_get('memory_limit');
if ($memory_limit != "" && $memory_limit != "-1") { // if memory_limit is set
	rtrim($memory_limit, 'M');
	$memory_limit_int = (int)$memory_limit;
	if ($memory_limit_int < $memory_needed) {
		ini_set("memory_limit", "$memory_needed" . "M");
	}
}
$large_scale_test = AppConfig::setting('install_demo.large_scale_test', false);

$number_contacts = 1000;
$number_companies = 150;
$number_leads = 1000;

$number_contacts = 200;

// If large scale test is set to true, increase the seed data.
if ($large_scale_test) {

	// increase the cuttoff time to 1 hour
	ini_set("max_execution_time", "3600");
	$number_contacts = 100000;
	$number_companies = 15000;
	$number_leads = 100000;
}

$possible_duration_hours_arr = array(
	0,
	1,
	2
);
$possible_duration_minutes_arr = array(
	'00' => '00',
	'15' => '15',
	'30' => '30',
	'45' => '45'
);

$account_ids = $account_names = array();
$contact_ids = array();
$account_addr_state = $account_assigned_uid = array();
$opportunity_ids = Array();

// Determine the assigned user for all demo data.  This is the default user if set, or admin
$assigned_user_name = "admin";
if(AppConfig::setting('install.default_user.create'))
	$assigned_user_name = AppConfig::setting('install.default_user.user_name');

// Look up the user id for the assigned user
$seed_user = new User;
$assigned_user_id = $seed_user->retrieve_user_id($assigned_user_name);

$contract_types = array(
	array(
		'24/7 LAN Support',
		8*60
	) ,
	array(
		'24/7 Server Support',
		4*60
	) ,
	array(
		'Business Hours LAN Support',
		8*60
	) ,
	array(
		'Business Hours Server Support',
		4*60
	) ,
);

$user_fields = array(
	'first_name',
	'last_name',
	'is_admin',
	'title',
	'department',
);

$user_ids = array(
	1
);
/** changed on/off to 1/0 by Jason Eggers */
$user_data = array(
	array(
		"Michael",
		"Whitehead",
		'1',
		'President',
		'Corporate Office',
		0
	) ,
	array(
		"Andrew",
		"Whitehead",
		'1',
		'Lead Developer',
		'R&D',
		1
	) ,
	array(
		"Andrey",
		"Demenev",
		'0',
		'Developer',
		'R&D',
		2
	) ,
	array(
		"Suzanne",
		"Louis",
		'0',
		'Direct Marketing',
		'Sales',
		2
	) ,
);

$tasks = array(
	array(
		'Conceptualization',
		0,
		5,
		1, -1,
		'',
	) ,
	array(
		'Brainstorming',
		0,
		1,
		0, -1,
		'',
	) ,
	array(
		'Specifications',
		1,
		5,
		0,
		1,
		'FTS',
	) ,
	array(
		'Engineering',
		5,
		20,
		1, -1,
		'',
	) ,
	array(
		'Design',
		5,
		11,
		0,
		2,
		'STS',
	) ,
	array(
		'Prototype',
		11,
		20,
		0,
		4,
		'FTS',
	) ,
	array(
		'Testing',
		20,
		30,
		1, -1,
		'',
	) ,
	array(
		'Alpha Test',
		20,
		26,
		0, -1,
		'',
	) ,
	array(
		'Beta Test',
		23,
		27,
		0,
		7,
		'FTS',
	) ,
	array(
		'Focus Group Test',
		25,
		30,
		0,
		8,
		'FTF',
	) ,
	array(
		'Production',
		30,
		38,
		1, -1,
		'',
	) ,
	array(
		'First Production Run',
		30,
		38,
		0,
		9,
		'FTS',
	) ,
);


try { // catch database error

	try {

		$db->query('START TRANSACTION;');

		if (have_demo('subcontracts')) {
			foreach($contract_types as $ctype_info) {
				$ctype = RowUpdate::blank_for_model('ContractType');
				$ctype->set(array(
					'name' => $ctype_info[0],
					'vendor_name' => 'Service Inc.',
					'response_time' => $ctype_info[1],
				));
				$ctype->save();
				$contract_type_ids[] = $ctype->getPrimaryKeyValue();
			}
		}

		$monthly_service_names = array(
			'Email Package (10 addresses)',
			'Hi-Speed Internet Connection (Extreme)',
			'Hi-Speed Internet Connection (Ultra)',
			'Hosting Bundle A (Hosting, Email, Ultra)',
			'Remote Network Monitoring',
			'Website Hosting (With PHP Support)'
		);

		if (have_demo('monthly_services')) {
			for($i = 0; $i < sizeof($monthly_service_names); $i++) {
				$cat = RowUpdate::blank_for_model('BookingCategory');
				$cat->set('name', $monthly_service_names[$i]);
				$cat->set('booking_class', 'services-monthly');
				$cat->save();
				$service_category_ids[] = $cat->getPrimaryKeyValue();
			}
		}

		if (have_demo('expense_reports')) {
			require_bean('BookingCategory');
			$cat = new BookingCategory;
			$categories = $cat->get_full_list('RAND()', "booking_class='expenses'");
			$cat->cleanup();
			$n = rand(4, 10);
			$types = $app_list_strings['expense_report_type_dom'];
			unset($types['']);
			do {
				$report = RowUpdate::blank_for_model('ExpenseReport');
				$report->set(array(
					'status' => 'In Preparation',
					'advance_currency_id' => '-99',
					'currency_id' => '-99',
					'advance' => ($n % 2) ? rand(50, 500) : 0,
					'advance_exchange_rate' => 1,
					'exchange_rate' => 1,
					'type' => array_rand($types),
					'assigned_user_id' => array_get_random($user_ids),
					'total_amount' => 0,
					'total_pretax' => 0,
					'tax' => 0,
					'balance' => 0,
				));
				$ret = $report->save();
				
				$nitems = rand(2, 7);
				$total = 0;
				for ($i = 0; $i < $nitems; $i++) {
					$item = RowUpdate::blank_for_model('ExpenseItem');
					$cat = $categories[array_rand($categories)];
					$item->set(array(
						'date' => create_date(),
						'report_id' => $report->getPrimaryKeyValue(),
						'item_number' => $i,
						'line_order' => $i,
						'split' => 0,
						'category' => $cat->id,
					));
					if ($cat->expenses_unit) {
						$qty = rand(1, 8);
						$rate = rand(3, 70);
						$item->set(array(
							'unit' => $cat->expenses_unit,
							'quantity' => $qty,
							'paid_rate' => $rate,
							'amount' => $qty * $rate,
						));
					} else {
						$item->set('amount', rand(3, 70));
					}
					$item->set('total', $item->getField('amount'));
					$total += $item->getField('amount');
					$item->save();
					unset($item);
				}
				
				$report->set('total_amount', $total);
				$report->set('total_pretax', $total);
				$report->set('tax', 0);
				$report->set('balance', $total - $report->getField('advance'));
				$report->save();
				unset($report);
			} while (--$n);
		}



		if (have_demo('users')) {
			$label = $mod_strings['LBL_CREATE_EMPLOYEES'];
			$demo_photo_dir = $demo_dir . 'photos/';

			$n = count($user_data);

			foreach($user_data as $i => $data) {
				$user = RowUpdate::blank_for_model('User');
				foreach($user_fields as $k => $f) $user->set($f, $data[$k]);
				$user_name = strtolower($data[0][0] . $data[1]);
				$user->set(array(
					'reports_to_id' => $user_ids[$data[5]],
					'in_directory' => 1,
					'user_name' => $user_name,
					'status' => 'Info Only',
					'email1' => $user_name . '@company.com',
					'phone_work' => create_phone_number(),
					'phone_home' => create_phone_number(),
					'address_street' => array_get_random($street_address_array),
					'address_city' => array_get_random($city_array),
					'address_state' => 'ON',
					'address_postalcode' => 'K' . mt_rand(0, 9) . 'A' . mt_rand(0, 9) . 'N' . mt_rand(0, 9),
					'address_country' => 'Canada',
				));
				$user->set('location', $user->getField('address_city'));
				$photo = $data[0] . $data[1] . '.png';
				$source = $demo_photo_dir . $photo;
				$img_path = install_photo($source, 'images/directory/');
				$user->set('photo_filename', $img_path);
				$user->set('photo_thumb', $img_path);
				$user->save();
				$user_id = $user->getPrimaryKeyValue();
				$user_ids[$i + 1] = $user_id;

				unset($user);

				$lq = new ListQuery('Employee');
				$lq->addSimpleFilter('user_id', $user_id);
				$empl_result = $lq->runQuerySingle();
				if($empl_result && ! $empl_result->failed) {
					$empl = RowUpdate::for_result($empl_result);
					$start_date = create_past_date();
					$empl->set('start_date', $start_date);
					$empl->set('employee_num', 'A' . date('Y', strtotime($start_date)) . '-' . mt_rand(100, 999));
					$empl->save();
				}
				$progressIndicator->logProgress($label, ($i+1) / $n * 100);
			}


			$user = RowUpdate::blank_for_model('User');
			$user->set(array(
				'first_name' => 'Portal',
				'last_name' => 'User',
				'is_admin' => 0,
				'title' =>'',
				'department' => '',
				'in_directory' => 0,
				'user_name' => '_p_demo',
				'status' => 'Active',
				'portal_only' => 1,
				'user_hash' => strtolower(md5('demo')),
				'id' => PORTAL_USER_ID,
			));
			$user->save();

			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Users and employees");
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	try {
		$db->query('START TRANSACTION;');


		///////////////////////////////////////////////////////////////////////////////

		////	ACCOUNTS

		if (have_demo('accounts')) {

			$label = $mod_strings['LBL_CREATE_SAMPLE_ACCOUNTS'];
			$n = $number_companies;

			$vendor = RowUpdate::blank_for_model('Account');
			$vendor_row = array(
				'name' => $vendor_info['name'],
				'phone_office' => array_get_default($vendor_info, 'phone'),
				'phone_fax' => array_get_default($vendor_info, 'fax'),
				'email1' => array_get_default($vendor_info, 'email_sales'),
				'email2' => array_get_default($vendor_info, 'email_support'),
				'website' => array_get_default($vendor_info, 'url'),
				'is_supplier' => 1,
				'account_type' => 'Supplier',
				'industry' => 'Technology',
				'assigned_user_id' => 1,
			);
			foreach(array('address_street', 'address_city', 'address_state', 'address_country', 'address_postalcode') as $f) {
				$vendor_row['billing_' . $f] = array_get_default($vendor_info, $f);
				$vendor_row['shipping_' . $f] = array_get_default($vendor_info, $f);
			}
			if (! empty($vendor_info['logo'])) {
				$img_path = install_photo($vendor_info['logo']);
				$vendor_row['photo_filename'] = $img_path;
				$vendor_row['photo_thumb'] = $img_path;
			}
			$vendor->set($vendor_row);
			if($vendor->save()) {
				$vendor_id = $vendor->getPrimaryKeyValue();
				$account_ids[] = $vendor_id;
				$account_names[] = $vendor->getField('name');
				$account_addr_state[] = $vendor->getField('billing_address_state');
				$account_assigned_uid[] = $vendor->getField('assigned_user_id');

				require_once('modules/SocialAccounts/SocialAccount.php');
				foreach(array('facebook_url', 'twitter_url', 'linkedin_url', 'youtube_url', 'instagram_url') as $f) {
					if(! empty($vendor_info[$f])) {
						$soc = SocialAccount::quick_create_row($vendor_info[$f], 'Accounts', $vendor_id);
						if($soc) $soc->save();
					}
				}
			}
			
			$acct_names = $company_name_array;
			shuffle($acct_names);		

			for ($i = 0;$i < $number_companies;$i++) {

				if(! count($acct_names)) {
					$acct_names = $company_name_array;
					shuffle($acct_names);
				}
				$account_name = $test_name = array_pop($acct_names);
				$ai = 2;
				while(in_array($test_name, $account_names)) {
					$test_name = $account_name . ' ' . ($ai ++);
				}
				$account_name = $test_name;

				// Create new accounts.
				$account = RowUpdate::blank_for_model('Account');
				$account->set(array(
					'name' => $account_name,
					'phone_office' => create_phone_number(),
					'email1' => createEmailAddress(),
					'website' => createWebAddress(),
					'billing_address_street' => array_get_random($street_address_array),
					'billing_address_city' => array_get_random($city_array),
					'billing_address_state' => ($i % 3 == 1) ? 'NY' : 'CA',
					'assigned_user_id' => array_get_random($user_ids),
					'billing_address_postalcode' => mt_rand(10000, 99999),
					'billing_address_country' => 'USA',
					'industry' => array_rand($app_list_strings['industry_dom']),
					'account_type' => "Customer",
					'currency_id' => '-99',
					'exchange_rate' => 1,
					'invalid_email' => 0,
					'email_opt_out' => 0,
				));
				foreach(array('street', 'city', 'state', 'postalcode', 'country') as $f)
					$account->set('shipping_address_'.$f, $account->getField('billing_address_'.$f));

				if ($i == 0) {
					$account->set('id', PORTAL_ACCOUNT_ID);
				}

				$account->save();
				$account_ids[] = $account->getPrimaryKeyValue();
				$account_names[] = $account->getField('name');
				$account_addr_state[] = $account->getField('billing_address_state');
				$account_assigned_uid[] = $account->getField('assigned_user_id');

				$account_for_project = $account->getPrimaryKeyValue();
				unset($account);
				$progressIndicator->logProgress($label, ($i+1) / $n * 100);
			}

			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	try {
		$db->query('START TRANSACTION;');


		if (have_demo('notes')) {

			$i = 0;
			$label = $mod_strings['LBL_CREATE_SAMPLE_NOTES'];
			$n = count($account_ids);

			foreach ($account_ids as $account_id) {
				$note = RowUpdate::blank_for_model('Note');
				$seed_data_index = mt_rand(0, 3);
				$note->set(array(
					'parent_type' => 'Accounts',
					'parent_id' => $account_id,
					'name' => $note_seed_names_and_Descriptions[$seed_data_index][0],
					'description' => $note_seed_names_and_Descriptions[$seed_data_index][1],
					'assigned_user_id' => array_get_random($user_ids),
					'portal_flag' => 0,
				));
				$note->save();

				$i++;
				$progressIndicator->logProgress($label, $i / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}

		if (have_demo('calls')) {

			$i = 0;
			$label = $mod_strings['LBL_CREATE_SAMPLE_CALLS'];
			$n = count($account_ids);

			foreach ($account_ids as $account_id) {
				$call = RowUpdate::blank_for_model('Call');
				$call->set(array(
					'name' => $call_seed_data_names[mt_rand(0, 3)],
					'assigned_user_id' => array_get_random($user_ids),
					'direction' => 'Outbound',
					'date_start' => create_date_time(),
					'duration' => 30,
					'account_id' => $account_id,
					'status' => 'Planned',
				));
				$call->save();

				$i++;
				$progressIndicator->logProgress($label, $i / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}

		if (have_demo('opportunities')) {

			$label = $mod_strings['LBL_CREATE_SAMPLE_OPPS'];
			$n = count($account_ids);

			foreach ($account_ids as $i => $account_id) {
				$sales_stage = array_rand($app_list_strings['sales_stage_dom']);
				$opp_name = substr($account_names[$i] . " - 1000 units", 0, 50);
				
				$opp = RowUpdate::blank_for_model('Opportunity');
				$opp->set(array(
					'assigned_user_id' => array_get_random($user_ids),
					'name' => $opp_name,
					'account_id' => $account_id,
					'lead_source' => array_rand($app_list_strings['lead_source_dom']),
					'sales_stage' => $sales_stage,
					'forecast_category' => $app_list_strings['sales_forecast_dom'][$sales_stage],
					'probability' => $app_list_strings['sales_probability_dom'][$sales_stage],
					'opportunity_type' => array_rand($app_list_strings['opportunity_type_dom']),
				));

				if ($sales_stage == "Closed Won" || $sales_stage == "Closed Lost") {
					if (ord($opp_name[0]) % 3 == 0) {
						$opp->set('date_closed', create_past_date());
					} else {
						$opp->set('date_closed', create_opp_past_date());
					}
				}
				else if (ord($opp_name[0]) % 3 == 0) {
					$opp->set('date_closed', create_date());
				} else {
					$opp->set('date_closed', create_opp_date());
				}

				$amount = array(
					10000,
					25000,
					50000,
					75000
				);
				$opp->set('amount', array_get_random($amount));
				$opp->save();
				$opportunity_ids[] = $opp->getPrimaryKeyValue();
				unset($opp);

				if (rand(1, 100) < 10) {
					if (have_demo('subcontracts')) {
						$num_subs = rand(1, 5);
						for ($j = 1;$j <= $num_subs;$j++) {
							if (rand(0, 10) < 8) $date_expire = create_date();
							else $date_expire = create_past_date();
							$subcon = RowUpdate::blank_for_model('SubContract');
							$subcon->set(array(
								'account_id' => $account_id,
								'contract_type_id' => array_get_random($contract_type_ids),
								'date_start' => create_past_date(),
								'name' => "Contract #$j",
								'is_active' => 'yes',
								'assigned_user_id' => 1,
								'date_expire' => $date_expire,
							));
							$subcon->save();
							$subcon_ids[] = $subcon_id = $subcon->getPrimaryKeyValue();
							$subcon_accts[$subcon_id] = $account_id;
							unset($subcon);
						}
					}
				}

				$progressIndicator->logProgress($label, ($i+1) / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}


		if (have_demo('projects')) {

			$label = $mod_strings['LBL_CREATE_SAMPLE_PROJECTS'];
			$n = count($account_ids);

			foreach ($account_ids as $i => $account_id) {
				if (ord($account_id[0]) % 3 == 1 || $account_id == PORTAL_ACCOUNT_ID) {
					$amount = array(
						10000,
						25000,
						50000,
						75000
					);

					$proj = RowUpdate::blank_for_model('Project');
					$proj->set(array(
						'assigned_user_id' => array_get_random($user_ids),
						'name' => "Contract with " . $account_names[$i],
						'account_id' => $account_id,
						'date_starting' => create_past_date(),
						'date_ending' => create_date(),
						'lead_source' => array_rand($app_list_strings['lead_source_dom']),
						'project_phase' => array_rand($app_list_strings['project_status_dom']),
						'project_type' => array_rand($app_list_strings['project_type_dom']),
						'amount' => array_get_random($amount),
					));
					$proj->save();
					$project_ids[] = $proj_id = $proj->getPrimaryKeyValue();

					$financ = new ProjectFinancials();
					$financ->load($proj);
					$periods = $financ->get_project_financial_periods();
					$end_yr = date("Y");
					$end_mo = date("m");
					foreach($periods as $period) {
						list($yr, $mo) = sscanf($period, "%04d-%02d");
						$values = array();
						foreach(ProjectFinancials::$value_fields as $f) {
							if (substr($f, 0, 6) == 'expect') $values[$f] = rand(0, 10000);
							else if ($yr < $end_yr || ($yr == $end_yr && $mo < $end_mo)) $values[$f] = rand(0, 1000000) / 100;
							else $values[$f] = 0;
						}
						$financ->update_for_period($period, $values);
					}
					$financ->save();
					$financ->cleanup();
					unset($financ);

					unset($proj);
				}
				$progressIndicator->logProgress($label, ($i+1) / $n * 100);
			}

			$spd = 24 * 60 * 60;
			$base = time() - 10 * $spd;
			$proj = RowUpdate::blank_for_model('Project');
			$proj->set(array(
				'name' => 'Gantt Chart Demo',
				'amount' => 1000,
				'account_id' => $account_for_project,
				'date_starting' => date($timedate->get_db_date_format() , $base),
				'date_ending' => date($timedate->get_db_date_format() , $base + 62 * $spd),
				'project_phase' => 'Active - In Progress',
				'percent_complete' => rand(0, 100),
				'assigned_user_id' => 1,
				'currency_id' => '-99',
			));
			$proj->save();
			$project_ids[] = $proj_id = $proj->getPrimaryKeyValue();

			foreach($tasks as $i => $def) {
				$task = RowUpdate::blank_for_model('ProjectTask');
				$task->set(array(
					'parent_id' => $proj_id,
					'status' => array_rand($app_list_strings['project_task_status_options']),
					'priority' => array_rand($app_list_strings['project_task_priority_options']),
					'percent_complete' => rand(0, 100),
					'assigned_user_id' => 1,
					'name' => $def[0],
					'date_start' => date($timedate->get_db_date_time_format() , $base + $def[1] * $spd),
					'date_due' => date($timedate->get_db_date_time_format() , $base + $def[2] * $spd),
					'milestone_flag' => $def[3] ? 1 : 0,
					'number' => $i,
					'order_number' => $i,
					'currency_id' => $proj->getField('currency_id'),
					'portal_flag' => 0,
				));
				if ($def[4] != - 1) {
					$task->set('depends_on_id', $tasks[$def[4]]['id']);
					$task->set('dependency_type', $def[5]);
				}
				$task->save();
				$tasks[$i]['id'] = $task->getPrimaryKeyValue();
			}

			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	try {
		$db->query('START TRANSACTION;');


		$titles = array(
			"President",
			"VP Operations",
			"VP Sales",
			"Director Operations",
			"Director Sales",
			"Mgr Operations",
			"IT Developer",
			""
		);
		$folder_ids = array();

		///////////////////////////////////////////////////////////////////////////////
		////	DEMO CONTACTS

		if (have_demo('contacts')) {

			$label = $mod_strings['LBL_CREATE_SAMPLE_CONTACTS'];
			$n = $number_contacts;

			$contact_account_id = null;
			if (have_demo('accounts'))
				$contact_account_id = $vendor_id;



			for ($i = 0;$i < $number_contacts;$i++) {
				$account_number = array_rand($account_ids);
				$account_id = $account_ids[$account_number];
				if (!$contact_account_id)
					$contact_account_id = $account_id;
				$contact = RowUpdate::blank_for_model('Contact');
				if ($contact_account_id && $i == 0) {
					$data = array(
						'first_name' => 'Michael',
						'last_name' => 'Whitehead',
						'email1' => 'michael@1crm.com',
						'primary_account_id' => $contact_account_id,
						'primary_address_street' => '688 Falkland Road',
						'primary_address_city' => 'Victoria',
						'primary_address_state' => 'BC',
						'primary_address_postalcode' => 'V8S 4L5',
						'primary_address_country' => 'Canada',
						'lead_source' => array_rand($app_list_strings['lead_source_dom']),
						'title' => 'President/CEO',
						'phone_work' => '+1 (778) 432-2761',
						'assigned_user_id' => $account_assigned_uid[$account_number],
						'portal_active' => 0,
						'photo_filename' => install_photo('include/images/iah/Michael.jpg'),
					);
				} else {
					$data = array(
						'first_name' => array_get_random($first_name_array),
						'last_name' => array_get_random($last_name_array),
						'email1' => createEmailAddress(),
						'primary_account_id' => $account_id,
						'primary_address_street' => array_get_random($street_address_array),
						'primary_address_city' => array_get_random($city_array),
						'primary_address_state' => $account_addr_state[$account_number],
						'primary_address_postalcode' => mt_rand(10000, 99999),
						'primary_address_country' => 'USA',
						'lead_source' => array_rand($app_list_strings['lead_source_dom']),
						'title' => array_get_random($titles),
						'phone_work' => create_phone_number(),
						'phone_home' => create_phone_number(),
						'phone_mobile' => create_phone_number(),
						'assigned_user_id' => $account_assigned_uid[$account_number],
						'portal_active' => 0,
					);
				}
				$contact->set($data);
				
				if ($i == 1) {
					$contact->set('id', PORTAL_CONTACT_ID);
					$contact->set('portal_name', '_p_demo');
					$contact->set('first_name', 'John');
					$contact->set('last_name', 'Smith');
					$contact->set('email1', 'john.smith@example.com');
					$contact->set('portal_active', 1);
					$contact->set('primary_account_id', PORTAL_ACCOUNT_ID);
				}

				$contact->save();
				$contact_id = $contact->getPrimaryKeyValue();
				$contact_ids[] = $contact_id;
				$contact_account_ids[$contact_id] = $account_id;
				
				$contact->addUpdateLink('accounts', $account_id);
				$contact->addUpdateLink('opportunities', array(
					'id' => array_get_random($opportunity_ids),
					'contact_role' => 'Primary Decision Maker',
				));
				unset($contact);

				$progressIndicator->logProgress($label, ($i+1) / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Contacts and related objects");
		}


		if (have_demo('leads')) {

			$label = $mod_strings['LBL_CREATE_SAMPLE_LEADS'];
			$n = count($contact_ids);
			$i = 0;

			foreach($contact_ids as $contact_id) {
				if (ord($contact_id[0]) % 4 == 0) {
					$lead = RowUpdate::blank_for_model('Lead');
					$contact = ListQuery::quick_fetch('Contact', $contact_id);
					if(! $contact || $contact->failed) continue;
					$lead->set($contact->row);
					$lead->set('assigned_user_id', array_get_random($user_ids));
					$lead->set('contact_id', $contact_id);
					$lead->set('status', 'Recycled'); // should be 'Converted', but then it would be hidden
					$lead->set('account_name', $contact->getField('account'));
					$lead->set('portal_active', 0);
					$lead->save();
					unset($lead);
					unset($contact);
				}
				$i++;
				$progressIndicator->logProgress($label, $i / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	try {
		$db->query('START TRANSACTION;');


		if (have_demo('tasks')) {

			$task_names = array(
				'Assemble catalogs',
				'Make travel arrangements',
				'Send contract',
				'Send a follow-up letter',
				'Send literature',
				'Send proposal',
				'Send quote',
				'Call to schedule meeting',
				'Set up evaluation',
				'Get demo feedback',
				'Arrange introduction',
				'Escalate support request',
				'Close out support request',
				'Ship product',
				'Arrange reference call',
				'Schedule training',
				'Send local user group information',
				'Add to mailing list');

			$label = $mod_strings['LBL_CREATE_SAMPLE_TASKS'];
			$n = count($contact_ids);
			$i = 0;

			foreach($contact_ids as $contact_id) {
				if (ord($contact_id[0]) % 4 == 2) {
					$task = RowUpdate::blank_for_model('Task');
					$task->set(array(
						'name' => array_get_random($task_names),
						'date_due' => create_date_time(),
						'priority' => array_rand($app_list_strings['task_priority_dom']),
						'assigned_user_id' => $user_ids[array_rand($user_ids)],
						'status' => array_rand($app_list_strings['task_status_dom']),
						'contact_id' => $contact_id,
						'account_id' => $contact_account_ids[$contact_id],
					));
					$task->save();
				}
				$i++;
				$progressIndicator->logProgress($label, $i / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}

		if (have_demo('meetings')) {

			$meeting_names = array(
				'Follow-up on proposal',
				'Initial discussion',
				'Review needs',
				'Discuss pricing',
				'Demo',
				'Introduce all players',
			);

			$label = $mod_strings['LBL_CREATE_SAMPLE_MEETINGS'];
			$n = count($contact_ids);
			$i = 0;

			foreach($contact_ids as $contact_id) {
				//Create new meetings
				$meeting = RowUpdate::blank_for_model('Meeting');
				$meeting->set(array(
					'name' => array_get_random($meeting_names),
					'date_start' => create_date_time(),
					'duration' => array_rand($possible_duration_hours_arr) * 60 + array_rand($possible_duration_minutes_arr),
					'assigned_user_id' => array_get_random($user_ids),
					'description' => 'Meeting to discuss project plan and hash out the details of implementation',
					'status' => array_rand($app_list_strings['meeting_status_dom']),
					'contact_id' => $contact_id,
					'account_id' => $contact_account_ids[$contact_id],
				));
				$meeting->save();
				$meeting->addUpdateLink('users', array(
					'id' => $meeting->getField('assigned_user_id'),
					'accept_status' => 'accept',
				));
				$i++;
				$progressIndicator->logProgress($label, $i / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}

		if (have_demo('emails')) {

			$email_subjects = array(
				'Follow-up on proposal',
				'Initial discussion',
				'Review needs',
				'Discuss pricing',
				'Demo',
				'Introduce all players',
			);

			$label = $mod_strings['LBL_CREATE_SAMPLE_EMAILS'];
			$n = count($contact_ids);
			$i = 0;

			foreach($contact_ids as $contact_id) {
				$email_uid = array_get_random($user_ids);
				if (!isset($folder_ids[$email_uid])) {
					$folder_ids[$email_uid] = EmailFolder::get_std_folder_id($email_uid, STD_FOLDER_INBOX);
				}

				//Create new emails
				$email = RowUpdate::blank_for_model('Email');
				$email->set(array(
					'name' => array_get_random($email_subjects),
					'to_addrs' => createEmailAddress(),
					'date_start' => create_past_date(),
					'time_start' => create_time(),
					'assigned_user_id' => $email_uid,
					'folder' => $folder_ids[$email_uid],
					'description' => 'Discuss project plan and hash out the details of implementation',
					'status' => 'sent',
					'contact_id' => $contact_id,
					'account_id' => $contact_account_ids[$contact_id],
				));
				$email->save();
				unset($email);

				$i++;
				$progressIndicator->logProgress($label, $i / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	try {
		$db->query('START TRANSACTION;');


		if (have_demo('cases')) {
			$i = 0;
			$label = $mod_strings['LBL_CREATE_SAMPLE_CASES'];
			$namesCount = is_countable($case_seed_names) ? count($case_seed_names) : 0;
			$n = count($account_ids) + $namesCount * 4;

			for ($k = 0; $k < 4; $k++) {
				foreach($case_seed_names as $subject) {
					$case = RowUpdate::blank_for_model('aCase');
					$case_data = array(
						'assigned_user_id' => array_get_random($user_ids),
						'name' => $subject,
						'status' => array_rand($app_list_strings['case_status_dom']),
						'priority' => array_rand($app_list_strings['case_priority_dom']),
						'account_id' => array_get_random($account_ids),
						'date_entered' => create_past_date_time(true),
					);

					if (!$i)
						$case_data['account_id'] = PORTAL_ACCOUNT_ID;
					$case->set($case_data);
					$case_id = $case->save();
					unset($case);
				
					$i++;
					$progressIndicator->logProgress($label, $i / $n * 100);
				}
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Cases");
		}

		if (have_demo('bugs')) {

			$software_products_created = array();
			$releases_created = array();
			$software_products = array(
				array(
					'1CRM Professional',
					array(
						'7.0.0',
						'7.1.0',
						'7.5.0'
					) ,
				) ,
				array(
					'Self-Service Portal & eStore',
					array(
						'4.0',
						'4.5',
						'5.0'
					) ,
				) ,
				array(
					'1CRM Finance (QB)',
					array(
						'1.1',
						'1.2',
						'1.3'
					) ,
				) ,
			);
			foreach($software_products as $product) {
				$sp = RowUpdate::blank_for_model('SoftwareProduct');
				$sp->set('name', $product[0]);
				$sp->save();
				$sp_id = $sp->getPrimaryKeyValue();
				$software_products_created[] = $sp_id;
				foreach($product[1] as $i => $release_name) {
					$release = RowUpdate::blank_for_model('Release');
					$release->set(array(
						'name' => $release_name,
						'list_order' => $i + 1,
						'status' => 'Active',
						'product_id' => $sp_id,
					));
					$release->save();
					$release_id = $release->getPrimaryKeyValue();
					$releases_created[$sp_id][] = $release_id;
				}
			}
			
			$bugs = array(
				array(
					'Not enough logic errors',
					'New',
					'P1',
					'Defect'
				) ,
				array(
					'Pretty new icons',
					'New',
					'P2',
					'Feature'
				) ,
				array(
					'Apalling lack of disregard',
					'New',
					'P1',
					'Defect'
				) ,
				array(
					'Quite possibly too many tabs',
					'New',
					'P0',
					'Defect'
				) ,
				array(
					'Ridiculous amounts of functionality',
					'New',
					'P1',
					'Feature'
				) ,
			);
			
			$i = 0;
			$label = $mod_strings['LBL_CREATE_SAMPLE_BUGS'];
			$n = count($bugs);
			
			foreach($bugs as $bug_info) {
				$bug = RowUpdate::blank_for_model('Bug');
				$product_id = array_get_random($software_products_created);
				$bug_data = array(
					'product_id' => $product_id,
					'found_in_release' => array_rand($releases_created[$product_id]),
					'name' => $bug_info[0],
					'status' => $bug_info[1],
					'priority' => $bug_info[2],
					'type' => $bug_info[3],
					'assigned_user_id' => 1,
				);
				if (!$i)
					$bug_data['account_id'] = PORTAL_ACCOUNT_ID;
				$bug->set($bug_data);
				$bug->save();
				unset($bug);
				
				$i++;
				$progressIndicator->logProgress($label, $i / $n * 100);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Bugs");
		}

		if (have_demo('documents')) {
			$label = $mod_strings['LBL_CREATE_SAMPLE_DOCUMENTS'];

			$knownMimeTypes = array(
				'doc' => 'application/msword',
				'xls' => 'application/vnd.ms-excel',
				'pdf' => 'application/pdf',
			);
			$demo_doc_dir = $demo_dir . 'documents/';
			if (false !== ($doc_dir = @opendir($demo_doc_dir))) {
				$files = array();
				while (false !== ($fname = readdir($doc_dir))) {
					$files[] = $fname;
				}
				closedir($doc_dir);
				$n = count($files);
				foreach ($files as $i => $fname) {
					$extension = substr($fname, -4);
					$source = $demo_doc_dir . $fname;
					if ($extension == '.doc' || $extension == '.xls') {
						$doc = RowUpdate::blank_for_model('Document');
						$doc->set(array(
							'document_name' => substr($fname, 0, -4),
							'department' => 'Human Resources',
							'status_id' => 'Approved',
							'category_id' => array_rand($app_list_strings['document_category_dom']),
							'active_date' => create_past_date(),
							'exp_date' => create_date(),
						));
						$doc->save();
						
						$rev = RowUpdate::blank_for_model('DocumentRevision');
						$rev->set('revision', '1.0');
						// FIXME - use RowUpdate's built-in file support
						$uploadFile->set_for_soap($fname, file_get_contents($source));
						$rev->set(array(
							'filename' => $uploadFile->create_stored_filename(),
							'file_ext' => $uploadFile->file_ext,
							'filesize' => filesize($source),
						));
						if (isset($knownMimeTypes[$uploadFile->file_ext])) {
							$rev->set('file_mime_type', $knownMimeTypes[$uploadFile->file_ext]);
						} else {
							$rev->set('file_mime_type', 'application/octet-stream');
						}
						$rev->set('date_entered', create_past_date_time(true));
						if ($extension == '.doc') $rev->set('filetype', 'MS Word');
						else $rev->set('filetype', 'MS Excel');
						$rev->set('document_id', $doc->getPrimaryKeyValue());
						$rev->save();
						
						$doc->set('document_revision_id', $rev->getPrimaryKeyValue());
						$doc->save();
						unset($doc);

						$uploadFile->final_move($rev->getPrimaryKeyValue());
						unset($rev);
					}
					$progressIndicator->logProgress($label, $i / $n * 100);
				}
			}

			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Documents");
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	try {
		$db->query('START TRANSACTION;');


		if (have_demo('feeds')) {

			$label = $mod_strings['LBL_ADD_RSS_FEEDS'];
			$feeds = array(
				array(
					'id' => '3a68ade5-eba9-dcf7-b8bc-41e2df75bea6'
				) , // BBC - Business - World Ed.

				array(
					'id' => 'a441427a-dded-20ec-14c0-41e2df00b0ca'
				) , // BBC - Technology - World Ed.

				array(
					'url' => "http://rss.cbc.ca/canadiannews.xml",
					'title' => "CBC | Canadian News"
				) ,
				array(
					'url' => "http://export.cnet.com/export/feeds/news/rss/1,11176,,00.xml",
					'title' => "CNET News.com"
				) ,
				array(
					'url' => "http://rss.macworld.com/macworld/feeds/main",
					'title' => "Macworld"
				) ,
				array(
					'id' => '7bd169d6-5a81-5486-a70b-41e2e1bdb372'
				) , // NYT > Business

				array(
					'id' => '2c248cf4-cbb0-1ae3-98dc-41e2e1f4b908'
				) , // NYT > Technology

				array(
					'url' => "http://www.fool.com/xml/foolnews_rss091.xml",
					'title' => "The Motley Fool"
				) ,
				array(
					'url' => "http://www.theregister.co.uk/tonys/slashdot.rdf",
					'title' => "The Register"
				) ,

				//array('id' => '6268c9b4-82b3-74b5-be2d-41e2e280945c'), // Telegraph news | Small Business
				array(
					'id' => 'b8ef9e66-846e-8c8a-5e37-41e2e2139fb6'
				) , // Washington Post - World

				array(
					'url' => "http://www.wired.com/news_drop/netcenter/netcenter.rdf",
					'title' => "Wired News"
				) ,

				// these ones are not favourites
				array(
					'url' => "http://www.dpreview.com/news/dpr.rdf",
					'title' => "Digital Photography Review",
					'fave' => false
				) ,
				array(
					'url' => "http://rss.cbc.ca/businessnews.xml",
					'title' => "CBC | Business News",
					'fave' => false
				) ,
				array(
					'url' => "http://rss.cbc.ca/hockeynews.xml",
					'title' => "CBC | Hockey News",
					'fave' => false
				) ,
				array(
					'url' => "http://rss.cbc.ca/ottawanews.xml",
					'title' => "CBC | Ottawa News",
					'fave' => false
				) ,
				array(
					'id' => '4bbca87f-2017-5488-d8e0-41e7808c2553',
					'fave' => false
				) ,
			);

			$n = count($feeds);

			require_once 'modules/Feeds/Feed.php';
			if (! AppConfig::setting(array('install.feature.disable_rss', 'site.feature.disable_rss'))) {
				$i = 0;
				$progressIndicator->logProgress($label, 0);
				foreach($feeds as $data) {
					$feed = new Feed;
					if (isset($data['id'])) {
						if (isset($data['fave']) && !$data['fave']) $feed->removeFavorites($data['id'], 1);
						else $feed->addToFavorites($data['id'], 1);
					} else {

						// create a new feed
						$feed->url = $data['url'];
						$feed->title = $data['title'];
						$feed->assigned_user_id = 1;
						$feed->modified_user_id = 1;
						$feed->save();
						if (!isset($data['fave']) || $data['fave']) $feed->addToFavorites($feed->id, 1);
					}
					$feed->cleanup();
					unset($feed);
					$i++;
					$progressIndicator->logProgress($label, $i / $n * 100);
				}
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Documents and feeds");
		}

		if (have_demo('products')) {
			$label = $mod_strings['LBL_CREATE_SAMPLE_PRODUCTS'];
			$progressIndicator->logProgress($label, 0);

			require_once 'modules/ProductCatalog/Product.php';
			require_once 'modules/ProductCategories/ProductCategory.php';
			require_once 'modules/ProductTypes/ProductType.php';
			require_once 'modules/Assets/Asset.php';
			$products_created = array();
			$demo_csv_dir = $demo_dir . 'csv/';
			$json = getJSONObj();
			$prod_infos = $json->decode(file_get_contents($demo_csv_dir . 'products.json'));
			$n = is_countable($prod_infos) ? count($prod_infos) : 0;

			foreach ($prod_infos as $i => $prod_info) {
				$prod_cat = installBean('ProductCategory', $prod_info['product_category_name']);
				$prod_type = installBean('ProductType', $prod_info['product_type_name'], array(
					'category_id' => $prod_cat->id
				));
				$info = array(
					'id' => $prod_info['id'],
					'product_category_id' => $prod_cat->id,
					'product_type_id' => $prod_type->id,
					'url' => array_get_default($prod_info, 'url'),
					'list_price' => $prod_info['list_price'],
					'cost' => sprintf('%0.2f', $prod_info['list_price'] / 2) ,
					'purchase_price' => sprintf('%0.2f', $prod_info['list_price'] * 0.9) ,
					'is_available' => 'yes',
					'date_available' => create_past_date() ,
					'is_taxable' => 'yes',
					'manufacturers_part_no' => $prod_info['manufacturers_part_no'],
					'pricing_formula' => 'Fixed Price',
					/** added by Jason Eggers */
					'in_stock' => rand(0, 20) ,
					'description' => str_replace('\n', "\n", $prod_info['description']) ,
					'description_long' => str_replace('\n', "\n", $prod_info['description_long']) ,
				);

				$supplier = null;
				if($prod_info['supplier_name'] == $vendor_info['name'])
					$info['supplier_id'] = $vendor_id;
				else {
					$supplier = installBean('Account', $prod_info['supplier_name'], array(
						'account_type' => 'Supplier',
						'assigned_user_id' => 1,
						'is_supplier' => 1,
						'currency_id' => '-99',
						'exchange_rate' => 1
					));
					$account_ids[] = $info['supplier_id'] = $supplier->id;
				}
				
				if (!empty($prod_info['currency_name'])) {
					$cur = new Currency;
					if ($cur->retrieve_by_string_fields(array(
						'iso4217' => $prod_info['currency_name']
					))) {
						$info['currency_id'] = $cur->id;
					}
					$cur->cleanup();
				}
				if ($supplier)
					$supplier->cleanup();
				$prod_cat->cleanup();
				$prod_type->cleanup();
				if (!empty($prod_info['image']))
					$info['image_filename'] = install_photo($demo_photo_dir . $prod_info['image']);
				if (!empty($prod_info['thumbnail']))
					$info['image_thumb'] = install_photo($demo_photo_dir . $prod_info['thumbnail']);
				$prod_tpl = installBean('Product', $prod_info['name'], $info);
				$products_created[] = $prod_tpl;
				if (have_demo('assets')) {
					$num_assets = rand(0, 10);
					for ($ai = 0;$ai < $num_assets;$ai++) {
						$info['service_subcontract_id'] = array_get_random($subcon_ids) ;
						$info['account_id'] = $subcon_accts[$info['service_subcontract_id']];
						$info['quantity'] = rand(1, 25);
						$asset = installBean('Asset', $prod_info['name'], $info);
						$asset->cleanup();
					}
				}
				$progressIndicator->logProgress($label, $i / $n * 100);
			}
			unset($prod_infos);
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Product catalog");
		}

		if (have_demo('taxes')) {
			$label = $mod_strings['LBL_CREATE_SAMPLE_TAXES'];
			$progressIndicator->logProgress($label, 0);
			
			global $taxrates;
			$taxrates = array();
			$rates = array(
				array(
					'HST',
					13.0,
					'',
					true,
				),
				array(
					'GST',
					5.0,
					'',
					false,
				),
				array(
					'Quebec PST',
					7.5,
					'compounded',
					false
				) ,
			);
			foreach($rates as $idx => $row) {
				$tax = RowUpdate::blank_for_model('TaxRate');
				$tax->set(array(
					'name' => $row[0],
					'rate' => $row[1],
					'compounding' => $row[2],
					'status' => 'Active',
				));
				$tax->save();
				if($row[3])
					$tax->addUpdateLink('taxcodes', array(
						'id' => constant('STANDARD_TAXCODE_ID'),
						'position' => $idx,
					));
				$taxrates[] = $tax;
			}

			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}

		if (have_demo('discounts')) {
			$label = $mod_strings['LBL_CREATE_SAMPLE_DISCOUNTS'];
			$progressIndicator->logProgress($label, 0);

			global $discounts;
			$discounts = array();
			$rates = array(
				array(
					'Special Promotion',
					10.0
				) ,
				array(
					'Preferred Customer',
					20.0
				) ,
				array(
					'Volume Discount',
					25.0
				) ,
			);
			foreach($rates as $row) {
				$disc = RowUpdate::blank_for_model('Discount');
				$disc->set(array(
					'name' => $row[0],
					'rate' => $row[1],
					'status' => 'Active',
				));
				$disc->save();
				$discounts[] = $disc;
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}

		if (have_demo('shipping_providers')) {
			$label = $mod_strings['LBL_CREATE_SAMPLE_PROVIDERS'];
			$progressIndicator->logProgress($label, 0);
			$shippers = array(
				array(
					'Canada Post'
				) ,
				array(
					'FedEx'
				) ,
				array(
					'Purolator'
				) ,
				array(
					'UPS'
				) ,
				array(
					'USPS Ground'
				) ,
			);
			$providers = array();
			foreach($shippers as $row) {
				$shipper = RowUpdate::blank_for_model('ShippingProvider');
				$shipper->set('name', $row[0]);
				$shipper->set('status', 'Active');
				$shipper->save();
				$providers[] = $shipper;
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Catalog supporting objects");
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	try {
		$db->query('START TRANSACTION;');


		if (have_demo(array('quotes','invoices','purchase_orders','bills'))) {
			
			$label = $mod_strings['LBL_CREATE_SAMPLE_QUOTES'];
			$progressIndicator->logProgress($label, 0);
			$n = count($account_ids);
			$i = 0;
			$quote_ids = $invoice_ids = array();

			foreach($account_ids as $account_id) {
				$account = new Account;
				if (!$account->retrieve($account_id)) continue;
				if (have_demo('quotes') && !$account->is_supplier) {
					if (rand(0, 10) > 7 || ! count($quote_ids) || $account_id == PORTAL_ACCOUNT_ID) {
						$quote = & create_quote_or_invoice('Quote', $account);
						$quote_ids[] = $quote->getPrimaryKeyValue();
						if ($quote->getField('quote_stage') == 'Closed Accepted') {
							if (have_demo('invoices')) {
								if (rand(0, 8) > 4 && have_demo('sales_orders')) {
									$so = & convert_quote_to_so($quote);
									$invoice = & convert_quote_to_invoice($so);
									unset($so);
								} else {
									$invoice = & convert_quote_to_invoice($quote);
								}
								allocate_payment($invoice);
								unset($invoice);
							}
						}
						unset($quote);
					}
				}
				if (have_demo('invoices') && !$account->is_supplier) {
					if (rand(0, 10) > 7 || ! count($invoice_ids)) {
						$invoice = & create_quote_or_invoice('Invoice', $account);
						$invoice_ids[] = $invoice->getPrimaryKeyValue();
						allocate_payment($invoice);

						create_shipping($invoice);
						unset($invoice);
					}
				}
				if (have_demo('purchase_orders') && $account->is_supplier) {
					$po = & create_quote_or_invoice('PurchaseOrder', $account);
					create_receiving($po);
					unset($po);
				}

				if (have_demo('bills') && $account->is_supplier) {
					$bill = & create_quote_or_invoice('Bill', $account);
					allocate_payment($bill);
					unset($bill);
				}
				$account->cleanup();
				unset($account);

				$i++;
				$progressIndicator->logProgress($label, $i / $n * 100);
				
				if($i && $i % 20 == 0) {
					$db->query('COMMIT;');
					$db->query('START TRANSACTION;');
				}
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Quotes and invoices");
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	try {
		$db->query('START TRANSACTION;');


		if (have_demo('monthly_services')) {	
			$label = $mod_strings['LBL_CREATE_SAMPLE_MONTHLY_SERVICES'];
			$progressIndicator->logProgress($label, 0);
			for ($i = 0; $i < sizeof($service_category_ids); $i++) {
				$quote = new Quote();
				if (!$quote->retrieve($quote_ids[array_rand($quote_ids)])) continue;
				$monthly_service = new MonthlyService();
				$monthly_service->assigned_user_id= array_get_random($user_ids);
				$monthly_service->booking_category_id = $service_category_ids[$i];
				$monthly_service->quote_id = $quote->id;
				$monthly_service->account_id = $quote->billing_account_id;
				$monthly_service->contact_id = $contact_ids[array_rand($contact_ids)];		
				$monthly_service->cc_user_id = $quote->assigned_user_id;
				$monthly_service->invoice_value = $quote->amount_usdollar;
				$monthly_service->purchase_order_num = $quote->purchase_order_num;		
				$monthly_service->invoice_terms =  array_rand($app_list_strings['terms_dom']);
				$start_date = rand(0, 1) > 0 ? create_date() : create_past_date();
				$monthly_service->start_date = $start_date;
				$monthly_service->end_date = create_service_end_date($start_date);
				$monthly_service->billing_day = get_service_billing_day($start_date);
				$monthly_service->address_id = main_vendor_id();
				$monthly_service->save();
				$monthly_service->cleanup();
				unset($monthly_service);
				$quote->cleanup();
				unset($quote);
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Recurring Services");	
		}

		if (have_demo('resources')) {
			$label = $mod_strings['LBL_CREATE_SAMPLE_RESOURCES'];

			$progressIndicator->logProgress($label, 0);
			$rooms = array(
				array(
					'Montreal',
					0,
					1,
					0,
					1,
					1,
					0,
					0
				) ,
				array(
					'Ottawa',
					0,
					0,
					0,
					1,
					0,
					0,
					0
				) ,
				array(
					'Guernsey',
					1,
					0,
					1,
					1,
					0,
					1,
					1
				) ,
				array(
					'Bristol',
					1,
					1,
					1,
					1,
					1,
					1,
					1
				) ,
			);
			foreach($rooms as $room) {
				$res = RowUpdate::blank_for_model('Resource');
				$attr = array('location', 'has_tv', 'has_dvd', 'has_vcr', 'has_projector', 'has_screen', 'has_pc', 'has_conf_phone');
				$res->set(array_combine($attr, $room));
				$res->set('name', $res->getField('location') . ' Room');
				$res->set('type', 'Meeting Room');
				$res->set('assigned_user_id', 1);
				$res->save();
			}
			$resources = array(
				array(
					'Projector A',
					'Montreal Room',
					'Projector'
				) ,
				array(
					'Projector B',
					'Ottawa Room',
					'Projector'
				) ,
				array(
					'Projector C',
					'Guernsey Room',
					'Projector'
				) ,
				array(
					'Projector D',
					'Bristol Room',
					'Projector'
				) ,
			);
			foreach($resources as $res_data) {
				$res = RowUpdate::blank_for_model('Resource');
				$res->set(array_combine(array('name', 'location', 'type'), $res_data));
				$res->set('assigned_user_id', 1);
				$res->save();
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
			showMemoryUsage("Resources");
		}


		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}
	$db->query('SET autocommit=1;');

	try {
		$db->query('START TRANSACTION;');
		if (have_demo('kb')) {
			$label = $mod_strings['LBL_CREATE_SAMPLE_ARTICLES'];
			include 'install/seed_data/kbSeedData.php';
			$n = is_countable($kb_seed_data) ? count($kb_seed_data) : 0;
			$i = 0;
			foreach ($kb_seed_data as $category) {
				install_kb_category($category);
				$progressIndicator->logProgress($label, ($i+1) / $n * 100);
				$i++;
			}
			$progressIndicator->logProgress($label, $mod_strings['LBL_DONE']);
		}
		$db->query('COMMIT;');
	} catch (Exception $e) {
		try { $db->query('ROLLBACK;'); } catch (Exception $e2) {}
		throw $e;
	}

} catch(IAHDatabaseError $e) {
	$progressIndicator->logMessage($e->getMessage(), 'error');
	$msg = $mod_strings['ERR_INSTALL_DEMO'];
	$progressIndicator->finish('crash', $msg);
	throw new IAHError($msg);
}

saveInstallerConfig();

AppConfig::lock_installer(! empty($_SESSION['setup_lock_demo_site']));

$progressIndicator->finish();

// DONE


function allocate_payment(&$invoice) {
	global $app_list_strings;
	global $currencies;
	$types = $app_list_strings['payment_type_dom'];
	if(rand(0, 1) > 0)
		$fraction = 10;
	else
		$fraction = rand(1, 9);
	$amount = sprintf('%0.2f', $invoice->getField('amount') * $fraction / 10);
	$currency = $currencies[$invoice->getField('currency_id')];
	$is_bill = ($invoice->getModelName() == 'Bill');
	$account_id = $invoice->getField($is_bill ? 'supplier_id' : 'billing_account_id');
	
	$payment = RowUpdate::blank_for_model('Payment');
	$payment->set(array(
		'direction' => ($is_bill ? 'outgoing' : 'incoming'),
		'amount' => $amount,
		'assigned_user_id' => $invoice->getField('assigned_user_id'),
		'account_id' => $account_id,
		'payment_date' => $invoice->getField('due_date'),
		'customer_reference' => sprintf('CRF-%d', rand(0, 100000)),
		'payment_type' => array_rand($types),
	));
	$payment->save();
	
	$link_name = ($is_bill ? 'bills' : 'invoices');
	$payment->addUpdateLink($link_name, array(
		'id' => $invoice->getPrimaryKeyValue(),
		'amount' => $amount,
		'amount_usdollar' => $currency->convertToDollar($amount),
		'currency_id' => $currency->id,
		'exchange_rate' => $currency->conversion_rate,
	));
}

function create_shipping(&$invoice) {
	return; // FIXME
	
	// $fraction = rand(1, 10);
	// $amount = sprintf('%0.2f', $invoice->amount * $fraction / 10);

	// $mgr = RowUpdate::blank_for_model('Shipping');
	// require_once('modules/Shipping/Shipping.php');
	// Shipping::init_from_po($mgr, $po);

	// $mgr->save();
	// return $mgr;
}

function create_receiving(&$po) {
	return; // FIXME
	
	// $fraction = rand(1, 10);
	// $amount = sprintf('%0.2f', $po->getField('amount') * $fraction / 10);

	// $mgr = RowUpdate::blank_for_model('Receiving');
	// require_once('modules/Receiving/Receiving.php');
	// Receiving::init_from_po($mgr, $po);

	// $mgr->save();
	// return $mgr;
}

// --
function &convert_quote_to_invoice($quote) {
	$inv = RowUpdate::blank_for_model('Invoice');
	require_once('modules/Invoice/Invoice.php');
	Invoice::init_from_tally($inv, $quote);
	$inv->set('due_date', create_date());
	$inv->save();
	return $inv;
}

// --
function &convert_quote_to_so($quote) {
	$so = RowUpdate::blank_for_model('SalesOrder');
	require_once('modules/SalesOrders/SalesOrder.php');
	SalesOrder::init_from_quote($so, $quote);
	$so->set('due_date', create_date());
	$so->set('so_stage', 'Ordered');
	$so->set('delivery_date', create_date());
	$so->save();
	return $so;
}

// --
function &create_quote_or_invoice($class, &$account) {
	global $products_created;
	global $providers;
	global $taxrates;
	global $discounts;
	global $currencies;
	global $app_list_strings;
	
	$mgr = RowUpdate::blank_for_model($class);
	require_bean($class);
	$data = call_user_func(array($class, 'init_from_account'), $account->id);
	if($data)
		$mgr->set($data);

	$mgr->set('currency_id', $account->currency_id);
	$mgr->set('assigned_user_id', 1);

	$due_date = rand(0, 1) > 0 ? create_date() : create_past_date();
	$mgr->set('due_date', $due_date);
	if($class == 'Quote')
		$mgr->set('valid_until', $due_date);
	if($class == 'Bill')
		$mgr->set('bill_date', create_past_date());

	$dom = ($class == 'SalesOrder' ? 'so_stage_dom' : 'quote_stage_dom');
	$stage = array_rand($app_list_strings[$dom]);
	$mgr->set('quote_stage', $stage);
	$mgr->set('terms', array_rand($app_list_strings['terms_dom']));
	$new_groups = array(
		'group~0' => array(
			'status' => $stage,
			'lines' => array() ,
			'adjusts' => array() ,
		) ,
	);
	$subtotal = 0.0;
	$used_products = array();
	for ($i = 0; $i < 3; $i++) {
		$prod_num = array_rand($products_created);
		if (isset($used_products[$prod_num])) continue;
		$used_products[$prod_num] = true;
		$prod = & $products_created[$prod_num];
		$mgr->set('name', $prod->name);
		if (($class == 'PurchaseOrder' || $class == 'Bill') && !empty($prod->supplier_id)) {
			$mgr->set('supplier_id', $prod->supplier_id);
		}
		$line_id = "line~$i";
		$new_groups['group~0']['lines'][$line_id] = array(
			'name' => $prod->name,
			'related_id' => $prod->id,
			'related_type' => 'ProductCatalog',
			'quantity' => ($i == 2 ? rand(2, 5) : 1),
			'mfr_part_no' => $prod->manufacturers_part_no,
			'cost_price' => $prod->cost,
			'list_price' => $prod->list_price,
			'unit_price' => $prod->purchase_price,
			'std_unit_price' => $prod->purchase_price,
			'tax_class_id' => STANDARD_TAXCODE_ID,
		);
		$subtotal += $prod->purchase_price;
	}
	$didx = array_rand($discounts);
	$adj_id = "adjdisc~0";
	$new_groups['group~0']['adjusts'][$adj_id] = array(
		'related_id' => $discounts[$didx]->getField('id'),
		'related_type' => 'Discounts',
		'type' => 'StandardDiscount',
		'rate' => $discounts[$didx]->getField('rate'),
		'name' => $discounts[$didx]->getField('name'),
		'amount' => 0.0,
	);
	$taxes = array(
		0,
		1
	); // GST, Ontario PST currently

	foreach($taxes as $tidx) {
		$adj_id = "adjtax~$tidx";
		$new_groups['group~0']['adjusts'][$adj_id] = array(
			'related_id' => $taxrates[$tidx]->getField('id'),
			'related_type' => 'TaxRates',
			'type' => $taxrates[$tidx]->getField('compounding') ? 'CompoundedTax' : 'StandardTax',
			'rate' => $taxrates[$tidx]->getField('rate'),
			'name' => $taxrates[$tidx]->getField('name'),
			'amount' => 0.0,
		);
	}
	$shipping = 0;
	if (rand(0, 1)) {
		$provider_num = array_rand($providers);
		$provider_id = $providers[$provider_num]->getField('id');
		$mgr->set('shipping_provider_id', $provider_id);
		$adj_id = "adjship~0";
		$new_groups['group~0']['adjusts'][$adj_id] = array(
			'related_id' => $provider_id,
			'related_type' => 'ShippingProviders',
			'type' => 'UntaxedShipping',
			'rate' => 0.0,
			'amount' => sprintf('%0.2f', $subtotal * rand(1, 7) / 100) ,
		);
	}
	
	$mgr->replaceGroups($new_groups);
	$mgr->save();
	return $mgr;
}

function create_opp_date() {
	global $timedate;
	$date = date($timedate->get_db_date_format());
	return $date;
}
function create_opp_past_date() {
	global $timedate;
	$date = date($timedate->get_db_date_format() , mktime(0, 0, 0, idate("m") , idate("d") + mt_rand(-5, -1) , idate("Y")));
	return $date;
}
function create_service_end_date($start_date) {
	global $timedate;
	list($m,$d,$y) = explode(' ', date('m d Y', strtotime($start_date)));
	$fmt = $timedate->get_db_date_format();
	$date = date($fmt, mktime(0, 0, 0, $m, $d+364, $y));
	return $date;	
}
function get_service_billing_day($start_date) {
	$day = idate('d', strtotime($start_date));
	return $day; 	
}

