<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

if( !isset( $install_script ) || !$install_script ){
    die($mod_strings['ERR_NO_DIRECT_SCRIPT']);
}

$dbType = '';

// longreach - start added - template support
require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WIZARD_TITLE'] .  $next_step);
$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_STEP'] . $next_step . ': ' . $mod_strings['LBL_CONFIRM_TITLE']);
$xtpl->assign('JAVASCRIPT', '');
$xtpl->assign('ONLOAD', '');
$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');
// longreach - end added


$dbCreate = "({$mod_strings['LBL_CONFIRM_WILL']} ";
if( $_SESSION['setup_db_create_database'] != 1 ){
	$dbCreate .= $mod_strings['LBL_CONFIRM_NOT'];
}
$dbCreate .= " {$mod_strings['LBL_CONFIRM_BE_CREATED']})";

$dbUser = "{$_SESSION['setup_db_sugarsales_user']} ({$mod_strings['LBL_CONFIRM_WILL']} ";
if( $_SESSION['setup_db_create_sugarsales_user'] != 1 ){
	$dbUser .= $mod_strings['LBL_CONFIRM_NOT'];
}
$dbUser .= " {$mod_strings['LBL_CONFIRM_BE_CREATED']})";

$yesNoDropCreate = ($_SESSION['setup_db_drop_tables']) ? $mod_strings['LBL_YES'] : $mod_strings['LBL_NO'];
if($_SESSION['setup_db_pop_demo_data']) {
	$yesNoDemoData = $mod_strings['LBL_YES'];
	if($_SESSION['setup_db_use_mb_demo_data'])
		$yesNoDemoData .= " ({$mod_strings['LBL_CONFIRM_MULTIBYTE']})";
} else
	$yesNoDemoData = $mod_strings['LBL_NO'];
$yesNoCustomSession = ($_SESSION['setup_site_custom_session_path'] == 1) ? $mod_strings['LBL_YES'] : $mod_strings['LBL_NO'];
$yesNoCustomLog = ($_SESSION['setup_site_custom_log'] == 1) ? $mod_strings['LBL_YES'] : $mod_strings['LBL_NO'];
$yesNoCustomId = ($_SESSION['setup_site_specify_guid'] == 1) ? $mod_strings['LBL_YES'] : $mod_strings['LBL_NO'];
$sample = $locale->getLocaleExampleName();
$nameFormat = $locale->getLocaleFormattedName($sample['first_name'], $sample['last_name'], $sample['salutation'], $_SESSION['default_locale_name_format']);
$numberFormat = $locale->sampleFormatNumber($_SESSION['default_number_format'], null, $_SESSION['default_currency_significant_digits']);
$addressFormat = $locale->translateAddressFormatName($_SESSION['default_address_format']);

// Populate the default date format, time format, and language for the system
$dateFormats = AppConfig::setting('locale.date_formats', array());
$timeFormats = AppConfig::setting('locale.time_formats', array());
$defaultDateFormat = array_get_default($dateFormats, $_SESSION['default_date_format'], $_SESSION['default_date_format']);
$defaultTimeFormat = array_get_default($timeFormats, $_SESSION['default_time_format'], $_SESSION['default_time_format']);
$defaultLanguage = AppConfig::setting('lang.labels.'.$_SESSION['default_language']);

///////////////////////////////////////////////////////////////////////////////
////	START OUTPUT

$out =<<<EOQ
<div class="row page-row">
<div class="column page-column">
<p>{$mod_strings['LBL_CONFIRM_DIRECTIONS']}</p>

<table width="100%" cellpadding="0" cellpadding="0" border="0" class="install-summary system-checks">
<thead>
	<tr><th colspan="2" align="left">{$mod_strings['LBL_DBCONF_TITLE']}</th></tr>
</thead>
<tbody>
	{$dbType}
	<tr>
		<td>{$mod_strings['LBL_DBCONF_DB_NAME']}</td>
		<td width="50%">
			{$_SESSION['setup_db_database_name']} {$dbCreate}
		</td>
	</tr>
	<tr>
		<td>{$mod_strings['LBL_DBCONF_DB_USER']}</td>
		<td>{$dbUser}</td>
	</tr>
	<tr>
		<td>{$mod_strings['LBL_DBCONF_DB_DROP_CREATE']}</td>
		<td>{$yesNoDropCreate}</td>
	</tr>
	<tr>
		<td>{$mod_strings['LBL_DBCONF_DEMO_DATA']}</td>
		<td>{$yesNoDemoData}</td>
	</tr>
	<tr>
		<td>{$mod_strings['LBL_DBCONF_PRIV_USER']}</td>
		<td>{$_SESSION['setup_db_admin_user_name']}</td>
	</tr>
	<tr class="spacer"><td colspan="2">&nbsp;</td></tr>
</tbody>
<thead>
	<tr>
		<th colspan="2" align="left">{$mod_strings['LBL_SITECFG_TITLE']}</th>
	</tr>
</thead>
<tbody>
	<tr>
		<td>{$mod_strings['LBL_SITECFG_URL']}</td>
		<td>{$_SESSION['setup_site_url']}</td>
	</tr>
	<tr>
		<td>{$mod_strings['LBL_SERVER_TIMEZONE']}</td>
		<td>
			{$_SESSION['setup_server_timezone']}
		</td>
	</tr>
	<tr class="spacer"><td colspan="2">&nbsp;</td></tr>
</tbody>
<thead>
	<tr>
		<th colspan="2" align="left">{$mod_strings['LBL_SITECFG_SITE_SECURITY']}</th>
	</tr>
</thead>
<tbody>
	<tr>
		<td>{$mod_strings['LBL_SITECFG_CUSTOM_SESSION']}?</td>
		<td>{$yesNoCustomSession}</td>
	</tr>
	<tr>
		<td>{$mod_strings['LBL_SITECFG_CUSTOM_LOG']}?</td>
		<td>{$yesNoCustomLog}</td>
	</tr>
	<tr>
		<td>{$mod_strings['LBL_SITECFG_CUSTOM_ID']}?</td>
		<td>{$yesNoCustomId}</td>
	</tr>
	<tr class="spacer"><td colspan="2">&nbsp;</td></tr>
</tbody>
<thead>
	<tr>
		<th colspan="2" align="left">{$mod_strings['LBL_LOCALE_TITLE']}</th>
	</tr>
</thead>
<tbody>
	<tr>	
		<td>
			{$mod_strings['LBL_LOCALE_DATEF']}
		</td>
		<td>
			{$defaultDateFormat}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_TIMEF']}
		</td>
		<td>
			{$defaultTimeFormat}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_LANG']}
		</td>
		<td>
			{$defaultLanguage}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_NAMEF']}
		</td>
		<td>
			{$nameFormat}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_ADDRESS_FORMAT']}
		</td>
		<td>
			{$addressFormat}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_EMAIL_CHARSET_TITLE']}
		</td>
		<td>
			{$_SESSION["default_email_charset"]}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_EXPORT']}
		</td>
		<td>
			{$_SESSION["default_export_charset"]}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_EXPORT_FORMAT']}
		</td>
		<td>
			{$_SESSION["default_export_format"]}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_CURR_DEFAULT']}
		</td>
		<td>
			{$_SESSION["default_currency_name"]}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_CURR_SYMBOL']}
		</td>
		<td>
			{$_SESSION["default_currency_symbol"]}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_CURR_ISO']}
		</td>
		<td>
			{$_SESSION["default_currency_iso4217"]}
		</td>
	</tr>
	<tr>
		<td>
			{$mod_strings['LBL_LOCALE_NUMBER_FORMAT']}
		</td>
		<td>
			{$numberFormat}
		</td>
	</tr>
	<tr class="spacer"><td colspan="2">&nbsp;</td></tr>
</tbody>
</table>

</div></div>

EOQ;
echo $out;

// longreach - start added

$buttons = array(
	array('TITLE' => $mod_strings['LBL_BACK'], 'NAME' => 'Back', 'TYPE' => 'button',
		'ONCLICK' => "this.form.goto.value='Back'; this.form.submit();", 'ICON' => 'arrow-left'),
	array('TITLE' => $mod_strings['LBL_INSTALL'], 'NAME' => 'Next', 'TYPE' => 'submit',
		'ONCLICK' => "this.form.goto.value='Next';", 'ICON' => 'accept', 'CLASS' => 'lwib-accept'),
	);
installer_show_buttons($xtpl, $buttons, $next_step);
$xtpl->parse('foot');
$xtpl->out('foot');

// longreach - end added
?>
