<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
********************************************************************************/

// $Id: dbConfig.php,v 1.5 2006/03/19 02:03:13 andy Exp $

if( !isset( $install_script ) || !$install_script ){
    die('Unable to process script directly.');
}

$setup_db_conn_test_result = -1;

if(empty($_SESSION['dbConfig_submitted'])){
    // set the form's php var to the loaded config's var else default to sane settings
    $have_primary = ! is_null(AppConfig::setting('database.primary'));
    $_SESSION['setup_db_host_name']     = AppConfig::setting(array('database.primary.host_name', 'install.defaults.database.host_name'), 'localhost');
    $_SESSION['setup_db_database_name'] = AppConfig::setting(array('database.primary.name', 'install.defaults.database.name'), 'onecrm');
    $_SESSION['setup_db_create_database']   = $have_primary ? false : AppConfig::setting('install.defaults.database.create_database', false);
    $_SESSION['setup_db_drop_tables']       = $have_primary ? true : AppConfig::setting('install.defaults.database.drop_tables', false);
    $_SESSION['setup_db_pop_demo_data']     = $have_primary ? false : AppConfig::setting('install_demo.add_demo_data', false);
    $_SESSION['setup_db_use_mb_demo_data']  = AppConfig::setting('install_demo.multibyte_data', false);
    if($_SESSION['setup_db_use_mb_demo_data'] === true)
    	$_SESSION['setup_db_use_mb_demo_data'] = 'yes';
    $_SESSION['setup_db_admin_user_name']   = AppConfig::setting('install.defaults.database.privileged_user_name', 'root');
    $_SESSION['setup_db_admin_password']    = AppConfig::setting('install.defaults.database.privileged_user_password', '');
    $_SESSION['setup_db_create_sugarsales_user']    = AppConfig::setting('install.defaults.database.create_user', false);
    $_SESSION['setup_db_sugarsales_user']       = AppConfig::setting(array('database.primary.user_name', 'install.defaults.database.user_name'), 'root');
    $_SESSION['setup_db_sugarsales_password']   = AppConfig::setting(array('database.primary.password', 'install.defaults.database.password'), '');
    $_SESSION['setup_db_sugarsales_password_retype']    = $_SESSION['setup_db_sugarsales_password'];
    $_SESSION['setup_db_username_is_privileged'] = ($_SESSION['setup_db_sugarsales_user'] == 'root');
}

$validationErr = '';
if( isset($validation_errors) ){
	if( is_countable($validation_errors) && count($validation_errors) > 0 ){
		 $validationErr  = '<div id="errorMsgs" class="alert alert-danger" role="alert">';
		 $validationErr .= '<p><span class="glyphicon glyphicon-exclamation-sign"></span> ';
		 $validationErr .= $mod_strings['ERR_DBCONF_VALIDATION'] . '</p>';
		 $validationErr .= '<ul>';

		 foreach( $validation_errors as $error ){
				$validationErr .= '<li>' . $error . '</li>';
		 }
		 $validationErr .= '</ul>';
		 $validationErr .= '</div>';
	}
}


// DB split 
$createDbCheckbox = '';
$createDb = (! empty($_SESSION['setup_db_create_database'])) ? 'checked="checked"' : '';
$dropCreate = (! empty($_SESSION['setup_db_drop_tables'])) ? 'checked="checked"' : ''; 
$demoData = (! empty($_SESSION['setup_db_pop_demo_data'])) ? 'checked="checked"' : '';
$mbDemoData = (isset($_SESSION['setup_db_use_mb_demo_data']) && $_SESSION['setup_db_use_mb_demo_data'] == 'yes') ? 'checked="checked"' : '';
$instanceName = array_get_default($_SESSION, 'setup_db_host_instance', '');
$dbUserChk = (isset($_SESSION['setup_db_create_sugarsales_user']) && !empty($_SESSION['setup_db_create_sugarsales_user'])) ? 'checked="checked"' : '';
$createDbCheckbox = "<div class='input-field input-addon input-check border-left'><input type='checkbox' name='setup_db_create_database' id='setup_db_create_database' onclick='toggleDropTables();' value='yes' {$createDb}><label class='input-label'> {$mod_strings['LBL_DBCONF_CREATE_DB']}</label></div>";
$dbPrivChk = isset($_SESSION['setup_db_username_is_privileged']) && !empty($_SESSION['setup_db_username_is_privileged']);
$reqd = '<span class="requiredStar">*</span>';


///////////////////////////////////////////////////////////////////////////////
////	BEGIN PAGE OUTPUT



// longreach - start added - template support
require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WIZARD_TITLE'] .  $next_step);
$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_STEP'] . $next_step . ': ' . $mod_strings['LBL_DBCONF_TITLE']);
$js = '<script type="text/javascript" src="install/dbConfig.js"></script>';
$xtpl->assign('JAVASCRIPT', $js);
$onload = "showMb();toggleDropTables();toggleCreateUser();toggleUsernameIsPrivileged();";
$xtpl->assign('ONLOAD', $onload);
$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');


$out = <<<EOQ
<div class="row page-row">
<div class="column page-column">
<p>{$mod_strings['LBL_DBCONF_INSTRUCTIONS']}</p>
</div></div>
{$validationErr}

<div class="row page-row">
<div class="column page-column">
<div class="panel-outer panel-default panel-border panel-round">
<div class="panel-body panel-pad-body">

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_db_host_name" class="form-label">{$mod_strings['LBL_DBCONF_HOST_NAME']}</label>
<div class="form-value">
<input type="text" class="input-text" name="setup_db_host_name" id="setup_db_host_name" value="{$_SESSION['setup_db_host_name']}" size="40">{$reqd}
</div></div>
</div>
</div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_db_database_name" class="form-label">{$mod_strings['LBL_DBCONF_DB_NAME']}</label>
<div class="form-value">
	<div class="input-field input-field-group form-value-line">
	<input type="text" class="input-text default-focus" name="setup_db_database_name" id="setup_db_database_name" value="{$_SESSION['setup_db_database_name']}" size="20">
	{$createDbCheckbox}</div>{$reqd}
	<div id="drop_tables">
	<div class="form-value-line input-field input-check flat"><input type="checkbox" name="setup_db_drop_tables" value="yes" {$dropCreate}><label class="input-label"> {$mod_strings['LBL_DBCONF_DB_DROP_CREATE']}</label></div>
	<p class="form-value-line form-text text-muted">{$mod_strings['LBL_DBCONF_DB_DROP_CREATE_WARN']}</p>
	</div>
</div></div>
</div>
</div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_db_sugarsales_user" class="form-label">{$mod_strings['LBL_DBCONF_DB_USER']}</label>
<div class="form-value">
	<div class="input-field input-field-group">
	<input type="text" class="input-text" name="setup_db_sugarsales_user" id="setup_db_sugarsales_user" maxlength="16" value="{$_SESSION['setup_db_sugarsales_user']}" size="20">
	<div class="input-addon input-field input-check border-left"><input type="checkbox" name="setup_db_create_sugarsales_user" id="setup_db_create_sugarsales_user" onclick="toggleCreateUser();" value="yes" {$dbUserChk}>
	<label class="input-label"> {$mod_strings['LBL_DBCONF_CREATE_USER']}</label></div>
	</div>{$reqd}
	<div class="form-value-line">
	<div class="input-field input-check flat" id="is_privileged"><input type="checkbox" name="setup_db_username_is_privileged" id="setup_db_username_is_privileged" value="yes" onclick="toggleUsernameIsPrivileged();" {$dbPrivChk}><label class="input-label"> {$mod_strings['LBL_DBCONF_PRIV_USER_2']}</label></div>
	</div>
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_db_sugarsales_password" class="form-label">{$mod_strings['LBL_DBCONF_DB_PASSWORD']}</label>
<div class="form-value">
	<input type="password" class="input-text" name="setup_db_sugarsales_password" id="setup_db_sugarsales_password" value="{$_SESSION['setup_db_sugarsales_password']}" size="20">
</div></div>
</div></div>

<div id="password_retype_required" class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_db_sugarsales_password_retype" class="form-label">{$mod_strings['LBL_DBCONF_DB_PASSWORD2']}</label>
<div class="form-value">
	<input type="password" class="input-text" name="setup_db_sugarsales_password_retype" id="setup_db_sugarsales_password_retype" value="{$_SESSION['setup_db_sugarsales_password_retype']}" size="20">
</div></div>
</div></div>

<div id="privileged_user_info">
<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_db_admin_user_name" class="form-label">{$mod_strings['LBL_DBCONF_PRIV_USER']}</label>
<div class="form-value">
	<input type="text" class="input-text" name="setup_db_admin_user_name" id="setup_db_admin_user_name" value="{$_SESSION['setup_db_admin_user_name']}" size="20">{$reqd}
	<p class="form-value-line form-text text-muted">{$mod_strings['LBL_DBCONF_PRIV_USER_DIRECTIONS']}</p>
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_db_admin_password" class="form-label">{$mod_strings['LBL_DBCONF_PRIV_PASS']}</label>
<div class="form-value">
	<input type="password" class="input-text" name="setup_db_admin_password" id="setup_db_admin_password" value="{$_SESSION['setup_db_admin_password']}" size="20">
</div></div>
</div></div>
</div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="demoData" class="form-label">{$mod_strings['LBL_DBCONF_DEMO_OPTS']}</label>
<div class="form-value">
<div class="input-field input-check flat"><input type="checkbox" id="demoData" name="setup_db_pop_demo_data" value="yes" {$demoData} onClick="showMb();"><label class="input-label"> {$mod_strings['LBL_DBCONF_DEMO_DATA']}</label></div>
<div class="form-value-line">
<div class="input-field input-check flat" id="demo_mb"><input type="checkbox" id="mbCheckbox" name="setup_db_use_mb_demo_data" value="yes" {$mbDemoData}><label class="input-label"> {$mod_strings['LBL_DBCONF_MB_DEMO_DATA']}</label></div>
</div>
</div></div>
</div></div>

</div></div>
</div>
</div>
</div>

EOQ;

echo $out;


////	END PAGE OUTPUT
///////////////////////////////////////////////////////////////////////////////


// longreach - start added


$buttons = array(
	array('TITLE' => $mod_strings['LBL_BACK'], 'NAME' => 'Back', 'TYPE' => 'button',
		'ONCLICK' => "this.form.goto.value='Back'; this.form.submit();", 'ICON' => 'arrow-left'),
	array('TITLE' => $mod_strings['LBL_NEXT'], 'NAME' => 'Next', 'TYPE' => 'submit',
		'ONCLICK' => "this.form.goto.value='Next';", 'ICON' => 'arrow-right', 'CLASS' => 'lwib-accept'),
);
installer_show_buttons($xtpl, $buttons, $next_step);
$xtpl->parse('foot');
$xtpl->out('foot');

// longreach - end added
?>
