<?php

include 'install/demoOptions.php';

require_once 'include/JSON.php';

$json = new JSON(JSON_LOOSE_TYPE);
$encoded_options = $json->encode($demo_options);

$javascript = <<<SCRIPT
<script type="text/javascript">
	demo_options= {$encoded_options};


function find_parent(options, id)
{
	for (var i in options) {
		var opt = options[i];
		if (opt.kids) {
			for (var j in opt.kids) {
				if (j == id) {
					return opt;
				}
			}
			var found = find_parent(opt.kids, id);
			if (found) return found;
		}
	}
	return false;
}

function find_opt(options, id)
{
	for (var i in options) {
		var opt = options[i];
		if (i == id) return opt;
		if (opt.kids) {
			for (var j in opt.kids) {
				if (j == id) {
					return opt.kids[j];
				}
			}
			var found = find_opt(opt.kids, id);
			if (found) return found;
		}
	}
	return false;
}


function check_required(id, checked)
{
	if (checked) {
		var me = demo_options[id];
		if (me.parent) {
			document.getElementById(me.parent).checked = true;
			check_required(me.parent, checked);
		}
		if (me.required) {
			for (var i=0; i < me.required.length; i++) {
				document.getElementById(me.required[i]).checked = true;
				check_required(me.required[i], checked);
			}
		}
	} else {
		var me = demo_options[id];
		if (me.kids) {
			for (var i=0; i < me.kids.length; i++) {
				if (document.getElementById(me.kids[i]).checked) {
					document.getElementById(me.kids[i]).checked = false;
					check_required(me.kids[i], checked);
				}
			}
		}

		for (var i in demo_options) {
			var opt = demo_options[i];
			if (opt.required) {
				for (var j=0; j < opt.required.length; j++) {
					if (opt.required[j] == id) {
						if (document.getElementById(i).checked) {
							document.getElementById(i).checked = false;
							check_required(i, checked);
						}
						break;
					}
				}
			}
		}
	}
}

function demo_checkall(checked)
{
	for (var i in demo_options) {
		document.getElementById(i).checked = checked;
	}		
}

</script>
SCRIPT;

foreach ($demo_options as $name => $opts) {
	$demo_options[$name]['checked'] = isset ($_SESSION['demo_options'][$name]) && empty($_SESSION['demo_options'][$name]) ? '' : 'checked="checked"';
}

require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WIZARD_TITLE'] .  $next_step);
$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_STEP'] . $next_step . ' : ' . $mod_strings['LBL_DEMOCONF_TITLE']);
$xtpl->assign('JAVASCRIPT', $javascript);

$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');

$out = <<<OUT
<div class="column page-column">
<div style="width: 70%; margin: 0.5em auto">
<div class="input-field input-check flat">
	<input id="demo_all" type="checkbox" onclick="demo_checkall(this.checked)">
	<label class="input-label bold">
		{$mod_strings['LBL_CHECK_UNCHECK']}
	</label>
</div>
<hr>
</div>
<div style="width: 70%; margin: 0.5em auto">
OUT;

$out .= options_tree($demo_options);
$out .= '</div></div>';

echo $out;

$buttons = array(
	array('TITLE' => $mod_strings['LBL_BACK'], 'NAME' => 'Back', 'TYPE' => 'button',
		'ONCLICK' => "this.form.goto.value='Back'; this.form.submit();", 'ICON' => 'arrow-left'),
	array('TITLE' => $mod_strings['LBL_NEXT'], 'NAME' => 'Next', 'TYPE' => 'submit',
		'ONCLICK' => "this.form.goto.value='Next';", 'ICON' => 'arrow-right', 'CLASS' => 'lwib-accept'),
	);
$xtpl->assign('BUTTONS_CLASS', 'sm-lifted-1');
installer_show_buttons($xtpl, $buttons, $next_step);
$xtpl->parse('foot');
$xtpl->out('foot');


function options_tree($all, $options = null, $level = 0)
{
	global $mod_strings;
	$indent = $level * 30;
	$ret = '';
	if (!$level) {
		$options = $all;
	}
	foreach ($options as $name => $opts) {
		if ($level) {
			$name = $opts;
			$opts = $all[$opts];
		}
		if ($opts['level'] != $level) continue;
		$label = $mod_strings[$opts['label']];
		$ret .= <<<DIV
<div id="display_{$name}" style="padding-left:{$indent}px;">
<div class="input-field input-check flat">
	<input type="hidden" name="demo_{$name}" value="">
	<input {$opts['checked']} id="{$name}" type="checkbox" name="demo_{$name}" onclick="check_required(this.id, this.checked)">
	<label class="input-label" for="{$name}">
		{$label}
	</label>
</div>
</div>
DIV;
		if (!empty($opts['kids'])) {
			$ret .= options_tree($all, $opts['kids'], $level+1);
		}
	}
	return $ret;
}
