<?php

require_once('include/utils.php');
require_once('include/database/PearDatabase.php');
require_once('include/database/DBManager.php');
require_once('include/utils/file_utils.php');
require_once 'modules/Users/User.php';

require_once 'include/ProgressIndicator.php';
$progressIndicator = new ProgressIndicator(AppConfig::setting('install_demo.progress_log'), true);

include 'install/demoOptions.php';
foreach ($demo_options as $name => $opts) {
	$_SESSION['demo_options'][$name] = !empty($_POST['demo_' . $name]);
}

$db = DBManager::getInstance();

$current_user = new User();
$current_user->retrieve(1);

require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WIZARD_TITLE'] .  $next_step);
$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_STEP'] . $next_step . ': ' . $mod_strings['LBL_DEMOSETUP_TITLE']);
$xtpl->assign('JAVASCRIPT', '');
$xtpl->assign('ONLOAD', "startProgressIndicator('demo');");

$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');

if(!empty($_SESSION['setup_save_config']) ) {
	$xtpl->assign('LBL_DOWNLOAD_CONFIG', $mod_strings['LBL_DOWNLOAD_CONFIG']);
	$xtpl->assign('CONFIG_PATH', InstallerConfigParser::finalConfigPath());
	$xtpl->parse('async.config_download');
}

$xtpl->parse('async');
$xtpl->out('async');

$buttons = array(
	array(
		'TITLE' => $mod_strings['LBL_FINISH'],
		'NAME' => 'Next',
		'TYPE' => 'submit',
		'ONCLICK' => "this.form.goto.value='Finish';",
		'ID' => 'Next',
		'ATTRS' => 'disabled="disabled"',
		'ICON' => 'accept',
		'CLASS' => 'lwib-accept',
	),
);
installer_show_buttons($xtpl, $buttons, $next_step);
$xtpl->parse('foot');
$xtpl->out('foot');


