/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/


function showInstallGuide() {
	window.open('docs/InstallGuide.pdf');
}

function installFormInit() {
	defaultFocus();
}

function disableButtons() {
	inputs = document.getElementsByTagName('input');
	for(i = 0; i < inputs.length; i++)
		if(inputs[i].type == 'button' || inputs[i].type == 'submit')
			inputs[i].disabled = 'disabled';
}


// set by caller
var setup_demo   = '';
var async_dotdot = '...';
var async_prefix = 'Performing: ';
var async_failed = 'Installation failed. Please check your server error logs.';


function show_async_message(div, icon, msg, indent) {
	var sub = document.createElement('div');
	sub.style.margin = '0.25em 0';
	var span = document.createElement('span');
	span.className = icon;
	span.style.display = 'inline-block';
	span.style.fontSize = '110%';
	span.style.width = '25px';
	if(indent) {
		sub.style.paddingLeft = '55px';
		span.style.marginLeft = '-25px';
	}
	sub.appendChild(span);
	sub.appendChild(document.createTextNode(msg));
	div.appendChild(sub);
}

var install_progress = {
	std_failure_msg: async_failed,
	doing_demo: false,
	start_http: true,
	sync_run: true,
	start_url: 'install.php?async={ACTION}',
	poll_url: 'install.php?async=progress&async_process={ACTION}&async_timestamp={TIMESTAMP}',
	start: function() {
		//console.log('start: '+this.action);
		var div = $('current');
		div.innerHTML = '';
		toggleDisplay(div, true);
		toggleDisplay('meter', true);
	},
	history: function(hist) {
		var msg, icon, div = $('history');
		show_async_message(div, 'uii uii-ok go', hist.name);
		if(hist.messages) {
			for(var i = 0; i < hist.messages.length; i++) {
				msg = hist.messages[i];
				if(msg.severity == 'error')
					icon = 'uii uii-danger stop';
				else
					icon = 'uii uii-info optional';
				show_async_message(div, icon, msg.message, 1);
			}
		}
	},
	progress: function(percent, process) {
		var div = $('current'), p1 = $('progress1');
		div.innerHTML = '';
		if(process)
			show_async_message(div, 'uii uii-hourglass text-muted', async_prefix + process + async_dotdot);
		p1.style.width = '' + percent + '%';
	},
	complete: function(status, msg) {
		var div = $('current'),
			next_btn = $('Next');
		toggleDisplay(div, false);
		if(! install_progress.doing_demo && parseInt(setup_demo, 10) > 0) {
			install_progress.doing_demo = true;
			startProgressIndicator('demo&auto=1');
		} else {
			toggleDisplay('meter', false);
			if(next_btn) {
				next_btn.disabled = false;
				next_btn.focus();
			}
			toggleDisplay('config_download', true);
		}
	},
	error: function(msg) {
		toggleDisplay('current', false);
		toggleDisplay('meter', false);
		show_async_message($('history'), 'uii uii-danger stop', msg);
	},
	start_complete: function() {
		//console.log('complete: '+this.action);
	}
};

function startProgressIndicator(action)
{
	var checker = new SUGAR.conn.ProgressChecker(install_progress);
	checker.start(action);
}
