<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/



if(! defined('IAH_IN_INSTALLER')) {
    die($mod_strings['ERR_NO_DIRECT_SCRIPT']);
}


// longreach - replaced - added template support and customized message

require_once('install/install_utils.php');

if(check_install_permissions($reason))
	$reason = 'locked';

require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);

if($reason == 'locked') {
	if (CLI_INSTALLER) {
		die ($mod_strings['LBL_DISABLED_TITLE'] . "\n" . $mod_strings['LBL_DISABLED_TITLE_SHORT'] ."\n");
	}
	$page_title = $mod_strings['LBL_DISABLED_TITLE'];
	$header_title = $mod_strings['LBL_DISABLED_TITLE_2'];
	$subheader_title = $mod_strings['LBL_DISABLED_TITLE_SHORT'];
	
	$install_disabled = '<p>' . str_replace('{CONFIG_PATH}', AppConfig::local_config_path(), $mod_strings['LBL_DISABLED_DESCRIPTION']) . '</p>';
	$install_disabled .= "<pre class=\"sample\">site\n    installer_locked: false</pre>";
	$install_disabled .= '<p>' . $mod_strings['LBL_DISABLED_DESCRIPTION_2'] . '</p>';
} else {
	$page_title = $mod_strings['LBL_ERROR_TITLE'];
	$header_title = $mod_strings['LBL_ERROR_TITLE_2'];
	
	if($reason == 'cachedir') {
		$subheader_title = $mod_strings['LBL_CACHEDIR_TITLE'];
		$cache_dir = str_replace('/', DIRECTORY_SEPARATOR, AppConfig::cache_dir() . 'system/');
		$basepath = realpath('.');
		if($basepath) $cache_dir = $basepath . DIRECTORY_SEPARATOR . $cache_dir;
		$install_disabled = '<p>' . $mod_strings['LBL_CACHEDIR_DESCRIPTION'] . '</p>';
		$install_disabled .= '<pre class="sample">' . $cache_dir . '</pre>';
		if (CLI_INSTALLER) {
			die (
				$mod_strings['LBL_CACHEDIR_TITLE'] 
				. "\n" . $mod_strings['LBL_CACHEDIR_DESCRIPTION'] . $cache_dir . "\n"
			);
		}
	}
	else if($reason == 'session') {
		$subheader_title = $mod_strings['LBL_SESSION_ERR_TITLE'];
		$phpIniLocation = get_cfg_var("cfg_file_path");
		$install_disabled = '<p>' . $mod_strings['LBL_SESSION_ERR_DESCRIPTION'] . '</p>';
		$install_disabled .= '<pre class="sample">' . $phpIniLocation . '</pre>';

		if (CLI_INSTALLER) {
			die(
				$mod_strings['LBL_SESSION_ERR_TITLE']
				. "\n" . $mod_strings['LBL_SESSION_ERR_DESCRIPTION']
				. $phpIniLocation . "\n"
			);
		}
	}
}

require_once('vendor_info.php');
$support_help = $mod_strings['LBL_DISABLED_HELP'];
$support_help = str_replace('{SUPPORT_EMAIL}', $vendor_info['email_support'], $support_help);
$support_help = str_replace('{SUPPORT_GUIDE}', $vendor_info['implementation_guide'], $support_help);
$install_disabled .= '<p>' . $support_help . '</p>';

$xtpl->assign('PAGE_TITLE', $page_title);
$xtpl->assign('HEADER_TITLE', $header_title);
$xtpl->assign('JAVASCRIPT', '');
$xtpl->assign('ONLOAD', '');
$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');

if(isset($subheader_title))
	$install_disabled = '<h3>' . $subheader_title . '</h3>' . $install_disabled;
$xtpl->assign('CONTENT', $install_disabled);
$xtpl->parse('main.bg_row');
$xtpl->parse('main');
$xtpl->out('main');

// buttons
$buttons = array(
	array('TITLE' => 'Retry', 'NAME' => 'goto', 'TYPE' => 'submit', 'ID'=> 'defaultFocus', 'ICON' => 'refresh'),
	);
installer_show_buttons($xtpl, $buttons, 0);
$xtpl->parse('foot');
$xtpl->out('foot');

?>
