<?php

require_once 'modules/UWizard/UWizard.php';

class InstallerLangPack
{
	private $errors = array();

	public function getErrors()
	{
		return $this->errors;
	}

	public function processRequest()
	{
		unset($_SESSION['UWizard_result']);
		$action = array_get_default($_REQUEST, 'languagePackAction');
		switch ($action) {
			case 'upload':
				return $this->processUpload();
				break;
			case 'delete':
				return $this->processDelete();
				break;
			case 'install':
				return $this->processInstall();
				break;
			case 'uninstall':
				return $this->processUninstall();
				break;
		}
		return '';
	}

	private function processUpload()
	{
		$error = translate(UWizard::upload('language_pack', 'langpack'), 'UWizard');
		if ($error) {
			$this->errors[] = $error;
		}
	}

	private function processInstall()
	{
		$zipfile = array_get_default($_REQUEST, 'source');
		$result = UWizard::quickInstall($zipfile);
		if($result['status'] != 'success') {
			$this->errors[] = $result['message'];
			return false;
		}
		installer_load_language(array_get_default($_REQUEST, 'language'), true, true);
		return true;
	}

	private function processDelete()
	{
		$zipfile = array_get_default($_REQUEST, 'source');
		UWizard::deletePackage($zipfile);
	}

	private function processUninstall()
	{
		$zipfile = array_get_default($_REQUEST, 'source');
		$result = UWizard::quickUninstall($zipfile);
		if($result['status'] != 'success') {
			$this->errors[] = $result['message'];
			return false;
		}
		installer_load_language(array_get_default($_REQUEST, 'language'), true, true);
		return true;
	}

}

