<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2005 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

// $Id: license.php,v 1.11 2005/07/22 00:47:09 bob Exp $

if( !isset( $install_script ) || !$install_script ){
    die('Unable to process script directly.');
}

// setup session variables (and their defaults) if this page has not yet been submitted
if(!isset($_SESSION['license_submitted']) || !$_SESSION['license_submitted']){
    $_SESSION['setup_license_accept'] = false;
}

$license_file_name = "LICENSE.txt";
$license_file = file_get_contents($license_file_name);
if(! $license_file)
	die("License file not found!");

// longreach - replaced - added template support

require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WIZARD_TITLE'] .  $next_step);
$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_STEP'] . $next_step . ': ' . $mod_strings['LBL_LICENSE_ACCEPTANCE']);
$xtpl->assign('JAVASCRIPT', '<script type="text/javascript" src="install/license.js"></script>');
$xtpl->assign('ONLOAD', 'toggleNextButton();');
$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');

$license_html = <<<EOL
<div class="text-center">
<textarea id="license-text" cols="80" rows="20" class="input-text" readonly="readonly" tabindex="1">{$license_file}</textarea>
</div><br>
EOL;

// main page content
$xtpl->assign('CONTENT', $license_html);
$xtpl->parse('main.bg_row');

$checked = (isset($setup_license_accept) && $setup_license_accept ? 'checked="on"' : '');
$extra_html = <<<END_EXTRA
<div class="row page-row">
	<div class="column page-column text-right">
        <button type="button" class="input-button" name="print_license" tabindex="1" onclick="window.open('install.php?page=licensePrint&language={$current_language}');">
        <span class="uii uii-print"></span> <span class="input-label">{$mod_strings['LBL_LICENSE_PRINTABLE']}</span></button>
	</div>
	<div class="column page-column text-left">
        <div class="input-field accept-label input-check"><input type="checkbox" name="setup_license_accept" onclick="toggleNextButton();" value="1"  class="default-focus" tabindex="1" {$checked} />
        <label class="input-label"> {$mod_strings['LBL_LICENSE_I_ACCEPT']}</label></div>
	</div>
</div>
END_EXTRA;

// main page content
$xtpl->assign('CONTENT', $extra_html);
$xtpl->parse('main.row');

// output main
$xtpl->parse('main');
$xtpl->out('main');

// buttons
$buttons = array(
	array('TITLE' => $mod_strings['LBL_BACK'], 'NAME' => 'Back', 'TYPE' => 'button',
		'ONCLICK' => "this.form.goto.value='Back'; this.form.submit();", 'ICON' => 'arrow-left'),
	array('TITLE' => $mod_strings['LBL_NEXT'], 'NAME' => 'Next', 'TYPE' => 'submit', 'ID'=> 'button_next',
		'ONCLICK' => "this.form.goto.value='Next';", 'ICON' => 'arrow-right', 'CLASS' => 'lwib-accept',
		'ATTRS' => 'disabled="disabled"'),
	);
$xtpl->assign('BUTTONS_CLASS', 'sm-lifted-1');
installer_show_buttons($xtpl, $buttons, $next_step);
$xtpl->parse('foot');
$xtpl->out('foot');

?>
