<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc. All Rights
 * Reserved. Contributor(s): ______________________________________..
 * *******************************************************************************/

if( !isset( $install_script ) || !$install_script ){
    die($mod_strings['ERR_NO_DIRECT_SCRIPT']);
}

require_once('include/utils/zip_utils.php');
require_once('include/utils/file_utils.php');
require_once('include/upload_file.php');
require_once('include/dir_inc.php');

///////////////////////////////////////////////////////////////////////////////
////    PREP VARS FOR LANG PACK
$base_upgrade_dir       = AppConfig::setting('site.paths.upgrades_dir', AppConfig::setting('site.paths.upload_dir').'upgrades');
$base_tmp_upgrade_dir   = $base_upgrade_dir."/temp";
///////////////////////////////////////////////////////////////////////////////    

$errors = array();

///////////////////////////////////////////////////////////////////////////////
////    PRELOAD DISPLAY DATA
$upload_max_filesize = ini_get('upload_max_filesize');
$upload_max_filesize_bytes = return_bytes($upload_max_filesize);
$fileMaxSize ='';
define('SUGARCRM_MIN_UPLOAD_MAX_FILESIZE_BYTES', 6 * 1024 * 1024);
if($upload_max_filesize_bytes < constant('SUGARCRM_MIN_UPLOAD_MAX_FILESIZE_BYTES')) {
    $GLOBALS['log']->debug("detected upload_max_filesize: $upload_max_filesize");
    $fileMaxSize = '<p class="error">'.$mod_strings['ERR_UPLOAD_MAX_FILESIZE']."</p>\n";
}
//$availableLanguagePacks = getLangPacks();
//$installedLanguagePacks = getInstalledLangPacks();

$datef = array_get_default($_SESSION, 'default_date_format', AppConfig::setting('locale.defaults.date_format'));
$timef = array_get_default($_SESSION, 'default_time_format', AppConfig::setting('locale.defaults.time_format'));
$dlang = array_get_default($_SESSION, 'default_language', AppConfig::setting('locale.defaults.language'));

$dateFormat = get_select_options_with_id(AppConfig::setting('locale.date_formats'), $datef);
$timeFormat = get_select_options_with_id(AppConfig::setting('locale.time_formats'), $timef);
$langs = AppConfig::get_languages();
foreach($langs as $k => &$v)
	$v .= " ($k)";
$languages  = get_select_options_with_id($langs, $dlang);
$nameFormat = array_get_default($_SESSION, 'default_locale_name_format', AppConfig::setting('locale.defaults.name_format'));
$defaultCurrencyName = array_get_default($_SESSION, 'default_currency_name', AppConfig::setting('locale.base_currency.name'));
$defaultCurrencySymbol = array_get_default($_SESSION, 'default_currency_symbol', AppConfig::setting('locale.base_currency.symbol'));
$defaultCurrencyIso = array_get_default($_SESSION, 'default_currency_iso4217', AppConfig::setting('locale.base_currency.iso4217'));
$getNumberJs = $locale->getNumberJs();
$dcharset = array_get_default($_SESSION, 'default_export_charset', AppConfig::setting('export.charset'));
$charsets = get_select_options_with_id($locale->getCharsetSelect(), $dcharset);
$echarset = array_get_default($_SESSION, 'default_email_charset', AppConfig::setting('email.default_charset'));
$charsetsEmail = get_select_options_with_id($locale->getCharsetSelect(), $echarset);
$exportFormat = array_get_default($_SESSION, 'default_export_format', AppConfig::setting('export.list_format'));
$export_formats = get_select_options_with_id($locale->getExportFormatSelect(), $exportFormat);
$numf = array_get_default($_SESSION, 'default_number_format', $locale->getLocaleDefaultNumberFormat());
$numFormats = get_select_options_with_id($locale->getLocaleNumberFormatOptions(), $numf);
$namef = array_get_default($_SESSION, 'default_name_format', $locale->getLocaleFormatMacro(true));
$nameFormat = $locale->getLocaleNameFormatSelector($namef);
$addrf = array_get_default($_SESSION, 'default_address_format', $locale->getLocaleDefaultAddressFormat());
$addrFormat = $locale->getLocaleAddressFormatSelector($addrf);

// default currencies    
$currencySelect = '';
$currencyDefs = "var currencyDefs = {};\r";

$currencies = array_merge(
	array($defaultCurrencyIso => array(
		'name' => $defaultCurrencyName,
		'symbol' => $defaultCurrencySymbol
	)),
	AppConfig::setting('locale.currencies')
);
foreach($currencies as $iso4217 => $currency) {
	$currencyDefs .= "currencyDefs.{$iso4217} = {\n";
	$currencyDefs .= "	name: '{$currency['name']}',\n";
	$currencyDefs .= "	symbol: '{$currency['symbol']}',\n";
	$currencyDefs .= "	iso4217: '{$iso4217}'};\n";
	
	$selected = '';
	if($iso4217 == $defaultCurrencyIso) {
		$selected = ' SELECTED';
	}
	$currencySelect .= "<option value='{$iso4217}'{$selected}> {$currency['name']} </option>";
}
$signficantDigits = array_get_default($_SESSION, 'default_currency_significant_digits', AppConfig::setting('locale.base_currency.significant_digits'));
$sigDigits = '';
for($i=0; $i<=6; $i++) {
	$sigDigitsSelected = ($signficantDigits == $i) ? ' SELECTED' : '';
	$sigDigits .= "<option value='{$i}'{$sigDigitsSelected}>{$i}</option>";
}

$errs = '';
if(isset($validation_errors)) {
	if(is_countable($validation_errors) && count($validation_errors) > 0) {
		$errs  = '<div id="errorMsgs" class="alert alert-danger">';
		$errs .= "<p><span class='uii uii-danger'></span> {$mod_strings['LBL_SYSOPTS_ERRS_TITLE']}</p>";
		$errs .= '<ul>';

		foreach($validation_errors as $error) {
			$errs .= '<li>' . $error . '</li>';
		}

		$errs .= '</ul>';
		$errs .= '</div>';
	}
}

////    PRELOAD DISPLAY DATA
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
////    BEING PAGE OUTPUT
$disabled = "";
$result = "";


// longreach - start added - template support
require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WIZARD_TITLE'] .  $next_step);
$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_STEP'] . $next_step . ': ' . $mod_strings['LBL_LOCALE_TITLE']);
$xtpl->assign('JAVASCRIPT', '');
$xtpl->assign('ONLOAD', '');
$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$out = $xtpl->text('head');
// longreach - end added


$out .= <<<EOQ
<div class="row page-row">
<div class="column page-column">
<p>{$mod_strings['LBL_LOCALE_DESC']}</p>
{$errs}

<div class="panel-outer panel-default panel-border panel-round">
<div class="panel-header"><h3 class="panel-title">{$mod_strings['LBL_LOCALE_UI']}</h3></div>
<div class="panel-body panel-pad-body">

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_date_format" class="form-label">{$mod_strings['LBL_LOCALE_DATEF']}</label>
<div class="form-value">
<select id="default_date_format" name="default_date_format" class="input-field default-focus">{$dateFormat}</select>
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_time_format" class="form-label">{$mod_strings['LBL_LOCALE_TIMEF']}</label>
<div class="form-value">
<select id="default_time_format" name="default_time_format" class="input-field">{$timeFormat}</select>
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_number_format" class="form-label">{$mod_strings['LBL_LOCALE_NUMBER_FORMAT']}</label>
<div class="form-value">
<select onchange="setSigDigits();" id="default_number_format" name="default_number_format" class="input-field">{$numFormats}</select>
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_language" class="form-label">{$mod_strings['LBL_LOCALE_LANG']}</label>
<div class="form-value">
<select id="default_language" name="default_language" class="input-field">{$languages}</select>
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_locale_name_format" class="form-label">{$mod_strings['LBL_LOCALE_NAMEF']}</label>
<div class="form-value">
<select id="default_locale_name_format" name="default_locale_name_format" onchange="update_name_format(this.value, 'sampleName');" class="input-field">{$nameFormat['OPTIONS']}</select>
{$nameFormat['JAVASCRIPT']}
<div id="sampleName" style="width: 16em; border: 1px dotted #999; margin: 3px 0; padding: 3px; clear: none">
{$nameFormat['SAMPLE']}
</div>
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_address_format" class="form-label">{$mod_strings['LBL_LOCALE_ADDRESS_FORMAT']}</label>
<div class="form-value">
<select id="default_address_format" name="default_address_format" onchange="update_address_format(this.value, 'sampleAddr');" class="input-field">{$addrFormat['OPTIONS']}</select>
{$addrFormat['JAVASCRIPT']}
<div id="sampleAddr" style="width: 16em; border: 1px dotted #999; margin: 3px 0; padding: 3px; clear: none">
{$addrFormat['SAMPLE']}
</div>
</div></div>
</div></div>

</div></div>

<br>

<div class="panel-outer panel-default panel-border panel-round">
<div class="panel-header"><h3 class="panel-title">{$mod_strings['LBL_LOCALE_EXPORT_TITLE']}</h3></div>
<div class="panel-body panel-pad-body">

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_email_charset" class="form-label">{$mod_strings['LBL_EMAIL_CHARSET_TITLE']}</label>
<div class="form-value">
<select id="default_email_charset" name="default_email_charset" class="input-field">{$charsetsEmail}</select>
<p class="form-value-line form-text text-muted =">{$mod_strings['LBL_EMAIL_CHARSET_DESC']}</p>
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_export_charset" class="form-label">{$mod_strings['LBL_LOCALE_EXPORT']}</label>
<div class="form-value">
<select id="default_export_charset" name="default_export_charset" class="input-field">{$charsets}</select>
<p class="form-value-line form-text text-muted">{$mod_strings['LBL_LOCALE_EXPORT_FOR']}</p>
</div></div>
</div></div>


<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_export_format" class="form-label">{$mod_strings['LBL_LOCALE_EXPORT_FORMAT']}</label>
<div class="form-value">
<select id="default_export_format" name="default_export_format" class="input-field">{$export_formats}</select>
</div></div>
</div></div>

</div></div>

<br>

<div class="panel-outer panel-default panel-border panel-round">
<div class="panel-header"><h3 class="panel-title">{$mod_strings['LBL_LOCALE_CURRENCY']}</h3></div>
<div class="panel-body panel-pad-body">

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="currency" class="form-label">{$mod_strings['LBL_LOCALE_CURR_DEFAULT']}</label>
<div class="form-value">
<select id='currency' onchange='fillCurrency(this.value); setSigDigits();' name='currency' class="input-field">{$currencySelect}</select>
<input type="text" disabled id="symbol" name="symbol" value="{$defaultCurrencySymbol}" size="3" style="text-align:center; border-width: 1px; margin: 3px 0; border-style: dotted">
<input type="text" disabled id="iso4217" name="iso4217" value="{$defaultCurrencyIso}" size="4" style="text-align:center; border-width: 1px; margin: 3px 0; border-style: dotted">
<input type="hidden" id="default_currency_name" name="default_currency_name" value="{$defaultCurrencyName}">
<input type="hidden" id="default_currency_symbol" name="default_currency_symbol" value="{$defaultCurrencySymbol}">
<input type="hidden" id="default_currency_iso4217" name="default_currency_iso4217" value="{$defaultCurrencyIso}">
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="default_currency_significant_digits" class="form-label">{$mod_strings['LBL_LOCALE_CURR_SIG_DIGITS']}</label>
<div class="form-value">
<select id='sigDigits' onchange='setSigDigits(this.value);' name='default_currency_significant_digits' id='default_currency_significant_digits' class="input-field">{$sigDigits}</select>
</div></div>
</div></div>

</div></div>

</div></div>

EOQ;
// longreach - added
$end_js = <<<EOQ

<script type="text/javascript">
	{$getNumberJs}
	
	function fillCurrency(keyIso) {
		{$currencyDefs}
		document.getElementById('symbol').value = currencyDefs[keyIso].symbol;
		document.getElementById('iso4217').value = currencyDefs[keyIso].iso4217;
		
		document.getElementById('default_currency_symbol').value = currencyDefs[keyIso].symbol;
		document.getElementById('default_currency_iso4217').value = currencyDefs[keyIso].iso4217;
		document.getElementById('default_currency_name').value = currencyDefs[keyIso].name;
	}
	
	fillCurrency('{$defaultCurrencyIso}');
	setSigDigits();
	
</script>

EOQ;

// longreach - start added
$buttons = array(
	array('TITLE' => $mod_strings['LBL_BACK'], 'NAME' => 'Back', 'TYPE' => 'button',
		'ONCLICK' => "this.form.goto.value='Back'; this.form.submit();", 'ICON' => 'arrow-left'),
	array('TITLE' => $mod_strings['LBL_NEXT'], 'NAME' => 'Next', 'TYPE' => 'submit',
		'ONCLICK' => "this.form.goto.value='Next';", 'ICON' => 'arrow-right', 'CLASS' => 'lwib-accept',
		'ATTRS' => (! empty($error_found) ? 'disabled="disabled"' : '')),
	);
installer_show_buttons($xtpl, $buttons, $next_step);
$xtpl->assign('END_JAVASCRIPT', $end_js);
$xtpl->parse('foot');
$out .= $xtpl->text('foot');
// longreach - end added


echo $out;


////    END PAGEOUTPUT
///////////////////////////////////////////////////////////////////////////////
?>
