<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/


$_SESSION['async_install_enabled'] = true;

require_once 'include/ProgressIndicator.php';
$progressIndicator = new ProgressIndicator(AppConfig::setting('install.progress_log'), true);

// This file will load the configuration settings from session data,
// write to the config file, and execute any necessary database steps.

if( !isset( $install_script ) || !$install_script ){
	die($mod_strings['ERR_NO_DIRECT_SCRIPT']);
}

require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WIZARD_TITLE'] .  $next_step);
if (AUTO_INSTALLER) {
	$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_AUTO_INSTALL_TITLE']);
} else {
	$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_STEP'] . $next_step . ': ' . $mod_strings['LBL_PERFORM_TITLE']);
}
$xtpl->assign('JAVASCRIPT', '');
$xtpl->assign('ONLOAD', "startProgressIndicator('perform');");
$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');

//////////////////////////


$buttons = array(
	array(
		'TITLE' => $mod_strings['LBL_FINISH'],
		'NAME' => 'Next',
		'TYPE' => 'submit',
		'ONCLICK' => "this.form.goto.value='Finish';",
		'ID' => 'Next',
		'ATTRS' => 'disabled="disabled"',
		'ICON' => 'accept',
		'CLASS' => 'lwib-accept',
	)
);

if(!empty($_SESSION['setup_db_pop_demo_data']) ){
	if (AUTO_INSTALLER) {
		$xtpl->assign('SETUP_DEMO', 1);
	} else {
		$xtpl->assign('SETUP_DEMO', 0);
		$buttons[0]['TITLE'] = $mod_strings['LBL_NEXT'];
		$buttons[0]['ONCLICK'] = "this.form.goto.value='Next'; this.form.submit();";
	}
}

if(!empty($_SESSION['setup_save_config']) && empty($_SESSION['setup_db_pop_demo_data']) ){
	$xtpl->assign('LBL_DOWNLOAD_CONFIG', $mod_strings['LBL_DOWNLOAD_CONFIG']);
	$xtpl->assign('CONFIG_PATH', InstallerConfigParser::finalConfigPath());
	$xtpl->parse('async.config_download');
}
$xtpl->parse('async');
$xtpl->out('async');

installer_show_buttons($xtpl, $buttons, $next_step);
$xtpl->parse('foot');
$xtpl->out('foot');

// longreach - end replaced
