<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/



if(empty($install_script)) {
    die($mod_strings['ERR_NO_DIRECT_SCRIPT']);
}

if( !isset($_SESSION['siteConfig_submitted']) || !$_SESSION['siteConfig_submitted'] ){
    $web_root = $_SERVER['HTTP_HOST'].$_SERVER['PHP_SELF'];
    $web_root = preg_replace('~(?<=/)install\.php.*$~', '', $web_root); // cn: bug 6898 add port if not 80
    $web_root = str_replace(":80/", "/", $web_root); // cn: bug 6898 keep old behavior
    $web_root = "http://$web_root";
    $current_dir = str_replace('\install',"", dirname(__FILE__));
    $current_dir = str_replace('/install',"", $current_dir);
    $current_dir = trim($current_dir);

    // set the form's php var to the loaded config's var else default to sane settings
    $_SESSION['setup_site_url']				= AppConfig::setting(array('site.base_url', 'install.defaults.base_url'), $web_root);
    $_SESSION['setup_site_session_path']    = AppConfig::setting(array('site.session.dir', 'install.session.dir'), '');
    $_SESSION['setup_site_custom_session_path'] = ($_SESSION['setup_site_session_path'] !== '');
    $_SESSION['setup_site_log_dir']         = AppConfig::setting(array('site.log.dir', 'install.defaults.log.dir'), 'logs');
    $_SESSION['setup_site_log_file']        = AppConfig::setting(array('site.log.file', 'install.defaults.log.file'), 'site.log');
    $_SESSION['setup_site_custom_log']      = ($_SESSION['setup_site_log_dir'] !== 'logs' || $_SESSION['setup_site_log_file'] !== 'site.log');
    $_SESSION['setup_site_guid']            = AppConfig::setting('config.unique_key', '');
    $_SESSION['setup_site_specify_guid']    = ($_SESSION['setup_site_guid'] !== '');
    $_SESSION['setup_site_defaults']        = ! ($_SESSION['setup_site_specify_guid'] || $_SESSION['setup_site_custom_log'] || $_SESSION['setup_site_custom_session_path']);
    $_SESSION['setup_site_admin_password']          = AppConfig::setting('install.defaults.admin_password', '');
    $_SESSION['setup_site_admin_password_retype']   = $_SESSION['setup_site_admin_password'];
}

////	errors
$errors = '';
if( isset($validation_errors) ){
    if( is_countable($validation_errors) && count($validation_errors) > 0 ){
        $errors  = '<div id="errorMsgs" class="alert alert-danger">';
        $errors .= '<p><span class="uii uii-danger"></span> '.$mod_strings['LBL_SITECFG_FIX_ERRORS'].'</p><ul>';
        foreach( $validation_errors as $error ){
			$errors .= '<li>' . $error . '</li>';
        }
		$errors .= '</ul></div>';
    }
}

// longreach - start added - template support
require_once('XTemplate/xtpl.php');
$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WIZARD_TITLE'] . $next_step);
$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_STEP'] . $next_step . ': ' . $mod_strings['LBL_SITECFG_TITLE']);
$xtpl->assign('JAVASCRIPT', '<script type="text/javascript" src="install/siteConfig.js"></script>');
$xtpl->assign('ONLOAD', "javascript:toggleGUID();toggleSession();toggleLogDir();toggleSiteDefaults();");
$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');
// longreach - end added

////	ternaries
$siteSecurity = (! empty($_SESSION['setup_site_defaults'])) ? 'checked="checked"' : '';
$customSession = (! empty($_SESSION['setup_site_custom_session_path'])) ? 'checked="checked"' : '';
$customLog = (! empty($_SESSION['setup_site_custom_log'])) ? 'checked="checked"' : '';
$customId = (! empty($_SESSION['setup_site_specify_guid'])) ? 'checked="checked"' : '';
$reqd = '<span class="requiredStar">*</span>';

///////////////////////////////////////////////////////////////////////////////
////	START OUTPUT
$out =<<<EOQ
<div class="row page-row">
<div class="column page-column">
<p>{$mod_strings['LBL_SITECFG_DIRECTIONS']}</p>
{$errors}

<div class="panel-outer panel-default panel-border panel-round">
<div class="panel-body panel-pad-body">

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_site_url" class="form-label">{$mod_strings['LBL_SITECFG_URL']}</label>
<div class="form-value">
<input type="url" class="input-text" name="setup_site_url" id="setup_site_url" value="{$_SESSION['setup_site_url']}" size="40">{$reqd}
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_site_admin_password" class="form-label">{$mod_strings['LBL_SITECFG_ADMIN_PASS']}</label>
<div class="form-value">
<input type="password" class="input-text default-focus" name="setup_site_admin_password" id="setup_site_admin_password" value="{$_SESSION['setup_site_admin_password']}" size="30">{$reqd}
</div></div>
</div></div>


<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_site_admin_password_retype" class="form-label">{$mod_strings['LBL_SITECFG_ADMIN_PASS_2']}</label>
<div class="form-value">
<input type="password" class="input-text" name="setup_site_admin_password_retype" id="setup_site_admin_password_retype" value="{$_SESSION['setup_site_admin_password_retype']}" size="30">{$reqd}
<p class="form-value-line form-text text-muted">{$mod_strings['LBL_SITECFG_ADMIN_PASS_WARN']}</p>
</div></div>
</div></div>

EOQ;

	require_once('include/TimeDate.php');
	$found = null;
	if(isset($_SESSION['setup_server_timezone']))
		$found = $_SESSION['setup_server_timezone'];
	else {
		$found = AppConfig::setting(array('site.timezone', 'install.defaults.timezone'));
		if(! $found) {
			$timedate = new TimeDate();
			$found = $timedate->guessTimeZone();
			if(! $found)
				$found = AppConfig::setting('locale.defaults.timezone');
		}
	}
	$opts = get_select_options_with_id(TimeDate::getTimeZones(true, true), $found);
	$save_config = empty($_SESSION['setup_save_config']) ? '' : 'checked="checked"';

	$out .= <<<EOQ

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_server_timezone" class="form-label">{$mod_strings['LBL_SERVER_TIMEZONE']}</label>
<div class="form-value">
<select name="setup_server_timezone" id="setup_server_timezone" class="input-field">{$opts}</select>{$reqd}
</div></div>
</div></div>

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_site_defaults" class="form-label">{$mod_strings['LBL_SITECFG_SITE_SECURITY']}</label>
<div class="form-value">
<div class="input-field input-check flat"><input type="checkbox" name="setup_site_defaults" id="setup_site_defaults" value="yes" onclick="toggleSiteDefaults();" {$siteSecurity}><label class="input-label"> {$mod_strings['LBL_SITECFG_USE_DEFAULTS']}</label></div>
</div></div>
</div></div>

<div id="advancedOptions">

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_site_custom_session_path" class="form-label nest-label">{$mod_strings['LBL_SITECFG_SESSION_OPTS']}</label>
<div class="form-value">
<div class="input-field input-check flat"><input type="checkbox" name="setup_site_custom_session_path" id="setup_site_custom_session_path" value="yes" onclick="toggleSession();" {$customSession}><label class="input-label"> {$mod_strings['LBL_SITECFG_CUSTOM_SESSION']}</label></div>

<div id="sessionOptions" class="form-value-line">
<p class="form-text text-muted">{$mod_strings['LBL_SITECFG_CUSTOM_SESSION_DIRECTIONS']}</p>
<div class="form-entry">
<label for="setup_site_session_path" class="form-label">{$mod_strings['LBL_SITECFG_SESSION_PATH']}{$reqd}</label>
<div class="form-value">
	<input type="text" class="input-text" name="setup_site_session_path" id="setup_site_session_path" value="{$_SESSION['setup_site_session_path']}" size="40">
</div>
</div>

</div></div>
</div></div>


<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_site_custom_log" class="form-label nest-label">{$mod_strings['LBL_SITECFG_LOG_OPTS']}</label>
<div class="form-value">
<div class="input-field input-check flat"><input type="checkbox" name="setup_site_custom_log" id="setup_site_custom_log" value="yes" onclick="toggleLogDir();" {$customLog}><label class="input-label"> {$mod_strings['LBL_SITECFG_CUSTOM_LOG']}</label></div>

<div id="logOptions" class="form-value-line">

<p class="form-text text-muted">{$mod_strings['LBL_SITECFG_CUSTOM_LOG_DIRECTIONS']}</p>

<div class="form-entry form-value-line">
<label for="setup_site_log_dir" class="form-label">{$mod_strings['LBL_SITECFG_LOG_DIR']}{$reqd}</label>
<div class="form-value">
	<input type="text" class="input-text" name="setup_site_log_dir" id="setup_site_log_dir" value="{$_SESSION['setup_site_log_dir']}">
</div>
</div>

<div class="form-entry form-value-line">
<label for="setup_site_log_file" class="form-label">{$mod_strings['LBL_SITECFG_LOG_FILE']}{$reqd}</label>
<div class="form-value">
	<input type="text" class="input-text" name="setup_site_log_file" id="setup_site_log_file" value="{$_SESSION['setup_site_log_file']}">
</div>
</div>

</div>
</div></div>

</div></div>


<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label for="setup_site_specify_guid" class="form-label">{$mod_strings['LBL_SITECFG_HOST_OPTS']}</label>
<div class="form-value">
<div class="input-field input-check flat"><input type="checkbox" name="setup_site_specify_guid" id="setup_site_specify_guid" value="yes" onclick="toggleGUID();" {$customId}><label class="input-label"> {$mod_strings['LBL_SITECFG_CUSTOM_ID']}</label></div>

<div id="guidOptions" class="form-value-line">
<p class="form-text text-muted">{$mod_strings['LBL_SITECFG_CUSTOM_ID_DIRECTIONS']}</p>
<div class="form-entry">
<label for="setup_site_guid" class="form-label">{$mod_strings['LBL_SITECFG_APP_ID']}{$reqd}</label>
<div class="form-value">
	<input type="text" class="input-text" name="setup_site_guid" id="setup_site_guid" value="{$_SESSION['setup_site_guid']}" size="40">
</div>
</div>
</div></div>

</div></div>
</div><!-- end advanced -->

<div class="row form-row">
<div class="column form-cell">
<div class="form-entry label-left">
<label class="form-label">{$mod_strings['LBL_SITECFG_MISC_OPTS']}</label>
<div class="form-value">
	<div class="input-field input-check flat"><input type="checkbox" name="setup_save_config" value="yes" {$save_config}><label class="input-label"> {$mod_strings['LBL_SAVE_CONFIG']}</label></div>
</div>
</div></div>
</div></div></div>

</div></div>
</div></div>

EOQ;

echo $out;

$buttons = array(
	array('TITLE' => $mod_strings['LBL_BACK'], 'NAME' => 'Back', 'TYPE' => 'button',
		'ONCLICK' => "this.form.goto.value='Back'; this.form.submit();", 'ICON' => 'arrow-left'),
	array('TITLE' => $mod_strings['LBL_NEXT'], 'NAME' => 'Next', 'TYPE' => 'submit',
		'ONCLICK' => "this.form.goto.value='Next';", 'ICON' => 'arrow-right', 'CLASS' => 'lwib-accept'),
	);
$xtpl->assign('BUTTONS_CLASS', 'sm-lifted-1');
installer_show_buttons($xtpl, $buttons, $next_step);
$xtpl->parse('foot');
$xtpl->out('foot');

?>
