<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2005 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

// $Id: welcome.php,v 1.2 2005/07/22 00:47:10 bob Exp $

if(! defined('IAH_IN_INSTALLER')){
    die('Unable to process script directly.');
}

require_once('XTemplate/xtpl.php');
require_once('install/langpack.php');

$lptpl = new XTemplate('install/langpacks.html');
$lptpl->assign('LANG', $mod_strings);

$lp = new InstallerLangPack;
$result = $lp->processRequest();

$errors = $lp->getErrors();
if($errors) {
	$errmsg = '<div class="alert alert-warning"><p>'.join('</p><p>', $errors).'</p></div>';
	$lptpl->assign('uploadResult', $errmsg);
}

$uploadedLanguages = UWizard::listUploadedPackages('langpack');
$installedLanguages = UWizard::listInstalledPackages('langpack');

// longreach - start replaced - added template support and changed message

$langDropDown = get_select_options_with_id($supportedLanguages, $current_language);

$intro_text = '<p>' . $mod_strings['LBL_WELCOME_1'] . '</p><p>' . $mod_strings['LBL_WELCOME_2'] . '</p>';

require_once('vendor_info.php');
$intro_text = str_replace('{SUPPORT_EMAIL}', $vendor_info['email_support'], $intro_text);
$intro_text = str_replace('{SUPPORT_GUIDE}', $vendor_info['implementation_guide'], $intro_text);

$xtpl = new XTemplate('install/template.html');

installer_init_template($xtpl);
$xtpl->assign('PAGE_TITLE', $mod_strings['LBL_WELCOME_TITLE']);
$xtpl->assign('HEADER_TITLE', $mod_strings['LBL_WELCOME_TITLE_WELCOME'] . $setup_sugar_version);
$xtpl->parse('head.start_form');
$xtpl->parse('head.row');
$xtpl->parse('head');
$xtpl->out('head');

$sel_lang = '<div class="form-label">' . $mod_strings['LBL_WELCOME_CHOOSE_LANGUAGE'] . '</div>'
	. '<div class="form-group"><select name="language" id="language-input" class="input-field default-focus" style="width: 16em">' . $langDropDown . '</select></div>';



if (!empty($uploadedLanguages)) {
	$lptpl->assign('header', $mod_strings['LBL_UPLOADED_LANGUAGES']);
	foreach ($uploadedLanguages as $package) {
		$package['status'] = translate($package['status'], 'UWizard');
		$lptpl->assign('package', $package);
		if(empty($package['installable']))
			$lptpl->assign('DISABLE_INSTALL', 'disabled="disabled"');
		$lptpl->parse('main.uploaded.installed_row.buttons_uploaded');
		$lptpl->parse('main.uploaded.installed_row');
	}
	$lptpl->parse('main.uploaded');
}

if (!empty($installedLanguages)) {
	$lptpl->assign('header', $mod_strings['LBL_INSTALLED_LANGUAGES']);
	foreach ($installedLanguages as $package) {
		$package['status'] = translate($package['status'], 'UWizard');
		$package['date'] = $package['date_entered'];
		$lptpl->assign('package', $package);
		$lptpl->parse('main.uploaded.installed_row.buttons_installed');
		$lptpl->parse('main.uploaded.installed_row');
	}
	$lptpl->parse('main.uploaded.installed');
	$lptpl->parse('main.uploaded');
}
$lptpl->parse('main');

// main page content
$xtpl->assign('CONTENT', $intro_text . '<div class="med-form">' . $sel_lang . $lptpl->text('main') . '</div>');
$xtpl->parse('main.bg_row');

$xtpl->parse('main');
$xtpl->out('main');

// buttons
$xtpl->assign('BUTTONS_CLASS', 'sm-lifted-2');
$buttons = array(
	array('TITLE' => $mod_strings['LBL_START'], 'NAME' => 'Next', 'TYPE' => 'submit',
		'ONCLICK' => "this.form.goto.value='Next';", 'CLASS' => 'lwib-accept', 'ICON' => 'arrow-right'),
	);
installer_show_buttons($xtpl, $buttons, 0);
$xtpl->parse('foot');
$xtpl->out('foot');
// longreach - end added

// longreach - removed raw HTML
?>
