<?php
 if(!defined('sugarEntry'))define('sugarEntry', true);
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

require_once('include/json/json_utils.php');
json_handle_magic_quotes_gpc();

define('IAH_JSON', true);
define('DISABLE_CLEAN_INCOMING_DATA', 1);
require_once('include/entryPoint.php');

require_once('include/JSON.php');
require_once('include/json/json_serialize.php');

error_reporting(error_reporting() & ~E_NOTICE);

if(! AppConfig::installed() || AppConfig::upgrade_in_progress())
	return;
// Prevent access via alternate site urls
if(AppConfig::is_extern_url())
	return;
if( ($redir = AppConfig::get_auto_redirect()) ) {
	header("Location: {$redir[0]}");
	return;
}

ob_start();

global $post_params;
$post_params = null;
if(! isset($HTTP_RAW_POST_DATA))
	$HTTP_RAW_POST_DATA = file_get_contents('php://input');
if(! empty($_ENV['JSON_USE_STDIN'])) {
	$stdin = file_get_contents('php://stdin');
	if(! empty($stdin))
		$HTTP_RAW_POST_DATA = $stdin;
}
if(! empty($HTTP_RAW_POST_DATA) && $HTTP_RAW_POST_DATA[0] == '{') {
	$json = getJSONobj();
	$post_params = $json->decode($HTTP_RAW_POST_DATA);
	if(is_array($post_params)) {
		foreach($post_params as $k => $v)
			$_REQUEST[$k] = $v;
	}
}


global $module, $action, $output_format, $jsrd_minimal;
$module = array_get_default($_REQUEST, 'module');
$action = array_get_default($_REQUEST, 'action');
$output_format = array_get_default($_REQUEST, 'output_format', 'json');
if($output_format == 'jsrd_minimal') {
	$jsrd_minimal = true;
	$output_format = 'jsrd';
}
else
	$jsrd_minimal = false;


// include supported functions
global $json_supported_actions;
include('include/json/json_auth.php');
include('include/json/json_basic.php');
include('include/json/json_meta.php');
include('include/json/json_fcm.php');
include('include/json/json_apns.php');
include('include/json/json_stripe.php');
if ($json_portal_enabled = !!AppConfig::setting('portal.enabled')) {
	include('include/json/json_portal.php');
}
$ext_f = 'custom/include/json/json.ext.php';
if(file_exists($ext_f))
	include($ext_f);
if($module) {
	if(! preg_match('~^[a-zA-Z0-9][a-zA-Z0-9_]*$~', $module) || ! AppConfig::setting("modinfo.by_name.$module")) {
		json_bad_request();
	}
	// module must check access permissions itself
	$incs = array(
		"modules/$module/json.php",
		"custom/modules/$module/json.php",
	);
	foreach($incs as $ext_f)
		if(file_exists($ext_f))
			include($ext_f);
}


$no_session = false;
if(! empty($json_supported_actions[$action]['no_session']))
	$no_session = true;
if(! $no_session) {
	if(isset($_REQUEST['json_session_id']))
		session_id($_REQUEST['json_session_id']);

	AppConfig::session_start();

	require_once ('modules/Users/authentication/AuthenticationController.php');
	global $authController;
	$authController = new AuthenticationController();
	global $jsonModuleList;
	$jsonModuleList = array_keys(AppConfig::setting('modinfo.system'));
	ACLController::filterModuleList($jsonModuleList);

	global $current_language, $app_strings, $app_list_strings;
	$check_lang = array();
	if(! empty($_REQUEST['json_set_session_language']))
		$check_lang[] = $_REQUEST['json_set_session_language'];
	if(! empty($_SESSION['json_session_language']))
		$check_lang[] = $_SESSION['json_session_language'];
	AppConfig::init_user_language($check_lang);

	global $theme, $image_path;
	if(! empty($_SESSION['json_session_theme']))
		$theme = $_SESSION['json_session_theme'];
	else if(! empty($_SESSION['authenticated_user_theme']))
		$theme = $_SESSION['authenticated_user_theme'];
	else
		$theme = AppConfig::setting('layout.defaults.theme');
	$image_path = "themes/$theme/images/";
}


register_cleanup_handler('json_cleanup');
function json_cleanup() {
	global $json_restore_prefs, $current_user;
	// prevent saving of user preferences
	if(! empty($current_user) && ! empty($current_user->id) && ! empty($json_restore_prefs)) {
		foreach($json_restore_prefs as $k => $v) {
			$_SESSION[$current_user->user_name.'_PREFERENCES']['global'][$k] = $v;
		}
	}
}

if($action == 'login' || (! empty($json_portal_enabled) && $action == 'portal_login')) {
	json_perform_action($action);
	sugar_cleanup(true);
}

if(! isset($_SESSION['authenticated_user_id'])) {
	if(json_action_supported($action)) {
		json_perform_action($action);
		sugar_cleanup(true);
	}
	else
		json_auth_die();
}

// If this is a portal call, use the portal validation
if (! empty($json_portal_enabled) && array_get_default($_SESSION, 'login_type') == 'portal') {
	if (! portal_validate_authenticated()) {
		// Invalid session
		json_auth_die();
	}
} else {
	if (! $authController->rpcSessionAuthenticate()) {
		// Invalid session
		json_auth_die();
	}
}

if($output_format == 'jsrd') {
	UserPreference::loadPreferences();
	$_nm = $current_user->user_name;
	global $json_restore_prefs;
	$json_update_prefs = array(
		'default_date_format' => 'Y-m-d',
		'default_time_format' => 'H:i',
	);
	if(! isset($_SESSION[$user->user_name . '_PREFERENCES']['global']))
		$_SESSION[$user->user_name . '_PREFERENCES']['global'] = array();
	foreach($json_update_prefs as $k => $v) {
		$json_restore_prefs[$k] = array_get_default($_SESSION[$_nm.'_PREFERENCES']['global'], $k);
		$_SESSION[$_nm.'_PREFERENCES']['global'][$k] = $v;
	}
	$timedate = new TimeDate(); // clear any cached values
}

if(json_action_supported($action)) {
	json_perform_action($action);
}
else {
	json_bad_request("Unsupported action: $action");
}

sugar_cleanup();
?>
