<?php
define('sugarEntry', true);
define('ONECRM_CSRF_PROTECT', 'none');
require_once('include/entryPoint.php');
require_once('modules/Emails/utils.php');

AppConfig::restrict_entry_point();

// Prevent access via alternate site urls
if(AppConfig::is_extern_url('leadCapture'))
	return;

/**
 * Add your custom lead capture settings to local_config.php
 * For example:
 * leadcapture
 *     users
 *         RANDOM KEY FROM YOUR WEBSITE HERE: 1CRM USER_NAME HERE
 */
$auth_users = AppConfig::setting('leadcapture.users');
if(! $auth_users) {
	$auth_users = array(
		//'lkjaskljgasg' => 'admin',
	);
}
/* enable this setting in order to update an existing lead when found matching the same email address */
$lookup_by_email = AppConfig::setting('leadcapture.lookup_by_email', false);
/* require an email address for new leads? */
$require_email = AppConfig::setting('leadcapture.require_email', false);
if(file_exists('leadCapture_override.php')){
	include('leadCapture_override.php');
}

$user_key = array_get_default($_REQUEST, 'user');

if ($user_key && !empty($auth_users[$user_key]))
	$uid = $current_user->retrieve_user_id($auth_users[$user_key]);
if(! empty($uid) && $current_user->retrieve($uid) && $current_user->status == 'Active') {
	AppConfig::session_start();

	$app_strings = return_application_language('base');
	$app_list_strings = return_app_list_strings_language('base');
	$mod_strings = return_module_language('base', 'Leads');

	$prefix = array_get_default($_REQUEST, 'prefix', '');
	$_REQUEST['record'] = $_POST['record'] = '';
	
	$email = array_get_default($_REQUEST, 'email1');
	$lead = null;
	
	if(strlen($email) && $lookup_by_email) {
		$related = lookup_email_addresses(array($email), false, array('Leads'));
		if($related) {
			$rel = current($related);
			if(isset($rel['Leads'])) {
				$rel_row = $rel['Leads'][0];
				$_REQUEST['record'] = $_POST['record'] = $rel_row['id'];
				unset($_REQUEST['lead_source']);
				$lead_result = ListQuery::quick_fetch('Lead', $rel_row['id'], true, array('acl_filters' => 'edit'));
				if($lead_result)
					$lead = RowUpdate::for_result($lead_result);
			}
		}
	}
	
	if(! empty($_REQUEST['name']) && empty($_REQUEST['last_name'])) {
		$name = trim($_REQUEST['name']);
		$sp = strrpos($name, ' ');
		if($sp === false) {
			$_REQUEST['first_name'] = '';
			$_REQUEST['last_name'] = $name;
		}
		else {
			$_REQUEST['first_name'] = trim(substr($name, 0, $sp));
			$_REQUEST['last_name'] = substr($name, $sp+1);
		}
	}
		
	if(empty($lead) && (! $require_email || strlen($email)))
		$lead = RowUpdate::blank_for_model('Lead');
	if(! empty($lead)) {
		$lead->setSource('leadcapture');
		$lead->loadRequest($prefix);
		if(! $lead->validate()) {
			$log->fatal("Lead capture failed: " . $lead->getErrors(true));
		}
		else {
			$ok = $lead->save();
			
			if(! empty($_REQUEST['redirect'])){
				//header("Location: ".$_REQUEST['redirect']);
				echo '<html><head><title>1CRM</title></head><body>';
				echo '<form name="redirect" action="' .to_html($_REQUEST['redirect']). '" method="POST">';

				foreach($_REQUEST as $param => $value) {
					if($param != 'redirect' && ! is_array($value)) {
						echo '<input type="hidden" name="'.to_html($param).'" value="'.to_html($value).'">';
					}
				}
				if(! $ok)
					echo '<input type="hidden" name="error" value="1">';
				echo '</form><script language="javascript" type="text/javascript">document.redirect.submit();</script>';
				echo '</body></html>';
			}

			echo "Thank you for your submission.";
			sugar_cleanup(true);
		}
	}	
}

echo "We're sorry, the server is currently unavailable, please try again later.";
if(! empty($_POST['redirect'])) {
	echo '<html><head><title>1CRM</title></head><body>';
	echo '<form name="redirect" action="' .to_html($_POST['redirect']). '" method="POST">';
	echo '</form><script language="javascript" type="text/javascript">document.redirect.submit();</script>';
	echo '</body></html>';
}

?>
