AppBase.module('roles').moduleRequires('ui-controls').init(function(App) {
	var UI = App.ui,
		Wrap = App.dom.elementOrId,
		MakeElt = App.dom.makeElement;

	UI.RolesEditor = function(id, params) {
		this.id = 'RolesEditor';
		if(isElement(id)) {
			this.elt = id;
			this.id = this.elt.id;
		} else
			this.id = id;
		if(params) extendObject(this, params);
	}

	UI.RolesEditor.prototype = {
		setup: function() {
			if(this.set_up) return;
			if(! this.elt)
				this.elt = $(this.id + '-body');
			if(! this.elt)
				return;
			this.addHooks();
			this.set_up = true;
		},
		
		addHooks: function() {
			var inputs = Wrap(this.elt).find('.acl-cell > input[type="hidden"]'),
				opts = this.options,
				self = this,
				elt, id;
			if(! opts) return;
			for(var i = 0; i < inputs.length; i++) {
				var id = inputs[i].getAttribute('id').substring(4),
					elt = inputs[i].parentNode;
				if(opts[id]) {
					if(isset(this.tabIndex)) elt.tabIndex = this.tabIndex;
					SUGAR.ui.registerMenuSource(elt, {
							id: elt.id,
							options_id: id,
							dynamic_options: function(menu) {
								return self.getOptions(this.options_id);
							},
							//icon_key: 'icon',
							width: 200, extClassName: 'acl-menu',
							target_offset: {top: -1},
							onchange: function(k, v) {
								self.setValue(this.options_id, k, v);
							}},
						this.form);
				}
			}
		},
		
		getOptions: function(id) {
			var input = Wrap('acl-'+id),
				opts = this.options[id],
				labels = [],
				values = [],
				selected = null;
			if(input && opts) {
				for(var i = 0; i < opts.length; i++) {
					labels[i] = opts[i];
					values[i] = '' + opts[i].value;
					if(values[i] === input.val())
						selected = values[i];
				}
			}
			return {
				keys: values,
				values: labels,
				selected: selected
			};
		},
		
		setValue: function(id, key, value) {
			var input = Wrap('acl-'+id),
				parent = input && input.closest('.acl-cell').ext(0),
				label;
			if(input) {
				label = parent.findFirst('.acl-label');
				parent.attr('class', 'grid-cell acl-cell responsive acl' + value.className);
				input.val(key);
				label.text(value.label);
			}
		}
	}
});


