<?php

/**
 * Created by PhpStorm.
 * User: brafreider
 * Date: 08.08.2016
 * Time: 11:04
 */
class ClientEntity extends SugarBean
{

	static function mutateDetailButtons($detail, &$buttons)
	{
		if (isset($buttons['delete'])) {
			$buttons['delete']['hidden'] = 'bean.is_public';
		}
	}
	
	public static function before_delete($upd) {
		$isPublic = $upd->getField('is_public', null, true);
		if ($isPublic) {
			throw new IAHActionAbort('Cannot delete public API clients');
		}
	}
	
	static function can_edit(DetailManager $mgr) {
		$record = $mgr->getRecord();
		if ($record) {
			if (!$record->new_record && $record->getField('is_public')) {
				add_flash_message(translate('ERR_CANT_EDIT_PUBLIC', 'APIClients'), 'error');
				indexRedirect('index.php?module=APIClients');
				sugar_die('');
			} elseif ($record->new_record) {
				$record->assign('is_public', null);
				$record->assign('api_key', null);
				$record->assign('api_secret', null);
				$gen = $mgr->getFormGenerator();
				$gen->formatResult($record);
			}
		}
	}
}
