<?php

class OAuthRegenerate {
	private $request = array();
	private $error = null;
	public function __construct($req) {
		$this->request = $req;
	}

	public function processRequest() {
		if ($this->input('process')) {
			$status = $this->process();
			echo json_encode($status);
			exit;
		}
		$this->render();
	}

	private function process() {
		$config = array(
	    	"digest_alg" => "sha512",
		    "private_key_bits" => 4096,
			"private_key_type" => OPENSSL_KEYTYPE_RSA,
		);
		$res=openssl_pkey_new($config);
		openssl_pkey_export($res, $privkey);
		$pubkey=openssl_pkey_get_details($res);
		$pubkey=$pubkey["key"];
		return ['public' => $pubkey, 'private' => $privkey];
	}

	private function render() {
		$message = translate('LBL_REGENERATE_WARNING', 'APIClients');
		$csrf_input = create_csrf_input();
		echo <<<HTML
		<form method="POST" action="async.php">
		{$csrf_input}
		<p style="padding: 1em;">$message</p>
		<button type="submit" class="input-button group-right" style="" tabindex="" onclick="SUGAR.popups.close(); return false;"><div class="input-icon left icon-cancel"></div><span class="input-label" >Cancel</span></button>
		<button type="submit" class="input-button group-right" style="" tabindex="" onclick="return regerenerate_oauth();"><div class="input-icon left icon-accept"></div><span class="input-label" >Regenerate Keys</span></button>
		</form>
HTML;
		echo $this->javascript();
	}

	private function input($name, $default = null) {
		return array_get_default($this->request, $name, $default);
	}

	private function javascript() {
?>
		<script type="text/javascript">
		function regerenerate_oauth() {
			var callback = function(res) {
				var form = document.forms['ConfigureSettings'];
				var data = JSON.parse(res.responseText);
				form.oauth_private_key.value = data['private'];
				form.oauth_public_key.value = data['public'];
				SUGAR.popups.close();
			}
			http_fetch_async('async.php', callback, '' , {module: 'APIClients', action: 'Regenerate', process: 1});
    		return false;
		}

		</script>
<?php
	}

}

$action = new OAuthRegenerate($_REQUEST);
$action->processRequest();
