<?php
/**
 * Created by PhpStorm.
 * User: brafreider
 * Date: 09.08.2016
 * Time: 12:36
 */

$json_supported_actions['change_oauth_password'] = array();
function json_change_oauth_password()
{
    $module = 'APIClients';
    $values = array_get_default($_REQUEST, 'values');
    if (!is_array($values) || empty($values['id'])) {
        return json_bad_request('missing_values');
    }

    $result = ListQuery::quick_fetch('ClientEntity', $values['id']);
    if (!$result)
        return json_bad_request('wrong_id');

    //Save error code
    $error_msg = 1;
    $error = false;
    $save = false;

	if ($result->getField('is_public')) {
        return json_bad_request('unauthorized_access');
	}

    if (!AppConfig::is_admin()) {
        return json_bad_request('unauthorized_access');
    }

    if ($values['new_password'] != $values['confirm_password'] || !strlen($values['new_password'])) {
        //Mismatch passwords error code
        $error_msg = 3;
    }

    if ($error === false) {
        $ro = RowUpdate::for_result($result);
        $ro->set('secret', password_hash($values['new_password'], PASSWORD_DEFAULT));
        if ($ro->validate()) $save = $ro->save();

    }


    if ($save === false)
        $ret = array('result' => 'fail', 'module' => $module, 'msg' => $error_msg);
    else
        $ret = array('result' => 'ok', 'module' => $module, 'msg' => 0);
    json_auto_return($ret);
}

$json_supported_actions['change_portal_password'] = array('login_required' => true);
function json_change_portal_password()
{
    $module = 'Contacts';
    $values = array_get_default($_REQUEST, 'values');
    if (!is_array($values) || empty($values['id'])) {
        return json_bad_request('missing_values');
    }

    $result = ListQuery::quick_fetch('Contact', $values['id']);
    if (!$result)
        return json_bad_request('wrong_id');

    //Save error code
    $error_msg = 1;
    $error = false;
    $save = false;

    if ($values['new_password'] != $values['confirm_password'] || !strlen($values['new_password'])) {
        //Mismatch passwords error code
        $error_msg = 3;
    }

    if ($error === false) {
        $ro = RowUpdate::for_result($result);
        $ro->set('portal_user_hash', password_hash($values['new_password'], PASSWORD_DEFAULT));
        if ($ro->validate()) $save = $ro->save();
        if ($save && AppConfig::setting('portal.enabled')) {
            $user = ListQuery::quick_fetch_key('User', 'user_name', $result->getField('portal_name'));
            if ($user) {
                $userUpdate = RowUpdate::for_result($user);
                $userUpdate->set('user_hash', strtolower(md5($values['new_password'])));
                if ($userUpdate->validate())$userUpdate->save();
            }
        }
        // alle RememberMe Tokens über Bord werfen
        $lq = new \ListQuery('RememberMeTokenEntity');
        $lq->addSimpleFilter('user_id', $values['id']);
        $listResult = $lq->runQuery();
        $rowResults = $listResult->getRowResults();
        foreach($rowResults as $row){
            $update = \RowUpdate::for_result($row);
            $update->deleteRow();
        }

    }


    if ($save === false)
        $ret = array('result' => 'fail', 'module' => $module, 'msg' => $error_msg);
    else
        $ret = array('result' => 'ok', 'module' => $module, 'msg' => 0);
    json_auto_return($ret);

}
