<?php

$meta = array(
	array(
		'module' => 'Invoice',
		'billing' => array(
			'id' => 'billing_account_id',
			'prefix' => 'billing_address_',
		),
		'shipping' => array(
			'id' => 'shipping_account_id',
			'prefix' => 'shipping_address_',
		),
	),
	array(
		'module' => 'Quotes',
		'billing' => array(
			'id' => 'billing_account_id',
			'prefix' => 'billing_address_',
		),
		'shipping' => array(
			'id' => 'shipping_account_id',
			'prefix' => 'shipping_address_',
		),
	),
	array(
		'module' => 'SalesOrders',
		'billing' => array(
			'id' => 'billing_account_id',
			'prefix' => 'billing_address_',
		),
		'shipping' => array(
			'id' => 'shipping_account_id',
			'prefix' => 'shipping_address_',
		),
	),
	array(
		'module' => 'PurchaseOrders',
		'shipping' => array(
			'id' => 'shipping_account_id',
			'prefix' => 'shipping_address_',
			'conditions' => array(
				'drop_ship' => 1
			),
		),
	),
	array(
		'module' => 'CreditNotes',
		'billing' => array(
			'id' => 'billing_account_id',
			'prefix' => 'billing_address_',
		),
	),
);


if (!empty($_POST['do_copy'])) {
	$account = ListQuery::quick_fetch('Account', $_POST['account_id']);
	if ($account) {
		foreach ($meta as $m) {
			if (!empty($_POST[$m['module']])) {
				if (isset($m['billing']))
					do_copy_addresses($m['module'], $account, $m['billing'], 'billing_address_');
				if (isset($m['shipping']))
					do_copy_addresses($m['module'], $account, $m['shipping'], 'shipping_address_');
			}
		}
	}

	indexRedirect(array(
		'module' => 'Accounts',
		'action' => 'DetailView',
		'record' => $_POST['account_id'],
	));

	exit;
}

function do_copy_addresses($module, $account, $meta, $account_prefix) {
	static $address_fields = array('street', 'city', 'state', 'postalcode', 'country');
	$model = AppConfig::module_primary_bean($module);
	$lq = new ListQuery($model);
	$lq->addSimpleFilter($meta['id'], $account->getField('id'));
	if (isset($meta['conditions'])) {
		foreach($meta['conditions'] as $k => $v)
			$lq->addSimpleFilter($k, $v);
	}
	$it = new ListQueryIterator($lq, 20);
	foreach ($it as $result) {
		$upd = RowUpdate::for_result($result);
		foreach ($address_fields as $f) {
			$upd->set($meta['prefix'] . $f, $account->getField($account_prefix . $f));
		}
		$upd->save();
	}

}

$lang = AppConfig::setting("lang.lists.current.app.moduleList");

echo '<p style="padding: 15px">' . translate('LBL_COPY_ADDRESSES_DESC', 'Accounts') . '</p>';

	$fields = array();
	foreach ($meta as $m) {
		$fields[$m['module']] = array(
			'vname' => $lang[$m['module']],
			'type' => 'bool',
			'editable' => true,
		);
	}
	$layout = array(
		'editable' => true,
		'buttons_position' => 'bottom',
		'form_hidden_fields' => array(
			'module' => 'Accounts',
			'action' => 'CopyAddresses',
			'do_copy' => '1',
			'account_id' => $_POST['account_id'],
		),
		'form_buttons' => array(
			'copy' => array(
				'icon' => 'icon-accept',
				'label' => translate('LBL_COPY_ADDRESSES', 'Accounts'),
				'params' => array(),
				'async' => true,
				'align' => 'right',
				'post_perform' => "SUGAR.popups.close()",
			),
		),
		'sections' => array(
			array(
				'label_position' => 'left',
				'columns' => 2,
				'elements' => array_keys($fields),
			),
		),
	);
	$result = new RowResult;
	$result->row = array();
	foreach($fields as $k => $f) {
		if(isset($f['default']))
			$result->row[$k] = $f['default'];
		if(isset($f['default_id']))
			$result->row[$f['id_name']] = $f['default_id'];
	}
	$result->fields = $fields;
	
	require_once('include/layout/forms/FormGenerator.php');
	$model = new ModelDef(AppConfig::module_primary_bean($_REQUEST['module']));
	$model->addDisplayFieldDefinitions($result->fields);
	$gen = FormGenerator::html_form($model, $layout, 'printForm');
	$gen->getFormObject()->max_ref_width = 50;
	$gen->getFormObject()->addHiddenFields(array('layout' => array_get_default($_REQUEST, 'layout')));
	$gen->renderForm($result);
	echo $gen->getResult();
	$gen->exportIncludes();

