<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once('modules/Emails/Email.php');

$access_errors = array();

if  (  ! ACLController::checkAccess('Accounts', 'edit')
	|| ! ACLController::checkAccess('Invoice', 'edit')
	|| ! ACLController::checkAccess('Booking', 'edit')
	|| ! ACLController::checkAccess('Emails', 'edit')) {
	$access_errors[] = translate('LBL_NO_SEND_INVOICES_PERMISSION', 'Accounts');
}

if (! Email::check_email_settings()) {
	$access_errors[] = translate('WARNING_SETTINGS_NOT_CONF', 'Emails');
}

if($access_errors) {
	echo '<table class="tabForm" align="center" width="60%"><tr><td class="dataField">';
	echo '<p class="error">'.implode('</p><p class="error">', $access_errors).'</p>';
	echo '</td></tr></table>';
	return;
}

if(empty($_POST['confirm'])) {
	echo '<table class="tabForm" align="center" width="60%"><tr><td class="dataField">';
	echo translate('LBL_CONFIRM_SEND_INVOICES', 'Accounts');
	echo '<form method="POST">';
	echo create_csrf_input();
	echo '<input type="hidden" name="module" value="Accounts">';
	echo '<input type="hidden" name="action" value="SendJobInvoices">';
	echo '<input type="hidden" name="confirm" value="1">';
	echo '<p align="right"><button type="submit" class="input-button input-outer"><div class="input-icon icon-accept left"></div><span class="input-label">' . translate('LBL_PROCEED', 'Quotes') . '</span></button>';
	echo ' <button type="button" class="input-button input-outer" onclick="SUGAR.util.loadUrl(\'index.php?module=Accounts\');"><div class="input-icon icon-cancel left"></div><span class="input-label">' . translate('LBL_CANCEL_BUTTON_LABEL', 'app') . '</span></button>';
	echo '</form>';
	echo '</td></tr></table>';
	return;
}


require_once('modules/Accounts/Account.php');
$objAccount = new Account();
// Generate the invoices
$objAccount->generateJobInvoices();

// Email the invoices
if (! empty($_SESSION['send_account_ids'])) {
	// Redirect to the send statements engine
    header("Location: index.php?module=Accounts&action=SendPDFStatements");
} else {
    global $mod_strings;
	// No invoices generated
    add_flash_message($mod_strings['LBL_NO_INVOICES_CREATED'], 'warn');
    //throw new IAHError($mod_strings['LBL_NO_INVOICES_CREATED']);
	//echo $mod_strings['LBL_NO_INVOICES_CREATED'];
}
?>
