function multiMapInit(divId, addresses, key) {

	var MakeElt = SUGAR.dom.makeElement;

	var formatInfo = function(addr) {
		var elt = MakeElt('div', {}, {}, [
			MakeElt('div').html(addr.name),
			MakeElt('br'),
			MakeElt('div', {}, {}, addr.address)
		]);
		addr.extra.forEach(function(e) {
			elt.append(
				MakeElt('div', {}, {}, [
					MakeElt('br'),
					MakeElt('b', {}, {}, e.label),
					nbsp(),
					MakeElt('span').html(e.value)
				])
			);
		});
		return elt.get();
	};
	
	var active = 0;
	var pending = [];
	var lookup = function(address, callback) {
		if (active > 10) {
			pending.push([address, callback]);
			return;
		}
		active++;

		var xhr = new XMLHttpRequest();
		xhr.onreadystatechange = function() {
			if(xhr.readyState === 4) {
				var result;
				try {
                    result = xhr.responseText.length ? JSON.parse(xhr.responseText) : {status: 'FAILED'};
                } catch(e) {
                    result = {status: 'FAILED'};
                }
				callback(result);
				active--;
				if (pending.length) {
					var p = pending.pop();
					lookup(p[0], p[1]);
				}
			}
		}
		xhr.open('GET', 'https://maps.googleapis.com/maps/api/geocode/json?address=' + encodeURIComponent(address) + '&key=' + key);
		xhr.send();

	}

	var map;
	var fname = 'multiMapInit2';
	window[fname] = function() {
		console.log(document.getElementById(divId));
		map = new google.maps.Map(document.getElementById(divId), {
			center: {lat: 0, lng: 0}
		});
		map.setZoom(10);
		iws = [];

		var status_id;

		var bounds = new google.maps.LatLngBounds();
		var n = addresses.length;
		var lastInfoWindow;
		var successCount = 0;
		if (addresses.length) {
			status_id = SUGAR.ui.Status.show(app_string('LBL_MAPS_SEARCHING'));
			addresses.forEach(function(addr) {
				var done = function(result) {
					var results = result.results;
					var status = result.status;
					status_id.setMessage(app_string('LBL_MAPS_SEARCHING_PROGRESS').replace('%1', (addresses.length - n + 1)).replace('%2', addresses.length));
					SUGAR.ui.Status.updateDisplay();
					if (status === 'OK' && results.length) {
						successCount++;
						var result = results[0];
						var latLng = result.geometry.location;
						bounds.extend(latLng);
						var marker = new google.maps.Marker({
							position: latLng,		
							map: map,
							title: addr.name_raw
						});

						var infowindow = new google.maps.InfoWindow({
							content: formatInfo(addr)
						});

						marker.addListener('click', function() {
							iws.forEach(function(w) {if (w !== infowindow) w.close();});
							infowindow.open(map, marker);
						});
						iws.push(infowindow);
						lastInfoWindow = infowindow;
					}
					n--;
					if (n == 0) {
						if (successCount != addresses.length) {
							var nFailed = addresses.length - successCount;
							status_id.setMessage(app_string('LBL_MAPS_SEARCHING_FAIL').replace('%1', nFailed).replace('%2', addresses.length) );
							status_id.updateTimeout(2000);
						} else {
							SUGAR.ui.Status.remove(status_id);
						}
						if (lastInfoWindow)
							lastInfoWindow.open(map, marker);
						map.fitBounds(bounds, 20);
					}
				};
				lookup(addr.address, done);
			});
		}
	}
	if (window.google && window.google.maps) {
		window[fname]();
	} else {
		var script = document.createElement('script');
		script.src="https://maps.googleapis.com/maps/api/js?key=" + key + "&callback=" + fname;
		script.async = true;
		script.defer = true;
		window.document.head.appendChild(script);
	}

}

