<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
if(!defined('inScheduler')) die('Unauthorized access');


global $db;
require_once('include/Notify/RecordActionMessage.php');

$res = $db->query("SELECT run_interval FROM schedules WHERE type='activities_notification'");
$row = $db->fetchByAssoc($res);
if(! $row) return;
$run_interval = $row['run_interval'] * 60;
$now = gmdate('Y-m-d H:i:00');
$upper_limit = gmdate('Y-m-d H:i:00', time() + $run_interval);

$activities = array(
	'Call',
	'Meeting',
	'Task'
);
$qs = array();
foreach ($activities as $class) {
	$tbl_name = AppConfig::setting("model.detail.$class.table_name");
	if(! $tbl_name) continue;
	$qs[] = "SELECT {$tbl_name}.id, '$class' bean_name, {$tbl_name}.assigned_user_id FROM {$tbl_name} WHERE {$tbl_name}.deleted = 0 AND {$tbl_name}.email_reminder_time > 0 AND "
		.  "{$tbl_name}.date_start IS NOT NULL AND DATE_SUB({$tbl_name}.date_start, INTERVAL email_reminder_time SECOND) >= '$now' AND DATE_SUB({$tbl_name}.date_start, INTERVAL email_reminder_time SECOND) < '$upper_limit'";
}

if($qs) {
	$query = '('.implode(') UNION ALL (', $qs).')';
	$r = $db->query($query);
	while($row = $db->fetchByAssoc($r)) {
		$message = RecordActionMessage::for_action($row['bean_name'], 'reminder');
		if($message) {
			$message->addRecordId($row['id']);
			$mailer = $message->getMailer();
			$inv = $message->getInvitees();
			foreach($inv as $target)
				$mailer->addTargetInfo($target);
			$mailer->sendMessage($message);
		}
	}
}

