<?php

require_once 'include/ListView/ListViewCarouselManager.php';
require_once 'include/database/ListQuery.php';

$parent_id = array_get_default($_POST, 'parent_id');
$parent_type = array_get_default($_POST, 'parent_type', 'Opportunities');

$lq = getImagesQuery($parent_type, $parent_id);

if (!$lq)
	return;

$parent = ListQuery::quick_fetch_row(AppConfig::module_primary_bean($parent_type), $parent_id, array('name'));

$lv = new ListViewCarouselManager('listview', true);
$lv->show_create_button = false;
$lv->show_mass_update = false;
$lv->show_checks = false;
$lv->show_filter = false;
$lv->show_help = false;
$lv->show_additional_details = true;
$lv->is_images_carousel = true;
$lv->show_navigation = true;
$lv->custom_icon = $parent_type;

$title = AppConfig::setting("display.list.{$parent_type}.title", 'LBL_MODULE_TITLE');
$title = translate($title, $parent_type);
$lv->custom_title_html = to_html($title) . translate('LBL_SEPARATOR', 'app') . $parent['name'];

$lv->hide_navigation_controls = false;
$lv->no_sort = true;
$lv->loadRequest();

if (!$lv->initModuleView('Activities', 'Summary', null, null, null, 'ActivityHistory')) {
	ACLController::displayNoAccess();
}
$lv->show_tabs = false;
$lv->getFormatter()->setQuery($lq);


$ff = $lv->getFormatter()->getFieldFormatter();
$ff->limit_text_length = AppConfig::setting('layout.history.long_text_limit', 150);

$lv->render();


function &getImagesQuery($parent_type, $parent_id)
{
	$lq = null;
	$bean_name = AppConfig::module_primary_bean($parent_type);
	if ($bean_name) {
		$lq = new ListQuery($bean_name, null, array('link_name' => 'notes'));
		$lq->setParentKey($parent_id);
		$lq->addField('module_name');
		$lq->addSimpleFilter('filename', "filename REGEXP '\\.(jpg|jpeg|png|gif|bmp|webp)$'", 'literal');
	}
	return $lq;
}


