<?php return; /* no output */ ?>

detail
	type: union
	primary_key: id
	default_order_by: activity_date desc
	reportable: true
fields
	app.id
	app.deleted
	# app.date_entered
	app.date_modified
	app.assigned_user
	# show module icon in subpanel
	# show 'close' button depending on module
	date_entered_a
		type: datetime
		vname: LBL_DATE_ENTERED
		vname_list: LBL_LIST_DATE_ENTERED
		width: 20
		massupdate: false
		union_source: date_entered
	query_module
		type: module_name
		vname: LBL_MODULE
		source
			type: module_name
		options
			- Calls
			- Meetings
			- Emails
			- Tasks
			- Notes
	name
		type: name
		vname: LBL_SUBJECT
		vname_list: LBL_LIST_SUBJECT
		width: 40
		dynamic_module: query_module
		unified_search: true
	status
		type: enum
		options: activity_status_dom
		vname: LBL_STATUS
		vname_list: LBL_LIST_STATUS
		width: 25
		massupdate: false
		union_source
			notes
				name: status
				type: status
				options: moduleListSingular
				source
					type: static
					value: Notes
	has_attach
		vname: LBL_HAS_ATTACH
		type: attach_icon
		union_source
			emails
				name: has_attach
				type: attach_icon
				source
					type: subselect
					class: Email
					function: has_attach
			notes
				source
					type: literal
					value: "IF(IFNULL(filename, '') = '', 0, 1)"
				name: has_attach
				type: attach_icon
			calls
				name: has_attach
				type: static
				value: 0
				source
					type: non-db
			meetings
				name: has_attach
				type: static
				value: 0
				source
					type: non-db
			tasks
				name: has_attach
				type: static
				value: 0
				source
					type: non-db
			chats
				name: has_attach
				type: static
				value: 0
				source
					type: non-db
	replied
		vname: LBL_IS_REPLIED
		type: replied_icon
		union_source
			emails: replied
			notes
				name: replied
				type: static
				value: 0
				source
					type: non-db
			calls
				name: replied
				type: static
				value: 0
				source
					type: non-db
			meetings
				name: replied
				type: static
				value: 0
				source
					type: non-db
			tasks
				name: replied
				type: static
				value: 0
				source
					type: non-db
			chats
				name: replied
				type: static
				value: 0
				source
					type: non-db
	contact
		type: ref
		bean_name: Contact
		vname: LBL_CONTACT
		vname_list: LBL_LIST_CONTACT
		width: 25
	contact_id
		type: id
		union_source
			meetings
				name: contact_id
				type: static
				value: ""
				source
					type: non-db
			calls
				name: contact_id
				type: static
				value: ""
				source
					type: non-db
	parent
		type: ref
		vname: LBL_RELATED_TO
		vname_list: LBL_LIST_RELATED_TO
		dynamic_module: parent_type
		width: 25
		massupdate: false
	parent_type
		type: module_name
		vname: LBL_RELATED_MODULE
	activity_date
		type: datetime
		vname: LBL_DATE
		vname_list: LBL_LIST_DATE
		width: 20
		massupdate: false
		union_source
			meetings: date_start
			calls: date_start
			tasks: date_due
			emails: date_start
			notes: date_entered
			chats: date_started
	filename
		type: varchar
		vname: LBL_FILENAME
		vname_list: LBL_LIST_FILENAME
		width: 20
		massupdate: false
		union_source
			notes: filename
			meetings
				name: filename
				source
					type: non-db
					value: ""
			calls
				name: filename
				source
					type: non-db
					value: ""
			tasks
				name: filename
				source
					type: non-db
					value: ""
			emails
				name: filename
				source
					type: non-db
					value: ""
			chats
				name: filename
				source
					type: non-db
					value: ""
	is_private
		type: bool
		vname: LBL_PRIVATE
		union_source
			emails
                name: is_private
                type: static
                value: 0
                source
                    type: non-db
			notes
                name: is_private
                type: static
                value: 0
                source
                    type: non-db
			chats
                name: is_private
                type: static
                value: 0
                source
                    type: non-db
	description
		type: text
		vname: LBL_DESCRIPTION
		union_source
			emails: body.description
			chats
				name: description
				source
					type: concat
					fields
						- id
						- provider_name
						- transcript
					separator: ~
		widget: ChatTranscriptHistoryWidget
	account_id
		type: ref_id
	extra1
		type: text
		source
			type: static
			value: ""
		union_source
			chats: transcript
	effort_estim
        vname: LBL_EFFORT_ESTIM
        type: duration
        len: 4
        union_source
            tasks: effort_estim
            calls
                name: effort_estim
                type: static
                value: ""
                source
                    type: non-db
            meetings
                name: effort_estim
                type: static
                value: ""
                source
                    type: non-db
            chats
                name: effort_estim
                type: static
                value: ""
                source
                    type: non-db
            emails
				name: effort_estim
                type: static
                value: ""
                source
                    type: non-db
			notes
				name: effort_estim
                type: static
                value: ""
                source
                    type: non-db
    effort_actual
        vname: LBL_EFFORT_ACTUAL
        type: duration
        len: 4
        union_source
            tasks: effort_actual
            calls
                name: effort_actual
                type: static
                value: ""
                source
                    type: non-db
            meetings
                name: effort_actual
                type: static
                value: ""
                source
                    type: non-db
            chats
                name: effort_actual
                type: static
                value: ""
                source
                    type: non-db
            emails
				name: effort_actual
                type: static
                value: ""
                source
                    type: non-db
			notes
				name: effort_actual
                type: static
                value: ""
                source
                    type: non-db
sources
	meetings
		model: Meeting
		filters
			--
				field: status
				value: [Held, Not Held]
	calls
		model: Call
		filters
			--
				field: status
				value: [Held, Not Held]
	tasks
		model: Task
		filters
			--
				field: status
				value: [Completed, Deferred]
	emails
		model: Email
		filters
			--
				field: folder_ref.reserved
				operator: !=
				value: 4
	notes
		model: Note
		filters
			--
				field: email_attachment
				operator: "false"
	chats
		model: Chat
		filters
			--
				field: status
				operator: !=
				value: In Progress

