<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

action_restricted_for('demo');

global $db;

$check = array(
	'Accounts' => array('billing_address', 'shipping_address'),
	'Contacts' => array('primary_address', 'alt_address'),
	'Leads' => array('primary_address', 'alt_address'),
	'Prospects' => array('primary_address', 'alt_address'),
	'Quotes' => array('billing_address', 'shipping_address'),
	'Invoice' => array('billing_address', 'shipping_address'),
	'PurchaseOrders' => array('billing_address', 'shipping_address'),
	'SalesOrders' => array('billing_address', 'shipping_address'),
);

$check_mod = array_get_default($_REQUEST, 'check_mod');
$check_field = array_get_default($_REQUEST, 'check_field');
$check_val = array_get_default($_REQUEST, 'check_value');
$codes = AppConfig::setting('lang.lists.current.app.country_codes');
$countries = array();
foreach($codes as $c => $name) {
	$countries[strtolower($name)] = $c;
}

$all_states = include('include/language/country_states.php');
$states = array();
foreach($all_states as $ccode => $sts) {
	foreach($sts as $scode => $s) {
		$states[$ccode][strtolower($s)] = $scode;
	}
}

if(! $check_mod) {
	echo '<h1>Check for unknown countries</h1>';
	echo '<div class="body" style="margin-top: 10px">';
	echo '<p>Select a module to check:</p>';
	foreach($check as $mod => $fields) {
		echo '<p><div class="input-icon theme-icon module-'.$mod.'"></div> <a href="?module=Administration&action=CheckCountries&check_mod=' . $mod . '">' . translate_dd('moduleList', $mod) . '</a></p>';
	}
	echo '</div>';
} else if(isset($check[$check_mod])) {
	$qfs = array();
	$labels = array();
	$q_fields = array();
	$model = AppConfig::module_primary_bean($check_mod);
	$table = AppConfig::setting("model.detail.$model.table_name");
	$have_code = array();

	foreach($check[$check_mod] as $f) {
		$spec = AppConfig::setting("model.fields.$model.{$f}_country");
		$spec2 = AppConfig::setting("model.fields.$model.{$f}_state");
		if($spec) {
			$qfs[] = $f;
			$labels[$f] = translate($spec['vname'], $check_mod);
			$labels[$spec['name']] = translate($spec['vname'], $check_mod);
			$labels[$spec2['name']] = translate($spec2['vname'], $check_mod);
			$q_fields[] = $spec['name'];
			$q_fields[] = $spec2['name'];
			$sf = AppConfig::setting("model.fields.$model.{$f}_statecode");
			$have_code[$f.'_state'] = $sf ? $sf['name'] : false;
			$cf = AppConfig::setting("model.fields.$model.{$f}_countrycode");
			$have_code[$f.'_country'] = $cf ? $cf['name'] : false;
			if($have_code[$f.'_state']) {
				$q_fields[] = $have_code[$f.'_state'];
				$labels[$sf['name']] = translate($sf['vname'], $check_mod);
			}
			if($have_code[$f.'_country']) {
				$q_fields[] = $have_code[$f.'_country'];
				$labels[$cf['name']] = translate($cf['vname'], $check_mod);
			}
		}
	}

	if(! empty($check_field) && isset($labels[$check_field])) {
		require_once('include/ListView/ListViewManager.php');
		$manager = ListViewManager::create('listview', array('is_primary' => 1));
		$manager->loadRequest();

		if(! $manager->initModuleView($check_mod, 'Browse')) {
			ACLController::displayNoAccess();
		}
		pr2("Showing records with {$labels[$check_field]}: \"" . $check_val . '"');
		$manager->addOverrideFilters(array($check_field => $check_val));
		$manager->render();
	} else {
		$miss = array();
		$miss_s = array();
		$update = array();
	
		if($qfs) {
			$q = new ListQuery($model, array_merge(array('_display'), $q_fields));
			foreach($q as $row) {
				$row_id = $row->getField('id');
				foreach($qfs as $f) {
					$ccode = null;
					$country_f = $f.'_country';
					$v = strtolower(trim($row->getField($country_f)));
					$l = strlen($v);
					if($l && ! isset($countries[$v])) {
						$uv = strtoupper($v);
						if(isset($codes[$uv])) {
							$update[$country_f][$codes[$uv]][] = $row_id;
							$ccode = $uv;
						}
						else if(! $have_code[$country_f] || ! $row->getField($have_code[$country_f])) {
							$miss[$country_f][$v][] = $row_id;
						}
					} else if($l)
						$ccode = $countries[$v];
					if($ccode) {
						if($have_code[$country_f] && $row->getField($have_code[$country_f]) != $ccode) {
							$update[$have_code[$country_f]][$ccode][] = $row_id;
						}
						if(isset($states[$ccode])) {
							$state_f = $f.'_state';
							$scode = null;
							$val = strtolower(trim($row->getField($state_f)));
							if($val) {
								if(! isset($states[$ccode][$val])) {
									$uv = strtoupper($val);
									if(isset($all_states[$ccode][$uv])) {
										$update[$state_f][$all_states[$ccode][$uv]][] = $row_id;
										$scode = $uv;
									}
									else if(isset($all_states[$ccode][$ccode.'-'.$uv])) {
										$update[$state_f][$all_states[$ccode][$ccode.'-'.$uv]][] = $row_id;
										$scode = $ccode.'-'.$uv;
									}
									else {
										$miss_s[$state_f][$ccode][$val] = $row_id;
									}
								}
								else if($have_code[$state_f])
									$scode = $states[$ccode][$val];
								if($scode) {
									if($row->getField($have_code[$state_f]) != $scode)
										$update[$have_code[$state_f]][$scode][] = $row_id;
								}
							}
						}
					}
				}
			}
		}
	
		echo '<h1>Check unknown countries: ' . translate_dd('moduleList', $check_mod) . '</h1>';
		if($miss) {
			foreach($miss as $field => $vals) {
				echo '<div class="body" style="margin-top: 10px">';
				echo $labels[$field];
				echo '<ul>';
				foreach($vals as $val => $rows) {
					$rowsCount = is_countable($rows) ? count($rows) : 0;
					echo '<li><a href="?module=Administration&action=CheckCountries&check_mod=' . $check_mod . '&check_field=' . $field . '&check_value=' . urlencode($val) . '">' . to_html($val) . '</a> (' . $rowsCount . ')</li>';
				}
				echo '</ul>';
				echo '</div>';
			}
		} else {
			pr2('No unknown country values found.');
		}
		
		if($miss_s) {
			echo '<h3>Unknown states</h3>';
			foreach($miss_s as $field => $vals) {
				echo '<div class="body" style="margin-top: 10px">';
				echo $labels[$field];
				echo '<ul>';
				foreach($vals as $ccode => $rows) {
					$cname = $codes[$ccode];
					foreach($rows as $state => $ids) {
						$cnt = is_array($ids) ? count($ids) : 1;
						echo '<li><a href="?module=Administration&action=CheckCountries&check_mod=' . $check_mod . '&check_field=' . $field . '&check_value=' . urlencode($state) . '">' . to_html($state) . '</a> (' . $cnt . ')</li>';
					}
				}
				echo '</ul>';
				echo '</div>';
			}
		}
		
		$max_upd = 200;
		
		foreach($update as $field => $vals) {
			foreach($vals as $ccode => $rows) {
				$qc = $db->quote($ccode);
				while($rows) {
					$ids = "('".implode("','", array_slice($rows, 0, $max_upd))."')";
					$rows = array_slice($rows, $max_upd);
					$q = "UPDATE `$table` SET `{$field}`='$qc' WHERE id IN $ids";
					//prq($q);
					$db->query($q);
				}
			}
		}
	}
}

?>

