<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/



global $app_strings;
global $app_list_strings;
global $mod_strings;


echo get_module_title($mod_strings['LBL_MODULE_NAME'], $mod_strings['LBL_MAINTAIN_TITLE'], true);


function make_section($title, $links) {
	$sect = [
		'label' => translate($title, 'Administration'),
		'columns' => 1,
		'elements' => []
	];

	foreach($links as $l) {
		$val = get_image($l['icon']) . ' ' . '<a href="' . to_html($l['url']) . '">';
		$val .= translate($l['vname'], 'Administration') . '</a>';

		$query = parse_url($l['url'], PHP_URL_QUERY);
		parse_str($query, $params);
		$hideItem = AppConfig::setting("site.features.admin_hide_{$params['action']}");
		if ($hideItem) continue;

		$sect['elements'][] = [
			'type' => 'static',
			'value' => $val,
			'desc' => translate($l['vdesc'], 'Administration'),
		];
	}

	return $sect;
}

$layout = [
	'type' => 'adminform',
	'sections' => []
];

$links = [
	[
		'icon' => 'Repair',
		'url' => 'index.php?module=Administration&action=RepairSchema',
		'vname' => 'LBL_REPAIR_DATABASE',
		'vdesc' => 'LBL_REPAIR_DATABASE_DESC',
	],
	[
		'icon' => 'Repair',
		'url' => 'index.php?module=Administration&action=CleanupCustom',
		'vname' => 'LBL_CLEANUP_CUSTOM',
		'vdesc' => 'LBL_CLEANUP_CUSTOM_DETAILS',
	]
];
$layout['sections'][] = make_section('LBL_DATABASE_MAINTAIN_TITLE', $links);


$links = [
	[
		'icon' => 'Notes',
		'url' => 'index.php?module=Administration&action=CleanUploads',
		'vname' => 'LBL_CLEAN_UPLOADS',
		'vdesc' => 'LBL_CLEAN_UPLOADS_TITLE',
	],
	[
		'icon' => 'Rebuild',
		'url' => 'index.php?module=Administration&action=ResetCache',
		'vname' => 'LBL_RESET_SYSTEM_CACHE_TITLE',
    	'vdesc' => 'LBL_RESET_SYSTEM_CACHE_DESC',
    ],
    [
    	'icon' => 'Rebuild',
    	'url' => 'index.php?module=Administration&action=clear_chart_cache',
    	'vname' => 'LBL_CLEAR_CHART_DATA_CACHE_TITLE',
    	'vdesc' => 'LBL_CLEAR_CHART_DATA_CACHE_DESC',
    ],
    [
    	'icon' => 'Rebuild',
    	'url' => 'index.php?module=Administration&action=RebuildSchedulers',
    	'vname' => 'LBL_REBUILD_SCHEDULERS_TITLE',
    	'vdesc' => 'LBL_REBUILD_SCHEDULERS_DESC_SHORT',
    ],
    [
    	'icon' => 'Rebuild',
    	'url' => 'index.php?module=Administration&action=RebuildPDFTemplates',
    	'vname' => 'LBL_REBUILD_PDF_TEMPLATES_TITLE',
    	'vdesc' => 'LBL_REBUILD_PDF_TEMPLATES_DESC_SHORT',
    ],
    [
    	'icon' => 'Rebuild',
    	'url' => 'index.php?module=Administration&action=RebuildDashlets',
    	'vname' => 'LBL_REBUILD_DASHLETS_TITLE',
    	'vdesc' => 'LBL_REBUILD_DASHLETS_DESC_SHORT',
    ],
    [
    	'icon' => 'Rebuild',
    	'url' => 'index.php?module=Administration&action=RebuildJSLang',
    	'vname' => 'LBL_REBUILD_JAVASCRIPT_LANG_TITLE',
    	'vdesc' => 'LBL_REBUILD_JAVASCRIPT_LANG_DESC_SHORT',
    ]
];
$layout['sections'][] = make_section('LBL_CACHE_MAINTAIN_TITLE', $links);


$links = [
	[
		'icon' => 'LanguagePacks',
		'url' => 'index.php?module=Administration&action=LanguageFiles',
		'vname' => 'LBL_LANGUAGE_FILES_TITLE',
		'vdesc' => 'LBL_LANGUAGE_FILES',
	],
	[
		'icon' => 'Activities',
		'url' => 'index.php?module=Administration&action=RepairSyncDates',
		'vname' => 'LBL_REPAIR_SYNC_DATES',
		'vdesc' => 'LBL_REPAIR_SYNC_DATES_DESC',
	],
	[
		'icon' => 'Employees',
		'url' => 'index.php?module=Administration&action=RepairEmployees',
		'vname' => 'LBL_REPAIR_EMPLOYEES',
		'vdesc' => 'LBL_REPAIR_EMPLOYEES_DESC',
	],
	[
		'icon' => 'EmailFolders',
		'url' => 'index.php?module=Administration&action=RepairEmailFolders',
		'vname' => 'LBL_REPAIR_EMAIL_FOLDERS',
		'vdesc' => 'LBL_REPAIR_EMAIL_FOLDERS_DESC',
	],
	[
		'icon' => 'ConfigureTabs',
		'url' => 'index.php?module=Administration&action=ClearUserTabPrefs',
		'vname' => 'LBL_CLEAR_TAB_PREFS',
		'vdesc' => 'LBL_CLEAR_TAB_PREFS_DESC',
	],
	[
		'icon' => 'Rebuild',
		'url' => 'index.php?module=Administration&action=UpgradeAccess',
		'vname' => 'LBL_REBUILD_HTACCESS',
		'vdesc' => 'LBL_REBUILD_HTACCESS_DESC',
	],
	[
		'icon' => 'Rebuild',
		'url' => 'index.php?module=Administration&action=RebuildVcards',
		'vname' => 'LBL_REBUILD_VCARDS',
		'vdesc' => 'LBL_REBUILD_VCARDS_DESC',
	],
	[
		'icon' => 'Rebuild',
		'url' => 'index.php?module=Administration&action=CheckCountries',
		'vname' => 'LBL_CHECK_COUNTRIES',
		'vdesc' => 'LBL_CHECK_COUNTRIES_DESC',
	],
	[
		'icon' => 'Rebuild',
		'url' => 'index.php?module=Administration&action=ValidateEmails',
		'vname' => 'LBL_VALIDATE_EMAILS',
		'vdesc' => 'LBL_VALIDATE_EMAILS_DESC',
	],
	[
		'icon' => 'Calls',
		'url' => 'index.php?module=Administration&action=NormalizePhoneNumbers',
		'vname' => 'LBL_NORMALIZE_PHONES',
		'vdesc' => 'LBL_NORMALIZE_PHONES_DESC',
	],
	[
		'icon' => 'KBArticles',
		'url' => 'index.php?module=KBCategories&action=UpdateCounters',
		'vname' => 'LBL_COUNT_ARTICLES',
		'vdesc' => 'LBL_COUNT_ARTICLES_DESC',
	],
	[
		'icon' => 'Rebuild',
		'url' => 'index.php?module=Administration&action=UpdateOpportunities',
		'vname' => 'LBL_UPDATE_OPPORTUNITY_NUMBERS',
		'vdesc' => 'LBL_UPDATE_OPPORTUNITY_NUMBERS_DESC',
	],
	[
		'icon' => 'Rebuild',
		'url' => 'index.php?module=Administration&action=UpdateAccountNumbers',
		'vname' => 'LBL_UPDATE_ACCOUNT_NUMBERS',
		'vdesc' => 'LBL_UPDATE_ACCOUNT_NUMBERS_DESC',
	],
	[
		'icon' => 'Rebuild',
		'url' => 'index.php?module=Administration&action=ResetInvoices',
		'vname' => 'LBL_RESET_INVOICES_TITLE',
		'vdesc' => 'LBL_RESET_INVOICES_DESC',
	],
	[
		'icon' => 'Emails',
		'url' => 'index.php?module=Administration&action=SetEmailCampaign',
		'vname' => 'LBL_FILL_EMAIL_CAMPAIGN',
		'vdesc' => 'LBL_FILL_EMAIL_CAMPAIGN_DESC',
	],
];
$layout['sections'][] = make_section('LBL_OTHER_MAINTAIN_TITLE', $links);

require_once('include/layout/forms/FormGenerator.php');
$gen = FormGenerator::html_form(null, $layout, 'AdminForm');
$gen->setFormClass('card-outer form-outer default-form admin-form');
$gen->renderForm(null, 'Administration');
$html = $gen->getResult();
$gen->exportIncludes();


echo '<div class="detailOuter">' . $html . '</div>';

