<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');


action_restricted_for('demo');

require_once 'include/database/ListQuery.php';
require_once 'include/utils/vcard_utils.php';

global $current_user;
if(! is_admin($current_user))
	die('Admin Only Section');

/** @var MysqliManager $db */
global $db, $mod_strings;

$q = new ListQuery('Contact');
$r = $q->fetchAll();
$errors_rows = '';

foreach ($r as $item) {
	$errors = [];
	$vcard = vCardUtils::vcard_update($item, null, true);

	if ($vcard) {
		$query = "UPDATE `contacts` SET `vcard` = '".$db->quote($vcard)."'  WHERE id = '{$item->getPrimaryKeyValue()}'";
		$result = $db->query($query);
	}

	if (sizeof($errors) > 0) {
		foreach ($errors as $contact_id => $details) {
			$errors_rows .= "<tr>
				<td style='padding: 6px;'>{$mod_strings['LBL_REBUILD_VCARDS_ERROR']} <a href='?module=Contacts&action=DetailView&record={$contact_id}' target='_blank'>{$details['name']}</a> - {$details['message']}</td>
			</tr>
		";
		}
	}
}

echo <<<EOF
<div style="font-size: 120%; max-width: 700px;">
<table class="tabForm" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<th class="dataLabel">
			<h2 style="text-align:center"><b>{$mod_strings['LBL_REBUILD_VCARDS']}</b></h2>
		</th>
	</tr>
	<tr>
		<td class="dataLabel" style="text-align: center;">
			<b>{$mod_strings['LBL_REBUILD_VCARDS_FINISH']}</b>
		</td>
	</tr>	
	{$errors_rows}	
</table>
</div>
EOF;
