<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
action_restricted_for('demo');
ini_set( "max_execution_time", "0" );

global $current_user;
if(! is_admin($current_user))
	die('Admin Only Section');

global $mod_strings;

$q = new ListQuery('CampaignLog', ['campaign_id', 'related_id']);

$clause = [
	'operator' => 'AND',
	'multiple' => [
		[
			'field' => 'campaign_id',
			'operator' => 'not_empty',
		],
		[
			'field' => 'related_type',
			'value' => 'Emails',
		]
	]
];

$q->addFilterClause($clause);
$result = $q->fetchAll();

if (!$result->failed) {
	$rows = $result->getRows();

	foreach ($rows as $item) {
		$email = ListQuery::quick_fetch('Email', $item['related_id']);
		if ($email->failed) continue;
		$upd = RowUpdate::for_result($email);
		$upd->set("campaign_id", $item['campaign_id']);
		$upd->save();
	}
}

AppConfig::set_local("site.features.admin_hide_SetEmailCampaign", true);
AppConfig::save_local();

echo <<<EOF
<div style="font-size: 120%; width: 100%;">
<table class="tabForm" cellpadding="0" cellspacing="0" width="100%">
	<tr>
		<th class="dataLabel">
			<h2 style="text-align:center"><b>{$mod_strings['LBL_FILL_EMAIL_CAMPAIGN']}</b></h2>
		</th>
	</tr>
	<tr>
		<td class="dataLabel" style="text-align: center;">
			<b>{$mod_strings['LBL_FILL_EMAIL_CAMPAIGN_FINISH']}</b>
		</td>
	</tr>	
</table>
</div>
EOF;
