<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

action_restricted_for('demo');
require_once('modules/Administration/upgrade_utils.php');

$update = update_htaccess();
if( $update['failed'] ){
    echo '<p>' . $mod_strings['LBL_HT_NO_WRITE'] . '<span class=stop>' . $update['file'] . "</span></p>\n";
    echo '<p>' . $mod_strings['LBL_HT_NO_WRITE_2'] . "</p>\n";
    echo '<textarea class="input-textarea" cols="100" rows="20">' . htmlspecialchars($update['contents']) . '</textarea><br>';
}


// cn: bug 9365 - security for filesystem
$uploadDir = getcwd()."/".AppConfig::upload_dir();
$uploadHta = $uploadDir.".htaccess";
$denyAll =<<<eoq
<Directory>
	Order Deny,Allow
	Deny from all
</Directory>
eoq;

if(file_exists($uploadHta) && filesize($uploadHta)) {
	// file exists, parse to make sure it is current
	if(is_writable($uploadHta) && ($fpUploadHta = @fopen($uploadHta, "r+"))) {
		$oldHtaccess = fread($fpUploadHta, filesize($uploadHta));
		// use a different regex boundary b/c .htaccess uses the typicals
		if(!preg_match("=".$denyAll."=", $oldHtaccess)) {
			$oldHtaccess .= $denyAll;
		}
		
		rewind($fpUploadHta);
		fwrite($fpUploadHta, $oldHtaccess);
		ftruncate($fpUploadHta, ftell($fpUploadHta));
		fclose($fpUploadHta);		
	} else {
		$htaccess_failed = true;
	}
} else {
	// no .htaccess yet, create a fill
	if($fpUploadHta = @fopen($uploadHta, "w")) {
		fputs($fpUploadHta, $denyAll, strlen($denyAll));
		fclose($fpUploadHta);
	} else {
		$htaccess_failed = true;
	}
}


if(! $update['failed']) {
	echo "\n<p>" . $mod_strings['LBL_HT_DONE']. "</p><br />\n";
    echo '<textarea class="input-textarea" cols="100" rows="20">' . htmlspecialchars($update['contents']) . '</textarea><br>';
}

echo '<button type="button" class="input-button input-outer" onclick="SUGAR.util.loadUrl(\'index.php?module=Administration&action=Maintain\');"><div class="input-icon icon-return left"></div><span class="input-label">'. translate('LBL_RETURN') . '</span></button>';

?>
