var selected_asset_account;

function setOnSubmitEvent() {
    if ($('DetailForm_save'))
        $('DetailForm_save').onclick = submitForm;
    if ($('DetailForm_save2'))
        $('DetailForm_save2').onclick = submitForm;
    $('DetailForm').onsubmit = submitForm;
}

function submitForm() {
    var form = document.DetailForm;
    if(window.serials_editor && form.serial_updates)
		form.serial_updates.value = serials_editor.getChanges();
    return SUGAR.ui.sendForm(form, {'record_perform':'save'});
}

function initAssetForm(form) {
	setOnSubmitEvent();
	set_contract_filters(form, null, true);
	set_cat_filter(form);
	add_product_extra_fields(form);
}

function initAssemblyForm(form) {
	setOnSubmitEvent();
	set_contract_filters(form, null, true);
	set_cat_filter(form);
	add_assembly_extra_fields(form);
}


function add_product_extra_fields(form) {
    var name = SUGAR.ui.getFormInput(form, 'product_name');
    if (name) {
        if (name.getKey() != '')
            name.update('', name.getKey(), true);
        var fields = {
            url: 'url',
            tax_code: 'tax_code',
            tax_code_id: 'tax_code_id',
            supplier: 'supplier',
            supplier_id: 'supplier_id',
            manufacturer: 'manufacturer',
            manufacturer_id: 'manufacturer_id',
            model: 'model',
            model_id: 'model_id',
            weight_1: 'weight_1',
            weight_2: 'weight_2',
            manufacturers_part_no: 'manufacturers_part_no',
            product_category: 'product_category',
            product_category_id: 'product_category_id',
            product_type: 'product_type',
            product_type_id: 'product_type_id',
            vendor_part_no: 'vendor_part_no',
            purchase_price: 'purchase_price',
            unit_support_price: 'support_selling_price',
            support_cost: 'support_cost',
            currency: 'currency_id',
            exchange_rate: 'exchange_rate',
            description: 'description'
        };
        name.addExtraReturnFields(fields);
    }
}

function set_asm_name_extra(form) {
    setTimeout('add_assembly_extra_fields("'+form+'")', 400);
}

function add_assembly_extra_fields(form) {
    var name = SUGAR.ui.getFormInput(form, 'assembly_name');
    if (name) {
        if (name.getKey() != '')
            name.update('', name.getKey(), true);
        var fields = {
            product_category: 'product_category',
            product_category_id: 'product_category_id',
            product_type: 'product_type',
            product_type_id: 'product_type_id',
            supplier: 'supplier',
            supplier_id: 'supplier_id',
            manufacturer: 'manufacturer',
            manufacturer_id: 'manufacturer_id',
            model: 'model',
            model_id: 'model_id',
            product_url: 'product_url',
            manufacturers_part_no: 'manufacturers_part_no',
            vendor_part_no: 'vendor_part_no',
            description: 'description'
        };
        name.addExtraReturnFields(fields);
    }
}

function set_contract_filters(form, account_id, initial) {
	var contract = SUGAR.ui.getFormInput(form, 'service_subcontract');
	if (contract) {
		contract.add_filters = [{param: 'account', field_name: "account"}];
		if (!initial) {
			if (selected_asset_account != account_id) {
				contract.clear();
				selected_asset_account = account_id;
			}
		} else {
			var account = SUGAR.ui.getFormInput(form, 'account');
			if (account)
				selected_asset_account = account.getKey();
		}
	}
}

function set_cat_filter(form) {
    var cat = SUGAR.ui.getFormInput(form, 'product_category'),
    	type = SUGAR.ui.getFormInput(form, 'product_type');
    if (! cat || ! type) return;
    
    SUGAR.ui.attachInputEvent(cat, 'onchange', function() { type.clear(); });

	type.addFilter({param: 'category', field_name: 'product_category'});
    
    var name = SUGAR.ui.getFormInput(form, 'product_name');
    if(name && name.addFilter) {
    	name.addFilter({param: 'product_category', field_name: 'product_category'});
    	name.addFilter({param: 'product_type', field_name: 'product_type'});
    }
}

function set_from_main(key, value, passthru) {
    var inp = null;
    for (var field in value) {
		val = value[field];
		if (field == 'description') {
			var tmp = document.createElement("DIV");
			tmp.innerHTML = val;
			val = tmp.textContent || tmp.innerText;
		}

        if (value.hasOwnProperty(field)) {
            inp = SUGAR.ui.getFormInput('DetailForm', field);
            if (inp) {
                if(inp.format == 'int' || inp.format == 'float' || inp.format == 'currency') {
					val = stdFormatNumber(val);
				}
                if (typeof(inp.setValue) != 'undefined') {
                    inp.setValue(val, true);
                } else if (typeof(inp.update) != 'undefined') {
                    inp.update(value[field + '_id'], val, true);
                    delete value[field + '_id'];
                }
            } else {
                if (typeof(document.forms.DetailForm[field]) != 'undefined' && field != 'id') {
                    document.forms.DetailForm[field].value = val;
                }
            }
        }
    }
}
