<?php

require_once 'include/ListView/ListFormatter.php';
require_once 'include/database/RowResult.php';

class AuditListFormatterFactory {
	static function create($model = null, $link_name = null, $list_id = null, $context = 'listview', $params = null)
	{
		return new AuditListFormatter($model, $link_name, $list_id, $context, $params);
	}
	
}

class AuditListFormatter extends ListFormatter {
	function loadColumns($spec, &$columns, $depth = 0, $report_data = false) {
		$spec[] = [
            'field' => 'source',
            'width' => 30,
            'vname' => 'LBL_PERSONAL_INFO_SOURCE',
            'vname_module' => 'app',
		];
		$ret = parent::loadColumns($spec, $columns, $depth, $report_data);
		return $ret;
	}

	function formatResultRows(ListResult &$result) {
		$ret = parent::formatResultRows($result);
		$value = '<div class="badge state-error">' . translate('LBL_VALUE_ERASED', 'app') . '</div>';
		foreach ($result->formatted_rows as &$fr) {
			if ($fr['erased']) {
				if ($fr['erased'] == 1) {
					$fr['after_value_string'] = $value;
				}
				$fr['before_value_string'] = $value;
			}
		}
		return $ret;
	}
}

