var HoursEditView = function() {
	return {
		initEditView:function(form_id) {
            HoursEditView.form = SUGAR.ui.getForm(form_id);
            var tab = SUGAR.ui.getFormInput(HoursEditView.form, 'form-tabs');
            if(tab) {
                tab.enableDisableTab('Meeting', true);
                tab.enableDisableTab('Call', true);
                tab.enableDisableTab('Booking', true);
            }
            SUGAR.ui.onInitForm(this.form, function() { HoursEditView.initExtra(); });
		},
		initFilters: function() {
            var rel = SUGAR.ui.getFormInput(HoursEditView.form, 'related');
            if (rel && rel instanceof SUGAR.ui.RefInput) {
                /*if (! change_type) {
                    var func = rel.module_field.onchange;
                    rel.module_field.onchange = function() {func(); HoursEditView.setRelatedFilters(true)};
                }*/
                rel.addExtraReturnFields({'account_id': 'account_id', 'account': 'account',
                	'default_booking_category_id': 'default_booking_category_id', 'default_booking_category': 'default_booking_category'});
                rel.addFilter({param: 'account', field_name: 'account'});
                rel.addFilter({param: 'user_id', field_name: 'assigned_user_id'});

				SUGAR.ui.attachInputEvent(rel, 'onchange',
					function(k, v) {
						var acct = SUGAR.ui.getFormInput(this.form, 'account'),
							cat = SUGAR.ui.getFormInput(this.form, 'booking_category');
						if(acct && v && v.account_id)
							acct.update(v.account_id, v.account, true);
						if(cat && v && v.default_booking_category_id)
							cat.update(v.default_booking_category_id, v.default_booking_category, true);

						HoursEditView.setTaskRates();
					}
				);
            }
            else if( (rel = SUGAR.ui.getFormInput(HoursEditView.form, 'related_id')) ) {
				SUGAR.ui.attachInputEvent(rel, 'onchange',
					function(k, v) {
						SUGAR.ui.getFormInput(HoursEditView.form, 'account').update(v.account_id, v.account, true);
						HoursEditView.setTaskRates();
					}
				);
			}
		},
        initExtra:function() {
        	var input, price_fields = ['billing_rate', 'paid_rate', 'billing_total', 'paid_total'];
        	for(var i = 0; i < price_fields.length; i++) {
        		input = SUGAR.ui.getFormInput(this.form, price_fields[i]);
        		if(input) input.onchange = function() { HoursEditView.updateAmount(this); }
        	}
        	SUGAR.ui.attachFormInputEvent(this.form, 'quantity', 'onchange',
				function() { HoursEditView.updateQuantity(); });
        	SUGAR.ui.attachFormInputEvent(this.form, 'booking_category_id', 'onchange',
				function() { HoursEditView.setRates(this.getValue()); });
			SUGAR.ui.attachFormInputEvent(this.form, 'assigned_user', 'onchange',
				function() {HoursEditView.setTaskRates();});
			this.initFilters();
        },
        
		show:function(targetElement, activityId, userId, dateStart, timeHourStart, timeMinuteStart, timesheetId) {
        	var params = {
        		record: activityId,
        		assigned_user_id: userId,
        		//date_start: dateStart,
        		//time_hour_start: timeHourStart,
        		//time_minute_start: timeMinuteStart,
        		timesheet_id: timesheetId,
        		date_is_gmt: 1,
        		layout: 'Standard'
			};
			
			function reload() {
				if(document.form_calendar && document.form_calendar.view_type && window.CalendarCtrl)
                    CalendarCtrl.reload(document.form_calendar.view_type.value);
			}
            SUGAR.ui.openQuickCreate('Booking', params, reload);
		},

        showNew:function(targetElement, userId, timesheetId, dateStart, timeHourStart, timeMinuteStart, durHour, durMin, related) {
        	var params = {
        		assigned_user_id: userId,
        		date_start: dateStart,
        		time_hour_start: timeHourStart,
        		time_minute_start: timeMinuteStart,
        		duration_hours: durHour,
        		duration_minutes: durMin,
        		timesheet_id: timesheetId,
        		date_is_gmt: 1
			};
            if(isset(related)) {
				params.related_type = related.type;
				params.related_id = related.id;
			}
			function reload() {
				if(document.form_calendar && document.form_calendar.view_type && window.CalendarCtrl)
                    CalendarCtrl.reload(document.form_calendar.view_type.value);
			}

            SUGAR.ui.openQuickCreate('Booking', params, reload);
        },

		setupPopupDialog:function() {
			if(! this.popupDialog) {
				this.popupDialog = new SUGAR.ui.Dialog('bookingEditView', { width: '670px', resizable: false, draggable: true });
				this.popupDialog.onshow = function() {
					var name = document.asyncEditView ? document.asyncEditView.name : null;
					if(name && name.focus && ! name.value) name.focus();
				}
			}
		},
		
		setTitle:function(title) {
			if(this.popupDialog)
				this.popupDialog.setTitle(title || '');
		},

        swapAdditional:function() {
            var content = $('add_content');
            if (content.style.display == 'none') {
                content.style.display = ''
            } else {
                content.style.display = 'none';
            }
            SUGAR.popups.reposition();
        },

		hide:function() {
			if(this.popupDialog) {
				this.popupDialog.close();
				this.popupDialog = null;
			}
		},
		
		save:function() {
            var success = function(data) {
                var result = null;
                HoursEditView.hide();
                try {
                    var viewType = window.document.form_calendar.view_type.value;
                    CalendarCtrl.reload(viewType);
                } catch (err) {
                    var msg = SUGAR.language.get('app_strings', 'NTC_HOURS_BOOKED');
                    alert(msg);
                    //document.location.reload(true);
                    var frm = SUGAR.ui.getForm('DetailForm');
                    if(frm && frm.module && frm.module.value == 'ProjectTask')
                    	SUGAR.ui.refreshTarget('DetailForm');
                    else
						sugarListView.reloadSubpanel('booked_hours');
                }
            };
            var resultDiv = this.popupDialog.getContentElement();
            return SUGAR.ui.sendForm(HoursEditView.form, {record_perform: 'save'}, {resultDiv: resultDiv, receiveCallback: success}, false, false);
		},

        duplicate:function() {
            function ready() {
                HoursEditView.initEditView('asyncEditView');
            }
            var resultDiv = this.popupDialog.getContentElement();
            SUGAR.ui.sendForm(HoursEditView.form, {record_perform: 'duplicate'}, {no_validate: true, resultDiv: resultDiv, receiveCallback: ready}, false, false);
        },

        deleteActivity:function() {
            var success = function(data) {
                HoursEditView.hide();
                try {
                    var viewType = window.document.form_calendar.view_type.value;
                    CalendarCtrl.reload(viewType);
                } catch (err) {
                    document.location.reload(true);
                }
            };

            var msgConfirm = SUGAR.language.get('app_strings', 'NTC_DELETE_CONFIRMATION');

            if(confirm(msgConfirm) == false) {
                return false;
            }

            var resultDiv = this.popupDialog.getContentElement();
            SUGAR.ui.sendForm(HoursEditView.form, {record_perform: 'delete'}, {no_validate: true, resultDiv: resultDiv, receiveCallback: success}, false, false);
        },

        updatedRelatedType:function(fld) {
            fld.form.related_id.value = '';
            fld.form.related_name.value = '';
            HoursEditView.updateAccountEdit();
        },
        
        updateAccountEdit:function() {
        	var form = document.forms.asyncEditView;
        	if(form.related_id.value) {
        		form.account_select.style.display = 'none';
        		form.account_name.readOnly = true;
        	} else {
        		form.account_select.style.display = '';
        		form.account_name.readOnly = false;
        	}
        },

        updateQuantity:function() {
			var qty_inp = SUGAR.ui.getFormInput(HoursEditView.form, 'quantity');
			if(! qty_inp) return;
            var qty = qty_inp.getValue(true) / 60;
            if(! qty) return;

            var rate1_inp = SUGAR.ui.getFormInput(HoursEditView.form, 'billing_rate');
            var total1_inp = SUGAR.ui.getFormInput(HoursEditView.form, 'billing_total');
            var rate2_inp = SUGAR.ui.getFormInput(HoursEditView.form, 'paid_rate');
            var total2_inp = SUGAR.ui.getFormInput(HoursEditView.form, 'paid_total');
            
            if(rate1_inp && total1_inp) {
            	total1_inp.setValue(rate1_inp.isBlank() ? '' : rate1_inp.getValue(true) * qty, true);
			}
            if(rate2_inp && total2_inp) {
            	total2_inp.setValue(rate2_inp.isBlank() ? '' : rate2_inp.getValue(true) * qty, true);
			}
        },

        updateAmount:function(price_elem) {
            var name = price_elem.name;

            var qty_inp = SUGAR.ui.getFormInput(HoursEditView.form, 'quantity');
            var amount_inp = SUGAR.ui.getFormInput(HoursEditView.form, name);
            if(! qty_inp || ! amount_inp) return;

            var id = amount_inp.field.name.split('_');
            var other, val, newval;

            var qty = qty_inp.getValue(true) / 60;
            if(! qty) return;
            val = amount_inp.isBlank() ? null : amount_inp.getValue(true);

            if(id[1] == 'rate') {
                other = 'total';
                newval = isset(val) ? val * qty : '';
            } else {
                other = 'rate';
                newval = isset(val) ? val / qty : '';
            }

            other = SUGAR.ui.getFormInput(HoursEditView.form, id[0] + '_' + other);
            if(other) other.setValue(newval, true);
        },

        setTaskRates:function() {
			var ready = function()
			{
                var row = this.getResult();
				if (row.result != 'ok')
					return;
                var rate = SUGAR.ui.getFormInput(HoursEditView.form, 'paid_rate'),
                	cur = SUGAR.ui.getFormInput(HoursEditView.form, 'paid_currency_id');
				if(cur) cur.setValue(row['currency_id'], true);
				if(rate) rate.setValue(row['hourly_cost']);
				HoursEditView.updateQuantity();
			}
			if (this.form.related_type.value == 'ProjectTask') {
				//var task_id = SUGAR.ui.getFormInput(this.form, 'related_id').getValue();
				var related = SUGAR.ui.getFormInput(this.form, 'related'),
					user = SUGAR.ui.getFormInput(this.form, 'assigned_user'),
					user_id = user ? user.getKey() : SUGAR.session.user_id,
			    	query_params = {task_id: related ? related.getKey() : null, user_id: user_id},
					req = new SUGAR.conn.JSONRequest('get_user_task_rates', {status_msg: app_string('LBL_SAVING')}, query_params);
	            req.fetch(ready);
			}
		},

        setRates:function(category_id) {
            function ready() {
                var row = this.getResult();
                if(row.result == 'ok') {
                    var cat_fields = ['billing_rate', 'billing_currency_id', 'paid_rate', 'paid_currency_id', 'tax_code_id'];
                    var num_fields = {billing_rate: true, paid_rate: true};
                    var name = '';
                    var input = null;

                    for (var i = 0; i < cat_fields.length; i++) {
                        name = cat_fields[i];
                        if (isset(row[name])) {
                            input = SUGAR.ui.getFormInput(HoursEditView.form, name);
                            if (input) {
								var val = row[name];
								if (num_fields[name])
									val = parseFloat(val);
                                input.setValue(val);
                                if (typeof(input.handleChanged) == 'function')
                                    input.handleChanged();
                            }
                        }
                    }
                }
                return false;
            }

            var query_params = {category_id: category_id};
            var req = new SUGAR.conn.JSONRequest('get_rates_by_cat', {status_msg: app_string('LBL_SAVING')}, query_params);
            req.fetch(ready);
        }
	};
}();

window.sqsAsyncInit = true;
