{*
/******************************************************************************
* The contents of this file are subject to the CareBrains Software End User
* License Agreement ('License') which can be viewed at
* http://www.sugarforum.jp/download/cbieula.shtml
* By installing or using this file, You have unconditionally agreed to the
* terms and conditions of the License, and You may not use this file except in
* compliance with the License.  Under the terms of the license, You shall not,
* among other things: 1) sublicense, resell, rent, lease, redistribute, assign
* or otherwise transfer Your rights to the Software, and 2) use the Software
* for timesharing or service bureau purposes such as hosting the Software for
* commercial gain and/or for the benefit of a third party.  Use of the Software
* may be subject to applicable fees and any use of the Software without first
* paying applicable fees is strictly prohibited.
* Your Warranty, Limitations of liability and Indemnity are expressly stated
* in the License.  Please refer to the License for the specific language
* governing these rights and limitations under the License.
*****************************************************************************/
*}

<form name="form_calendar" id="form_calendar" method="POST">
	<input type="hidden" name="module" value="Calendar">
	<input type="hidden" name="action" value="asyncCalendarBody">
	<input type="hidden" name="to_pdf" value="1">
	<input type="hidden" id="view_type" name="view_type" value="day">
	<input type="hidden" id="target_date" name="target_date" value="{$target_date}">
	<input name="target_res_type" type="hidden" value="">

	<input type="hidden" id="view_mode" name="view_mode" value="{$MODE}">	
	<input type="hidden" id="target_type" name="target_type" value="{$target_type}">
	<input type="hidden" id="target_id" name="target_id" value="{$target_id}">
	<input type="hidden" id="selected_targets" name="selected_targets" value="{$selected_targets|default:''}">
	<input type="hidden" id="project_id" name="project_id" value="{$PROJECT_ID}">	
	<input type="hidden" id="timesheet_id" name="timesheet_id" value="{$timesheet_id|default:''}">
	<input type="hidden" id="target_team_id" name="target_team_id" value="{$target_team_id|default:''}">
	
	<input type="hidden" id="display_meetings" name="display_meetings" {$display_meetings|default:''}>
	<input type="hidden" id="display_calls" name="display_calls" {$display_calls|default:''}>
	<input type="hidden" id="display_tasks" name="display_tasks" {$display_tasks|default:''}>
	<input type="hidden" id="display_project_tasks" name="display_project_tasks" {$display_project_tasks|default:''}>
	<input type="hidden" id="display_events" name="display_events" {$display_events|default:''}>
	<input type="hidden" id="display_leave" name="display_leave" {$display_leave|default:''}>
	<input type="hidden" id="display_booked_hours" name="display_booked_hours" {$display_booked_hours|default:''}>
	<input type="hidden" id="display_bookings" name="display_bookings" {$display_bookings|default:''}>
	<input type="hidden" id="target_department" name="target_department" value="{$target_department|default:''}">
	<input type="hidden" id="forDashlet" name="forDashlet" value="{$forDashlet|default:''}">

	<input id="print_url" type="hidden" value="{$PRINT_LINK}" >
</form>


{$calendar_tab|default:''}
<section class="{$outer_class} day-calendar">
<header class="card-header panel-header">
<div class="row align-middle">
	<div class="column col-8 text-center">
		<div class="nav-row">
			<div class="nav-left">
				<div class="uii uii-previous uii-lg active-icon" onclick="DayCalendarCtrl.moveCalendar('{$prev_date}');" title="{$APP.LBL_PREVIOUS_DAY}"></div>
			</div>
			<h4 class="nav-title">
				{$cal_dt.formattedDate} <span class="{$weekdayfonts.$target_weekday_index}">({$target_weekday})</span>
			</h4>
			<div class="nav-right">
				<div class="uii uii-next uii-lg active-icon" onclick="DayCalendarCtrl.moveCalendar('{$next_date}');" title="{$APP.LBL_NEXT_DAY}"></div>
			</div>
		</div>
		{$target_rokuyo}
		{if $target_holiday != ""}
			<span class="holiday">{$target_holiday}</span>
		{/if}		
	</div>

	<div class="column text-right">
		<a name="print_link" class="utilsLink small" href="#">{$APP.LNK_PRINT}</a> &middot;
		{$select_date}
	</div>
</div>
{assign var="calendar_ctrl" value="DayCalendarCtrl"}
{include file="modules/Calendar/CalendarViewer/SettingsBar.tpl"}
</header>

<div class="card-body grid-body" id="calendar-body">
	<div class="grid-row number-row hour-row all-day">
		<div class="grid-cell number-cell label hour-number"><span class="number">{$MOD.LBL_ALL_DAY_COL_HEADER}</span></div>
		<div class="grid-cell number-cell hour responsive" id="calendar-hour-content-allday"></div>
	</div>
{foreach from=$hours key=hour item=hour_info}
	<div class="grid-row number-row hour-top-row">
		<div class="grid-cell number-cell label hour-number"><span class="number">{$hour_info.display}</span></div>
		<div class="grid-cell number-cell hour responsive" id="calendar-hour-content-{$hour}"></div>
	</div>
	<div class="grid-row number-row hour-bottom-row">
		<div class="grid-cell number-cell label hour-number"></div>
		<div class="grid-cell number-cell hour responsive" id="calendar-hour-content-bottom-{$hour}"></div>
	</div>
{/foreach}

{if $summary}
	<div class="calendar_activity_box summary" style="top:1px;left:{$hour_width+4}px;width:400px;max-width:400px" onmouseover="DayCalendarCtrl.ov(this);" onmouseout="DayCalendarCtrl.ot(this);">
	<div class="summary_content">{$summary}</div>
	<div class="summary_details" id="summary_details_0">
	{foreach from=$activities item=activity}
		{assign var=activity_id value=$activity.id}
		{if $activity.is_daylong}
			<div 
			class="{$activity_class} {$activity.cssClass}{if $activity.canEdit} card-input can-edit{/if}">				
				<div class="{$activity_header_class}">
					<div class="icon" id="div_detail_{$activity_id}">
					{if $activity.isViewAble}
						<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item">
						{$activity.imgHTML}
						</a>
					{else}{$activity.imgHTML}
					{/if}
					</div>
					<div class="title">
						{$activity.displayTime}
					</div>
				</div>
				<div class="{$activity_body_class}">
					{$activity.subject}
					{$activity.recurrenceImgHTML}									
				</div>
			</div>
		{/if}
	{/foreach}
	</div>
	</div></div>

{/if}

{foreach from=$activities key=activity_id item=activity}
	{assign var=activity_id value=$activity.id}
	{if !$activity.is_daylong || !$summary}
		<div id="div_act_{$activity_id}"
			class="{$activity_class} can-expand {$activity.cssClass}{if $activity.canEdit} card-input can-edit{/if}"
			style="position:absolute;top:{$activity.top+$top_offset}px;left:{$activity.left}px;min-width:{$activity.width}px;width:{$activity.width}px;height:{$activity.height}px;min-height:{$activity.height}px;z-index:{$activity.duplicateLevel}">
			<div class="{$activity_header_class}">
				<div class="icon" id="div_detail_{$activity_id}">
				{if $activity.isViewAble}
					<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item">
					{$activity.imgHTML}
					</a>
				{else}{$activity.imgHTML}
				{/if}
				</div>
				<div class="title">
					{$activity.displayTime}
					{if $activity.height <= 25}
					<span class="short_title">
						&nbsp;{$activity.subject}
					</span>
					{/if}
				</div>
			</div>
			<div class="{$activity_body_class}">
				{$activity.subject}
				{$activity.recurrenceImgHTML}									
				<div class="extended-info">
					<div class="info-line">{$activity.statusHtml}</div>
					<div class="info-line">{$activity.inviteesHtml}</div>
				</div>
			</div>
		</div>
	{/if}
{/foreach}
</div>

<footer class="card-footer panel-footer">
	<div class="calendar-footer-help text-center">
		{$MOD.LBL_MODIFIED_HELP}
	</div>
</footer>
</section>


{iah_script}
window.defaultEditModule = '{$defaultEditModule}';
{$init_js|default:''}
setPrintLink({if $forDashlet}'dashlet_print_{$dashletId}'{/if});
{/iah_script}

