{*
/******************************************************************************
* The contents of this file are subject to the CareBrains Software End User
* License Agreement ('License') which can be viewed at
* http://www.sugarforum.jp/download/cbieula.shtml
* By installing or using this file, You have unconditionally agreed to the
* terms and conditions of the License, and You may not use this file except in
* compliance with the License.  Under the terms of the license, You shall not,
* among other things: 1) sublicense, resell, rent, lease, redistribute, assign
* or otherwise transfer Your rights to the Software, and 2) use the Software
* for timesharing or service bureau purposes such as hosting the Software for
* commercial gain and/or for the benefit of a third party.  Use of the Software
* may be subject to applicable fees and any use of the Software without first
* paying applicable fees is strictly prohibited.
* Your Warranty, Limitations of liability and Indemnity are expressly stated
* in the License.  Please refer to the License for the specific language
* governing these rights and limitations under the License.
*****************************************************************************/
*}

<form name="form_calendar" id="form_calendar" method="POST">
	<input type="hidden" name="module" value="Calendar">
	<input type="hidden" name="action" value="asyncCalendarBody">
	<input type="hidden" name="to_pdf" value="1">
	<input type="hidden" id="view_type" name="view_type" value="month">
	<input type="hidden" id="target_date" name="target_date" value="{$target_date}">
	<input name="target_res_type" type="hidden" value="">
	
	<input type="hidden" id="view_mode" name="view_mode" value="{$MODE}">		
	<input type="hidden" id="target_type" name="target_type" value="{$target_type}">
	<input type="hidden" id="target_id" name="target_id" value="{$target_id|default:''}">
	<input type="hidden" id="selected_targets" name="selected_targets" value="{$selected_targets|default:''}">
	<input type="hidden" id="target_team_id" name="target_team_id" value="{$target_team_id|default:''}">
	<input type="hidden" id="project_id" name="project_id" value="{$PROJECT_ID|default:''}">	
	<input type="hidden" id="timesheet_id" name="timesheet_id" value="{$timeshee_id|default:''}">

	<input type="hidden" id="display_meetings" name="display_meetings" {$display_meetings|default:''}>
	<input type="hidden" id="display_calls" name="display_calls" {$display_calls|default:''}>
	<input type="hidden" id="display_tasks" name="display_tasks" {$display_tasks|default:''}>
	<input type="hidden" id="display_project_tasks" name="display_project_tasks" {$display_project_tasks|default:''}>
	<input type="hidden" id="display_events" name="display_events" {$display_events|default:''}>
	<input type="hidden" id="display_leave" name="display_leave" {$display_leave|default:''}>
	<input type="hidden" id="display_booked_hours" name="display_booked_hours" {$display_booked_hours|default:''}>
	<input type="hidden" id="display_bookings" name="display_bookings" {$display_bookings|default:''}>
	<input type="hidden" id="target_department" name="target_department" value="{$target_department|default:''}">
	<input type="hidden" id="forDashlet" name="forDashlet" value="{$forDashlet|default:''}">

	<input id="print_url" type="hidden" value="{$PRINT_LINK}" >
</form>

{$calendar_tab|default:''}
<section class="{$outer_class|default:''}">
<header class="card-header panel-header">
<div class="row align-middle">
	<div class="column col-8 text-center nav-row">
		<div class="nav-left">
			<div class="uii uii-previous uii-lg active-icon" onclick="MonthCalendarCtrl.moveCalendar('{$prev_date}');" title="{$APP.LBL_PREVIOUS_MONTH}"></div>
		</div>
		<h4 class="nav-title">{$cal_dt.formattedMonth}</h4>
		<div class="nav-right">
			<div class="uii uii-next uii-lg active-icon" onclick="MonthCalendarCtrl.moveCalendar('{$next_date}');" title="{$APP.LBL_NEXT_MONTH}"></div>
		</div>
	</div>
	
	<div class="column text-right">
		{$select_date}
	</div>
</div>
{assign var="calendar_ctrl" value="MonthCalendarCtrl"}
{include file="modules/Calendar/CalendarViewer/SettingsBar.tpl"}
</header>

{assign var=colCount value=$activities_of_weeks_array.0.week_days|@count}
<header class="card-header panel-subheader no-pad grid-body">
	<div class="grid-row number-row dates">
		<div class="grid-cell number-cell day-head label week-number">{$APP.LBL_WEEK_COL_HEADER}</div>
		{foreach from=$activities_of_weeks_array.0.week_days key=day_index item=weekday name=days}
		<div class="grid-cell number-cell day-head {$weekday.weekdayCssClass}">{$weekday.weekday}</div>
		{/foreach}
	</div>
</header>

<div class="card-body panel-body grid-body" id="calendar-body">
{foreach from=$activities_of_weeks_array key=row_index item=activities_of_weeks name=weeks}
<!-- weeks -->
	<div class="grid-row number-row">
		<div class="grid-cell number-cell day responsive label week-number"
			onclick="WeekCalendarCtrl.asyncCalendarBody('{$activities_of_weeks.weekDT->localDate}', '{$target_id}', '{$target_type}', '{$target_team_id|default:''}');">
			<span class="number">{$APP.LBL_WEEK_PREFIX}{$activities_of_weeks.week_number}</span>
		</div>
		{foreach from=$activities_of_weeks.week_days key=day_index item=weekday name=days}
		<!-- 1 -->
			<div class="grid-cell number-cell day large-cell responsive {$weekday.dateCssClass}" onclick="DayCalendarCtrl.moveCalendar('{$weekday.date}');">
				<span class="number">{$weekday.day}</span>
				{if 0 && $canEdit && $MODE != 'projects'}
					<div class="input-icon theme-icon create-Meeting"
					onclick="MonthCalendarCtrl.showNew(this, '{$target_user_id}', '{$target_res_id}', '{$weekday.date}', '{$local_current_hour}', '0');"
					onselectstart="return false;" onmousedown="return false;" style="cursor: pointer"></div>
				{/if}
				{if $weekday.holiday != ""}
					<div onmousedown="SUGAR.ui.stopPropagation(event);"
						onclick="SUGAR.ui.stopPropagation(event);"
						class="{$activity_class} holiday">
						<div class="{$activity_body_class}">
							{$weekday.holiday}
						</div>
					</div>
				{/if}
				
				{foreach from=$activities_of_weeks.activities_of_week key=user_id item=activities_of_week_array}
				<!-- 2 -->
					{foreach from=$activities_of_week_array.activities_of_day_array key=week_index item=activities_of_day name=days}
					<!-- 3 -->
						{if $week_index == $day_index}
							{foreach from=$activities_of_day.activities key=activity_id item=activity}
							<!-- 3 -->							
								<div id="div_act_{$activity_id}"
									{if $activity.isViewAble}
										on{$hover_event}="return SUGAR.util.getAdditionalDetails('{$activity.module}', '{$activity_id}', 'div_detail_{$activity_id}', {ldelim}calendarDate:'{$activity.forDate|default:''}'{rdelim}, null, 1000);"
										onmouseout="return SUGAR.util.clearAdditionalDetailsCall();"
									{/if}
									{if $activity.canEdit}
									   ondblclick="MonthCalendarCtrl.showEditor(this, '{$activity.module}', '{$activity_id}');"
									{/if}
									class="{$activity_class} {$activity.cssClass}{if $activity.canEdit} card-input{/if}">
									<div class="{$activity_header_class}">
										<div class="icon" id="div_detail_{$activity_id}">
											{if $activity.isViewAble}
												<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item" onclick="SUGAR.ui.stopPropagation(event)">
												{$activity.imgHTML}
												</a>
											{else}{$activity.imgHTML}
											{/if}
										</div>
										<div class="title">
											{$activity.startTime}{if $activity.endTime}-{$activity.endTime}{/if}
										</div>
									</div>
									<div class="{$activity_body_class}" style="{$activity.calendar_color}">
										{$activity.subject}
										{$activity.recurrenceImgHTML}									
									</div>
								</div>
							{/foreach}
							{foreach from=$activities_of_day.tasks|default:[] key=task_id item=task}
								<table cols="1" width="95%" class="week_activity_item" border="0" cellspacing="0" cellpadding="2">
									<tr>
										<td width="16" class="week_activity_item">
											<a href="index.php?module=Tasks&amp;action=DetailView&amp;record={$task_id}" class="week_activity_item" onclick="SUGAR.ui.stopPropagation(event)">
												<div class="input-icon theme-icon module-Tasks"></div>
											</a>
										<td>
										<td class="week_activity_item">
											<div class="input-icon icon-info" id="act_{$task_id}" onmouseover="return SUGAR.util.getAdditionalDetails('Tasks', '{$task_id}', 'act_{$task_id}');" onmouseout="return SUGAR.util.clearAdditionalDetailsCall();"></div>
											{$task.subject}
										</td>
									</tr>
								</table>
							{/foreach}
						{/if}
					<!-- 2 -->
					{/foreach}
			<!-- /1 -->
			{/foreach}
			</div>
		{/foreach}
	</div>
<!-- weeks -->
{/foreach}
</div>

<footer class="card-footer panel-footer">
    <div class="calendar-footer-help text-center">
		{$MOD.LBL_TIMEBAR_HELP_MONTH}
    </div>
</footer>
</section>


{iah_script}
{$init_js|default:''}
setPrintLink({if $forDashlet}'dashlet_print_{$dashletId}'{/if});
window.defaultEditModule = '{$defaultEditModule}';
{/iah_script}
