{*
/******************************************************************************
* The contents of this file are subject to the CareBrains Software End User
* License Agreement ('License') which can be viewed at
* http://www.sugarforum.jp/download/cbieula.shtml
* By installing or using this file, You have unconditionally agreed to the
* terms and conditions of the License, and You may not use this file except in
* compliance with the License.  Under the terms of the license, You shall not,
* among other things: 1) sublicense, resell, rent, lease, redistribute, assign
* or otherwise transfer Your rights to the Software, and 2) use the Software
* for timesharing or service bureau purposes such as hosting the Software for
* commercial gain and/or for the benefit of a third party.  Use of the Software
* may be subject to applicable fees and any use of the Software without first
* paying applicable fees is strictly prohibited.
* Your Warranty, Limitations of liability and Indemnity are expressly stated
* in the License.  Please refer to the License for the specific language
* governing these rights and limitations under the License.
*****************************************************************************/
*}

<form name="form_calendar" id="form_calendar" method="POST">
	<input type="hidden" name="module" value="Calendar">
	<input type="hidden" name="action" value="asyncCalendarBody">
	<input type="hidden" name="to_pdf" value="1">
	<input type="hidden" id="view_type" name="view_type" value="resource_day">
	<input type="hidden" id="target_date" name="target_date" value="{$target_date}">
	<input type="hidden" id="selected_targets" name="selected_targets" value="{$selected_targets|default:''}">
	<input type="hidden" id="target_id" name="target_id" value="{$target_id|default:''}">
	<input type="hidden" id="view_mode" name="view_mode" value="{$MODE}">	
	<input type="hidden" id="target_type" name="target_type" value="{$target_type|default:''}">
	<input type="hidden" id="target_user_id" name="target_user_id" value="">
	<input type="hidden" id="target_team_id" name="target_team_id" value="">
	<input type="hidden" id="target_res_type" name="target_res_type" value="{$target_res_type|default:''}">
	<input type="hidden" id="project_id" name="project_id" value="{$PROJECT_ID|default:''}">	
	<input type="hidden" id="timesheet_id" name="timesheet_id" value="{$timesheet_id|default:''}">	

	<input type="hidden" id="display_meetings" name="display_meetings" {$display_meetings|default:''}>
	<input type="hidden" id="display_calls" name="display_calls" {$display_calls|default:''}>
	<input type="hidden" id="display_tasks" name="display_tasks" {$display_tasks|default:''}>
	<input type="hidden" id="display_project_tasks" name="display_project_tasks" {$display_project_tasks|default:''}>
	<input type="hidden" id="display_events" name="display_events" {$display_events|default:''}>
	<input type="hidden" id="display_leave" name="display_leave" {$display_leave|default:''}>
	<input type="hidden" id="display_bookings" name="display_bookings" {$display_bookings|default:''}>
	<input type="hidden" id="target_department" name="target_department" value="{$target_department|default:''}">
	<input type="hidden" id="forDashlet" name="forDashlet" value="{$forDashlet|default:''}">

	<input id="print_url" type="hidden" value="{$PRINT_LINK}" >
</form>


{$calendar_tab|default:''}
<section class="{$outer_class|default:''} expand">
<header class="card-header panel-header">
<div class="row align-middle">
	<div class="column col-8 text-center">
		<div class="nav-row">
			<div class="nav-left">
				<div class="uii uii-previous uii-lg active-icon" onclick="ResourceDayCalendarCtrl.moveCalendar('{$prev_date}');" title="{$APP.LBL_PREVIOUS_DAY}"></div>
			</div>
			<div class="nav-title">
				<h4>{$cal_dt.formattedDate} <span class="{$weekdayfonts[$cal_dt.localWeekDayIndex]}">({$cal_dt.localWeekDay})</span></h4>
			</div>
			<div class="nav-right">
				<div class="uii uii-next uii-lg active-icon" onclick="ResourceDayCalendarCtrl.moveCalendar('{$next_date}');" title="{$APP.LBL_NEXT_DAY}"></div>
			</div>
		</div>
		{$target_rokuyo}
		{if $target_holiday != ""}
			<span class="holiday">{$target_holiday}</span>
		{/if}
	</div>
	
	<div class="column text-right">
		{$select_date}
	</div>
</div>
{assign var="calendar_ctrl" value="ResourceDayCalendarCtrl"}
{include file="modules/Calendar/CalendarViewer/GridSettingsBar.tpl"}
</header>


<div class="card-body panel-body">
	<table class="calendar_outer_table" cellpadding="0" cellspacing="0"><tbody>
		<tr>
			<td colspan="100" class="team_cal_separator"><div class="input-icon theme-icon module-Users"></div> {$MOD.LBL_SECTION_USERS}</td>
			</tr>
			{foreach from=$activities_every_user_array key=user_id item=activities_every_user}
			<tr>
			<td width="100" class="team_cal_user" rowspan="2">&nbsp;</td>
			{foreach from=$hours key=hour item=hour_info}
			<td width="100" colspan="4" align="center" class="team_cal_header">{$hour_info.display}</td>
			{/foreach}
		</tr>
		<tr>
			{foreach from=$hours key=hour item=hour_info}
			<td width="25" onselectstart="return false;" onmousedown="return false;" onmouseover="ResourceDayCalendarCtrl.ov(this);" onmouseout="ResourceDayCalendarCtrl.ot(this);" class="team_cal_header_min"
			{if $canEdit}
				onclick="ResourceDayCalendarCtrl.showNew(this, '{$user_id}', '', '{$target_date}', '{$hour}', '0', '', '15', 0, '{$user_ids}', '{$resource_ids}');"
			{/if}>&nbsp;</td>
			<td width="25" onselectstart="return false;" onmousedown="return false;" onmouseover="ResourceDayCalendarCtrl.ov(this);" onmouseout="ResourceDayCalendarCtrl.ot(this);" class="team_cal_header_min noleft"
			{if $canEdit}
				onclick="ResourceDayCalendarCtrl.showNew(this, '{$user_id}', '', '{$target_date}', '{$hour}', '15', '', '15', 0, '{$user_ids}', '{$resource_ids}');"
			{/if}>&nbsp;
			</td>
			<td width="25" onselectstart="return false;" onmousedown="return false;" onmouseover="ResourceDayCalendarCtrl.ov(this);" onmouseout="ResourceDayCalendarCtrl.ot(this);" class="team_cal_header_min"
			{if $canEdit}
				onclick="ResourceDayCalendarCtrl.showNew(this, '{$user_id}', '', '{$target_date}', '{$hour}', '30', '', '15', 0, '{$user_ids}', '{$resource_ids}');"
			{/if}>&nbsp;</td>
			<td width="25" onselectstart="return false;" onmousedown="return false;" onmouseover="ResourceDayCalendarCtrl.ov(this);" onmouseout="ResourceDayCalendarCtrl.ot(this);" class="team_cal_header_min noleft"
			{if $canEdit}
				onclick="ResourceDayCalendarCtrl.showNew(this, '{$user_id}', '', '{$target_date}', '{$hour}', '45', '', '15', 0, '{$user_ids}', '{$resource_ids}');"
			{/if}>&nbsp;</td>
			{/foreach}
		</tr>
		{foreach from=$activities_every_user.activities_of_level key=level item=activities name=act}
		<tr>
			{if $smarty.foreach.act.first}
			<td valign="top" class="team_cal_user" rowspan="{$activities_every_user.max_level+1}"  nowrap="nowrap">
			<div class="tools-row">
				<a href="javascript:DayCalendarCtrl.asyncCalendarBody('{$target_date}', '{$user_id}', 'user');">{$activities_every_user.full_name}</a>
				<span class="uii uii-md uii-remove active-icon" onclick="{$calendar_ctrl}.deleteGridEntry('{$user_id}', 'user');"></span>
			</div>
			</td>
			{/if}
			{assign var=pre_end_offset value=$start_offset_min}
			{foreach from=$activities item=activity}
			{assign var=activity_id value=$activity.id}
			{* 空白を追加 *}
			{if $pre_end_offset < $activity.startOffsetMinutes}
			{math equation="(x-y+1)/15" x=$activity.startOffsetMinutes y=$pre_end_offset format="%d" assign=diff}
			<td valign="top" colspan="{$diff}" class="team_cal_empty">&nbsp;</td>
			{/if}
			{* 予定を追加 *}
			{math equation="max(x+y, 0)" x=$activity.startOffsetMinutes y=$activity.durationMin format="%d" assign=endOffsetMinutes}
			{if $endOffsetMinutes > $end_offset_min}
			{math equation="(x-y+1)/15" x=$end_offset_min y=$activity.startOffsetMinutes format="%d" assign=diff}
			{assign var=pre_end_offset value=$end_offset_min}
			{else}
			{math equation="(x-y+1)/15" x=$endOffsetMinutes y=$activity.startOffsetMinutes format="%d" assign=diff}
			{assign var=pre_end_offset value=$endOffsetMinutes}
			{/if}
			{if $activity.isViewAble == true}
			<td  valign="top" colspan="{$diff}" class="team_cal_activity{if $activity.isDuplicate} dup{/if}{if $activity.canEdit} can_edit{/if}">
			
			<div id="div_act_{$activity_id}"
				{if $activity.canEdit}
				   ondblclick="ResourceDayCalendarCtrl.showEditor(this, '{$activity.module}', '{$activity_id}');"
				{/if}
				onmousedown="SUGAR.ui.stopPropagation(event);"
				onclick="SUGAR.ui.stopPropagation(event);"
				{if $activity.isViewAble}
					on{$hover_event}="return SUGAR.util.getAdditionalDetails('{$activity.module}', '{$activity_id}', 'div_detail_{$activity_id}', {ldelim}calendarDate:'{$activity.forDate}'{rdelim}, null, 1000);"
					onmouseout="return SUGAR.util.clearAdditionalDetailsCall();"
				{/if}
				class="{$activity_class} {$activity.cssClass}{if $activity.canEdit} card-input{/if}">
				<div class="{$activity_body_class}" style="{$activity.calendar_color}">
					<div class="activity-title">
						<div class="icon" id="div_detail_{$activity_id}">
							{if $activity.isViewAble}
								<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item">
								{$activity.imgHTML}
								</a>
							{else}{$activity.imgHTML}
							{/if}
						</div>
						<div class="title-left">
							{$activity.subject}
							{$activity.recurrenceImgHTML}
						</div>
					</div>
				</div>
			</div>

			</td>
			{else}
			<td  valign="top" colspan="{$diff}" class="team_cal_activity{if $activity.isDuplicate} dup{/if}">
			<div id="div_act_{$activity_id}" valign="top">
			{$activity.imgHTML}
			{$activity.subject}
			{$activity.recurrenceImgHTML}
			</div>
			</td>
			{/if}
			{/foreach}
			{* 一番最後の予定より後ろの部分に空白を埋める *}
			{if $pre_end_offset < $end_offset_min}
			{math equation="ceil((x-y+1)/30)*2" x=$end_offset_min y=$pre_end_offset format="%d" assign=diff}
			<td valign="top" colspan="{$diff}" class="team_cal_empty">&nbsp;</td>
			{/if}
		</tr>
		{/foreach}
		{/foreach}

		<tr>
			<td class="team_cal_add" align="right">
				<b>{$MOD.LBL_ADD_USER}:&nbsp;</b>
			</td>
			<td colspan="100" class="team_cal_add">&nbsp;{$add_user}</td>
		</tr>

		<tr>
			<td class="team_cal_add" align="right">
				<b>{$MOD.LBL_ADD_TEAM}:&nbsp;</b>
			</td>
			<td colspan="100" class="team_cal_add">&nbsp;{$add_team}</td>
		</tr>

		{if $MODE eq "activities"}
		<tr>
			<td colspan="100" class="team_cal_separator"><div class="input-icon theme-icon module-Resources"></div> {$MOD.LBL_SECTION_RESOURCES}</td>
		</tr>
		{foreach from=$activities_every_resource_array key=resource_id item=activities_every_resource}
		<tr>
			<td width="100" class="team_cal_user" rowspan="2">&nbsp;</td>
			{foreach from=$hours key=hour item=hour_info}
			<td width="100" colspan="4" align="center" class="team_cal_header">{$hour_info.display}</td>
			{/foreach}
		</tr>
		<tr>
			{foreach from=$hours key=hour item=hour_info}
			<td width="25" onselectstart="return false;" onmousedown="return false;" onmouseover="ResourceDayCalendarCtrl.ov(this);" onmouseout="ResourceDayCalendarCtrl.ot(this);" class="team_cal_header_min"
			{if $canEdit}
			onclick="ResourceDayCalendarCtrl.showNew(this, '', '{$resource_id}', '{$target_date}', '{$hour}', '0', '', 15, 0, '{$user_ids}', '{$resource_ids}');"
			{/if}
			>&nbsp;</td>
			<td width="25" onselectstart="return false;" onmousedown="return false;" onmouseover="ResourceDayCalendarCtrl.ov(this);" onmouseout="ResourceDayCalendarCtrl.ot(this);" class="team_cal_header_min noleft"
			{if $canEdit}
			onclick="ResourceDayCalendarCtrl.showNew(this, '', '{$resource_id}', '{$target_date}', '{$hour}', '15', '', 15, 0, '{$user_ids}', '{$resource_ids}');"
			{/if}
			>&nbsp;</td>
			<td width="25" onselectstart="return false;" onmousedown="return false;" onmouseover="ResourceDayCalendarCtrl.ov(this);" onmouseout="ResourceDayCalendarCtrl.ot(this);" class="team_cal_header_min"
			{if $canEdit}
			onclick="ResourceDayCalendarCtrl.showNew(this, '', '{$resource_id}', '{$target_date}', '{$hour}', '30', '', 15, 0, '{$user_ids}', '{$resource_ids}');"
			{/if}
			>&nbsp;</td>
			<td width="25" onselectstart="return false;" onmousedown="return false;" onmouseover="ResourceDayCalendarCtrl.ov(this);" onmouseout="ResourceDayCalendarCtrl.ot(this);" class="team_cal_header_min noleft"
			{if $canEdit}
			onclick="ResourceDayCalendarCtrl.showNew(this, '', '{$resource_id}', '{$target_date}', '{$hour}', '45', '', 15, 0, '{$user_ids}', '{$resource_ids}');"
			{/if}
			>&nbsp;</td>
			{/foreach}
		</tr>
		{foreach from=$activities_every_resource.activities_of_level key=level item=activities name=act}
		<tr>
			{if $smarty.foreach.act.first}
			<td valign="top" class="team_cal_user" rowspan="{$activities_every_resource.max_level+1}" nowrap="nowrap">
			<div class="tools-row">
				<a href="javascript:DayCalendarCtrl.asyncCalendarBody('{$target_date}', '{$resource_id}', 'resource');">{$activities_every_resource.full_name}</a>
				<span class="uii uii-md uii-remove active-icon" onclick="{$calendar_ctrl}.deleteGridEntry('{$resource_id}', 'resource');"></span>
			</div>
			</td>
			{/if}
			{assign var=pre_end_offset value=$start_offset_min}
			{foreach from=$activities item=activity}
			{assign var=activity_id value=$activity.id}
			{* 空白を追加 *}
			{if $pre_end_offset < $activity.startOffsetMinutes}
			{math equation="(x-y+1)/15" x=$activity.startOffsetMinutes y=$pre_end_offset format="%d" assign=diff}
			<td valign="top" colspan="{$diff}" class="team_cal_empty">&nbsp;</td>
			{/if}
			{* 予定を追加 *}
			{math equation="max(x+y, 0)" x=$activity.startOffsetMinutes y=$activity.durationMin format="%d" assign=endOffsetMinutes}

			{if $endOffsetMinutes > $end_offset_min}
			{math equation="(x-y+1)/15" x=$end_offset_min y=$activity.startOffsetMinutes format="%d" assign=diff}
			{assign var=pre_end_offset value=$end_offset_min}
			{else}
			{math equation="(x-y+1)/15" x=$endOffsetMinutes y=$activity.startOffsetMinutes format="%d" assign=diff}
			{assign var=pre_end_offset value=$endOffsetMinutes}
			{/if}
			<td  valign="top" colspan="{$diff}" class="team_cal_activity{if $activity.isDuplicate} dup{/if}{if $activity.canEdit} can_edit{/if}">

			<div id="div_act_{$activity_id}"
				{if $activity.canEdit}
				   ondblclick="ResourceDayCalendarCtrl.showEditor(this, '{$activity.module}', '{$activity_id}');"
				{/if}
				{if $activity.isViewAble}
					on{$hover_event}="return SUGAR.util.getAdditionalDetails('{$activity.module}', '{$activity_id}', 'div_detail_{$activity_id}', {ldelim}calendarDate:'{$activity.forDate}'{rdelim}, null, 1000);"
					onmouseout="return SUGAR.util.clearAdditionalDetailsCall();"
				{/if}
				onmousedown="SUGAR.ui.stopPropagation(event);"
				onclick="SUGAR.ui.stopPropagation(event);"
				class="{$activity_class} {$activity.cssClass}{if $activity.canEdit} card-input{/if}">
				<div class="{$activity_body_class}" style="{$activity.calendar_color}">
					<div class="icon" id="div_detail_{$activity_id}">
						{if $activity.isViewAble}
							<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item">
							{$activity.imgHTML}
							</a>
						{else}{$activity.imgHTML}
						{/if}
					</div>
					<div class="title">
						{$activity.subject}
						{$activity.recurrenceImgHTML}
					</div>
				</div>
			</div>

			</td>
			{/foreach}
			{* 一番最後の予定より後ろの部分に空白を埋める *}
			{if $pre_end_offset < $end_offset_min}
			{math equation="ceil((x-y+1)/30)*2" x=$end_offset_min y=$pre_end_offset format="%d" assign=diff}
			<td valign="top" colspan="{$diff}" class="team_cal_empty">&nbsp;</td>
			{/if}
		</tr>
		{/foreach}
		{/foreach}

		<tr>
			<td class="team_cal_add" align="right">
				<b>{$MOD.LBL_ADD_RESOURCE}:&nbsp;</b>
			</td>
			<td colspan="100" class="team_cal_add">&nbsp;{$add_resource}</td>
		</tr>
		{/if}
		</tbody>
	</table>
</div>

<footer class="card-footer panel-footer text-center">
	<div class="calendar-footer-help">
		{$MOD.LBL_MODIFIED_TIMEBAR_HELP}
	</div>
</footer>
</section>


{iah_script}
{$init_js|default:''}
setPrintLink({if $forDashlet}'dashlet_print_{$dashletId}'{/if});
window.defaultEditModule = '{$defaultEditModule}';
{literal}
function checkUserId() {
	setTimeout('var newId = $("user_id_selected").value; if (newId != "") DayCalendarCtrl.addGridEntry($("settings_form"), "user");', 200);
}
function checkResourceId() {
	setTimeout('var newId = $("res_id_selected").value; if (newId != "") DayCalendarCtrl.addGridEntry($("settings_form"), "resource");', 200);
}
{/literal}
{/iah_script}
