{*
/******************************************************************************
* The contents of this file are subject to the CareBrains Software End User
* License Agreement ('License') which can be viewed at
* http://www.sugarforum.jp/download/cbieula.shtml
* By installing or using this file, You have unconditionally agreed to the
* terms and conditions of the License, and You may not use this file except in
* compliance with the License.  Under the terms of the license, You shall not,
* among other things: 1) sublicense, resell, rent, lease, redistribute, assign
* or otherwise transfer Your rights to the Software, and 2) use the Software
* for timesharing or service bureau purposes such as hosting the Software for
* commercial gain and/or for the benefit of a third party.  Use of the Software
* may be subject to applicable fees and any use of the Software without first
* paying applicable fees is strictly prohibited.
* Your Warranty, Limitations of liability and Indemnity are expressly stated
* in the License.  Please refer to the License for the specific language
* governing these rights and limitations under the License.
*****************************************************************************/
*}

<form name="form_calendar" id="form_calendar" method="POST">
	<input type="hidden" name="module" value="Calendar">
	<input type="hidden" name="action" value="asyncCalendarBody">
	<input type="hidden" name="to_pdf" value="1">
	<input type="hidden" id="view_type" name="view_type" value="resource_week">
	<input type="hidden" id="target_date" name="target_date" value="{$target_date}">
	<input type="hidden" id="selected_targets" name="selected_targets" value="{$selected_targets|default:''}">
	<input type="hidden" id="target_id" name="target_id" value="{$target_id|default:''}">
	<input type="hidden" id="target_type" name="target_type" value="{$target_type|default:''}">
	<input type="hidden" id="view_mode" name="view_mode" value="{$MODE}">
	<input type="hidden" id="project_id" name="project_id" value="{$PROJECT_ID}">				
	<input type="hidden" id="target_user_id" name="target_user_id" value="">
	<input type="hidden" id="target_team_id" name="target_team_id" value="">
	<input type="hidden" id="target_res_type" name="target_res_type" value="{$target_res_type|default:''}">
	<input type="hidden" id="display_meetings" name="display_meetings" {$display_meetings|default:''}>
	<input type="hidden" id="display_calls" name="display_calls" {$display_calls|default:''}>
	<input type="hidden" id="display_tasks" name="display_tasks" {$display_tasks|default:''}>
	<input type="hidden" id="display_project_tasks" name="display_project_tasks" {$display_project_tasks|default:''}>
	<input type="hidden" id="display_events" name="display_events" {$display_events|default:''}>
	<input type="hidden" id="display_leave" name="display_leave" {$display_leave|default:''}>
	<input type="hidden" id="display_bookings" name="display_bookings" {$display_bookings|default:''}>
	<input type="hidden" id="target_department" name="target_department" value="{$target_department|default:''}">
	<input type="hidden" id="forDashlet" name="forDashlet" value="{$forDashlet|default:''}">
</form>


{$calendar_tab|default:''}
<section class="{$outer_class|default:''}">
<header class="card-header panel-header">
<div class="row align-middle">
	<div class="column col-8 text-center nav-row">
		<div class="nav-left">
			<div class="uii uii-previous uii-lg active-icon" onclick="ResourceWeekCalendarCtrl.moveCalendar('{$prev_date}');" title="{$APP.LBL_PREVIOUS_WEEK}"></div>
		</div>
		<h4 class="nav-title">{$formated_target_date}</h4>
		<div class="nav-right">
			<div class="uii uii-next uii-lg active-icon" onclick="ResourceWeekCalendarCtrl.moveCalendar('{$next_date}');" title="{$APP.LBL_NEXT_WEEK}"></div>
		</div>
	</div>
	
	<div class="column text-right">
		{$select_date}
	</div>
</div>
{assign var="calendar_ctrl" value="ResourceWeekCalendarCtrl"}
{include file="modules/Calendar/CalendarViewer/GridSettingsBar.tpl"}
</header>


<div class="card-body panel-body">
	<table cols="8" class="calendar_outer_table" cellpadding="0" cellspacing="0" width="100%"><tbody>
		<tr>
			<td width="10%" valign="top" class="week_header_left corner">&nbsp;</td>
{foreach from=$weekdays key=week_index item=weekday}
			<td width="13%" align="center" valign="top" class="week_header{$weekday.dateCssClass}">
				<a href="javascript:ResourceDayCalendarCtrl.moveCalendar('{$weekday.date}');">
					<span class="{$weekdayfonts[$weekday.weekDayIndex]}">{$weekday.date_short} ({$weekday.weekday})</span>
				</a>
				{$weekday.rokuyo}
				{if $weekday.holiday != ""}
					<span class="holiday">{$weekday.holiday}</span>
				{/if}
			</td>
{/foreach}
		</tr>

{* 各ユーザの予定 *}

		<tr>
		<td colspan="100" class="team_cal_separator"><div class="input-icon theme-icon module-Users"></div> {$MOD.LBL_SECTION_USERS}</td>
		</tr>

{foreach from=$activities_every_user_array key=user_id item=activities_every_user}
		<tr>
			<td valign="top" class="week_user" nowrap="nowrap">
				<div class="tools-row">
					<a href="javascript:WeekCalendarCtrl.asyncCalendarBody('{$target_date}', '{$user_id}', 'user');">{$activities_every_user.user_full_name}</a>
					<div class="uii uii-md uii-remove active-icon" onclick="{$calendar_ctrl}.deleteGridEntry('{$user_id}', 'user');"></div>
				</div>
			</td>
	{foreach from=$activities_every_user.activities_of_day_array key=week_index item=activities_of_day}
			<td valign="top" class="week_activity{$weekdays.$week_index.dateCssClass}" onmouseover="ResourceWeekCalendarCtrl.ov(this);" onmouseout="ResourceWeekCalendarCtrl.ot(this);">
			{foreach from=$activities_of_day.activities item=activity key=activity_id}

				<div id="div_act_{$activity_id}"
					{if $activity.canEdit}
					   ondblclick="ResourceWeekCalendarCtrl.showEditor(this, '{$activity.module}', '{$activity_id}');"
					{/if}
					onmousedown="SUGAR.ui.stopPropagation(event);"
					onclick="SUGAR.ui.stopPropagation(event);"
					{if $activity.isViewAble}
						on{$hover_event}="return SUGAR.util.getAdditionalDetails('{$activity.module}', '{$activity_id}', 'div_detail_{$activity_id}', {ldelim}calendarDate:'{$activity.forDate|default:''}'{rdelim}, null, 1000);"
						onmouseout="return SUGAR.util.clearAdditionalDetailsCall();"
					{/if}
					class="{$activity_class} {$activity.cssClass}{if $activity.canEdit} card-input{/if}">
					<div class="{$activity_header_class}">
						<div class="icon" id="div_detail_{$activity_id}">
							{if $activity.isViewAble}
								<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item">
								{$activity.imgHTML}
								</a>
							{else}{$activity.imgHTML}
							{/if}
						</div>
						<div class="title">
							{$activity.startTime}-{$activity.endTime}
						</div>
					</div>
					<div class="{$activity_body_class}" style="{$activity.calendar_color}">
						{$activity.subject}
						{$activity.recurrenceImgHTML}
					</div>
				</div>

			{/foreach}
				{if $canEdit && $MODE != "projects"}
				<div style="padding-top:3px; text-align:right; ">
					<div class="input-icon theme-icon create-Meeting"
					onclick="ResourceWeekCalendarCtrl.showNew(this, '{$user_id}', '', '{$weekdays.$week_index.date}', '{$local_current_hour}', '0', '0', '30', 0, '{$user_ids}', '{$resource_ids}');"
					onselectstart="return false;" onmousedown="return false;" style="cursor: pointer"></div>
				</div>
				{/if}
			</td>
	{/foreach}
		</tr>
{/foreach}

		<tr>
			<td class="team_cal_add" align="right">
				<b>{$MOD.LBL_ADD_USER}:&nbsp;</b>
			</td>
			<td colspan="100" class="team_cal_add">&nbsp;{$add_user}</td>
		</tr>

		<tr>
			<td class="team_cal_add" align="right">
				<b>{$MOD.LBL_ADD_TEAM}:&nbsp;</b>
			</td>
			<td colspan="100" class="team_cal_add">&nbsp;{$add_team}</td>
		</tr>

{if $MODE eq "activities"}
<tr>
<td colspan="100" class="team_cal_separator"><div class="input-icon theme-icon module-Resources"></div> {$MOD.LBL_SECTION_RESOURCES}</td>
</tr>

{foreach from=$activities_every_resource_array key=resource_id item=activities_every_resource}
		<tr>
			<td valign="top" class="week_user" nowrap="nowrap">
				<div class="tools-row">
					<a href="javascript:WeekCalendarCtrl.asyncCalendarBody('{$target_date}', '{$resource_id}', 'resource');">{$activities_every_resource.user_full_name}</a>
					<div class="uii uii-md uii-remove active-icon" onclick="{$calendar_ctrl}.deleteGridEntry('{$resource_id}', 'resource');"></div>
				</div>
			</td>
	{foreach from=$activities_every_resource.activities_of_day_array key=week_index item=activities_of_day}
			<td valign="top" class="week_activity{$weekdays.$week_index.dateCssClass}" onmouseover="ResourceWeekCalendarCtrl.ov(this);" onmouseout="ResourceWeekCalendarCtrl.ot(this);">
			{foreach from=$activities_of_day.activities item=activity key=activity_id}

				<div id="div_act_{$activity_id}"
					{if $activity.canEdit}
					   ondblclick="ResourceWeekCalendarCtrl.showEditor(this, '{$activity.module}', '{$activity_id}');"
					{/if}
					{if $activity.isViewAble}
						on{$hover_event}="return SUGAR.util.getAdditionalDetails('{$activity.module}', '{$activity_id}', 'div_detail_{$activity_id}', {ldelim}calendarDate:'{$activity.forDate|default:''}'{rdelim}, null, 1000);"
						onmouseout="return SUGAR.util.clearAdditionalDetailsCall();"
					{/if}
					onmousedown="SUGAR.ui.stopPropagation(event);"
					onclick="SUGAR.ui.stopPropagation(event);"
					class="card-outer card-panel card-block compact card-activity {$activity_class} {$activity.cssClass}{if $activity.canEdit} card-input{/if}">
					<div class="card-body" style="{$activity.calendar_color}">
						<div class="card-row activity-title small">
							<div class="icon" id="div_detail_{$activity_id}">
								{if $activity.isViewAble}
									<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item">
									{$activity.imgHTML}
									</a>
								{else}{$activity.imgHTML}
								{/if}
							</div>
							<div class="title">
								{$activity.startTime}-{$activity.endTime}
							</div>
						</div>
						<div class="card-row">
							{$activity.subject}
							{$activity.recurrenceImgHTML}
						</div>
					</div>
				</div>

			{/foreach}
				{if $canEdit}
				<div style="padding-top:3px; text-align:right; ">
					<div class="input-icon theme-icon create-Meeting" onclick="ResourceWeekCalendarCtrl.showNew(this, '', '{$resource_id}', '{$weekdays.$week_index.date}', '{$local_current_hour}', '0', '0', '30', 0, '{$user_ids}', '{$resource_ids}');" onselectstart="return false;" onmousedown="return false;" style="cursor: pointer"></div>
				</div>
				{/if}
			</td>
	{/foreach}
		</tr>
{/foreach}

		<tr>
			<td class="team_cal_add" align="right">
				<b>{$MOD.LBL_ADD_RESOURCE}:&nbsp;</b>
			</td>
			<td colspan="100" class="team_cal_add">&nbsp;{$add_resource}</td>
		</tr>
{/if}
	</tbody></table>
</div>
<footer class="card-footer panel-footer text-center">
	<div class="calendar-footer-help">
		{$MOD.LBL_TIMEBAR_HELP_WEEK_GRID}
	</div>
</footer>
</section>


<input id="print_url" type="hidden" value="{$PRINT_LINK}" >
{iah_script}
{$init_js|default:''}
setPrintLink({if $forDashlet}'dashlet_print_{$dashletId}'{/if});
window.defaultEditModule = '{$defaultEditModule}';
{literal}
function checkUserId() {
	setTimeout('var newId = $("user_id_selected").value; if (newId != "") WeekCalendarCtrl.addGridEntry($("settings_form"), "user");', 200);
}
function checkResourceId() {
	setTimeout('var newId = $("res_id_selected").value; if (newId != "") WeekCalendarCtrl.addGridEntry($("settings_form"), "resource");', 200);
}
{/literal}
{/iah_script}

