{*
/******************************************************************************
* The contents of this file are subject to the CareBrains Software End User
* License Agreement ('License') which can be viewed at
* http://www.sugarforum.jp/download/cbieula.shtml
* By installing or using this file, You have unconditionally agreed to the
* terms and conditions of the License, and You may not use this file except in
* compliance with the License.  Under the terms of the license, You shall not,
* among other things: 1) sublicense, resell, rent, lease, redistribute, assign
* or otherwise transfer Your rights to the Software, and 2) use the Software
* for timesharing or service bureau purposes such as hosting the Software for
* commercial gain and/or for the benefit of a third party.  Use of the Software
* may be subject to applicable fees and any use of the Software without first
* paying applicable fees is strictly prohibited.
* Your Warranty, Limitations of liability and Indemnity are expressly stated
* in the License.  Please refer to the License for the specific language
* governing these rights and limitations under the License.
*****************************************************************************/
*}

<form name="form_calendar" id="form_calendar" method="POST">
	<input type="hidden" name="module" value="Calendar">
	<input type="hidden" name="action" value="asyncCalendarBody">
	<input type="hidden" name="to_pdf" value="1">
	<input type="hidden" id="view_type" name="view_type" value="week">
	<input name="target_res_type" type="hidden" value="">	
	<input type="hidden" id="target_date" name="target_date" value="{$target_date}">
	<input type="hidden" id="view_mode" name="view_mode" value="{$MODE}">
	<input type="hidden" id="project_id" name="project_id" value="{$PROJECT_ID}">				
	<input type="hidden" id="target_type" name="target_type" value="{$target_type}">
	<input type="hidden" id="target_id" name="target_id" value="{$target_id}">
	<input type="hidden" id="timesheet_id" name="timesheet_id" value="{$timesheet_id|default:''}">
	<input type="hidden" id="selected_targets" name="selected_targets" value="{$selected_targets|default:''}">
	
	<input type="hidden" id="target_team_id" name="target_team_id" value="{$target_team_id|default:''}">
	
	<input type="hidden" id="week_first_date" name="week_first_date" value="{$week_first_date}">
	<input type="hidden" id="today_weekindex" name="today_weekindex" value="{$today_weekindex}">
	
{foreach from=$weekdays key=weekday_index item=weekday}	
	<input type="hidden" id="week_date_{$weekday_index}" name="week_date_{$weekday_index}" value="{$weekday.date}">
{/foreach}	
	<input type="hidden" id="display_meetings" name="display_meetings" {$display_meetings|default:''}>
	<input type="hidden" id="display_calls" name="display_calls" {$display_calls|default:''}>
	<input type="hidden" id="display_tasks" name="display_tasks" {$display_tasks|default:''}>
	<input type="hidden" id="display_project_tasks" name="display_project_tasks" {$display_project_tasks|default:''}>
	<input type="hidden" id="display_events" name="display_events" {$display_events|default:''}>
	<input type="hidden" id="display_leave" name="display_leave" {$display_leave|default:''}>
	<input type="hidden" id="display_booked_hours" name="display_booked_hours" {$display_booked_hours|default:''}>
	<input type="hidden" id="display_bookings" name="display_bookings" {$display_bookings|default:''}>
	<input type="hidden" id="target_department" name="target_department" value="{$target_department|default:''}">
	<input type="hidden" id="forDashlet" name="forDashlet" value="{$forDashlet|default:''}">

	<input id="print_url" type="hidden" value="{$PRINT_LINK}" >
</form>


{$calendar_tab|default:''}
<section class="{$outer_class|default:''} week-calendar">
<header class="card-header panel-header">
<div class="row align-middle">
	<div class="column col-8 text-center nav-row">
		<div class="nav-left">
			<div class="uii uii-previous uii-lg active-icon" onclick="WeekCalendarCtrl.moveCalendar('{$prev_date}');" title="{$APP.LBL_PREVIOUS_WEEK}"></div>
		</div>
		<h4 class="nav-title">{$formated_target_date}</h4>
		<div class="nav-right">
			<div class="uii uii-next uii-lg active-icon" onclick="WeekCalendarCtrl.moveCalendar('{$next_date}');" title="{$APP.LBL_NEXT_WEEK}"></div>
		</div>
	</div>
	
	<div class="column text-right">
		{$select_date}
	</div>
</div>
{assign var="calendar_ctrl" value="WeekCalendarCtrl"}
{include file="modules/Calendar/CalendarViewer/SettingsBar.tpl"}
</header>

<header class="card-header panel-subheader no-pad grid-body">
	<div class="grid-row number-row week-head">
		<div class="grid-cell number-cell label hour-number"><span class="number">{$APP.LBL_WEEK_PREFIX}{$week_number}</span></div>			
		{foreach from=$weekdays key=weekday_index item=weekday}
		<div class="grid-cell number-cell day-head label responsive {$weekday.dateCssClass}"
			onclick="DayCalendarCtrl.moveCalendar('{$weekday.date}');"
		>{$weekday.date_short} ({$weekday.weekday})</div>
		{/foreach}
	</div>
</header>

<div class="card-body panel-body grid-body" id="calendar-body">	
	<div class="grid-row number-row hour-row all-day">
		<div class="grid-cell number-cell label hour-number"><span class="number">{$MOD.LBL_ALL_DAY_COL_HEADER}</span></div>
		{foreach from=$weekdays key=weekday_index item=weekday}
		<div class="grid-cell number-cell large-cell hour responsive" id="calendar-hour-content-allday-{$weekday.date}"></div>
		{/foreach}
	</div>
{foreach from=$hours key=hour item=hour_info}
	<div class="grid-row number-row hour-top-row">
		<div class="grid-cell number-cell label hour-number"><span class="number">{$hour_info.display}</span></div>
		{foreach from=$weekdays key=weekday_index item=weekday}
		<div class="grid-cell number-cell large-cell hour responsive" id="calendar-hour-content-{$hour}-{$weekday.date}"></div>
		{/foreach}
	</div>
	<div class="grid-row number-row hour-bottom-row">
		<div class="grid-cell number-cell label hour-number"></div>
		{foreach from=$weekdays key=weekday_index item=weekday}
		<div class="grid-cell number-cell large-cell hour responsive" id="calendar-hour-content-bottom-{$hour}-{$weekday.date}"></div>
		{/foreach}
	</div>
{/foreach}
	
{foreach from=$summary key=offsetIndex item=text}
	<div class="week_day_column calendar_activity_box summary" style="top:{$top_offset}px;left:{$text.offset}px;" onmouseover="WeekCalendarCtrl.ov(this);" onmouseout="WeekCalendarCtrl.ot(this);">
	<div class="summary_content">{$text.text}</div>
	<div class="summary_details" id="summary_details_{$offsetIndex}">
	{foreach from=$activities item=activity}
		{assign var=activity_id value=$activity.id}
		{if $activity.offsetIndex == $offsetIndex}
			{if $activity.is_daylong}
				{if $activity.module == 'Holidays'}
					<div class="{$activity_class} holiday">
						<div class="{$activity_body_class}">
							{$activity.subject}
						</div>
					</div>
				{else}
					<div class="{$activity_class} week_activity_item {$activity.cssClass}{if $activity.canEdit} can_edit{/if}">
						<div class="{$activity_header_class}">
							<div class="icon" id="div_detail_{$activity_id}_{$activity.offsetIndex}">
								<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item">
								{$activity.imgHTML}
								</a>
							</div>
							<div class="title">
								{$activity.displayTime}
							</div>
						</div>
						<div class="{$activity_body_class}">
							{$activity.subject}
							{$activity.recurrenceImgHTML}
						</div>
					</div>
				{/if}
			{/if}
		{/if}
	{/foreach}
	</div>
	</div>

{/foreach}

{foreach from=$activities item=activity}
	{if !$activity.is_daylong || !$summary[$activity.offsetIndex]}
		{if $activity.module == 'Holidays'}
			<div style="position:absolute;top:{$activity.top+$top_offset}px;left:{$activity.left}px;width:{$activity.width}px;height:{$activity.height}px;min-height:{$activity.height}px;z-index:{$activity.duplicateLevel};"
				class="{$activity_class} holiday">
				<div class="{$activity_body_class}">
					{$activity.subject}
				</div>
			</div>
		{else}
			{assign var=activity_id value=$activity.id}
			<div id="div_act_{$activity_id}" 
				class="{$activity_class} can-expand {$activity.cssClass}{if $activity.canEdit} card-input can-edit{/if}"
				style="position:absolute;top:{$activity.top+$top_offset}px;left:{$activity.left}px;width:{$activity.width}px;min-width:{$activity.width}px;height:{$activity.height}px;min-height:{$activity.height}px;z-index:{$activity.duplicateLevel}">
				<div class="{$activity_header_class}">
					<div class="icon" id="div_detail_{$activity_id}_{$activity.offsetIndex}">
					{if $activity.isViewAble}
						<a href="index.php?module={$activity.module}&amp;action=DetailView&amp;record={$activity_id}" class="week_activity_item">
						{$activity.imgHTML}
						</a>
					{else}{$activity.imgHTML}
					{/if}
					</div>
					<div class="title">
						{$activity.displayTime}
					</div>
				</div>
				<div class="{$activity_body_class}">
					{$activity.subject}
					{$activity.recurrenceImgHTML}
					<div class="extended-info">
						<div class="info-line">{$activity.statusHtml}</div>
						<div class="info-line">{$activity.inviteesHtml}</div>
					</div>
				</div>
			</div>
		{/if}
	{/if}
{/foreach}
</div>

<footer class="card-footer panel-footer text-center">
	<div class="calendar-footer-help">
		{$MOD.LBL_MODIFIED_HELP}
	</div>
</footer>
</section>


{iah_script}
window.defaultEditModule = '{$defaultEditModule}';
{$init_js|default:''}
setPrintLink({if $forDashlet}'dashlet_print_{$dashletId}'{/if});
{/iah_script}
