{*
/******************************************************************************
* The contents of this file are subject to the CareBrains Software End User
* License Agreement ('License') which can be viewed at
* http://www.sugarforum.jp/download/cbieula.shtml
* By installing or using this file, You have unconditionally agreed to the
* terms and conditions of the License, and You may not use this file except in
* compliance with the License.  Under the terms of the license, You shall not,
* among other things: 1) sublicense, resell, rent, lease, redistribute, assign
* or otherwise transfer Your rights to the Software, and 2) use the Software
* for timesharing or service bureau purposes such as hosting the Software for
* commercial gain and/or for the benefit of a third party.  Use of the Software
* may be subject to applicable fees and any use of the Software without first
* paying applicable fees is strictly prohibited.
* Your Warranty, Limitations of liability and Indemnity are expressly stated
* in the License.  Please refer to the License for the specific language
* governing these rights and limitations under the License.
*****************************************************************************/
*}

<form name="form_calendar" id="form_calendar" method="POST">
	<input type="hidden" name="module" value="Calendar">
	<input type="hidden" name="action" value="asyncCalendarBody">
	<input type="hidden" name="to_pdf" value="1">
	<input type="hidden" id="view_type" name="view_type" value="year">
	<input type="hidden" id="target_date" name="target_date" value="{$target_date}">
	<input type="hidden" id="view_mode" name="view_mode" value="{$MODE}">
	<input type="hidden" id="project_id" name="project_id" value="{$PROJECT_ID}">				
	<input type="hidden" id="target_type" name="target_type" value="{$target_type}">
	<input type="hidden" id="target_id" name="target_id" value="{$target_id}">
	<input type="hidden" id="selected_targets" name="selected_targets" value="{$selected_targets|default:''}">
	<input type="hidden" id="timesheet_id" name="timesheet_id" value="{$timesheet_id|default:''}">
	
	<input type="hidden" id="target_team_id" name="target_team_id" value="{$target_team_id|default:''}">
	
	<input type="hidden" id="display_meetings" name="display_meetings" {$display_meetings|default:''}>
	<input type="hidden" id="display_calls" name="display_calls" {$display_calls|default:''}>
	<input type="hidden" id="display_tasks" name="display_tasks" {$display_tasks|default:''}>
	<input type="hidden" id="display_project_tasks" name="display_project_tasks" {$display_project_tasks|default:''}>
	<input type="hidden" id="display_events" name="display_events" {$display_events|default:''}>
	<input type="hidden" id="display_leave" name="display_leave" {$display_leave|default:''}>
	<input type="hidden" id="display_booked_hours" name="display_booked_hours" {$display_booked_hours|default:''}>
	<input type="hidden" id="display_bookings" name="display_bookings" {$display_bookings|default:''}>
	<input type="hidden" id="target_department" name="target_department" value="{$target_department|default:''}">
	<input type="hidden" id="forDashlet" name="forDashlet" value="{$forDashlet|default:''}">

	<input id="print_url" type="hidden" value="{$PRINT_LINK}" >
</form>


{$calendar_tab|default:''}
<section class="{$outer_class|default:''} year-calendar">
<header class="card-header panel-header">
<div class="row align-middle">
	<div class="column"></div>
	
	<div class="column text-center nav-row">
		<div class="nav-left">
			<div class="uii uii-previous uii-lg active-icon" onclick="YearCalendarCtrl.moveCalendar('{$prev_date}');" title="{$APP.LBL_PREVIOUS_YEAR}"></div>
		</div>
		<h4 class="nav-title">{$target_year}</h4>
		<div class="nav-right">
			<div class="uii uii-next uii-lg active-icon" onclick="YearCalendarCtrl.moveCalendar('{$next_date}');" title="{$APP.LBL_NEXT_YEAR}"></div>
		</div>
	</div>
	
	<div class="column"></div>
</div>
</header>

<div class="card-body panel-body">
	<table border="0" cellspacing="0" cellpadding="0" width="100%"><tbody>
		<tr>
{foreach from=$month1to6 item=contents}
			<td valign="top" width="17%" class="year_cal_month">
				<table border="0" cellspacing="0" cellpadding="0" width="100%" class="year_cal_month"><tbody>
					<tr>
						<td align="center" class="year_cal_month_head" colspan="2">{$contents.month_formatted}{$MOD.LBL_DECO_MONTH}</td>
					</tr>
	{foreach from=$contents.dayContents key=day item=dayContent}
					<tr class="{if $dayContent.date == $to_day}today{/if}">
						<td class="year_cal_day" width="20" align="center">
							<a class="year_cal_day" href="javascript:DayCalendarCtrl.asyncCalendarBody('{$dayContent.date}');">
								<span class="{$weekdayfonts[$dayContent.weekdayIndex]}">{$day}</span></a>
						</td>
						<td class="year_cal_day_content" width="80">
							{if $dayContent.holiday}<span class="holiday">{$dayContent.holiday}</span>{/if}&nbsp;
						</td>
					</tr>
	{/foreach}
				</tbody></table>
			</td>
{/foreach}
		</tr>
		<tr>
			<td class="year_cal_break">&nbsp;</td>
		</tr>
		<tr>
{foreach from=$month7to12 item=contents}
			<td valign="top" width="17%" class="year_cal_month">
				<table border="0" cellspacing="0" cellpadding="0" width="100%" class="year_cal_month"><tbody>
					<tr>
						<td align="center" class="year_cal_month_head" colspan="2">{$contents.month_formatted}{$MOD.LBL_DECO_MONTH}</td>
					</tr>
	{foreach from=$contents.dayContents key=day item=dayContent}
					<tr class="{if $dayContent.date == $to_day}today{/if}">
						<td class="year_cal_day" width="20" align="center">
							<a class="year_cal_day" href="javascript:DayCalendarCtrl.asyncCalendarBody('{$dayContent.date}');">
								<span class="{$weekdayfonts[$dayContent.weekdayIndex]}">{$day}</span></a>
						</td>
						<td class="year_cal_day_content" width="80">
							{if $dayContent.holiday}<span class="holiday">{$dayContent.holiday}</span>{/if}&nbsp;
						</td>
					</tr>
	{/foreach}
				</tbody></table>
			</td>
{/foreach}
		</tr>
	</tbody></table>
</div>

<footer class="card-footer panel-footer">
	<div class="calendar-footer-help">
		&nbsp;
	</div>
</footer>
</section>


{iah_script}
{$init_js|default:''}
setPrintLink({if $forDashlet}'dashlet_print_{$dashletId}'{/if});
window.defaultEditModule = '{$defaultEditModule}';
{/iah_script}

