<?php

class CalendarModel extends ModelDef {
	var $name = 'Calendar';
	
	function __construct() {
	}

	function getDisplayField($name, $resolve=false) {
		$def = parent::getDisplayField($name, $resolve);
		$lang_strings = AppConfig::setting("lang.dashlet_strings.current.Calendar.Calendar20Dashlet");
		if ($name == 'default_view') 
			$def = array(
				'name' => 'default_view',
				'label' => $lang_strings['LBL_DEFAULT_VIEW'],
				'type' => 'enum',
				'options' => array(
					'day' => translate('LBL_DAY', 'Calendar'),
					'week' => translate('LBL_WEEK', 'Calendar'),
					'month' => translate('LBL_MONTH', 'Calendar'),
					'year' => translate('LBL_YEAR', 'Calendar'),
				),
				'options_add_blank' => false,
			);

		if($def) {
			if(! isset($def['type'])) $def['type'] = 'varchar';
			$def['name'] = $name;
			$def['source']['type'] = 'db';
		}
		return $def;
	}
	
	function getDisplayFieldDefinitions() {
		$defs = parent::getDisplayFieldDefinitions();
		foreach($defs as $k => &$def) {
			if(! isset($def['type'])) $def['type'] = 'varchar';
			$def['name'] = $k;
			$def['source']['type'] = 'db';
		}
		return $defs;
	}
}

?>
