<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  TODO: To be written.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/




require_once('data/SugarBean.php');
require_once('modules/Contacts/Contact.php');
require_once('modules/Users/User.php');

// Call is used to store customer information.
class Call extends SugarBean {
	var $field_name_map;
	// Stored fields
	var $id;
	var $date_entered;
	var $date_modified;
	var $assigned_user_id;
	var $modified_user_id;


	// longreach - added
	var $is_private;
	
	var $description;
	var $name;
	var $status;
	var $date_start;
	var $date_end;
	var $parent_type;
	var $parent_id;
	var $contact_id;
	var $user_id;
	var $direction;
	var $reminder_time;
	var $required;
	var $accept_status;
	var $created_by;
	var $created_by_name;
	var $modified_by_name;
	var $parent_name;
	var $contact_name;
	var $contact_phone;
	var $contact_email;
	var $account_id;
	var $opportunity_id;
	var $case_id;
	var $assigned_user_name;
	var $note_id;
	var $outlook_id;

	// longreach - added
	var $email_reminder_time;


	var $update_vcal = true;
	var $contacts_arr;
	var $users_arr;
	var $default_call_name_values = array('Assemble catalogs', 'Make travel arrangements', 'Send a letter', 'Send contract', 'Send fax', 'Send a follow-up letter', 'Send literature', 'Send proposal', 'Send quote');
	var $minutes_value_default = 15;
	var $minutes_values = array('0'=>'00','15'=>'15','30'=>'30','45'=>'45');
	var $table_name = "calls";
	var $rel_users_table = "calls_users";
	var $rel_contacts_table = "calls_contacts";
	var $module_dir = 'Calls';
	var $object_name = "Call";
	var $new_schema = true;
	// This is used to retrieve related fields from form posts.
	var $additional_column_fields = array('assigned_user_name', 'assigned_user_id', 'contact_id', 'user_id', 'contact_name');
	var $relationship_fields = array(	'account_id'		=> 'accounts',
										'opportunity_id'	=> 'opportunities',
										'contact_id'		=> 'contacts',
										'case_id'			=> 'cases',
										'user_id'			=> 'users',
										'assigned_user_id'	=> 'users',
										'note_id'			=> 'notes',
								);



	/** Returns a list of the associated contacts
	 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc..
	 * All Rights Reserved..
	 * Contributor(s): ______________________________________..
	*/
	function get_contacts()
	{
		// First, get the list of IDs.
		$query = "SELECT contact_id as id from calls_contacts where call_id='$this->id' AND deleted=0";
		$tpl = new Contact();
		return $this->build_related_list($query, $tpl);
	}


	function get_call_users() {
		$template = new User();
		// First, get the list of IDs.
		$query = "SELECT calls_users.required, calls_users.accept_status, calls_users.user_id from calls_users where calls_users.call_id='$this->id' AND calls_users.deleted=0";
		$GLOBALS['log']->debug("Finding linked records $this->object_name: ".$query);
		$result = $this->db->query($query, true);
		$list = Array();
		
		while($row = $this->db->fetchByAssoc($result)) {
			$template = new User(); // PHP 5 will retrieve by reference, always over-writing the "old" one
			$record = $template->retrieve($row['user_id']);
			$template->required = $row['required'];
			$template->accept_status = $row['accept_status'];
			
			if($record != null) {
			    // this copies the object into the array
				$list[] = $template;
			}
		}
		return $list;
	}
	

    static function init_record(RowUpdate &$upd, $input) {
		if (! $upd->getField('date_start')) {
			$tm = time();
            //$tm = ceil($tm / 3600) * 3600;
            $upd->set('date_start', gmdate('Y-m-d H:i:s', $tm));
        }

        if (! $upd->getField('duration'))
            $upd->set('duration', 5);

        if (! $upd->getField('parent_type') && isset($input['return_module']) && $input['return_module'] != 'Calls')
            $upd->set('parent_type', $input['return_module']);

        $parent_type = $upd->getField('parent_type');
        $parent_id = $upd->getField('parent_id');
        if($parent_type == 'Accounts' && $parent_id) {
        	$upd->set(array('parent_type' => null, 'parent_id' => null, 'account_id' => $parent_id));
        	$parent_type = $parent_id = null;
        }

        if (! $upd->getField('phone_number')) {
			$phone = '';
        	if($parent_type && $parent_id) {
				$bean = AppConfig::module_primary_bean($parent_type);
				$parent = ListQuery::quick_fetch_row($bean, $parent_id, array('phone_office', 'phone_work'));

				if (isset($parent['phone_office'])) {
					$phone = $parent['phone_office'];
				} elseif (isset($parent['phone_work'])) {
					$phone = $parent['phone_work'];
				}

				if ($phone != '')
					$upd->set('phone_number', $phone);
			}
			if (! $phone && ($acc_id = $upd->getField('account_id'))) {
				$acc = ListQuery::quick_fetch_row('Account', $acc_id, array('phone' => 'phone_office'));
				if($acc && ! empty($acc['phone']))
					$upd->set('phone_number', $acc['phone']);
			}
        }
        
        self::set_default_reminder_time($upd);

        $acc_f = $parent_type ? get_standard_account_field($parent_type) : null;
        if($acc_f && $parent_id && ! $upd->getField('account_id')) {
        	$acc_m = AppConfig::module_primary_bean($parent_type);
			$acc_p = ListQuery::quick_fetch_row($acc_m, $parent_id, array($acc_f['id']));
			if($acc_p)
				$upd->set('account_id', $acc_p[$acc_f['id']]);
        }
        
        if(! $upd->getField('name')) {
			if(($parent_type == 'Contacts' || $parent_type == 'Leads') && $parent_id) {
				$pq = ListQuery::quick_fetch(AppConfig::module_primary_bean($parent_type), $parent_id, ['name']);
				$call_with = $pq->getField('name');
			} else if( ($acc_id = $upd->getField('account_id')) ) {
				$pq = ListQuery::quick_fetch('Account', $acc_id, ['name']);
				$call_with = $pq->getField('name');
			}
			if(! empty($call_with))
				$upd->set('name', translate('LBL_CALL_WITH_PREFIX', 'Calls') . $call_with);
		}
    }

    static function set_default_reminder_time(RowUpdate &$upd) {
	    global $current_user;
	    $remind = $current_user->getPreference('reminder_time');
	    if($remind) $upd->set('reminder_time', $remind);
    }

	static function before_save(RowUpdate $upd) {
		$start = $upd->getField('date_start');
		$dt_start = explode(' ', $start, 2);
		$duration = $upd->getField('duration');

		$input = $upd->getInput();
		if (! isset($input['reminder_time']))
			self::set_default_reminder_time($upd);

		if(count($dt_start) == 2) {
            require_once('modules/Calendar/DateTimeUtil.php');
			$date_time_start = DateTimeUtil::get_time_start($dt_start[0], $dt_start[1]);
			$dt_end = DateTimeUtil::get_time_end($date_time_start, 0, $duration);
			$upd->set('date_end', $dt_end->get_mysql_date());
		}
	}

    static function update_invitees(RowUpdate $upd) {
        require_once('modules/Meetings/ActivityInvite.php');
        $row_updates = $upd->getRelatedData('event_scheduler_rows');
		$linked = ActivityInvite::update_links($upd, $row_updates);
        $send = $upd->getRelatedData('send_invites');
        if ($send && $linked)
            self::send_invites($upd);
    }
    
    static function send_invites(RowUpdate $upd) {
    	require_once('include/Notify/RecordActionMessage.php');
    	$message = RecordActionMessage::for_action($upd->getModelName(), 'invited', $upd->getUserId());
    	if($message) {
			$message->addRecordId($upd->getPrimaryKeyValue());
			$inv = $message->getInvitees();
			if($inv) {
				$mailer = $message->getMailer();
				foreach($inv as $tgt)
					$mailer->addTargetInfo($tgt);
				$mailer->sendMessage($message);
			}
		}
	}

	static function send_apns(RowUpdate $upd) {
		require_once 'include/utils/apns_utils.php';
		$prev_user_id = $upd->getField('assigned_user_id', null, true);
		$user_id = $upd->getField('assigned_user_id');
		$user_changed = $prev_user_id && ($prev_user_id != $user_id);

		$prev_reminder = $upd->getField('reminder_time', null, true);
		$reminder = $upd->getField('reminder_time');
		$reminder_changed = $prev_reminder && ($prev_reminder != $reminder);

		$prev_start = $upd->getField('date_start', null, true);
		$start = $upd->getField('date_start');
		$start_changed = $prev_start && ($prev_start != $start);

		$prev_name = $upd->getField('name', null, true);
		$name = $upd->getField('name');
		$name_changed = $prev_name && ($prev_name != $name);

		if ($user_changed) {
			apns_events_updated($user_id);
			apns_events_updated($prev_user_id);
		}
		if ((!$prev_user_id && $user_id) || $reminder_changed || $start_changed || $name_changed) {
			apns_events_updated($user_id);
		}
	}

    static function set_phone_number(DetailManager $mgr) {
        if ($mgr->perform == 'view') {
            $rec = $mgr->getRecord();
            $pn = format_phone($rec->getField('phone_number'));
            $mgr->layout->addFormHiddenFields(array('phone_number' => $pn), false);
        }
   	}

    static function after_delete(RowUpdate $upd) {
        require_once('modules/Meetings/ActivityInvite.php');
        ActivityInvite::handle_delete($upd);
    }
    
    static function update_user_vcal(RowUpdate $upd, $link_name=null) {
    	if($link_name == 'users') {
			require_once('modules/Meetings/ActivityInvite.php');
			$link = $upd->getLinkUpdate();
			ActivityInvite::update_vcal($link->getField('user_id'));
    	}
    }
	
	static function update_vcal(RowUpdate $upd) {
		if(!version_compare(phpversion(), "5.4", ">="))
			return;
		require_once 'include/utils/vcal_utils.php';
		if (!$upd->getField('id')) {
			$id = create_guid();
			$upd->set('id', $id);
			$upd->set('vcal_uri', $id . '.ics');
		}
		$vcal = vCalUtils::vcal_update($upd, null, true);
		$upd->set('vcal', $vcal);
		$upd->set('vcal_size', strlen($vcal));
	}

    static function get_activity_status(RowUpdate $upd) {
        require_once('modules/Meetings/Meeting.php');
        return Meeting::get_activity_status($upd);
    }

	public static function additional_details_title($record, &$title)
	{
		if ($record) {
			if (AppConfig::current_user_id() != $record->getField('assigned_user_id')) {
				$is_private = $record->getField('is_really_private', '__UNSET__');
				if ($is_private === '__UNSET__') 
					$is_private = $record->getField('is_private');
				if ($is_private) {
					$title = translate('LBL_PRIVATE_MEETING', 'Meetings');
				}
			}
		}
	}

	public static function is_really_private($id, $is_private) {
		if (!$is_private) return false;
        $lq = new ListQuery('Call', null, array('link_name' => 'users', 'parent_key' => $id));
        $lq->addSimpleFilter('id', AppConfig::current_user_id());
		$count = $lq->fetchResultCount();
		return $count == 0;
	}
}
?>
