/**
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 */

//grid functions
var grid2, grid3, grid4, grid3F, grid4F;
var add_all_fields = SUGAR.language.get('app_strings',
	'LBL_ADD_ALL_LEAD_FIELDS');
var remove_all_fields = SUGAR.language.get('app_strings',
	'LBL_REMOVE_ALL_LEAD_FIELDS');

function checkFields(REQUIRED_LEAD_FIELDS, LEAD_SELECT_FIELDS) {
	var left = SUGAR.ui.getFormInput('DetailForm', 'left');
	var right = SUGAR.ui.getFormInput('DetailForm', 'right');
	var leftKeys = left.getSelectedKeys();
	var rightKeys = right.getSelectedKeys();
	var reqFields = [];
	WTL_REQUIRED.forEach(function(f) {
		var name = f[0];
		var label = f[1];
		if (!~leftKeys.indexOf(name) && !~rightKeys.indexOf(name)) {
			reqFields.push(label);
		}
	});

	if (reqFields.length) {
		alert(REQUIRED_LEAD_FIELDS + ' ' + reqFields[reqFields.length - 1]);
		return false;
	} else if (!leftKeys.length && !rightKeys.length) {
		alert(LEAD_SELECT_FIELDS);
		return false;
	} else {
		return true;
	}
}

function askLeadQ(direction, REQUIRED_LEAD_FIELDS, LEAD_SELECT_FIELDS) {
	//change current step value to that of the step being navigated to
	var lead_Div = document.getElementById('lead_queries_Div');
	var grid_Div = document.getElementById('grid_Div');
	var allButton = document.getElementById('lead_add_remove_button');
	var nextButton = document.getElementById('lead_next_button');
	var backButton = document.getElementById('lead_back_button');
	var genButton1 = document.getElementById('lead_form_button');
	var genButton2 = document.getElementById('lead_export_button');
	if (direction == 'back') {
		grid_Div.style.display = 'block';
		lead_Div.style.display = 'none';
	}
	if (direction == 'next') {
		if (!checkFields(REQUIRED_LEAD_FIELDS, LEAD_SELECT_FIELDS)) {
			return false;
		} else {
			lead_Div.style.display = 'block';
			grid_Div.style.display = 'none';
		}
	}
	allButton.style.display = grid_Div.style.display;
	nextButton.style.display = grid_Div.style.display;
	backButton.style.display = lead_Div.style.display;
	genButton1.style.display = lead_Div.style.display;
	genButton2.style.display = lead_Div.style.display;
}

function campaignPopulated() {
	var camp_populated = document.getElementById('campaign_id');
	if (camp_populated.value == 0) {
		return true;
	}
	return true;
}

function selectFields(indexes, grid) {
	var retStr = '';
	for (var i = 0; i < indexes.length; i++) {
		retStr = retStr + grid.getRow(indexes[i]).childNodes[0].childNodes[0].innerHTML +
			',' + '\n';
		retStr = retStr + '\n';
	}
	return retStr.substring(0, retStr.lastIndexOf(','));
}

function displayAddRemoveDragButtons(Add_All_Fields, Remove_All_Fields) {
	var addRemove = document.getElementById("lead_add_remove_button-label");
	if (grid2.getDataModel().getTotalRowCount() == 0) {
		addRemove.innerText = Remove_All_Fields;
		addRemove.setAttribute('title', Remove_All_Fields);
	} else if (grid3.getDataModel().getTotalRowCount() == 0 && grid4.getDataModel()
		.getTotalRowCount() == 0) {
		addRemove.innerText = Add_All_Fields;
		addRemove.setAttribute('title', Add_All_Fields);
	}
}

function displayAddRemoveButtons(Add_All_Fields, Remove_All_Fields) {
	var addRemove = document.getElementById("lead_add_remove_button-label");
	var $b = SUGAR.dom.extNode('#lead_add_remove_button .input-icon');
	var left = SUGAR.ui.getFormInput('DetailForm', 'left');
	var right = SUGAR.ui.getFormInput('DetailForm', 'right');
	var o = left.getOptions();
	var all = o.getKeys();
	var leftKeys = left.getSelectedKeys();
	var rightKeys = right.getSelectedKeys();

	if (all.length > leftKeys.length + rightKeys.length) {
		$b.removeClass('icon-delete')
		$b.addClass('icon-add')
		addRemove.innerText = Add_All_Fields;
		addRemove.setAttribute('title', Add_All_Fields);
	} else {
		$b.addClass('icon-delete')
		$b.removeClass('icon-add')
		addRemove.innerText = Remove_All_Fields;
		addRemove.setAttribute('title', Remove_All_Fields);
	}
}

function dragDropAllFields(Add_All_Fields, Remove_All_Fields) {
	var left = SUGAR.ui.getFormInput('DetailForm', 'left');
	var right = SUGAR.ui.getFormInput('DetailForm', 'right');
	var o = left.getOptions();
	var all = o.getKeys();
	var leftKeys = left.getSelectedKeys();
	var rightKeys = right.getSelectedKeys();

	if (all.length > leftKeys.length + rightKeys.length) {
		var leftSide = true;
		all.forEach(function(key) {
			if (~leftKeys.indexOf(key) || ~rightKeys.indexOf(key))
				return;
			(leftSide ? left : right).addOption(key);
			leftSide = !leftSide;
		});
	} else {
		leftKeys.forEach(function(key) {left.removeOption(key)});
		rightKeys.forEach(function(key) {right.removeOption(key)});
	}
	displayAddRemoveButtons(Add_All_Fields, Remove_All_Fields);
}

function editUrl() {
	var edit_inp = SUGAR.ui.getFormInput('DetailForm', 'chk_edit_url');
	var check = edit_inp.getValue();
	if (check == 1) {
		var url_elm = document.getElementById("post_url");
		url_elm.disabled = false;
	} else {
		var url_elm = document.getElementById("post_url");
		url_elm.disabled = true;
	}
}

function addTargetListToForm(arg) {
	var id = arg.getKey();
	var name = arg.getValue();
	if (!id)
		return;
	var div = document.getElementById("selected_target_lists");
	var inner = document.createElement('div');
	var hidden = document.createElement('input');
	hidden.setAttribute('name', 'subscriptions[]');
	hidden.setAttribute('type', 'hidden');
	hidden.setAttribute('value', id);
	inner.appendChild(hidden);
	inner.appendChild(document.createTextNode(name));
	var button = document.createElement('div');
	button.className = "input-icon icon-delete active-icon";
	inner.appendChild(button);
	button.onclick = function() {
		div.removeChild(inner);
	};
	div.appendChild(inner);
	arg.update("", "");
}

function initLeftRight(required) {
	window.WTL_REQUIRED = required;
	setTimeout(function() {
		var filter = function(other) {
			return function(idx, key, sel, perform_remove) {
				if (perform_remove) {
					return sel && sel[key];
				} else {
					return !(sel && sel[key]) && !~other.getSelectedKeys().indexOf(key);
				}
			};
		};

		var onDrop = function(self) {
			return function(ev, data) {
				var cfg = self.getDragConfig();

				var other = data.values.source_input;
				if (other === self) {
					var remove_at = self.drag_index;
					var insert_at = data.target_index;
					var keys = self.getSelectedKeys();
					var removed = keys.splice(remove_at, 1);
					if (insert_at > remove_at)
						insert_at --;
					keys.splice(insert_at, 0, removed[0]);
					self.setSelectedKey(keys);
				} else {
					var keys = other.getSelectedKeys();
					var removed = keys.splice(other.drag_index, 1);
					other.removeOption(removed[0]);
					other.setSelectedKey(keys);
					self.addOption(removed[0], undefined, data.target_index);
				}
			}
		};

		var left = SUGAR.ui.getFormInput('DetailForm', 'left');
		var right = SUGAR.ui.getFormInput('DetailForm', 'right');
		left.rows = left.min_rows = 10;
		right.rows = right.min_rows = 10;
		left.add_remove_sorted = false;
		right.add_remove_sorted = false;
		left.initSearcher();
		right.initSearcher();
		left.searcher.target_offset = {over: true, align: 'onright'};
		right.searcher.target_offset = {over: true, align: 'onleft'};
		left.searcher.filter_keys = filter(right);
		right.searcher.filter_keys = filter(left);

		var createIndicator = function() {
			var dm = createElement2('div', {'class': 'drag-row-marker', style: {position: 'relative'}});
			dm.appendChild(createElement2('div', {'class': 'uii uii-lg uii-next icon-mark-left'}));
			dm.appendChild(createElement2('div', {'class': 'uii uii-lg uii-previous icon-mark-right'}));
			return SUGAR.dom.extNode(dm);
		};

		[ left, right].forEach(function(input) {
			input.setDragConfig({
				as_source: true,
				checkAccept: function(evt, data) {
					return true;
				},
				//create_indicator_elt: createIndicator,
				onDrop: onDrop(input)
			})
		});


		left.setPanelHeight();
		right.setPanelHeight();
	}, 0);
};

