<?php

require_once 'modules/ProspectLists/ProspectList.php';
require_once 'modules/Campaigns/Campaign.php';

$json_supported_actions['get_subscriptions'] = array('login_required' => true, 'admin_only' => true);
$json_supported_actions['set_subscriptions'] = array('login_required' => true, 'admin_only' => true);

function json_get_subscriptions()/*{{{*/
{
	$target_id = array_get_default($_REQUEST, 'target_id');
	$target_type = array_get_default($_REQUEST, 'target_type');
	if (empty($target_id)) {
		return json_bad_request('no_target_id');
	}
	if ($target_type != 'Contacts' && $target_type != 'Leads') {
		return json_bad_request('bad_target_type');
	}

	$subscriptions = array();

	$lq = new ListQuery('Campaign');
	$lq->addSimpleFilter('campaign_type', 'NewsLetter');
	if ($target_type == 'Contacts') {
		$rel_name = 'contacts';
		$rel_model = 'Contact';
	} else {
		$rel_name = 'leads';
		$rel_model = 'Lead';
	}
	$campaigns = $lq->fetchAllRows();

	foreach ($campaigns as $campaign) {
		$subscriptions[$campaign['id']] = array(
			'name' => $campaign['name'],
			'subscribed' => false,
			'subscription_id' => $campaign['id'],
			'default' => true,
		);
		$lq = new ListQuery('Campaign', true, array('link_name' => 'prospectlists', 'parent_key' => $campaign['id']));
		$lists = $lq->fetchAllRows();
		foreach ($lists as $list) {
			$lq = new ListQuery('ProspectList', array('id'), array('link_name' => $rel_name, 'parent_key' => $list['id']));
			$entries = $lq->fetchAllRows();
			$ids = array();
			foreach ($entries as $e) {
				$ids[] = $e['id'];
			}
			if (!in_array($target_id, $ids, true)) {
				continue;
			}
			if ($list['list_type'] == 'default' && (!isset($subscriptions[$campaign['id']]) || isset($subscriptions[$campaign['id']]['default']))) {
				$subscriptions[$campaign['id']] = array(
					'name' => $campaign['name'],
					'subscribed' => true,
					'subscription_id' => $campaign['id'],
				);
			} elseif ($list['list_type'] == 'exempt') {
				$subscriptions[$campaign['id']] = array(
					'name' => $campaign['name'],
					'subscribed' => false,
					'subscription_id' => $campaign['id'],
				);
			}
		}
	}
	$subscriptions = array_values($subscriptions);
	json_return_value($subscriptions);
}/*}}}*/

function json_set_subscriptions()/*{{{*/
{

	$target_id = array_get_default($_REQUEST, 'target_id');
	$target_type = array_get_default($_REQUEST, 'target_type');
	if (empty($target_id)) {
		return json_bad_request('no_target_id');
	}
	if ($target_type != 'Contacts' && $target_type != 'Leads') {
		return json_bad_request('bad_target_type');
	}
	if ($target_type == 'Contacts') {
		$rel_name = 'contacts';
	} else {
		$rel_name = 'leads';
	}
	foreach ($_REQUEST['subscriptions'] as $cid => $subs) {
		$camp = ListQuery::quick_fetch_row('Campaign', $cid);
		if ($camp) {
			$lq = new ListQuery('Campaign', true, array('link_name' => 'prospectlists', 'parent_key' => $camp['id']));
			$lists = $lq->fetchAll();
			foreach($lists->getRowIndexes() as $idx) {
				$list = $lists->getRowResult($idx);
				if ($list->getField('list_type') == 'default') {
					$upd = RowUpdate::for_result($list);
					if ($subs) {
						$upd->addUpdateLink($rel_name, $target_id);
					} else {
						$upd->removeLink($rel_name, $target_id);
					}
				}
				if ($list->getField('list_type') == 'exempt') {
					$upd = RowUpdate::for_result($list);
					if ($subs) {
						$upd->removeLink($rel_name, $target_id);
					} else {
						$upd->addUpdateLink($rel_name, $target_id);
					}
				}
			}
		}
	}
}/*}}}*/



