//this function toggles the tracker values based on whether the opt out check box is selected
function toggle_tracker_url(isoptout) {
    var tracker_url = document.getElementById('tracker_url');
    if (isoptout.checked) {
        tracker_url.disabled=true;
        tracker_url.value="removeme.php";
    } else {
        tracker_url.disabled=false;
    }
}

//create variables that will be used to monitor the number of tracker url
var trackers_added = 0;
//variable that will be passed back to server to specify list of trackers
var list_of_trackers_array = [];

//this function adds selected tracker to list
function add_tracker() {
    //perform validation
    if(validate_step3()) {
    //increment tracker count value
        trackers_added++;
        document.getElementById('added_tracker_count').value = trackers_added ;
        //get the appropriate values from tracker form
        var trkr_name = document.getElementById('tracker_name');
        var trkr_url = document.getElementById('tracker_url');
        var trkr_opt_in = document.getElementById('is_optin');
        var trkr_opt_out = document.getElementById('is_optout');
        var trkr_opt_in_checked = '';
        var trkr_opt_out_checked = '';
        if(trkr_opt_in.checked){trkr_opt_in_checked = 'checked';	}
        if(trkr_opt_out.checked){trkr_opt_out_checked = 'checked';	}
        //construct html to display chosen tracker
        var trkr_name_html = "<input id='tracker_name"+trackers_added +"' type='text' size='20' maxlength='255' name='wiz_step3_tracker_name"+trackers_added+"' title='"+EDIT_TRACKER_NAME+trackers_added+"' value='"+trkr_name.value+"' >";
        var trkr_url_html = "<input type='text' size='60' maxlength='255' name='wiz_step3_tracker_url"+trackers_added+"' title='"+EDIT_TRACKER_URL+trackers_added+"' id='tracker_url"+trackers_added+"' value='"+trkr_url.value+"' >";
        var trkr_opt_in_html = "<input name='wiz_step3_is_optin"+trackers_added+"' title='"+EDIT_OPT_IN+trackers_added+"' id='is_optin"+trackers_added+"' class='checkbox' type='checkbox' "+trkr_opt_in_checked+" />";
        var trkr_opt_out_html = "<input name='wiz_step3_is_optout"+trackers_added+"' title='"+EDIT_OPT_OUT+trackers_added+"' id='is_optout"+trackers_added+"' class='checkbox' type='checkbox' "+trkr_opt_out_checked+" />";
        //display the html
		var trkr_html = '<div class="row form-row" style="padding-bottom:4px;" id="trkr_added_'+trackers_added+'"><div class="column form-cell sm-1">'+trkr_opt_in_html+'</div><div class="column form-cell sm-2">'+trkr_opt_out_html+'</div><div class="column form-cell sm-4">'+trkr_name_html+'</div><div class="column form-cell sm-4">'+trkr_url_html+'</div><div class="column form-cell sm-1"> <span class="uii uii-remove active-icon" onclick="remove_tracker(\'trkr_added_'+trackers_added+'\',\''+trackers_added+'\'); return false; "></span></div></div>';
        document.getElementById('added_trackers').innerHTML = document.getElementById('added_trackers').innerHTML + trkr_html;

        //add values to array in string, seperated by "@@" characters
        list_of_trackers_array[trackers_added] = trkr_name.value+"@@"+trkr_opt_in.checked+"@@"+trkr_opt_out.checked+"@@"+trkr_url.value;
        //assign array to hidden input, which will be used by server to process array of trackers
        document.getElementById('wiz_list_of_trackers').value = list_of_trackers_array.toString();

        //now lets clear the form to allow input of new tracker
        trkr_name.value = '';
        trkr_url.disabled = false;
        trkr_url.value = '';
        trkr_opt_in.checked = false;
        trkr_opt_out.checked = false;

        if(trackers_added > 0) {
            document.getElementById('no_trackers').style.display='none';
        }
    }
}

//this function will remove the selected tracker from the ui, and from the tracker array
function remove_tracker(div,num){
    //clear UI
    var trkr_div = document.getElementById(div);
    trkr_div.style.display = 'none';
    trkr_div.parentNode.removeChild(trkr_div);
    //clear tracker array from this entry and assign to form input
    list_of_trackers_array[num] = '';
    document.getElementById('wiz_list_of_trackers').value = list_of_trackers_array.toString();
}

//this function will remove the existing tracker from the ui, and add it's value to an array for removal upon save
function remove_existing_tracker(div,id){
    //clear UI
    var trkr_div = document.getElementById(div);
    trkr_div.style.display = 'none';
    trkr_div.parentNode.removeChild(trkr_div);
    //assign this id to form input for removal
    document.getElementById('wiz_remove_tracker_list').value += ','+id;
}

/**
*This function will iterate through list of trackers and gather all the values.  It will
*populate these values, seperated by delimiters into hidden inputs for processing
*/
function gatherTrackers() {
    //start with the newly added trackers, get count of total added
    var count = parseInt(trackers_added);
    var final_list_of_trackers_array = [];
    //iterate through list of added trackers

    for(var i = 1; i <= count; i++){
        //make sure all values exist
        if( document.getElementById('tracker_name'+i)  &&  document.getElementById('is_optin'+i) &&  document.getElementById('is_optout'+i)  &&  document.getElementById('tracker_url'+i) ){
            //make sure the check box value is int (0/1)
            var opt_in_val = '0';
            if(document.getElementById('is_optin'+i).checked){opt_in_val = 1;}
            var opt_out_val = '0';
            if(document.getElementById('is_optout'+i).checked){opt_out_val = 1;}
            //add values for this tracker entry into array of tracker entries
            final_list_of_trackers_array[i] = document.getElementById('tracker_name'+i).value+"@@"+opt_in_val+"@@"+opt_out_val+"@@"+document.getElementById('tracker_url'+i).value;
        }
    }

    //assign array of tracker entries to hidden input, which will be used by server to process array of trackers
    document.getElementById('wiz_list_of_trackers').value = final_list_of_trackers_array.toString();

    //Now lets process existing trackers, get count of existing trackers
    count = parseInt(document.getElementById('existing_tracker_count').value);
    var final_list_of_existing_trackers_array = [];
    //iterate through list of existing trackers
    for(i=0; i<count; i++){
        //make sure all values exist
        if( document.getElementById('existing_tracker_name'+i) &&  document.getElementById('existing_is_optin'+i) &&  document.getElementById('existing_is_optout'+i)  &&  document.getElementById('existing_tracker_url'+i) ){
            //make sure the check box value is int (0/1)
            var opt_in_val = '0';
            if(document.getElementById('existing_is_optin'+i).checked){opt_in_val = 1;}
            var opt_out_val = '0';
            if(document.getElementById('existing_is_optout'+i).checked){opt_out_val = 1;}
            //add values for this tracker entry into array of tracker entries
            final_list_of_existing_trackers_array[i] = document.getElementById('existing_tracker_id'+i).value+"@@"+document.getElementById('existing_tracker_name'+i).value+"@@"+opt_in_val+"@@"+opt_out_val+"@@"+document.getElementById('existing_tracker_url'+i).value;
        }
    }
    //assign array of tracker entries to hidden input, which will be used by server to process array of trackers
    document.getElementById('wiz_list_of_existing_trackers').value = final_list_of_existing_trackers_array.toString();
}


/*
* this is the custom validation script that will validate the fields on step3 of wizard
* this is called directly from the add tracker button
*/

function validate_step3() {
    var requiredTxt = SUGAR.language.get('app_strings', 'ERR_MISSING_REQUIRED_FIELDS');
    var stepname = 'wiz_step3_';
    var has_error = 0;
    var fields = [];
    fields[0] = 'tracker_name';
    fields[1] = 'tracker_url';

	SUGAR.ui.addRemoveClass(document.getElementById('tracker_name'), 'invalid', false);
	SUGAR.ui.addRemoveClass(document.getElementById('tracker_url'), 'invalid', false);

    if(trim(document.getElementById('tracker_name').value) =='' ){
		SUGAR.ui.addRemoveClass(document.getElementById('tracker_name'), 'invalid', true);
        has_error = 1;
    }
    if( trim(document.getElementById('tracker_url').value) =='' ){
		SUGAR.ui.addRemoveClass(document.getElementById('tracker_url'), 'invalid', true);
        has_error = 1;
    }
    //error has been thrown, return false
    if(has_error == 1){
        return false;
    }

    return true;
    //add fields to validation and call generic validation script
    //if(validate['wizform']!='undefined'){delete validate['wizform']};
    //addToValidate('wizform', 'tracker_name', 'alphanumeric', false,  document.getElementById('tracker_name').title);
    //addToValidate('wizform', 'tracker_url', 'alphanumeric', false,  document.getElementById('tracker_url').title);
    //return check_form('wizform');

}

