<?php

require_once 'include/ListView/ListFormatter.php';

class HighlightedListFieldFormatterComm extends FieldFormatter {

    function formatRows(array &$model_fields, array &$rows, $union_key=null) {
        $today = date('Y-m-d H:i:s', time());
        $field = 'percentage_total';
        $additional_fields = array('percentage');

        $unformatted = $rows;
        $ret = parent::formatRows($model_fields, $rows, $union_key);

        if ($this->format == 'html' && $this->getModuleDir() != 'Notes') {
            foreach ($ret as $key => &$row) {
                if (empty($row[$field]) || ! isset($unformatted[$key][$field]))
                    continue;

                if ($this->isHighlighted($unformatted[$key], $field)) {
                    $additional_fields[] = $field;
                    $this->highlightField($row, $additional_fields);
                }
            }
        }

        return $ret;
    }

    function highlightField(&$row, $fields) {
        if (! is_array($fields))
            $fields = array($fields);

        if (sizeof($fields) > 0) {
            for ($i = 0; $i < sizeof($fields); $i++) {
                $name = $fields[$i];
                if (isset($row[$name]))
                    $row[$name] = "<span class='overdueTask'>".$row[$name]."</span>";
            }
        }
    }

    function isHighlighted($row, $perc_total) {
        $status = false;
        if ($row[$perc_total] < 100)
            $status = true;
        elseif($row[$perc_total] > 100)
            $status = true;

        return $status;
    }
}

