<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/**
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 */

action_restricted_for('demo');

if(!is_admin($current_user)){
	sugar_die('Admin Only');	
}

echo get_module_title('Log', $mod_strings['LBL_VIEW_LOGS_TITLE'], true);

$filter = '';
if(!empty($_REQUEST['filter'])){
	$filter = 	$_REQUEST['filter'];
}
$ignore_self = false;
if(!empty($_REQUEST['ignore_self'])){
	$ignore_self = 'checked';	
}
$reg_ex = false;
if(!empty($_REQUEST['reg_ex'])){
	$reg_ex = 'checked';	
}
$filter_q = to_html($filter);
set_time_limit(180);
echo <<<EOQ
<div class="detailOuter">
<form action='index.php' name='logview' class="card-outer form-outer default-form" style="margin-bottom: 1em">
<input type='hidden' name='action' value='LogView'>
<input type='hidden' name='module' value='Configurator'>
<input type='hidden' name='doaction' value=''>

<div class="card-header form-buttons">
<button type="button" class="input-button" onclick='document.logview.doaction.value="all";document.logview.submit()' name='all'><span class="input-label">All</span></button>
<button type="button" class="input-button" onclick='document.logview.doaction.value="mark";document.logview.submit()' name='mark'><span class="input-label">Mark Point</span></button>
<button type="submit" class="input-button" name='display'><span class="input-label">Refresh From Mark</span></button>
<button type="button" class="input-button" onclick='document.logview.doaction.value="next";document.logview.submit()' name='next'><span class="input-label">Next &gt;&gt;</span></button>
</div>

<div class="form-body">
<div class="form-section">
<div class="row form-row">
<div class="column form-cell"><div class="form-entry"><div class="form-value">
<div class="buttons-inline">
<div class="inline-elt">
	<input type='text' size="20" name='filter' value="$filter_q" class="input-text" placeholder="Search">
</div>
<div class="inline-elt">
	<div class="input-check input-field"><input type='checkbox' name='reg_ex' $reg_ex><label class="input-label"> Reg Exp</label></div>
</div>
<!-- div class="inline-elt">
	<div class="input-check input-field"><input type='checkbox' name='ignore_self' $ignore_self><label class="input-label"> Ignore Self</label></div>
</div -->
</div>
</div></div></div>
</div>
</div></div>

</form>
EOQ;

$logFile = AppConfig::setting('site.paths.logs_dir').'/'.AppConfig::setting('site.log.file');

if (!file_exists($logFile)) {
	echo '<div class="panel-outer panel-alert panel-border panel-round">';
	echo '<div class="panel-body panel-pad-body">Log file not found: ' . to_html($logFile) . '</div>';
	echo '</div>';
	echo '</div>';
	return;
}
$lastMatch = false;
$doaction =(!empty($_REQUEST['doaction']))?$_REQUEST['doaction']:'';

switch($doaction){
	case 'mark':
		echo '<h3>Marking Where To Start Logging From</h3><br>';
		$_SESSION['log_file_size'] = filesize($logFile);
		break;
	case 'next':
		if(!empty($_SESSION['last_log_file_size'])){
			$_SESSION['log_file_size'] = $_SESSION['last_log_file_size'];	
		}else{
			$_SESSION['log_file_size'] = 0;	
		}	
		$_REQUEST['display'] = true;
		break;
	case 'all':
		$_SESSION['log_file_size'] = 0;	
		$_REQUEST['display'] = true;
		break;
}
		

if (!empty ($_REQUEST['display'])) {
	echo '<div class="panel-outer panel-info panel-border panel-round">';
	echo '<div class="panel-header">';
	echo '<h4 class="no-margin">Displaying Log</h4>';
	echo '</div>';
	echo '<div class="panel-body panel-pad-body">';

	$process_id =  getmypid();	
	echo 'Your process id [' . $process_id. ']';
	$ip = query_client_ip();
	echo '<br>Your IP Address is ' . $ip;
	/*if($ignore_self){
		echo ', it will be ignored ';	
	}*/
	echo '<br>';
	if (empty ($_SESSION['log_file_size'])) {
		$_SESSION['log_file_size'] = 0;
	}
	$cur_size = filesize($logFile);
	$_SESSION['last_log_file_size'] = $cur_size;
	$pos = 0;
	if ($cur_size >= $_SESSION['log_file_size']) {
		$pos = $_SESSION['log_file_size'] - $cur_size;
	}
	if($_SESSION['log_file_size'] == $cur_size){
		echo 'log has not changed<br>';	
	}else{
		$fp = fopen($logFile, 'r');
		fseek($fp, $pos , SEEK_END);
		echo '<pre>';
		while($line = fgets($fp)){
			//$found = preg_match('~([0-9\.,:]+) ([0-9\.,:]+) \[([0-9]*)\] (A-Z+) (.*)$~', $line, $result);
			$found = 1;
			//ob_flush();
			//flush();
			if(! $found) {
				if($lastMatch)
					echo to_html($line);
			}else{
				$lastMatch = false;
				/*if(empty($result) || ($ignore_self && $result[2] == $ip)){
					
				}else{ */
					if(empty($filter) || (!$reg_ex && substr_count($line, $filter) > 0) || ($reg_ex && preg_match('~'.$filter.'~', $line))){
						$lastMatch = true;
						echo to_html($line);	
					}	
				//}
			}	
		}
		echo '</pre>';
		fclose($fp);
	}
	echo '</div></div>';
}
?>
