<?php
if (!defined('inScheduler')) die('Unauthorized access');

require_once('modules/LicenseInfo/LicenseHistory.php');
require_once('vendor_info.php');
global $timedate, $db, $vendor_info, $app_strings;

$env = PHP_SAPI == 'cli' ? getenv() : $_SERVER;

$license = new LicenseHistory();
$hosting_type = $license->retrieve_latest()->hosting_type;
$storage_type = array_get_default($env, 'STORAGE_TYPE',  $vendor_info['storage_type']);
$onecrm_cloud = getenv("ONECRM_CLOUD");
$storage_total_startup = array_get_default($env, 'STORAGE_TOTAL_STARTUP', $vendor_info['storage_total_startup']);
if($onecrm_cloud == 1)
	$storage_total_startup = 1;
$storage_total_startup_plus = array_get_default($env, 'STORAGE_TOTAL_STARTUPP', $vendor_info['storage_total_startupp']);
if($onecrm_cloud == 1)
	$storage_total_startup_plus = 1;
$storage_total_professional = array_get_default($env, 'STORAGE_TOTAL_PRO', $vendor_info['storage_total_pro']);
if($onecrm_cloud == 1)
	$storage_total_professional = 2;
$storage_total_enterprise = array_get_default($env, 'STORAGE_TOTAL_ENT', $vendor_info['storage_total_ent']);
if($onecrm_cloud == 1)
	$storage_total_enterprise = 2.5;

function GetDirectorySize($path){
	    $bytestotal = 0;
	    $path = realpath($path);
	    if($path!==false && $path!='' && file_exists($path)){
	        foreach(new RecursiveIteratorIterator(new RecursiveDirectoryIterator($path, FilesystemIterator::SKIP_DOTS)) as $object){
	            $bytestotal += $object->getSize();
	        }
	    }
	    return $bytestotal;
	}

$p = LicenseHistory::weather('PRODUCTS');

if(in_array('startup', $p))
	$storage_total = $storage_total_startup;
else if(in_array('startup_plus', $p))
	$storage_total = $storage_total_startup_plus;
else if(in_array('infoathand', $p))
	$storage_total = $storage_total_professional;
else if(in_array('enterprise', $p))
	$storage_total = $storage_total_enterprise;
else
	$storage_total = $storage_total_startup;

$clouduser = false;

if($onecrm_cloud == 1) {
	$cloud = $mod_strings['LBL_CLOUD_USER'];
	$limit = LicenseHistory::weather('USERS');
	$totalspace = $limit * $storage_total;
	$usedspace = GetDirectorySize('./');
	$freespace = $totalspace-$usedspace;
} else {
	if($storage_type == 'Per User') {
		$cloud = $mod_strings['LBL_CLOUD_USER'];
		$totalspace = $storage_total*LicenseHistory::weather('USERS');
		$usedspace = GetDirectorySize('./');
		$freespace = $totalspace-$usedspace;
	} else if($storage_type == 'Per Instance') {
		$cloud = $mod_strings['LBL_CLOUD_USER'];
		$totalspace = $storage_total;
		$usedspace = GetDirectorySize('./');
		$freespace = $totalspace-$usedspace;
	} else {
		$freespace = disk_free_space("./");
		$totalspace = disk_total_space("./");

		$freespace = round($freespace/1024/1024/1024,2);
		$totalspace = round($totalspace/1024/1024/1024,2);
		$usedspace = $totalspace-$freespace;
	}
}

$usedspace_backups = GetDirectorySize('./files/backups');
$usedspace_backups = round($usedspace_backups/1024/1024,2);

$usedspace_email = GetDirectorySize('./files/email');
$usedspace_email = round($usedspace_email/1024/1024,2);

$usedspace_images = GetDirectorySize('./files/images');
$usedspace_images = round($usedspace_images/1024/1024,2);

$usedspace_reports = GetDirectorySize('./files/reports');
$usedspace_reports = round($usedspace_reports/1024/1024,2);

$usedspace_uploads = GetDirectorySize('./files/upload');
$usedspace_uploads = round($usedspace_uploads/1024/1024,2);

$last_notify = AppConfig::setting('misc.storageutil_last_notify');

$now = $timedate->get_gmt_db_datetime();

$usedspace = round($usedspace/1024/1024/1024,2);


$dbname = $db->dbName;
$sql = $db->query('SELECT ROUND(SUM(data_length + index_length) / 1024 / 1024, 1) AS tsize 
					FROM information_schema.tables 
					WHERE table_schema = "'.$dbname.'"; ');

$dbstorage_row = $db->fetchByAssoc($sql);
$used_storage_perc = round((($usedspace+$dbstorage_row['tsize'])/$totalspace*100),2);

$upd = array();
$upd['misc.current_disk_space_usage'] = $usedspace+round($dbstorage_row['tsize']/1024,2);
$upd['misc.current_disk_space_usage_backups'] = $usedspace_backups;
$upd['misc.current_disk_space_usage_email'] = $usedspace_email;
$upd['misc.current_disk_space_usage_images'] = $usedspace_images;
$upd['misc.current_disk_space_usage_reports'] = $usedspace_reports;
$upd['misc.current_disk_space_usage_upload'] = $usedspace_uploads;
$upd['misc.current_db_usage_upload'] = $dbstorage_row['tsize'];
$upd['misc.current_disk_space_usage_perc'] = $used_storage_perc;
if($last_notify == NULL)
	$upd['misc.storageutil_last_notify'] = $now;

AppConfig::update_local($upd, true);
AppConfig::save_local();

$last_notify = AppConfig::setting('misc.storageutil_last_notify');
if($last_notify == '') {
	$diff = 31;
}
else {
	$last_notify = new DateTime($last_notify);
	$today = new DateTime($now);
	$diff = $today->diff($last_notify)->format("%a");
}


$scheduled_report = AppConfig::setting('misc.storageutil_weekly_notify');
$notifications_on = AppConfig::setting('misc.storageutil_notify_disk_space');

require_once('include/Notify/NotifyMessage.php');
require_once('include/Notify/NotifyMailer.php');
$email = AppConfig::setting('misc.storageutil_notify_email');

$body = '<h3>'.$app_strings['LBL_STORAGE_REPORT_HEAD'].'</h3>';
$body .= $app_strings['LBL_STORAGE_TOTAL'].': '.$totalspace.' GB <br />';
$body .= $app_strings['LBL_STORAGE_USED'].': '.$usedspace.' GB / '.$used_storage_perc.' % <br />';
$body .= $app_strings['LBL_STORAGE_FREE'].': '.$freespace.' GB <br />';
$body .= '<h4>'.$app_strings['LBL_STORAGE_BY_TYPE'].'</h4>';
$body .= $app_strings['LBL_STORAGE_BACKUPS'].': '.$usedspace_backups.' MB <br />';
$body .= $app_strings['LBL_STORAGE_EMAILS'].': '.$usedspace_email.' MB <br />';
$body .= $app_strings['LBL_STORAGE_IMAGES'].': '.$usedspace_images.' MB <br />';
$body .= $app_strings['LBL_STORAGE_REPORTS'].': '.$usedspace_reports.' MB <br />';
$body .= $app_strings['LBL_STORAGE_UPLOADS'].': '.$usedspace_uploads.' MB <br />';
$body .= $app_strings['LBL_STORAGE_DB'].': '.$dbstorage_row['tsize'].' MB <br />';


if($diff >= 1 && $scheduled_report == 'Daily' && $notifications_on == 1) {
	//Daily Storage Notification
	$msg = new NotifyMessage();
	$msg->title = $app_strings['LBL_STORAGE_USAGE_REPORT'];
	$msg->subject = $app_strings['LBL_STORAGE_USAGE_REPORT'];
	$msg->rows = array(array('body' => $body));
	$mailer = $msg->getMailer();
	$mailer->addTarget($email);
	$mailer->sendMessage($msg);

	$upd = array();
	$upd['misc.storageutil_last_notify'] = $now;
	AppConfig::update_local($upd, true);
	AppConfig::save_local();
} 

if($diff >= 7 && $scheduled_report == 'Weekly' && $notifications_on == 1) {
	//Weekly Storage Notification
	$msg = new NotifyMessage();
	$msg->title = $app_strings['LBL_STORAGE_USAGE_REPORT'];
	$msg->subject = $app_strings['LBL_STORAGE_USAGE_REPORT'];
	$msg->rows = array(array('body' => $body));
	$mailer = $msg->getMailer();
	$mailer->addTarget($email);
	$mailer->sendMessage($msg);

	$upd = array();
	$upd['misc.storageutil_last_notify'] = $now;
	AppConfig::update_local($upd, true);
	AppConfig::save_local();
} 

if($diff >= 30 && $scheduled_report == 'Monthly' && $notifications_on == 1) {
	//Monthly Storage Notification
	$msg = new NotifyMessage();
	$msg->title = $app_strings['LBL_STORAGE_USAGE_REPORT'];
	$msg->subject = $app_strings['LBL_STORAGE_USAGE_REPORT'];
	$msg->rows = array(array('body' => $body));
	$mailer = $msg->getMailer();
	$mailer->addTarget($email);
	$mailer->sendMessage($msg);

	$upd = array();
	$upd['misc.storageutil_last_notify'] = $now;
	AppConfig::update_local($upd, true);
	AppConfig::save_local();
}

$notify_on = AppConfig::setting('misc.notify_percentage');
$notify_type = AppConfig::setting('misc.notify_type');
$last_warn = AppConfig::setting('misc.storage_last_warn');
if($last_warn == '') {
	$diff_warn = 1;
}
else {
	$last_warn = new DateTime($last_warn);
	$diff_warn = $today->diff($last_warn)->format("%a");
}

$free_storage = $totalspace-$usedspace;

if($diff_warn > 0 && $notify_on <= $used_storage_perc && $notify_type == 'Percentage' && $notifications_on == 1) {
	//Send storage usage warning % used
	$body = '<h3>'.$app_strings['LBL_STORAGE_WARN_PERC'].' '.$notify_on.' %</h3>';
	$body .= '<h4>'.$app_strings['LBL_STORAGE_REPORT_HEAD'].'</h4>';
	$body .= $app_strings['LBL_STORAGE_TOTAL'].': '.$totalspace.' GB <br />';
	$body .= '<span style="color:red">'.$app_strings['LBL_STORAGE_USED'].': '.$usedspace.' GB / '.$used_storage_perc.' % </span><br />';
	$body .= $app_strings['LBL_STORAGE_FREE'].': '.$freespace.' GB <br />';
	$body .= '<h5>'.$app_strings['LBL_STORAGE_BY_TYPE'].'</h5>';
	$body .= $app_strings['LBL_STORAGE_BACKUPS'].': '.$usedspace_backups.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_EMAILS'].': '.$usedspace_email.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_IMAGES'].': '.$usedspace_images.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_REPORTS'].': '.$usedspace_reports.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_UPLOADS'].': '.$usedspace_uploads.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_DB'].': '.$dbstorage_row['tsize'].' MB <br />';
	
	$msg = new NotifyMessage();
	$msg->title = $app_strings['LBL_STORAGE_USAGE_WARN'];
	$msg->subject = $app_strings['LBL_STORAGE_USAGE_WARN'];
	$msg->rows = array(array('body' => $body));
	$mailer = $msg->getMailer();
	$mailer->addTarget($email);
	$mailer->sendMessage($msg);

	$upd = array();
	$upd['misc.storage_last_warn'] = $now;
	AppConfig::update_local($upd, true);
	AppConfig::save_local();
}

if($diff_warn > 0 && $notify_on >= $free_storage && $notify_type == 'GB' && $notifications_on == 1) {
	//Send storage usage warning free gb
	$body = '<h3>'.$app_strings['LBL_STORAGE_WARN_GB'].' '.$notify_on.' GB</h3>';
	$body .= '<h4>'.$app_strings['LBL_STORAGE_REPORT_HEAD'].'</h4>';
	$body .= $app_strings['LBL_STORAGE_TOTAL'].': '.$totalspace.' GB <br />';
	$body .= '<span style="color:red">'.$app_strings['LBL_STORAGE_USED'].': '.$usedspace.' GB / '.$used_storage_perc.' % </span><br />';
	$body .= $app_strings['LBL_STORAGE_FREE'].': '.$freespace.' GB <br />';
	$body .= '<h5>'.$app_strings['LBL_STORAGE_BY_TYPE'].'</h5>';
	$body .= $app_strings['LBL_STORAGE_BACKUPS'].': '.$usedspace_backups.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_EMAILS'].': '.$usedspace_email.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_IMAGES'].': '.$usedspace_images.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_REPORTS'].': '.$usedspace_reports.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_UPLOADS'].': '.$usedspace_uploads.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_DB'].': '.$dbstorage_row['tsize'].' MB <br />';

	$msg = new NotifyMessage();
	$msg->title = $app_strings['LBL_STORAGE_USAGE_WARN'];
	$msg->subject = $app_strings['LBL_STORAGE_USAGE_WARN'];
	$msg->rows = array(array('body' => $body));
	$mailer = $msg->getMailer();
	$mailer->addTarget($email);
	$mailer->sendMessage($msg);

	$upd = array();
	$upd['misc.storage_last_warn'] = $now;
	AppConfig::update_local($upd, true);
	AppConfig::save_local();
}

$last_warn = AppConfig::setting('misc.storage_last_warn_cloud');
if($last_warn == '') {
	$diff_warn = 1;
}
else {
	$last_warn = new DateTime($last_warn);
	$diff_warn = $today->diff($last_warn)->format("%a");
}

if($usedspace > $totalspace && $diff_warn > 0 && ($storage_type == 'Per User' || $storage_type == 'Per Instance' || $onecrm_cloud == 1) && $storage_notify_email != '') {
	//Send storage usage warning Cloud user
	$body = '<h3>'.$app_strings['LBL_STORAGE_WARN_CLOUD'].' '.$license->retrieve_latest()->name.'</h3>';
	$body .= '<h4>'.$app_strings['LBL_STORAGE_REPORT_HEAD'].'</h4>';
	$body .= $app_strings['LBL_STORAGE_TOTAL'].': '.$totalspace.' GB <br />';
	$body .= '<span style="color:red">'.$app_strings['LBL_STORAGE_USED'].': '.$usedspace.' GB / '.$used_storage_perc.' % </span><br />';
	$body .= $app_strings['LBL_STORAGE_FREE'].': '.$freespace.' GB <br />';
	$body .= '<h5>'.$app_strings['LBL_STORAGE_BY_TYPE'].'</h5>';
	$body .= $app_strings['LBL_STORAGE_BACKUPS'].': '.$usedspace_backups.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_EMAILS'].': '.$usedspace_email.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_IMAGES'].': '.$usedspace_images.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_REPORTS'].': '.$usedspace_reports.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_UPLOADS'].': '.$usedspace_uploads.' MB <br />';
	$body .= $app_strings['LBL_STORAGE_DB'].': '.$dbstorage_row['tsize'].' MB <br />';

	$email2 = $vendor_info['storage_notify_email'];
	if($onecrm_cloud == 1)
		$email2 = $vendor_info['email_support'];

	$msg = new NotifyMessage();
	$msg->title = $app_strings['LBL_STORAGE_USAGE_WARN'];
	$msg->subject = $app_strings['LBL_STORAGE_USAGE_WARN'];
	$msg->rows = array(array('body' => $body));
	$mailer = $msg->getMailer();
	$mailer->addTarget($email);
	$mailer->addTarget($email2);
	$mailer->sendMessage($msg);

	$upd = array();
	$upd['misc.storage_last_warn_cloud'] = $now;
	AppConfig::update_local($upd, true);
	AppConfig::save_local();
}
