function load_vcard(form) {
	if(! form || ! form.record)
		return;
	var id = form.record.value;
	SUGAR.util.loadUrl('vCard.php?module=Contacts&record=' + encodeURIComponent(id), false);
}

function check_cookie_name(name)
{
	var match = document.cookie.match(new RegExp('(^| )' + name + '=([^;]+)'));
	var b1 = document.getElementById("DetailForm_card_scanner")
	var b2 = document.getElementById("DetailForm_card_scanner2");
	var display = match ? 'block' : 'none';
	if (b1) b1.style.display = display;
	if (b2) b2.style.display = display;
}

function initContactForm(form) {
	check_cookie_name("IOS_APP")

	const primaryAccountId = document.getElementsByName('primary_account_id')[0]?.value;
	const accountCheckbox = document.getElementById('DetailFormnewaccount-input-checkbox');

	if (accountCheckbox) {
		updateOpportunityVisibility(accountCheckbox.checked || primaryAccountId);
	}

	var account = SUGAR.ui.getFormInput(form, 'primary_account');
	if (account) {
        var acct_fields = {
            'primary_address_street': 'billing_address_street',
            'primary_address_city': 'billing_address_city',
            'primary_address_statecode': 'billing_address_statecode',
            'primary_address_state': 'billing_address_state',
            'primary_address_countrycode': 'billing_address_countrycode',
            'primary_address_country': 'billing_address_country',
            'primary_address_postalcode': 'billing_address_postalcode',
        };
        account.addExtraReturnFields(acct_fields);

        function setAccount(result) {
			updateOpportunityVisibility(result);

        	if(SUGAR.ui.getFormInput(form, 'primary_address_street').getValue() == ''
        			&& SUGAR.ui.getFormInput(form, 'primary_address_city').getValue() == ''
        			&& SUGAR.ui.getFormInput(form, 'primary_address_statecode').getValue() == ''
        			&& SUGAR.ui.getFormInput(form, 'primary_address_state').getValue() == ''
        			&& SUGAR.ui.getFormInput(form, 'primary_address_countrycode').getValue() == ''
        			&& SUGAR.ui.getFormInput(form, 'primary_address_country').getValue() == ''
        			&& SUGAR.ui.getFormInput(form, 'primary_address_postalcode').getValue() == '') {
        		SUGAR.ui.getFormInput(form, 'primary_address_street').setValue(result.primary_address_street);
            	SUGAR.ui.getFormInput(form, 'primary_address_city').setValue(result.primary_address_city);
            	SUGAR.ui.getFormInput(form, 'primary_address_statecode').setValue(result.primary_address_statecode);
            	SUGAR.ui.getFormInput(form, 'primary_address_state').setValue(result.primary_address_state);
            	SUGAR.ui.getFormInput(form, 'primary_address_countrycode').setValue(result.primary_address_countrycode);
            	SUGAR.ui.getFormInput(form, 'primary_address_country').setValue(result.primary_address_country);
            	SUGAR.ui.getFormInput(form, 'primary_address_postalcode').setValue(result.primary_address_postalcode);
        	}
        }

        SUGAR.ui.attachInputEvent(account, 'onchange', function(k, v) {
            setAccount(v);
        });
    }
}

function load_scanner(form) {
	confirm('scanneropen');
}

function toggleDisplayContacts(id) {
	const element = document.getElementById(id);
	element.style.display = (element.style.display === 'none') ? 'block' : 'none';

	const primaryAccountId = document.getElementsByName('primary_account_id')[0].value;
	const accountCheckbox = document.getElementById('DetailFormnewaccount-input-checkbox');

	updateOpportunityVisibility(accountCheckbox.checked || primaryAccountId);
}

function updateOpportunityVisibility(visible = true) {
	const oppCheckbox = document.getElementById('DetailFormnewopp-input-checkbox');
	const label = document.querySelector("[for='DetailFormnewopp-input-checkbox']");
	const newOppDiv = document.getElementById('newoppdiv');

	if (visible) {
		oppCheckbox.disabled = false;
		label.innerHTML = '<div class="switch"></div> ' + mod_string('LNK_NEW_OPPORTUNITY', 'Contacts')
	} else {
		oppCheckbox.disabled = true;
		oppCheckbox.checked = false;
		newOppDiv.style.display = 'none';
		label.innerHTML =
			'<div class="switch"></div> '
			+ mod_string('LNK_NEW_OPPORTUNITY', 'Contacts') + ' ('
			+ mod_string('LBL_ACCOUNT_IS_REQUIRED', 'Contacts') + ')'
	}
}
