<?php

require_once('include/layout/forms/FormField.php');

class SalutationNameWidget extends FormField {
	var $salutation_field = 'salutation';

	function init($params=null, $model=null) {
		$this->width = 22;
		parent::init($params, $model);
	}
	
	function getRequiredFields() {
		return array($this->salutation_field, $this->name);
	}
	
	function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context) {
		global $app_list_strings;
		$summary = ! empty($context['summary']);
		
		$value = parent::renderHtml($gen, $row_result, $parents, $context);
		if($value) {
			if($this->getEditable($context)) {
				$f = new FormField($this->salutation_field);
				//$f->style = 'margin-right: 0.5em';
				if($summary) {
					$f->class = 'no-sep input-addon border-right';
					$f->width = '8em';
				}
				else
					$f->width = '4.5em';
				$f->tabindex = $this->tabindex;
				$salut = $gen->getFormObject()->renderField($row_result, $this->salutation_field, $f);
				if($summary) {
					$value = '<div class="input-field input-field-group" style="width: 18em">'.$salut.$value.'</div>';
				} else
					$value = $salut . $value;
			} else {
				$salut = $row_result->getField($this->salutation_field);
				if($salut) {
					$salut = array_get_default($app_list_strings['salutation_dom'], $salut, $salut) . ' ';
					if(($p = strrpos($value, '&nbsp;')) !== false) {
						// compensate for favorites star
						$value = substr($value, 0, $p + 6) . $salut . substr($value, $p + 6);
					} else
						$value = $salut . $value;
				}
			}
		}
		return $value;
	}
	
}

?>