<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */


require_once 'include/layout/forms/FormField.php';

class CreditNoteAmountDue extends FormField {

	function init($params=null, $model=null) {
        parent::init($params, $model);
	}

	function getRequiredFields() {
		return array('apply_credit_note', 'invoice_id', 'amount_due');
	}

	function renderListValue(ListFormatter $fmt, ListResult $result, $row_id, $list_params=null) {
		$row = $result->getRowResult($row_id);
		if ($row->getField('apply_credit_note'))
			return '&mdash;';
		else {
			return $result->formatted_rows[$row_id]['amount_due'];
		}
    }

    function standardRenderView(RowResult $result, array $parents, array $context) {
		if ($result->getField('apply_credit_note'))
			return '&mdash;';
		else {
			return currency_format_number($result->getField('amount_due'));
		}
	}
}
