var CustomerLevelRenderer = function() {

	var nextId = 1;
	var UI = SUGAR.ui;
	var MakeElt = SUGAR.dom.makeElement;

	this.disabled = null;

	this.renderPlan = function(row, field, sect_index, row_index, editor, cell) {
		var init, d;
		if(! row._init) {
			row._init = { };
		}
		if(! row._init.div) {
			var fid = 'plan_' + (nextId++);
			d = row._init.div = MakeElt('div');
			var rel = new UI.RefInput(fid, {
				block: true,
				module: 'SubscriptionPlans',
				extra_fields: {
					id: 'id',
					name: 'name'
				},
				onchange: function(k, value) { 
					row.plan_id = k;
				},
				disabled: this.disabled
			});
			d.append(rel.render());
			rel.update(row.plan_id, row.plan_name);
			UI.registerInput('DetailForm', rel);
		}
		return row._init.div;
	};

	this.renderCoupon = function(row, field, sect_index, row_index, editor, cell) {
		var init, d;
		if(! row._init) {
			row._init = { };
		}
		if(! row._init.coupon_div) {
			var fid = 'coupon_' + (nextId++);
			d = row._init.coupon_div = MakeElt('div');
			var rel = new UI.RefInput(fid, {
				block: true,
				module: 'SubscriptionCoupons',
				extra_fields: {
					id: 'id',
					name: 'name'
				},
				onchange: function(k, value) { 
					row.coupon_id = k;
				},
				disabled: this.disabled
			});
			d.append(rel.render());
			rel.update(row.coupon_id, row.coupon_name);
			UI.registerInput('DetailForm', rel);
		}
		return row._init.coupon_div;
	};
	
	this.renderCheckbox = function(row, field, sect_index, row_index, editor, cell) {
		return MakeElt('div', {
			'class': row.keep_default ? "checked active-icon uii-checkbox uii" : "active-icon uii-checkbox uii"
		});
	}
}

var CustomerLevelRendererView = function() {
	CustomerLevelRenderer.call(this);
	this.disabled = 'readonly';
}

