<?php

require_once 'include/DetailView/StandardDetailManager.php';

class DataPrivacyDetailManager extends StandardDetailManager {
	function loadRecord($id=null) {
		$models = AppConfig::setting('model.index.personal_data');
		$options = [];
		foreach ($models as $model) {
			$module = AppConfig::module_for_model($model);
			$fields = AppConfig::setting("model.consent_fields.$model");
			$def = new ModelDef($model);
			foreach ($fields as $f ) {
				$fdef = $def->getFieldDefinition($f);
				$options[$module][$f] = translate(array_get_default($fdef, 'vname'), array_get_default($fdef, 'vname_module', $module));
			}
		}
		$json = getJSONobj();
		$encoded_options = $json->encode($options);
		$ret = parent::loadRecord($id);
		$this->layout->addScripts([ ['literal' => 'data_privacy_detail_init("' . $this->form_name . '", ' . $encoded_options . ');', 'priority' => LOAD_PRIORITY_FOOT] ]);
		return $ret;
	}
	
	function runDisplayHook() {
		$field = $this->record->getField('consent_field');
		$module = $this->record->getField('parent_type');
		$model = AppConfig::module_primary_bean($module);
		$def = new ModelDef($model);
		$fdef = $def->getFieldDefinition($field);
		if ($fdef) {
			$this->record->formatted['consent_field'] = translate(array_get_default($fdef, 'vname'), array_get_default($fdef, 'vname_module', $module));
		}
	}
}

