function data_privacy_detail_init(form_name, fields) {
	var UI = SUGAR.ui;
	var msgElt;

	var showConsentFields = function(module, type) {
		var unavail_message = null;
		var consent_input = UI.getFormInput(form_name, 'consent_field');
		if (type != 'consent' && type != 'withdraw') {
			unavail_message = mod_string('LBL_CHANGE_CONSENT_TYPE', 'DataPrivacy');
		} else if (!module || module.length < 1) {
			unavail_message = mod_string('LBL_SELECT_RELATED', 'DataPrivacy');
		}
		msgElt.innerText = unavail_message;
		if (unavail_message) {
			consent_input.clear();
			consent_input.elt.style.display = 'none';
		} else {
			consent_input.elt.style.display = '';
			var options = {keys: [], values: [], maxlen: 30};
			var value = consent_input.getValue();
			var exists = false;
			if (fields[module]) {
				Object.keys(fields[module]).forEach(function(k) {
					if (k == value) exists = true;
					options.keys.push(k);
					options.values.push(fields[module][k]);
				});
			}
			consent_input.setOptions(options);
			if (exists) consent_input.setValue(value);
			else consent_input.clear();
		}
	}

	var updateAvalableFields = function() {
		var parent_input = UI.getFormInput(form_name, 'parent');
		var type_input = UI.getFormInput(form_name, 'type');
		var module = parent_input.getModule();
		var type = type_input.getValue();
		showConsentFields(module, type);
	}

	UI.onInitForm(form_name, function() {
		var consent_input = UI.getFormInput(form_name, 'consent_field');
		if (!consent_input) return;

		msgElt = document.createElement('span');
		consent_input.elt.parentNode.appendChild(msgElt);

		var parent_input = UI.getFormInput(form_name, 'parent');
		var type_input = UI.getFormInput(form_name, 'type');
		SUGAR.ui.attachInputEvent(parent_input, 'onchange', updateAvalableFields);
		SUGAR.ui.attachInputEvent(type_input, 'onchange', updateAvalableFields);
		updateAvalableFields();
	});

}

function data_privacy_erase_init(form_name) {
	var UI = SUGAR.ui;
	UI.onInitForm(form_name, function() {
		var all_input = UI.getFormInput(form_name, 'check_all');
		var fields_input = UI.getFormInput(form_name, 'fields');
		SUGAR.ui.attachInputEvent(all_input, 'onchange', function() {
			var value = !!all_input.getValue();
			var rows = fields_input.getRows();
			rows.forEach(function(row, idx) {
				row.erase = value;
				fields_input.updateRow(0, idx, row, true, true);
			});
			fields_input.renderSections();
		});
	});
}
