<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/EmailMarketing/EmailMarketing.php
	unified_search: false
	duplicate_merge: false
	table_name: email_marketing
	primary_key: id
	reportable: true
fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
	app.modified_user
	app.created_by_user
	name
		vname: LBL_NAME
		type: name
		len: 150
		required: true
		unified_search: true
	from_addr
		vname: LBL_FROM_ADDR
		type: varchar
		len: 100
	from_name
		vname: LBL_FROM_NAME
		type: varchar
		len: 100
	inbound_email
		vname: LBL_FROM_MAILBOX_NAME
		type: ref
		required: true
		bean_name: EmailPOP3
		massupdate: true
	date_start
		vname: LBL_DATE_START
		type: datetime
		massupdate: true
	template
		vname: LBL_TEMPLATE
		type: ref
		required: true
		bean_name: EmailTemplate
		massupdate: true
	status
		vname: LBL_STATUS
		type: enum
		len: 25
		required: true
		options: email_marketing_status_dom
		default: active
		massupdate: true
	campaign
		vname: LBL_CAMPAIGN
		type: ref
		bean_name: Campaign
		massupdate: true
	all_prospect_lists
		vname: LBL_ALL_PROSPECT_LISTS
		type: bool
		default: 0
		massupdate: true
	no_auto_optout
		vname: LBL_NO_AUTO_OPTOUT
		type: bool
		default: 0
		massupdate: true
	no_auto_optin
		vname: LBL_NO_AUTO_OPTIN
		type: bool
		default: 0
		massupdate: true
	dripfeed_delay
		type: int
		width: 8
		default: 0
	dripfeed_delay_unit
		type: enum
		options: dripfeed_delay_unit_dom
		options_add_blank: false
		len: 25
		default: days
		massupdate: true
	total_entries
		vname: LBL_ENTRIES
		type: int
		source
			type: function
			value_function
				- EmailMarketing
				- get_entry_count
			fields
				- id
				- campaign_id
				- all_prospect_lists
links
	prospectlists
		relationship: email_marketing_prospect_lists
		vname: LBL_PROSPECT_LISTS
	emailtemplate
		relationship: email_template_email_marketings
		vname: LBL_TEMPLATE
	sent_emails
		no_create: true
		layout: WithRelated
		relationship: marketing_campaignlog_sent
		vname: LBL_LOG_ENTRIES_TARGETED_TITLE
		vname_module: Campaigns
		module: CampaignLog
		bean_name: CampaignLog
		reportable: false
	errored_emails
		no_create: true
		layout: Errored
		relationship: marketing_campaignlog_error
		vname: LBL_LOG_ENTRIES_SEND_ERROR_TITLE
		vname_module: Campaigns
		module: CampaignLog
		bean_name: CampaignLog
		reportable: false
	invalid_emails
		no_create: true
		layout: Errored
		relationship: marketing_campaignlog_invalid
		vname: LBL_LOG_ENTRIES_INVALID_EMAIL_TITLE
		vname_module: Campaigns
		module: CampaignLog
		bean_name: CampaignLog
		reportable: false
	link_clicked_emails
		no_create: true
		layout: WithRelated
		relationship: marketing_campaignlog_link
		vname: LBL_LOG_ENTRIES_LINK_TITLE
		vname_module: Campaigns
		module: CampaignLog
		bean_name: CampaignLog
		reportable: false
	viewed_emails
		no_create: true
		layout: WithRelated
		relationship: marketing_campaignlog_viewed
		vname: LBL_LOG_ENTRIES_VIEWED_TITLE
		vname_module: Campaigns
		module: CampaignLog
		bean_name: CampaignLog
		reportable: false
	removed_emails
		no_create: true
		layout: WithRelated
		relationship: marketing_campaignlog_removed
		vname: LBL_LOG_ENTRIES_REMOVED_TITLE
		vname_module: Campaigns
		module: CampaignLog
		bean_name: CampaignLog
		reportable: false
	created_leads
		no_create: true
		relationship: marketing_campaignlog_lead
		vname: LBL_LOG_ENTRIES_LEAD_TITLE
		vname_module: Campaigns
		module: CampaignLog
		bean_name: CampaignLog
		reportable: false
	created_contacts
		no_create: true
		relationship: marketing_campaignlog_contact
		vname: LBL_LOG_ENTRIES_CONTACT_TITLE
		vname_module: Campaigns
		module: CampaignLog
		bean_name: CampaignLog
		reportable: false
indices
	idx_emmkt_name
		fields
			- name
	idx_emmkit_del
		fields
			- deleted
relationships
	email_template_email_marketings
		key: template_id
		target_bean: EmailTemplate
		target_key: id
		relationship_type: one-to-many
	marketing_campaignlog_sent
		managed: true
		key: id
		target_bean: CampaignLog
		target_key: marketing_id
		relationship_type: one-to-many
		role_column: activity_type
		role_value: targeted
	marketing_campaignlog_error
		managed: true
		key: id
		target_bean: CampaignLog
		target_key: marketing_id
		relationship_type: one-to-many
		role_column: activity_type
		role_value: send error
	marketing_campaignlog_invalid
		managed: true
		key: id
		target_bean: CampaignLog
		target_key: marketing_id
		relationship_type: one-to-many
		role_column: activity_type
		role_value: invalid email
	marketing_campaignlog_link
		managed: true
		key: id
		target_bean: CampaignLog
		target_key: marketing_id
		relationship_type: one-to-many
		role_column: activity_type
		role_value: link
	marketing_campaignlog_viewed
		managed: true
		key: id
		target_bean: CampaignLog
		target_key: marketing_id
		relationship_type: one-to-many
		role_column: activity_type
		role_value: viewed
	marketing_campaignlog_removed
		managed: true
		key: id
		target_bean: CampaignLog
		target_key: marketing_id
		relationship_type: one-to-many
		role_column: activity_type
		role_value: removed
	marketing_campaignlog_lead
		managed: true
		key: id
		target_bean: CampaignLog
		target_key: marketing_id
		relationship_type: one-to-many
		role_column: activity_type
		role_value: lead
	marketing_campaignlog_contact
		managed: true
		key: id
		target_bean: CampaignLog
		target_key: marketing_id
		relationship_type: one-to-many
		role_column: activity_type
		role_value: contact
