<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once('modules/Emails/EmailImport.php');

$test_saved = true;
$for_user = null;
if (!empty($_REQUEST['_has_data'])) {
	$test_saved = false;
} else {
	if(empty($_REQUEST['record']))
		sugar_die('No record ID provided');
	$result = ListQuery::quick_fetch('EmailPOP3', $_REQUEST['record'], array('user_id'));
	$for_user = null;
	if($result) {
		$for_user = $result->getField('user_id');
		if($for_user == '-1') $for_user = null;
		if(! AppConfig::is_admin() && $for_user && $for_user != AppConfig::current_user_id()) {
			pr2('Error: access to mailbox denied');
			return;
		}
	}
}
$import = new EmailImport(false, $for_user, false);

	if ($test_saved) 
		$test_result = $import->connection_test($_REQUEST['record']);
	else
		$test_result = $import->connection_test2($_REQUEST);


$messages = [];

if ($test_result['connect'] !== true) {
	$messages[] = [
		'text' => "Connection failed: The error was: " . $test_result['connect'],
		'class' => 'danger',
	];
} elseif ($test_result['login'] !== true) {
	$messages[] = [
		'text' => "Connection succeeded, but login failed: The error was: " . $test_result['login'],
		'class' => 'danger',
	];
} elseif ($test_result['open'] !== true) {
	$messages[] = [
		'text' => $test_result['open'] ,
		'class' => 'danger',
	];
	$messages[] = [
		'text' => 'The list of available folders is provided below for your reference',
		'class' => 'info',
	];
} else {
	$messages[] = [
		'text' => 'Connection tested successfully',
		'class' => 'final',
	];
}

echo '<div style="padding: 8px; max-width: 600px">';

require_once('XTemplate/xtpl.php');

$messages_html = [];

foreach ($messages as $m) {
	$tpl = new XTemplate('include/utils/FlashMessages.html');
	$tpl->assign('ICON', '<span class="uii uii-' . $m['class'] . '"></span>');
	$tpl->assign('PANEL_CLASS', 'panel-'  . $m['class']);
	$tpl->assign('MESSAGE', $m['text']);
	$tpl->parse('static.message');
	$tpl->parse('static');
	$messages_html[] = $tpl->text('static');
}

echo join('<br>', $messages_html);

echo '</div>';

$encoded_folders = json_encode($test_result['folders']);

?>
<script type="text/javascript">
set_folders_list(<?php echo $encoded_folders;?>);
</script>

