function showHideFormRow(elt, visible) {
	var p = elt.parentNode;
	while(p && p.tagName && p.tagName.toLowerCase() != 'tr' && ! SUGAR.ui.hasClass(p, 'form-row')) p = p.parentNode;
	toggleDisplay(p, visible);
}

function imap_auth_update(form) {
	var auth = SUGAR.ui.getFormInput(form, 'imap_auth_type');
	var token = SUGAR.ui.getFormInput(form, 'o365_auth_token');
	var btn = document.getElementById('o365_auth_btn');
	if (!auth || !token || !btn) return;
	if(auth.getValue() == 'gmail') {
		btn.classList.add('google_signin');
		btn.innerText = '';
	} else {
		btn.classList.remove('google_signin');
		btn.innerText = mod_string('LBL_O365_AUTH_BUTTON_LABEL');
	}

	showHideFormRow(token.elt, auth.getValue() == "o365" || auth.getValue() == "gmail");
}

function imap_auth_changed() {
	imap_auth_update(this.form);
}

function smtp_auth_update(form) {
	var auth = SUGAR.ui.getFormInput(form, 'smtp_auth_req');
	var token = SUGAR.ui.getFormInput(form, 'smtp_o365_auth_token');
	if (auth && token)
		showHideFormRow(token.elt, auth.getValue() == "o365" || auth.getValue() == "gmail");
}

function smtp_auth_changed() {
	smtp_auth_update(this.form);
}

function set_folders_list(list) {
	var input = SUGAR.ui.getFormInput('DetailForm', '_dummy_folder_name');
	var label = SUGAR.language.getString('LBL_SELECT_FOLDER', 'EmailPOP3');
	if (input) {
		if (input.menu) {
			input.menu.width = 500;
		}
		var show = list && list.length;
		showHideFormRow(input.elt, show);
		if (show) {
			var options = {
				keys: [''].concat(list),
				values: [label].concat(list),
			};
			input.setOptions(options);
			input.setValue('');
		}
	}
}


