var mailbox_form;

function mailbox_init_form(form) {
	mailbox_form = form;
    fetch_folder_list(form);
	SUGAR.ui.attachFormInputEvent(form, 'use_ssl', 'onchange', set_default_port);
	SUGAR.ui.attachFormInputEvent(form, 'protocol', 'onchange', set_default_port);
	SUGAR.ui.attachFormInputEvent(form, 'host', 'onchange', guess_address);
	SUGAR.ui.attachFormInputEvent(form, 'username', 'onchange', guess_address);
	SUGAR.ui.attachFormInputEvent(form, '_dummy_folder_name', 'onchange', set_folder_name);
	var input = SUGAR.ui.getFormInput('DetailForm', '_dummy_folder_name');
	if (input) {
		showHideFormRow(input.elt, false);
	}
	set_default_port(false);
}

function set_default_port(update) {
	var portInput = SUGAR.ui.getFormInput('DetailForm', 'port');
	var protoInput = SUGAR.ui.getFormInput('DetailForm', 'protocol');
	var sslInput = SUGAR.ui.getFormInput('DetailForm', 'use_ssl');
	if (update || !portInput.getValue()) {
	    var imap = protoInput.getValue() == 'IMAP';
    	var ssl = sslInput.getValue();
	    if (imap) {
    	    document.DetailForm.port.value = ssl ? '993' : '143';
	    } else {
    	    document.DetailForm.port.value = ssl ? '995' : '110';
	    }
	}
}

function guess_address() {
	var email = SUGAR.ui.getFormInput(this.form, 'email'),
		host = SUGAR.ui.getFormInput(this.form, 'host'),
		user = SUGAR.ui.getFormInput(this.form, 'username'),
		h, u;
	if(! email.getValue() && (h = host.getValue()) && (u = user.getValue())) {
		email.setValue(u + '@' + h.replace(/^((imap|mail|pop)[^\.]*|m)\./, ''));
	}
}

function fetch_folder_list(form) {
	var uid = form.user_id.value,
		sel = SUGAR.ui.getFormInput(form, 'email_folder_id'),
		req = new SUGAR.conn.JSONRequest('get_email_folder_list', null, {module: 'EmailFolders', user_id: uid});
	if(uid && sel && req)
	req.fetch(function() {
		var result = this.getResult();
		result.width = Math.max(result.maxlen/2, 10) + 'em';
		var fid = sel.getValue();
		sel.setOptions(new SUGAR.ui.SelectOptions(result));
        if(! fid || ! result.keys.indexOf(fid)) {
            for(var i = 0; i < result.values.length; i++) {
				if(result.values[i].reserved == 1) {
					sel.setValue(result.keys[i], true);
					break;
				}
			}
		} else {
            sel.setValue(fid, true);
        }
	});
}

function wizard_return(form, data) {
	SUGAR.ui.getFormInput(form, 'protocol').setValue(data.imap.protocol, true);
	SUGAR.ui.getFormInput(form, 'host').setValue(data.imap.host, true);
	SUGAR.ui.getFormInput(form, 'disable_gssapi').setValue(data.imap.disable_gssapi, true);
	SUGAR.ui.getFormInput(form, 'use_ssl').setValue(data.imap.ssl, true);
	SUGAR.ui.getFormInput(form, 'port').setValue(data.imap.port, true);
	SUGAR.ui.getFormInput(form, 'username').setValue(data.imap.username, true);
	SUGAR.ui.getFormInput(form, 'password').setValue(data.imap.password, true);
	SUGAR.ui.getFormInput(form, 'email').setValue(data.imap.email, true);
	SUGAR.ui.getFormInput(form, 'name').setValue(data.imap.display, true);
}

function set_folder_name() {
	var input = SUGAR.ui.getFormInput(this.form, 'imap_folder');
	var v = this.getValue();
	if (input && v) {
		input.setValue(v);
		var self = this;
		setTimeout(function() {
			self.setValue('');
		}, 100);
	}
}

