<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/EmailPOP3/EmailPOP3.php
	unified_search: false
	duplicate_merge: false
	table_name: emails_pop3
	primary_key: id
	assigned_user_id: user_id
hooks
	new_record
		--
			class_function: init_record
fields
	app.id
	app.deleted
	user
		vname: LBL_LIST_USER_NAME
		type: ref
		bean_name: User
		massupdate: true
	name
		vname: LBL_NAME
		type: name
		len: 50
		required: true
		unified_search: true
	leave_on_server
		vname: LBL_LEAVE_ON_SERVER
		type: bool
		required: true
		default: 1
		massupdate: true
	mark_read
		vname: LBL_MARK_READ
		type: bool
		default: 1
		required: true
		massupdate: true
	detect_bcc
		vname: LBL_DETECT_BCC
		type: bool
		default: 0
		required: true
		massupdate: true
	active
		vname: LBL_ACTIVE
		type: bool
		default: 1
		massupdate: true
	scheduler
		vname: LBL_SCHEDULER
		type: bool
		default: 1
		massupdate: true
	host
		type: varchar
		len: 80
		vname: LBL_HOST
		required: true
	username
		type: varchar
		len: 60
		width: 25
		vname: LBL_USERNAME
	password
		type: password
		len: 60
		width: 25
		reportable: false
		vname: LBL_PASSWORD
    imap_auth_type
		editable: true
		type: enum
		options: imap_auth_type
		options_add_blank: false
		vname: LBL_AUTH_TYPE
	o365_auth_token
		vname: LBL_O365_AUTH_TOKEN
		type: text
		widget: EmailAuthInput
		email_service_field: imap_auth_type
	email
		type: email
		vname: LBL_EMAIL
		required: true
		unified_search: true
	return_path
		type: email
		vname: LBL_RETURN_PATH
		vdesc: LBL_RETURN_PATH_DESC
		required: false
		unified_search: true
	reply_to
		type: email
		vname: LBL_REPLY_TO
		vdesc: LBL_REPLY_TO_DESC
		required: false
		unified_search: true
	from_name
		type: varchar
		len: 80
		vname: LBL_FROM_NAME
	last_check
		vname: LBL_LAST_CHECK
		type: datetime
		massupdate: true
	last_id
		type: varchar
		len: 255
		reportable: false
	protocol
		type: enum
		len: 10
		vname: LBL_PROTOCOL
		default: IMAP
		options_function
			- EmailPOP3
			- get_protocol_options
		options_add_blank: false
		massupdate: true
	disable_gssapi
		type: bool
		default: 0
		vname: LBL_DISABLE_GSSAPI
	imap_folder
		type: varchar
		len: 100
		vname: LBL_IMAP_FOLDER
		default: INBOX
	imap_is_sent
		type: bool
		default: 0
		vname: LBL_IMAP_IS_SENT
	port
		type: int
		required: true
		vname: LBL_PORT
	use_ssl
		vname: LBL_USE_SSL
		type: bool
		required: true
		massupdate: true
	mailbox_type
		vname: LBL_MAILBOX_TYPE
		type: enum
		len: 10
		options_function
			- EmailPOP3
			- get_type_options
		massupdate: true
	template
		vname: LBL_AUTOREPLY
		type: ref
		bean_name: EmailTemplate
		massupdate: true
	ooo_template
		vname: LBL_OOO_TEMPLATE
		type: ref
		bean_name: EmailTemplate
		massupdate: true
	filter_domain
		vname: LBL_FILTER_DOMAIN
		type: varchar
		len: 50
	email_folder_id
		type: enum
		dbType: char
		len: 40
		vname: LBL_DELIVER_TO_FOLDER
		options
		massupdate: false
	restrict_since
		type: enum
		len: 10
		vname: LBL_RESTRICT_SINCE
		options_function
			- EmailPOP3
			- get_restrict_options
		default: 30d
		options_add_blank: false
		massupdate: true
	one_case
		type: bool
		vname: LBL_ONE_CASE
	auto_create_contact
		type: bool
		vname: LBL_AUTO_CREATE_CONTACT
	smtp_host
		vname: LBL_SMTP_HOST
		type: varchar
	smtp_port
		vname: LBL_SMTP_PORT
		type: int
	smtp_auth_req
		vname: LBL_SMTP_AUTH_REQ
		type: enum
		options: smtp_auth_type
		options_add_blank: false
	smtp_security
		vname: LBL_SMTP_SECURITY
		type: enum
		options: smtp_security_dom
	smtp_username
		vname: LBL_SMTP_USER
		type: varchar
	smtp_password
		type: password
		vname: LBL_SMTP_PASSWORD
	smtp_verification
		vname: LBL_SMTP_VERIFICATION
		type: enum
		len: 40
		options: dom_smtp_ssl_verify
	smtp_on
		vname: LBL_SMTP_ON
		type: bool
	smtp_o365_auth_token
		vname: LBL_O365_AUTH_TOKEN
		type: text
		widget: EmailAuthInput
		email_service_field: smtp_auth_req
links
	skills
		relationship: emailpop3_skills
		vname: LBL_SKILLS
links
	teams
		vname: LBL_EMAILPOP3_TEAMS_REL
		relationship: emailpop3_teams_rel
		module: SecurityGroups
		bean_name: SecurityGroup
indices
	idx_user_id
		fields
			- user_id
	idx_name
		fields
			- name
