var EmailSetupWizard = function(frm) {

	var wizard = this;
	var outer;
	var serviceId;
	var callback;
	var dialog;
	var form = frm;

	var createForm = function(map) {
	   	var template = {
			tag: 'div', params: {style: {width: '100%'}},
			children: [
				{
					tag: 'table',
					params: {className: 'tabForm', width: '100%'},
					children : [
						{
							tag: 'tr',
							children : [
								{
									tag: 'td',
									params: {className: "cell-from_name dataField"},
									children: [
										{
											tag: 'p', params: {className: "topLabel"},
											children: [
												{
													tag: 'span', 
													children: [
														{ text: 'Email Address'}
													]
												}
											]
										},
										{
											tag: 'div', params: {className: "fieldValue"},
											children: [
												{ id: 'email', tag: 'input', params:{type: "text", className: "input-text input-outer", maxlength: "80", size: "35"}}
											]
										}
									]
								}
							]
						},
						{
							tag: 'tr',
							children : [
								{
									tag: 'td',
									params: {className: "cell-from_name dataField"},
									children: [
										{
											tag: 'p', params: {className: "topLabel"},
											children: [
												{
													tag: 'span', 
													children: [
														{ text: 'Password'}
													]
												}
											]
										},
										{
											tag: 'div', params: {className: "fieldValue"},
											children: [
												{ id: 'password', tag: 'input', params:{type: "password", className: "input-text input-outer", maxlength: "80", size: "35"}}
											]
										}
									]
								}
							]
						}
					]
				},
				{
					tag: 'div', params: {style: {paddingTop: '10px', textAlign: 'right'}},
					children: [
						{
							id: 'cancel', tag: 'button', params: {type: 'button', className: 'input-button'},
							children: [
								{
									tag: 'div', params: {className: "input-icon icon-cancel left"}
								},
								{
									tag: 'span', params: {className: "input-label"},
									children: [{text: app_string('LBL_CANCEL_BUTTON_LABEL')}]
								}
							]
						},
						{text: ' '},
						{
							id: 'ok', tag: 'button', params: {type: 'button', className: 'input-button'},
							children: [
								{
									tag: 'div', params: {className: "input-icon icon-accept left"}
								},
								{
									tag: 'span', params: {className: "input-label"},
									children: [{text: app_string('LBL_ACCEPT_BUTTON_LABEL')}]
								}
							]
						}
					]
				}
			]
		}
		return wizard.renderDOM(template, map);
	};

	var services = {
		icloud : {
			name: 'iCloud',
			display: 'iCloud Account',
			logo : 'include/images/icloud.png',
			description: 'Email addresses ending with @mac.com, @me.com and @icloud.com',
			rules: {
				imap: {
					protocol: 'IMAP',
					email: {template: 'email'},
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'imap.mail.me.com',
					port: '993',
					ssl: true,
				},
				smtp: {
					email: {template: 'email'},
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'smtp.mail.me.com',
					port: '587',
					security: 'tls',
					auth: true
				}
			}
		},
		gmail : {
			name: 'GMail',
			display: 'GMail Account',
			logo : 'include/images/gmail.png',
			description: 'Email addresses ending with @gmail.com, and corporate emails using Google Apps',
			rules: {
				imap: {
					email: {template: 'email'},
					protocol: 'IMAP',
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'imap.gmail.com',
					port: '993',
					ssl: true,
				},
				smtp: {
					email: {template: 'email'},
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'smtp.gmail.com',
					port: '587',
					security: 'tls',
					auth: true
				}
			}
		},
		yahoo : {
			name: 'Yahoo Mail',
			display: 'Yahoo Account',
			logo : 'include/images/yahoomail.png',
			description: 'Email addresses ending with @yahoo.com',
			rules: {
				imap: {
					email: {template: 'email'},
					protocol: 'IMAP',
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'imap.mail.yahoo.com',
					port: '993',
					ssl: true,
				},
				smtp: {
					email: {template: 'email'},
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'smtp.mail.yahoo.com',
					port: '587',
					security: 'tls',
					auth: true
				}
			}
		},
		aol : {
			name: 'AOL Mail',
			display: 'AOL Account',
			logo : 'include/images/aol.png',
			description: 'Email addresses ending with @aol.com, @love.com, @ygm.com, @games.com, and @wow.com',
			rules: {
				imap: {
					email: {template: 'email'},
					protocol: 'IMAP',
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'imap.aol.com',
					port: '993',
					ssl: true,
				},
				smtp: {
					email: {template: 'email'},
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'smtp.aol.com',
					port: '587',
					security: 'tls',
					auth: true
				}
			}
		},
		outlook : {
			name: 'Outlook.com',
			display: 'Outlook Account',
			logo : 'include/images/outlook.png',
			description: 'Email addresses ending with @outlook.com, @hotmail.com, @live.com and @msn.com',
			rules: {
				imap: {
					email: {template: 'email'},
					protocol: 'IMAP',
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'imap-mail.outlook.com',
					port: '993',
					ssl: true,
					disable_gssapi: true
				},
				smtp: {
					email: {template: 'email'},
					username: {template: 'email'},
					password: {template: 'password'},
					host: 'smtp.office365.com',
					port: '587',
					security: 'tls',
					auth: true
				}
			}
		}
	};

	this.run = function(cb) {
		callback = cb;
		outer = createElement2('div', {style: {padding: '5px'}});
		dialog = new SUGAR.ui.Dialog('email_setup_wizard', {content_elt: outer, width: '450px', title: ''});
		dialog.destroy_on_close = true;
		wizard.renderStep1();
		dialog.render();
		dialog.show();
		setTimeout(function() {dialog.reposition();}, 200);
	};

	this.renderStep1 = function() {
		dialog.setTitle(mod_string('LBL_WIZARD_STEP1_TITLE'));
		outer.innerHTML = '';
		for (var i in services) {
			outer.appendChild(wizard.renderButton(i, services[i]));
		}
	};

	this.renderButton = function(id, srv) {
		var container = createElement2('div', {style: {clear: 'both', padding: '5px'}});
		var button = createElement2('button', {type: 'button', className: 'input-field', style : { margin: '2px', padding: '5px', height: 'auto', float: 'left', cursor: 'pointer'}});
		var logo = createElement2('img', {src: srv.logo});
		button.appendChild(logo);
		var desc = createElement2('div', {style : { padding: '5px', height: 'auto', 'float': 'left', width: '200px'}});
		desc.innerText = srv.description;
		container.appendChild(button);
		container.appendChild(desc);
		button.onclick = wizard.serviceSeleted;
		button.setAttribute('data-id', id);;
		return container;
	};

	this.serviceSeleted = function() {
		serviceId = this.getAttribute('data-id');
		wizard.renderStep2();
	};

	this.renderDOM = function(template, map) {
		if (template.text) {
			return document.createTextNode(template.text);
		}
		var ret = createElement2(template.tag, template.params);
		if (template.id)
			map[template.id] = ret;
		if (template.children) {
			for (var i =0; i < template.children.length; i++) {
				ret.appendChild(wizard.renderDOM(template.children[i], map));
			}
		}
		return ret;
	};

	this.renderStep2 = function() {
		dialog.setTitle(mod_string('LBL_WIZARD_STEP2_TITLE'));
		outer.innerHTML = '';
		var map = {};
		var form = createForm(map);
		outer.appendChild(form);
		map.cancel.onclick = SUGAR.popups.close;
		map.ok.onclick = function() {
			wizard.save(map.email.value, map.password.value);
		};
	};

	this.parseRule = function(rule, email, password) {
		var templates = {email: email, password: password};
		var ret = {};
		for (var i in rule) {
			var val = rule[i];
			if (typeof val == 'object') {
				val = templates[val.template];
			}
			ret[i] = val;
		}
		return ret;
	};

	this.save = function(email, password) {
		var srv = services[serviceId];
		var ret = {
			imap: wizard.parseRule(srv.rules.imap, email, password),
			smtp: wizard.parseRule(srv.rules.smtp, email, password)
		};
		ret.imap.display = srv.display;
		ret.smtp.display = srv.display;
		SUGAR.popups.close();
		callback(form, ret);
	};

};
