<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2005 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/


require_once 'data/SugarBean.php';
require_once 'include/database/ListQuery.php';
require_once 'include/database/RowUpdate.php';
require_once 'include/maxmind/MaxMindGeoIP.php';

class EmailTracker extends SugarBean {
	public static function track_email() {
		$email_id = array_get_default($_REQUEST, 'e');
		if (empty($email_id)) return;
		$email = ListQuery::quick_fetch('Email', $email_id);
		if (!$email || $email->failed) return;

		$ua = array_get_default($_SERVER, 'HTTP_USER_AGENT', '');
		$is_google_proxy = strpos($ua, 'GoogleImageProxy') !== false;
		$ip = array_get_default($_SERVER, 'REMOTE_ADDR', '');
		$data = [
			'email_id' => $email_id,
			'modified_user_id' => $email->getField('assigned_user_id'),
			'assigned_user_id' => $email->getField('assigned_user_id'),
			'ip' => $ip,
		];
		if (!$is_google_proxy) {
			$address = MaxMindGeoIP::lookup($ip);
			if ($address) {
				$data['city'] = $address->city->name;
				$data['country'] = $address->country->name;
				$data['state'] = join(', ', array_reverse(array_map(function($sd) {return $sd->name;}, $address->subdivisions)));
			}
		}
		$tracker = RowUpdate::blank_for_model('EmailTracker');
		$tracker->set($data);
		$tracker->save();

		$email_upd = RowUpdate::for_result($email);
		$email_upd-> set('open_count', $email->getField('open_count') + 1);
		if (!$email->getField('first_opened'))
			$email_upd-> set('first_opened', gmdate('Y-m-d H:i:s'));
		$email_upd-> update_date_modified = false;
		$email_upd->save();

	}
}

