<?php

use Spatie\Dropbox\Client;

require_once 'include/Dropbox/AuthProvider.php';

global $pageInstance;
$path = array_get_default($_REQUEST, 'path', '/');

$json = getJSONObj();

try {
	$provider = new DropboxAuthProvider(false);
    $client = new Client($provider);
	$folderContents = $client->listFolder($path);
	$type = $_REQUEST['type'] == 'file' ? 'file' : 'link';

	echo '<form method="POST" action="async.php" id="dropbox_navigation_form">';
	echo '<input type="hidden" name="type" value="' . $type . '">';
	echo '<input type="hidden" name="module" value="Emails">';
	echo '<input type="hidden" name="action" value="DropboxChooser">';
	echo '<div class="dropbox_listing">';
	$parts = array_values(array_filter(explode('/', $path), 'strlen'));
	echo '<div class="breadcrumps">';
	$onclick = '';
	$class = '';
	if (count($parts)) {
		$onclick = 'navigateToDropdoxFolder($(\'dropbox_navigation_form\'), \'/\')';
		$class = '-clickable';
	}
	echo '<span class="breadcrump' . $class . '" onclick="' .$onclick . ' ">Dropbox</span>';
	$path = '/';
	foreach ($parts as $i => $p) {
		$onclick = '';
		$class = '';
		if ($path !== '/')
			$path .= '/';
		$path .= $p;
		if ($i < (count($parts) - 1)) {
			$onclick = 'navigateToDropdoxFolder($(\'dropbox_navigation_form\'), ' . to_html($json->encode($path)) . ')';
			$class = '-clickable';
		}
		echo '<span class="breadcrump' . $class . '" onclick="' . $onclick . ' ">&nbsp;&raquo;&nbsp;' . to_html($p) . '</span>';
	}
	echo '</div>';
	echo '<ul class="filelist">';
	do {
		$items = $folderContents['entries'];
		foreach ($items as $item) {
			if ($item['.tag'] === 'folder') {
				$onclick = 'navigateToDropdoxFolder($(\'dropbox_navigation_form\'), ' . to_html($json->encode($item['path_display'])) . '); return false;';
				$icon = 'folder';
			} else {
				if (array_get_default($_REQUEST, 'type') == 'link') {
					$method = 'insertDropboxLink';
				} else {
					$method = 'attachDropboxFile';
				}
				$onclick = $method . '(' . to_html($json->encode($item['path_lower'])) . ', ';
				$onclick .= to_html($json->encode(basename($item['name']))) . '); return false;';
				$icon = 'page_white';
			}

			printf('<li><div onclick="' . $onclick . '" class="db_file"><img width="32" src="https://www.dropbox.com/static/images/icons64/%s.png" /><div class="db_filename">%s</div></div></li>', urlencode($icon), to_html(basename($item['name'])));
		}
		if (empty($folderContents['has_more']))
			break;
		$cursor = $folderContents['cursor'];
		$folderContents = $client->listFolderContinue($cursor);
	} while (true);
	echo '</ul>';
	echo '</div>';
	echo '</form>';

	$pageInstance->add_css_include("modules/Emails/dropbox_chooser.css", null, LOAD_PRIORITY_FOOT);

} catch (Exception $e) {
	echo $e->getMessage();
}
