/**
 * EditView javascript for Email
 *
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 */

// $Id: Email.js,v 1.5 2006/03/23 02:06:31 chris Exp $


///////////////////////////////////////////////////////////////////////////////
////	HTML/PLAIN EDITOR FUNCTIONS
function setEditor() {
	if($('setEditor').checked == false) {
		toggle_textonly();
	}
}

function toggle_textonly() {
	var altText = $('alt_text_div');
	var plain = $('text_div');
	var html = $('html_div');
	
	if(html.style.display == 'none') {
		html.style.display = 'block';
		if($('toggle_textarea_elem').checked == false) {
			plain.style.display = 'none';
		}
		altText.style.display = 'block';
	} else {
		html.style.display = 'none';
		plain.style.display = 'block';
		altText.style.display = 'none';
	}
}

function toggle_textarea() {
	var checkbox = $('toggle_textarea_elem');
	var plain = $('text_div');

	if (checkbox.checked == false) {
		plain.style.display = 'none';
	} else {
		plain.style.display = 'block';
	}
}
////	END HTML/PLAIN EDITOR FUNCTIONS
///////////////////////////////////////////////////////////////////////////////




///////////////////////////////////////////////////////////////////////////////
////	EMAIL TEMPLATE CODE
function fill_email(id, form) {
	if(id == '') return;
	var req = new SUGAR.conn.JSONRequest('retrieve', null, {module: 'EmailTemplates', record: id});
	req.email_form = form;
	req.append = true;
	req.fetch(function(resp) { setTimeout(function() { appendEmailTemplateJSON.call(resp); }, 100); });
}


appendGuard = false;
function appendEmailTemplateJSON() {
	var result = this.getResult();
	if(! result || ! result.fields) return;
	var template = result.fields;
	
	if (appendGuard) return;
	appendGuard = true;
	var form = this.email_form;
	var subject = SUGAR.ui.getFormInput(form, 'name');
	var body = SUGAR.ui.getFormInput(form, 'description_html');

	// query based on template, contact_id0,related_to
	if(subject)
		subject.setValue(template['subject']);
	if(this.append) {
		if(body) {
			body.focus();
			body.insertHtml(template['body_html'].replace(/<BR>/ig, '\n'));
		}
	} else {
		if(body)
			body.setValue(template['body_html'].replace(/<BR>/ig, '\n'));
	}

	if(form.description && form.description.value != '') {
		form.toggle_html.checked = true;
		toggle_textarea(form.toggle_html);
	}
	
	var chk = SUGAR.ui.getFormInput(form, 'replace_fields');
	if(chk && ! chk.getValue()) {
        chk.setValue(1);
    }
	appendGuard = false;
	
	var req = new SUGAR.conn.JSONRequest('fetch_template_attachments', null, {module: 'Emails', record: template.id});
	req.email_form = form;
	req.fetch(setTemplateAttachments);
}


function setTemplateAttachments() {
	var result = this.getResult();
	if(result) {
		var form = this.email_form;
		if(result.note_ids && form.new_notes)
			form.new_notes.value = result.note_ids.join(',');
		$('template_attachments').innerHTML = result.body;
	}
}

////	END EMAIL TEMPLATE CODE
///////////////////////////////////////////////////////////////////////////////


///////////////////////////////////////////////////////////////////////////////
////	SIGNATURE CODE
function insertSignature(text) {
	if(typeof window.CKEDITOR != undefined) {
	 	var oEditor = CKEDITOR.instances.description_html;
	  	oEditor.insertHtml(text);
	} else if (typeof window.html_editor != undefined) {
   		html_editor.focusEditor();
    
    	if(HTMLArea.is_ie) {
	        html_editor.insertHTML(text + " " );
	    } else {
    	    html_editor.insertNodeAtSelection(document.createTextNode(text + " "));
    	}
	}    
}


function showAddressField(elt) {
	var id = elt.getAttribute('data-field');
	if (id) {
		var e = document.getElementById('addr_input_' + id);
		if (e) {
			e.style.display = 'block';
			elt.parentNode.style.display = 'none';
		}
		var input = SUGAR.ui.getFormInput(SUGAR.dom.elementOrId(elt).closest('form').get(0), id);
		if(input) input.focus();
	}
}

function insertHTML(html) {
	if(typeof(window.html_editor) != 'undefined') {
		html_editor.insertHTML(html);
	} else if(typeof(window.CKEDITOR) != 'undefined') {
		var oEditor = CKEDITOR.instances.description_html;
		if(navigator.userAgent.toLowerCase().indexOf("webkit") > -1)
			oEditor.insertHtml(''); // work around safari issue
		oEditor.insertHtml(html);
	}
}

////	END SIGNATURE CODE
///////////////////////////////////////////////////////////////////////////////

SUGAR.ui.EmailAttachments = EmailAttachments = function(id, params) {
	this.id = id || 'attachments';
	this.MAXFILES = 10;
	this.params = params;
}
EmailAttachments.addFile = function(form) {
	var inp = SUGAR.ui.getFormInput(form, 'attachments'); if(inp) inp.addFile();
}
EmailAttachments.addDocument = function(form) {
	var inp = SUGAR.ui.getFormInput(form, 'attachments'); if(inp) inp.addDocument();
}
EmailAttachments.removeAttachment = function(control, id) {
	var inp = SUGAR.ui.getFormInput(control && control.form || 'DetailForm', 'attachments');
	if(inp) inp.removeAttachment(control, id);
}
EmailAttachments.prototype = {
	beforeSubmitForm: function(form) {
		var boxes = document.getElementsByName('keep_attachments[]');
		var remove = $('remove_attachments');
		if (!remove) return;
		remove.value = '';
		for (var i = 0; i< boxes.length; i++) {
			if (!boxes[i].checked) {
				if (remove.value != '') remove.value += ',';
				remove.value += boxes[i].value;
			}
		}
	},
	addFile: function() {
		for(var i=0; i<this.MAXFILES; i++) {
			var elem = $('file'+i);
			if(! elem) {
				var inp = new SUGAR.ui.FileInput('file'+i, {name: 'email_attachment'+i});
				SUGAR.ui.registerInput(this.form, inp);
				var remove = createElement2('div', {className: 'uii uii-remove uii-lg active-icon'});
				remove.onclick = function() {
					SUGAR.ui.removeNode($('file-outer'+i));
				}
				createElement2('div', {id: 'file-outer'+i, style: 'padding-bottom: 0.3em'}, [inp.render(),nbsp(),remove], $('uploads_div'));
				inp.focus();
				break;
			}
		}
	},
	addDocument: function() {
		for(var i=0; i<this.MAXFILES; i++) {
			var elem = $('document'+i), self = this;
			if(! elem) {
				var inp = new SUGAR.ui.RefInput('document'+i, {module: 'Documents'});
				inp.onchange = function() {
					self.updateNewDocuments();
				}
				SUGAR.ui.registerInput(this.form, inp);
				var remove = createElement2('div', {className: 'uii uii-remove uii-lg active-icon'});
				remove.onclick = function() {
					SUGAR.ui.removeNode($('document-outer'+i));
				}
				createElement2('div', {id: 'document-outer'+i, style: 'padding-bottom: 0.3em'}, [inp.render(),nbsp(),remove], $('documents_div'));
				inp.focus();
				window.xx = inp;
				break;
			}
		}
	},
	removeAttachment: function(control, id) {
		if(confirm(mod_string('NTC_REMOVE_ATTACHMENT', 'Emails'))) {
			SUGAR.ui.removeNode(control.parentNode);
			if(this.form && this.form.remove_notes)
				this.form.remove_notes.value += ','+id;
		}
	},
	updateNewDocuments: function() {
		var i, k, docs = [], hidden = this.form.new_documents;
		for(i = 0; i < this.MAXFILES; i++) {
			var inp = SUGAR.ui.getFormInput(this.form, 'document'+i);
			if(inp && (k = inp.getKey()))
				docs.push(k);
		}
		if(hidden) hidden.value = docs.join(',');
	}
};

function focus_body(form) {
	var html_input = SUGAR.ui.getFormInput(form, 'description_html'),
		plain_inp = SUGAR.ui.getFormInput(form, 'description');
	if(html_input)
		html_input.focus();
	else if(plain_inp)
		plain_inp.focus();
}
	
function set_email_focus(form) {
	var addr_inp = SUGAR.ui.getFormInput(form, 'to_addrs'),
		subj_inp = SUGAR.ui.getFormInput(form, 'name'), ord, i;
	if(SUGAR.themes.version(8)) ord = [subj_inp, addr_inp];
	else ord = [addr_inp, subj_inp];
	for(i = 0; i < ord.length; i++) {
		if(ord[i] && ord[i].isBlank()) {
			ord[i].focus();
			return;
		}
	}
	focus_body(form);
}

function initEmailEdit(form) {
	var rel = SUGAR.ui.getFormInput(form, 'parent');
	if(rel) {
		rel.addExtraReturnFields({
			'account': '_account',
			'account_id': '_account_id'
		});
		SUGAR.ui.attachInputEvent(rel, 'onchange', function(k, v) {
			if(v && v.account_id) {
				var acct = SUGAR.ui.getFormInput(form, 'account');
				if(acct) acct.update(v.account_id, v.account);
			}
		});
	}
	initEmailDropzone();
}


var emailWidgetDropzone;
var emailProcessDropzoneHandler;

function emailProcessDropzone(done) {
    var files = emailWidgetDropzone.getFilesWithStatus(Dropzone.QUEUED);
	emailProcessDropzoneHandler = function() {
		var inputs = document.querySelectorAll("#email_dropzone input[type=hidden]");
		for (var i = 0 ; i < inputs.length; i++) {
			var input = inputs[i];
			input.parentNode.removeChild(input);
		}
		var i = 0;
		for (var j = 0; j < emailWidgetDropzone.files.length; j++) {
			var file = emailWidgetDropzone.files[j];
			if (file.incoiming_id) {
				var input = document.createElement('input');
				input.setAttribute('type', 'hidden');
				input.setAttribute('name', 'email_attachment' + i);
				input.setAttribute('value', 'INCOMING~' + file.incoiming_id);
				document.getElementById('email_dropzone').appendChild(input);
				i++;
			}
		}
		done();
	};
	if (files.length) {
		emailWidgetDropzone.processQueue();
	} else {
    	var files = emailWidgetDropzone.getFilesWithStatus(Dropzone.ERROR);
		if (!files.length) {
			emailProcessDropzoneHandler();
		}
	}
}

function initEmailDropzone() {
	Dropzone.options.emailDropzone = {
		paramName: "file",
		url: "upload.php",
		clickable: true,
		parallelUploads: 1,
		autoProcessQueue: false,
		previewTemplate: document.getElementById("email_dropzone_preview_template") ? document.getElementById("email_dropzone_preview_template").innerHTML : null,
		init: function() {
			var status = null;
			var dropzone = this;

			emailWidgetDropzone = this;
			this.on("sending", function(file, xhr, formData) {
				var csrf_cookie;
				if (!status) {
					status = new SUGAR.ui.StatusMessage(app_string('LBL_UPLOADING'));
				}
				SUGAR.ui.Status.show(status);
				formData.append('user_id', SUGAR.session.user_id);
				formData.append('fail_on_first_error', '1');
				csrf_cookie = 
					window.document.cookie.split(";")
						.map(function(str) {return str.trim()})
						.map(function(str) {return str.split('=')})
						.find(function(parts) {return parts[0] === 'UNKNOWN'});
				if (csrf_cookie) {
					xhr.setRequestHeader('X-OneCRM-CSRF-Token', csrf_cookie[1]);
				}
			});
			this.on("success", function(file, response) {
				file.incoiming_id = response.files.file.id;
    			var files = emailWidgetDropzone.getFilesWithStatus(Dropzone.QUEUED);
				if (files.length) {
					dropzone.processQueue();
				}
			});
			this.on("addedfile", function(file) {
				file.previewElement.querySelector(".dz-delete").onclick = function() {
					dropzone.removeFile(file);
				};
			});
			this.on("queuecomplete", function() {
				SUGAR.ui.Status.remove(status);
    			var files = emailWidgetDropzone.getFilesWithStatus(Dropzone.ERROR);
				if (files.length) {
					return;
				}
				if (emailProcessDropzoneHandler) {
					emailProcessDropzoneHandler();
				}
			});
		}
	};
	var messages = app_list_strings('dropzone_messages');
	for (var k in messages) {
		Dropzone.options.emailDropzone[k] = messages[k];
	}
    Dropzone.autoDiscover = false;
	var elt = document.getElementById('email_dropzone');
	if (elt) {
		if (!elt.dropzone) {
			new Dropzone("#email_dropzone");
		}
	}
}


function addDropboxLink() {
	var dlg = new SUGAR.ui.Dialog("dropbox-chooser",
				{ width: "504px", destroy_on_close: true, title_text: mod_string('LBL_DROPBOX_CHOOSE_FILE'), resizable: false, content_id: 'dropbox-chooser-content' });
	dlg.fetchContent('async.php?module=Emails&action=DropboxChooser&type=link', {}, null, true);
}

function addDropboxFile() {
	var dlg = new SUGAR.ui.Dialog("dropbox-chooser",
				{ width: "504px", destroy_on_close: true, title_text: mod_string('LBL_DROPBOX_CHOOSE_FILE'), resizable: false, content_id: 'dropbox-chooser-content' });
	dlg.fetchContent('async.php?module=Emails&action=DropboxChooser&type=file', {}, null, true);

}

function insertDropboxLink(path, name) {	
	SUGAR.ui.PopupManager.close();
	var callback = function(a) {
		if (a.result.success) {
			var div = document.createElement('div');
			div.appendChild(document.createTextNode(a.result.url));
			var url = div.innerHTML;

			var div = document.createElement('div');
			div.appendChild(document.createTextNode(name));
			var n = div.innerHTML;

			insertHTML('<a href="' + url + '">' + n + '</a>');
		}
	}
	var args = new SUGAR.conn.FormArgs(true);
	args.append('path', path);
	var result = call_json_method(
		'Emails',
		'dropbox_create_link',
		args.getData(),
		'dropbox_result_'  ,
		callback
	);
}

function attachDropboxFile(path, name) {
	SUGAR.ui.PopupManager.close();
	for(var i=0; i<10; i++) {
		var elem = $('dropbox-outer'+i);
		if(! elem) {
			var tempFileInput = createElement2('input', {type:'hidden', name: 'dropbox_temp_file_' + i});
			var filenameInput = createElement2('input', {type:'hidden', name: 'dropbox_file_' + i});
			var loading = createElement2('img', {src: 'include/images/loading.gif'});
			var icon = createElement2('div',  {className: "theme-icon ticon-dropbox left"});
			var fileName = createElement2('span', {}, [document.createTextNode(name)]);
			var remove = createElement2('div', {className: 'uii uii-remove uii-lg active-icon'});
			remove.onclick = function() {
				SUGAR.ui.removeNode($('dropbox-outer'+i));
			}
			createElement2('div', {id: 'dropbox-outer'+i, style: 'padding-bottom: 0.3em'}, [tempFileInput, filenameInput, loading, nbsp(), icon, nbsp(), fileName, nbsp(), remove], $('uploads_div'));

			var args = new SUGAR.conn.FormArgs(true);
			args.append('path', path);
			var callback = function(a) {
				loading.style.display = 'none';
				if (!a.result.success) {
					fileName.style.color = '#F00';
					fileName.style.textDecoration = 'line-through';
				} else {
					tempFileInput.value = a.result.filename;
					filenameInput.value = name;
				}
			}
			var result = call_json_method(
				'Emails',
				'dropbox_download',
				args.getData(),
				'dropbox_result_' + i,
				callback
			);


			break;
		}
	}
}

function dropboxUpload() {
	for(var i=0; i<10; i++) {
		var elem = $('db_file'+i);
		if(! elem) {
			var inp = new SUGAR.ui.FileInput('db_file'+i, {name: 'db_attachment'+i});
			var upload = createElement2('button', {type: 'button', className: 'input-button'});
			upload.appendChild(document.createTextNode('Upload'));
			SUGAR.ui.registerInput('DetailForm', inp);
			var remove = createElement2('div', {className: 'input-icon icon-delete active-icon'});
			remove.onclick = function() {
				SUGAR.ui.removeNode($('file-outer'+i));
			}
			var div = createElement2('div', {id: 'dbfile-outer'+i, style: 'padding-bottom: 0.3em'}, [inp.render(),nbsp(),upload, nbsp(), remove], $('uploads_div'));
			inp.render().onchange = function () {
				var form = createElement2('form', {method: 'POST', action: 'async.php'}, [], document.body);
				form.appendChild(inp.render());
				SUGAR.ui.sendForm(form, {module: 'Emails', action : 'UploadToDropbox', slotIndex: i}, {resultDiv: div});
				return false;
			}
			inp.focus();
		  	break;
		}
	}
}

function navigateToDropdoxFolder(theForm, path) {
	var loadingStr = app_string('LBL_LOADING');
	SUGAR.ui.sendForm(theForm, {path: path}, {status_msg: loadingStr, resultDiv: 'dropbox-chooser-content'}, null, true);
}

function initWorkflowEmail(form) {
	var tpl = SUGAR.ui.getFormInput(form, 'template');
	var subj = SUGAR.ui.getFormInput(form, 'name');
	var body = SUGAR.ui.getFormInput(form, 'description_html');
	function getParentRow(e) {
		e = SUGAR.dom.extNode(e);
		e = e && e.get();
		while(e && !SUGAR.ui.hasClass(e, 'row')) {
			e = e.parentNode;
			if(e === window || e === document) e = null;
		}
		return e;
	}
	function toggleEmailBody() {
		var e = getParentRow(body.elt),
			s = getParentRow(subj.elt);
		if(e) toggleDisplay(e, tpl.getValue() == '');
		if(s) toggleDisplay(s, tpl.getValue() == '');
		SUGAR.popups.reposition();
	}
	if(tpl && subj && body) {
		tpl.onchange = toggleEmailBody;
		toggleEmailBody();
	}
}

