<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
if (!defined('inScheduler')) die('Unauthorized access');


 /*********************************************************************************
 * $Id: $
 ********************************************************************************/

    require_once 'include/database/PearDatabase.php';
    require_once('modules/EmailFolders/EmailFolder.php');

    global $log;
	global $db;

	$defs = array(
		'trash_cleanup_age' => array(),
		'inbox_cleanup_age' => array(
			'status' => array('received', 'archived',),
		),
		'sent_cleanup_age' => array(
			'status' => array('sent',),
		),
		'inbox_assoc_cleanup_age' => array(
			'status' => array('received', 'archived',),
			'assoc' => true,
		),
		'sent_assoc_cleanup_age' => array(
			'status' => array('sent',),
			'assoc' => true,
		),
	);

	$assoc = array(
		'accounts',
		'bugs',
		'cases',
		'contacts',
		'invoices',
		'leads',
		'opportunities',
		'project_tasks',
		'projects',
		'prospects',
		'quotes',
		'tasks',
		'users',
	);


	$date = gmdate('Y-m-d H:i:s');

    $lq = new ListQuery('User');
    $result = $lq->fetchAllRows('id'); 

	$noteModel = new ModelDef('Note');

	foreach ($result as $row) {
		$user = new User;
		$user->retrieve($row['id']);
		foreach ($defs as $name => $def) {
			$threshold = $user->getPreference($name);
			$m = array();
			if (!preg_match('/^([0-9]+)([dwmy])$/', $threshold, $m)) continue;
			switch ($m[2]) {
				case 'd' : $interval = $m[1] . ' days'; break;
				case 'w' : $interval = $m[1]*7 . ' days'; break;
				case 'm' : $interval = $m[1] . ' months'; break;
				case 'y' : $interval = $m[1] . ' years'; break;
			}
			
			$date_cut = date('Y-m-d H:i:s', strtotime($date. ' - '.$interval));

			if ($name == 'trash_cleanup_age') {
				$folder_id = EmailFolder::get_std_folder_id($user->id, STD_FOLDER_TRASH);

    			$query_emails = new ListQuery('Email');
    			$query_emails->addSimpleFilter('folder', $folder_id, '=');
    			$query_emails->addSimpleFilter('date_modified', $date_cut, '<=');
    			$emails_result = $query_emails->fetchAll();

    			$email_ids = '';
    			$i=0;
    			foreach($emails_result as $email) {
    				if($i!=0) $email_ids .= ',';
    				$email_ids .= "'".$email->getField('id')."'";
    				$i++;
    			}

    			$lq_notes = new ListQuery('Email', null, array('link_name' => 'notes'));
				$lq_notes->addSimpleFilter('parent_id', $email_ids, 'IN');
				$lq_notes->addSimpleFilter('email_attachment', 1, '=');
				$notes_result = $lq_notes->fetchAllRows('filename');

				foreach ($notes_result as $note) {
					if ((string)$note['filename'] !== '') {
						@unlink(AppConfig::upload_dir() . $note['filename']);
					}
					$db->deleteRow($noteModel, ['id' => $note['id']]);
				}

				if($email_ids != '') {
	    			$query = "DELETE FROM emails_bodies WHERE email_id IN ($email_ids)";
	    			$db->query($query, true, "Error cleaning trash: ");
	    			$query = "DELETE FROM emails WHERE id IN ($email_ids)";
	    			$db->query($query, true, "Error cleaning trash: ");
	    		}
			} else {
				$query_emails = new ListQuery('Email');
				if ($contact_id) $clause['multiple'][] = ['field' => 'contact_id', 'value' => $contact_id];
				$clause['multiple'] = array();
				foreach($defs as $def) {
					$clause['multiple'][] = ['field' => 'status', 'value' => $def['status']];
				}
				$query_emails->addFilterClause($clause);
    			$query_emails->addSimpleFilter('date_modified', $date_cut, '<=');
    			$query_emails->addSimpleFilter('assigned_user_id', $user->id, '=');
    			$emails_result = $query_emails->fetchAll();

    			$i=0;
    			foreach($emails_result as $email_del) {
    				if($i!=0) $email_ids .= ',';
    				$email_ids .= "'".$email->getField('id')."'";
    				$i++;
    			}

    			if($email_ids != '') {
    				$query = "DELETE FROM emails_bodies WHERE email_id IN ($email_ids)";
	    			$db->query($query, true, "Error cleaning trash: ");
	    			$query = "DELETE FROM emails WHERE id IN ($email_ids)";
	    			$db->query($query, true, "Error cleaning trash: ");

	    			$lq_notes = new ListQuery('Email', null, array('link_name' => 'notes'));
					$lq_notes->addSimpleFilter('parent_id', $email_ids, 'IN');
					$lq_notes->addSimpleFilter('email_attachment', 1, '=');
					$notes_result = $lq_notes->fetchAllRows('filename');

					foreach ($notes_result as $note) {
						if ((string)$note['filename'] !== '') {
							@unlink(AppConfig::upload_dir() . $note['filename']);
						}
					}

	    			if($name == 'assoc' && $def) {
	    				foreach($assoc as $link) {
	    					$query = "DELETE FROM emails_$link WHERE email_id IN ($email_ids)";
	    					$db->query($query, true, "Error cleaning trash: ");
	    				}
	    			}
    			}
			}
		}
	}

