<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */


require_once('include/layout/forms/FormField.php');

class EmailFolderWidget extends FormField {

	function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context) {
		if($gen->getLayout()->getType() == 'view')
			return $this->renderHtmlView($gen, $row_result, $parents, $context);
		return parent::renderHtml($gen, $row_result, $parents, $context);
	}
	
	function renderHtmlView(HtmlFormGenerator $gen, RowResult $row_result, array $parents, array $context) {
		$value = to_html($row_result->getField($this->name));
		$id = $row_result->getField('folder');
		$fuid = ListQuery::quick_fetch_row('EmailFolder', $id, array('user_id'));
		if(ACLController::checkAccess('Emails', 'list') && $id && $fuid) {
			$layout = ($fuid['user_id'] == '-1' ? 'Group' : 'Browse');
			$url = to_html('index.php?module=Emails&action=index&layout=' . $layout. '&folder=' . $id . '&query=true');
			$value = '<div class="input-icon theme-icon module-EmailFolders"></div>&nbsp;<a href="'.$url.'" onclick="return SUGAR.util.loadUrl(\''.$url.'\', null, true);" class="tabDetailViewDFLink">'.$value.'</a>';
		}
		return $value;
	}
	
	
}
?>