<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');


require_once('data/SugarBean.php');
require_once('include/utils.php');

class EventsCustomer extends SugarBean {
	// Stored fields
	var $id;
	var $deleted;
	var $date_entered;
	var $date_modified;
	var $modified_user_id;
	var $created_by;
	var $created_by_name;
	var $modified_by_name;
	var $session_id;
	var $customer_id;
	var $customer_type;
	var $registered;
	var $attended;

	var $table_name = "events_customers";

	var $object_name = "EventsCustomer";
	var $module_dir = 'EventsCustomers';
	var $new_schema = true;

	// This is used to retrieve related fields from form posts.
	var $additional_column_fields = Array();

	function get_summary_text()
	{
		return "$this->name";
	}

    static function get_set_registered_control($id, $value) {
        $html = EventsCustomer::get_status_control($id, $value, 'registered');

        return $html;
    }

    static function get_set_attended_control($id, $value) {
        $html = EventsCustomer::get_status_control($id, $value, 'attended');

        return $html;
    }

    static function get_status_control($id, $value, $status_field) {
        require_once('include/layout/forms/EditableForm.php');

        $url = 'async.php?module=EventsCustomers&action=SetStatus&cust_id='.$id.'&field='. $status_field;
        $field_id =  $status_field .'_'. $id;
        $onclick = "SUGAR.util.retrieveAndFill('".$url."', null, null, updatePanel, '{$field_id}');";

        $html = EditableForm::get_tag('input', array('type' => 'hidden', 'id' => $field_id.'-def', 'value' => 0), true);

        $attrs = ['class' => 'input-field input-check', 'id' => $field_id .'-input'];
        $html .= EditableForm::get_tag('div', $attrs);

        $attrs = ['type' => 'checkbox', 'id' => $field_id, 'onclick' => $onclick, 'value' => 1];
        if($value)
            $attrs['checked'] = 'checked';
        $html .= EditableForm::get_tag('input', $attrs, true);
        
        $html .= EditableForm::get_tag('label', ['for' => $field_id, 'class' => 'input-label'], true);
        $html .= '</div>';

        return $html;
    }
    
    static function before_save(RowUpdate $upd) {
		$reg = $upd->getField('registered');
		if($reg) {
			global $timedate;
			$dt_fmt = $timedate->get_db_date_time_format();
			$now = gmdate($dt_fmt);
			$today = explode(' ', $timedate->handle_offset($now, $dt_fmt, true), 2);
			$upd->set('registered_date', $today[0]);
		} else if(isset($reg)) {
			$upd->set('registered_date', null);
		}
    }
}

