<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

$model = new ModelDef('Forecast');
$fields = array('id', 'forecast', 'commit_date', 'quota', 'quota_date');

$upd = RowUpdate::for_model($model);
$upd->limitFields($fields);
$inputParams = $upd->getInput();

$lq = new ListQuery($model, true);
$lq->addPrimaryKey();
$lq->addAclFilter('edit');

if (! empty($_REQUEST['target'])) {
    $lq->addFilterPrimaryKey($_REQUEST['target']);
	$result = $lq->runQuerySingle();

    if($upd->setOriginal($result)) {
        global $timedate, $current_user;
        $update = array();

        $currency = ListQuery::quick_fetch_row('Currency', $current_user->getPreference('currency'), array('conversion_rate'));
        $conv_rate = 1;
        if (isset($currency['conversion_rate']))
            $conv_rate = $currency['conversion_rate'];

        if (! empty($_REQUEST['forecast'])) {
            //convert to Dollar
            $update['forecast'] = round(( unformat_number($_REQUEST['forecast']) / $conv_rate), 6);
            $update['commit_date'] = date($timedate->get_db_date_format());
        }
        if (! empty($_REQUEST['quota'])) {
            //convert to Dollar
			$update['quota'] = round(( unformat_number($_REQUEST['quota']) / $conv_rate), 6);
            $update['quota_date'] = date($timedate->get_db_date_format());
        }

        $upd->set($update);
        $upd->save();

		$period = $result->getField('start_date');
		$uid = $result->getField('user_id');
		require_once('modules/Forecasts/ForecastCalculator.php');
		$calc = new ForecastCalculator($period);
		$calc->update_user_team_forecasts($uid, $period);
    }
}

$params = array(
    'module' => 'Forecasts', 'action' => 'WorksheetView', 'record' => $_REQUEST['record'],
    'type' => $_REQUEST['type'], 'start_date' => $_REQUEST['period_start']);

if (! empty($_REQUEST['user_id']))
    $params['user_id'] = $_REQUEST['user_id'];

return array('perform', $params);
?>
