{*

/**
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 */



*}


<form name='UnifiedSearchAdvancedMain' action='index.php' method='post' class="form-outer panel-outer panel-border panel-default panel-round">
{$csrf_input}
<input type='hidden' name='module' value='Home'>
<input type='hidden' name='advanced' value='true'>
<input type='hidden' name='action' value='UnifiedSearch'>
<input type='hidden' name='search_form' value='false'>
<div class="form-body panel-header">
<div class="form-section">
	<div class="row form-row sm-unstack">
		<div class="column form-cell sm-6">
			<div class="row form-row">
				<div class="column form-cell">
					<div class="form-entry">
						<p class="form-label">{$MOD.LBL_SEARCH_TEXT}</p>
						<div class="form-value">
							{$search_input}
							<div class="text-center" style="margin-top: 0.8em">
								<label>{$PREFIX_MATCH}&nbsp;&nbsp;&nbsp;{$MOD.LBL_MATCH_PREFIX_ONLY}</label>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="row form-row">
				<div class="column form-cell align-bottom text-right">
					<div class="form-entry"><div class="form-value">
						<button type="submit" class="input-button"><span class="uii uii-md uii-accept"></span><span class="input-label"> {$APP.LBL_SEARCH}</span></button>
					</div></div>
				</div>
			</div>
		</div>
		<div class="column form-cell sm-6">
			<div class="form-entry">
				<p class="form-label">{$MOD.LBL_MODULES_TO_SEARCH}</p>
				<div class="form-value">{$MODULE_LIST}</div>
				<div class="buttons-inline" style="margin-top: 5px">
					<div class="inline-elt">
						<div class="uii uii-add active-icon uii-link" onclick="search_check_all(true);"><label>{$APP.LBL_CHECKALL}</label></div>
					</div>
					<div class="inline-elt">
						<div class="uii uii-remove active-icon uii-link" onclick="search_check_all(false);"><label>{$APP.LBL_CLEARALL}</label></div>
					</div>
					<div class="inline-elt">
						<div class="uii uii-cancel active-icon uii-link" onclick="search_reset()"'><label>{$MOD.LBL_DEFAULTS}</label></div>
					</div>
				</div>
			</div>
		</div>
	</div>
</div>
</div>
</form>
<br />

<script type="text/javascript">
	var search_defaults = {$default_mods};
	var search_all = {$all_mods};
{literal}
	function search_reset(state) {
		var form = SUGAR.ui.getForm('UnifiedSearchAdvancedMain'),
			modules = SUGAR.ui.getFormInput(form, 'module_list');
		if(modules) {
			modules.field.value = search_defaults.join('^,^');
			modules.initSelectedKeys();
		}
		var pfx = SUGAR.ui.getFormInput(form, 'prefix_match_only');
		if(pfx) pfx.setValue(0);
		var query = SUGAR.ui.getFormInput(form, 'query_string');
		if(query) query.setValue('');
	}
	function search_check_all(state) {
		var form = SUGAR.ui.getForm('UnifiedSearchAdvancedMain'),
			modules = SUGAR.ui.getFormInput(form, 'module_list'),
			val = state ? search_all : [];
		modules.field.value = val.join('^,^');
		modules.initSelectedKeys();
	}
{/literal}
</script>
