<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

if (AppConfig::is_mobile()) return;

require_once('include/layout/forms/EditableForm.php');

global $themeInstance, $pageInstance;

$edit_layout = false;
$dashlets_locked = AppConfig::setting('layout.lock_homepage');
$editing = '';
if(isset($_REQUEST['edit'])) {
	if($_REQUEST['edit'] == 'page' && ! $dashlets_locked) {
		$edit_layout = true;
		$editing = 'page';
	}
	else if($_REQUEST['edit'] == 'delete' && ! $dashlets_locked) {
		$delete_layout = true;
	}
}
$json = getJSONobj();

if(! $edit_layout)
	;//theme_hide_side_menu();
else
	$pageInstance->edit_layout = true;

if( ($dboard = $pageInstance->get_dashboard()) ) {
	if (!empty($_REQUEST['refresh_all_dashlets']) || !empty($GLOBALS['theme_changed'])) {
	}
	$columns = $dboard->process_dashlets($edit_layout);
	$widths = $dboard->column_widths;
	$can_edit = $dboard->user_can_edit();
} else {
	$columns = array();
	$can_edit = false;
}
if(! $columns)
	$columns = array(array('colClass' => ''), array('colClass' => ''));

if(! empty($delete_layout) && $can_edit) {
	$dboard->mark_deleted($dboard->id);
	header('Location: index.php');
	exit;
}

$t = $pageInstance->get_dashboard_title();
$editMenu = $pageMenu = '';
if(! $edit_layout) {
	$actions = array();
	if(! $dashlets_locked && $can_edit) {
		$actions['edit_page'] = array(
			'label' => $mod_strings['LBL_EDIT_LAYOUT'],
			'icon' => 'icon-editlayout',
			'url' => '?module=Home&action=index&edit=page&layout='.$pageInstance->dashboard_id,
		);
		$actions['edit_detail'] = array(
			'label' => $mod_strings['LBL_EDIT_DETAILS'],
			'icon' => 'icon-edit',
			'url' => '?module=Dashboard&action=EditView&record='.$pageInstance->dashboard_id.'&return_module=Home&return_action=index&return_layout='.$pageInstance->dashboard_id,
		);
		$actions['delete'] = array(
			'label' => $mod_strings['LBL_DELETE_DASHBOARD'],
			'icon' => 'icon-delete',
			'url' => '?module=Home&action=index&edit=delete&layout='.$pageInstance->dashboard_id,
			'confirm' => $mod_strings['NTC_CONFIRM_DELETE_DASHBOARD'],
		);
	} else {
		// need support for disabled menu items
		//$editMenu .= '<div class="menuItem">'.$mod_strings['LBL_CANNOT_EDIT'].'</div>';
	}
	$actions['create_page'] = array(
		'label' => $mod_strings['LBL_CREATE_DASHBOARD'],
		'icon' => 'theme-icon create-Dashboard',
		'url' => '?module=Dashboard&action=EditView&return_module=Dashboard&return_action=DetailView',
	);
	$actions['dupe_page'] = array(
		'label' => $mod_strings['LBL_DUPE_DASHBOARD'],
		'icon' => 'icon-duplicate',
		'url' => '?module=Dashboard&action=Duplicate&record='.$pageInstance->dashboard_id.'&return_module=Dashboard&return_action=DetailView',
	);
	
	foreach($actions as &$a) {
		$a['perform'] = "SUGAR.util.navigateTo('{$a['url']}', null, true); return false;";
		unset($a['url']);
	}
	$params = array(
		'options' => array('keys' => array_keys($actions), 'values' => array_values($actions), 'width' => '200px'),
		'icon_key' => 'icon',
		'label_key' => 'label',
	);
	
	if($themeInstance->classic_title) {
		$t .= '&nbsp;&nbsp;&nbsp;<button type="button" class="input-button muted menu-source" style="margin: -4px 0" id="dashboard-menu"><div class="input-arrow"><div class="input-icon icon-action"></div></div></button>';
		$params_js = $json->encode($params);
		$pageInstance->add_js_literal("SUGAR.ui.registerMenuSource('dashboard-menu', $params_js);", null, LOAD_PRIORITY_FOOT);
	} else {
		$pageInstance->set_tools_options($params['options']);
	}
	
	/*if(!using_grouped_tabs()) {
		$pages = $pageInstance->dmgr->get_dashboard_page_info();
		$pageMenu = '<div class="menu" id="select_page_menu">';
		foreach($pages as $grp => $pgList) {
			$grpName = array_get_default($app_strings, $grp, $grp);
			foreach($pgList as $pid => $pg) {
				$pageLink = 'index.php?module=Home&action=index&layout='.$pid;
				$icon = get_image($image_path . $pg['icon'], 'alt="" style="vertical-align: middle"');
				$pageMenu .= '<a href="'.$pageLink.'" onclick="SUGAR.popups.hidePopup();" onmouseover="SUGAR.popups.hiliteItem(this, true);" onmouseout="SUGAR.popups.unhiliteItem(this);" class="menuItem">'.$icon.'&nbsp;'.htmlspecialchars($pg['title'], ENT_QUOTES, 'UTF-8').'</a>';
			}
		}
		$pageMenu .= '</div>';
		$t .= '&nbsp;&nbsp;<button type="button" class="button" onclick="SUGAR.popups.showPopup(this, \'select_page_menu\', {below:1});" style="margin: -4px 0">'.$mod_strings['LBL_SELECT_PAGE_BUTTON_LABEL'].'</button>';
	}*/
}
else if(! $dashlets_locked && $can_edit)
	$pageInstance->add_edit_javascript(defined('ASYNC_ENTRY'));

echo '<div class="dashboardOuter">';

$icon = $pageInstance->get_dashboard_icon();
if($t) {
	echo $themeInstance->get_module_title($icon, $t, ! $edit_layout, true);
	echo $editMenu;
	echo $pageMenu;
}

$pageInstance->set_page_state(array('context' => 'dashboard', 'module' => 'Home', 'layout' => $pageInstance->dashboard_id));

if(isset($widths)) $widths_json = $json->encode($widths);
else $widths_json = 'null';

$edit_flag = $edit_layout ? 1 : 0;
$script = ["
	SUGAR.session.dashboard_id='{$pageInstance->dashboard_id}';
	SUGAR.session.dashboard_edit={$edit_flag};
	SUGAR.session.dashboard_widths={$widths_json};
"];

if($edit_layout) {
	$buttons = [
		[
			'type' => 'button', 'class' => 'input-button', 'id' => 'finish_edit',
			'onclick' => 'document.location.replace("?module=Home&action=index&layout='.$pageInstance->dashboard_id.'");',
			'icon' => 'input-icon icon-accept',
			'label' => $mod_strings['LBL_FINISH_EDIT'],
		],
		[
			'type' => 'button', 'class' => 'input-button', 'id' => 'add_dashlets',
			'onclick' => 'return SUGAR.sugarHome.showDashletsPopup();',
			'icon' => 'input-icon icon-add',
			'label' => $mod_strings['LBL_ADD_DASHLETS'],
		],
		[
			'type' => 'button', 'class' => 'input-button rbullet rbullet-ddown', 'id' => 'set_columns',
			'icon' => 'input-icon icon-layout',
			'label' => $mod_strings['LBL_SET_COLUMNS'],
		]
	];
	echo '<div class="buttons-inline">';
	foreach($buttons as $b) {
		echo '<div class="inline-elt">';
		echo EditableForm::render_button($b);
		echo '</div>';
	}
	echo '</div>';
}

$outer_cls = $edit_layout ? 'edit-layout' : '';
echo "<main class=\"dashboard-outer {$outer_cls}\" id=\"dashboard_columns\">";
echo "<div class=\"row dashboard-row md-unstack\">";
foreach($columns as $colNum => $data) {
	echo "<div class=\"column dashboard-column {$data['colClass']}\" id=\"dash-col-{$colNum}\">";
	foreach($data['dashlets'] as $id => $dashlet) {
		echo "<section id=\"dashlet-{$id}\" class=\"dashlet-section\">";
		$script[] = "SUGAR.sugarHome.setDashletWidth('{$id}', '{$data['width']}');";
		if(! empty($dashlet['script']))
			echo $dashlet['script'];
		echo $dashlet['display'];
		echo '</section>';
	}
	echo '</div>';
}
echo '</div>';
echo '</main>';

if($edit_layout)
	$script[] = "SUGAR.onDomLoad(function() { SUGAR.sugarHome.initEdit(); });";

if($script)
	$pageInstance->add_js_literal(implode("\n", $script), null, LOAD_PRIORITY_FOOT);

echo '</div>'; // dashboardOuter


?>
