<?php return; /* no output */ ?>

detail
	type: union
	primary_key: id
	default_order_by: name
	reportable: true
fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
	query_module
		type: module_name
		vname: LBL_MODULE
		source
			type: module_name
		options
			- Contacts
			- Users
            - Leads
	accept_status
		type: varchar
		vname: LBL_ACCEPT_STATUS
		vname_module: Meetings
		union_source
			contacts: ~join.accept_status
			users: ~join.accept_status
            leads: ~join.accept_status
	primary_account
		type: ref
		bean_name: Account
		vname: LBL_PRIMARY_ACCOUNT
		vname_module: Contacts
		width: 25
	primary_account_id
		type: id
		union_source
			users
				name: primary_account_id
				source
					type: static
					value: ""
	name
		type: name
		vname: LBL_NAME
		vname_list: LBL_LIST_NAME
		vname_module: Contacts
		width: 40
		dynamic_module: query_module
		union_source
			contacts: name
			users: full_name
		unified_search: true
	first_name
		type: varchar
		vname: LBL_FIRST_NAME
		vname_module: Contacts
	last_name
		type: varchar
		vname: LBL_LAST_NAME
		vname_module: Contacts
	salutation
		type: varchar
		vname: LBL_SALUTATION
		vname_module: Contacts
	email1
		type: email
		vname: LBL_EMAIL_ADDRESS
		unified_search: true
		vname_module: Contacts
	email2
		type: email
		vname: LBL_ALT_EMAIL_ADDRESS
		vname_module: Contacts
	phone_work
		type: phone
		vname: LBL_OFFICE_PHONE
		vname_list: LBL_PHONE
		vname_module: Contacts
		unified_search: true
	phone_home
		type: phone
		vname: LBL_HOME_PHONE
		vname_module: Contacts
		unified_search: true
	phone_mobile
		type: phone
		vname: LBL_MOBILE_PHONE
		vname_module: Contacts
		unified_search: true
	phone_other
		type: phone
		vname: LBL_OTHER_PHONE
		vname_module: Contacts
	phone_fax
		type: fax
		vname: LBL_FAX_PHONE
		vname_module: Contacts
	receive_notifications
		type: bool
		union_source
			contacts
				name: receive_notifications
				type: bool
				source
					type: static
					value: 1
            leads
                name: receive_notifications
                type: bool
                source
                    type: static
                    value: 1
	email_opt_out
		type: bool
		union_source
			users
				name: email_opt_out
				type: bool
				source
					type: static
					value: 0
	invalid_email
		type: bool
		union_source
			users
				name: invalid_email
				type: bool
				source
					type: static
					value: 0
sources
	contacts
		model: Contact
	users
		model: User
		filters
			--
				field: status
				value: Active
			--
				field: portal_only
				value: 0
    leads
        model: Lead
relationships
	meetings_invitees
		target_bean: Meeting
		target_key: id
		sources
			contacts
				relationship: meetings_contacts
			users
				relationship: meetings_users
            leads
                relationship: meetings_leads
	calls_invitees
		target_bean: Call
		target_key: id
		sources
			contacts
				relationship: calls_contacts
			users
				relationship: calls_users
            leads
                relationship: calls_leads
