KBTagsFilter = new function()
{
	this.cache = {};

	this.displayTagsFilter = function(form)
	{
		this.form = form;
		this.dialog = new SUGAR.ui.Dialog('kbTagsDlg', {title: SUGAR.language.get('KBArticles', 'LBL_TAGS_FILTER'), width:'400px'});
		var vars = {module: 'KBArticles', action: 'TagsFilter', in_popup: 'true'};
		vars.include_tags = form.include_tags.value;
		vars.exclude_tags = form.exclude_tags.value;
		this.dialog.fetchFormContent(form, vars, {url: 'async.php'}, null, true);
		return false;
	};

	this.applyFilter = function(srcForm)
	{
		var incl_input = SUGAR.ui.getFormInput(srcForm, 'kb_tags_include');
		var include = incl_input.tags_field.value;
		var excl_input = SUGAR.ui.getFormInput(srcForm, 'kb_tags_exclude');
		var exclude = excl_input.tags_field.value;
		this.form.include_tags.value = include;
		this.form.exclude_tags.value = exclude;
		this.dialog.hide();
		this.dialog.destroy();
		SUGAR.ui.submitForm(this.form);
	};

	this.cancel = function()
	{
		this.dialog.hide();
		this.dialog.destroy();
	};

	this.cachePopupContent = function()
	{
		KBTagsFilter.cache.popupContent = KBTagsFilter.dlg.getContentElement().innerHTML;
	};

	this.cacheValid = function(form)
	{
		var ret =  
				this.cache.include_tags == form.include_tags.value
			&&	this.cache.exclude_tags == form.exclude_tags.value
			&&	this.cache.popupContent != undefined
		;
		return ret;
	};

}();

KBTagsAutocomplete = function() {
	this.init = function(container, id, name, allow_new, tags)
	{
		var attrs = {id: id, name: name, tags: tags, allow_add: allow_new};
	    var input = new SUGAR.ui.TagsInput(id, attrs);
		var e = input.render();
		$(container).appendChild(e);
		var form = document.forms.DetailForm;
	    if(form) SUGAR.ui.registerInput(form, input);
    	return input.elt;
	};

};

function KBInitListOrder(form, inputName, categories) {
	var input = SUGAR.ui.getFormInput(form, inputName);
	var select = SUGAR.ui.getFormInput(form, '_order_after');
	if (input && select) {
		SUGAR.ui.attachInputEvent(input, 'onchange', function(id) {
			var req = new SUGAR.conn.JSONRequest('kb_get_order_list', null, {module: 'KBArticles', category_id : id, categories: categories});
			req.fetch(function() {
				var current = select.getValue();
				var result = this.getResult();
				var opts = {
					keys: result.map(function(r) {return r['id'];}),
					values: result.map(function(r) {return r['name'];}),
					width: 300
				};
				select.setOptions(new SUGAR.ui.SelectOptions(opts));
				if (!~opts.keys.indexOf(current)) {
					select.setValue(opts.keys[opts.keys.length - 1]);
				}
			});
		});
	}
}

