<?php

require_once('include/layout/forms/FormField.php');

class KBDisplayOrderWidget extends FormField {

	function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context) {
		$model = $row_result->getModelName();

		if ($model == 'KBArticle') $field = 'category_id';
		else $field = 'parent_id';

		$id = $row_result->getField('id');
		$category_id = $row_result->getField($field);
		$order = (int)$row_result->getField('display_order');
		$lq = new ListQuery($model);
		if ($category_id)
			$lq->addSimpleFilter($field, $category_id);
		else
			$lq->addSimpleFilter($field, '', 'empty');
		$rows = $lq->fetchAllRows('display_order, name');
		$selected = '';
		$options = ['' => translate('LBL_ORDER_BEGINNING', 'KBArticles')];
		$last = '';
		foreach ($rows as $row) {
			if ($row['id'] == $id) {
				$selected = $last;
				continue;
			}
			$last = $row['id'];
			$options[$row['id']] = $row['name'];
		}
		$def = [
			'type' => 'enum',
			'name' => '_order_after',
			'options' => $options,
		];
		$value = $gen->form_obj->renderSelect($def, $selected);
		return $value;
	}
	
	function loadUpdateRequest(RowUpdate $update, array $input) {
		$update->setRelatedData('_order_after', $input['_order_after']);
	}

	function beforeUpdate(RowUpdate $update) {
		$model = $update->getModelName();
		if ($model == 'KBArticle') $field = 'category_id';
		else $field = 'parent_id';
		$order = 0;
		$name = '';
		$after_id = $update->getRelatedData('_order_after');
		$category_id = $update->getField($field);
		if ($after_id) {
			$after = ListQuery::quick_fetch_row($model, $after_id);
			if ($after) {
				$order = (int)$after['display_order'] ;
				$name = $after['name'];
			}
		}
		$update->set('display_order', $order + 1);
		$update->setRelatedData('_order', $order);
		$update->setRelatedData('_order_name', $name);
	}

	function afterUpdate(RowUpdate $update) {
		global $db;
		$model = $update->getModelName();
		$table = $update->getTableName();
		if ($model == 'KBArticle') $field = 'category_id';
		else $field = 'parent_id';
		$id = $db->quote($update->getField('id'));
		$category_id = $db->quote($update->getField('category_id'));
		$order = $update->getRelatedData('_order');
		$name = $db->quote($update->getRelatedData('_order_name'));
		$query = "UPDATE $table SET display_order = IFNULL(display_order, 0) + 2 WHERE id != '$id' AND IFNULL($field, '') ='$category_id' AND (IFNULL(display_order, 0) > $order OR ( display_order = $order AND name > '$name' ))";
		$GLOBALS['log']->fatal($query);
		$db->query($query);
	}
}

