<?php

require_once('include/layout/forms/FormField.php');

class ReferenceSlugs extends FormField {

	function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context) {
		global $db; 

		if(empty($this->name) || $this->missing_field || ! $row_result)
			return '';
		if($this->getEditable($context))
			$value = $this->standardRenderEdit($gen->getFormObject(), $row_result, $parents, $context);
		else
			$value = $this->standardRenderView($row_result, $parents, $context);


		$detailview = false;
		
		if(!$this->getEditable($context)) {
			$value = str_replace("<onecrm:","<onecrm_",$value);
			$value = str_replace("</onecrm:","</onecrm_",$value);
			$detailview = true;
		}

		if($value != '' && $detailview) {
			$doc = new DOMDocument();
			libxml_use_internal_errors(true);
			$doc->loadHTML('<?xml encoding="utf-8" ?><div>' . $value . '</div>');

			$nodes = [];
			$result = $doc->getElementsByTagName('onecrm_article');
			foreach ($result as $node) {
				$nodes[] = $node;
			}

			foreach ($nodes as $node) {
				$id = $node->getAttribute('id');

				$article = ListQuery::quick_fetch('KBArticle', $id);

				if($article) {
					$new_node = new DOMElement('a');
					$node->parentNode->replaceChild($new_node, $node);
					$new_node->setAttribute('class', 'listViewNameLink');
					$new_node->setAttribute('href', '?module=KBArticles&action=DetailView&record=' . $id);
					foreach ($node->childNodes as $c) {
						$new_node->appendChild($c);
					}
				}
			}

			$nodes = [];
			$result = $doc->getElementsByTagName('onecrm_category');
			foreach ($result as $node) {
				$nodes[] = $node;
			}

			foreach($nodes as $node) {
				$id = $node->getAttribute('id');

				$category = ListQuery::quick_fetch('KBCategory', $id);

				if($category) {

					$new_node = new DOMElement('a');
					$node->parentNode->replaceChild($new_node, $node);
					$new_node->setAttribute('class', 'listViewNameLink');
					$new_node->setAttribute('href', '?module=KBCategories&action=DetailView&record=' . $id);
					foreach ($node->childNodes as $c) {
						$new_node->appendChild($c);
					}
				}
			}
			$value = $doc->saveHTML();
		}
		return $value;
	}
}

?>
