<?php

global $timedate, $current_user;
$now = gmdate($timedate->get_db_date_time_format());
//$now = $timedate->handle_offset($now_dt, $timedate->get_db_date_time_format(), true);
$user = ListQuery::quick_fetch_row('User', AppConfig::current_user_id(), array('id', '_display'));

$defs = array(
	'varchar' => '• Testing varchar •',
	'char' => 'Testing char',
	'id' => $user['id'],
	//'name' => 'Record name',
	'ref' => array(
		'value' => $user['_display'],
		'id_name' => 'id',
		'bean_name' => 'User',
	),
	'enum' => array(
		'options' => 'case_priority_dom',
		'value' => 'P2',
	),
	'multienum' => array(
		'options' => 'case_priority_dom',
		'value' => 'P2^,^P3',
	),
	'status' => array(
		'options' => 'booked_hours_status_dom',
		'value' => 'draft',
	),
	'module_name' => 'Invoice',
	//'user_name' => $user['_display'],
	'date' => explode(' ', $now)[0],
	'time' => explode(' ', $now)[1],
	'datetime' => $now,
	'duration' => 1000,
	'bool' => 1,
	'number' => 1234,
	'int' => 5,
	'float' => 10.5,
	'currency' => 123.45,
	'base_currency' => 123.45,
	'raw_currency' => 123.45,
	'double' => 10.5,
	'percentage' => 45,
	'rate_percent' => 90,
	'progress' => 40,
	'star_rating' => 3.5,
	'text' => "Etc\netc\netc",
	'blob' => '25i92i5o2kag',
	'html' => array(
		'height' => 5,
		'value' => '<b>Test</b><br>Test',
	),
	'phone' => '613-737-1111',
	'extension_number' => '12',
	'fax' => '613-737-1111',
	'skype' => '+1-613-737-1111',
	'email' => 'test@example.com',
	'url' => 'http://1crm.com',
	'sequence_prefix' => 'TEST-',
	'sequence_number' => '1000',
	'item_number' => 'TEST-1000',
	'email_recips' => 'a@b.ca',
	'file_ref' => array(
		'upload_dir' => 'include/images/iah/',
		'value' => '1crm-top.png',
	),
	'file_size' => 12345,
	'image' => array(
		'store_full_path' => true,
		'filename' => 'image_file',
	),
	'color' => '#2e95a9',
);

$fields = $values = $rendered = array();
$values['image_file'] = 'include/images/iah/1crm-top.png';
$supported = AppConfig::setting('model.supported_types');
foreach($defs as $k => $d) {
	if(is_array($d)) {
		$d['name'] = $k;
		$d['type'] = $k;
		$values[$k] = array_get_default($d, 'value');
		unset($d['value']);
		$fields[$k] = $d;
	} else {
		$fields[$k] = array('name' => $k, 'type' => $k);
		$values[$k] = $d;
	}
	if(isset($supported[$k])) {
		$fields[$k] = array_merge($supported[$k], $fields[$k]);
	}
}

$result = new RowResult();
require_once('include/layout/FieldFormatter.php');
$edit_fmt = new FieldFormatter('html', 'editview');
$detail_fmt = new FieldFormatter('html', 'view');
$list_fmt = new FieldFormatter('html', 'listview');
$json_fmt = new FieldFormatter('json');
$pdf_fmt = new FieldFormatter('pdf');
$email_fmt = new FieldFormatter('html', 'email');
$result->fields = $fields;
$result->row = $values;
$detail_row = $detail_fmt->formatRowResult($result);
$list_row = $list_fmt->formatRowResult($result);
$json_row = $json_fmt->formatRowResult($result);
$pdf_row = $pdf_fmt->formatRowResult($result);
$email_row = $email_fmt->formatRowResult($result);
$edit_fmt->formatRowResult($result);

require_once('include/layout/forms/EditableForm.php');
$frm = new EditableForm('editview', 'EditForm');

echo $frm->open();
echo '<div class="panel-outer panel-default panel-border">';
echo '<div class="panel-body panel-pad-body scroll">';
echo '<table cellpadding="0" cellspacing="2" border="0">';
echo '<tr>';
echo '<th class="dataLabel"><b>Type</b></th>';
echo '<th class="dataLabel"><b>List value</b></th>';
echo '<th class="dataLabel"><b>Detail value</b></th>';
echo '<th class="dataLabel"><b>Non-editable</b></th>';
echo '<th class="dataLabel"><b>Email</b></th>';
echo '<th class="dataLabel"><b>JSON</b></th>';
echo '<th class="dataLabel"><b>PDF</b></th>';
echo '<th class="dataLabel"><b>Editable</b></th>';
echo '</tr>';
$json = getJSONobj();
foreach($fields as $k => $def) {
	echo '<tr>';
	$label = translate_dd('field_type_dom', $k);
	echo '<td class="dataLabel">' . $label . '</td>';
	echo '<td class="dataField">' . array_get_default($list_row, $k) . '</td>';
	echo '<td class="dataField">' . array_get_default($detail_row, $k) . '</td>';
	echo '<td class="dataField">' . array_get_default($result->formatted, $k) . '</td>';
	echo '<td class="dataField">' . array_get_default($email_row, $k) . '</td>';
	echo '<td class="dataField">' . to_html($json->encode(array_get_default($json_row, $k))) . '</td>';
	echo '<td class="dataField">' . nl2br(to_html(array_get_default($pdf_row, $k))) . '</td>';
	echo '<td class="dataField">';
	if(array_get_default($def, 'editable', true))
		echo $frm->renderField($result, $k);
	else
		echo array_get_default($result->formatted, $k);
	echo '</td>';
	echo '</tr>';
}
echo '</table>';
echo '</div>';
echo '</div>';
echo $frm->close();

$frm->exportIncludes();

