<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

$as = get_user_array();
$uid = AppConfig::current_user_id();
foreach($as as $idx => $a) {
	if($idx && $idx != $uid) {
		$uid = $idx;
		break;
	}
}


$msgs = array();
$msgs[] = array(
	'subject' => '(1CRM) Assigned Account: Apple Inc.',
	'title' => '<a href="index.php?module=Users">Andrew Whitehead</a> (awhitehead) has assigned 2 records to you',
	'rows' => array(
		array(
			'records' => array(
				array(
					'name' => '<img src="themes/Default/images32/Accounts.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Accounts">Apple Inc.</a>',
					'props' => array(
						array(
							'name' => 'Account Type:',
							'value' => 'Supplier',
						),
						array(
							'name' => 'Industry:',
							'value' => 'Technology',
						),
						array(
							'name' => 'Primary Contact:',
							'value' => '<img src="themes/Default/images32/Contacts.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Contacts">Tim Cook</a>',
						),
					),
				),
				array(
					'name' => '<img src="themes/Default/images32/Accounts.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Accounts">1CRM Corp.</a>',
					'props' => array(
						array(
							'name' => 'Account Type:',
							'value' => 'Partner',
						),
						array(
							'name' => 'Industry:',
							'value' => 'Entertainment',
						),
						array(
							'name' => 'Primary Contact:',
							'value' => '<img src="themes/Default/images32/Contacts.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Contacts">Michael Whitehead</a>',
						),
					),
				),
			),
		),
	),
);

$msgs[] = array(
	'subject' => '(1CRM) Approved Timesheet: 2016-05 Andrew Whitehead',
	'title' => 'Your timesheet has been approved by <a href="index.php?module=Users">Michael Whitehead</a> (mwhitehead)',
	'rows' => array(
		array(
			'head' => 'Header text goes here',
			'records' => array(
				array(
					'name' => '<img src="themes/Default/images32/Timesheets.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Timesheets">2016-05 Andrew Whitehead</a>',
					'props' => array(
						array(
							'name' => 'Start Date:',
							'value' => '2016-01-01',
						),
						array(
							'name' => 'Total Hours:',
							'value' => 22.0,
						),
					),
				),
			),
			'buttons' => array(
				array(
					'label' => 'View Record',
					'url' => 'index.php?module=Timesheets',
				),
				array(
					'label' => 'Edit Record',
					'url' => 'index.php?module=Timesheets',
				),
			),
		),
	),
);


$msgs[] = array(
	'subject' => '(1CRM) Meeting: Discuss sales numbers (2016-01-01 11:00am)',
	'title' => 'You have been invited to a meeting held by <a href="index.php?module=Users">Michael Whitehead</a> (mwhitehead)',
	'rows' => array(
		array(
			'records' => array(
				array(
					'name' => '<img src="themes/Default/images32/Meetings.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Meetings">Discuss sales numbers</a>',
					'props' => array(
						array(
							'name' => 'Start Time:',
							'value' => '2016-01-01 11:00am',
						),
						array(
							'name' => 'Duration:',
							'value' => '30 minutes',
						),
					),
				),
			),
			'buttons' => array(
				array(
					'label' => 'Decline',
					'url' => 'index.php?module=Meetings',
				),
				array(
					'label' => 'Tentative',
					'url' => 'index.php?module=Meetings',
				),
				array(
					'label' => 'Accept',
					'url' => 'index.php?module=Meetings',
				),
			),
		),
	),
	// vcal attachment!
);


$msgs[] = array(
	'subject' => '(1CRM) Rescheduled: Discuss sales numbers (2016-01-01 11:00am)',
	'title' => 'A meeting held by <a href="index.php?module=Users">Michael Whitehead</a> (mwhitehead) has been rescheduled',
	'rows' => array(
		array(
			'records' => array(
				array(
					'name' => '<img src="themes/Default/images32/Meetings.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Meetings">Discuss sales numbers</a>',
					'props' => array(
						array(
							'name' => 'Original Start Time:',
							'value' => '2016-01-01 11:00am',
						),
						array(
							'name' => 'New Start Time:',
							'value' => '2016-01-01 12:00am',
						),
						array(
							'name' => 'Duration:',
							'value' => '30 minutes',
						),
					),
				),
			),
		),
	),
	// vcal attachment!
);


$test = array_get_default($_REQUEST, 'test');
require_once('include/Notify/RecordActionMessage.php');

if($test == 'survey') {
	$msgs = array();
	$msg = RecordActionMessage::for_action('aCase', 'survey');
	if($msg) {
		$target = array('bean_name' => 'Contact', 'id' => 'test-contact', 'name' => 'Test Contact');
		$lq = new ListQuery('aCase', array('id'), true, array('acl_filters' => 'view'));
		$r = $lq->runQuery(0, 1);
		if($r->getResultCount()) {
			$ids = array_column($r->rows, 'id');
			$msg->addRecordIds($ids);
			$msgs[] = $msg;
		}
	}
}
else if($test == 'invite' || $test == 'email') {
	$msgs = array();
	$msg = RecordActionMessage::for_action('Meeting', 'invited', $uid);
	if($msg) {
		$target = array('bean_name' => 'Contact', 'id' => 'test-contact', 'name' => 'Test Contact');
		$lq = new ListQuery('Meeting', array('id'), true, array('acl_filters' => 'view'));
		$r = $lq->runQuery(0, 1);
		if($r->getResultCount()) {
			$ids = array_column($r->rows, 'id');
			$msg->addRecordIds($ids);
			$msgs[] = $msg;
		}
	}
}
else if($test == 'case_create') {
	$msgs = array();
	$msg = RecordActionMessage::for_action('aCase', 'created');
	if($msg) {
		$target = array('bean_name' => 'Contact', 'id' => 'test-contact', 'name' => 'Test Contact');
		$lq = new ListQuery('aCase', array('id'), true, array('acl_filters' => 'view'));
		$r = $lq->runQuery(0, 1);
		if($r->getResultCount()) {
			$ids = array_column($r->rows, 'id');
			$msg->addRecordIds($ids);
			$msgs[] = $msg;
		}
	}
}
else if($test == 'report') {
	$msgs = array();
	$msg = RecordActionMessage::for_action('ReportData', 'report');
	if($msg) {
		$target = array('bean_name' => 'Contact', 'id' => 'test-contact', 'name' => 'Test Contact');
		$lq = new ListQuery('ReportData', array('id'), true, array('acl_filters' => 'view'));
		$r = $lq->runQuery(0, 1);
		if($r->getResultCount()) {
			$ids = array_column($r->rows, 'id');
			$msg->addRecordIds($ids);
			$msgs[] = $msg;
		}
	}
}
else if($test == 'rows') {
	// test multiple message rows
	$msgs = [array(
		'subject' => '(1CRM) Rescheduled: Discuss sales numbers (2016-01-01 11:00am)',
		'title' => 'A meeting held by <a href="index.php?module=Users">Michael Whitehead</a> (mwhitehead) has been rescheduled',
		'rows' => array(
			array(
				'records' => array(
					array(
						'name' => '<img src="themes/Default/images32/Meetings.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Meetings">Discuss sales numbers</a>',
						'props' => array(
							array(
								'name' => 'Original Start Time:',
								'value' => '2016-01-01 11:00am',
							),
							array(
								'name' => 'New Start Time:',
								'value' => '2016-01-01 12:00am',
							),
							array(
								'name' => 'Duration:',
								'value' => '30 minutes',
							),
						),
					),
				),
			),
			array(
				'records' => array(
					array(
						'name' => '<img src="themes/Default/images32/Meetings.png" width="16" height="16" style="vertical-align: text-bottom"> <a href="index.php?module=Meetings">Discuss sales numbers</a>',
						'props' => array(
							array(
								'name' => 'Original Start Time:',
								'value' => '2016-01-01 11:00am',
							),
							array(
								'name' => 'New Start Time:',
								'value' => '2016-01-01 12:00am',
							),
							array(
								'name' => 'Duration:',
								'value' => '30 minutes',
							),
						),
					),
				),
			),
		),
		// vcal attachment!
	)];
}

else if(1) {
	// test assigned record templates
	$msgs = array();
	$mods = AppConfig::setting('modinfo.index.all');
	foreach($mods as $m) {
		$bean = AppConfig::module_primary_bean($m);
		if($bean) {
			$msg = RecordActionMessage::for_action($bean, 'assigned', $uid);
			if($msg) {
				$lq = new ListQuery($bean, array('id'), true, array('acl_filters' => 'view'));
				$r = $lq->runQuery(0, 2);
				if($r->getResultCount()) {
					$ids = array_column($r->rows, 'id');
					$msg->addRecordIds($ids);
					$msgs[] = $msg;
				}
			}
		}
	}
}

if(0) {
	$target = get_user_info($uid);
	$target['bean_name'] = 'User';
}

if(0 && $current_user->email1) {
	require_once('include/Notify/NotifyMailer.php');
	$mailer = new NotifyMailer();
	$mailer->addTargetId('User', $current_user->id, array('name' => 'Test'));
	$mailer->sendMessages($msgs);
	pr2('message sent');
}
else {
	require_once('include/Notify/NotifyFormatter.php');
	$fmt = NotifyFormatter::create_standalone(true);
	if($test == 'survey' || $test == 'email') {
		$fmt = NotifyFormatter::create_standard();
		$fmt->setAttachImages(false);
		$fmt->setExternal(true);
	}
	if(! empty($target))
		$fmt->setTarget($target);
	$text_format = array_get_default($_REQUEST, 'text');
	$subject = null;
	if($text_format || $test == 'email') {
		$text = $fmt->renderMessagesText($msgs);
		$body = $text;
	}
	if(! $text_format) {
		$html = $fmt->renderMessages($msgs);
		$body = $html;
		if($msgs && is_object($msgs[0])) {
			$subject = $msgs[0]->getMessageSubject($fmt);
			$pfx = $msgs[0]->getPrefixSubject();
			if(! isset($pfx) || $pfx)
				$subject = $fmt->translate('LBL_SUBJECT_PREFIX') . ' ' . $subject;
		}
	}
	if($text_format) {
		header('Content-type: text/plain');
		echo $body;
		exit;
	}
	else if($test == 'email') {
		echo '<textarea class="input-text input-block" rows="20">' . to_html($text) . '</textarea>';
		echo '<textarea class="input-text input-block" rows="20" style="margin-top: 1em">' . to_html($body) . '</textarea>';
		echo '<div style="margin-top: 1em">' . $body . '</div>';
		exit;
	}
	else {
		if($subject) pr2($subject);
		echo $body;
		exit;
	}
}

