<?php

class InitialLeadguerrillaPush {

	function process() {
		$sync_objects = AppConfig::setting('lead_guerrilla.contacts');
		$filters = ['Contact' => null, 'Lead' => null];
		switch ($sync_objects) {
		case 'both':
			$models = ['Lead', 'Contact'];
			$filters['Lead'] = ['field' => 'contact_id', 'value' => null, 'operator' => 'NOT'];
			break;
		case 'contacts':
			$models = ['Contact'];
			break;
		default:
			$models = ['Lead'];
			break;
		}

		global $db;
		$total = AppConfig::setting('lead_guerrilla.initial_push_total');
		$done_count = AppConfig::setting('lead_guerrilla.initial_push_count', 0);
		if (!is_numeric($total)) {
			$total = 0;
			foreach ($models as $model) {
				$lq = new ListQuery($model);
				$lq->addSimpleFilter('mautic_id', null, 'NOT');
				if (!empty($filters[$model]))
					$lq->addFilterClause($filters[$model]);
				$sql = $lq->getSql(false, true);
				$r = $db->query($sql, false);
				$row = $db->fetchByAssoc($r);
				$total += $row['c'];
			}
			AppConfig::set_local('lead_guerrilla.initial_push_total', $total);
			AppConfig::save_local();
		}


		foreach ($models as $model) {
			$since = AppConfig::setting('lead_guerrilla.initial_push_date_' . $model);
			list($date, $finished, $count) = $this->processModel($model, $since, $filters[$model]);
			$done_count += $count;
			AppConfig::set_local('lead_guerrilla.initial_push_date_' . $model, $date);
			if (!$finished)
				break;
		}
		AppConfig::set_local('lead_guerrilla.initial_push_count', $done_count);
		if ($finished) {
			AppConfig::set_local('lead_guerrilla.initial_push_finished', true);
		}
		AppConfig::save_local();
	}

	function processModel($model, $since = null, $extra_filters = null) {
		$count = 0;
		$lq = new ListQuery($model);
		$lq->addColumnFields();
		$lq->addField('primary_account');
		$lq->addSimpleFilter('mautic_id', null, 'NOT');
		if ($since) {
			$lq->addSimpleFilter('date_entered', $since, 'gte');
		}
		if ($extra_filters)
			$lq->addFilterClause($extra_filters);
		$lq->setOrderBy('date_entered');
		$res = $lq->runQuery(0, null, true, null, 100);
		$date = $since;
		foreach ($res->rows as $row_idx => $row) {
			$row_result = $res->getRowResult($row_idx);
			$upd = RowUpdate::for_result($row_result);
			$upd->update_date_modified = false;
			$upd->prohibit_workflow = true;
			$upd->save();
			$date = $upd->getField('date_entered');
			if ($upd->getField('mautic_id'))
				$count++;
		}
		return [$date, $res->page_finished, $count];
	}

	function countModels($model, $extra_filters = null) {
	}
}


function initial_leadguerrilla_push() {
	if (!AppConfig::setting('lead_guerrilla.initial_push') || !AppConfig::setting('lead_guerrilla.enabled'))
		return;
	define('LEAD_GUERRILLA_INITIAL_PUSH', true);
	$process = new InitialLeadguerrillaPush();
	$process->process();
	define('LEAD_GUERRILLA_INITIAL_PUSH_DONE', true);
}


