<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/Leads/Lead.php
	audit_enabled: true
	activity_log_enabled: true
	unified_search: true
	duplicate_merge: true
	optimistic_locking: true
	comment: Leads are persons of interest early in a sales cycle
	table_name: leads
	primary_key: id
	default_order_by: date_entered DESC
	importable: LBL_LEADS
	reportable: true
	record_status: status
	personal_data: true
hooks
	new_record
		--
			class_function: init_record
		--
			class_function: init_from_email
	after_save
		--
			class_function: set_related
		--
			class_function: update_prospect
portal
	enabled: true
	filter
		class_function: portal_filter
fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
	app.modified_user
	app.assigned_user
	app.created_by_user
	name
		vname: LBL_NAME
		type: name
		source
			type: person_name
			fields
				- first_name
				- last_name
				- salutation
		importable: false
		unified_search: true
	converted
		vname: LBL_CONVERTED
		type: bool
		required: true
		default: 0
		comment:
			Has Lead been converted to a Contact (and other Sugar
			objects)
		massupdate: false
	categories
		vname: LBL_CATEGORY
		vname_list: LBL_LIST_CATEGORY
		type: multienum
		options: contact_category_dom
		len: 40
		multi_select_group: category
		multi_select_count: 10
		massupdate: true
	temperature
		vname: LBL_TEMPERATURE
		type: enum
		options: temperature_dom
		len: 40
		massupdate: true
	salutation
		vname: LBL_SALUTATION
		type: enum
		options: salutation_dom
		massupdate: false
		len: 20
		comment: Salutation (ex: Mr, Mrs, Ms)
		audited: true
		personal_info: true
	first_name
		vname: LBL_FIRST_NAME
		type: varchar
		len: 100
		comment: First name of Lead
		merge_filter: selected
		audited: true
		personal_info: true
	last_name
		vname: LBL_LAST_NAME
		type: name
		len: 100
		comment: Last name of Lead
		merge_filter: selected
		required: false
		audited: true
		personal_info: true
	title
		vname: LBL_TITLE
		type: varchar
		len: 100
		comment: Lead title (ex: Director))
		list_subtitle: true
		audited: true
		personal_info: true
	refered_by
		vname: LBL_REFERED_BY
		type: varchar
		len: 100
		comment: Identifies who refered the lead
		merge_filter: enabled
	lead_source
		vname: LBL_LEAD_SOURCE
		type: enum
		options: lead_source_dom
		len: 100
		audited: true
		comment: Lead source (ex: Web, print)
		merge_filter: enabled
		massupdate: true
	lead_source_description
		vname: LBL_LEAD_SOURCE_DESCRIPTION
		type: text
		width: 30
		height: 3
		comment: Description of the lead source
	status
		vname: LBL_STATUS
		type: status
		len: 100
		options: lead_status_dom
		audited: true
		comment: Status of the lead
		merge_filter: enabled
		vname_list: LBL_LIST_STATUS
		required: true
		default: New
		massupdate: true
	status_description
		vname: LBL_STATUS_DESCRIPTION
		type: text
		width: 30
		height: 3
		comment: Description of the status of the lead
	department
		vname: LBL_DEPARTMENT
		type: varchar
		len: 100
		comment: Department the lead belongs to
		merge_filter: enabled
	reports_to
		vname: LBL_REPORTS_TO
		type: ref
		bean_name: Contact
		massupdate: true
	do_not_call
		vname: LBL_DO_NOT_CALL
		type: bool
		dbType: varchar
		len: 3
		default: 0
		audited: true
		comment: Do Not Call indicator
		massupdate: true
	phone_home
		vname: LBL_HOME_PHONE
		type: phone
		unified_search: true
		comment: Home phone number
		merge_filter: enabled
		audited: true
		personal_info: true
	phone_mobile
		vname: LBL_MOBILE_PHONE
		type: phone
		unified_search: true
		comment: Mobile or cell phone number
		merge_filter: enabled
		audited: true
		personal_info: true
	phone_work
		vname: LBL_OFFICE_PHONE
		type: phone
		audited: true
		unified_search: true
		comment: Office phone number
		merge_filter: enabled
		vname_list: LBL_LIST_PHONE
		personal_info: true
	phone_other
		vname: LBL_OTHER_PHONE
		type: phone
		unified_search: true
		comment: Other phone number
		merge_filter: enabled
		audited: true
		personal_info: true
	phone_fax
		vname: LBL_FAX_PHONE
		type: fax
		unified_search: true
		comment: Fax phone number
		merge_filter: enabled
		audited: true
		personal_info: true
	skype_id
		vname: LBL_SKYPE_ID
		type: skype
		unified_search: true
		comment: Skype ID
		audited: true
		personal_info: true
	email1
		vname: LBL_EMAIL_ADDRESS
		type: email
		audited: true
		unified_search: true
		comment: Main email address of lead
		merge_filter: enabled
		vname_list: LBL_LIST_EMAIL_ADDRESS
		personal_info: true
	email2
		vname: LBL_OTHER_EMAIL_ADDRESS
		type: email
		unified_search: true
		comment: Secondary email address of lead
		merge_filter: enabled
		vname_list: LBL_LIST_EMAIL_ADDRESS
		audited: true
		personal_info: true
	email_opt_out
		vname: LBL_EMAIL_OPT_OUT
		type: bool
		dbType: varchar
		len: 3
		default: 0
		audited: true
		comment:
			Indicator signaling if lead elects to opt out of email
			campaigns
		massupdate: true
	email_opt_in
		vname: LBL_EMAIL_OPT_IN
		type: bool
		default: 0
		massupdate: false
	email_opt_in_date
		type: date
		editable: false
		vname: LBL_EMAIL_OPT_IN_DATE
	website
		vname: LBL_WEBSITE
		type: url
		len: 255
		comment: URL of website for the lead
		massupdate: true
		audited: true
		personal_info: true
	primary_address_street
		vname: LBL_PRIMARY_ADDRESS_STREET
		type: varchar
		len: 150
		comment: Primary street address
		merge_filter: enabled
		audited: true
		personal_info: true
	primary_address_city
		vname: LBL_PRIMARY_ADDRESS_CITY
		vname_list: LBL_CITY
		type: varchar
		len: 100
		comment: Primary address city
		merge_filter: enabled
		audited: true
		personal_info: true
	primary_address_state
		vname: LBL_PRIMARY_ADDRESS_STATE
		vname_list: LBL_STATE
		type: varchar
		len: 100
		comment: Primary address state
		merge_filter: enabled
		audited: true
		personal_info: true
	primary_address_postalcode
		vname: LBL_PRIMARY_ADDRESS_POSTALCODE
		type: varchar
		len: 20
		comment: Primary address postal code
		merge_filter: enabled
		audited: true
		personal_info: true
	primary_address_country
		vname: LBL_PRIMARY_ADDRESS_COUNTRY
		type: varchar
		len: 100
		comment: Primary address country
		merge_filter: enabled
		audited: true
		personal_info: true
	primary_address_statecode
		vname: LBL_PRIMARY_ADDRESS_STATECODE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	primary_address_countrycode
		vname: LBL_PRIMARY_ADDRESS_COUNTRYCODE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	alt_address_street
		vname: LBL_ALT_ADDRESS_STREET
		type: varchar
		len: 150
		comment: Alternate street address
		merge_filter: enabled
		audited: true
		personal_info: true
	alt_address_city
		vname: LBL_ALT_ADDRESS_CITY
		type: varchar
		len: 100
		comment: Alternate address city
		merge_filter: enabled
		audited: true
		personal_info: true
	alt_address_state
		vname: LBL_ALT_ADDRESS_STATE
		type: varchar
		len: 100
		comment: Alternate address state
		merge_filter: enabled
		audited: true
		personal_info: true
	alt_address_postalcode
		vname: LBL_ALT_ADDRESS_POSTALCODE
		type: varchar
		len: 20
		comment: Alternate address postal code
		merge_filter: enabled
		audited: true
		personal_info: true
	alt_address_country
		vname: LBL_ALT_ADDRESS_COUNTRY
		type: varchar
		len: 100
		comment: Alternate address country
		merge_filter: enabled
		audited: true
		personal_info: true
	alt_address_statecode
		vname: LBL_ALT_ADDRESS_STATECODE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	alt_address_countrycode
		vname: LBL_ALT_ADDRESS_COUNTRYCODE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	description
		vname: LBL_DESCRIPTION
		type: text
		comment: Lead description
	account_name
		vname: LBL_ACCOUNT_NAME
		type: varchar
		len: 150
		unified_search: true
		comment: Account name for lead
		vname_list: LBL_LIST_ACCOUNT_NAME
	account_description
		vname: LBL_ACCOUNT_DESCRIPTION
		type: text
		comment: Description of lead account
	contact
		type: ref
		vname: LBL_CONVERTED_CONTACT
		comment: If converted, Contact resulting from the conversion
		bean_name: Contact
		massupdate: false
	account
		type: ref
		vname: LBL_CONVERTED_ACCOUNT
		comment: If converted, Account resulting from the conversion
		bean_name: Account
		editable: false
	opportunity
		type: ref
		vname: LBL_CONVERTED_OPP
		comment: If converted, Opportunity resulting from the conversion
		bean_name: Opportunity
		editable: false
	campaign
		type: ref
		vname: LBL_CAMPAIGN
		comment: Campaign that generated lead
		bean_name: Campaign
		massupdate: true
	portal_active
		vname: LBL_PORTAL_ACTIVE
		type: bool
		default: 0
		comment: Indicator whether this lead is a portal user
		massupdate: true
	portal_name
		vname: LBL_PORTAL_NAME
		type: varchar
		len: 255
		comment: Portal user name when lead created via lead portal
	portal_app
		vname: LBL_PORTAL_APP
		type: varchar
		len: 255
		comment: Portal application that resulted in created of lead
	invalid_email
		vname: LBL_INVALID_EMAIL
		type: bool
		comment: Indicator that email address for lead is invalid
		massupdate: true
	partner
		vname: LBL_PARTNER
		type: ref
		bean_name: Partner
		massupdate: true
	date_converted
		vname: LBL_DATE_CONVERTED
		type: datetime
		massupdate: false
	last_activity_date
		vname: LBL_LAST_ACTIVITY
		vname_list: LBL_LIST_LAST_ACTIVITY
		type: datetime
		editable: false
	photo
		vname: LBL_PHOTO
		type: image
		placeholder: themes/Default/images/no_user.png
	photo_filename
		vname: LBL_PHOTO_FILENAME
		type: file_ref
	photo_thumb
		vname: LBL_THUMBNAIL_FILENAME
		type: file_ref
	consent_to_process
		vname: LBL_CONSENT_TO_PROCESS
		type: bool
		privacy_consent: true
		audited: true
	sf_id
		vname: LBL_SF_ID
		reportable: false
		type: hidden
		len: 50
		editable: false
		updateable: false
links
	activities
		relationship: leads_activities
		module: Activities
		bean_name: Activity
		vname: LBL_ACTIVITIES_SUBPANEL_TITLE
	history
		relationship: leads_history
		module: Activities
		bean_name: ActivityHistory
		layout: History
		vname: LBL_HISTORY_SUBPANEL_TITLE
		icon: History
	eventsessions
		relationship: events_leads
		vname: LBL_EVENTS
		bean_name: EventSession
	documents
		relationship: documents_leads
		module: Documents
		bean_name: Document
		vname: LBL_DOCUMENTS
	reports_to_link
		relationship: lead_direct_reports
		link_type: one
		side: right
		vname: LBL_REPORTS_TO
	partners
		relationship: leads_partners
		vname: LBL_PARTNERS
	converted_account
		relationship: lead_converted_account
		vname: LBL_CONVERTED_ACCOUNT
	converted_contact
		relationship: lead_converted_contact
		vname: LBL_CONVERTED_CONTACT
	converted_opportunity
		relationship: lead_converted_opp
		vname: LBL_CONVERTED_OPP
	tasks
		relationship: lead_tasks
		vname: LBL_TASKS
		bean_name: Task
	notes
		relationship: lead_notes
		vname: LBL_NOTES
		bean_name: Note
	meetings
		relationship: lead_meetings
		vname: LBL_MEETINGS
		bean_name: Meeting
	calls
		relationship: lead_calls
		vname: LBL_CALLS
		bean_name: Call
	emails
		relationship: emails_leads_rel
		side: right
		vname: LBL_EMAILS
		bean_name: Email
	chats
		relationship: lead_chats
		vname: LBL_CHATS
		bean_name: Chat
	campaign_leads
		relationship: lead_campaign
		module: Campaigns
		bean_name: Campaign
		vname: LBL_CAMPAIGNS
	campaigns
		relationship: lead_campaign_log
		module: CampaignLog
		bean_name: CampaignLog
		vname: LBL_CAMPAIGNS
		no_create: true
		layout: WithoutTarget
	prospect_lists
		relationship: prospect_list_leads
		bean_name: ProspectList
		vname: LBL_PROSPECT_LIST
	app.securitygroups
		relationship: securitygroups_leads
indices
	idx_lead_last_first
		fields
			- last_name
			- first_name
			- deleted
	idx_lead_del_stat
		fields
			- last_name
			- status
			- deleted
			- first_name
	idx_lead_opp_del
		fields
			- opportunity_id
			- deleted
	idx_leads_acct_del
		fields
			- account_id
			- deleted
	idx_lead_email1
		fields
			- email1
			- deleted
	idx_lead_email2
		fields
			- email2
			- deleted
	idx_lead_assigned
		fields
			- assigned_user_id
	idx_lead_contact
		fields
			- contact_id
relationships
	lead_direct_reports
		key: id
		target_bean: Lead
		target_key: reports_to_id
		relationship_type: one-to-many
	lead_tasks
		key: id
		target_bean: Task
		target_key: parent_id
		role_column: parent_type
		role_value: Leads
		relationship_type: one-to-many
	lead_notes
		key: id
		target_bean: Note
		target_key: parent_id
		role_column: parent_type
		role_value: Leads
		relationship_type: one-to-many
	lead_chats
		key: id
		target_bean: Chat
		target_key: parent_id
		relationship_type: one-to-many
	lead_meetings
		key: id
		target_bean: Meeting
		target_key: parent_id
		role_column: parent_type
		role_value: Leads
		relationship_type: one-to-many
	lead_calls
		key: id
		target_bean: Call
		target_key: parent_id
		role_column: parent_type
		role_value: Leads
		relationship_type: one-to-many
	lead_emails
		key: id
		target_bean: Email
		target_key: parent_id
		role_column: parent_type
		role_value: Leads
		relationship_type: one-to-many
	lead_campaign_log
		key: id
		target_bean: CampaignLog
		target_key: target_id
		relationship_type: one-to-many
	lead_campaign
		key: id
		target_bean: Campaign
		target_key: id
		relationship_type: one-to-many
	leads_partners
		key: partner_id
		target_bean: Partner
		target_key: id
		relationship_type: one-to-many
	lead_converted_account
		key: account_id
		target_bean: Account
		target_key: id
		relationship_type: one-to-many
	lead_converted_contact
		key: contact_id
		target_bean: Contact
		target_key: id
		relationship_type: one-to-many
	lead_converted_opp
		key: opportunity_id
		target_bean: Opportunity
		target_key: id
		relationship_type: one-to-many
	leads_activities
		target_bean: Activity
		target_key: id
		sources
			meetings
				relationship: lead_meetings
			calls
				relationship: lead_calls
			tasks
				relationship: lead_tasks
			chats
				relationship: lead_chats
	leads_history
		target_bean: ActivityHistory
		target_key: id
		sources
			meetings
				relationship: lead_meetings
			calls
				relationship: lead_calls
			tasks
				relationship: lead_tasks
			notes
				relationship: lead_notes
			emails
				relationship: emails_leads_rel
			chats
				relationship: lead_chats

