function check_for_updates() {
    function ready() {
        var row = this.getResult();

        if (row) {
            if ($('updates-outer') && row.result)
                $('updates-outer').innerHTML = row.result;
            if (row.error == 1) {
                var msg = app_string('LBL_ASYNC_JS_ERROR');
                if (row.error_message)
                    msg = row.error_message;
                alert(msg);
            }
        }
    }

    var req = new SUGAR.conn.JSONRequest('check_for_updates', {status_msg: app_string('LBL_LOADING')});
    req.fetch(ready);
}

function request_startup() {
	var ready = function(data) {
	}

	var params = {
		module: 'LicenseInfo',
		action: 'StartupPopup',
	};

	var popupDialog = new SUGAR.ui.Dialog('startupRequestDialog', { width: '661px', resizable: false, draggable: true, title: mod_string('LBL_STARTUP_LICENSE_TITLE') });
	popupDialog.max_auto_size.height = 780;
	popupDialog.fetchContent('async.php', {method: 'POST', postData: params}, ready, true);
	return false;
}

function update_license(form) {
	var req = new SUGAR.conn.JSONRequest('update_license', {status_msg: app_string('LBL_LOADING')}, {module: 'LicenseInfo'}),
		err = function(zero, msg) {
			SUGAR.util.hideMask(mask);
			SUGAR.popups.showMessage(msg.failure_msg, {icon: 'uii-danger text-error', timeout: 10000, show_mask: true});
			this.revertFileInputs(true);
		}, mask;
	req.loadForm(form);
	mask = SUGAR.util.maskDiv('content-main');
	req.fetchJSON(function(data) {
		if(data.status == 'ok') {
			SUGAR.popups.showMessage(data.message, {
				icon: 'uii-accept text-success',
				onclose: function() { SUGAR.util.loadUrl('?module=LicenseInfo&action=index&updated=1'); },
				timeout: 10000,
				show_mask: true});
		} else {
			err.call(this, null, {failure_msg: data.message});
		}
	}, err);
	return false;
}

function license_form_init(form) {
	if(form && form.license_key && form.license_key.value) {
		setTimeout(function() { update_license(form); }, 100);
	}
}

function disable_startup_button(form) {
	var b = $(form.name + '_request');
	var cb = SUGAR.ui.getFormInput(form, 'consent');
	if (b && cb) {
		b.setAttribute('disabled', true);
		SUGAR.ui.attachInputEvent(cb, 'onchange', function() {
			if (cb.getValue())
				b.removeAttribute('disabled');
			else
				b.setAttribute('disabled', true);
		});
	}
}

