<?php

require_once 'include/utils/dl_utils.php';

class LiveChatIncAPIClient {

	const BASE_URL = 'https://api.livechatinc.com';
	
	var $username;
	var $api_key;

	public function __construct($username, $api_key) {
		$this->username = $username;
		$this->api_key = $api_key;
	}

	public function send($method, $path, $postdata = null) {
		$opts = [
			'auth' => [
				'user' => $this->username,
				'password' => $this->api_key,
			],
			'timeout' => 5,
			'connect_timeout' => 5,
			];
		$headers = [ "X-API-VERSION: 2"];
		$headers[] =  "Content-Type: application/json";
		if ($postdata) {
			$json = getJSONObj();
			$postdata = $json->encode($postdata);
		}
		$url = self::BASE_URL . $path;
		$req = RemoteRequest::create($url, $method, $postdata, $headers, $opts);
		$result = $req->fetch();
		$json = getJSONObj();
		$decoded = $json->decode($result);
		if ($decoded)
			return $decoded;
		return $result;
	}
}

