var LiveChatIncImpl = function() {
};

LiveChatIncImpl.prototype.renderTab = function(chat, tab) {
	tab.contentEl.appendChild(document.createTextNode(tab.id));
	if (tab.id == 'info') {
		this.renderInfoTab(tab);
	}
};

LiveChatIncImpl.prototype.initialize = function(chat) {
	this.chat = chat;
	this.reloadVisitors();
}

LiveChatIncImpl.prototype.sendRequest = function(endpoint, method, params) {
	var callback = function() {
		var result;
		try {
			result = this.responseText.length ? JSON.parse(this.responseText) : null;
		} catch(e) {
			console.error(e, this.responseText);
		}
		if(result && params.callback) {
			params.callback(result);
		}
	}
	var errback = function() {
		if(params.errback) {
			params.errback();
		}
	}
	params = params || {};
	var postData = {
		method: method,
		postdata: params.postData,
		query: params.query
	}
	var reqParams = {
		method : 'POST',
		postData : JSON.stringify(postData),
		content_type : 'application/json'
	};


	var self = this;
	var url = "chatapi.php/private/livechatinc/apirequest" + endpoint;
	SUGAR.conn.asyncRequest(url, reqParams, callback, errback);
}

LiveChatIncImpl.prototype.renderInfoTab = function(tab) {
	var doRender = function() {
		console.log(this.chat.state.agent_info);
		var info = this.chat.state.agent_info;
		tab.contentEl.innerHTML = '';
		createElement2('img', {src : '//' + info.avatar, className : 'avatar'}, null, tab.contentEl);
		createElement2('div', {className : 'agent-info-name'}, info.name, tab.contentEl);
		createElement2('div', {className : 'agent-info-title'}, info.job_title, tab.contentEl);
		createElement2('div', {className : 'agent-info-email'}, info.login, tab.contentEl);
		
		var statusInput = new SUGAR.ui.SelectInput('livechatinc-operator-status', {
			options: {dom_name: 'livechatinc_operator_status_dom'},
			onchange: function(value, label, changed) {
				if (changed) {
					this.setAgentStatus(value);
				}
			}.bind(this)
		});
		tab.contentEl.appendChild(statusInput.render());
		statusInput.setValue(info.status, true);
	}.bind(this);

	if (this.chat.state.agent_info) {
		doRender();
	} else {
		this.chat.tabLoading(tab);
		this.reloadAgentInfo(doRender);
	}
}

LiveChatIncImpl.prototype.setAgentStatus = function(status) {
	this.sendRequest('/agents/' + this.chat.options.username, 'PUT', {
		postData: {status: status},
		callback: function(result) {
			if (result) {
				this.chat.state.agent_info = result;
				this.reloadAgentInfo(function() {
					this.chat.renderTab('info');
				}.bind(this));
			}
		}.bind(this)
	});
}

LiveChatIncImpl.prototype.reloadAgentInfo = function(callback) {
	this.sendRequest('/agents/' + this.chat.options.username, 'GET', {
		callback: function(result) {
			if (result) {
				this.chat.state.agent_info = result;
				callback();
			}
		}.bind(this)
	});
}

LiveChatIncImpl.prototype.reloadVisitors = function(callback) {
	var finished = 0;
	var tempVisitors = [];
	var onFinished = function() {
		setTimeout(function() {
			this.reloadVisitors();
		}.bind(this), 1000);
		console.log(tempVisitors);
	}.bind(this);
	this.sendRequest('/visitors' , 'GET', {
		query: {state: 'queued'},
		callback: function(result) {
			if (Array.isArray(result)) {
				result.forEach(function(visitor) {
					tempVisitors.push(visitor);
				});
			finished++;
			if (finished == 2) {
				onFinished();
			}
			} else {
				console.log(result);
			}
		}.bind(this),

		errback: function() {
			console.log('ERRR');
			finished++;
			if (finished == 2) {
				onFinished();
			}
		}.bind(this)
	});
	this.sendRequest('/visitors' , 'GET', {
		query: {state: 'chatting'},
		callback: function(result) {
			if (Array.isArray(result)) {
				result.forEach(function(visitor) {
					tempVisitors.push(visitor);
				});
			} else {
				console.log(result);
			}
			finished++;
			if (finished == 2) {
				onFinished();
			}
		}.bind(this),

		errback: function() {
			console.log('ERRR');
			finished++;
			if (finished == 2) {
				onFinished();
			}
		}.bind(this)
	});
}

