<?php

require_once 'modules/UserPreferences/UserPreference.php';
require_once 'include/OnlineMeetings/GoToMeeting/GoToMeeting.php';
$gtm = new GoToMeeting;
$for_company = !empty($_GET['system']);
if ($for_company && !AppConfig::is_admin()) {
	$error = 'Admin only';
} else {
	try {
		$token = $gtm->obtainToken($_GET['code'], $for_company);
		$info = $gtm->obtainOrganizerInfo();
		$token['organizer_email'] = $info[0]['email'];
		if ($for_company) {
			AppConfig::set_local('company.gtm_auth_token', serialize($token), true);
			AppConfig::save_local('company');
		} else {
			UserPreference::setPreference('gtm_token', $token);
			UserPreference::savePreferencesToDB();
		}
		$error = false;
	} catch (Exception $e) {
		$error = $e->getMessage();
	}
}

$json = getJSONobj();
$error = $json->encode($error);

?>
<script>
var error = <?php echo $error?>;
try {
	var error_div = window.opener.document.getElementById('gtm_error_message');	
	var success_div = window.opener.document.getElementById('gtm_success_message');	
	if (error) {
		if (error_div) {
			error_div.style.display = 'block';
			error_div.innerText = error;
		}
		if (success_div) {
			success_div.style.display = 'none';
		}
	} else {
		if (error_div) {
			error_div.style.display = 'none';
		}
		if (success_div) {
			success_div.style.display = 'block';
		}
	}
} catch (e) {
}
window.close();
</script>
<?php

