function initMeetingEdit(form) {

	var allDayChanged = false,
		dateChanged = false,
		timeChanged = false
	;

	var rel = SUGAR.ui.getFormInput(form, 'parent');
	if(rel) {
		rel.addExtraReturnFields({
			'account': '_account',
			'account_id': '_account_id'
		});
		SUGAR.ui.attachInputEvent(rel, 'onchange', function(k, v) {
			if(v && v.account_id) {
				var acct = SUGAR.ui.getFormInput(form, 'account');
				if(acct) acct.update(v.account_id, v.account);
			}
		});
	}

	var breakInput = SUGAR.ui.getFormInput(form, 'break_sequence');
	if (breakInput) {
		var dateInput = SUGAR.ui.getFormInput(form, 'date_start');
		var beforeSubmitForm = dateInput.beforeSubmitForm;
		dateInput.beforeSubmitForm = function() {
			var mode = breakInput.getValue();
			if (dateChanged && mode == 'all') {
				alert(mod_string('LBL_UPDATE_MODE_ERROR', 'Meetings'));
				return false;
			}
			if (beforeSubmitForm)
				return beforeSubmitForm();
		}
		SUGAR.ui.attachInputEvent(dateInput, 'onchange', function(_, v) {
			var orig = this.orig_value || ' ';
			var origDate = orig.split(' ');
			var newDate = v.split(' ');
			if (origDate.length < 2) origDate.push('');
			if (newDate.length < 2) newDate.push('');
			origDate = [origDate[0], origDate.slice(1).join(' ')];
			newDate = [newDate[0], newDate.slice(1).join(' ')];
			dateChanged = origDate[0] !== newDate[0];
			timeChanged = origDate[1] !== newDate[1];
		});
		var allDayInput = SUGAR.ui.getFormInput(form, 'is_daylong');
		SUGAR.ui.attachInputEvent(allDayInput, 'onchange', function(_, v) {
			var orig = this.orig_value || '0';
			allDayChanged = (v != orig);
		});
	}
}


