<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/Meetings/Meeting.php
	unified_search
		enabled: true
		default: false
	activity_log_enabled: true
	duplicate_merge: false
	optimistic_locking: true
	comment: Meeting activities
	table_name: meetings
	primary_key: id
	importable: LBL_MEETINGS
	reportable: true
	primary_account: account
	record_status: status
hooks
	new_record
		--
			class_function: init_record
	load_request
		--
			class_function: load_request
	before_save
		--
			class_function: reset_recurrence
			required_fields
				- recurrence_rule_id
		--
			class_function: prepare_recurrence_update
			required_fields
				- recurrence_rule_id
				- recurrence_exception
				- date_start
				- is_daylong
				- assigned_user_id
				- recurrence_start_time
		--
			class_function: before_save
			required_fields
				- gtm_id
				- gtm_org_id
				- gtm_email
				- online_meeting_create
                - online_meeting_params
		--
			class_function: send_apns
			required_fields
				- reminder_time
				- date_start
				- assigned_user_id
		--
			class_function: update_vcal
	after_save
		--
			class_function: update_parent_activity
		--
			class_function: update_invitees
		--
			class_function: update_recurrence
	before_delete
		--
			class_function: before_delete
			required_fields
				- recurrence_rule_id
				- date_start
				- is_daylong
				- assigned_user_id
				- recurrence_start_time
	after_delete
		--
			class_function: after_delete
	after_add_link
		--
			class_function: update_user_vcal
	after_remove_link
		--
			class_function: update_user_vcal
fields
	app.id
	app.date_entered
	app.date_modified
	app.assigned_user
	app.modified_user
	app.created_by_user
	app.recurrence_fields
	app.deleted
	is_publish
		vname: LBL_PUBLISH_SETTING
		type: bool
		massupdate: false
		reportable: false
		default: 1
	is_daylong
		vname: LBL_IS_DAYLONG
		type: bool
		massupdate: false
		reportable: false
	is_private
		vname: LBL_IS_PRIVATE
		type: bool
		massupdate: true
	name
		vname: LBL_SUBJECT
		type: name
		len: 150
		comment: Meeting name
		unified_search: true
		vname_list: LBL_LIST_SUBJECT
		required: true
		default: ""
	location
		vname: LBL_LOCATION
		type: varchar
		len: 255
		comment: Meeting location
		width: 35
	duration
		vname: LBL_DURATION
		type: duration
		comment: Meeting duration in minutes
		all_day_flag: is_daylong
	date_start
		vname: LBL_DATE_TIME
		type: datetime
		comment: Date of start of meeting
		vname_list: LBL_LIST_DATE
		massupdate: true
	date_end
		vname: LBL_DATE_END
		type: date
		massupdate: false
		comment: Date meeting ends
	parent_type
		vname: LBL_RELATED_TYPE
		type: module_name
		reportable: false
		comment: Module meeting is associated with
		options
			- Contacts
			- Opportunities
			- Leads
			- Prospects
			- Emails
			- Tasks
			- Project
			- ProjectTask
			- Bugs
			- Cases
			- Quotes
			- Invoice
			- PurchaseOrders
			- SalesOrders
			- Bills
			- Users
	status
		vname: LBL_STATUS
		type: status
		len: 25
		width: 10
		options: meeting_status_dom
		comment: Meeting status (ex: Planned, Held, Not held)
		vname_list: LBL_LIST_STATUS
		required: true
		default: Planned
		massupdate: true
		list_subtitle: true
	account
		vname: LBL_ACCOUNT
		type: ref
		bean_name: Account
		massupdate: true
		unified_search: true
	parent
		vname: LBL_LIST_RELATED_TO
		type: ref
		comment: Item indicated by parent_type
		dynamic_module: parent_type
		massupdate: true
	description
		vname: LBL_DESCRIPTION
		type: text
		comment: Full description of meeting
		unified_search: true
	reminder_time
		vname: LBL_REMINDER
		type: reminder
		default: -1
		comment:
			Specifies when a reminder alert should be issued; -1 means
			no alert; otherwise the number of seconds prior to the start
	email_reminder_time
		vname: LBL_EMAIL_REMINDER
		type: reminder
		default: -1
		len: 4
		comment:
			Specifies when a reminder email should be sent; -1 means no
			email; otherwise the number of seconds prior to the start
	outlook_id
		vname: LBL_OUTLOOK_ID
		type: varchar
		len: 255
		reportable: false
		comment:
			When the Sugar Plug-in for Microsoft Outlook syncs an
			Outlook appointment, this is the Outlook appointment item ID
	gtm_id
		type: varchar
		len: 64
		reportable: false
	gtm_email
		type: varchar
		vname: LBL_GTM_CREATED_FOR
		len: 255
		reportable: false
	gtm_org_id
		type: varchar
		len: 255
		reportable: false
    online_meeting_params
        type: text
        comment: Special params for external meeting app
        reportable: false
	vcal_size
		type: int
		comment: Size of vCal
		reportable: false
		editable: false
	vcal
		type: text
		comment: Pre-generated vCal
		reportable: false
		editable: false
	vcal_uri
		type: varchar
		len: 255
		comment: URI generated by external calendar
		reportable: false
		editable: false
    booking_app
        vname: LBL_BOOKING_APP_APPOINTMENT
        vdesc: LBL_BOOKING_APP_APPOINTMENT_DESC
        type: bool
        comment: The flag indicates whether the meeting is a booking appointment
        editable: false
    booking_app_wp_id
        vname: LBL_BOOKING_APP_WP_ID
        type: int
        editable: false
        comment:
            When the Portal plugin syncs an WordPress
            booking appointment, this is the WP booking appointment item ID
    booking_app_status
        vname: LBL_BOOKING_APP_STATUS
        type: enum
        options: meeting_booking_status_dom
        len: 20
        editable: false
        default: Pending
        comment: Booking Appointment status (ex: Approved, Pending)
    booking_app_payment_status
        vname: LBL_BOOKING_APP_PAYMENT_STATUS
        type: varchar
        editable: false
        len: 255
        comment: Booking Appointment payment status (ex: Completed, PayPal: FAILED)
    booking_app_cost
        vname: LBL_BOOKING_APP_COST
        type: currency
        currency: booking_app_currency
        editable: false
        default: 0
        base_field: booking_app_cost_usd
        comment: Booking Appointment cost
    booking_app_currency
        type: currency_ref
        exchange_rate: booking_app_exchange_rate
    booking_app_exchange_rate
        type: exchange_rate
    booking_app_resource
        vname: LBL_BOOKING_APP_RESOURCE
        type: ref
        bean_name: Resource
        editable: false
	sf_id
		vname: LBL_SF_ID
		reportable: false
		type: hidden
		len: 50
		editable: false
		updateable: false
links
	resources
		relationship: meetings_resources
		vname: LBL_RESOURCES
	contacts
		relationship: meetings_contacts
		vname: LBL_CONTACTS
	users
		relationship: meetings_users
		vname: LBL_USERS
    leads
        relationship: meetings_leads
        vname: LBL_LEADS
	invitees
		relationship: meetings_invitees
		vname: LBL_INVITEE
		module: Invitees
		bean_name: Invitee
	opportunity
		relationship: opportunity_meetings
		link_type: one
		vname: LBL_OPPORTUNITY
	case
		relationship: case_meetings
		link_type: one
		vname: LBL_CASE
	notes
		relationship: meetings_notes
		module: Notes
		bean_name: Note
		vname: LBL_NOTES
	app.securitygroups
		relationship: securitygroups_meetings
indices
	idx_mtg_name
		fields
			- name
	idx_meet_par_del
		fields
			- parent_id
			- parent_type
			- deleted
relationships
	meetings_notes
		key: id
		target_bean: Note
		target_key: parent_id
		role_column: parent_type
		role_value: Meetings
		relationship_type: one-to-many
