
var original_message = '';

function msTeamsAuth(form, for_company) {
    let id = '';
    let secret = '';

    if (for_company) {
        id = SUGAR.ui.getFormInput(form, 'company_ms_teams_client_id').getValue();
        secret = SUGAR.ui.getFormInput(form, 'company_ms_teams_client_secret').getValue();
    }

    const error_div = document.getElementById('om_error_message');

    if (original_message == '')
        original_message = error_div.innerText;

    error_div.innerText = original_message;

    if (for_company && (id == '' || secret == '')) {
        error_div.style.display = 'block';
        error_div.innerText = mod_string('LBL_MS_TEAMS_AUTH_PARAMS_ERROR', 'Configurator');

        return false;
    }

    const req = new SUGAR.conn.JSONRequest(
        'get_ms_teams_auth_url',
        {status_msg: app_string('LBL_LOADING')},
        {
            module: 'Meetings',
            id: id,
            secret: secret,
            for_company: for_company
        }
    );
    const mask = SUGAR.util.maskDiv('content-main');

    const err = function(zero, msg) {
        SUGAR.util.hideMask(mask);
        SUGAR.popups.showMessage(msg.failure_msg, {icon: 'uii-danger text-error', timeout: 10000, show_mask: true});
        this.revertFileInputs(true);
    };

    req.fetchJSON(function(data) {
        if(data.url != '') {
            SUGAR.util.hideMask(mask);
            open_popup_window({url: data.url})
        } else {
            err.call(this, null, {failure_msg: data.message});
        }
    }, err);

    return false;
}
