ModuleDesignerRel = new function()
{

	this.init = function(module, moduleData)
	{
		this.module = module;
		this.moduleData = moduleData;
		this.newRelationships = {};
	};

	this.add = function(module)
	{
		if (!module.length)
			return;

		var table = $('rels_table');
		var relId = this.module.toLowerCase() + '_' + module.toLowerCase() + '_' + (new Date()).getTime();
		this.newRelationships[relId] = module;
		
		createElement2('div', {className: 'row form-row'},
			createElement2('div', {className: 'column form-cell sm-12', style: {height: '1px', backgroundColor: '#CCC' }}),
			table
		);
		row = createElement2('div', {id: relId, className: 'row form-row col-unstack', style: {cursor: 'pointer'}}, null, table);
		row.onmouseover = function() {
			SUGAR.ui.addClass(this, 'currentRow markRow');
		};
		row.onmouseout = function() {
			SUGAR.ui.removeClass(this, 'currentRow markRow');
		};
		var div = document.createElement('div');
		div.className = 'input-icon icon-delete active-icon';
		div.onclick = function() {
			ModuleDesignerRel.remove(relId);
		};
		var icon = createElement2('span', {});
		icon.innerHTML = this.moduleData[module].icon;

		var values = [
			[icon, nbsp(), this.moduleData[module].label],
			this.moduleData[module].bean,
			relId,
			div
		];
		var widths = [ 4, 3, 4, 1];
		values.forEach(function(value, idx) {
			var p = createElement2('p', { className: 'form-value'}, value);
			var entry = createElement2('div', {className: 'form-entry'}, p);
			var col = createElement2('div', {className: 'column form-cell sm-' + widths[idx]}, entry);
			row.appendChild(col);
		});

	};

	this.remove = function(relId)
	{
		var row = $(relId);
		row.previousElementSibling.remove();
		row.remove();
		delete this.newRelationships[relId];
	};

	this.save = function(form)
	{
		var rels = JSON.stringify(this.newRelationships);
		return SUGAR.ui.sendForm(form, {newrels: rels}, null);
	};

}();

