<?php

require_once 'modules/NewStudio/wizards/StudioWizardBase.php';
require_once 'modules/NewStudio/utils.php';

class EditLayoutWizard extends StudioWizardBase
{
	public function render()
	{
		return render_EditLayoutWizard($this);
	}
	
	
	public function renderModules()
	{
		global $mod_strings;
		$sep = translate('LBL_SEPARATOR', 'app');
		echo get_module_title('Administration', $mod_strings['LBL_EDIT_LAYOUT'], false);
		global $app_list_strings;
		$modules = AppConfig::setting('modinfo.index.normal');
		$modules = array_merge($modules, AppConfig::setting('modinfo.index.manual'));
		$mods_trans = array();
		foreach($modules as $mod)
			$mods_trans[$mod] = array_get_default($app_list_strings['moduleList'], $mod, $mod);
		asort($mods_trans);
		$url_tpl = 'index.php?module=NewStudio&wizard=EditLayout&edit_module={MODULE}';
		echo '<div class="detailOuter">';
		echo parent::renderModuleChooser($mods_trans, $url_tpl, '<h4 class="no-margin">' . $mod_strings['LBL_SELECT_MODULE'] . '</h4>');
		echo '</div>';
	}

	public function renderViews()
	{
		global $mod_strings;
		global $app_list_strings;
		$mod = $this->params['edit_module'];
		$modName = array_get_default($app_list_strings['moduleList'], $mod, $mod);
		$bean = AppConfig::module_primary_bean($mod);
		$sep = translate('LBL_SEPARATOR', 'app');
		echo get_module_title('Administration', $mod_strings['LBL_EDIT_LAYOUT'], false);
		$types = array(
			'edit', 'record',
		);
		foreach ($types as $type) {
			$detail = AppConfig::setting("views.detail.{$mod}.{$type}");
			$layouts[$type] = array();
			foreach ($detail as $layout => $def) {
				if ($type != 'record' && ! ($type == 'edit' && $layout == 'QuickCreate'))
					continue;
				$vname = AppConfig::setting("display.$type.$bean.layouts.$layout.vname");
				if (empty($vname)) {
					$vname = array_get_default($def, "title");
				}
				$title = translate($vname, $mod);
				$perform = $layout == 'QuickCreate' ? 'edit_layout_edit' : 'edit_layout_record';
				$custom = file_exists(AppConfig::custom_dir() . "modules/$mod/new_views/$type.$layout.php");
				$layouts[$type][] = array($layout, $title, $custom, $perform);
			}
		}

		$body = '<div class="row form-row col-unstack">';
		$body .= '<div class="column form-cell">';
		$body .= '<div class="form-entry">';
		$body .= '<p class="form-label">' . $mod_strings['LBL_RECORD_LAYOUTS'] . '</p>';
		$body .= '<div class="form-value">';
		foreach($layouts['record'] as $row) {
			$body .= "<a href=\"index.php?module=$mod&action=DetailView&record_perform={$row[3]}&layout={$row[0]}\">";
			$body .= "{$row[1]} [{$row[0]}]";
			$body .= "</a>";
		}
		$body .= '</div></div></div>';
		$body .= '<div class="column form-cell">';
		$body .= '<div class="form-entry">';
		$body .= '<p class="form-label">' . $mod_strings['LBL_EDIT_LAYOUTS'] . '</p>';
		$body .= '<div class="form-value">';
		foreach($layouts['edit'] as $row) {
			$body .= "<a href=\"index.php?module=$mod&action=DetailView&record_perform={$row[3]}&layout={$row[0]}\">";
			$body .= "{$row[1]} [{$row[0]}]";
			$body .= "</a>";
		}
		$body .= '</div></div></div>';
		$body .= '</div>';
		
		echo '<div class="detailOuter">';
		
		echo parent::renderPanel($body,
			'<h4 class="no-margin">' . get_image($mod) . ' ' . $modName . $sep . $mod_strings['LBL_SELECT_VIEW'] . '</h4>',
			'<a class="utilsLink" href="index.php?module=NewStudio&wizard=EditLayout"><span class="uii uii-previous"></span> ' . $mod_strings['LBL_SELECT_MODULE'] . '</a>');
		echo '</div>';
	}
}

