<?php

abstract class StudioWizardBase
{
	var $params;

	public function __construct($params)
	{
		$this->params = $params;
	}

	public function process() {}
	abstract public function render();

	public static function renderModuleChooser($modules, $url_tpl, $title='', $ext_info=null)
	{
		$beans = AppConfig::setting('modinfo.primary_beans');
		$i = 0;
		$body = '<div class="row form-row col-unstack">';
		foreach ($modules as $mod => $modName) {
			if (!isset($beans[$mod])) continue;
			$bean = $beans[$mod];
			if (($i & 3) == 0) {
				$body .= '</div><div class="row form-row col-unstack">';
			}
			$modName = to_html($modName);
			$icon = get_image($bean, '');
			$url = str_replace('{MODULE}', $mod, $url_tpl);
			$body .= '<div class="column form-cell sm-3">';
			$body .= '<div class="form-entry tools-row align-top">';
			$body .= "<div class=\"no-flex\" style=\"margin-right: 0.5em\">$icon</div>";
			$body .= "<a href=\"$url\" onclick=\"SUGAR.util.handleLink(event)\">$modName</a>";
			if($ext_info && isset($ext_info[$bean])) {
				$body .= '<span class="no-flex">('.$ext_info[$bean].')</span>';
			}
			$body .= '</div></div>';
			//if (($i & 3) == 3) {
			//	echo "</tr>";
			//}
			$i++;
		}
		if (($i & 3) != 3) {
			while ($i & 3) {
				$body .= '<div class="column form-spacer">&nbsp;</div>';
				$i++;
			}
			$body .= '</div>';
		}
		return self::renderPanel($body, $title);
	}
	
	public static function renderPanel($body, $title='', $subtitle='') {
		$outer = '<section class="panel-outer panel-default panel-border panel-round" style="max-width: 800px; margin: 0 auto">';
		if($title)
			$outer .= '<div class="panel-header">' . $title . '</div>';
		if($subtitle)
			$outer .= '<div class="panel-subheader">' . $subtitle . '</div>';
		$outer .= '<div class="panel-body">';
		$outer .= $body;
		$outer .= '</div></section>';
		return $outer;
	}
}
