<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/Notes/Note.php
	unified_search: true
	duplicate_merge: false
	optimistic_locking: true
	comment: Notes and Attachments
	table_name: notes
	primary_key: id
	default_order_by: name
	importable: LBL_NOTES
	reportable: true
	primary_account: account
hooks
	after_save
		--
			class_function: update_parent_activity
	new_record
		--
			class_function: init_record
	unified_search
		--
			class_function: unified_search_hook
fields
	app.id
	app.date_entered
	app.date_modified
	app.assigned_user
	app.modified_user
	app.created_by_user
	app.deleted
	name
		vname: LBL_SUBJECT
		type: name
		len: 255
		width: 45
		unified_search: true
		vname_list: LBL_LIST_SUBJECT
	filename
		vname: LBL_FILENAME
		type: file_ref
		file_mime_type: file_mime_type
		len: 255
		unified_search: true
		comment: File name associated with the note (attachment)
		vname_list: LBL_LIST_FILENAME
	file_mime_type
		vname: LBL_FILE_MIME_TYPE
		type: varchar
		len: 100
		comment: Attachment MIME type
	parent_type
		vname: LBL_RELATED_TYPE
		type: module_name
		options
			- Calls
			- Documents
			- Meetings
			- Emails
			- Leads
			- Opportunities
			- Prospects
			- Quotes
			- Invoice
			- PurchaseOrders
			- Bills
			- SalesOrders
			- Shipping
			- Receiving
			- Cases
			- Bugs
			- Project
			- ProjectTask
			- Timesheets
			- KBArticles
	parent
		vname: LBL_RELATED_TO
		vname_list: LBL_LIST_RELATED_TO
		type: ref
		dynamic_module: parent_type
		massupdate: true
	contact
		vname: LBL_CONTACT_NAME
		vname_list: LBL_LIST_CONTACT
		type: ref
		bean_name: Contact
		add_filters
			--
				param: primary_account
				field_name: account
		massupdate: true
	contact_phone
		vname: LBL_PHONE
		type: phone
		source
			type: field
			field: contact.phone_work
	contact_email
		vname: LBL_EMAIL_ADDRESS
		type: email
		source
			type: field
			field: contact.email1
	account
		vname: LBL_ACCOUNT
		type: ref
		bean_name: Account
		unified_search: true
	portal_flag
		vname: LBL_PORTAL_FLAG
		type: bool
		required: true
		default: 0
		comment: Portal flag indicator determines if note created via portal
		massupdate: true
	description
		unified_search
		vname: LBL_NOTE
		type: text
		comment: Full text of the note
		fulltext_search: true
	email_attachment
		vname: LBL_EMAIL_ATTACHMENT
		type: bool
		required: true
		default: 0
		reportable: false
		massupdate: false
	sf_id
		vname: LBL_SF_ID
		reportable: false
		type: hidden
		len: 50
		editable: false
		updateable: false
links
	cases
		relationship: case_notes
		vname: LBL_CASES
	app.securitygroups
		relationship: securitygroups_notes
indices
	notes_attachment
		fields
			- deleted
			- email_attachment
	idx_note_name
		fields
			- name
	idx_notes_parent
		fields
			- parent_type
			- parent_id
	idx_note_contact
		fields
			- contact_id
	idx_note_account
		fields
			- account_id
	idx_note_date_modified
		fields
			- date_modified
	idx_note_assigned_user
		fields
			- assigned_user_id
	idx_note_desc
		type: fulltext
		fields
			- description

