<?php

global $pageInstance;
theme_hide_side_menu(true);

$styles = AppConfig::setting('notify.styles');

if (!empty($_POST)) {
	foreach (array_keys($styles) as $name) {
		if (isset($_POST[$name]))
			AppConfig::set_local("notify.styles.$name", $_POST[$name]);
	}
	AppConfig::save_local();
	header('Location: index.php?module=Notify&action=EditTemplate');
	return;
}

$models = AppConfig::setting('model.index.by_type.bean');
$types = [];
foreach ($models as $m) {
	$module = AppConfig::module_for_model($m);
	$modelName = translate_dd('moduleListSingular', $module);
	$messages = AppConfig::setting("display.notify.$m.messages");
	if ($messages) {
		foreach ($messages as $action => $msg) {
			$types[] = [
				'label' => $modelName . ' : ' . translate_dd('activity_log_status_dom', $action, $action),
				'model' => $m,
				'action' => $action,
			];
		}
	}
}

usort($types, function($a, $b) { return strcmp($a['label'], $b['label']);});

$json = getJSONObj();
$pageInstance->add_js_include('modules/Notify/template_editor.js', null, LOAD_PRIORITY_HEAD);
$pageInstance->add_js_literal("notifyTemplateEditorInit(" . $json->encode($types) . ");", null, LOAD_PRIORITY_FOOT);
$pageInstance->add_js_literal("notifyTemplatePreview();", null, LOAD_PRIORITY_FOOT);

echo get_module_title('Administration', translate('LBL_CUSTOMIZE_TITLE', 'Notify'), true);

?>

<div class="detailOuter">
<form method="POST" action="index.php" class="card-outer form-outer default-form">
<?php echo create_csrf_input(); ?>
<input type="hidden" name="module" value="Notify">
<input type="hidden" name="action" value="EditTemplate">
<div class="card-header form-buttons">
<div class="row buttons-row">
<div class="column buttons-inline">
	<div class="inline-elt">
		<button type="submit" class="input-button"><div class="input-icon left icon-accept"></div><span class="input-label" ><?php echo translate('LBL_SAVE', 'Notify'); ?></span></button>
	</div>
	<div class="inline-elt">
		<button type="button" onclick="return SUGAR.util.navigateTo({module: 'Administration'});" class="input-button"><div class="input-icon left icon-cancel"></div><span class="input-label"><?php echo translate('LBL_CANCEL', 'Notify'); ?></span></button>
	</div>
</div>
<div class="column form-cell">
	<div class="form-entry">
	<label class="form-label" for="notify_action_type"><?php echo translate('LBL_SELECT_TEMPLATE', 'Notify'); ?></label>
	<div class="form-value">
	<select id="notify_action_type" onchange="notifyTemplateUpdated()" class="input-field">
	<?php foreach ($types as $i => $type) {
		echo '<option value="' . $i . '">' . to_html($type['label']) . '</option>';
	} ?>
	</select>
	<?php /* <div class="input-field input-check"><input type="checkbox" id="notify_text_format" onchange="notifyTemplateUpdated()"><label class="input-label" for="notify_text_format"> <?php echo translate('LBL_TEXT_FORMAT', 'Notify'); ?></label></div>
	*/ ?>
	</div></div>
</div>
</div>
</div>
<div class="card-body form-body">
<div class="form-section">
<div class="row form-row">
<div class="column form-cell col-4">
<?php foreach ($styles as $name => $css) {
	echo '<div class="form-entry">';
	echo '<div class="form-label">' . translate('LBL_STYLE_' . strtoupper($name), 'Notify') . '</div>';
	echo '<div class="form-value">';
	echo '<textarea oninput="notifyTemplateUpdated()" class="input-text input-block notify-style" rows="3" name="' . $name . '">' . to_html($css) . '</textarea>';
	echo '</div></div>';
} ?>
</div>
<div class="column form-cell">
<div class="form-entry"><div class="form-value">
	<div style="width: 700px; overflow-y: auto; background: #FFF; margin: 0 auto">
	<iframe id="notify-preview-iframe" style="border: none; width: 700px; height: 600px; overflow-y: auto"></iframe>
	</div>
</div></div>
</div>
</div>
</div>
</div>
</form>

<?php
/*
if($msg) {
			$msg->addRecordId($id);

			NotifyManager::record_notify_targets($model, $act, $this->getPrimaryKeyValue(), $targets, $this->getUserId());
 */

