<?php

if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once 'include/database/ListQuery.php';

$json_supported_actions['notify_preview'] = array('login_required' => 'true');

function json_notify_preview()
{
	$model = array_get_default($_REQUEST, 'preview_model', 'Meeting');
	$action = array_get_default($_REQUEST, 'preview_action', 'assigned');
	$lq = new ListQuery($model);
	$lq->setOrderBy( [ ['field' => 'date_entered', 'order' => 'desc'] ] );
	$lq->addAclFilter('list');
	$res = $lq->runQuerySingle();

	$styles = array_get_default($_REQUEST, 'styles');
	$text_format = array_get_default($_REQUEST, 'text');
	require_once 'include/Notify/RecordActionMessage.php';
	require_once 'include/Notify/NotifyTargets.php';
	require_once 'include/Notify/NotifyFormatter.php';

	$ts = [ ['bean_name' => 'User', 'id' => AppConfig::current_user_id()] ];
	$targets = NotifyTargets::target_list($ts);
	$params = null;
	$fields = array_get_default($_REQUEST, 'fields');
	if ($fields)
		$params = ['override_fields' => $fields];

	$msg = RecordActionMessage::for_action($model, $action, null, $params);
	$msg->addRecordId($res->getField('id'));

	$fmt = NotifyFormatter::create_standard();
	$fmt->setStandalone();
	reset($targets->targets);
	$t = current($targets->targets);
	$fmt->setTarget($t);
	//$mf = $msg->formatMessage($fmt);
	$params = ['logo' => '&nbsp;'];
	if (!empty($styles))
		$params['styles'] = $styles;
	if($text_format)
		$body = '<pre>' . to_html($fmt->renderMessagesText([$msg], $params)) . '</pre>';
	else
		$body = $fmt->renderMessages([$msg], $params);
	$ret = ['body' => $body ];
	json_return_value($ret);
}

