{*
Note: for email usage, the HTML should prefer tables to divs and
inline any necessary CSS styles. Separate <style> blocks can be used,
but only for optional enhancements.
*}

{if ! $params.body_only}
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html>
<head>
{if $params.site_url}<base href="{$params.site_url}">{/if}
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="viewport" content="width=device-width" />
<meta name="format-detection" content="telephone=no" />
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1" />
{if $params.title}<title>{$params.title}</title>{/if}
{if $params.standalone}
<style type="text/css">
.input-icon {
	background-repeat: no-repeat;
	display: inline-block;
	width: 16px;
	height: 16px;
	line-height: 16px;
	vertical-align: baseline;
}
input, textarea { {$params.styles.text_input} }
textarea {	padding: 3px; }
body { {$params.styles.body}  }
</style>
{/if}
{$params.favicon}
{$params.std_include}

<style type="text/css">
/* outlook.com fixes */
table { border-collapse:separate; }
a, a:link, a:visited { text-decoration: none; color: #00788a; }
a:hover { text-decoration: underline; }
h2,h2 a,h2 a:visited,h3,h3 a,h3 a:visited,h4,h5,h6,.t_cht { color:#000 !important; }
.ExternalClass p, .ExternalClass span, .ExternalClass font, .ExternalClass td { line-height: 100%; }
.ExternalClass { width: 100%; }

.notify-outer { {$params.styles.outer} }
.message-title {
	position: relative;
	{$params.styles.message_title_container}
}
.message-title h3 { {$params.styles.message_title} }
.itemNumber {  {$params.styles.item_number}   }
.badge {
	background: rgba(255, 255, 255, 0.7);
	color: #888;
	border-radius: 4px;
	text-transform: uppercase;
	font-size: 80%;
	font-weight: bold;
	line-height: 100%;
	margin-top: 2px;
	padding: 0;
	white-space: nowrap;
	border: 1px solid #999;
	cursor: default;
}
.badge td {
	padding: 2px 4px;
}
.badge-active {
{$params.styles.badge_active}
}
.badge-draft {
{$params.styles.badge_draft}
}
.badge-neutral {
{$params.styles.badge_neutral}
}
.badge-pending {
{$params.styles.badge_pending}
}
.badge-deferred {
{$params.styles.badge_deferred}
}
.badge-closed {
{$params.styles.badge_closed}
}
.badge-dead {
{$params.styles.badge_dead}
}
.badge-warn {
{$params.styles.badge_warn}
}
.badge-error {
{$params.styles.badge_error}
}
.prop-name {
{$params.styles.prop_name}
}
.prop-value {
{$params.styles.prop_value}
}
.message-button, .message-button:link, .message-button:visited {
	{$params.styles.button_normal}
}
.message-button.default, .message-button.default:link, .message-button.default:visited {
	{$params.styles.button_default}
}
.message-row {
	{$params.styles.message_row}
}
.message-row.last {
	{$params.styles.message_row_last}
}
</style>
<style type="text/css">
@charset "UTF-8";
.message-title h3:before {
	float: left;
	font-family: "Apple Color Emoji", "Segoe UI Emoji", "NotoColorEmoji", "Segoe UI Symbol", "Android Emoji", "EmojiSymbols";
    font-size: 120%;
    font-weight: bold;
    line-height: 100%;
    margin-right: 0.3em;
    color: #999;
    content: "📋";
}
.message-error .message-title h3:before {
    content: "⚠";
}
.message-success .message-title h3:before {
	content: "✅";
}
.message-upcoming .message-title h3:before {
	content: "🕒";
}
.message-query .message-title h3:before {
	content: "🎭";
}
.message-assigned .message-title h3:before {
	content: "📥";
}
.message-expire_warn .message-title h3:before, .message-expired .message-title h3:before,
.message-overdue .message-title h3:before {
	content: "⌛";
}
</style>

{$params.head_include}

</head>
<body>

{$params.body_include}

<table class="notify-outer" cellpadding="0" cellspacing="0" border="0" width="100%" style="margin-top: 1em; {$params.body_style}">
<tr>
<td width="1.5%">&nbsp;</td>
<td>
{/if}

{if $params.standalone}
<table class="notify-head" cellpadding="0" cellspacing="0" border="0" width="100%" style="margin-top: .5em">
<tr>
<td width="5">&nbsp;</td>
<td>
	{$params.logo}
</td>
</tr>
</table>
{/if}

{foreach from=$messages item=message name=msgloop}
{$message.before}
{if $message.form}
<form id="{$message.form.id}" name="{$message.form.name}" action="{$message.form.action}" method="{$message.form.method|default:'POST'}" style="padding: 0; margin: 0; {$message.form.style}">
	{foreach from=$message.form.params item=param}
		<input type="hidden" name="{$param.name|escape:'html'}" value="{$param.value|escape:'html'}" />
	{/foreach}
{/if}
<table class="message-outer {if $message.kind}message-{$message.kind}{/if}" cellpadding="0" cellspacing="0" border="0" style="margin: 1em 0 1em 0; width: 100%;">
<tr>
<td>
	<table class="message-title" cellpadding="0" cellspacing="0" border="0" width="100%">
	<tr>
	<td width="15">&nbsp;</td>
	<td style="padding: .25em 0">
		{if $message.title}
		<h3 style="font-family: Geneva, Helvetica, Arial, sans-serif; {if $params.standalone}font-size: 110%{else}font-size: 100%{/if}; font-weight: normal; margin: 0; padding: .5em 0 .4em 0; line-height: 120%">{$message.title}</h3>
		{/if}
	</td>
	<td width="15">&nbsp;</td>
	</tr>
	</table>
	
	{foreach from=$message.rows item=row name=rowloop}
		<table class="message-row {if $smarty.foreach.rowloop.last}last{/if}" cellpadding="0" cellspacing="0" border="0" width="100%">
		{if $row.head}
		<tr>
		<td width="15">&nbsp;</td>
		<td style="padding: 0.5em 0" class="message-head">
			{$row.head}
		</td>
		<td width="15">&nbsp;</td>
		</tr>
		{/if}
		
		{foreach from=$row.records item=rec name=recloop}
		<tr>
		<td width="15" {if $smarty.foreach.recloop.index %2}style="background: #fafafa"{/if}>&nbsp;</td>
		<td style="padding: 0.5em 0; {if $smarty.foreach.recloop.index %2}background: #fafafa{/if}; {if !$smarty.foreach.recloop.last}border-bottom: 1px solid #eee{/if}">
	
			<h2 style="font-size: 110%; font-weight: normal; margin: 0.1em 0 0 0; letter-spacing: 0.06em">{$rec.name}</h2>
	
			{if $rec.props}
			<table cellpadding="0" cellspacing="0" border="0" style="margin: 0.1em 0 0.1em 1.5em">
			{foreach from=$rec.props item=prop}
			<tr style="vertical-align: top">
			<td class="prop-name">{$prop.name}</td>
			<td class="prop-value">{$prop.value}</td>
			</tr>
			{/foreach}
			</table>
			{/if}
		</td>
		<td width="15" {if $smarty.foreach.recloop.index %2}style="background: #fafafa"{/if}>&nbsp;</td>
		</tr>
		{/foreach}
		
		{if $row.body}
		<tr>
		<td width="15">&nbsp;</td>
		<td style="padding: 0.5em 0 1em 0" class="message-body">
			{$row.body}
		</td>
		<td width="15">&nbsp;</td>
		</tr>
		{/if}
		
		{if $row.buttons}
		<tr>
		<td width="15">&nbsp;</td>
		<td style="padding: 0.4em 0 0.8em 0">
			{foreach from=$row.buttons item=btn}
				<a class="message-button {$btn.class}" href="{$btn.url|default:'#'}" onclick="{$btn.onclick}" style="display: inline-block;  {$btn.style}" title="{$btn.title}">{$btn.label}</a>
			{/foreach}
		</td>
		<td width="15">&nbsp;</td>
		</tr>
		{/if}
	
		</table>
	{/foreach}
	
	{if $smarty.foreach.msgloop.last && $params.footer}
	<table class="message-footer" cellpadding="0" cellspacing="0" border="0" width="100%" style="margin-top: 1em">
	<tr>
	<td width="15">&nbsp;</td>
	<td style="padding: 0.3em 0">
		<span style="font-size: 80%">
			{$params.footer}
		</span>
	</td>
	<td width="15">&nbsp;</td>
	<td style="padding: 0.3em 0" align="right" width="10%">
		<span style="font-weight: bold; letter-spacing: 0.05em; color: #bbb">{$params.app_signature}</span>
	<td width="15">&nbsp;</td>
	</tr>
	</table>
	{/if}
</td>
</tr>
</table>
{if $message.form}</form>{/if}
{$message.after}
{/foreach}


{if $params.extern}
<table class="notify-foot" cellpadding="0" cellspacing="0" border="0" width="100%" style="margin: 1.5em 0 0.5em 0;">
<tr>
<td width="20">&nbsp;</td>
<td>
	{$params.company_address}
</td>
<td width="20">&nbsp;</td>
</tr>
</table>
{/if}


{if ! $params.body_only}
</td>
<td width="1.5%">&nbsp;</td>
</tr>
</table>

{$params.foot_include}
</body>
</html>
{/if}
