function initOppForm(form) {
	var setStage = function() {
		var forecast_cats = app_list_strings('sales_forecast_dom');
		var probabilities = app_list_strings('sales_probability_dom');
		var stage = this.getValue();

		if(isset(stage)) {
			var probability_val = 0;
			if (probabilities[stage])
				probability_val = probabilities[stage];

			var probability = SUGAR.ui.getFormInput(this.form, 'probability'),
				forecast = SUGAR.ui.getFormInput(this.form, 'forecast_category');
			if(probability)
				probability.setValue(probability_val);
			if (forecast_cats[stage] && forecast)
				forecast.setValue(forecast_cats[stage]);
		}
	}

	var updateExchangeRate = function (oldrate, newrate) {
		var amount = SUGAR.ui.getFormInput(this.form, 'amount');
		if(amount) {
			amount.decimals = this.getDecimals();
			if(! amount.isBlank())
				amount.setValue(amount.getValue(true) * newrate / oldrate);
		}
	}

	var accountChanged = function(id, extra) {
		cur_input.setValueAndRate(extra.currency_id, extra.exchange_rate);
	}

	SUGAR.ui.attachFormInputEvent(form, 'currency', 'onrateupdate', updateExchangeRate);
	SUGAR.ui.attachFormInputEvent(form, 'sales_stage', 'onchange', setStage);
	SUGAR.ui.attachFormInputEvent(form, 'account', 'onchange', accountChanged);

	var cur_input = SUGAR.ui.getFormInput(form, 'currency');
	var account_input = SUGAR.ui.getFormInput(form, 'account');
	if (account_input)
		account_input.addExtraReturnFields({currency_id: 'currency_id', exchange_rate: 'exchange_rate'});
}
