<?php
require_once 'modules/PDFTemplates/PDFTemplateProviderBase.php';

class PDFTemplateBasicProvider extends PDFTemplateProviderBase
{
	public function __construct($mod)	{	}
	
	public static function template_types()
	{
		return array(
			'basic' => translate('LBL_BASIC_TEMPLATE', 'PDFTemplates'),
		);
	}
	
	public static function template_skeleton($type){}
	public static function template_sample_data($type) {}
	public static function create($type) {}

	public function begin()
	{
	}
	
	public function iterate(PDFTemplatePrinter $p)
	{
		$p->renderSection($this->findSection('header'), $this->getData('header'));
	}
	
	protected function findSection($name)
	{
		foreach ($this->layout['sections'] as $s) {
			if ($s['name'] == $name)
				return $s;
		}
		return array();
	}
	
	public function end()
	{
	}
	
	public function getFileName()
	{
		$filename =  $this->row->getModelName() . '_' . $this->getNoteTitle();
		$filename = preg_replace('~\.+$~', '', trim($filename));
		$filename .= '.pdf';
		return $filename;
	}
	
	public function getRow()
	{
		return $this->row;
	}
	
	public function getNoteTitle()
	{
		return $this->row->getField($this->display_name);
	}

	public function getEmailTitle()
	{
		return $this->getNoteTitle();
	}
	
	public function getData($section = null)
	{
		if (empty($this->data))
			$this->createData();
		if (!$section)
			return $this->data;
		return array_get_default($this->data, $section, array());
	}

	protected function createData()
	{
		$this->data = array();
		$this->data['header'] = $this->header_data;
	}
	
	
	public function initialize($layout, ListQuery $lq)
	{
		$lq->addField('assigned_user.name', 'assigned_user_name');
		$this->display_name = $lq->addDisplayName();
		$fs = array_merge(
			$lq->base_model->getColumnFields(),
			$lq->base_model->getCustomFields()
		);
		$fs = $lq->base_model->getFieldDefinitions();
		foreach ($fs as $f) {
			if (isset($f['vname']) && in_array($f['type'], self::$field_types)) {
				$lq->addField($f['name'], '_' . $f['name'], false, false, true);
			}
		}
		parent::initialize($layout, $lq);
	}

}

