<?php

require_once 'include/pdf/PDFManager.php';

class PDFTemplatePDFManager extends PDFManager
{
	private $printer;

	protected $last_set_font;

	public function loadLayout($layout, PDFTemplatePrinter $printer)
	{
		$this->printer = $printer;

		if(is_countable($layout['sections']) && count($layout['sections'])) {
			if ($layout['sections'][0]['name'] == 'page_header')
				$this->printer->setHeaderSection($layout['sections'][0]);

			$idx = count($layout['sections']) - 1;
			if ($layout['sections'][$idx]['name'] == 'page_footer')
				$this->printer->setFooterSection($layout['sections'][$idx]);
		}
	}
	
	public function getProvider() {
		if($this->printer) return $this->printer->getProvider();
	}

	public function SetFont($family, $style = '', $size = NULL, $fontfile = '', $subset = 'default', $out = true) {
		$this->last_set_font = array($family, $style, $size);
		return parent::SetFont($family, $style, $size);
	}
	
	function Header()
	{
		$f = $this->last_set_font;
		$this->printer->renderHeaderFooter();
		if ($f)
			$this->SetFont($f[0], $f[1], $f[2]);
	}

	function Footer()
	{
		$this->InFooter = true;
		$this->AliasNbPages();
		$f = $this->last_set_font;
		$this->printer->renderHeaderFooter(true);
		if ($f)
			$this->SetFont($f[0], $f[1], $f[2]);
		$this->InFooter = false;
	}
}
