<?php

require_once('include/layout/forms/FormField.php');
require_once 'modules/PDFTemplates/PDFTemplateProviderBase.php';

class PDFTemplateModuleWidget extends FormField {

	function init($params=null, $model=null) {
		parent::init($params, $model);
	}
	
	function getRequiredFields() {
		return array('template_module', 'template_type');
	}
	
	function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context)
	{
		return $this->render_the_field($row_result);
	}
	
	function renderListValue(ListFormatter $fmt, ListResult $result, $row_id, $list_params=null)
	{
		$row = $result->getRowResult($row_id);
		return $this->render_the_field($row);
	}

	private function render_the_field(RowResult $row_result)
	{
		if ($this->name == 'template_module') {
			$ret = isset($GLOBALS['app_list_strings']['moduleList'][$row_result->row['template_module']]) ? $GLOBALS['app_list_strings']['moduleList'][$row_result->row['template_module']] : null;
		} else {
			$module = $row_result->row['template_module'];
			$arr = PDFTemplateProviderBase::get_template_types($module);
			$ret = array_get_default($arr, $row_result->row['template_type']);
		}
		return $ret;
	}
}

