<?php

namespace OneCRM\PaymentProcessors;

class OptionSetRecord extends ChargeBeeRecord{

    public $name = 'OptionSet';                     // name of object at Payment Processor
    public $ppid_field = 'id';                      // PP unique id field name
    public $model = 'OptionSet';                    // name of matching 1CRM Model
    public $model_ppid_field = 'pp_optionset_id';   // 1CRM Model field name holding PP unique id
    public $map=[
        "id" => "pp_optionset_id",
        "name" => "name",
        "description" => "description",
        "updated_at" => "date_modified",
        "currency_code" => "currency",      // ISO
    ];


    /**
     * normalization of records:
     */

    /**
     * translates $this->native to $this->onecrm
     * @param array|null $data
     * @return BaseRecord $this
     * @throws \OneCRM\API\Errors\BadRequest
     */
    public function to_onecrm($data=null)
    {
        // copy the fields defined by the map:
        parent::to_onecrm($data);

        // OptionSet-specific fields:
        die ('TODO: $map');

        return $this;
    }

    /**
     * translates $this->onecrm to $this->native
     * @param array|null $data
     * @return BaseRecord $this
     */
    public function to_native($data=null)
    {
        // copy the fields defined by the map:
        parent::to_native($data);

        // accon-specific fields:
        die('TODO: optionset to_native()');

        return $this;
    }




}
