<?php

function update_subscriptions_mrr() {
	require_once __DIR__ . '/vendor/autoload.php';
	require_once 'modules/PaymentProcessors/PaymentProcessor.php';
	$pp = PaymentProcessor::getDefault();
	if (! $pp instanceof PaymentProcessorChargeBee) {
		return;
	}
	$threshold = gmdate('Y-m-d H:i:s', strtotime('-5 minutes'));

	$lq = new ListQuery('Subscription');
	$lq->addFilterClause(['operator' => 'literal', 'value' => "((date_modified > mrr_retrieved AND date_modified <= '$threshold') OR mrr_retrieved IS NULL)"]);
	foreach ($lq->getIterator() as $sub) {
		try {
			$ext_id = $sub->getField('pp_subs_id');
			$result = ChargeBee_Subscription::retrieve($ext_id);
			$subscription = $result->subscription();
			$upd = RowUpdate::for_result($sub);
			$upd->set([
				'next_billig_date' => null,
				'mrr' => $subscription->mrr / 100,
				'mrr_retrieved' => $sub->getField('date_modified'),
				'date_modified' => $sub->getField('date_modified'),
			]);
			if (!empty($subscription->nextBillingAt)) {
				$upd->set('next_billing_date', gmdate('Y-m-d H:i:s', $subscription->nextBillingAt));
			}
			$upd->update_date_modified = false;
			$upd->save();
		} catch (ChargeBee_APIError $e) {
		} catch (Exception $e ) {
		}
	}
}

