<?php

require_once('include/layout/forms/FormField.php');


class PaymentProcessorChargeBeeHint extends FormField {

	function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context) {
		$json = getJSONobj();
		$site_url = rtrim(AppConfig::site_url(), '/');
		$webhook_url = $site_url . '/api.php/subscription/events/ChargeBee';
		$webhook_url_json = to_html($json->encode($webhook_url));
		$lbl_copied = $json->encode(translate('LBL_URL_COPIED', 'PaymentProcessors'));
		$lbl_copy_error = $json->encode(translate('LBL_URL_COPY_ERROR', 'PaymentProcessors'));
		return <<<HTML
<p>
When configuring webhook on ChargeBee site, use the following URL:
</p>
<p>
<i>$webhook_url</i>
</p>
<button type="button" class="input-button group-left first" onclick="chargebeeCopyTextToClipboard($webhook_url_json)">
	<div class="input-icon left icon-duplicate"></div>
	<span class="input-label">Copy URL to Clipboard</span>
</button>
<span id="chargebee-copy-result" style="opacity: 0; transition: opacity 0.5s ease-in-out"></span>

<script type="text/javascript">
function chargebeeCopyTextToClipboard(text) {
  var success;
  var textArea = document.createElement("textarea");
  textArea.style.position = 'fixed';
  textArea.style.top = 0;
  textArea.style.left = 0;
  textArea.style.width = '2em';
  textArea.style.height = '2em';
  textArea.style.padding = 0;
  textArea.style.border = 'none';
  textArea.style.outline = 'none';
  textArea.style.boxShadow = 'none';
  textArea.style.background = 'transparent';
  textArea.value = text;
  document.body.appendChild(textArea);
  textArea.focus();
  textArea.select();
  try {
    success = document.execCommand('copy');
  } catch (err) {
  }
  document.getElementById('chargebee-copy-result').innerText = success ? $lbl_copied : $lbl_copy_error;
  document.getElementById('chargebee-copy-result').style.opacity = 1;
  if (success) {
	  setTimeout(function() {
  			document.getElementById('chargebee-copy-result').style.opacity = 0;
		}, 500);
	}
  document.body.removeChild(textArea);
}

</script>
HTML;
	}
}

