<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/Payments/Payment.php
	audit_enabled: true
	activity_log_enabled: true
	unified_search
		enabled: true
		default: false
	duplicate_merge: false
	table_name: payments
	primary_key: id
	default_order_by: full_number
	display_name
		type: prefixed
		fields
			- full_number
			- name
	reportable: true
	primary_account: account
	record_status: direction
	edit_sequence: true
hooks
	new_record
		--
			class_function: init_record
	after_delete
		--
			class_function: after_delete
	fill_defaults
		--
			class_function: fill_defaults
	before_save
		--
			class_function: before_save
	after_save
		--
			class_function: save_line_items
	after_add_link
		--
			class_function: after_add_link
	before_subpanel_create
		--
			class: Payment
			file: modules/Payments/Payment.php
			class_function: before_subpanel_create
fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
	app.assigned_user
	app.created_by_user
	app.modified_user
	app.currency
		required: true
	amount
		vname: LBL_RECEIVED_AMOUNT
		vname_list: LBL_LIST_RECEIVED
		type: currency
		required: true
		audited: true
		base_field: amount_usdollar
		min: 0
	total_amount
		vname: LBL_TOTAL_ALLOCATED
		type: currency
		currency: applied_currency
		required: true
		base_field: total_amount_usdollar
		editable: false
	payment_date
		vname: LBL_PAYMENT_DATE
		type: date
		required: true
		vname_list: LBL_LIST_PAYMENT_DATE
		updateable: false
		massupdate: true
	prefix
		vname: LBL_PAYMENT_PREFIX
		type: sequence_prefix
		sequence_name: payment_prefix
	payment_id
		vname: LBL_PAYMENT_ID
		type: sequence_number
		sequence_name: payment_number_sequence
		prefix_name: prefix
		vname_sequence: LBL_PAYMENT_NUMBER
		required: true
		unified_search: exact
	full_number
		vname: LBL_PAYMENT_NUMBER
		type: item_number
		source
			type: sequence
			fields
				- prefix
				- payment_id
		unified_search: prefix
	customer_reference
		vname: LBL_CUSTOMER_REFERENCE
		type: varchar
		len: 50
		width: 20
	notes
		vname: LBL_NOTES
		type: text
	payment_type
		vname: LBL_PAYMENT_TYPE
		type: enum
		options: payment_type_dom
		len: 40
		required: true
		audited: true
		vname_list: LBL_LIST_PAYMENT_TYPE
		updateable: false
		massupdate: false
	direction
		type: status
		options: payment_direction_dom
		len: 20
		default: incoming
		vname: LBL_PAYMENT_DIRECTION
		massupdate: false
		required: true
		audited: true
		updateable: false
	refund
		type: bool
		default: 0
		vname: LBL_REFUND
		massupdate: false
	account
		vname: LBL_ACCOUNT_ID
		type: ref
		bean_name: Account
		massupdate: false
		required: true
		updateable: false
	refunded
		vname: LBL_REFUNDED
		type: bool
		default: 0
		massupdate: true
	related_invoice
		vname: LBL_RELATED_INVOICE
		type: ref
		bean_name: Invoice
		editable: false
	applied_currency
		vname: LBL_APPLIED_CURRENCY
		type: currency_ref
		exchange_rate: applied_rate
		default: null
	applied_amount
		vname: LBL_APPLIED_AMOUNT
		vname_list: LBL_LIST_APPLIED
		type: currency
		currency: applied_currency
		base_field: applied_amount_usdollar
	applied_rate
		vname: LBL_APPLIED_RATE
		type: exchange_rate
	effective_rate
		vname: LBL_EFFECTIVE_RATE
		type: exchange_rate
	actual_rate
		vname: LBL_ACTUAL_RATE
		type: exchange_rate
		default: null
	currency_converted
		vname: LBL_CURRENCY_CONVERTED
		type: bool
		default: 0
links
	app.signed_documents
	invoices
		relationship: invoices_payments
		vname: LBL_INVOICE_ALLOCATION
		layout: Payments
		managed: true
	credits
		relationship: credits_payments
		vname: LBL_PAYMENT_CREDITS
		layout: Payments
		managed: true
	bills
		relationship: bills_payments
		vname: LBL_BILL_ALLOCATION
		layout: Payments
		managed: true
	fees
		relationship: payment_payment_fees
		vname: LBL_PAYMENT_FEES
		managed: true
relationships
	app.signed_documents

