<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo,
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');


require_once 'data/SugarBean.php';
require_once 'modules/PriceBooks/PriceBookFormulaParser.php';

class PriceBook extends SugarBean
{
	// Stored fields
	var $id;
	var $name;
	var $editable;
	var $deleted;
	var $date_entered;
	var $date_modified;
	var $formula;

	var $table_name = "price_books";
	var $object_name = "PriceBook";
	var $module_dir = "PriceBooks";
	var $new_schema = true;

	var $required_fields = array('name'=>1);


	static function validate_custom_formula(RowUpdate &$upd) {
		return self::validate_formula($upd, 'custom_formula');
	}

	static function validate_formula(RowUpdate &$upd, $field_name = 'formula') {
		try {
			PriceBookFormulaParser::parse($upd->getField($field_name));
		} catch (PriceBookFormulaParserException $e) {
			$upd->addValidationError('invalid_formula', $field_name);
		}
    }

}

