<?php

require_once 'include/layout/widgets/QuickEditListElt.php';

class PriceBookFormulaWidget extends QuickEditListElt {
	function getRequiredFields() {
		$f = parent::getRequiredFields();
		$f[] = '~parent.formula';
		$f[] = '~parent.editable';
		$f[] = '~join.custom_formula';
		return $f;
	}
	
	function renderListValue(ListFormatter $fmt, ListResult $result, $row_id, $list_params=null) {
		if (!empty($result->rows[$row_id]['~parent.editable'])) {
			$custom = $result->rows[$row_id]['~join.custom_formula'];
			if (!strlen(trim($custom))) {
				$result->rows[$row_id]['~join.custom_formula'] = $result->rows[$row_id]['~parent.formula'];
				$result->formatted_rows[$row_id]['~join.custom_formula'] = $result->formatted_rows[$row_id]['~parent.formula'];
			}
			$ret = parent::renderListValue($fmt, $result, $row_id, $list_params);
		} else {
			$ret = $result->formatted_rows[$row_id]['~parent.formula'];
		}
		return $ret ;
	}
}

