<?php

require_once('include/layout/forms/FormField.php');
require_once('modules/PriceBooks/PriceBookFormulaParser.php');
require_once('modules/PriceBooks/utils.php');
require_once('modules/ProductCatalog/Product.php');

class PopupPriceFromPriceBook extends FormField {
	function renderListValue(ListFormatter $fmt, ListResult $result, $row_id, $list_params=null) {
		static $cache = array();
		static $all_cache = array();
		$rrow = $result->rows[$row_id];

		$pricebook_id = array_get_default($_REQUEST, 'pricebook_id');
		$vars = array(
			'list_price'=> $rrow['list_price'],
			'cost' => $rrow['cost'],
			'purchase_price' => $rrow['purchase_price'],
		);
		$dcurrency = $fmt->display_currency_id;
		$convert = true;
		$price = Product::calc_pricebook_price($pricebook_id, $row_id, $vars);
		if(isset($price)) {
			if(! empty($price[2])) {
				$dcurrency = $price[2];
				$convert = false;
				$rrow['currency_id'] = $dcurrency;
			}
			$spec = array(
				'name' => $this->name,
				'type' => 'currency',
				'currency_id' => 'currency_id',
				'display_converted' => $convert,
				'base_field' => '___',
				'display_currency_id' => $dcurrency,
			);
			$rrow['___'] = $price[0];
			return 
				get_module_header_icon('PriceBooks', '')
				. '&nbsp;' . $fmt->field_formatter->formatRowValue($spec, $rrow, $price[1]);
		}

		return parent::renderListValue($fmt, $result, $row_id, $list_params);
	}
}

