<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */

if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once 'modules/Project/gantt.php';
require_once 'modules/ProjectTask/ProjectTask.php';
require_once 'include/database/ListQuery.php';
require_once 'include/database/RowUpdate.php';

$proj_id = $_REQUEST['project_id'];

if (!empty($_REQUEST['move'])) {
	$task = new ProjectTask;
	$tid = $_REQUEST['move'];
	$task = ListQuery::quick_fetch('ProjectTask', $tid);
	$dir = $_REQUEST['dir'];
	if ($task && $task->getField('parent_id') == $proj_id) {
		$lq = new ListQuery('ProjectTask');
		$lq->addSimpleFilter('parent_id', $proj_id);
		$result = $lq->runQuery(0, null, false, 'order_number');
		$count = $result->getResultCount();
		$delta = 0;
		$i = 0;
		$up = $down = -1;
		foreach ($result->getRowIndexes() as $idx) {
			$i++;
			$row = $result->getRowResult($idx);
			if ($row->getField('id') === $tid) {
				if ($dir == 'down' && $i < $count) {
					$up = $i;
					$down = $i - 1;
				} elseif ($dir == 'up' && $i > 1) {
					$up = $i - 1;
					$down = $i - 2;
				}
			}
		}
		$i = -1;
		foreach ($result->getRowIndexes() as $idx) {
			$i++;
			$upd = $result->getRowUpdate($idx);
			$order = $i;
			if ($i == $up) $order--;
			elseif ($i == $down) $order++;
			$upd->set('order_number', $order);
			$upd->save();
		}
		$renderer = new GanttRender();
		$chart = $renderer->render($proj_id);
		echo $chart; exit;
	}
}

