<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */

require_once('modules/Workflow/WFProcessorBase.php');

class CreateProjectProc extends WFProcessorBase {
	var $related_model = 'Project';

	function initRelatedRecord(RowUpdate $rowUpdate) {
		$project = parent::initRelatedRecord($rowUpdate);
		$project->set('date_starting', $this->getRelativeDate('date_starting', false));
		$project->set('date_ending', $this->getRelativeDate('date_ending', false));
		$this->setValuesWithAlt($rowUpdate, $project, ['account'], $this->getParams());
		return $project;
	}
	
	function getConfigFields() {
		$fields = parent::getConfigFields();
		
		$model = new ModelDef('Project');
		
		$fields['name'] = $model->getFieldDefinition('name');
		$fields['name']['width'] = 40;
		$fields['account'] = $model->getFieldDefinition('account');
		$fields['account_id'] = array('type' => 'ref_id', 'hidden' => true);
		$fields['account']['alt_options'] = $this->getRelatedRefFields('Account');
		$fields['account_alt'] = array('type' => 'varchar', 'hidden' => true);
		$fields['currency'] = $model->getFieldDefinition('currency');
		$fields['currency_id'] = array('type' => 'ref_id', 'hidden' => true);
		$fields['amount'] = $model->getFieldDefinition('amount');

		$fields['date_starting'] = $model->getFieldDefinition('date_starting');
		$fields['date_starting']['widget'] = 'RelativeTimeInput';
		$fields['date_starting_type']['hidden'] = true;
		$fields['date_starting_count'] = array(
			'type' => 'int',
			'hidden' => true,
		);

		$fields['date_ending'] = $model->getFieldDefinition('date_ending');
		$fields['date_ending']['widget'] = 'RelativeTimeInput';
		$fields['date_ending_type']['hidden'] = true;
		$fields['date_ending_count'] = array(
			'type' => 'int',
			'hidden' => true,
		);
		$fields['lead_source'] = $model->getFieldDefinition('lead_source');
		$fields['use_timesheets'] = $model->getFieldDefinition('use_timesheets');
		$fields['description'] = $model->getFieldDefinition('description');
		
		return $fields;
	}

}

