<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */


require_once('include/layout/forms/FormTableSection.php');
require_once('modules/Project/Project.php');

class GanttChartWidget extends FormTableSection {
	function init($params=null, $model=null) {
		parent::init($params, $model);
		if(! $this->id)
			$this->id = 'project_gantt';
	}
	
	function renderHtml(HtmlFormGenerator $gen, $row_result, array $parents, array $context) {
        global $current_user, $app_strings, $mod_strings;
        
		if($gen->getLayout()->getEditingLayout()) {
			$params = array();
			return $this->renderOuterTable($gen, $parents, $context, $params);		
		}
		if (!$row_result->getField('id')) return;
		
		require_once('modules/Project/gantt.php');
		$renderer = new GanttRender();
		$chart = $renderer->render($row_result->getField('id'));

		$body = <<<EOQ
			<div id="{$this->id}-main" class="gantt-main">
				<div class="row form-row">
					<div class="column form-cell expand"><div class="form-entry">
					<section class="card-outer panel-outer panel-default gantt-outer panel-border panel-round panel-readonly">
						<div id="gantt-body" class="card-body panel-body panel-pad-body gantt-body">
							{$chart}
						</div>
					</section>
					</div></div>
				</div>
			</div>
EOQ;

		$params = ['body' => $body];
        return $this->renderOuterTable($gen, $context, $parents, $params);
	}

}
?>
