<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/Prospects/Prospect.php
	unified_search: true
	duplicate_merge: false
	table_name: prospects
	primary_key: id
	reportable: true
	importable: LBL_PROSPECTS
	personal_data: true
fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
	app.modified_user
	app.assigned_user
	app.created_by_user
	name
		vname: LBL_NAME
		type: name
		source
			type: person_name
			fields
				- first_name
				- last_name
				- salutation
		importable: false
		unified_search: true
	tracker_key
		vname: LBL_TRACKER_KEY
		type: int
		len: 11
		required: true
		auto_increment: true
		importable: false
	salutation
		vname: LBL_SALUTATION
		type: enum
		options: salutation_dom
		massupdate: false
		len: 20
		audited: true
		personal_info: true
	first_name
		vname: LBL_FIRST_NAME
		type: varchar
		len: 100
		audited: true
		personal_info: true
	last_name
		vname: LBL_LAST_NAME
		type: name
		len: 100
		required: false
		audited: true
		personal_info: true
	title
		vname: LBL_TITLE
		type: varchar
		len: 100
		vname_list: LBL_LIST_TITLE
		audited: true
		personal_info: true
	department
		vname: LBL_DEPARTMENT
		type: varchar
		len: 255
		audited: true
		personal_info: true
	birthdate
		vname: LBL_BIRTHDATE
		massupdate: false
		type: date
		audited: true
		personal_info: true
	do_not_call
		vname: LBL_DO_NOT_CALL
		type: bool
		dbType: varchar
		len: 3
		default: 0
		massupdate: true
	phone_home
		vname: LBL_HOME_PHONE
		type: phone
		unified_search: true
		audited: true
		personal_info: true
	phone_mobile
		vname: LBL_MOBILE_PHONE
		type: phone
		unified_search: true
		audited: true
		personal_info: true
	phone_work
		vname: LBL_OFFICE_PHONE
		type: phone
		unified_search: true
		vname_list: LBL_LIST_PHONE
		audited: true
		personal_info: true
	phone_other
		vname: LBL_OTHER_PHONE
		type: phone
		unified_search: true
		audited: true
		personal_info: true
	phone_fax
		vname: LBL_FAX_PHONE
		type: fax
		unified_search: true
		audited: true
		personal_info: true
	email1
		vname: LBL_EMAIL_ADDRESS
		type: email
		unified_search: true
		vname_list: LBL_LIST_EMAIL_ADDRESS
		audited: true
		personal_info: true
	email2
		vname: LBL_OTHER_EMAIL_ADDRESS
		type: email
		unified_search: true
		audited: true
		personal_info: true
	assistant
		vname: LBL_ASSISTANT
		type: varchar
		len: 75
		unified_search: true
		audited: true
		personal_info: true
	assistant_phone
		vname: LBL_ASSISTANT_PHONE
		type: phone
		unified_search: true
		audited: true
		personal_info: true
	email_opt_out
		vname: LBL_EMAIL_OPT_OUT
		type: bool
		dbType: varchar
		len: 3
		default: 0
		massupdate: true
	email_opt_in
		vname: LBL_EMAIL_OPT_IN
		type: bool
		default: 0
		massupdate: false
	email_opt_in_date
		type: date
		editable: false
		vname: LBL_EMAIL_OPT_IN_DATE
	primary_address_street
		vname: LBL_PRIMARY_ADDRESS_STREET
		type: varchar
		len: 150
		audited: true
		personal_info: true
	primary_address_city
		vname: LBL_PRIMARY_ADDRESS_CITY
		type: varchar
		len: 100
		audited: true
		personal_info: true
	primary_address_state
		vname: LBL_PRIMARY_ADDRESS_STATE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	primary_address_postalcode
		vname: LBL_PRIMARY_ADDRESS_POSTALCODE
		type: varchar
		len: 20
		audited: true
		personal_info: true
	primary_address_country
		vname: LBL_PRIMARY_ADDRESS_COUNTRY
		type: varchar
		len: 100
		audited: true
		personal_info: true
	primary_address_statecode
		vname: LBL_PRIMARY_ADDRESS_STATECODE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	primary_address_countrycode
		vname: LBL_PRIMARY_ADDRESS_COUNTRYCODE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	alt_address_street
		vname: LBL_ALT_ADDRESS_STREET
		type: varchar
		len: 150
		audited: true
		personal_info: true
	alt_address_city
		vname: LBL_ALT_ADDRESS_CITY
		type: varchar
		len: 100
		audited: true
		personal_info: true
	alt_address_state
		vname: LBL_ALT_ADDRESS_STATE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	alt_address_postalcode
		vname: LBL_ALT_ADDRESS_POSTALCODE
		type: varchar
		len: 20
		audited: true
		personal_info: true
	alt_address_country
		vname: LBL_ALT_ADDRESS_COUNTRY
		type: varchar
		len: 100
		audited: true
		personal_info: true
	alt_address_statecode
		vname: LBL_ALT_ADDRESS_STATECODE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	alt_address_countrycode
		vname: LBL_ALT_ADDRESS_COUNTRYCODE
		type: varchar
		len: 100
		audited: true
		personal_info: true
	description
		vname: LBL_DESCRIPTION
		type: text
	invalid_email
		vname: LBL_INVALID_EMAIL
		type: bool
		massupdate: true
	lead
		type: ref
		reportable: false
		vname: LBL_LEAD_ID
		bean_name: Lead
		massupdate: true
	account_name
		vname: LBL_ACCOUNT_NAME
		type: varchar
		len: 150
		audited: true
		personal_info: true
	last_activity_date
		vname: LBL_LAST_ACTIVITY
		type: datetime
		massupdate: true
	campaign
		comment: Campaign that generated lead
		vname: LBL_CAMPAIGN
		rname: id
		id_name: campaign_id
		type: ref
		table: campaigns
		isnull: true
		module: Campaigns
		reportable: false
		massupdate: false
		duplicate_merge: disabled
		bean_name: Campaign
	website
		vname: LBL_WEBSITE
		type: url
		len: 255
		comment: URL of website for the lead
		massupdate: true
		audited: true
		personal_info: true
	consent_to_process
		vname: LBL_CONSENT_TO_PROCESS
		type: bool
		privacy_consent: true
		audited: true
links
	activities
		relationship: prospects_activities
		module: Activities
		bean_name: Activity
		vname: LBL_ACTIVITIES_SUBPANEL_TITLE
	history
		relationship: prospects_history
		module: Activities
		bean_name: ActivityHistory
		layout: AccountHistory
		vname: LBL_HISTORY_SUBPANEL_TITLE
		icon: History
	campaigns
		relationship: prospect_campaign_log
		module: CampaignLog
		bean_name: CampaignLog
		vname: LBL_CAMPAIGNS
		no_create: true
		layout: WithoutTarget
	prospect_lists
		relationship: prospect_list_prospects
		module: ProspectLists
		vname: LBL_PROSPECT_LIST
	emails
		relationship: emails_prospects
		vname: LBL_EMAILS
		module: Emails
		bean_name: Email
	meetings
		relationship: meetings_prospects
		module: Meetings
		bean_name: Meeting
		vname: LBL_MEETINGS
	calls
		relationship: calls_prospects
		module: Calls
		bean_name: Call
		vname: LBL_CALLS
	notes
		relationship: notes_prospects
		module: Notes
		bean_name: Note
		vname: LBL_NOTES
	tasks
		relationship: tasks_prospects
		module: Tasks
		bean_name: Task
		vname: LBL_TASKS
	app.securitygroups
		relationship: securitygroups_prospects
indices
	prospect_auto_tracker_key
		fields
			- tracker_key
	idx_prospects_last_first
		fields
			- last_name
			- first_name
			- deleted
	idx_prospecs_del_last
		fields
			- last_name
			- deleted
relationships
	prospect_campaign_log
		key: id
		target_bean: CampaignLog
		target_key: target_id
		relationship_type: one-to-many
	emails_prospects
		key: id
		target_bean: Email
		target_key: parent_id
		role_column: parent_type
		role_value: Prospects
		relationship_type: one-to-many
	meetings_prospects
		key: id
		target_bean: Meeting
		target_key: parent_id
		role_column: parent_type
		role_value: Prospects
		relationship_type: one-to-many
	calls_prospects
		key: id
		target_bean: Call
		target_key: parent_id
		role_column: parent_type
		role_value: Prospects
		relationship_type: one-to-many
	notes_prospects
		key: id
		target_bean: Note
		target_key: parent_id
		role_column: parent_type
		role_value: Prospects
		relationship_type: one-to-many
	tasks_prospects
		key: id
		target_bean: Task
		target_key: parent_id
		role_column: parent_type
		role_value: Prospects
		relationship_type: one-to-many
	prospects_activities
		target_bean: Activity
		target_key: id
		sources
			meetings
				relationship: meetings_prospects
			calls
				relationship: calls_prospects
			tasks
				relationship: tasks_prospects
	prospects_history
		target_bean: ActivityHistory
		target_key: id
		sources
			meetings
				relationship: meetings_prospects
			calls
				relationship: calls_prospects
			tasks
				relationship: tasks_prospects
			notes
				relationship: notes_prospects
			emails
				relationship: emails_prospects
