contract_action_change = function(form, input_name) {
	var input = SUGAR.ui.getFormInput(form, input_name);
	
	SUGAR.dom.ExtNode(input.elt).closest('.form-row').find('.form-cell').removeClass('sm-3').addClass('sm-4');

	var display = [
		'none', 'none', 'none'
	];

    var prefix = 'subcontract';
    if (input.name == '__action_project')
        prefix = 'project';


	var inputs = [
		SUGAR.ui.getFormInput(form, '__' + prefix),
		SUGAR.ui.getFormInput(form, '__' + prefix + '_name'),
		SUGAR.ui.getFormInput(form, '__' + prefix + '_type')
	];


	if (input.getValue() == 'create_new') {
		display[1] = '';
		display[2] = '';
    } else if (input.getValue() == 'use_existing') {
		display[0] = '';
    }

	inputs.forEach(function(input, idx) {
		if (input) {
			SUGAR.dom.ExtNode(input.elt).closest('.form-cell').css('display', display[idx]);
		}
	});

};

create_contracts = function(form, list_id, parent_type, parent_id, account_id) {
    var errors = [];
	var map = {
		__action_subcontract: 'contract_action',
		__subcontract_type: 'contract_type',
		__subcontract_name: 'contract_name',
		__subcontract: 'contract_id',
		__action_project: 'project_action',
		__project_name: 'project_name',
		__project: 'project_id'
	};
    var params = {
        action: 'CreateProducts',
        account_id: account_id,
        parent_type: parent_type,
        parent_id: parent_id,
        no_redirect: 1
	};

	Object.keys(map).forEach(function(k) {
		var input = SUGAR.ui.getFormInput(form, k);
		if (input) {
			SUGAR.ui.addRemoveClass(input.elt.id, 'invalid', false);
			params[map[k]] = input.getValue();
		}
	});
    if (params.contract_action == 'create_new') {
        if (! params.contract_type.length) {
            errors.push('__subcontract_type');
        }
        if (! params.contract_name.length) {
            errors.push('__subcontract_name');
        }
    }
    if (params.project_action == 'create_new') {
        if (! params.project_name.length) {
            errors.push('__project_name');
        }
	}
	errors.forEach(function(k) {
		var input = SUGAR.ui.getFormInput(form, k);
		if (input) {
			SUGAR.ui.addRemoveClass(input.elt.id, 'invalid', true);
		}
	});
    if (errors.length) {
        return false;
    }

    var list = sListView.getListView(list_id);
    if(! list || ! list.form) {
        console.log("missing listview objects: "+list_id);
        return false;
    }
    var uidList = sListView.getUids(list_id);
    if(! uidList || ! uidList.getCount()) {
        alert(app_string('LBL_LISTVIEW_NO_SELECTED'));
        return false;
    }
    uidList.save();

    var success = function(data) { SUGAR.ui.PopupManager.close(); };

    try {
        return SUGAR.ui.sendForm(list.form, params, {receiveCallback: success}, false, true);
    } catch(e) {
        console.error(e); return false;
    }
};
