<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

function BuildSoapItemsList(&$focus)
{
	global $app_list_strings, $current_language;
	$mod_strings = return_module_language($current_language, 'Quotes');

	$ret = array(
		'groups' => array(),
		'extra' => array(),
	);

	$all_shipping_taxed = -1;
	//
	require_once 'include/Tally/TallyUpdate.php';
	require_once 'include/database/ListQuery.php';
	$result = ListQuery::quick_fetch($focus->object_name, $focus->id);
	$tally = new TallyUpdate($result);
	$tally->loadCurrency();
	$groups = $tally->getGroups();
	
	$currency = AppConfig::db_object('Currency', $focus->currency_id);
	$symbol = $currency->symbol;
	//
	$shipping_provider = AppConfig::db_object('ShippingProvider', $focus->shipping_provider_id);
	$shipper = $shipping_provider->name;
	unset($shipping_provider);
	//

	foreach ($groups as $key => $grp) {
		$tally->addBaseAmounts($grp, $tally->group_model, array('total', 'subtotal'));
		$group_stage = '&nbsp;';
		if($focus->object_name == 'Quote') {
			$group_stage = $mod_strings['LBL_GROUP_STAGE'].'&nbsp;<b>'.array_get_default($app_list_strings['quote_stage_dom'], $grp['status'], '').'</b>';
		}

		$group = array(
			'lines' => array(),
			'extra' => array(),
		);
		$lines =& $group['lines'];
		$extra =& $group['extra'];


		$taxes = array();
		$discounts = array();
		$row_shipping = '';
		$row_shipping_taxed = false;
		

		if(! empty($grp['adjusts'])) {
			foreach($grp['adjusts'] as $idx => $adj) {
				$tally->addBaseAmounts($adj, $tally->adj_model);
				$adj['desc'] = $adj['name'] . ' (' . format_number($adj['rate'], -1) . '%)';
				$adj['amount'] = currency_format_number($adj['amount'], $format_params);
				if($adj['type'] == 'StandardDiscount')
					$discounts[] = $adj;
				else if($adj['type'] == 'StandardTax' || $adj['type'] == 'CompoundedTax')
					$taxes[] = $adj;
				else if($adj['type'] == 'TaxedShipping' || $adj['type'] == 'UntaxedShipping') {
					$row_shipping = $adj['amount_usd'];
					$row_shipping_taxed = $adj['type'] == 'TaxedShipping';
				}
			}
		}

		if(! empty($grp['lines'])) {
			$top_index = 1;
			$next_line = array();
			$idx = '';
			foreach(array_keys($grp['lines']) as $nidx) {
				$next_line[$idx] = $nidx; $next_line[$nidx] = ''; $idx = $nidx;
			}
			foreach ($grp['lines'] as $idx => $line) {
				$tally->addBaseAmounts($line, $tally->line_model);
				$newline = array();
				if($line['depth']) {
					if(empty($line['is_comment']))
						$part_index ++;
					$show_top_index = '&nbsp;';
					$next = array_get_default($grp['lines'], $next_line[$idx]);
				} else {
					$show_top_index = $top_index;
					$part_index = '';
				}
				
				if(! empty($line['is_comment'])) {
					$newline['name'] = nl2br($line['body']);
				} else {
					if($focus->object_name != 'PurchaseOrder' && $focus->object_name != 'Bill') {
						$newline['cost_price'] = currency_format_number(array_get_default($line, 'cost_price_usd', $line['cost_price']), $format_params);
						$newline['list_price'] = currency_format_number(array_get_default($line, 'list_price_usd', $line['list_price']), $format_params);
					}
					$newline['unit_price'] = currency_format_number(array_get_default($line, 'unit_price_usd', $line['unit_price']), $format_params);
	
					$name = $line['name'];
					if($line['sum_of_components']) {
						$name = "<b>$name</b>";
					}
					$newline['name'] = $name;
					$newline['quantity'] = format_number($line['quantity'], -1);
					if(! $line['depth'])
						$top_index ++;
				}
				$lines[] = $newline;
			}
		}

		if(! $row_shipping_taxed)
			$all_shipping_taxed = 0;
		else if($all_shipping_taxed < 0)
			$all_shipping_taxed = 1;
				
		if(count($groups) > 1) {
			// only show group totals if more than one group exists
			foreach(array('subtotal', 'total') as $f) {
				$f2 = "row_$f";
				$f = $f . '_usd';
				$$f2 = currency_format_number($grp[$f], $format_params);
			}
			$extra[] = array(
				'name' => $mod_strings['LBL_SUBTOTAL'],
				'value' => $row_subtotal,
			);
			foreach($discounts as $d) {
				$extra[] = array(
					'name' => $d['desc'],
					'value' => '-' . currency_format_number($d['amount_usd'], $format_params),
				);
			}


			if($row_shipping != 0 && $row_shipping_taxed) {
				$extra[] = array(
					'name' => $mod_strings['LBL_SHIPPING'],
					'value' => $row_shipping,
				);
			}

			foreach($taxes as $t) {
				$extra[] = array(
					'name' => $t['desc'],
					'value' => $t['amount_usd'],
				);
			}
			
			if($row_shipping != 0 && !$row_shipping_taxed) {
				$extra[] = array(
					'name' => $mod_strings['LBL_SHIPPING'],
					'value' => $row_shipping,
				);
			}

			$extra[] = array(
				'name' => $mod_strings['LBL_TOTAL'],
				'value' => $row_total,
			);
		}

		$ret['groups'][] = $group;
	}

	$extra =& $ret['extra'];
	foreach(array('subtotal', 'total', 'tax', 'discount', 'shipping') as $f) {
		$f2 = "grand_$f";
		$$f2 = currency_format_number($currency->convertToDollar($tally->totals[$f]), $format_params);
		if(($f == 'tax' || $f == 'discount' | $f == 'shipping') && empty($tally->totals[$f]))
			 $$f2 = '';
	}
	
	$extra[] = array(
		'name' => $mod_strings['LBL_SUBTOTAL'],
		'value' => $grand_subtotal,
	);

	$grand_shipping_str = '';

	if(count($groups) > 1) {
		if($grand_discount) {
			$extra[] = array(
				'name' => $mod_strings['LBL_DISCOUNT'],
				'value' => -$grand_discount,
			);
		}
		if($all_shipping_taxed == 1) {
			if(($focus->shipping_provider_id && $focus->shipping_provider_id != '-99') || $tally->totals['shipping']) {
				if ($grand_shipping) {
					$shipping_label = $mod_strings['LBL_SHIPPING'];
					if (!empty($shipper)) $shipping_label .= ' (' . $shipper . ')';
					$extra[] = array(
						'name' => $shipping_label,
						'value' => $grand_shipping,
					);
				}
			}
		}
		if($grand_tax) {
			$extra[] = array(
				'name' => $mod_strings['LBL_TAX'],
				'value' => $grand_tax,
			);
		}
	} else {
		if(!empty($discounts)) {
			foreach($discounts as $d) {
				$extra[] = array(
					'name' => $d['desc'],
					'value' => '-' . currency_format_number($d['amount_usd'], $format_params),
				);
			}
		}
		if($all_shipping_taxed == 1) {
			if ($grand_shipping != 0) {
				$shipping_label = $mod_strings['LBL_SHIPPING'];
				if (!empty($shipper)) $shipping_label .= ' (' . $shipper . ')';
				$extra[] = array(
					'name' => $shipping_label,
					'value' => $grand_shipping,
				);
			}
		}
		if(!empty($taxes)) {
			foreach($taxes as $t) {
				$extra[] = array(
					'name' => $t['desc'],
					'value' => currency_format_number($t['amount_usd'], $format_params),
				);
			}
		}
	}
	
	if($all_shipping_taxed != 1) {
		if ($grand_shipping) {
			$shipping_label = $mod_strings['LBL_SHIPPING'];
			if (!empty($shipper)) $shipping_label .= ' (' . $shipper . ')';
			$extra[] = array(
				'name' => $shipping_label,
				'value' => $grand_shipping,
			);
		}
	}

	
	$extra[] = array(
		'name' => $mod_strings['LBL_TOTAL'],
		'value' => $grand_total,
	);

	foreach ($ret['groups'] as $gid => $grp) {
		foreach ($grp['lines'] as $lid => $ln) {
			$line = array();
			foreach($ln as $name => $value) {
				$line[] = array(
					'name' => $name,
					'value' => $value,
				);
			}
			$ret['groups'][$gid]['lines'][$lid] = $line;
		}
	}
	return $ret;
}
