<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */

require_once('data/SugarBean.php');
        
class RecordAction extends SugarBean {
	// Stored fields
	var $id;
	var $date_entered;
	var $date_modified;
	var $assigned_user_id;
	var $type;
	var $source;
	var $sequence;
	var $status;
	var $date_start;
	var $workflow_id;
    var $wf_action_id;
    var $parent_type;
    var $parent_id;
    var $related_type;
    var $related_id;
    var $params;
    var $depends_on_id;
	var $hidden;
	
	var $object_name = 'RecordAction';
	var $table_name = 'record_actions';
	var $module_dir = 'RecordActions';
	
	static function get_action_types() {
		require_once('modules/Workflow/WFProcessorBase.php');
		$types = WFProcessorBase::get_action_options();
		$ret = array();
		foreach($types as $k => $t)
			$ret[$k] = $t['label'];
		return $ret;
	}
	
	static function before_save(RowUpdate $u) {
		$stat = $u->getField('status');
		if($u->getFieldUpdated('status') && $stat != 'failed' && $stat != 'pending') {
			$u->set('errmsg', null);
		}
	}
}


?>
