<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/Recurrence/RecurrenceRule.php
	unified_search: false
	duplicate_merge: false
	table_name: recurrence_rules
	primary_key: id
hooks
	before_save
		--
			class_function: before_save
			required_fields
				- parent_type
				- template
				- limit_count
				- instance_count
				- date_last_instance
				- until
				- rule
	after_save
		--
			class_function: update_recurrence
			required_fields
				- template
				- limit_count
				- instance_count
				- date_last_instance
				- until
				- rule
	after_delete
		--
			class_function: remove_instances
fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
	recurrence_group_id
		type: id
	parent_type
		vname: LBL_PARENT_TYPE
		required: false
		type: module_name
	parent
		vname: LBL_PARENT_ID
		required: false
		type: ref
		dynamic_module: parent_type
		massupdate: true
	freq
		vname: LBL_FREQUENCY
		required: true
		type: enum
		options: recur_frequency_dom
		len: 30
		massupdate: true
	freq_interval
		vname: LBL_INTERVAL
		required: true
		type: int
		default: 1
	until
		vname: LBL_UNTIL
		type: datetime
		massupdate: true
	limit_count
		vname: LBL_COUNT
		type: int
	rule
		vname: LBL_RULE
		type: varchar
		len: 255
	is_restriction
		vname: LBL_IS_RESTRICTION
		required: true
		type: bool
		default: 0
		massupdate: true
	instance_count
		vname: LBL_INSTANCE_COUNT
		type: int
	date_last_instance
		vname: LBL_LAST_INSTANCE
		type: datetime
		massupdate: true
	forward_times
		vname: LBL_INTERVAL
		type: text
	template
		ui: false
		type: text
	vcal_size
		type: int
		comment: Size of vCal
		reportable: false
		editable: false
	vcal
		type: text
		comment: Pre-generated vCal
		reportable: false
		editable: false
	vcal_uri
		type: varchar
		len: 255
		comment: URI generated by external calendar
		reportable: false
		editable: false
indices
	idx_recurrence_parent
		type: alternate_key
		fields
			- parent_type
			- parent_id
