<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

require_once('modules/Reports/Report.php');
require_once('modules/Reports/ReportTemplate.php');

global $sugar_version;

$report = new Report();
$report->retrieve($_REQUEST['record']);
$tpl = new ReportTemplate();
$tpl->populateFromRow($report->fetched_row);

$details=['name','primary_module','description',
	'run_method','run_interval','run_interval_unit',
	'chart_name','chart_type','chart_title','chart_rollover','chart_description','chart_series',
];
$specs=['sources_spec','columns_spec','filters_spec','filter_values','sort_order'];
foreach ($details as $detail) {
	$out['detail'][$detail] = ($report->fetched_row)[$detail];
}
foreach ($specs as $spec) {
	$out[$spec] = ((array)$tpl)[$spec];
}

require_once(__DIR__ . '/../../include/config/format/ConfigWriter.php');
$cw = new ConfigWriter();
$report_iahconfig = $cw->encodeToString($out);

$name = preg_replace('~[^A-Za-z0-9\-.]~', '_', $tpl->name);

ob_start();
echo "<?php return; /* no output */ ?>\r\n\r\n";
echo $report_iahconfig;
echo "\r\n";
$content = ob_get_contents();
ob_end_clean();

header('Content-Type: application/x-httpd-php-source');
header("Content-Disposition: inline; filename={$name}.php");
header("Pragma: cache");
header("Expires: Mon, 26 Jul 1997 05:00:00 GMT" );
header("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT" );
header("Cache-Control: post-check=0, pre-check=0", false );
header('Content-Length: '.strlen($content));
echo $content;

?>
