<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
if(!defined('inScheduler')) die('Unauthorized access');

require_once('modules/Reports/utils.php');

global $log, $db, $timedate;

$lq = new ListQuery('Report');
$now = $timedate->get_gmt_db_datetime();

$lq->addFilterClauses(array(
	array('field' => 'run_method', 'value' => 'scheduled'),
	"(next_run IS NULL OR next_run < '$now')",
));

$reports = $lq->fetchAll('last_run asc');

foreach($reports->getRowIndexes() as $idx) {
    $report = $reports->getRowResult($idx);
    $report_id = $report->getField($report->primary_key);
	$data_id = run_report_result($report, true, true);

	if(! $data_id) {
		$log->error("Error running scheduled report: '{$report->getField('name')}' ({$report_id})");
		continue;
	}
	
	notify_report_result($data_id, $report);
}

?>
