<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
?><?php return; /* no output */ ?>

detail
	name: LBL_STD_REPORT_SALES_BY_VENDOR
	run_method: scheduled
	run_interval: 1
	run_interval_unit: months
	primary_module: SalesOrders
sources
	--
		name: salesorder
		display: primary
		module: SalesOrders
		bean_name: SalesOrder
		required: 1
	--
		name: lines_link
		display: joined
		module: SalesOrders
		bean_name: SalesOrderLine
		vname: LBL_LINE_ITEMS
		vname_module: SalesOrders
		parent: salesorder
		field_name: lines_link
		required: 1
	--
		name: product_link
		display: joined
		module: ProductCatalog
		bean_name: Product
		parent: lines_link
		vname: LBL_PRODUCT
		vname_module: SalesOrders
		field_name: product_link
		link_name: lines_link.product_link
		required: 1
columns
	--
		field: sales_orders.full_number
		name: sales_orders.full_number
		vname: LBL_LIST_NUMBER
		vname_module: SalesOrders
		source: lines_link
	--
		field: name
		name: name
		vname: LBL_NAME
		vname_module: SalesOrders
		source: lines_link
	--
		field: mfr_part_no
		name: mfr_part_no
		vname: LBL_PARTNO
		vname_module: SalesOrders
		source: lines_link
	--
		field: cost_price
		name: cost_price
		vname: LBL_COST
		vname_module: SalesOrders
		source: lines_link
	--
		field: unit_price
		name: unit_price
		vname: LBL_UNIT_PRICE
		vname_module: SalesOrders
		source: lines_link
	--
		field: supplier
		name: supplier
		vname: LBL_PRODUCT_SUPPLIER_NAME
		vname_module: ProductCatalog
		source: product_link
filters
	--
		field: date_entered
		source: lines_link
		operator: period_prev
		period: month
		hidden: true
