<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
?><?php return; /* no output */ ?>

detail
	name: LBL_STD_REPORT_WEEKLY_OPPS
	run_method: scheduled
	primary_module: Opportunities
	chart_type: pie
	chart_series: "amount_usdollar:sum"
    chart_title: LBL_STD_REPORT_WEEKLY_OPPS_CHART
	run_interval: 1
	run_interval_unit: weeks
sources
	--
		name: Oppo
		display: primary
		module: Opportunities
		bean_name: Opportunity
		required: 1
columns
	--
		field: forecast_category
		vname: LBL_FORECAST_CATEGORY
		vname_module: Opportunities
		source: Oppo
		grouped: 1
	--
		field: name
		vname: LBL_OPPORTUNITY_NAME
		vname_module: Opportunities
		source: Oppo
	--
		field: account
		vname: LBL_ACCOUNT_NAME
		vname_module: Opportunities
		source: Oppo
	--
		field: amount_usdollar
		vname: LBL_AMOUNT
		vname_module: Opportunities
		source: Oppo
	--
		field: date_closed
		vname: LBL_FIELD_EXP_CLOSE
		vname_module: Opportunities
		label: Expected Close
		source: Oppo
	--
		field: probability
		vname: LBL_PROBABILITY
		vname_module: Opportunities
		source: Oppo
	--
		field: sales_stage
		vname: LBL_SALES_STAGE
		vname_module: Opportunities
		source: Oppo
	--
		field: opportunity_type
		vname: LBL_TYPE
		vname_module: Opportunities
		source: Oppo
	--
		name : id:count
		field : id
		vname : LBL_ID
		vname_module : app
		label : ID: Count
		total : count
	--
		name : amount_usdollar:sum
		field : amount_usdollar
		vname : LBL_AMOUNT
		vname_module : Opportunities
		label : Amount: Sum
		total : sum
filters
	--
		field: sales_stage
		operator: any_of
		hidden: 1
		value
			- Prospecting
			- Qualification
			- Needs Analysis
			- Value Proposition
			- Id. Decision Makers
			- Perception Analysis
			- Proposal/Price Quote
			- Negotiation/Review
sort_order
	--
		field: probability
