<?php

require_once 'data/SugarBean.php';

class SFImport extends SugarBean
{
	var $id;
	var $name;

	static function after_save(RowUpdate $upd) {
		if($upd->getRelatedData('total_updated'))
			return;
		$upload_dir = AppConfig::upload_dir();

		$array = $fields = array(); $i = 0;
		$handle = @fopen($upload_dir.$upd->getField('filename'), "r");
		if ($handle) {
			while (($row = fgetcsv($handle, 4096, ",")) !== false) {
				if (empty($fields)) {
					$fields = $row;
					continue;
				}
				foreach ($row as $k=>$value) {
					$array[$i][$fields[$k]] = $value;
				}
				if($upd->getField('import_module') == 'Users') {
					if($array[$i]['UserType'] != 'Standard') {
						unset($array[$i]);
						continue;
					}
				}

				if($upd->getField('import_module') == 'Tasks') {
					if($array[$i]['Type'] == 'Call') {
						unset($array[$i]);
						continue;
					}
				}

				if($upd->getField('import_module') == 'Calls') {
					if($array[$i]['Type'] != 'Call') {
						unset($array[$i]);
						continue;
					}
				}
				$i++;
			}
			if (!feof($handle)) {
				echo "Error: unexpected fgets() fail\n";
			}
			fclose($handle);
		}

		$total_rows = count($array);

		$record = ListQuery::quick_fetch('SFImport', $upd->getPrimaryKeyValue());

		$total_update = RowUpdate::for_result($record);
		$total_update->set(['count' => $total_rows]);
		$total_update->setRelatedData('total_updated', true);
		$total_update->save();
	}
}
