<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

action_restricted_for('demo');

require_once('modules/Scheduler/Schedule.php');

if(empty($_REQUEST['record']))
	sugar_die('No record ID provided');
$record = trim($_REQUEST['record']);

$focus = ListQuery::quick_fetch('Schedule', $record);

if(! $focus)
	sugar_die('Error retrieving schedule');

$return_label = to_html(translate('LBL_RETURN_BUTTON_LABEL', 'Scheduler'));

echo get_module_title('Scheduler', translate('LBL_TEST_BUTTON_LABEL', 'Scheduler'), false);

?>
<div class="card-outer form-outer default-form">
	<div class="card-body form-body">
		<div class="form-section">
			<div class="row form-row" id="scheduler_meter">
				<div class="column form-cell">
					<div class="form-entry">
						<div class="form-value">
							<div class="input-field input-progress-outer input-lg input-block">
								<div class="input-progress">
									<div class="input-progress-bar state-active" id="scheduler_progress1"></div>
									<div class="input-progress-bar empty" id="scheduler_progress2"></div>
								</div>
							</div>
						</div>
					</div>
				</div>
			</div>
			<div class="row form-row" id="scheduler_current_outer">
				<div class="column form-cell">
					<div class="form-entry">
						<div id="scheduler_current">Connecting ...</div>
					</div>
				</div>
			</div>
			<div class="row form-row">
				<div class="column form-cell">
					<div class="form-entry">
						<div id="scheduler_history"></div>
					</div>
				</div>
			</div>
		</div>
	</div>
	<div class="card-footer form-buttons">
		<div class="row buttons-row">
			<div class="column buttons-inline align-left">
				<div class="inline-elt">
					<button class="input-button" type="button" onclick="SUGAR.util.loadUrl('index.php?module=Scheduler&action=index');"><div class="input-icon icon-return left"></div><span class="input-label"><?php echo $return_label; ?></span></button>
				</div>
			</div>
		</div>
	</div>
</div>

<?php
	$pageInstance->add_js_include('modules/Scheduler/scheduler.js', null, LOAD_PRIORITY_BODY);
	$pageInstance->add_js_literal('init_test_run("'.javascript_escape($record).'");', null, LOAD_PRIORITY_FOOT);
?>
