
function sched_async_message(div, icon, msg, indent) {
	var sub = document.createElement('div'), idiv;
	sub.style.margin = '0.25em 0';
	if(icon == 'wait') {
		if(! div.waitIcon)
			div.waitIcon = SUGAR.util.waitIcon();
		idiv = div.waitIcon;
	} else if(icon) {
		idiv = document.createElement('span');
		idiv.className = 'uii uii-led '+icon;
	}
	if(idiv) {
		idiv.style.marginRight = '9px';
		if(indent)
			idiv.style.marginLeft = '-25px';
		sub.appendChild(idiv);
	}
	if(indent) {
		sub.style.paddingLeft = idiv ? '55px' : '30px';
	}
	sub.appendChild(document.createTextNode(msg));
	div.appendChild(sub);
}

// set by caller
var setup_demo   = '';
var async_dotdot = '...';
var async_prefix = 'Performing: ';
var async_failed = 'Scheduled task failed. Please check your server error logs.';

function init_test_run(id) {
	setTimeout(function() { start_test_run(id); }, 100);
}

function start_test_run(id) {
	var sched_progress = {
		std_failure_msg: async_failed,
		module: 'Scheduler',
		start: function() {
			var div = $('scheduler_current');
			div.innerHTML = '';
			sched_async_message(div, 'wait', 'Connecting ...');
			toggleDisplay('scheduler_current_outer', true);
			toggleDisplay('scheduler_meter', true);
		},
		start_complete: function() {
			//console.log(this.progress_id);
		},
		history: function(hist) {
			var msg, icon, div = $('scheduler_history');
			sched_async_message(div, 'led-green', hist.name);
			if(hist.messages) {
				for(var i = 0; i < hist.messages.length; i++) {
					msg = hist.messages[i];
					if(msg.severity == 'error')
						icon = 'led-red';
					else
						icon = '';
					sched_async_message(div, icon, msg.message, 1);
				}
			}
		},
		progress: function(percent, process) {
			var div = $('scheduler_current'), p1 = $('scheduler_progress1');
			div.innerHTML = '';
			if(process)
				sched_async_message(div, 'wait', async_prefix + process + async_dotdot + ' (' + this.get_duration() + ')');
			p1.style.width = '' + percent + '%';
		},
		complete: function(status, msg) {
			var hist = $('scheduler_history');
			toggleDisplay('scheduler_current_outer', false);
			setTimeout(function() {
				toggleDisplay('scheduler_meter', false);
			}, 1000); // leave meter up for a second
			sched_async_message(hist, status == 'success' ? '' : 'led-red', '' + msg + ' (' + this.get_duration() + ')');
		},
		error: function(msg) {
			toggleDisplay('scheduler_current_outer', false);
			toggleDisplay('scheduler_meter', false);
			sched_async_message($('scheduler_history'), 'led-red', msg);
		}
	};
	var checker = new SUGAR.conn.ProgressChecker(sched_progress);
	checker.start('run_scheduled_task&record='+id, 'get_scheduler_progress');
}
