<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/SubContracts/SubContract.php
	audit_enabled: true
	unified_search: false
	duplicate_merge: false
	table_name: service_subcontracts
	primary_key: id
	reportable: true
	display_name
		field: name
	record_status: is_active
	primary_account: account
hooks
	after_save
		--
			class_function: update_balance
fields
	app.id
	app.date_entered
	app.created_by_user
	app.date_modified
	app.modified_user
	app.assigned_user
	app.deleted
	account
		vname: LBL_ACCOUNT
		type: ref
		bean_name: Account
		required: true
		updateable: false
		isnull: true
	date_start
		vname: LBL_SUBC_DATE_START
		type: date
		massupdate: true
	date_expire
		vname: LBL_SUBC_DATE_EXPIRE
		type: date
		audited: true
		massupdate: true
	date_billed
		vname: LBL_SUBC_DATE_BILLED
		type: date
		audited: true
		massupdate: true
	name
		vname: LBL_SUBC_NAME
		type: name
		len: 100
		required: true
		unified_search: true
	vendor_contract
		vname: LBL_SUBC_VENDOR_CONTRACT_NAME
		type: varchar
		len: 100
	customer_contact
		vname: LBL_SUBC_CUST_CONTACT_NAME
		type: ref
		audited: true
		bean_name: Contact
		massupdate: true
		add_filters
			--
				param: primary_account
				field_name: account
	contract_type
		vname: LBL_SUBC_CONTRACT_TYPE
		type: ref
		required: true
		bean_name: ContractType
		massupdate: true
	description
		vname: LBL_DESCRIPTION
		type: text
	is_active
		vname: LBL_IS_ACTIVE
		type: status
		options: contract_status_dom
		dbType: char
		len: 3
		default: yes
		audited: true
		massupdate: true
		required: true
	prepaid_balance_usd
		vname: LBL_SUBC_PREPAID_BALANCE
		type: base_currency
links
	assets
		relationship: subcontract_assets
		vname: LBL_ASSETS
		add_existing: true
		initial_filter_fields
			account_id: account_id
	supportedassemblies
		relationship: subcontract_supported_assemblies
		vname: LBL_SUPPORTED_ASSEMBLIES
		add_existing: true
		initial_filter_fields
			account_id: account_id
	cases
		relationship: subcontract_cases
		vname: LBL_CASES
	prepaid_amounts
		relationship: subcontract_prepaid_amounts
		module: PrepaidAmounts
		bean_name: PrepaidAmount
		vname: LBL_PREPAID_AMOUNTS
		layout: SubContracts
	app.securitygroups
		relationship: securitygroups_subcontracts
indices
	acct_idx
		fields
			- account_id
	customer_contact_idx
		fields
			- customer_contact_id
	assigned_user_idx
		fields
			- assigned_user_id
	contract_type_idx
		fields
			- contract_type_id
relationships
	subcontract_assets
		key: id
		target_bean: Asset
		target_key: service_subcontract_id
		relationship_type: one-to-many
	subcontract_supported_assemblies
		key: id
		target_bean: SupportedAssembly
		target_key: service_subcontract_id
		relationship_type: one-to-many
	subcontract_cases
		key: id
		target_bean: aCase
		target_key: contract_id
		relationship_type: one-to-many
	subcontract_prepaid_amounts
		key: id
		target_bean: PrepaidAmount
		target_key: subcontract_id
		relationship_type: one-to-many
