<?php return; /* no output */ ?>

detail
	table_name: addons
	comment: Addons
	type: bean
    tab_visibility: manual
	bean_file: modules/SubscriptionAddons/Addon.php
	audit_enabled: false
	unified_search: false
	duplicate_merge: false
	optimistic_locking: true
	primary_key: id
	default_order_by: name ASC
	reportable: false

hooks
    after_add_link
        --
            class_function: after_add_link
    after_remove_link
        --
            class_function: after_remove_link
    after_save
        --
            class_function: after_save

fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
    app.currency
		editable: false
	name
		vname: LBL_ADDON_NAME
		type: name
		len: 100
		editable: false
		unified_search: true
	long_name
		vname: LBL_LONG_NAME
		type: name
	display_order
		vname: LBL_DISPLAY_ORDER
		type: int
	payment_processor
        type: ref
        bean_name: PaymentProcessor
		vname: LBL_PAYMENT_PROCESSOR
		vname_list: LBL_PAYMENT_PROCESSOR
		editable: false
	pp_addon_id
		type: varchar
		vname: LBL_PP_ADDON_ID
		comment: payment processor's ID
		editable: false
    pricing_model
        vname: LBL_PRICING_MODEL
        type: enum
        options: pricing_model_dom
        comment: same options as plan
		editable: false
    pricing_tiers
        vname: LBL_PRICING_TIERS
        type: varchar
        comment: json {1:75,11:275,61:500,211:800}
    popup_info
        type: html
		vname: LBL_POPUP_INFO
    pricing_tiers_desc
        type: text
		editable: false
	product
		type: ref
		vname: LBL_PRODUCT
		bean_name: Product
		default: null
		detail_link: true
		comment: Product this Addon is built around
		editable: false
	qty_label
		vname: LBL_QUANTITY_LABEL
		type: varchar
        default: null
		len: 30
		massupdate: true
	default_qty
		vname: LBL_DEFAULT_QUANTITY
		type: int
        default: null
		massupdate: true
	addons_group
		vname: LBL_ADDONS_GROUP
		type: varchar
        default: null
		massupdate: true
	amount
		vname: LBL_AMOUNT
		type: currency
		default: null
		comment: base product retail per unit ONLY IF NO TIERS!
		editable: false
    billing_cycle
        type: enum
        vname: LBL_BILLING_CYCLE
        vname_list: LBL_BILLING_CYCLE_LIST
        options: Addon_cycle_dom
        len:30
        required:true
        default: Monthly
        massupdate:false
        audited:false
		editable: false
    billing_cycle_mult
        type: int
        vname: LBL_BILLING_CYCLE_MULT
        required:true
        default: 1
        massupdate:false
        audited:false
		comment: Billing cycle multiplier. For example, if it is 2 and billing_cycle is Monthly, then the user will be charged the specified amount every 2 months
		editable: false
	coupons
		type: text
        default: null
		vname: LBL_COUPONS
		comment: hash of related coupon id
	options
		type: varchar
		size: 255
        default: null
		vname: LBL_OTHER_OPTIONS
		vname_list: LBL_OTHER_OPTIONS_LIST
		comment: aka 'meta', array of no-charge options to offer ie color.
	global
		type: bool
		vname: LBL_GLOBAL
		comment: true = available on All Plans
		editable: false
    active
        vname: LBL_ACTIVE
        type: status
        options: simple_status_dom
		editable: false
	native
		type: text
		editable: false
		comment: JSON-encoded native representation
	copy_plan_qty
		type: bool
		vname: LBL_COPY_PLAN_QTY
indices
    pp_addon_id
        fields
            - pp_addon_id

links
	coupons
		relationship: addons_coupons
		vname: LBL_ADDON_COUPONS
		bean_name: Coupon
	options
		relationship: addons_options
		vname: LBL_ADDON_OPTIONS
		bean_name: Option
	plans
		relationship: plans_addons
		vname: LBL_ADDON_PLANS
		bean_name: Plan

relationships
	addon_processor
		relationship: one-to-one
		key: payment_processor_id
		target_bean: PaymentProcessor
		target_key: id
		comment: the Payment Processor for this addon
