<?php return; /* no output */ ?>

detail
	table_name: coupons
	comment: coupons Master Records
	type: bean
	bean_file: modules/SubscriptionCoupons/Coupon.php
	audit_enabled: false
	unified_search: false
	duplicate_merge: false
	optimistic_locking: true
	primary_key: id
	default_order_by: name ASC
	reportable: false

fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
    app.currency
	name
		vname: LBL_COUPON_NAME
		type: name
		len: 100
	payment_processor
		vname: LBL_PAYMENT_PROCESSOR
		vname: LBL_PAYMENT_PROCESSOR_LIST
		type: ref
	pp_coupon_id
		type: varchar
		vname: LBL_PP_COUPON_ID
		comment: payment processor's ID
	discount_amount
		type: currency
		vname: LBL_DISCOUNT_AMOUNT
		vname_list: LBL_DISCOUNT_AMOUNT_LIST
		len: 9
	discount_type
		type: enum
		vname: LBL_DISCOUNT_TYPE
		vname_list: LBL_DISCOUNT_TYPE_LIST
		options: discount_type_dom
		comment: Fixed Amount or Percentage
	discount_mode
		type: enum
		vname: LBL_DISCOUNT_MODE
		options: discount_mode_dom
        comment: Each Item or Invoice Amount
	discount_percentage
		type: percentage
		vname: LBL_DISCOUNT_PERCENTAGE
		len: 9
	addon_mode
		type: enum
		vname: LBL_ADDON_MODE
		options: addon_mode_dom
		comment: all = all addons, selected = specific addons
	plan_mode
		type: enum
		vname: LBL_PLAN_MODE
		options: plan_mode_dom
		comment: all = all plans, selected = specific plans
    active
        vname: LBL_ACTIVE
        type: status
        options: simple_status_dom
	native
		type: text
		editable: false
		comment: JSON-encoded native representation

indices
    pp_coupon_id
        fields
            - pp_coupon_id

links
	addons
		relationship: addons_coupons
		vname: LBL_ADDON_COUPONS
		bean_name: Addon
	plans
		relationship: plans_coupons
		vname: LBL_PLAN_COUPONS
		bean_name: Plan

relationships
	coupon_processor
		relationship: one-to-one
		key: payment_processor_id
		target_bean: PaymentProcessor
		target_key: id
		comment: the Payment Processor for this plan
