<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/SubscriptionOptions/Option.php
	audit_enabled: false
	unified_search: false
	activity_log_enabled: false
	duplicate_merge: false
	optimistic_locking: true
	comment: Options are non-cost options which can be added to Subscription Plans and Addons
	table_name: options
	primary_key: id
	reportable: false

fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
	name
		vname: LBL_OPTION_NAME
		type: name
		len: 100
        required: true
        comment: Long, unique name
		unified_search: true
    label
        vname: LBL_OPTION_LABEL
        type: varchar
        len: 255
        required: true
        comment: short name, need not be unique
    description
        vname: LBL_OPTION_DESCRIPTION
        type: text
        comment: description of the field / help mouseover text
    placeholder
        vname: LBL_OPTION_PLACEHOLDER
        type: varchar
        len: 80
        comment: hint text for a field when no label is shown
    input
        vname: LBL_OPTION_INPUT
        type: varchar
        len: 24
        comment: form input name
    len
        vname: LBL_OPTION_LENGTH
        type: int
        len: 6
        default: null
    default
        vname: LBL_OPTION_DEFAULT
        type: varchar
        default: null
    type
        vname: LBL_OPTION_TYPE
        type: enum
        options: option_type_dom
        default: varchar
        comment: validation type, managed by OneCRM\Portal\Renderer\EditView class
    required
        vname: LBL_OPTION_REQUIRED
        type: bool
        default: 1
    updateable
        vname: LBL_OPTION_UPDATEABLE
        type: bool
        default: 0
	options
		vname: LBL_OPTION_VALUES
		type: text
		comment: linefeed-separated values, split to value and label on first ' = '; value = label if no split.
    meta
        vname: LBL_OPTION_META
        type: text
        comment: JSON {key:"value", ...} control values ie min/max/class
	required_message
		vname: LBL_REQUIRED_MESSAGE
		type: varchar
		comment: Message to display if required field is not filled in
	validation_rule
		vname: LBL_VALIDATION_RULE
		type: varchar
		comment: Regular expression to use as validation rule for varchar options
	validation_message
		vname: LBL_VALIDATION_MESSAGE
		type: varchar
		comment: Message to display if validation fails
	suffix_label
		vname: LBL_SUFFIX_LABEL
		type: varchar
		comment: Label to display next to option input
	custom_field_name
		vname: LBL_CUSTOM_FIELD_NAME
		type: varchar
links
	plans
		relationship: plans_options
		vname: LBL_PLANS_OPTIONS
		bean_name: Plan

	addons
		relationship: addons_options
		vname: LBL_ADDONS_OPTIONS
		bean_name: Addon

