<?php return; /* no output */ ?>

detail
	table_name: plans
	comment: Plans Master Records
	type: bean
    tab_visibility: hidden
	bean_file: modules/SubscriptionPlans/Plan.php
	audit_enabled: false
	unified_search: false
	duplicate_merge: false
	optimistic_locking: true
	primary_key: id
	default_order_by: name ASC
	reportable: false

hooks
    after_add_link
        --
            class_function: after_add_link
    after_remove_link
        --
            class_function: after_remove_link
    after_save
        --
            class_function: after_save

fields
	app.id
	app.deleted
	app.date_entered
	app.date_modified
	app.currency
		editable: false	
	name
		vname: LBL_NAME
		type: name
		len: 100
		editable: false
	long_name
		vname: LBL_LONG_NAME
		type: name
	display_order
		vname: LBL_DISPLAY_ORDER
		type: int
    active
        vname: LBL_ACTIVE
        type: status
        options: simple_status_dom
		editable: false
	description
		vname: LBL_DESCRIPTION
		type: varchar
		len: 255
		editable: false
	payment_processor
        type: ref
        bean_name: PaymentProcessor
		vname: LBL_PAYMENT_PROCESSOR
		vname_list: LBL_PAYMENT_PROCESSOR_LIST
		editable: false
    pp_plan_id
        vname: LBL_PP_PLAN_ID
        type: varchar
        len: 128
		editable: false
    pricing_model
        vname: LBL_PRICING_MODEL
        type: enum
        options: pricing_model_dom
		editable: false
    pricing_tiers
        vname: LBL_PRICING_TIERS
        type: text
        comment: json {1:75,11:275,61:500,211:800}
		editable: false
    pricing_tiers_desc
        type: text
		editable: false
    popup_info
        type: html
		vname: LBL_POPUP_INFO
	product
		type: ref
		vname: LBL_PRODUCT
		bean_name: Product
		default: null
		comment: Product this plan is built around
		massupdate: true
	qty_max
		vname: LBL_QUANTITY_MAX
		type: int
		default: 0
		len: 9
	qty_max_message
		vname: LBL_QUANTITY_MAX_MESSAGE
		type: varchar
	qty_min
		vname: LBL_QUANTITY_MIN
		type: int
		default:0
		len: 9
	qty_min_message
		vname: LBL_QUANTITY_MIN_MESSAGE
		type: varchar
	qty_label
		vname: LBL_QUANTITY_LABEL
		type: varchar
        default: null
		len: 50
		massupdate: true
	qty_comment
		vname: LBL_QUANTITY_COMMENT
		type: varchar
        default: null
		massupdate: true
	volume_discounts
		vname: LBL_DISCOUNTS
        type: status
        default: Inactive
        options: simple_status_dom
        comment: toggle: changes Tiered Pricing language to Volume Discount language
	amount
		vname: LBL_AMOUNT
		type: currency
		default: null
		comment: base product retail per unit ONLY IF NO TIERS!
		editable: false
	setup
		vname: LBL_SETUP_FEE
		type: currency
		default: null
		comment: base product retail per unit disregarding tiers?
		editable: false
    billing_cycle
        type: enum
        vname: LBL_BILLING_CYCLE
        vname_list: LBL_BILLING_CYCLE_LIST
        options: plan_cycle_dom
        len:30
        required:true
        default: Monthly
        massupdate:false
        audited:false
		comment: valid billing cycles: Single, Weekly, Monthy, Yearly
		editable: false
    billing_cycle_mult
        type: int
        vname: LBL_BILLING_CYCLE_MULT
        required:true
        default: 1
        massupdate:false
        audited:false
		comment: Billing cycle multiplier. For example, if it is 2 and billing_cycle is Monthly, then the user will be charged the specified amount every 2 months
		editable: false
	addons
		type: text
        default: null
		vname: LBL_ADDONS
		comment: hash of related addon id
	coupons
		type: text
        default: null
		vname: LBL_COUPONS
		comment: hash of related coupon id
	options
		type: varchar
		size: 255
        default: null
		vname: LBL_OTHER_OPTIONS
		vname_list: LBL_OTHER_OPTIONS_LIST
		comment: aka 'meta', array of no-charge options to offer ie color.
	num_subscriptions
		vname: Number Active
		type: int
        default: 0
		len: 9
		comment: refcount by subscription model
		editable: false
	native
		type: text
		editable: false
		comment: JSON-encoded native representation
	hidden
		type: bool
		default: 0
		required: false
		vname: LBL_HIDDEN

indices
    pp_plan_id
        fields
            - pp_plan_id

links
	addons
		relationship: plans_addons
		vname: LBL_PLAN_ADDONS
		bean_name: Addon
	coupons
		relationship: plans_coupons
		vname: LBL_PLAN_COUPONS
		bean_name: Coupon
	options
		relationship: plans_options
		vname: LBL_PLAN_OPTIONS
		bean_name: Option

relationships
	plan_product
		relationship: one-to-one
		key: product_id
		target_bean: Product
		target_key: id
		comment: Product the Plan is based around
	plan_processor
		relationship: one-to-one
		key: payment_processor_id
		target_bean: PaymentProcessor
		target_key: id
		comment: the Payment Processor for this plan

