<?php return; /* no output */ ?>

detail
    table_name: subscriptions
    comment: Subscription Master Records
    type: bean
    bean_file: modules/Subscriptions/Subscription.php
    audit_enabled: false
    unified_search: false
    duplicate_merge: false
    optimistic_locking: true
    primary_key: id
    primary_account: account
    primary_contact: contact
    default_order_by: current_period_start ASC
	reportable: true
hooks
	api_decorate
		--
			class_function: extract_subscription_details
			file: modules/Subscriptions/Subscription.php
			class: Subscription
portal
	enabled: true
	filter
		class_function: portal_filter
fields
    app.id
    app.deleted
    app.date_entered
    app.date_modified
	app.currency
		editable: false
    name
        vname: LBL_NAME
        type: name
        len: 100
		editable: false
		unified_search: true
    contact
        type: ref
        vname: LBL_CONTACT
        audited: false
        bean_name: Contact
        massupdate: false
        required: true
        detail_link: true
        comment: contact owning this subscription.
    account
        type: ref
        vname: LBL_ACCOUNT
        audited: false
        bean_name: Account
        massupdate: false
        required: true
        detail_link: true
        comment: billing account for this subscription. invoices attached here.
    payment_processor
        vname: LBL_PAYMENT_PROCESSOR
        vname: LBL_PAYMENT_PROCESSOR_LIST
        type: ref
        bean_name: PaymentProcessor
		editable: false
    pp_subs_id
        vname: LBL_PP_SUBS_ID
        type: varchar
        len: 128
        comment: maps PP webhooks to correct 1CRM contact/subscription etc
		editable: false
    plan
        type: ref
        vname: LBL_PLAN
        bean_name: Plan
        required: true
        detail_link: true
        comment: plan chosen at time subscription was created
		editable: false
    addons
        type: varchar
        size: 255
        vname: LBL_ADDONS
        comment: hash of addon id : quantity, taken from plan
		editable: false
    coupons
        type: varchar
        size: 255
        vname: LBL_COUPONS
        comment: hash of coupon id : quantity, taken from plan
		editable: false
    quantity
        vname: LBL_QUANTITY
        type: decimal
        len: 9
        comment: factor of plan.product ordered by the subscription
		editable: false
    options
        type: varchar
        size: 255
        vname: LBL_OTHER_OPTIONS
        vname_list: LBL_OTHER_OPTIONS_LIST
        comment: aka 'meta', array of no-charge options chosen from the plan ie color.
		editable: false
    start_date
        vname: LBL_START_DATE
        type: datetime
        comment: empty in 'Draft' state.  Current date when started or un-paused
		editable: false
    billing_cycle
        type: enum
        vname: LBL_BILLING_CYCLE
        vname_list: LBL_BILLING_CYCLE_LIST
        options: subscription_cycle_dom
        len:30
        required:true
        default: Monthly
        massupdate:false
        audited:false
		editable: false
    cancel_at_period_end
        type: bool
        vname: LBL_CANCELLED
		editable: false
    current_period_start
        type: date
        vname: LBL_CURRENT_PERIOD_START
        comment: no sub-day pro-rata.
		editable: false
    current_period_end
        type: date
        vname: LBL_CURRENT_PERIOD_END
		editable: false
    state
        vname: LBL_SUBSCRIPTION_STATE
        type: status
        options: subscription_status_dom
        len: 30
        required: true
        audited: false
        default: Active
        massupdate: false
        comment: Draft, Active, Complimentary, Paused, Non-Renewing, Dead
		editable: false
    balance
        vname: LBL_BALANCE
        type: currency
        comment: outstanding balance - updated when webhooks fire
		editable: false
    mrr
        vname: LBL_MRR
        vname_list: LBL_MRR_LIST
        type: currency
		editable: false
    next_billing_date
        vname: LBL_NEXT_BILLING_DATE
        type: datetime
		editable: false
    mrr_retrieved
        type: datetime
		editable: false
	has_unpaid_invoices
		vname: LBL_HAS_UNPAID_INVOICES
		type: bool
		editable: false
		comment: true if subscription has outstanding invoices. Can be used to suspend licenses
	native
		type: text
		editable: false
		comment: JSON-encoded native representation

indices
    pp_subs_id
        fields
            - pp_subs_id

links
	invoices
		relationship: subscriptions_invoices
		bean_name: Invoice
		vname: LBL_INVOICES
	creditnotes
		relationship: subscriptions_creditnotes
		bean_name: CreditNote
		vname: LBL_CREDITNOTES

relationships
    subscriptions_accounts
        relationship_type: one-to-one
        key: account_id
        target_bean: Account
        target_key: id
        comment: Billing account for the subscription
    subscriptions_contacts
        relationship_type: one-to-one
        key: contact_id
        target_bean: Contact
        target_key: id
        comment: The customer / primary billing contact
    subscriptions_plans
        relationship: one-to-one
        key: plan_id
        target_bean: Plan
        target_key: id
        comment: source Plan at time Subscription was created
    subscriptions_processors
        relationship: one-to-one
        key: payment_processor_id
        target_bean: PaymentProcessor
        target_key: id
        comment: the Payment Processor where canonical records & payment source are held
