<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  TODO: To be written.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/




require_once('data/SugarBean.php');

// Task is used to store customer information.
class Task extends SugarBean {
	// Stored fields
	var $id;
	var $date_entered;
	var $date_modified;
	var $assigned_user_id;
	var $modified_user_id;
	var $created_by;
	var $created_by_name;
	var $modified_by_name;


	var $description;
	var $name;
	var $status;
	var $date_due;
	var $date_start;
	var $priority;
	var $parent_type;
	var $parent_id;
	var $contact_id;

	var $parent_name;
	var $contact_name;
	var $contact_phone;
	var $contact_email;
	var $assigned_user_name;



	// longreach - start added
	var $effort_estim;
	var $effort_estim_unit;
	var $effort_actual;
	var $effort_actual_unit;
	var $is_private;
	// longreach - end added


	var $table_name = "tasks";

	var $object_name = "Task";
	var $module_dir = 'Tasks';

	// This is used to retrieve related fields from form posts.
	// longreach - added email_id
	var $additional_column_fields = Array('assigned_user_name', 'assigned_user_id', 'contact_name', 'contact_phone', 'contact_email', 'parent_name', 'email_id');
	// longreach - added
	var $relationship_fields = Array('email_id'=>'emails', );


	var $new_schema = true;



	// longreach - start added
	function get_effort_estimated() {
		global $app_list_strings, $app_strings;
		if(isset($this->effort_estim) && $this->effort_estim != 0) {
			if($this->effort_estim_unit == 'hours')
				return sprintf('%d:00 ', $this->effort_estim).$app_strings['LBL_HOURS_SHORT'];
			$unit = $app_list_strings['task_effort_unit_dom'][$this->effort_estim_unit];
			return sprintf('%d', $this->effort_estim) . ' ' . $unit;
		}
	}

	function get_effort_actual() {
		global $app_list_strings, $app_strings;
		if(isset($this->effort_actual) && $this->effort_actual != 0) {
			if($this->effort_actual_unit == 'hours')
				return sprintf('%d:00 ', $this->effort_actual).$app_strings['LBL_HOURS_SHORT'];
			$unit = $app_list_strings['task_effort_unit_dom'][$this->effort_actual_unit];
			return sprintf('%d', $this->effort_actual) . ' ' . $unit;
		}
	}

    static function init_record(RowUpdate &$upd, $input) {
        $parent_type = array_get_default($input, 'parent_type');
    	$parent_id = array_get_default($input, 'parent_id');
    	$cid = array_get_default($input, 'contact_id');
    	if($parent_type == 'Contacts') {
    		$upd->set('contact_id', $parent_id);
    		$cid = $parent_id;
    	} else if($cid) {
    		$upd->set('contact_id', $cid);
    	}
        if($parent_type == 'Contacts' && $parent_id == $cid) {
        	$upd->set(array('parent_type' => null, 'parent_id' => null));
        	$parent_type = $parent_id = null;
        }
		if($parent_type == 'Accounts' && $parent_id) {
        	$upd->set(array('parent_type' => null, 'parent_id' => null, 'account_id' => $parent_id));
        	$parent_type = $parent_id = null;
        }
    	
        if($parent_type && $parent_id) {
        	$acc_pmod = $parent_type;
        	$acc_pid = $parent_id;
        } else {
        	$acc_pmod = 'Contacts';
        	$acc_pid = $cid;
        }
        $acc_f = $acc_pmod ? get_standard_account_field($acc_pmod) : null;
        if($acc_f && $acc_pid && ! $upd->getField('account_id')) {
        	$acc_m = AppConfig::module_primary_bean($acc_pmod);
			$acc_p = ListQuery::quick_fetch_row($acc_m, $acc_pid, array($acc_f['id']));
			if($acc_p)
				$upd->set('account_id', $acc_p[$acc_f['id']]);
        }

        self::set_default_reminder_time($upd);
    }

	static function set_default_reminder_time(RowUpdate &$upd) {
		global $current_user;
		$remind = $current_user->getPreference('reminder_time');
		if($remind) $upd->set('reminder_time', $remind);
	}

	static function init_from_email(RowUpdate &$upd, $input) {
    	$email_id = array_get_default($input, 'email_id');
        if ($email_id) {
            $email = ListQuery::quick_fetch('Email', $email_id, array('name', 'description', 'contact'));

            if ($email) {
                $update = array('name' => $email->getField('name'), 'description' => $email->getField('description'),
                    'contact_id' => $email->getField('contact_id'));

                $upd->set($update);
            }
        }
    }

	static function before_save(RowUpdate $upd) {
		$input = $upd->getInput();
		if (! isset($input['reminder_time']))
			self::set_default_reminder_time($upd);
	}

	static function set_related(RowUpdate $upd) {
        if (array_get_default($_REQUEST, 'return_module') == 'Emails')
            self::set_email_parent($upd);
    }
    
    static function clear_vcal(RowUpdate $upd) {
    	require_once('modules/vCals/vCal.php');
		vCal::clear_sugar_vcal($upd->getField('assigned_user_id'));
	}

	static function update_vcal(RowUpdate $upd) {
		if(!version_compare(phpversion(), "5.4", ">="))
			return;
		require_once 'include/utils/vcal_utils.php';
		if (!$upd->getField('id')) {
			$id = create_guid();
			$upd->set('id', $id);
			$upd->set('vcal_uri', $id . '.ics');
		}
		$vcal = vCalUtils::vcal_update($upd, null, true);
		$upd->set('vcal', $vcal);
		$upd->set('vcal_size', strlen($vcal));
	}

    static function get_activity_status(RowUpdate $upd) {
        $status = null;

        if ($upd->getField('status') == 'Completed' && $upd->getField('status', null, true) != 'Completed') {
            $status = 'closed';
        } elseif ($upd->getField('status') == 'In Progress' && $upd->getField('status', null, true) == 'Completed') {
            $status = 'reopened';
        }

        return $status;
    }

	static function send_apns(RowUpdate $upd) {
		require_once 'include/utils/apns_utils.php';
		$prev_user_id = $upd->getField('assigned_user_id', null, true);
		$user_id = $upd->getField('assigned_user_id');
		$user_changed = $prev_user_id && ($prev_user_id != $user_id);

		$prev_reminder = $upd->getField('reminder_time', null, true);
		$reminder = $upd->getField('reminder_time');
		$reminder_changed = $prev_reminder && ($prev_reminder != $reminder);

		$prev_start = $upd->getField('date_start', null, true);
		$start = $upd->getField('date_start');
		$start_changed = $prev_start && ($prev_start != $start);

		$prev_name = $upd->getField('name', null, true);
		$name = $upd->getField('name');
		$name_changed = $prev_name && ($prev_name != $name);

		if ($user_changed) {
			apns_events_updated($user_id);
			apns_events_updated($prev_user_id);
		}
		if ((!$prev_user_id && $user_id) || $reminder_changed || $start_changed || $name_changed) {
			apns_events_updated($user_id);
		}
	}}
?>
