
function check_download(id, timeout) {
	setTimeout(function() { do_check_download(id, timeout) }, timeout || 250);
}

function do_check_download(id, next_timeout) {
	var req = new SUGAR.conn.HTTPRequest('download.php?check_download_id=' + encodeURIComponent(id), {silent: true});
	var start = (new Date()).getTime();
	req.fetch(function(req) {
		var result;
		try {
			result = JSON.parse(req.responseText);
		} catch(e) {
			console.error(e, req.responseText);
			return;
		}
		if(result && result[0]) {
			var stat = $('download_status');
			if(stat) SUGAR.ui.setElementText(stat, result[0].progress_text);
			var icon = $('download_icon');
			if(icon) {
				var old = ~icon.className.indexOf('input-icon');
				if(result[0].status == 'complete')
					icon.className = old ? 'input-icon icon-ledgreen' : 'uii uii-led led-green';
				else if(result[0].status == 'failed' || result[0].status == 'timeout')
					icon.className = old ? 'input-icon icon-ledred' : 'uii uii-led led-red';
			}
			if(result[0].status == 'complete') {
				var btn = $('download_install');
				if(btn) btn.style.display = 'block';
			}
			else if(result[0].status == 'failed' || result[0].status == 'timeout') {
				var btn = $('download_return');
				if(btn) btn.style.display = 'block';
			}
			else {
				var now = (new Date()).getTime();
				check_download(id, Math.max(next_timeout - now + start, 50));
			}
		}
	});
}
