<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
require_once('include/database/ListQuery.php');
global $mod_strings, $app_strings, $current_user;

$pageInstance->set_partial_page();

$record = array_get_default($_REQUEST, 'record');
if(! $record) showError();

if($record != AppConfig::current_user_id()) {
	$user = ListQuery::quick_fetch('User', $record, array('id', 'user_name', 'need_new_password'));
    if (! $user || (! is_admin() && $user->getField('id') != AppConfig::current_user_id()))
		showError();
}
else {
	$user = null;
}

require_once('include/layout/forms/FormGenerator.php');

$layout = array(
	'type' => 'configform',
	'editable' => true,
	'form_buttons' => array(
		'save' => array(
			'icon' => 'icon-accept',
			'vname' => 'LBL_SAVE_BUTTON_LABEL',
			'perform' => "return check_password(this.form, true);",
		),
		'cancel' => array(
			'icon' => 'icon-cancel',
			'type' => 'button',
			'vname' => 'LBL_CANCEL_BUTTON_LABEL',
			'perform' => 'SUGAR.popups.close()',
		),
	),
	'sections' => array(
		array(
			'id' => 'main',
			'label_position' => 'top',
			'columns' => 1,
			'elements' => array(),
		),
	),
);

$fields = array();
if (! is_admin() || ! $user) {
	$fields['old_password'] = array(
		'vname' => 'LBL_OLD_PASSWORD',
		'type' => 'password',
		'len' => 150,
		'required' => true,
	);
}
$fields['new_password'] = array(
	'vname' => 'LBL_NEW_PASSWORD',
	'type' => 'password',
	'len' => 150,
	'required' => true,
	'check_strength' => true,
);
$fields['confirm_new_password'] = array(
	'vname' => 'LBL_CONFIRM_PASSWORD',
	'type' => 'password',
	'len' => 150,
	'required' => true,
);
if(is_admin() && $user) {
	$fields['need_new_password'] = array(
		'vname' => 'LBL_CHANGE_PASSWORD_FLAG',
		'type' => 'bool',
	);
}

$result = new RowResult();
$result->row = array(
	'need_new_password' => $user ? $user->getField('need_new_password') : '',
);
$result->fields = array();
foreach($fields as $k => $f) {
	$result->fields[$k] = $f;
	$f['name'] = $k;
	$layout['sections'][0]['elements'][] = $f;
}

$gen = FormGenerator::html_form(null, $layout, 'PwForm');
$gen->getFormObject()->addHiddenFields(
	array('module' => 'Users', 'action' => 'DetailView', 'in_popup' => 1, 'record' => $record)
);
$gen->renderForm($result);
$out = $gen->getResult();
$gen->exportIncludes();
echo $out;


function showError() {
    sugar_die("Unauthorized access.");
}
?>
