<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  TODO: To be written.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/


global $app_strings;
global $app_list_strings;
global $mod_strings;
global $timedate;
global $pageInstance;
global $authController;
global $current_user;

/*
prompt for email address if missing
adjust number, date settings
*/

if(! empty($_REQUEST['saveConfig'])) {
	$fail = false;
	$tz = array_get_default($_REQUEST, 'timezone');
	if($tz) {
		$current_user->setPreference('timezone', $tz);
		$current_user->setPreference('ut', 1);
		$current_user->savePreferencesToDB();
	}
	if($current_user->need_new_password) {
		$new_pw = array_get_default($_REQUEST, 'new_password');
		$conf_pw = array_get_default($_REQUEST, 'confirm_new_password');
		$user_name = $current_user->user_name;
		if(! $new_pw || $new_pw != $conf_pw) {
			$fail = true;
		}
		else if($authController->testAuthenticate($user_name, $new_pw)) {
			$pw_warn = translate('LBL_NEW_PASSWORD_REQUIRED');
			$fail = true;
		}
		else {
			$params = array('pw_change' => 0);
			$save = $authController->updatePassword($user_name, $new_pw, $params);
		}
	}
	if(! $fail) {
		session_write_close();
		header('Location: index.php?module=Home&action=index');
		sugar_cleanup(true);
	}
}

require_once('include/layout/forms/EditableForm.php');

$pageInstance->set_no_decoration();
$pageInstance->add_js_include('modules/Users/User.js', null, LOAD_PRIORITY_BODY);
$pageInstance->add_js_language('Users');

if (!$current_user->getPreference('ut') || $current_user->need_new_password) {
	$json = getJSONobj();
	$result = new RowResult();

	$frm = new EditableForm('configform', 'ConfigForm');
	$frm->addHiddenFields(array('module' => 'Users', 'action' => 'InitUser', 'saveConfig' => 1));
	$frm->addHooks(array('onsubmit' => 'return SUGAR.ui.checkForm(this);'));
	$frm->onInitForm("SUGAR.ui.focusForm('{$frm->form_name}');");
	echo $frm->open();
	echo create_csrf_input();
	echo '<div class="panel-outer panel-system panel-border panel-round" style="width: 550px; margin: 2rem auto">';

	if ( ! $current_user->getPreference('ut')) {

		$selectedZone = $current_user->getPreference('timezone');
		if (empty($selectedZone) && ! empty($_REQUEST['gmto'])) {
			$selectedZone = $timedate->guessTimeZone(- 60 * $_REQUEST['gmto']);
		}

		$zones = $timedate->getTimeZones(true, true);
		$zone_cats = array();
		foreach ($zones as $cat => $lst) {
			$zone_cats[$cat] = $cat;
			foreach ($lst as $ident => $nm) {
				$zones[$cat][$ident] = substr($nm, strlen($cat) + 1);
			}
		}

		$spec = array(
			'name' => 'timezone_cat',
			'type' => 'enum',
			'options' => $zone_cats,
			'options_add_blank' => false,
			'required' => true,
			'tabindex' => 0,
		);
		$selTzCat = $frm->renderField($result, $spec);
		$spec = array(
			'name' => 'timezone',
			'vname' => 'LBL_TIMEZONE',
			'type' => 'enum',
			'width' => 30,
			'required' => true,
			'tabindex' => 0,
		);
		$selTz = $frm->renderField($result, $spec);

		$tz_js = $json->encode($zones);

		$frm->onInitForm("initTimezones(document.forms.{$frm->form_name}, '$selectedZone')");
		$frm->addInit("loadTimezones($tz_js);");

		echo <<<EOQ
	<div class="panel-header">
		<h4 class="panel-title">{$mod_strings['LBL_SELECT_TIMEZONE']}</h4>
	</div>
	<div class="panel-body panel-pad-body">
		{$mod_strings['LBL_PICK_TZ_DESCRIPTION']}
		<br><br>
		{$selTzCat}&nbsp;{$selTz}<span class="requiredStar">*</span>
		<br><br>
		<span class="dateFormat">{$mod_strings['LBL_DST_INSTRUCTIONS']}</span>
	</div>
EOQ;
	}

	if ($current_user->need_new_password) {
		$spec = array(
			'name' => 'new_password',
			'vname' => 'LBL_NEW_PASSWORD',
			'type' => 'password',
			'len' => 150,
			'required' => true,
			'check_strength' => true,
			'tabindex' => 0,
		);
		$newPw = $frm->renderField($result, $spec);
		$spec = array(
			'name' => 'confirm_new_password',
			'vname' => 'LBL_CONFIRM_PASSWORD',
			'type' => 'password',
			'len' => 150,
			'required' => true,
			'tabindex' => 0,
		);
		$chkPw = $frm->renderField($result, $spec);

		$warn = '';
		if ( ! empty($pw_warn)) {
			$warn = '<p class="error" style="margin-top: 1em; margin-bottom: 0">' . to_html($pw_warn) . '</p>';
		}

		$frm->onInitForm("init_check_password(document.forms.{$frm->form_name})");

		echo <<<EOQ
	<div class="panel-header">
		<h4 class="panel-title">{$mod_strings['LBL_CHANGE_PASSWORD']}</h4>
	</div>
	<div class="panel-body panel-pad-body">
		{$mod_strings['LBL_NEW_PASSWORD_EXPLAIN']}
		<br><br>
		<div style="margin-bottom: 0.5em">
		<p class="form-label">{$mod_strings['LBL_NEW_PASSWORD']}</p>
		{$newPw}<span class="requiredStar">*</span>
		</div>
		<p class="form-label">{$mod_strings['LBL_CONFIRM_PASSWORD']}</p>
		{$chkPw}<span class="requiredStar">*</span>
		{$warn}
	</div>
EOQ;
	}

	echo '<div class="panel-footer">';
	echo '<div class="row buttons-row">';
	echo '<div class="column buttons-inline align-right">';
	echo '<div class="inline-elt">';
	echo '<button class="input-button" type="submit" tabindex=0>'
		. '<div class="input-icon icon-accept left"></div><span class="input-label">'
		. $app_strings['LBL_SAVE_BUTTON_LABEL'] . '</span></button>';
	echo '</div></div></div></div>';
	echo '</div>';
	echo $frm->close();

	$frm->exportIncludes();
} elseif (AppConfig::check_2fa()) {
	$pageInstance->add_js_include('modules/Users/MultiFASetup.js', null, LOAD_PRIORITY_BODY);
	$pageInstance->add_js_include('modules/Users/MultiFAPageSetup.js', null, LOAD_PRIORITY_BODY);

	echo '<div id="outer-body" class="outer-body" style="padding: 0;" ">';
	echo '<div id="main-title" class="h3" style="margin: 0;">
    <div class="title-content">
        <span id="main-title-module" class="title-module visible">
            <span>
                <span>' . $app_strings['LBL_MULTI_FA_TITLE'] . '</span>
            </span>
        </span>
    </div>
	</div>';
	echo '<main id="main-body">
			<div id="content-main">
				<div style="min-height: 450px">&nbsp;</div>
			</div>
		</main>';
	echo '</div>';
} else {
	header("Location: index.php?action=index&module=Home");
}
