const MultiFASetupWizard = function (form) {

    const wizard = this;
    var outer;
    var dialog;
    var main_form = form;
    var dialog_form_elem;
    var buttons_container;

	this.isPage = false;

    const err = function(zero, msg) {
        const error_container = createElement2('div', {class: 'uii-danger text-error'});
        error_container.innerText = msg.failure_msg;
        body.appendChild(error_container);
        wizard.renderCancelButton();
    };

    this.run = function (isPage = false) {
		if (isPage) this.isPage = isPage;

		const dialog = this.initDialog('multi_fa_setup_wizard', '500px', '325px');

        wizard.renderStep1();
        dialog.render();
        dialog.show();

        setTimeout(function() {dialog.reposition();}, 200);
    };

    this.renderStep1 = function () {
        dialog.setTitle(mod_string('LBL_MULTI_FA_WIZARD_STEP1_TITLE'));
        outer.innerHTML = '';
        buttons_container.innerHTML = '';

        const desc = createElement2('div', {style : { 'text-align': 'justify', padding: '5px', height: 'auto', width: '97%'}});
        desc.innerText = mod_string('LBL_MULTI_FA_WIZARD_STEP1');
        outer.appendChild(desc);

        this.renderNextButton(function() { wizard.renderStep2(); });
        this.renderCancelButton();
    };

    this.renderStep2 = function () {
        dialog.setTitle(mod_string('LBL_MULTI_FA_WIZARD_STEP2_TITLE'));
        outer.innerHTML = '';
        buttons_container.innerHTML = '';

        const body = createElement2('div', {id: 'mfa_step2_container', style : { 'text-align': 'justify', padding: '5px', height: 'auto', width: '97%'}});

        //Load recovery codes
        const req = new SUGAR.conn.JSONRequest(
            'get_mfa_recovery_codes',
            {status_msg: app_string('LBL_LOADING')},
            {
                module: 'Users',
                user_id: main_form.record.value,
            }
        );

        const description = mod_string('LBL_MULTI_FA_WIZARD_STEP2');
        const note = mod_string('LBL_MULTI_FA_WIZARD_STEP2_NOTE');

        req.fetchJSON(function(data) {
            if (data.success) {
                const info_container = createElement2('div');
                info_container.innerHTML = description +'<br><strong>'+ note +'</strong>';
                body.appendChild(info_container);

                //Render recovery codes
                const codes_container = createElement2('ul');
                let codes_str = '';

                for (let i = 0; i <  data.codes.length; i++) {
                    let code_elem = createElement2('li', {class: 'monospace_font', style: {'font-weight': 'bold'}});
                    code_elem.innerText = data.codes[i];
                    codes_container.appendChild(code_elem);

                    codes_str += data.codes[i] + '\n';
                }

                body.appendChild(codes_container);

                //Add hidden textarea for the copy to clipboard function
                const textArea = createElement2('textarea', {id: 'mfa_recovery_codes_container'});
                textArea.style.position = 'fixed';
                textArea.style.opacity = 0;
                textArea.value = codes_str;

                body.appendChild(textArea);

                wizard.renderNextButton(function() { wizard.renderStep3(); });
                wizard.renderPrintButton();
                wizard.renderCopyButton();
                wizard.renderCancelButton();
            } else {
                err.call(this, null, {failure_msg: data.error});
            }
        }, err);

        outer.appendChild(body);
        setTimeout(function() {dialog.reposition();}, 200);
    };

    this.renderStep3 = function () {
        dialog.setTitle(mod_string('LBL_MULTI_FA_WIZARD_STEP3_TITLE'));
        outer.innerHTML = '';
        buttons_container.innerHTML = '';

        const body = createElement2('div', {class: 'form-outer', id: 'mfa_step3_container', style : { 'text-align': 'justify', padding: '5px', height: 'auto', width: '97%'}});

        //Load QR code URI
        const req = new SUGAR.conn.JSONRequest(
            'get_mfa_qr_code',
            {status_msg: app_string('LBL_LOADING')},
            {
                module: 'Users',
                user_id: main_form.record.value,
            }
        );

        const description_scan = mod_string('LBL_MULTI_FA_WIZARD_STEP3_SCAN');
        const description_enter = mod_string('LBL_MULTI_FA_WIZARD_STEP3_ENTER_CODE');
        const description_text_code = mod_string('LBL_MULTI_FA_WIZARD_STEP3_TEXT_CODE_DESC');
        const text_code_link = mod_string('LBL_MULTI_FA_WIZARD_STEP3_TEXT_CODE_LINK');

        req.fetchJSON(function(data) {
            if (data.success) {

                const code_link = createElement2('a', {href: '#', style: {'text-decoration': 'none'}});
                code_link.onclick = function() { wizard.showSecret(); return false; };
                code_link.innerText = text_code_link + '.';

                const code_container = createElement2('div', {id: 'text_code', class: 'mfa_text_code monospace_font', style: {display: 'none'}});
                const info_container = createElement2('div');

                info_container.innerHTML = description_scan +' '+ description_text_code +', ';
                info_container.appendChild(code_link);
                info_container.appendChild(code_container);
                body.appendChild(info_container);

                //Render QR code
                const qr_code_container = createElement2('div', {style : {'text-align': 'center', padding: '5px', height: 'auto', width: '95%'}});
                const qr_code = createElement2('img', {style: {width: '192px', height: '192px'}});
                qr_code.src = data.qr_code_uri;
                qr_code_container.appendChild(qr_code);

                body.appendChild(qr_code_container);

                //Render code input
                const code_input_container = createElement2('div', {class: 'form-group'});

                code_input_container.innerHTML = '<label class="control-label" for="login_pass">'+description_enter+'</label>' +
                    '<div class="input-field input-field-group input-block" style="width: 80%;">' +
                    '<input id="otp" name="otp" class="input-text input-lg" type="text" autocapitalize="off" autocorrect="off" spellcheck="false" autocomplete="off" tabindex="1" value="" data-groupfocus="1" placeholder="123456">' +
                    '<span class="input-label input-field-icon lg"><span class="uii uii-lock uii-lg"></span></span>' +
                    '</div>';

                body.appendChild(code_input_container);

                //Render code verification error section
                const error_container = wizard.getErrorSection();
                body.appendChild(error_container);

                wizard.renderEnableButton();
                wizard.renderCancelButton();

				window.addEventListener("keydown", wizard.verifyCodeOnEnterKeyPress,true);
			} else {
                err.call(this, null, {failure_msg: data.error});
            }
        }, err);

        outer.appendChild(body);
        setTimeout(function() {dialog.reposition();}, 200);
    };

    this.showSecret = function () {
        const code_elm = document.getElementById('text_code');

        if (code_elm && code_elm.style.display == 'none') {
            //Load text code URI
            const req = new SUGAR.conn.JSONRequest(
                'get_mfa_secret_code',
                {status_msg: app_string('LBL_LOADING')},
                {
                    module: 'Users',
                    user_id: main_form.record.value,
                }
            );

            req.fetchJSON(function(data) {
                if (data.success) {
                    const code_elm = document.getElementById('text_code');
                    code_elm.innerText = data.code;
                    code_elm.style.display = '';
                } else {
                    err.call(this, null, {failure_msg: data.error});
                }
            }, err);

        } else {
            code_elm.innerText = '';
            code_elm.style.display = 'none';
        }
    };

    this.verifyCode = function () {
        this.hideErrorSection();

        let otp = '';
        const otp_elm = document.getElementById('otp');

        if (otp_elm)
            otp = otp_elm.value;

        const verification_err = function() {
            wizard.showErrorSection(mod_string('LBL_MULTI_FA_VERIFY_CODE_ERROR'));
            if (otp_elm) otp_elm.focus();
        };

        const req = new SUGAR.conn.JSONRequest(
            'verify_mfa_code',
            {status_msg: app_string('LBL_LOADING')},
            {
                module: 'Users',
                user_id: main_form.record.value,
                code: otp
            }
        );

        req.fetchJSON(function(data) {
            if (data.success) {
                location.reload();
                SUGAR.popups.close();
            } else {
                verification_err.call(this, null);
            }
        }, verification_err);
    };

    this.copyCodes = function () {
        const container = document.getElementById('mfa_recovery_codes_container');

        if (container) {
            container.focus();
            container.select();

            document.execCommand('copy');
        }
    };

    this.printCodes = function () {
        window.open('index.php?module=Users&action=MultiFARecoveryCodesPDF', '_blank');
    };

    this.disable = function () {
        const dialog = this.initDialog('multi_fa_disable', '500px', '200px');

        wizard.renderDisableDialog();
        dialog.render();
        dialog.show();

        setTimeout(function() {dialog.reposition();}, 200);
    };

    this.processDisable = function () {
        this.hideErrorSection();

        let password = '';
        const password_elm = document.getElementById('mfa_password');

        if (password_elm)
            password = password_elm.value;

        const disable_err = function() {
            wizard.showErrorSection(mod_string('LBL_MULTI_FA_DISABLE_PASSWORD_ERROR'));
            if (password_elm) password_elm.focus();
        };

        const req = new SUGAR.conn.JSONRequest(
            'disable_mfa',
            {status_msg: app_string('LBL_LOADING')},
            {
                module: 'Users',
                user_id: main_form.record.value,
                password: password
            }
        );

        req.fetchJSON(function(data) {
            if (data.success) {
                location.reload();
                SUGAR.popups.close();
            } else {
                disable_err.call(this, null);
            }
        }, disable_err);
    };

    this.renderDisableDialog = function () {
        dialog.setTitle(mod_string('LBL_MULTI_FA_WIZARD_DISABLE_TITLE'));
        outer.innerHTML = '';
        buttons_container.innerHTML = '';

        const body = createElement2('div', {class: 'form-outer', id: 'mfa_disable_container', style : { 'text-align': 'justify', padding: '5px', height: 'auto', width: '97%'}});

        const description = mod_string('LBL_MULTI_FA_WIZARD_DISABLE_PASSWORD_DESCRIPTION');
        const info_container = createElement2('div');
        info_container.innerHTML = description;
        body.appendChild(info_container);

        const password_input_container = createElement2('div', {class: 'form-group'});
        const password_label = mod_string('LBL_MULTI_FA_WIZARD_DISABLE_PASSWORD');

        password_input_container.innerHTML = '<label class="control-label" for="login_pass">'+password_label+'</label>' +
            '<div class="input-field input-field-group input-block" style="width: 80%;">' +
            '<input id="mfa_password" name="mfa_password" class="input-text input-lg" type="password" autocapitalize="off" autocorrect="off" spellcheck="false" autocomplete="off" tabindex="1" value="" data-groupfocus="1">' +
            '<span class="input-label input-field-icon lg"><span class="uii uii-lock uii-lg"></span></span>' +
            '</div>';

        body.appendChild(password_input_container);

        //Render code verification error section
        const error_container = wizard.getErrorSection();
        body.appendChild(error_container);

        outer.appendChild(body);
        this.renderDisableButton();
        this.renderCancelButton();

        window.addEventListener("keydown", this.processDisableOnEnterKeyPress,true);
	};

    this.initDialog = function (id, width, min_height) {
        const main = createElement2('div', {class: 'card-body dialog-body'});

        const onSubmit = function(e) {
        	e.preventDefault();
        	return false;
		};

        dialog_form_elem = createElement2('form', {class: 'card-outer form-outer default-form'});
		dialog_form_elem.onsubmit = onSubmit;
        const form_body = createElement2('div', {class: 'card-body form-body'});
        outer = createElement2('div', {class: 'form-section', style: {'min-height': min_height}});

        form_body.appendChild(outer);
        dialog_form_elem.appendChild(form_body);
        dialog_form_elem.appendChild(this.renderButtonContainer());
        main.appendChild(dialog_form_elem);

		if (this.isPage) {
			main_form.record = {};
			main_form.record.value = SUGAR.session.user_id;
		}

		dialog = new SUGAR.ui.Dialog(id, {
			content_elt: main,
			width: width,
			title: '',
			resizable: false,
			have_close_button: !this.isPage,
		});
        dialog.destroy_on_close = true;
        dialog.ondestroy = function() {
        	window.removeEventListener("keydown", wizard.processDisableOnEnterKeyPress);
			window.removeEventListener("keydown", wizard.verifyCodeOnEnterKeyPress);
		};

        return dialog;
    };

    this.getErrorSection = function () {
        return createElement2('section', {class: 'card-outer panel-outer panel-border panel-round panel-alert form-group login-error', role: 'alert', id: 'error-outer', style: {width: '80%', display: 'none'}});
    };

    this.renderButtonContainer = function () {
        const main = createElement2('div', {className: 'card-footer form-buttons'});
        const row = createElement2('div', {className: 'row buttons-row'});
        const row_left = createElement2('div', {className: 'column buttons-inline align-left'});
        const row_center = createElement2('div', {className: 'column buttons-inline align-center'});
        const row_right = createElement2('div', {className: 'column buttons-inline align-right'});

        //buttons on the left
        buttons_container = row_left;

        row.appendChild(row_left);
        row.appendChild(row_center);
        row.appendChild(row_right);
        main.appendChild(row);

        return main;
    };

    this.hideErrorSection = function () {
        const error_container = document.getElementById('error-outer');

        if (error_container) {
            error_container.innerHTML = '';
            error_container.style.display = 'none';
        }
    };

    this.showErrorSection = function (error) {
        const error_container = document.getElementById('error-outer');

        if (error_container) {
            error_container.innerHTML = '<div class="card-body panel-body panel-pad-body">' +
                '<span class="uii uii-alert"></span>' +
                '<span id="login-error">'+error+'</span>' +
                '</div>';

            error_container.style.display = '';
        }
    };

    this.renderNextButton = function (callback) {
        const b = new SUGAR.ui.ButtonInput(null, {
            id: 'mfa_wizard_next_button',
            onclick: callback,
            label: app_string('LBL_NEXT_BUTTON_LABEL'),
            icon: 'icon-right'
        });

        const container = createElement2('div', {class: 'inline-elt'});
        container.appendChild(b.render());
        buttons_container.appendChild(container);
    };

    this.renderCancelButton = function () {
		if (this.isPage) return;

        const b = new SUGAR.ui.ButtonInput(null, {
            onclick: function() { SUGAR.popups.close(); },
            label: app_string('LBL_CANCEL_BUTTON_LABEL'),
            icon: 'icon-cancel'
        });

        const container = createElement2('div', {class: 'inline-elt'});
        container.appendChild(b.render());
        buttons_container.appendChild(container);
    };

    this.renderCopyButton = function () {
        const b = new SUGAR.ui.ButtonInput(null, {
            onclick: function() { wizard.copyCodes(); },
            label: mod_string('LBL_MULTI_FA_COPY_BUTTON'),
            icon: 'icon-print'
        });

        const container = createElement2('div', {class: 'inline-elt'});
        container.appendChild(b.render());
        buttons_container.appendChild(container);
    };

    this.renderPrintButton = function () {
        const b = new SUGAR.ui.ButtonInput(null, {
            onclick: function() { wizard.printCodes(); },
            label: app_string('LBL_PDF_PDF'),
            icon: 'icon-print'
        });

        const container = createElement2('div', {class: 'inline-elt'});
        container.appendChild(b.render());
        buttons_container.appendChild(container);
    };

    this.renderEnableButton = function () {
        const b = new SUGAR.ui.ButtonInput(null, {
            onclick: function() { wizard.verifyCode(); },
            label: mod_string('LBL_MULTI_FA_ENABLE_BUTTON'),
            icon: 'icon-accept'
        });

        const container = createElement2('div', {class: 'inline-elt'});
        container.appendChild(b.render());
        buttons_container.appendChild(container);
    };

    this.renderDisableButton = function () {
        const b = new SUGAR.ui.ButtonInput(null, {
            id: 'mfa_wizard_disable_button',
            onclick: function() { wizard.processDisable(); },
            label: mod_string('LBL_MULTI_FA_DISABLE_BUTTON'),
            icon: 'icon-delete'
        });

        const container = createElement2('div', {class: 'inline-elt'});
        container.appendChild(b.render());
        buttons_container.appendChild(container);
    };

    this.verifyCodeOnEnterKeyPress = function (event) {
		if (event.defaultPrevented) {
			return;
		}
		if (event.key === "Enter") {
			event.preventDefault();
			wizard.verifyCode();
		}
	}

    this.processDisableOnEnterKeyPress = function (event) {
		if (event.defaultPrevented) {
			return;
		}
		if (event.key === "Enter") {
			event.preventDefault();
			wizard.processDisable();
		}
	}
};

function mfa_enable(form) {
    const mfa = new MultiFASetupWizard(form);
    mfa.run();
}

function mfa_disable(form) {
    const mfa = new MultiFASetupWizard(form);
    mfa.disable();

	const date = new Date();
	date.setTime(date.getTime() + (24 * 60 * 60 * 1000));
	const expires = "expires=" + date.toUTCString();
	document.cookie = 'check_2fa' + "=" + '0' + ";" + expires + ";path=/";
}
