
function enable_change_password_button() {
    if (document.getElementById('DetailForm_change_password') != 'undefined') {
        var butt = document.getElementById('DetailForm_change_password');
        if(document.DetailForm.record.value != "" && document.DetailForm.record.value != 'undefined') {
            butt.style.display = '';
        } else {
            butt.style.display = 'none';
        }
    }
}

function open_password_form() {
	var URL = "async.php?module=Users&action=ChangePassword";
    if(document.DetailForm.record.value != "" && document.DetailForm.record.value != 'undefined') {
		URL += "&record=" + document.DetailForm.record.value;
    }
    var title = mod_string('LBL_CHANGE_PASSWORD_BUTTON_LABEL', 'Users');
    SUGAR.popups.openUrl(URL, null, {width: '320px', title_text: title, resizable: false},
    	{show: init_password_form});
}

function init_password_form(form) {
	if(! form) form = document.forms.PwForm;
	if(! form) return;
	if(form.old_password) form.old_password.focus();
	else if(form.new_password) form.new_password.focus();
}

function check_password(form, submit) {
	if (form.old_password && form.old_password.value == "") {
		alert(mod_string('ERR_ENTER_OLD_PASSWORD', 'Users'));
		return false;
	}
	if (form.new_password.value == "") {
		alert(mod_string('ERR_ENTER_NEW_PASSWORD', 'Users'));
		return false;
	}
	if (form.confirm_new_password.value == "") {
		alert(mod_string('ERR_ENTER_CONFIRMATION_PASSWORD', 'Users'));
		return false;
	}
	if (form.new_password.value != form.confirm_new_password.value) {
        alert(mod_string('ERR_REENTER_PASSWORDS', 'Users'));
        return false;
	}
	
	if(! submit) return true;
	
	var check = SUGAR.ui.checkForm(form);
	if(isdef(check)) return check;

    var callback = function(data) {
        var result = data.getResult();
        if(! result.failed) {
            if (result['result'] == 'ok') {
                alert(mod_string('MSG_CHANGED_PASSWORD', 'Users'));
                SUGAR.popups.hidePopup(popup_dialog);
            } else {
                alert(get_password_error_msg(result['msg']));
            }
        } else {
            SUGAR.popups.hidePopup(popup_dialog);
        }
    }

    var old_password = form.old_password ? form.old_password.value : '';

    var query = {module: 'Users', values:{id: form.record.value, new_password: form.new_password.value, old_password: old_password, confirm_password: form.confirm_new_password.value}}
	var need_new_password = form.querySelector('input[name="need_new_password"][type="checkbox"]')
    if(need_new_password)
    	query.values.need_new_password = need_new_password.checked ? '1' : '0';
    var req = new SUGAR.conn.JSONRequest('change_password', {}, query);
    req.fetch(callback);

    return false;
}

function init_check_password(form) {
	var inp = SUGAR.ui.getFormInput(form, 'confirm_new_password');
	if(inp) inp.customValidate = function() {
		var newpw = SUGAR.ui.getFormInput(this.form, 'new_password');
		if(! newpw) return;
		if(newpw.getValue() != this.getValue()) {
			this.invalid = true;
			this.invalidMsg = mod_string('ERR_PASSWORD_MISMATCH', 'Users');
		}
	}
}

function get_password_error_msg(code) {
    var msg = 'ERR_PASSWORD_CHANGE_FAILED';
    switch (code) {
        case 2:
            msg = 'ERR_PASSWORD_INCORRECT_OLD_1';
            break;
        case 3:
            msg = 'ERR_PASSWORD_MISMATCH';
            break;
    }
    return mod_string(msg, 'Users');
}

function setPasswordValidation(form) {
    var confirm_password = SUGAR.ui.getFormInput(form, 'confirm_password');
    if (confirm_password) {
        confirm_password.customValidate = function () {
            var password = SUGAR.ui.getFormInput(form, 'password');

            if (this.isBlank() || password.isBlank())
                return true;

            if (this.getValue() != password.getValue()) {
                this.invalid = true;
                this.invalidMsg = get_password_error_msg(3);
                password.invalid = true;
                password.updateDisplay();
                return false;
            }
            return true;
        };
    }
}

function showHideCertificateVerification(form) {
    var mail_smtpsecurity = SUGAR.ui.getFormInput(form, 'mail_smtpsecurity');
    var mail_smtp_verification = SUGAR.ui.getFormInput(form, 'mail_smtp_verification');
    if(mail_smtpsecurity && mail_smtp_verification) {
		var sval = mail_smtpsecurity.getValue();
		showHideFormRow(mail_smtp_verification.elt, sval != "")
	}
}

function showHideFormRow(elt, visible) {
	var p = elt.parentNode;
	while(p && p.tagName && p.tagName.toLowerCase() != 'tr' && ! SUGAR.ui.hasClass(p, 'form-row')) p = p.parentNode;
	toggleDisplay(p, visible);
}

function setSigEditButtonVisibility() {
	var field = document.DetailForm.signature_id;
    var editButt = document.getElementById('getSignatureButtons');
	if(field && field.value != '') {
		editButt.style.visibility = "visible";
	} else {
		editButt.style.visibility = "hidden";
	}
}

function open_email_signature_form(record, the_user_id, title) {
	var URL = "async.php?module=Users&action=SignatureDialog";
	if(record != "")
		URL += "&record="+record;
	if(the_user_id != "")
		URL += "&the_user_id="+the_user_id;
    SUGAR.popups.openUrl(URL, null, {width: '800px', title_text: title, resizable: false, onshow: function () {
            this.modal = false;
            CKEDITOR.instances['signature_html'].on("instanceReady",function(a){
                a.editor.config.baseFloatZIndex = 100001;
            });
    }});
}

function refresh_signature_list(signature_id, signature_name) {
	var field=document.DetailForm.signature_id;
	var bfound=0;
	for (var i=0; i < field.options.length; i++) {
			if (field.options[i].value == signature_id) {
				if (field.options[i].selected==false) {
					field.options[i].selected=true;
				}
				bfound=1;
			}
	}
	//add item to selection list.
	if (bfound == 0) {
		var newElement=document.createElement('option');
		newElement.text=signature_name;
		newElement.value=signature_id;
		field.options.add(newElement);
		newElement.selected=true;
	}	

	//enable the edit button.
	var field1 = document.getElementById('getSignatureButtons');
	field1.style.visibility="visible";
}

function move_tabs_left() {
	var left = SUGAR.ui.getFormInput('DetailForm', 'display_tabs');
		right = SUGAR.ui.getFormInput('DetailForm', 'hide_tabs');
	return move_user_tabs(right, left);
}

function move_tabs_right() {
	var left = SUGAR.ui.getFormInput('DetailForm', 'display_tabs');
		right = SUGAR.ui.getFormInput('DetailForm', 'hide_tabs');
	return move_user_tabs(left, right);
}

function move_user_tabs(left, right) {
	var sel = left.getSelectedIndexes();
	if(! sel.length) return;
	var o = left.getOptions(), o2 = right.getOptions();
	var idx;
	for(var i = 0; i < sel.length; i++) {
		o2.keys.push(o.keys[sel[i]]);
		o2.limit_keys.push(o.keys[sel[i]]);
		o2.values.push(o.values[sel[i]]);
	}
	for(var i = 0; i < sel.length; i++) {
		o.keys.splice(sel[i]-i, 1);
		o.limit_keys.splice(sel[i]-i, 1);
		o.values.splice(sel[i]-i, 1);
	}
	left.setSelected(null, true);
	right.setSelected(null, true);
	left.renderOptions();
	right.renderOptions();
}

function set_tabs_chooser() {
	var hide = SUGAR.ui.getFormInput('DetailForm', 'hide_tabs');
	if(hide) {
		var tabs = hide.getOptions().keys;
		var dtabs = createElement2('input', {type: 'hidden', name: 'hide_tabs_list', value: tabs.join(',')}, null, document.forms.DetailForm);
	}
}

function setOnSubmitEvent() {
    if ($('DetailForm_save'))
        $('DetailForm_save').onclick = submitUserForm;
    if ($('DetailForm_save2'))
        $('DetailForm_save2').onclick = submitUserForm;
    document.DetailForm.onsubmit = submitUserForm;
}

function submitUserForm() {
	set_tabs_chooser();
    return SUGAR.ui.sendForm(document.DetailForm, {'record_perform':'save'});
}

function setSignatureOnSubmitEvent() {
    if ($('SignatureForm_save'))
        $('SignatureForm_save').onclick = submitSignatureForm;
    if ($('SignatureForm_cancel'))
        $('SignatureForm_cancel').onclick = cancelSignatureForm;
    document.SignatureForm.onsubmit = submitSignatureForm;
}

function submitSignatureForm() {
    return SUGAR.ui.sendForm(document.SignatureForm, {'record_perform':'save'}, null, false, true);
}

function cancelSignatureForm() {
    SUGAR.popups.close();
}


function smtp_auth_update(form) {
	var auth = SUGAR.ui.getFormInput(form, 'mail_smtpauth_req');
	var token = SUGAR.ui.getFormInput(form, 'o365_auth_token');
	if (auth && token) {
		showHideFormRow(token.elt, auth.getValue() == "o365" || auth.getValue() == "gmail");
		var btn = document.getElementById('o365_auth_btn');
		if(auth.getValue() == 'gmail') {
			btn.classList.add('google_signin');
			btn.innerText = '';
		} else {
			btn.classList.remove('google_signin');
			btn.innerText = mod_string('LBL_O365_AUTH_BUTTON_LABEL');
		}
	}
}

function smtp_auth_changed() {
	smtp_auth_update(this.form);
}

function smtp_security_changed() {
	showHideCertificateVerification(this.form);
	var secure = SUGAR.ui.getFormInput(this.form, 'mail_smtpsecurity'),
		port = SUGAR.ui.getFormInput(this.form, 'mail_smtpport'),
		host = SUGAR.ui.getFormInput(this.form, 'mail_smtpserver'),
		auth = SUGAR.ui.getFormInput(this.form, 'mail_smtpauth_req'),
		sval, pval, hval, m;
	if(secure && port && host && auth) {
		sval = secure.getValue();
		pval = port.getValue();
		hval = host.getValue();
		if(this.name == 'mail_smtpsecurity' && ! sval && (! pval || pval == 465 || pval == 587))
			port.setValue(25, true);
		else if(this.name == 'mail_smtpserver') {
			m = hval.match(/^(ssl|tls):\/\/(.*)$/);
			if(m) {
				host.setValue(m[2], true);
				hval = m[2];
				if(m[1] == 'ssl')
					secure.setValue('ssl', true);
				else
					secure.setValue('tls', true);
				port.setValue(587, true);
			}
			if(hval == 'smtp.gmail.com') {
				secure.setValue('tls', true);
				port.setValue(587, true);
				auth.setValue(1, true);
			}
		}
		else if(! pval || pval == 25) {
			if(sval)
				port.setValue(587, true);
		}
	}
}

function GoogleAuthenticate() {
	var w = window.open('async.php?print=1&module=Users&action=GoogleAuth', '_blank', 'width=300,height=400');
}

function email_account_wizard_return(form, data) {
	SUGAR.ui.getFormInput(form, 'mail_sendtype').setValue('SMTP');
	SUGAR.ui.getFormInput(form, 'mail_smtpserver').setValue(data.smtp.host, true);
	SUGAR.ui.getFormInput(form, 'mail_smtpport').setValue(data.smtp.port, true);
	SUGAR.ui.getFormInput(form, 'mail_smtpauth_req').setValue(data.smtp.auth, true);
	SUGAR.ui.getFormInput(form, 'mail_smtpsecurity').setValue(data.smtp.security, true);
	SUGAR.ui.getFormInput(form, 'mail_smtppass').setValue(data.smtp.password, true);
	SUGAR.ui.getFormInput(form, 'mail_smtpuser').setValue(data.smtp.username, true);
}

var tzData;
function loadTimezones(zones) {
	tzData = zones;
}

function setTimezoneCat(form, newval) {
	var cat = SUGAR.ui.getFormInput(form, 'timezone_cat'),
		tz = SUGAR.ui.getFormInput(form, 'timezone'), opts, cv, init;
	if(! cat || ! tz) return;
	if(! cat.onchange)
		cat.onchange = function() { setTimezoneCat(this.form); }
	if(newval) cat.setValue(newval);
	cv = cat.getValue();
	if(cv && cv != tz.sel_cat) {
		opts = {keys: [], values: [], width: '30em'};
		for(var i in tzData[cv]) {
			if(! isset(init)) init = i;
			opts.keys.push(i);
			opts.values.push(tzData[cv][i]);
		}
		tz.setOptions(new SUGAR.ui.SelectOptions(opts));
		tz.sel_cat = cv;
		tz.setValue(init);
	}
}

function setTimezone(form, value) {
	var cat, p, tz;
	if(value) {
		p = value.indexOf('/');
		if(p > 0) cat = value.substring(0, p);
	}
	setTimezoneCat(form, cat);
	if(cat) {
		tz = SUGAR.ui.getFormInput(form, 'timezone');
		tz.setValue(value);
		return true;
	}
}

function initTimezones(form, value) {
	if(value) {
		if(setTimezone(form, value))
			return;
	}
	setTimezoneCat(form);
	var callback = function(req) {
		var data = req ? req.getResult() : null;
		if(! data) return;
		setTimezone(form, data.timezone);
	}
	var now = new Date(),
		d1 = new Date(now.getFullYear(), 0, 1, 0, 0, 0),
		d1GMTString = d1.toGMTString(),
		d2 = new Date(d1GMTString.substring(0, d1GMTString.lastIndexOf(' ') - 1)),
		offset = ((d1 - d2) / (1000 * 60)),
		req = new SUGAR.conn.JSONRequest('guess_timezone', null, {module: 'Users', userOffset: offset});
	req.fetch(callback);
}

function reset_dav_tokens(form) {
	const req = new SUGAR.conn.JSONRequest(
		'reset_dav_tokens',
		{status_msg: app_string('LBL_LOADING')},
		{
			module: 'Users',
			user_id: form.record.value,
		}
	);

	var err = function(zero, msg) {
		SUGAR.popups.showMessage(msg.failure_msg, {icon: 'uii-danger text-error', timeout: 10000, show_mask: true});
	};

	req.fetchJSON(function(data) {
		if (data.success) {
			SUGAR.popups.showMessage(
				data.message,
				{icon: 'uii-accept text-success', timeout: 10000, show_mask: true}
			);
		} else {
			err.call(this, null, {failure_msg: data.message});
		}
	}, err);
}

