<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description: TODO:  To be written.
 * Portions created by SugarCRM are Copyright (C) SugarCRM, Inc.
 * All Rights Reserved.
 * Contributor(s): ______________________________________..
 ********************************************************************************/

require_once('modules/UserPreferences/UserPreference.php');
require_once ('data/SugarBean.php');

// User is used to store customer information.
class User extends SugarBean {

	const DROPBOX_KEY = 'kggmlwdlifdjzw4';
	const DROPBOX_SECRET = 'r7zme95oi4a383h';

	// Stored fields
	var $name = '';
	var $full_name;
	var $id;
	var $user_name;
	var $user_hash;
	var $first_name;
	var $last_name;
	var $date_entered;
	var $date_modified;
	var $modified_user_id;
	var $created_by;
	var $created_by_name;
	var $modified_by_name;
	var $description;
	var $phone_home;
	var $phone_mobile;
	var $phone_work;
	var $phone_other;
	var $phone_fax;
	var $email1;
	var $email2;
	var $address_street;
	var $address_city;
	var $address_state;
	var $address_postalcode;
	var $address_country;
	var $status;
	var $title;
	var $portal_only;
	var $department;
	var $error_string;
	var $is_admin;
	var $employee_status;
	var $messenger_id;
	var $messenger_type;
	var $accept_status; // to support Meetings

	var $receive_notifications;


	// longreach
	var $location;
	var $sms_address;
	var $photo_filename;
	var $in_directory;
	var $last_access;
	var $is_online;
	// longreach
	var $activity_table_name = "users_activity";
	var $tracking_table_name = "users_tracking";
	var $reporting_table_name = "users_reporting";
	var $reporting_daily_table_name = "users_reporting_daily";


	var $reports_to_name;
	var $reports_to_id;
	var $team_exists = false;
	var $table_name = "users";
	var $module_dir = 'Users';
	var $object_name = "User";

	var $savingpreferencetodb = false;

	var $encodeFields = Array ("first_name", "last_name", "description");

	// This is used to retrieve related fields from form posts.
	var $additional_column_fields = array ('reports_to_name');



	var $new_schema = true;

	// longreach - start added
	var $default_order_by = "user_name";
	var $teamLeaders = null;
	var $team = null;
	var $quotation_mode;
	var $project_mode;
	var $week_start_day;
	var $day_begin_hour;
	var $day_end_hour;
	var $recovery_key;
	var $need_new_password;

	static $restrict_since_opts = array(
		'1d', '7d', '30d', '60d', '90d', '6m', '12m', '18m', 'all',
	);
	static $restrict_period_opts = array(
		'd' => 'days', 'm' => 'months', 'y' => 'years',
	);
	// longreach - end added

    /**
     * returns an admin user
     */
    function getSystemUser() {
    	global $db;
        if(null !== $this->retrieve('1')) {
            return $this;
        } else {
            // handle cases where someone deleted user with id "1"
            $q = "SELECT users.id FROM users WHERE users.status = 'Active' AND users.deleted = 0 AND users.is_admin = 1";
            $r = $db->query($q);
            while($a = $db->fetchByAssoc($r)) {
                $this->retrieve($a['id']);
                return $this;
            }
        }
    }

	function getDefaultSignature($encode=true) {
		global $db;
		$where = '';
		if($defaultId = $this->getPreference('signature_default')) {
			$where = ' AND id = \''.$defaultId.'\'';
			$q = 'SELECT signature, signature_html FROM users_signatures WHERE user_id = \''.$this->id.'\''.$where;
			$r = $db->query($q);
			$a = $db->fetchByAssoc($r, -1, $encode);

			return $a;
		} else {
			return '';
		}
	}

	/**
	 * retrieves any signatures that the User may have created as <select>
	 */
	function getSignatures($live=false, $defaultSig='') {
		global $db;
		$q = 'SELECT * FROM users_signatures WHERE user_id = \''.$this->id.'\' AND deleted = 0 ORDER BY name ASC';
		$r = $db->query($q);
		$sig = array(""=>"");
		while($a = $db->fetchByAssoc($r)) {
			$sig[$a['id']] = $a['name'];
		}
		$change = '';
		if(!$live) {
			$change = 'onChange="setSigEditButtonVisibility();" ';
		}
		$signs  = '<select '.$change.' id="signature_id" name="signature_id" tabindex="390">';
		$signs .= get_select_options($sig, $defaultSig).'</select>';
		return $signs;
	}

	/**
	 * returns buttons and JS for signatures
	 */
	function getSignatureButtons() {
		global $mod_strings;
        $title = $mod_strings['LBL_EMAIL_SIGNATURE'];
		$butts  = '<button type="button" class="input-button input-outer" onclick="open_email_signature_form(\'\', \''.$this->id.'\', \''.$title.'\')"><div class="input-icon icon-add left"></div><span class="input-label">' . $mod_strings['LBL_BUTTON_CREATE'] . '</span></button>&nbsp;';
		$butts .= '<span name="edit_sig" id="getSignatureButtons" style="visibility:hidden;"><button type="button" class="input-button input-outer" onclick="open_email_signature_form(document.DetailForm.signature_id.value, \''.$this->id.'\', \''.$title.'\')"><div class="input-icon icon-edit left"></div><span class="input-label">' . $mod_strings['LBL_BUTTON_EDIT'] . '</span></button>&nbsp;</span>';
		return $butts;
	}


	/* Returns the User's private GUID; this is unassociated with the User's
	 * actual GUID.  It is used to secure file names that must be HTTP://
	 * accesible, but obfusicated.
	 */
	function getUserPrivGuid() {
        $userPrivGuid = $this->getPreference('userPrivGuid', 'global', $this);
		if ($userPrivGuid) {
			return $userPrivGuid;
		} else {
			$this->setUserPrivGuid();
			if (empty($GLOBALS['_setPrivGuid_'])) {
				$GLOBALS['_setPrivGuid_'] = true;
				$userPrivGuid = $this->getUserPrivGuid();
				return $userPrivGuid;
			} else {
				sugar_die("Breaking Infinite Loop Condition: Could not setUserPrivGuid.");
			}
		}
	}

	function setUserPrivGuid() {
		$privGuid = create_guid();
		//($name, $value, $nosession=0)
		$this->setPreference('userPrivGuid', $privGuid, 0, 'global', $this);
	}

	/**
	 * Alias for setPreference in modules/UserPreferences/UserPreference.php
	 *
	 */
	function setPreference($name, $value, $nosession = 0, $category = 'global', $user = null) {
        if(isset($user)) {
            UserPreference::setPreference($name, $value, $nosession, $category, $user);
        }
        else {
            UserPreference::setPreference($name, $value, $nosession, $category, $this);
        }
	}

	/**
	 * Alias for setPreference in modules/UserPreferences/UserPreference.php
	 *
	 */
	function resetPreferences($user = null, $category = null) {
        if(isset($user)) {
            UserPreference::resetPreferences($category, $user);
        }
        else {
            UserPreference::resetPreferences($category, $this);
        }
	}


	/**
	 * Alias for setPreference in modules/UserPreferences/UserPreference.php
	 *
	 */
	function savePreferencesToDB($user = null) {
        if(isset($user)) {
            UserPreference::savePreferencesToDB($user); // note the correct spelling!
        }
        else {
            UserPreference::savePreferencesToDB($this);
        }
	}

	/**
	 * Alias for setPreference in modules/UserPreferences/UserPreference.php
	 *
	 */
	function getUserDateTimePreferences($user = null) {
        if(isset($user)) {
            return UserPreference::getUserDateTimePreferences($user);
        }
        else {
            return UserPreference::getUserDateTimePreferences($this);
        }

	}

	/**
	 * Alias for setPreference in modules/UserPreferences/UserPreference.php
	 *
	 */
	function loadPreferences($category = 'global', $user = null, $reload=false) {
        if(isset($user)) {
            UserPreference::loadPreferences($category, $user, $reload);
        }
        else {
            UserPreference::loadPreferences($category, $this, $reload);
        }
	}

	/**
	 * Alias for setPreference in modules/UserPreferences/UserPreference.php
	 *
	 */
	function getPreference($name, $category = 'global', $user = null) {
        if(isset($user)) {
            return UserPreference::getPreference($name, $category, $user);
        }
        else {
            return UserPreference::getPreference($name, $category, $this);
        }
	}

	function save($check_notify = false) {
		// longreach - added $ret
		$ret = parent::save($check_notify);

        $this->savePreferencesToDB($this);

		// longreach - added return
		return $ret;
	}

	static function before_save(RowUpdate &$upd) {
		require_once 'include/utils/misc_functions.php';
		return User_before_save($upd);
    }

	static function after_save(RowUpdate &$upd) {
		if($upd->new_record) {
			// create employee to match user
			require_once('modules/HR/Employee.php');
			Employee::create_for_user($upd);
			// create email folders for user
			require_once('modules/EmailFolders/EmailFolder.php');
			EmailFolder::create_default_folders_for_user($upd);
		}

		AppConfig::invalidate_cache('acl');
		if($upd->getPrimaryKeyValue() == AppConfig::current_user_id())
			AppConfig::invalidate_cache('userpref');

    	$status = $upd->getField('status');
    	$old_status = $upd->getField('status', null, true);
		$status_changed = ($status=='Active') ^ ($old_status=='Active');
		if($upd->getFieldUpdated('reports_to_id') || $status_changed) {
			self::recalculate_forecasts($upd, $status_changed);
		}
	}

    function get_summary_text() {
        $this->_create_proper_name_field();
        return $this->name;
	}


    /**
     * retrieves an User bean
     * preformat name & full_name attribute with first/last
     * loads User's preferences
     *
     * @param string id ID of the User
     * @param bool encode encode the result
     * @return object User bean
     * @return null null if no User found
     */
	function retrieve($id=-1, $encode = true) {
		global $locale;

		$ret = parent::retrieve($id, $encode);

		if ($ret) {
			// make a properly formatted first and last name
			$this->_create_proper_name_field();

			if (isset ($_SESSION)) {
				$this->loadPreferences();
			}
		}
		return $ret;
	}


	function retrieve_user_id($user_name) {
		global $db;
		$query = "SELECT id from users where user_name='$user_name' AND deleted=0";
		$result = $db->query($query, false, "Error retrieving user ID: ");
		$row = $db->fetchByAssoc($result);
		return $row['id'];
	}


	/**
	 * Generate the name field from the first_name and last_name fields.
	 */
	function _create_proper_name_field() {
        global $locale;
        $full_name = $locale->getLocaleFormattedName($this->first_name, $this->last_name);
        $this->name = $full_name;
        $this->full_name = $full_name;

	}


	// longreach - start added
	function is_team_leader()
	{
		global $db;
		$result = $db->query("select count(id) from `{$this->table_name}` where reports_to_id='" . PearDatabase::quote($this->id) . "' and deleted != 1");
		if ($row = $db->fetchByAssoc($result)) {
			if (0 < current($row))
				return true;
		}
		return false;
	}


	function getTeam($add_quotes=true)
	{
		global $db;
		if (is_null($this->team)) {
			$this->team = array($this->id);
			$result = $db->query("select id, reports_to_id from `{$this->table_name}` where deleted != 1 and status='Active'");
			$source = array();
			while ($source[] = $db->fetchByAssoc($result));
			array_pop($source);
			$this->createTeamList($source, $this->id, true);
		}
		$GLOBALS['log']->debug('TEAM for ' . $this->user_name);
		$GLOBALS['log']->debug($this->team);
		if($add_quotes) {
			foreach($this->team as $k => $v)
				$this->team[$k] = "'$v'";
		}
		return $this->team;
	}


	function createTeamList($source, $id, $override = false)
	{
		foreach ($source as $value) {
			if ($id == $value['reports_to_id']
				&& !in_array($value['id'], $this->team, true)
				) {
				$this->team[] = $value['id'];
				$this->createTeamList($source, $value['id']);
			}
		}
	}

	function getTeamLeaders()
	{
		global $db;
		if (is_null($this->teamLeaders)) {
			$this->teamLeaders = array($this->id);
			$id = $this->id;
			while (null != $id) {
				$result = $db->query(
					"SELECT other.id FROM users LEFT JOIN users other
					 ON other.id=users.reports_to_id AND other.status='Active' AND other.deleted=0
					 WHERE users.id='" . PearDatabase::quote($id) . "' AND users.deleted = 0 AND users.status='Active'",1);
				if ($row = $db->fetchByAssoc($result)) {
					if (null != ($id = current($row)))
						$this->teamLeaders[] = $id;
				}
				else $id = null;
			}
		}
		return $this->teamLeaders;
	}


	static function recalculate_forecasts(RowUpdate &$user, $status_changed) {
		global $db;

		require_once 'modules/Forecasts/Forecast.php';
		require_once 'modules/Forecasts/ForecastCalculator.php';
		$seedForecast = new Forecast();
		$period 			= AppConfig::setting('company.forecast_period');
		$fiscal_year_start	= AppConfig::setting('company.fiscal_year_start');
		$user_id = $user->getPrimaryKeyValue();

		if ($status_changed) {
			$db->query("UPDATE forecasts SET deleted = 1 WHERE user_id='{$user_id}'");
			if ($user->getField('status') == 'Active') {
				$forecast_periods 	= AppConfig::setting('company.retain_forecast_periods');
				$history_periods 	= AppConfig::setting('company.retain_history_periods');
				$user_data = array(
					$user_id => array(
						'id' => $user_id,
						'user_name' => $user->getField('user_name'),
						'reports_to_id' => $user->getField('reports_to_id'),
					)
				);
				$fcalc = new ForecastCalculator($period, $user_data);
				for ($i = -$history_periods; $i < $forecast_periods; $i ++) {
					$fcalc->fill_forecasts($i, $fiscal_year_start, true);
				}
				$fcalc->cleanup();
			}
		}

		$fcalc = new ForecastCalculator($period);

		$old_reports_to = $user->getField('reports_to_id', null, true);
		if ($old_reports_to && $user->getFieldUpdated('reports_to_id')) {
			$fcalc->update_user_team_forecasts($old_reports_to);
		}
		$fcalc->update_user_team_forecasts($user_id);

		$fcalc->cleanup();
		$seedForecast->cleanup();
	}

	// longreach - start added - insert a row in the activity log - called when a user logs in
	function insert_access_time() {
		global $db; /** @var $db DBManager */
		if(! $this->id || $db->isReadOnly()) return;
		$this->update_access_time();
		$query = "DELETE FROM $this->activity_table_name WHERE user_id='$this->id'".
			" AND access_time < NOW() - INTERVAL 1 HOUR";
		$db->query($query, false);
	}

	// longreach - added - update access time for the current user
	function update_access_time() {
		global $db; /** @var $db DBManager */
		if(! $this->id || $db->isReadOnly()) return;
		$sess_id = $db->quote(session_id());
		$query = "INSERT INTO $this->activity_table_name (user_id, session_id, access_time) "
				. "VALUES ('$this->id', '$sess_id', NOW()) "
				. "ON DUPLICATE KEY UPDATE access_time=VALUES(access_time)";
		$result = $db->query($query, false);
		$this->log_user_access($db);
	}

	function log_user_access(DBManager $db){
		global $log; /** @var $log \Katzgrau\KLogger\Logger */
		$is_login = $db->getAffectedRowCount() == 1;
		$mode = AppConfig::setting('site.user.activity.tracker', 'off');
		if ($mode == 'off') return true;
		//$log->error(var_export($_REQUEST,true));
		if (!$is_login) {
			$fields = ['action'=>'', 'record_perform'=>'', 'module'=>'', 'record'=>''];
			$values = array_intersect_key($_POST + $_GET, $fields);
			if (isset($values['record_perform'])) {
				$values['action'] = $values['record_perform'];
			}
			// SID re-use vulnerability
			if (!isset($values['action'])){
				$values = ['action' => "Login", 'module' => "Users", 'record'=>""];
			}
			foreach ($values as &$value) $value = $db->quote($value);
			unset($value);
			if ($mode != "modules" && $mode != 'records') $values['module'] = '';
			if ($mode != "records") $values['record'] = '';
			$values = $values + $fields;

		} else {
			$values = ['action' => "Login", 'module' => "Users", 'record'=>""];
		}
		// IGNORE reduces clutter for login redirects and index calls to async / multiple async per page.
		$query = "INSERT IGNORE INTO $this->tracking_table_name (user_id, access_time, action, related_type, related_id) "
			. "VALUES ('$this->id', NOW(), '{$values['action']}', '{$values['module']}', '{$values['record']}') ";
		$result = $db->query($query);

		return $result;

	}

	// longreach - added - get last access time for a user
	function get_last_access_time() {
		global $db;
		$query = "SELECT MAX(access_time) AS last_access,".
			" (MAX(access_time) > NOW() - INTERVAL 15 MINUTE) AS is_online".
			" FROM $this->activity_table_name".
			" WHERE user_id='$this->id' AND NOT deleted";
		$result = $db->limitQuery($query,0,1, false);
		if(!empty($result)) {
			$row = $db->fetchByAssoc($result);
			$this->last_access = $row['last_access'];
			$this->is_online = $row['is_online'];
		}
		return $this->last_access;
	}

	// longreach - added - mark user's activity session as deleted
	function logged_out_session() {
		global $db;
		if(! $this->id || $db->isReadOnly()) return;
		$sess_id = session_id();
		$query = "UPDATE $this->activity_table_name SET deleted=1".
			" WHERE user_id='$this->id' AND session_id='$sess_id'";
		$db->query($query, false);
	}

	// longreach - added
	function retrieveAdminUser()
	{
		global $db;
		// try standard admin user first
		if ($admin = $this->retrieve('1')) {
			return $admin;
		}
		$query = 'SELECT id FROM users WHERE is_admin AND ! deleted LIMIT 1';
		$res = $db->query($query, true);
		$row = $db->fetchByAssoc($res);
		return $this->retrieve($row['id']);
	}


	// longreach - end added

	function invalidate_emails_count() {
		$_SESSION['email_last_count_time'.$this->id] = 0;
	}

	function get_new_emails_count() {
		$import_ts = $this->getPreference('new_email_timestamp', 'email_import');
		$count_ts = array_get_default($_SESSION, 'email_last_count_time'.$this->id);
		$last_count = array_get_default($_SESSION, 'email_last_count');
		if(isset($count_ts) && $count_ts > time() - 3*3600 && (! isset($import_ts) || $import_ts < $count_ts))
			return $last_count;

		$new_msgs = 0;
		require_once 'modules/EmailFolders/EmailFolder.php';
		$folders = EmailFolder::get_folders_list($this->id);
		foreach ($folders as $folder) {
			if ($folder['reserved'] == STD_FOLDER_INBOX && $folder['newmessages'] > 0) {
				$new_msgs = $folder['newmessages'];
				break;
			}
		}
		$_SESSION['email_last_count'] = $new_msgs;
		$_SESSION['email_last_count_time'.$this->id] = time();
		return $new_msgs;
	}

    static function rewrite_onsubmit(DetailManager $mgr) {
        if ($mgr->layout_name == 'Display') {
            global $pageInstance;
            $pageInstance->add_js_literal("setOnSubmitEvent();", null, LOAD_PRIORITY_FOOT);
        }
    }

    /**
     * Get a list of all users that are direct
     * or indirect reports to the current user
     *
     * @static
     * @param string $user_id
     * @param bool $add_finder_id
     * @param bool $add_indirect
     *
     * @return array
     */
    static function get_team_list($user_id, $add_finder_id = true, $add_indirect = true) {
        $lq = new ListQuery('User', array('id', 'reports_to_id'));
        $result = $lq->fetchAll();

        $team = array();
        if ($result)
            $team = User::fill_team($result->rows, $user_id, $add_indirect);

        if ($add_finder_id)
            $team[] = $user_id;

        return $team;
    }

    /**
     * Grab team members IDs from Active users list
     *
     * @static
     * @param array $users
     * @param string $user_id
     * @param bool $override
     * @return array
     */
    static function fill_team($users, $user_id, $add_indirect = true, $override = false) {
        static $result = array();
        if ($override)
            $result = array();

        foreach ($users as $value) {
            if ($user_id == $value['reports_to_id'] && !in_array($value['id'], $result, true)) {
                $result[] = $value['id'];
                if ($add_indirect)
                    User::fill_team($users, $value['id']);
            }
        }

        return $result;
    }

    static function is_online($id) {
        global $db;

        $query = "SELECT (MAX(access_time) > NOW() - INTERVAL 15 MINUTE) AS is_online".
            " FROM `users_activity`".
            " WHERE user_id='$id' AND NOT deleted";

        $result = $db->limitQuery($query, 0, 1, false);
        $status = false;

        if(! empty($result)) {
            $row = $db->fetchByAssoc($result);
            if ($row['is_online'] == '1')
                $status = true;
        }

        return $status;
    }

    static function format_cost($projecttask_id, $cost, $symbol = true) {
        require_once('include/utils/html_utils.php');
        global $db;

        $query = "SELECT currency_id, exchange_rate FROM project_task WHERE id = '".$projecttask_id."'";
        $result = $db->limitQuery($query, 0, 1, false);
        $params = array('name' => 'actual_cost', 'type' => 'currency', 'entered_currency_id' => '-99');
        $currency_id = '-99';

        if (! $symbol)
            $params['currency_symbol'] = false;

        if(! empty($result)) {
            $row = $db->fetchByAssoc($result);
            if (sizeof($row) > 0) {
                $currency_id = $row['currency_id'];
                $params['exchange_rate'] = $row['exchange_rate'];
                $params['convert'] = true;
            }
        }

        $params['currency_id'] = $currency_id;
        $formatted_cost = html2plaintext(currency_format_number($cost, $params));

        return $formatted_cost;
    }

    static function get_hourly_rate($user_id) {
        global $db;
        $hourly_rate = 0;

        $query = "SELECT std_hourly_rate_usdollar AS hourly_rate FROM employees WHERE user_id = '".$user_id."'";
        $result = $db->limitQuery($query, 0, 1, false);

        if (! empty($result)) {
            $row = $db->fetchByAssoc($result);

            if (! empty($row['hourly_rate']))
                $hourly_rate = $row['hourly_rate'];
        }

        return $hourly_rate;
    }

    static function actual_hours_select($spec, $table, $for_order=false) {
    	return "SELECT SUM(quantity) FROM booked_hours WHERE NOT deleted AND related_type='ProjectTask' "
    		.  "AND related_id=$table.projecttask_id AND assigned_user_id=$table.user_id";
    }

    static function actual_cost_select($spec, $table, $for_order=false) {
    	return "SELECT SUM(paid_total_usd) FROM booked_hours WHERE NOT deleted AND related_type='ProjectTask' "
    		.  "AND related_id=$table.projecttask_id AND assigned_user_id=$table.user_id";
    }

    static function estim_cost_select($spec, $table, $for_order=false) {
    	return "SELECT $table.estim_hours * IF($table.hourly_cost_custom, $table.hourly_cost_usdollar, "
    		.  "(SELECT std_hourly_rate_usdollar FROM employees WHERE user_id=$table.user_id))";
    }


	static function get_status_options() {
		global $app_list_strings;
		return array('' => translate('LBL_ANY_STATUS', 'Users'), 'NotInactive' => translate('LBL_NOT_INACTIVE', 'Users')) + $app_list_strings['user_status_dom'];
	}

	static function get_search_status_where($param) {
		$name = $param['name'];
		$value = $param['value'];
		if ($value == 'NotInactive') return array('field' => $name, 'value' => 'Inactive', 'operator' => 'not_eq');
		else if(! $value) return;
		else return array('field' => $name, 'value' => $value, 'operator' => 'eq');
	}

	static function update_acl(RowUpdate $upd, $link_name) {
		$model = $upd->getModelName();
		if($model == 'User' && ($link_name == 'aclroles' || $link_name == 'securitygroups')) {
			AppConfig::invalidate_cache('acl');
		}
	}

	static function create_recovery_key($length=16) {
		$uniq = str_replace('-', '', create_guid());
		// removed characters which might be confused
		$range = "23456789ABCDEFGHJKLMNPQRSTUVWXYZabcdefghijkmnopqrstuvwxyz";
		$range = preg_split('//', $range);
		shuffle($range);
		$key = '';
		for($i=0; $i < $length; $i ++)
			$key .= $range[mt_rand(0, count($range)-1)];
		return $key;
	}

	public static function __callStatic($name, $args)
	{
		$name = strtolower($name);
		if (substr($name, 0, 17) == 'preference_field_') {
			return self::preference_field(substr($name, 17), $args);
		}
	}

	protected static function preference_field($name, $args)
	{
        return UserPreference::getPreference($name, 'global', $args[0]);
	}

	static function get_restrict_options() {
        return User::restrict_since_options();
    }

    static function format_restrict_since($val) {
    	global $app_list_strings;
    	$dom =& $app_list_strings['calendar_import_since_dom'];
    	if(preg_match('/^(\d+)([dmy])$/', $val, $m)) {
    		$lbl = $dom['prev_n_'.self::$restrict_period_opts[$m[2]]];
    		return str_replace('{N}', $m[1], $lbl);
    	}
    	if(isset($dom[$val]))
    		return $dom[$val];
    	return $val;
    }

    static function restrict_since_options() {
    	$opts = array();
    	foreach(self::$restrict_since_opts as $s)
    		$opts[$s] = self::format_restrict_since($s);
    	return $opts;
    }

    static function restrict_since_time($val=null) {
    	if(preg_match('/^(\d+)([dmy])$/', $val, $m)) {
    		return (-$m[1]).' '.self::$restrict_period_opts[$m[2]];
    	}
    	return '';
    }

	static function add_check_2fa_flag() {
		if (AppConfig::setting('layout.list.require_2fa', false)) {
			setcookie('check_2fa', '1', time() + (86400), "/");
		}
	}

	/**
	 * Check user_name duplication, returns reason if exists
	 *
	 * @param $id
	 * @param $user_name
	 * @return mixed|string|void
	 */
	static function check_user_name_duplication($id, $user_name) {
		$lq = new ListQuery("User", ['id']);
		$lq->addSimpleFilter("id", $id, '!=');
		$lq->addSimpleFilter("user_name", $user_name);
		$listResult = $lq->runQuery();

		if ($listResult->count()) {
			return translate('ERR_ENTER_DUPLICATED_USER_NAME', 'Users');
		}
	}

} // end class definition

?>
