<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/Users/User.php
	unified_search
		enabled: true
		default: false
	duplicate_merge: false
	table_name: users
	primary_key: id
	display_name: name
	default_order_by: _display
	importable: LBL_USERS
	record_status: status
	personal_data: true
    reportable: true
hooks
	before_save
		--
			class_function: before_save
	after_save
		--
			class_function: after_save
	after_add_link
		--
			class_function: update_acl
	after_remove_link
		--
			class_function: update_acl
	after_login
		--
			function: [User, add_check_2fa_flag]
		--
			function: [SystemMessage, check_system_messages]
	after_page_render
		--
			function: [SystemMessage, show_system_messages]
fields
	app.id
	app.date_entered
	app.date_modified
	app.modified_user
	app.created_by_user
	app.deleted
	full_name
		vname: LBL_NAME
		type: name
		source
			type: person_name
			fields
				- first_name
				- last_name
				- salutation
			order: display
		unified_search: true
        reportable: true
	user_name
		vname: LBL_USER_NAME
		type: user_name
		len: 60
		vname_list: LBL_LIST_USER_NAME
		unified_search: true
		required: true
        reportable: true
	user_hash
		vname: LBL_NEW_PASSWORD1
		type: char
		len: 255
		editable: false
		reportable: false
		protected: true
	authenticate_id
		vname: LBL_AUTHENTICATE_ID
		type: varchar
		len: 100
		reportable: false
	sugar_login
		vname: LBL_SUGAR_LOGIN
		type: bool
		default: 1
		massupdate: false
		reportable: false
	salutation
		vname: LBL_SALUTATION
		type: enum
		options: salutation_dom
		massupdate: false
		len: 20
		personal_info: true
	first_name
		vname: LBL_FIRST_NAME
		type: name
		len: 30
		personal_info: true
	last_name
		vname: LBL_LAST_NAME
		type: name
		len: 30
		personal_info: true
	name
		vname: LBL_NAME
		type: name
		source
			type: user_display_name
		reportable: false
	reports_to
		vname: LBL_REPORTS_TO
		type: ref
		reportable: true
		bean_name: User
		massupdate: true
	is_admin
		vname: LBL_IS_ADMIN
		vname_list: LBL_LIST_ADMIN
		vdesc: LBL_ADMIN_TEXT
		type: bool
		default: 0
		massupdate: true
	receive_notifications
		vname: LBL_RECEIVE_NOTIFICATIONS
		vdesc: LBL_RECEIVE_NOTIFICATIONS_TEXT
		type: bool
		default: 1
		reportable: false
		massupdate: true
	description
		vname: LBL_NOTES
		type: text
	title
		vname: LBL_TITLE
		type: varchar
		len: 50
		personal_info: true
	department
		vname: LBL_DEPARTMENT
		type: enum
		options: departments_dom
		vname_list: LBL_LIST_DEPARTMENT
		massupdate: true
		personal_info: true
        reportable: true
	phone_home
		vname: LBL_HOME_PHONE
		type: phone
		personal_info: true
	phone_mobile
		vname: LBL_MOBILE_PHONE
		type: phone
		personal_info: true
	phone_work
		vname: LBL_WORK_PHONE
		type: phone
		vname_list: LBL_LIST_PRIMARY_PHONE
		personal_info: true
	phone_other
		vname: LBL_OTHER_PHONE
		type: phone
		personal_info: true
	phone_fax
		vname: LBL_FAX_PHONE
		type: fax
		personal_info: true
	skype_id
		vname: LBL_SKYPE_ID
		type: skype
		unified_search: true
		comment: Skype ID
		personal_info: true
	local_extension
		vname: LBL_LOCAL_EXTENSION
		type: extension_number
		len: 6
	email1
		vname: LBL_EMAIL
		type: email
		vname_list: LBL_LIST_EMAIL
		personal_info: true
	email2
		vname: LBL_OTHER_EMAIL
		type: email
		personal_info: true
	website
		vname: LBL_WEBSITE
		type: url
		personal_info: true
	status
		vname: LBL_STATUS
		vname_list: LBL_LIST_STATUS
		type: status
		len: 25
		options: user_status_dom
		massupdate: true
		required: true
		default: Active
        reportable: true
	address_street
		vname: LBL_ADDRESS_STREET
		type: varchar
		len: 150
		personal_info: true
	address_city
		vname: LBL_ADDRESS_CITY
		type: varchar
		len: 100
		personal_info: true
	address_state
		vname: LBL_ADDRESS_STATE
		type: varchar
		len: 100
		personal_info: true
	address_country
		vname: LBL_ADDRESS_COUNTRY
		type: varchar
		len: 25
		personal_info: true
	address_postalcode
		vname: LBL_ADDRESS_POSTALCODE
		type: varchar
		len: 9
		personal_info: true
	location
		vname: LBL_LOCATION
		type: varchar
		len: 30
		reportable: false
		personal_info: true
	sms_address
		vname: LBL_SMS
		type: varchar
		len: 100
		reportable: false
		personal_info: true
	photo
		vname: LBL_PHOTO
		type: image
		upload_dir: {FILES}/images/directory/
		placeholder: themes/Default/images/no_user.png
		personal_info: true
	photo_filename
		vname: LBL_PHOTO_FILENAME
		type: file_ref
		personal_info: true
	photo_thumb
		vname: LBL_THUMBNAIL_FILENAME
		type: file_ref
		personal_info: true
	in_directory
		vname: LBL_IN_DIRECTORY
		vdesc: LBL_IN_DIRECTORY_TEXT
		type: bool
		default: 0
		reportable: false
		massupdate: true
	quotation_mode
		type: enum
		len: 30
		options: quotation_modes
		vname: LBL_QUOTE_CATALOG_MODE
		massupdate: false
		reportable: false
	project_mode
		type: enum
		len: 30
		options: project_modes
		vname: LBL_PROJECT_CATALOG_MODE
		massupdate: false
		reportable: false
	week_start_day
		vname: LBL_WEEK_START_DAY
		type: int
		len: 1
		default: 0
		reportable: false
	day_begin_hour
		vname: LBL_DAY_BEGIN_HOUR
		type: float
		default: 8
		reportable: false
		disable_num_format: true
	day_end_hour
		vname: LBL_DAY_END_HOUR
		type: float
		default: 18
		reportable: false
		disable_num_format: true
	portal_only
		vname: LBL_PORTAL_ONLY
		vname_list: LBL_LIST_PORTAL
		vdesc: LBL_PORTAL_ONLY_TEXT
		type: bool
		massupdate: true
	employee_status
		vname: LBL_EMPLOYEE_STATUS
		type: enum
		options: employee_status_dom
		len: 25
		massupdate: true
		default: Active
        reportable: true
	messenger_id
		vname: LBL_MESSENGER_ID
		type: varchar
		len: 50
	messenger_type
		vname: LBL_MESSENGER_TYPE
		type: varchar
		len: 25
	signature_image
		vname: LBL_SIGNATURE_IMAGE
		type: image
		filename: signature_image_filename
		placeholder: include/language/images/en_us/default_signature.png
		display_size: [300, 100]
		pdf_format: true
		max_size: 500
	signature_image_filename
		vname: LBL_SIGNATURE_IMAGE_FILENAME
		type: file_ref
	last_login_attempt
		vname: LBL_LAST_LOGIN_ATTEMPT
		type: datetime
		reportable: false
	login_attempts
		vname: LBL_LOGIN_ATTEMPTS
		type: int
		reportable: false
	need_new_password
		vname: LBL_CHANGE_PASSWORD_FLAG
		type: bool
		reportable: false
		default: 0
	recovery_key
		vname: LBL_RECOVERY_KEY
		type: varchar
		len: 50
		editable: false
		reportable: false
		protected: true
	recovery_key_time
		vname: LBL_RECOVERY_KEY_TIME
		type: datetime
		editable: false
		reportable: false
	recovery_ip_addr
		vname: LBL_RECOVERY_IP_ADDR
		type: varchar
		len: 50
		editable: false
		reportable: false
		protected: true
	sf_id
		vname: LBL_SF_ID
		reportable: false
		type: hidden
		len: 50
		editable: false
		updateable: false
	notarius_phone
		vname: LBL_NOTARIUS_PHONE
		type: phone
		comment: Phone number that can be used as second authentication factor for ConsignO Cloud signing
		audited: true
		personal_info: true
	notarius_question
		vname: LBL_NOTARIUS_QUESTION
		type: varchar
		len: 100
		comment: Secret question that can be used as second authentication factor for ConsignO Cloud signing
		personal_info: true
	notarius_answer
		vname: LBL_NOTARIUS_ANSWER
		type: varchar
		len: 100
		comment: Answer to the secret question that can be used as second authentication factor for ConsignO Cloud signing
		personal_info: true
	notarius_second_factor
		vname: LBL_NOTARIUS_SECOND_FACTOR
		type: enum
		options: notarius_auth_factor_dom
		len: 30
		comment: Type of the second authentication factor for ConsignO Cloud signing
		default: sms
		required: true
	notarius_subject_dn
		vname: LBL_NOTARIUS_SUBJECT_DN
		type: varchar
		len: 255
		personal_info: true
		comment: Subject Distinguished Name for CertifiO Cloud digital signature
	notarius_signature_type
		vname: LBL_NOTARIUS_SIGNATURE_TYPE
		type: enum
		options: notarius_signature_type_dom
		len: 30
		comment: Signature type
		default: esig
	notarius_language
		vname: LBL_NOTARIUS_LANGUAGE
		type: enum
		options: notarius_language_dom
		options_add_blank: false
		len: 5
		comment: Language
		default: en
links
	report_notify_link
		relationship: reports_notify_users
		vname: LBL_NOTIFIED_REPORTS
		reportable: false
	calls
		relationship: calls_users
		vname: LBL_CALLS
	meetings
		relationship: meetings_users
		vname: LBL_MEETINGS
	emails
		relationship: emails_users_rel
		vname: LBL_EMAILS
	tasks
		relationship: tasks_users
		vname: LBL_TASKS
	contacts_sync
		relationship: contacts_users
		vname: LBL_CONTACTS_SYNC
	aclroles
		relationship: acl_roles_users
		side: right
		vname: LBL_ROLES
	app.securitygroups
		relationship: securitygroups_users
	prospect_lists
		relationship: prospect_list_users
		module: ProspectLists
		vname: LBL_PROSPECT_LIST
	skills
		relationship: users_skills
		vname: LBL_USER_SKILLS
	mailboxes
		relationship: user_mailboxes
		vname: LBL_MAILBOXES
		layout: User
		removeable: false
	userreporting_user
		relationship: userreporting_user
		vname: LBL_USER_ACTIVITY_REPORTS
		reportable: true
	userreportingdaily_user
		relationship: userreportingdaily_user
		vname: LBL_USER_ACTIVITY_DAILY_REPORTS
		reportable: true
indices
	user_name_idx
		fields
			- user_name
relationships
	acl_roles_users
		key: id
		target_bean: ACLRole
		target_key: id
		join
			table: acl_roles_users
			source_key: user_id
			target_key: role_id
		relationship_type: many-to-many
	user_mailboxes
		key: id
		target_bean: EmailPOP3
		target_key: user_id
		relationship_type: one-to-many
	tasks_users
		key: id
		target_bean: Task
		target_key: assigned_user_id
		relationship_type: one-to-many
