<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo,
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

$json_supported_actions['get_reporting_users'] = array('function_name' => 'json_get_reporting_users');

function json_get_reporting_users() {
	global $current_user, $mod_strings	;
	$post = $_REQUEST;
	$can_approve = ACLController::checkAccess('Vacations', 'approve');
	$can_approve_self = false;

	if($current_user->reports_to_id == '' || $current_user->reports_to_id == $current_user->id)
		$can_approve_self = true;

	if(!isset($post['user_id'])) {
		$vac = ListQuery::quick_fetch_row('Vacation', $post['record']);
		$post['user_id'] = $vac['assigned_user_id'];
		$post['status'] = $vac['status'];
	}

	require_once('modules/Users/User.php');
	$team_users = User::get_team_list($current_user->id);
	if(in_array($post['user_id'], $team_users) && $can_approve)
		$res = [
			'id' => $current_user->id,
			'name' => $current_user->user_name,
			'message' => '',
			'can_assign' => true,
			'role' => 'reporting_user',
			'status' => $post['status'],
			'can_approve_self' => $can_approve_self
		];
	elseif ($post['user_id'] == $current_user->id)
		$res = [
			'id' => $current_user->id,
			'name' => $current_user->user_name,
			'message' => '',
			'can_assign' => true,
			'role' => 'current_user',
			'status' => $post['status'],
			'can_approve_self' => $can_approve_self
		];
	elseif (in_array($post['user_id'], $team_users) && !$can_approve)
		$res = [
			'id' => $current_user->id,
			'name' => $current_user->user_name,
			'message' => translate('LBL_CANNOT_ASSIGN_RIGHTS', 'Vacations'),
			'can_assign' => false,
			'role' => '',
			'status' => $post['status'],
			'can_approve_self' => $can_approve_self
		];
	else
		$res = [
			'id' => $current_user->id,
			'name' => $current_user->user_name,
			'message' => translate('LBL_CANNOT_ASSIGN', 'Vacations'),
			'can_assign' => false,
			'role' => '',
			'status' => $post['status'],
			'can_approve_self' => $can_approve_self
		];

	json_return_value($res);
}

?>
