
function testConnect(form) {
    var url = SUGAR.ui.getFormInput(form, 'woocommerce_url').getValue();
    var key = SUGAR.ui.getFormInput(form, 'woocommerce_consumer_key').getValue();
    var secret = SUGAR.ui.getFormInput(form, 'woocommerce_consumer_secret').getValue();

    var req = new SUGAR.conn.JSONRequest(
        'test_woo_connect',
        {status_msg: app_string('LBL_LOADING')},
        {
            module: 'WooCommerce',
            url: url,
            key: key,
            secret: secret,
        }
    );
    var mask = SUGAR.util.maskDiv('content-main');

    var err = function(zero, msg) {
        SUGAR.util.hideMask(mask);
        SUGAR.popups.showMessage(msg.failure_msg, {icon: 'uii-danger text-error', timeout: 10000, show_mask: true});
        this.revertFileInputs(true);
    };

    req.fetchJSON(function(data) {
        if(data.success == '1') {
            SUGAR.popups.showMessage(data.message, {
                icon: 'uii-accept text-success',
                onclose: function() { SUGAR.util.hideMask(mask);},
                timeout: 10000
            });
        } else {
            err.call(this, null, {failure_msg: data.message});
        }
    }, err);

    return false;
}

function resync(form) {

    var req = new SUGAR.conn.JSONRequest(
        'woo_resync',
        {status_msg: app_string('LBL_LOADING')},
        {module: 'WooCommerce'}
    );
    var mask = SUGAR.util.maskDiv('content-main');

    var err = function(zero, msg) {
        SUGAR.util.hideMask(mask);
        SUGAR.popups.showMessage(msg.failure_msg, {icon: 'uii-danger text-error', timeout: 10000, show_mask: true});
        this.revertFileInputs(true);
    };

    req.fetchJSON(function(data) {
        if(data.success == '1') {
            SUGAR.popups.showMessage(data.message, {
                icon: 'uii-accept text-success',
                onclose: function() { SUGAR.util.hideMask(mask);},
                timeout: 10000
            });
        } else {
            err.call(this, null, {failure_msg: data.message});
        }
    }, err);

    return false;
}


function resetStatus(form) {

	var req = new SUGAR.conn.JSONRequest(
		'woo_reset_status',
		{status_msg: app_string('LBL_LOADING')},
		{module: 'WooCommerce'}
	);
	var mask = SUGAR.util.maskDiv('content-main');

	var err = function(zero, msg) {
		SUGAR.util.hideMask(mask);
		SUGAR.popups.showMessage(msg.failure_msg, {icon: 'uii-danger text-error', timeout: 10000, show_mask: true});
		this.revertFileInputs(true);
	};

	req.fetchJSON(function(data) {
		if(data.success == '1') {
			SUGAR.popups.showMessage(data.message, {
				icon: 'uii-accept text-success',
				onclose: function() { SUGAR.util.hideMask(mask);},
				timeout: 10000
			});
		} else {
			err.call(this, null, {failure_msg: data.message});
		}
	}, err);

	return false;
}
