<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');


require_once('modules/Workflow/WFProcessorBase.php');

$mod = array_get_default($_REQUEST, 'module');
$bean = AppConfig::module_primary_bean($mod);
$rec = array_get_default($_REQUEST, 'record');
$perform = array_get_default($_REQUEST, 'perform');
$src = array_get_default($_REQUEST, 'source', 'detailview');

if(! $mod || ! $bean || ! $rec || ! $perform) sugar_die('Module, record, and action required');

$action = WFProcessorBase::get_action_info($perform);
if(! $action) sugar_die('Action not supported');
if(! in_array('manual', $action['allow_when'])) sugar_die('Manual invocation not supported');
$get_params = array();
if(! empty($act['acl']))
	$get_params['acl_filters'] = $act['acl'];

$row = ListQuery::quick_fetch($bean, $rec, true, $get_params);
if(! $row) sugar_die('Record not found');

$upd = $row->getRowUpdate();
WFProcessorBase::process_manual($upd, $perform, $src);

$ret = array();
foreach(array('return_module', 'return_action', 'return_record', 'return_layout') as $p) {
	$v = array_get_default($_REQUEST, $p);
	if($v) $ret[substr($p, 7)] = $v;
}
if($ret) return array('redirect', $ret);
else {
	return array('redirect', array('module' => $mod, 'action' => 'DetailView', 'record' => $rec));
}

