<?php
/*
 *
 * The contents of this file are subject to the info@hand Software License Agreement Version 1.3
 *
 * ("License"); You may not use this file except in compliance with the License.
 * You may obtain a copy of the License at <http://1crm.com/pdf/swlicense.pdf>.
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License for the
 * specific language governing rights and limitations under the License,
 *
 * All copies of the Covered Code must include on each user interface screen:
 * (i) the 1CRM copyright notice,
 * (ii) the "Powered by the 1CRM Engine" logo, 
 *
 * (iii) the "Powered by SugarCRM" logo, and
 * (iv) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.
 * See full license for requirements.
 *
 * The Original Code is : 1CRM Engine proprietary commercial code.
 * The Initial Developer of this Original Code is 1CRM Corp.
 * and it is Copyright (C) 2004-2012 by 1CRM Corp.
 *
 * All Rights Reserved.
 * Portions created by SugarCRM are Copyright (C) 2004-2008 SugarCRM, Inc.;
 * All Rights Reserved.
 *
 */

if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');

$json_supported_actions['get_operation_list'] = array();

function json_get_operation_list()
{
	$module = array_get_default($_REQUEST, 'trigger_module');
	
	if(! $module)
		return json_bad_request(array('error' => 'no_module'));
	
	require_once('modules/Workflow/WFProcessorBase.php');
	$actions = WFProcessorBase::get_action_options($module);
	
	$ret = array('keys' => array_keys($actions), 'values' => array_values($actions));
	return json_return_value($ret);
}

$json_supported_actions['save_operation_params'] = array();

function json_save_operation_params()
{
	$module = array_get_default($_REQUEST, 'trigger_module');
	$type = array_get_default($_REQUEST, 'operation_type');
	if(! $module)
		return json_bad_request(array('error' => 'no_module'));
	if(! $type)
		return json_bad_request(array('error' => 'no_type'));
	
	require_once('modules/Workflow/WFProcessorBase.php');
	$action = WFProcessorBase::create_module_action($module, $type);
	if(! $action)
		return json_bad_request(array('error' => 'unsupported'));
	
	$vals = $action->loadConfigRequest();
	if($vals) {
		$vals = array(
			'status' => 'ok',
			'message' => '',
			'result' => $vals,
		);
	}
	else {
		$vals = array(
			'status' => 'error',
			'message' => '',
			'result' => array(),
		);
	}
	return json_return_value($vals);
}


// temporary in order to enable legacy conditions editor

$json_supported_actions['get_workflow_field_list'] = array();

