<?php return; /* no output */ ?>

detail
	type: bean
	bean_file: modules/Workflow/Workflow.php
	audit_enabled: true
	unified_search: false
	duplicate_merge: true
	comment:
		Workflow is a series of actions registered with certain system activities,
		i.e. new record creation.
	table_name: workflow
	primary_key: id
	record_status: status
hooks
	new_record
		--
			class_function: init_record
fields
	app.id
	app.date_entered
	app.date_modified
	app.modified_user
	app.assigned_user
	app.created_by_user
	app.deleted
	name
		type: name
		vname: LBL_NAME
		comment: Name of the workflow
		unified_search: true
		audited: true
		vname_list: LBL_LIST_NAME
		required: true
	description
		vname: LBL_DESCRIPTION
		type: text
		comment: Descriptive information about the workflow
	trigger_module
		vname: LBL_TRIGGER_MODULE
		type: module_name
		len: 50
		width: 20
		comment: Workflow target module
		vname_list: LBL_LIST_TRIGGER_MODULE
		required: true
		options_function
			- Workflow
			- get_target_options
		options_add_blank: false
		massupdate: true
	trigger_action
		vname: LBL_TRIGGER_ACTION
		type: enum
		options: workflow_trigger_dom
		len: 25
		comment: The action on target module that triggers workflow
		vname_list: LBL_LIST_TRIGGER_ACTION
		massupdate: true
		default: saved
		required: true
	execute_mode
		vname: LBL_EXECUTE_MODE
		type: enum
		options: workflow_execute_mode_dom
		len: 30
		comment:
			Workflow execute mode: new records only or new record and
			existing records
		required: true
		massupdate: true
	occurs_when
		vname: LBL_OCCURS_WHEN
		type: enum
		len: 25
		options: workflow_occurs_dom
		required: false
	occurs_number
		vname: LBL_OCCURS_IN
		type: int
		len: 11
	occurs_type
		type: enum
		options: workflow_occurs_type
	status
		vname: LBL_STATUS
		type: status
		len: 10
		default: inactive
		options: workflow_status_dom
		comment: Workflow status: active or inactive
		vname_list: LBL_LIST_STATUS
		required: true
		massupdate: true
	operation_mode
		vname: LBL_OPERATION_MODE
		type: varchar
		comment: Operation mode: immediately or in given time period
	operation_days
		vname: LBL_OPERATION_DAYS
		type: varchar
		comment: Operation performed in days
	operation_hours
		vname: LBL_OPERATION_HOURS
		type: varchar
		comment: Operation performed in hours
	operation_mins
		vname: LBL_OPERATION_MINS
		type: varchar
		comment: Operation performed in minutes
	operation_owner
		vname: LBL_OPERATIONS_AS
		type: enum
		len: 36
		options_function
			- Workflow
			- get_owner_options
		options_function_dynamic: true
		options_icon: icon
		comment: Operation owner: the trigger or admin
		required: true
		massupdate: true
	criteria
		vname: LBL_CRITERIA
		type: text
		reportable: false
	criteria_fields
		vname: LBL_CRITERIA_FIELDS
		type: text
		reportable: false
	criteria_clauses
		vname: LBL_CRITERIA_CLAUSES
		type: text
		reportable: false
links
	operations
		vname: LBL_OPERATION
		relationship: wf_operations
		module: Workflow
		bean_name: WFOperation
relationships
	wf_operations
		key: id
		target_bean: WFOperation
		target_key: workflow_id
		relationship_type: one-to-many
