<?php

define('sugarEntry', true);
define('ONECRM_CSRF_PROTECT', 'none');

include 'include/entryPoint.php';

AppConfig::restrict_entry_point();

if(! AppConfig::session_start()) {
	header('HTTP/1.1 503 Service Unavailable');
	die('Error starting session');
}

require_once 'include/utils/oauth_utils.php';

$not_auth = false;
$current_user = new User();
$authController = new AuthenticationController();
if(empty($_SESSION['authenticated_user_id']))
	$not_auth = true;
else {
	if(! $authController->sessionAuthenticate()) {
		session_destroy();
		$not_auth = true;
	}
}
if(! empty($not_auth)) {
	$GLOBALS['log']->warn('Cancel o365 auth: user not authenticated');
	header('HTTP/1.1 401 Not Authorized');
	die('User is not authenticated');
}

if(! AppConfig::check_init_user()) {
	$GLOBALS['log']->warn('Cancel o365 auth: user not initialized');
	exit;
}


if (isset($_GET['_a'])) {
	processOAuthAuthenticationRequest($_GET['_a']);
}

if (isset($_GET['_t'])) {
	processOAuthTokenRequest($_GET['_t']);
}


processOAuthCodeRequest($_GET);

