<?php

define('sugarEntry', true);
define('ONECRM_CSRF_PROTECT', 'none');

include 'include/entryPoint.php';

if (!empty($_GET['code'])) {
	$client_id = AppConfig::setting('telephony.ringcentral_client_id');
	$client_secret = AppConfig::setting('telephony.ringcentral_client_secret');

	$sandbox = !!AppConfig::setting('telephony.ringcentral_sandbox', 0);
	$url = $sandbox ? 'https://platform.devtest.ringcentral.com/restapi/oauth/token' : 'https://platform.ringcentral.com/restapi/oauth/token';
	$cred = base64_encode("$client_id:$client_secret");
	$headers = array(
		'Authorization: Basic ' . $cred,
		'Content-Type: application/x-www-form-urlencoded;charset=UTF-8'
	);
	$data = http_build_query([
		'grant_type' => 'authorization_code',
		'code' => $_REQUEST['code'],
		'client_id' => $client_id,
		'redirect_uri' => AppConfig::site_url() . 'ringcentral_auth.php'
	]);
	$ch = curl_init($url);
	curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
	curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
	curl_setopt($ch, CURLINFO_HEADER_OUT, true);
	$body = curl_exec($ch);
	$code = curl_getinfo($ch, CURLINFO_HTTP_CODE);
	$res = @json_decode($body, true);

	$error = null;

	if (!is_array($res)) {
		$error = 'Unknown Error';
		$error_description = 'Unknown Error';
	}

	if ($error) {
		$res = [
			'error' => $error,
			'error_description' => $error_description,
		];
	}
	$uri = json_encode('?' . http_build_query($res));

} else {
	$uri = json_encode('?' . $_SERVER['QUERY_STRING']);
}

?>
<script>
window.opener.postMessage({RCAuthorizationResponse: <?php echo $uri; ?>});
</script>
