<?php
define('sugarEntry', 1);
require_once('include/utils/basic_utils.php');
require_once('include/config/AppConfig.php');
require_once('include/log/Logger.php');
include('sugar_version.php');
use Katzgrau\KLogger\Logger;

if( ($log_path = AppConfig::setting('site.log.php_log_file')) ) {
	ini_set('log_errors', 1);
	ini_set('error_log', $log_path);
}

if(! empty($_REQUEST['user_id'])) {
	AppConfig::set_system_timezone();
	
	$fields = [
		'Time' => '',
	];
	$copy = [
		'Module' => 'module',
		'Context' => 'context',
		'Layout' => 'layout',
		'Record' => 'record',
		'Async' => 'async',
		'Duration' => 'duration',
		'Render' => 'render_duration',
		'DB' => 'db_duration',
		'Config' => 'config_duration',
		'User' => 'user_id',
	];
	foreach($copy as $k => $f) {
		$val = array_get_default($_REQUEST, $f, '');
		if(! preg_match('~^[a-zA-Z0-9\.\-_ ]*$~', $val))
			return;
		$fields[$k] = $val;
	}
	
	if(! is_numeric($fields['Duration']))
		return;
	foreach(['Render', 'DB', 'Config'] as $f)
		if(! is_numeric($fields[$f]))
			$fields[$f] = '';
	
	$fields['Async'] = $fields['Async'] ? 1 : 0;
	$fields['Time'] = date('Y-m-d H:i:s');
	$fields['Version'] = $sugar_version;
	
	$params = [
		'file' => 'stats.log.'.date('Ymd'),
		'header' => implode(',', array_keys($fields)),
		'file_size' => 0,
	];
	$stat_log = new Logger('stats', $params);
	$stat_log->writeLine(implode(',', array_values($fields)));
}

