<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

global $even_bg, $odd_bg, $hilite_bg, $barChartColors, $pieChartColors;

// list view colors
$even_bg = "#fafafa";
$odd_bg = "#ffffff";
$hilite_bg = "#f0f0f0";

//graph colors
$barChartColors = array(
"docBorder"=>"0xffffff",
"docBg1"=>"0xffffff",
"docBg2"=>"0xffffff",
"xText"=>"0x33485c",
"yText"=>"0x33485c",
"title"=>"0x333333",
"misc"=>"0x999999",
"altBorder"=>"0xffffff",
"altBg"=>"0xffffff",
"altText"=>"0x666666",
"graphBorder"=>"0xcccccc",
"graphBg1"=>"0xf6f6f6",
"graphBg2"=>"0xf6f6f6",
"graphLines"=>"0xcccccc",
"graphText"=>"0x333333",
"graphTextShadow"=>"0xf9f9f9",
"barBorder"=>"0xeeeeee",
"barBorderHilite"=>"0x333333",
"legendBorder"=>"0xffffff",
"legendBg1"=>"0xffffff",
"legendBg2"=>"0xffffff",
"legendText"=>"0x444444",
"legendColorKeyBorder"=>"0x777777",
"scrollBar"=>"0xcccccc",
"scrollBarBorder"=>"0xeeeeee",
"scrollBarTrack"=>"0xeeeeee",
"scrollBarTrackBorder"=>"0xcccccc"
);

$pieChartColors = array(
"docBorder"=>"0xffffff",
"docBg1"=>"0xffffff",
"docBg2"=>"0xffffff",
"title"=>"0x333333",
"subtitle"=>"0x666666",
"misc"=>"0x999999",
"altBorder"=>"0xffffff",
"altBg"=>"0xffffff",
"altText"=>"0x666666",
"graphText"=>"0x33485c",
"graphTextShadow"=>"0xf9f9f9",
"pieBorder"=>"0xffffff",
"pieBorderHilite"=>"0x333333",
"legendBorder"=>"0xffffff",
"legendBg1"=>"0xffffff",
"legendBg2"=>"0xffffff",
"legendText"=>"0x444444",
"legendColorKeyBorder"=>"0x777777",
"scrollBar"=>"0xdfdfdf",
"scrollBarBorder"=>"0xfafafa",
"scrollBarTrack"=>"0xeeeeee",
"scrollBarTrackBorder"=>"0xcccccc"
);


/**
 * Create HTML to display formatted form title.
 * param $form_title - the string to display as the title in the header
 * param $other_text - the string to next to the title.  Typically used for form buttons.
 * param $show_help - the boolean which determines if the print and help links are shown.
 */
function get_form_header ($form_title, $other_text, $show_help, $icon='')
{
	return $GLOBALS['themeInstance']->get_form_header($form_title, $other_text, $show_help, $icon);
}

/**
 * Create HTML to display formatted form footer
 */
function get_form_footer() {
	return $GLOBALS['themeInstance']->get_form_footer();
}

/**
 * Create HTML to display formatted module title.
 * param $module - the string to next to the title.  Typically used for form buttons.
 * param $module_title - the string to display as the module title
 * param $show_help - the boolean which determines if the print and help links are shown.
 */
function get_module_title ($module, $module_title, $show_help)
{
	global $themeInstance;
	return $themeInstance->get_module_title($module, $module_title, $show_help);
}


/**
 * Create a header for a popup.
 * param $theme - The name of the current theme
 */
function insert_popup_header($theme)
{
	echo $GLOBALS['themeInstance']->get_popup_header();
}

/**
 * Create a footer for a popup.
 */
function insert_popup_footer()
{
	echo $GLOBALS['themeInstance']->get_popup_footer();
}

?>
