<?php
global $pageInstance;
$vars = array(
	'APP_NAME', 'DIR', 'CHARSET', 'FAVICON', 'PAGE_TITLE', 'HEADER_INCLUDES', 'IMAGE_PATH',
	'THEME', 'ONLOAD', 'CSS_PREFIX', 'CSS_SUFFIX', 'STATIC_URL', 'HEADERLESS_STYLE',
	'LICENSEE', 'DEV_BRANCH', 'MAX_USERS', 'WARN', 'UPDATES', 'CURRENT_USER', 'USER_ICON', 'USER_PHOTO',
	'IAH_SEARCH_LINK', 'IAH_INFO_LINK', 'IAH_EMAIL_LINK', 'IAH_PROFILE_LINK', 'IAH_DAY_LINK',
	'DATE', 'NEW_EMAILS', 'MAIN_TITLE' => '&nbsp;', 'THEME_SIDE_LOGO',
	'menu_calendar', 'menu_email', 'menu_system', 'global_links', 'hide_tab_bar',
	'disableFloat', 'module_tabs' => array(), 'no_decoration', 'is_demo_site',
);
foreach($vars as $v => $vv) {
	$def = null;
	if(is_int($v)) $v = $vv;
	else $def = $vv;
	$$v = array_get_default($tpl_vars, $v, $def);
}
?>
<!DOCTYPE html>
<html <?php echo $DIR; ?>>
<head>
<base href="<?php echo AppConfig::site_url() ?>" >
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta charset="<?php echo $CHARSET; ?>">
<meta name="viewport" content="width=device-width, initial-scale=1.0, viewport-fit=cover">
<?php echo $FAVICON; ?>
<title><?php echo $PAGE_TITLE; ?></title>
<?php echo $HEADER_INCLUDES; ?>
<script type="text/javascript">
SUGAR.themes.imagePath = '<?php echo $IMAGE_PATH; ?>';
SUGAR.themes.menu_offset = {left: 0, top: -4, outer_margin: 0};
<?php if($ONLOAD): ?>
SUGAR.onDomReady(function() { <?php echo $ONLOAD; ?> });
<?php endif; ?>
SUGAR.onDomReady(SUGAR.themes.initTopMenu);
</script>
</head>

<body class="float-menu">

<header class="app-header" id="tbarDiv" style="<?php echo $HEADERLESS_STYLE; ?>">
	<div id="app-bar" class="appbar-outer" onclick="window.scroll(0, 0);">
		<div class="appbar-cell appbar-name" width="50%">
			<a href="<?php echo $IAH_INFO_LINK; ?>" onclick="SUGAR.util.handleLink(event);"><span id="top-app-name">&nbsp;<span class="app-name"><?php echo $APP_NAME; ?></span>
			<?php if($is_demo_site) echo '['.translate('LBL_DEMO_VERSION', 'app').']'; ?>
			<?php if($DEV_BRANCH) echo '<span class="dev-branch">['.$DEV_BRANCH.']</span>'; ?>
			<?php if($LICENSEE) echo "<span class=\"lic-info\">&bull; $LICENSEE ({$MAX_USERS}U)</span>"; ?></span>
			<?php echo $WARN; ?>
			<?php echo $UPDATES; ?></a>
		</div>
		<div class="appbar-cell appbar-mobile">
			<a class="appbar-menu" href="index.php" id="tbar-mobile">
				<span class="uii uii-hamburger"></span>
			</a>
		</div>
		<?php if($IAH_SEARCH_LINK): ?>
		<div class="appbar-cell">
			<a class="appbar-menu" href="<?php echo $IAH_SEARCH_LINK; ?>" id="tbar-search">
				<span class="uii uii-search"></span><span id="tbar-search-label"> <?php echo translate('LBL_SEARCH', 'app'); ?></span><span class="rbullet rbullet-inline"></span>
			</a>
		</div>
		<?php endif; ?>
		<?php if($menu_calendar): ?>
		<div class="appbar-cell">
			<a class="appbar-menu" href="<?php echo $IAH_DAY_LINK; ?>" onclick="SUGAR.util.handleLink(event);" id="tbar-calendar">
				<span class="uii uii-date"></span><span id="tbar-today-label"> <?php echo $DATE; ?></span>
			</a>
		</div>
		<?php $pageInstance->add_js_literal("
			SUGAR.ui.registerMenuSource('tbar-calendar', {options: {$menu_calendar}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: 'center', outer_margin: 0}, ext_class: 'popup-global siteMenu'}, null, 'system-toolbar');
			", null, LOAD_PRIORITY_FOOT);
		endif;
		?>
		<?php if($menu_email): ?>
		<div class="appbar-cell">
			<a class="appbar-menu" href="<?php echo $IAH_EMAIL_LINK; ?>" onclick="SUGAR.util.handleLink(event);" id="tbar-email">
				<span class="uii uii-email"></span><span id="tbar-email-label"> <span id="new_emails_counter"><?php echo $NEW_EMAILS; ?></span></span>
			</a>
		</div>
		<?php $pageInstance->add_js_literal("
			SUGAR.ui.registerMenuSource('tbar-email', {options: {$menu_email}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: 'center', outer_margin: 0}, ext_class: 'popup-global siteMenu'}, null, 'system-toolbar');
			", null, LOAD_PRIORITY_FOOT);
			endif;
		?>
		<?php if($CURRENT_USER && $menu_system): ?>
		<div class="appbar-cell">
			<a class="appbar-menu" style="font-weight: bold" href="<?php echo $IAH_PROFILE_LINK; ?>" onclick="SUGAR.util.handleLink(event);" id="tbar-profile">
				<?php if($USER_PHOTO) { echo $USER_PHOTO; } else { ?><span class="uii uii-user"></span><?php } ?> <span id="tbar-profile-label"><?php echo (! empty($CURRENT_USER['first_name']) ? $CURRENT_USER['first_name'] : $CURRENT_USER['user_name']); ?></span>
			</a>
		</div>
		<?php $pageInstance->add_js_literal("
			SUGAR.ui.registerMenuSource('tbar-profile', {options: {$menu_system}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: 'center', outer_margin: 0}, ext_class: 'popup-global siteMenu'}, null, 'system-toolbar');
			", null, LOAD_PRIORITY_FOOT);
			endif;
		?>
		
		<?php if($global_links) {
			foreach($global_links as $link_id => $link) { ?>
		<div class="appbar-cell" width="25%">
			<a class="appbar-menu" href="<?php echo $link['url']; ?>" <?php if(! empty($link['menu'])) echo $link['menu']; ?>><?php if(! empty($link['icon'])) echo "<div class=\"input-icon {$link['icon']}\"></div>&nbsp;"; echo $link['label']; ?></a>
		</div>
		<?php } } ?>
	</div>
	
	<?php if(! $hide_tab_bar && ! empty($module_tabs['use_group_tabs']) && ! empty($module_tabs['tabs'])): ?>
	<div id="tab-bar" class="menubar-outer">
		<ul class="menubar-main"><?php
			$tabi = 0;
			foreach($module_tabs['all_tabs'] as $tab_name => $tab) {
				$cls = 'menubar-item';
				if(! empty($tab['active'])) $cls .= ' current';
				if(isset($tab['color'])) $cls .= ' '.$tab['color'];
				echo '<li class="'.$cls.'" id="grouptab-' . ($tabi++) . '" data-tab-id="' . to_html($tab['key']) . '">';
				echo '<a class="menubar-link" href="'.$tab['url'].'" onclick="SUGAR.themes.chooseTab(\''.$tab['key'].'\', event); return true;">';
				echo '<div class="menu-label">' . $tab['label'] . '</div>';
				echo '</a></li>';
			}
		?></ul>
		<div class="menubar-right">
			<?php echo get_image($THEME_SIDE_LOGO['src'], 'class="app-logo"', $THEME_SIDE_LOGO['width'], $THEME_SIDE_LOGO['height']); ?>
		</div>
	</div>
	<?php endif; ?>

</header>

<aside id="app-side" class="appside-outer"></aside>

<div id="all-page">

<div id="outer-body" class="outer-body">

<div id="main-title" class="h3 main-title" <?php if($no_decoration) echo 'style="display:none"'; ?>>
	<div class="title-attach main-title-left nowrap"><button class="input-button title-button flatter" type="button" onclick="SUGAR.themes.toggleSidebar(null, true); return false;" id="sidebar-toggle"><div class="input-icon icon-sidebar"></div></button></div>
	<div class="title-content">
		<span id="main-title-module" class="title-module"><span></span><span id="title-sep" class="title-sep"> &ndash; </span></span
		><span id="main-title-text" class="title-text"><?php echo $MAIN_TITLE; ?></span>
	</div>
	<div class="title-attach main-title-right nowrap">
		<button class="input-button title-button flatter menu-source" type="button" onclick="return false;" id="module-tools"><span class="uii uii-lg uii-gear rbullet rbullet-ddown"></span></button>
		<button class="input-button title-button flatter" type="button" onclick="return SUGAR.util.showHelp();" id="module-help"><span class="uii uii-lg uii-help"></span></button>
	</div>
</div>

<main id="main-body" class="main-body">
<div id="left-sidebar" class="sidebar" <?php if($no_decoration) echo 'style="display:none"'; ?>></div>
<?=	$pageInstance->add_js_literal("SUGAR.themes.customize_bg_title = '".addslashes(translate('LBL_CUSTOMIZE_THEME', 'Administration'))."'"); ?>
<?=	$pageInstance->add_js_literal("SUGAR.themes.customize_bg_label = '".addslashes(translate('LBL_CUSTOMIZE_BACKGROUND', 'Administration'))."'"); ?>
<script type="text/javascript" src="themes/<?=$pageInstance->theme?>/utility-personalisation.js"> </script>
