{*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************}

<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.01 Strict//EN">
<html {$DIR|default:''}>
<head>
<base href="{$BASE_URL}" >
<meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1">
<meta http-equiv="Content-Type" content="{$CONTENT_TYPE|default:''}">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
{$FAVICON}
<title>{$PAGE_TITLE}</title>
{$HEADER_INCLUDES}
<script type="text/javascript">
SUGAR.themes.imagePath = '{$IMAGE_PATH}';
{if ! empty($ONLOAD)}
SUGAR.onDomReady(function() {ldelim} {$ONLOAD} {rdelim});
{/if}
{if ! empty($hide_side_menu) && $hide_side_menu != 'guess'}SUGAR.themes.show_left_col = false;{/if}
SUGAR.onDomReady(SUGAR.themes.initLeftCol);
SUGAR.onDomReady(SUGAR.themes.initTopMenu);
SUGAR.themes.menu_offset = {ldelim}left: 3, top: -4, outer_margin: 0{rdelim};
SUGAR.themes.disable_detail_sidebar = true;
SUGAR.themes.enable_module_sidebar = true;
</script>

{literal}<!--[if lt IE 7]>
<style type="text/css">
	img { behavior:	url("{/literal}{$STATIC_URL}{literal}include/pngbehavior.htc"); }
</style>
<![endif]-->
<!--[if lte IE 7]>
<style type="text/css">
	ul.tabBar li, .menutab, .popupMenuBarOuter { display: inline; }
	.icon-box, .icon-box-default { display:inline; zoom:1; }
	.button, .buttonOn, .button:hover, .button:focus { padding: 0; margin: 0; line-height: auto; }
	button, input[type="button"], input[type="submit"], input[type="reset"] {
		padding: 0; margin: 0; line-height: auto; }
</style>
<![endif]-->
<!--[if lte IE 8]>
<link type="text/css" rel="stylesheet" media="all" href="{/literal}{$CSS_PREFIX}themes/{$THEME}/ie-compat.css{$CSS_SUFFIX}{literal}" />
<![endif]-->{/literal}
</head>

<body class="color-{$current_color_style}{if ! empty($texture_enabled)} textured{/if}">

	{if empty($disableFloat)}
	<div class="floating-tbar" id="tbarDiv" style="{$HEADERLESS_STYLE}">
	<table class="tbar-table" border="0" cellpadding="0" cellspacing="0" width="100%" onclick="window.scroll(0, 0);">
	<tr>
		<td class="tbar-cell app-name" width="50%">
			<a href="{$IAH_INFO_LINK}"><span id="app-name">{$APP.NTC_APPNAME}</span>{if ! empty($LICENSEE)}<span class="lic-info">: {$LICENSEE} ({$MAX_USERS}U)</span>{/if}{if ! empty($WARN)} {$WARN}{/if}{if ! empty($UPDATES)}&nbsp;{$UPDATES}{/if}</a>
		</td>
		{if ! empty($IAH_SEARCH_LINK)}
		<td class="tbar-cell">
		
		<form name='UnifiedSearch' method="GET" autocomplete="off">
			<input type="hidden" name="module" value="Home">
			<input type="hidden" name="action" value="UnifiedSearch">
			<div class="input-field input-field-group input-search tbar-search" id="searchField-input">
				<div class="input-icon icon-search"></div>
				<input type="text" class="input-text input-entry" autocapitalize="off"
					results="9" incremental="false" size="10" name="query_string" id="searchField"
					value="" autosave="com.infoathand.crm_search" />
				<a class="input-icon icon-clear search-clear" style="display: none"></a>
			</div>
		</form>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.initForm('UnifiedSearch', [
				new SUGAR.ui.SearchInput('searchField-input', {name: 'query_string', onclick: function(evt) { YEvent.stopPropagation(evt); } })
			]);
		{/literal}{/iah_script}
		</td>
		{/if}
		{if ! empty($menu_calendar)}
		<td class="tbar-cell">
			<a class="box with-popup" href="{$IAH_DAY_LINK}" id='tbar-calendar'>{iah_icon_image name='CalendarDay'}<span id="today-label">&nbsp;{$DATE}</span></a>
		</td>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.registerMenuSource('tbar-calendar', {options: {/literal}{$menu_calendar}{literal}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: 'center', outer_margin: 0}}, null, 'system-toolbar');
		{/literal}{/iah_script}
		{/if}
		{if ! empty($menu_email)}
		<td class="tbar-cell">
			<a class="box with-popup" href="{$IAH_EMAIL_LINK}" id='tbar-email'><div class="input-icon icon-email active"></div>&nbsp;<span id="new_emails_counter">{$NEW_EMAILS}</span></a>
		</td>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.registerMenuSource('tbar-email', {options: {/literal}{$menu_email}{literal}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: 'center', outer_margin: 0}}, null, 'system-toolbar');
		{/literal}{/iah_script}
		{/if}
		{if ! empty($CURRENT_USER) && ! empty($menu_system)}
		<td class="tbar-cell">
			<a class="box with-popup" style="font-weight: bold" href="{$IAH_PROFILE_LINK}" id='tbar-profile'><div class="input-icon {$USER_ICON} active"></div>&nbsp;{$CURRENT_USER.first_name|default:$CURRENT_USER.user_name}</a>
		</td>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.registerMenuSource('tbar-profile', {options: {/literal}{$menu_system}{literal}, icon_key: 'icon', hover_show: true, delay: 200, target_offset: {align: '', outer_margin: 0}}, null, 'system-toolbar');
		{/literal}{/iah_script}
		{/if}
	</tr>
	</table>
	</div>
	{/if}

	{if ! empty($module_tabs.more_tabs)}
	<div id="MoreMenu" class="menu" style="{$HEADERLESS_STYLE}" onmouseover="window.clearTimeout(SUGAR.themes.resetSubTabsTimer);" onmouseout="SUGAR.themes.setResetTimer();">
	{foreach from=$module_tabs.more_tabs key=module_key item=tab}
		{if ! empty($tab.more)}
			<a href="{$tab.url}" class="menuItem" id="{$tab.key}Handle" parentid="MoreMenu" onclick="SUGAR.themes.chooseTab('{$tab.key}'); return true;">{$tab.label}</a>
		{/if}
	{/foreach}
	</div>
	{/if}

	{if empty($hide_side_menu) || $hide_side_menu != 'complete'}
	<div id="HideMenu" class="subDmenu" style="position: absolute; width: 180px; z-index:500; display: none"></div>
	{/if}
	
	{if empty($hide_tab_bar) && ! empty($module_tabs.use_group_tabs) && ! empty($module_tabs.tabs)}
		{assign var=group_tabs_visible value=1}{/if}

	<div class="headerBg{if ! empty($group_tabs_visible)} overTabs{/if}" style="{$HEADERLESS_STYLE|default:''}">
	<div id="topRight">
		<table border="0" cellpadding="0" cellspacing="0" class="myArea">
		<tr>
			{if ! empty($is_demo_site)}<td style="padding: 0 1em">{$APP.LBL_DEMO_VERSION}</td>{/if}
			<td id="colorpicker"><ul class="colorpicker">
				{foreach from=$color_styles key=idx item=style}<li onclick="SUGAR.themes.changeColor('{$style.name}');" onmousedown="return false;"><div class="icon-box theme-style" style="background-position: {$idx*-15-15}px 0" title="{$style.title}"><img src="{$STATIC_URL}include/images/blank.gif" alt="{$style.name}" border="0" width="15" height="15"></div></li>{/foreach}
				<li onclick="SUGAR.themes.toggleTextures();" onmousedown="return false;"><div class="icon-box theme-style" style="background-position: 0 -15px" title="Toggle Background Textures"><img src="{$STATIC_URL}include/images/blank.gif" alt="texture" border="0" width="15" height="15"></div></li>
				{foreach from=$font_styles key=idx item=font}<li onclick="SUGAR.themes.changeFont('{$font.name}');" onmousedown="return false;"><div class="icon-box theme-style" style="background-position: {$idx*-15-15}px -15px" title="{$font.title}"><img src="{$STATIC_URL}include/images/blank.gif" alt="{$font.name}" border="0" width="15" height="15"></div></li>{/foreach}
				<li onclick="SUGAR.themes.toggleFullScreen();" onmousedown="return false;" id="fullscreen-button" style="display: none"><div class="icon-box theme-style" title="Toggle Full Screen"><img src="{$STATIC_URL}include/images/blank.gif" alt="fullscreen" border="0" width="15" height="15"></div></li>
				</ul>
			</td>
			{if ! empty($global_links)}
			<td>
				<ul class="topMenu">{foreach from=$global_links key=link_id item=link}<li><a href="{$link.url}" {$link.menu}>{$link.label}</a>{$link.menu_arrow}</li>{/foreach}</ul>
			</td>
			{/if}
		</tr>
		</table>
		<img id="tlr-logo" src="{$STATIC_URL}{$THEME_SIDE_LOGO.src}" width="{$THEME_SIDE_LOGO.width}" height="{$THEME_SIDE_LOGO.height}" alt="{$THEME_SIDE_LOGO.alt}" border="0">
	</div>
	<div class="logo">
		<img id="top-logo" src="{$STATIC_URL}{$THEME_TOP_LOGO.src}" width="{$THEME_TOP_LOGO.width}" height="{$THEME_TOP_LOGO.height}" alt="{$THEME_TOP_LOGO.alt}" border="0">
	</div>
	</div>

<div id="all-page" style="display: inline-block; min-width: 100%">

{if ! empty($group_tabs_visible)}
<div id="tabBar" style="{$HEADERLESS_STYLE}">
	<ul id="top-tabBar" class="tabBar">{foreach from=$module_tabs.all_tabs key=tab_name item=tab name=grp}<li
		class="menutab-item {if ! empty($tab.active)}{assign var=active_tab value=$tab}current{/if}" id="grouptab-{$smarty.foreach.grp.index}"
			><a class="menutab-link" href="{$tab.url}" onclick="SUGAR.themes.chooseTab('{$tab.key}', event); return false;"><div class="menutab left"></div><div class="menutab mid">{$tab.label}</div><div class="menutab right"></div></a
		></li
	>{/foreach}</ul>
</div>
{elseif empty($hide_tab_bar)}
	{assign var=active_tab value=$module_tabs}
{/if}

<table id="outer-body" width="100%" cellspacing="0" cellpadding="0" border="0" style="margin-top: 8px">
<tr>
	<td valign="top" width="10" style="{$HEADERLESS_STYLE|default:''}">
		<div style="cursor: pointer; width: 10px; height: 25px; background-position: {if ! empty($hide_side_menu)}0 0{else}-10px 0{/if}" id="HideHandle" onclick='SUGAR.themes.toggleLeftCol(); SUGAR.popups.hidePopup();' onmouseover="SUGAR.themes.showHiddenMenu(this)"></div>
	</td>
	<td valign="top" id="leftColumn" style="{$HEADERLESS_STYLE|default:''}">
		<div id="left-sidebar" class="sidebar" style="width: 180px">
		</div>
	</td>
	<td style="padding-right: 10px; padding-left: 8px; width: 100%;" valign="top" style="{$HEADERLESS_STYLE|default:''}">
		<div class="popupMenuBarOuter" id="menuBar" style="display: none"></div>
