<?php
// import utilities and globals
global $pageInstance;
global $pageController;
include(__DIR__ . '/utilities/escaping.php');
include 'templates/utilities-template.php';
?>

<!DOCTYPE html>
<html>
    <head>
        <!-- basic meta info -->
        <meta http-equiv="x-ua-compatible" content="ie=edge,chrome=1">
        <meta charset="<?php echo $tpl_vars['CHARSET']; ?>">
        <meta name="viewport" content="width=device-width, initial-scale=1.0">
        <?php echo $tpl_vars['FAVICON']; ?>
        <title><?php echo $tpl_vars['PAGE_TITLE']; ?></title>
		<?php echo $tpl_vars['HEADER_INCLUDES']; ?>
		<script type="text/javascript">
		<?php if(! empty($tpl_vars['ONLOAD'])): ?>
		SUGAR.onDomReady(function() { <?php echo $tpl_vars['ONLOAD']; ?> });
		<?php endif; ?>
		SUGAR.onDomReady(SUGAR.themes.initTopMenu);
		</script>
    </head>

    <body class="theTheme <?=isset($pageInstance->dashboard->edit_layout) ? 'edit-dashboard ' : ''?>">
    <div class='background-overlay'></div>

        <?php
        if(isset( $_SESSION['authenticated_user_id'])){

            // personalisation modal
            include 'modules/personalisation/index.php';
            /* target for cti extension */
            echo "<div id='sidebar-inner'></div>";

            /* navigation */
            include 'templates/navigation.php';

            /* title section */
            include 'modules/title/template-title.php';

            /* settings for development  */
            /* ini_set('xdebug.var_display_max_depth', -1); */
            /* ini_set('xdebug.var_display_max_children', -1); */
            /* ini_set('xdebug.var_display_max_data', -1); */
            /* var_dump($tpl_vars['THEME_TOP_LOGO']); */

        } ?>

	<div id="outer-body" class="outer-body">
    <div id="main-body" class="main-body">

	<div class="sidebar" id="left-sidebar" <?php if(! empty($tpl_vars['no_decoration'])) echo 'style="display:none"'; ?>></div>
	<div class="sidebar-spacer"></div>
    
    <script type="text/javascript" src="themes/<?=$pageInstance->theme?>/templates/utility-personalisation.js"> </script>

