<?php

require_once('include/layout/BaseTheme.php');

class FlexTheme extends BaseTheme {

	var $theme_name = 'Flex';
	var $custom_max_tabs = -1;
	var $custom_max_subtabs = -1;
	var $hide_dupe_list_shortcuts = true;
	var $texture_support = false;
	var $support_color_styles = false;
	var $support_font_styles = false;

	function get_theme_css_params() {
		$params = parent::get_theme_css_params();
		$style = array_get_default($_COOKIE, 'Flex_style');
		if($style) {
			$ps = explode(' ', $style);
			$style = $ps[0];
			if(preg_match('/^[a-z]*$/', $style) && file_exists("themes/{$this->theme_name}/less/style-{$style}.less")) {
				$params['theme-style'] = $style;
				if(count($ps) > 1 && $ps[1] == 'invert-scheme')
					$params['theme-invert'] = true;
			}
		}
		return $params;
	}

}

?>
