<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2005 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): The Long Reach Corporation
 *                 http://www.thelongreach.com
 ********************************************************************************/
/*********************************************************************************
 * $Id: header.php 7017 2010-03-16 19:37:22Z andrew $
 * Description:  Contains a variety of utility functions used to display UI
 * components such as form headers and footers.  Intended to be modified on a per
 * theme basis.
 ********************************************************************************/

require_once('XTemplate/xtpl.php');
require_once("data/Tracker.php");


global $currentModule;
global $moduleList;
global $theme;
$theme_path="themes/".$theme."/";
$image_path=$theme_path."images/";
require_once($theme_path.'layout_utils.php');
require_once("include/globalControlLinks.php");

$cfg = AppConfig::get_theme_config();
unset($cfg['name']); unset($cfg['description']);
extract($cfg);
if (!isset($record)) {
$record="";
}


global $app_strings;
$default_charset = AppConfig::charset();

$xtpl=new XTemplate ($theme_path."header.html");
$xtpl->assign("APP", $app_strings);

$xtpl->assign("LBL_CHARSET", $default_charset);
$xtpl->assign("THEME", $theme);
$xtpl->assign("IMAGE_PATH", $image_path);
$xtpl->assign("PRINT_URL", "phprint.php?jt=".session_id().$GLOBALS['request_string']);
$xtpl->assign("MODULE_NAME", $currentModule);
$xtpl->assign("DATE", date("Y-m-d"));
assign_calendar_links($xtpl);
$xtpl->assign("TITLE", $app_strings['LBL_SEARCH']);
foreach($style_options as $key => $s) {
	$s['ID'] = $key;
	$xtpl->assign("OPT", $s);
	$xtpl->parse('main.style_select.option');
}
$xtpl->assign("STYLE", style_info());
$xtpl->parse('main.style_select');

if ($current_user->first_name != '') $xtpl->assign("CURRENT_USER", $current_user->first_name);
else $xtpl->assign("CURRENT_USER", $current_user->user_name);

$xtpl->assign("CURRENT_USER_ID", $current_user->id);
	
if (isset($_REQUEST['query_string'])) $xtpl->assign("SEARCH", $_REQUEST['query_string']);

$xtpl->assign("ONLOAD", $GLOBALS['pageInstance']->get_onload());


// longreach - start added
$realModule = $currentModule;
theme_template_setup($xtpl);
// longreach - end added


$i = 0;
foreach($global_control_links as $key => $value) {
	foreach ($value as $linkattribute => $attributevalue) {
		if($linkattribute == 'linkinfo') {
			foreach ($attributevalue as $label => $url) {
				$xtpl->assign("GCL_LABEL", $label);
				$xtpl->assign("GCL_URL", $url);
				$emph = (isset($value['current']) && $value['current']) ? ' style="text-decoration: underline"' : '';
				if (isset($sub_menu[$key]) && $sub_menu[$key]) {
					$xtpl->assign("GCL_MENU", "id='".$key."Handle' onmouseover=' tbButtonMouseOver(this.id,94,\"\",0);'" . $emph);
					$xtpl->assign("MENU_ARROW", "<img src='".$image_path."menuarrow.gif' alt='' align='absmiddle' id='".$key."Handle' style='margin-bottom: 1px; margin-left:2px; cursor: hand;' align='absmiddle' onmouseover='tbButtonMouseOver(this.id,94,\"\",0);'>");
				} else {
					$xtpl->assign("GCL_MENU", $emph);
					$xtpl->assign("MENU_ARROW", "");
				}
				if($i < sizeof($global_control_links)-1) {
					$xtpl->assign("SEPARATOR", " | ");
				} else {
					$xtpl->assign("SEPARATOR", "");
				}
			}
		}

		if($linkattribute == 'submenu' && $attributevalue) {
			if (is_array($attributevalue)) {
				foreach ($attributevalue as $submenulinkkey => $submenulinkinfo) {
					foreach ($submenulinkinfo as $submenulinklabel => $submenulinkurl) {
					$xtpl->assign("GCL_SUBMENU_LINK_LABEL", $submenulinklabel);
					$xtpl->assign("GCL_SUBMENU_LINK_URL", $submenulinkurl);
					}	
					$xtpl->assign("GCL_SUBMENU_KEY", $key);
					$xtpl->assign("GCL_SUBMENU_LINK_KEY", $submenulinkkey);	
					$xtpl->parse("main.gcl_submenu.gcl_submenu_items");
				}
				
			}
			$xtpl->assign("GCL_SUBMENU_KEY", $key);
			$xtpl->parse("main.gcl_submenu");
		}
	}
	$xtpl->parse("main.global_control_links");
	$i++;
}


function showShortcutsMenu($row_field, $first_field='', $hide_saved_search = false) {
	global $xtpl, $modListHeader, $pageController;
	global $image_path, $currentMenu, $currentModule;
	static $module_menu;

	if(! isset($module_menu)) {
		if($currentMenu == 'Administration' && $currentModule != $currentMenu)
			$currentMenu = $currentModule;
		$module_menu = $pageController->get_menu_shortcuts($currentMenu);
	}
	
	$row = 0;
	foreach($module_menu as $menu_item) {
		if ($hide_saved_search && strpos($menu_item[1], 'wp_shortcut_fill') !== false) {
			continue;
		}

			$after_this = current($module_menu);
		
			if ($menu_item[1] != 'Deleted Items') {
				$xtpl->assign("URL", $menu_item[0]);
				$xtpl->assign("LABEL", $menu_item[1]);
				$xtpl->assign("SC_MODULE_NAME", $menu_item[2]);
				$mouseover = "onmouseover=\"this.className = 'subMenuOver';\" onmouseout=\"this.className = 'subMenu';\"";
				$xtpl->assign("SC_MOUSEOVER", $mouseover);
				$img = get_image($image_path.$menu_item[2],"alt='".$menu_item[1]."'  border='0' align='absmiddle'");
				if($img) $img .= '&nbsp;';
				$xtpl->assign("SC_IMAGE", $img);
				if (empty($after_this)) $xtpl->assign("SEPARATOR", "");
				else $xtpl->assign("SEPARATOR", "");
			}
			else {
				$xtpl->assign("DELETED_ITEMS_URL", $menu_item[0]);
				$xtpl->assign("DELETED_ITEMS_LABEL", $menu_item[1]);
			}
			$xtpl->parse($row_field);
			if($row == 0 && !empty($first_field))
				$xtpl->parse($first_field);
			$row++;
	}
}


// Loop through the module list.
// For each tab that is off, parse a tab_off.
// For the current tab, parse a tab_on
$modListHeader = query_module_access_list($current_user);
if(AppConfig::current_user_id())
	$xtpl->parse('main.hide_handle');

// longreach - added
$formModule = $currentModule;
$currentMenu = $currentModule;

$user_navigation_paradigm = $current_user->getPreference('navigation_paradigm');
if(!isset($user_navigation_paradigm)) $user_navigation_paradigm = AppConfig::setting('layout.defaults.navigation_paradigm');
$useGroupTabs = $user_navigation_paradigm == 'gm';


function format_tabs($tabStructure, $grouped=false) {
	global $xtpl, $image_path, $currentModule;
	
	foreach($tabStructure as $tabKey => $tabInfo) {
		$xtpl->assign("MODULE_NAME", $tabInfo['label']);
		$icon = array_get_default($tabInfo, 'icon', $tabInfo['module']);
		$xtpl->assign("MODULE_IMAGE", get_image($image_path.$icon, "alt='' border='0' align='absmiddle'"));
		$xtpl->assign("MODULE_KEY", $tabKey);
		$xtpl->assign("MODULE_URL", $tabInfo['url']);
	
		if(! empty($tabInfo['active']))
		{
			$mouseover = '';
			$xtpl->assign("TAB_CLASS", "currentTab");
			$xtpl->assign("MOUSEOVER", $mouseover);
			// Assign the module name back to the current module.
			
			//ignore these modules
			$ignoreMods=array("Home" /*,"Dashboard"*/);
	
			if(!in_array($currentModule, $ignoreMods)) {
				showShortcutsMenu('main.left_form.menu.tabs.sub_menu.sub_menu_item');
				$xtpl->parse("main.left_form.menu.tabs.sub_menu");
				showShortcutsMenu('main.hide.tabs.tab.sub_hide');
			}
			
			//$xtpl->parse("main.modules_menu.current");
		}
		else {
			$mouseover = "onmouseover=\"this.className = 'hoverTab';\" onmouseout=\"this.className = 'otherTab';\"";
			$xtpl->assign("TAB_CLASS", "otherTab");
			$xtpl->assign("MOUSEOVER", $mouseover);
		}
		$xtpl->parse("main.hide.tabs.tab");
		$xtpl->parse("main.left_form.menu.tabs.tab");
		//$xtpl->parse("main.modules_menu.row");
	}
	$xtpl->assign("GROUPED", $grouped ? ' grouped' : '');
	$xtpl->parse("main.left_form.menu.tabs");
	$xtpl->parse("main.hide.tabs");
}


require_once('include/GroupedTabs/GroupedTabStructure.php');
$tabManager = new GroupedTabStructure();

if($useGroupTabs && !empty($modListHeader)) {
    $groupedTabStructure = $tabManager->get_grouped_tabs($currentModule, null);
    foreach($groupedTabStructure as $mainTab => $group) {
        if(empty($group['modules']))
            continue;
        
        $tabUrl = '';
        $activeTab = array_get_default($group, 'active');
        $tabKey = key($group['modules']);
        $tabUrl = array_get_default($group['modules'][$tabKey], 'url', '');
        $xtpl->assign('GROUP_URL', $tabUrl);
        $xtpl->assign('GROUP_LABEL', htmlspecialchars($group['label'], ENT_QUOTES, 'UTF-8'));
		$xtpl->assign('GROUP', $group);
		$xtpl->assign('ACTIVE_GROUP', $activeTab ? ' active' : '');
		$xtpl->parse('main.left_form.menu.group_header');
		$xtpl->parse('main.hide.group_header');
		if($activeTab) {
			$currentMenu = $group['modules'][$activeTab]['module'];
			format_tabs($group['modules'], true);
		}
		$xtpl->parse('main.left_form.menu');
		$xtpl->parse('main.hide');
	}
}
else {
	$tabStructure = $tabManager->get_flat_tabs($currentModule, null);
	foreach($tabStructure as $tabKey=>$tabInfo) {
		if(! empty($tabInfo['active']))
			$currentMenu = $tabInfo['module'];
	}
	format_tabs($tabStructure);
	$xtpl->parse('main.left_form.menu');
	$xtpl->parse('main.hide');
}

//longreach - added
$currentModule = $realModule;

if (isset($_SESSION["authenticated_user_id"])) {

$xtpl->assign("TITLE_LAST_VIEW", $app_strings['LBL_LAST_VIEWED']);
$xtpl->parse("main.left_form_search");
$xtpl->parse("main.left_form");

//$xtpl->parse("main.modules_menu");


showShortcutsMenu("main.shortcuts_menu.row", "main.shortcuts_menu.first", true);
$xtpl->parse("main.shortcuts_menu");


$history = Tracker::get_recently_viewed($current_user->id);

$current_row=1;

if (count($history) > 0) {
	foreach($history as $row) {
		$xtpl->assign("RECENT_LABEL", to_html(getTrackerSubstring($row['item_summary'], 30, true)));
		$xtpl->assign("RECENT_LABEL_FULL",to_html($row['item_summary']));
		$xtpl->assign("MODULE_NAME",$row['module_name']);
		$xtpl->assign("ROW_NUMBER",$current_row);
		$xtpl->assign("RL_IMAGE",get_image($image_path.$row['module_name'],'border="0" align="absmiddle" title="'.htmlspecialchars($row['item_summary'], ENT_QUOTES, 'UTF-8').'"'));
		$xtpl->assign("RECENT_URL","index.php?module=$row[module_name]&action=DetailView&record=$row[item_id]");
		$xtpl->parse("main.recent_view_menu.row");
		
		if($current_row == 1)
			$xtpl->parse("main.recent_view_menu.first");
		$current_row++;
		if ($current_row >= $max_tracker_items)
			break;
	}
}
else {
	$xtpl->parse("main.recent_view_menu.empty");
}

$xtpl->parse("main.recent_view_menu");


}
$xtpl->parse("main");
$xtpl->out("main");

?>
