<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2005 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): The Long Reach Corporation
 *                 http://www.thelongreach.com
 ********************************************************************************/
/*********************************************************************************
 * $Id: layout_utils.php 6011 2009-04-27 04:28:25Z andrew $
 * Description:  Contains a variety of utility functions used to display UI
 * components such as form headers and footers.  Intended to be modified on a per
 * theme basis.
 ********************************************************************************/

global $even_bg, $odd_bg, $hilite_bg, $barChartColors, $pieChartColors;

// list view colors
$even_bg = "";
$odd_bg = "";
$hilite_bg = "#FFFFFF";
//$click_bg = "#FCB670";

//graph colors
$barChartColors = array(
"docBorder"=>"0xFFFFFF",
"docBg1"=>"0xf9f3e0",
"docBg2"=>"0xf9f3e0",
"xText"=>"0x785130",
"yText"=>"0x785130",
"title"=>"0x785130",
"misc"=>"0x785130",
"altBorder"=>"0xDFD2C0",
"altBg"=>"0xf6f0e0",
"altText"=>"0x785130",
"graphBorder"=>"0xDFD2C0",
"graphBg1"=>"0xDFD2C0",
"graphBg2"=>"0xf6f0e0",
"graphLines"=>"0xC8B190",
"graphText"=>"0x785130",
"graphTextShadow"=>"0xDFD2C0",
"barBorder"=>"0xA89170",
"barBorderHilite"=>"0xFFFFFF",
"legendBorder"=>"0xDFD2C0",
"legendBg1"=>"0xf6f0e0",
"legendBg2"=>"0xf6f0e0",
"legendText"=>"0x785130",
"legendColorKeyBorder"=>"0x2D62B6",
"scrollBar"=>"0xC8B190",
"scrollBarBorder"=>"0x785130",
"scrollBarTrack"=>"0xDFD2C0",
"scrollBarTrackBorder"=>"0x6a645c"
);

$pieChartColors = array(
"docBorder"=>"0xFFFFFF",
"docBg1"=>"0xf9f3e0",
"docBg2"=>"0xf9f3e0",
"title"=>"0x785130",
"subtitle"=>"0x785130",
"misc"=>"0x785130",
"altBorder"=>"0xDFD2C0",
"altBg"=>"0xf6f0e0",
"altText"=>"0x785130",
"graphText"=>"0x785130",
"graphTextShadow"=>"0xDFD2C0",
"pieBorder"=>"0xA89170",
"pieBorderHilite"=>"0xFFFFFF",
"legendBorder"=>"0xDFD2C0",
"legendBg1"=>"0xf6f0e0",
"legendBg2"=>"0xf6f0e0",
"legendText"=>"0x785130",
"legendColorKeyBorder"=>"0x2D62B6",
"scrollBar"=>"0xC8B190",
"scrollBarBorder"=>"0x785130",
"scrollBarTrack"=>"0xDFD2C0",
"scrollBarTrackBorder"=>"0x6a645c"
);

/**
 * Create HTML to display formatted form title of a form in the left pane
 * param $left_title - the string to display as the title in the header
 */
function get_left_form_header ($left_title)
{
global $image_path;

$the_header = '<table cellpadding="0" cellspacing="0" border="0" width="100%" class="leftColumnModuleHead">';
$the_header .= '<tr>';
$the_header .= '<th width="100%">'.$left_title.'</th>';
$the_header .= '</tr>';
$the_header .= '</table>';
$the_header .= '<table width="100%" cellpadding="3" cellspacing="0" border="0"><tr><td align="left" class="leftColumnModuleS3" colspan="3">';


return $the_header;
}

/**
 * Create HTML to display formatted form footer of form in the left pane.
 */
function get_left_form_footer() {
global $image_path;
$html = '</td>';
$html .= '</tr>';
$html .= '</table>';
return ($html);
}

/**
 * Create HTML to display formatted form title.
 * param $form_title - the string to display as the title in the header
 * param $other_text - the string to next to the title.  Typically used for form buttons.
 * param $show_help - the boolean which determines if the print and help links are shown.
 */
function get_form_header ($form_title, $other_text, $show_help, $icon='')
{
global $image_path;
global $app_strings;

$the_form = '';
if ( isset($_REQUEST['module']) && $_REQUEST['module'] != 'Calendar')
{
	$the_form = '<div class="formHeader">';
	$close_div = true;
}

if($icon) {
	if(strpos($icon, '<') === false) {
		if(strpos($icon, '/') === false)
			$icon = $GLOBALS['image_path'].$icon;
		$icon = get_image($icon, 'align="absmiddle" alt="" title="" border="0" style="margin-top: -2px; margin-bottom: -2px"');
	}
}
if(! $icon) {
	$icon = '<img src="'.$image_path.'h3Arrow.gif" alt="" border="0" width="11" height="11" style="vertical-align: middle; margin-bottom: 4px">';
}

$the_form .= '<table width="100%" cellpadding="0" cellspacing="0" border="0" class="formHeader"><tr>';
$the_form .= '<td nowrap><h3>'.$icon.'&nbsp;'.$form_title.'</h3></td>';


$keywords = array("/class=\"button\"/","/class='button'/","/class=button/","/<\/form>/");
$match="";

	foreach ($keywords as $left) {
		 if (preg_match($left,$other_text)) {$match=true;}
	}
if ($other_text && $match) {
$the_form .= "<td colspan='10' width='100%'><img height='1' width='1' src='include/images/blank.gif' alt=''></td>\n";
	$the_form .= "</tr><tr>\n";
	$the_form .= "<td align='left' valign='middle' nowrap style='padding-bottom: 2px;'>$other_text</td>\n";
	$the_form .= "<td width='100%'><img height='1' width='1' src='include/images/blank.gif' alt=''></td>\n";

	if ($show_help==true) {
		$the_form .= "<td align='right' nowrap>";
	    
	    // longreach - replaced Help link
	    $help_link = get_help_link();
	    $the_form .= "&nbsp;<a href='$help_link' target='_blank' class='utilsLink'><div class='input-icon icon-help active-icon'></div>&nbsp;{$app_strings['LNK_HELP']}</a></td>\n";

	}

} else {

if ($other_text) {



		$the_form .= "<td width='20'><img height='1' width='20' src='include/images/blank.gif' alt=''></td>\n";
		$the_form .= "<td valign='middle' nowrap width='100%'>$other_text</td>\n";
	}
	else {
		$the_form .= "<td width='100%'><img height='1' width='1' src='include/images/blank.gif' alt=''></td>\n";
	}
	
	if ($show_help==true) {
		$the_form .= "<td align='right' nowrap>";

	    // longreach - replaced Help link
	    $help_link = get_help_link();
	    $the_form .= "&nbsp;<a href='$help_link' target='_blank' class='utilsLink'><div class='input-icon icon-help active-icon'></div>&nbsp;{$app_strings['LNK_HELP']}</a></td>\n";

	}

}



$the_form .= <<<EOQ
	  </tr>
</table>

EOQ;
if(! empty($close_div)) $the_form .= '</div>';

return $the_form;
}

/**
 * Create HTML to display formatted form footer
 */
function get_form_footer() {
	return '</div>';
}

/**
 * Create HTML to display formatted module title.
 * param $module - the string to next to the title.  Typically used for form buttons.
 * param $module_title - the string to display as the module title
 * param $show_help - the boolean which determines if the print and help links are shown.
 */
function get_module_title ($module, $module_title, $show_help) {
global $image_path;
global $app_strings;

$the_title = "<table width='100%' cellpadding='0' cellspacing='0' border='0' class='moduleTitle'><tr><td valign='top'>\n";
/*
$module = preg_replace("/ /","",$module);
if (is_file($image_path.$module.".gif")) {
	$the_title .= "<IMG src='".$image_path.$module.".gif' border='0' style='margin-top: 3px;' alt='".$module_title."' height='16' width='16'>&nbsp;</td><td width='100%'>";
}
*/
$icon = get_module_header_icon($module, $module_title);
if($icon)  $the_title .= $icon . '</td><td width="100%">';
$the_title .= "<h2>&nbsp;".$module_title."</h2></td>\n";

if ($show_help) {
		
		$the_title .= "<td valign='top' align='right' nowrap style='padding-top:3px; padding-left: 5px;'>";
	    
	    // longreach - replaced Help link
	    $help_link = get_help_link();
	    $the_title .= "&nbsp;<a href='$help_link' target='_blank' class='utilsLink'><div class='input-icon icon-help active-icon'></div>&nbsp;{$app_strings['LNK_HELP']}</a></td>\n";

	}


$the_title .= "</tr></table>\n";

return $the_title;

}

/**
 * Create a header for a popup.
 * param $theme - The name of the current theme
 */
function insert_popup_header($theme)
{
global $app_strings;
$charset = AppConfig::charset();
$style_info = style_info();

$out  = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">'."\n";
$out .=	'<html><head>';
$out .= get_favicon();
$out .=	'<meta http-equiv="Content-Type" content="text/html; charset='.$charset.'">';
$out .=	'<title>'.$app_strings['LBL_BROWSER_TITLE'].'</title>';
$out .= get_header_includes('popup');
$out .=	'</head><body style="margin: 10px" class="popUp">';

echo $out;
}

/**
 * Create a footer for a popup.
 */
function insert_popup_footer()
{
echo <<< EOQ
	</body>
	</html>
EOQ;
}


function &style_info() {
	global $current_user, $theme, $pageInstance, $themeInstance;
	global $style_options, $style_default;
	require_once("themes/$theme/config.php");
	$info = array();
	
	$style_pref = $current_user->getPreference("{$theme}_theme_style");
	if(!empty($_COOKIE["{$theme}_color_style"])) {
		$style = $_COOKIE["{$theme}_color_style"];
		if(!array_key_exists($style, $style_options))
			unset($style);
		else if($style != $style_pref)
			$current_user->setPreference("{$theme}_theme_style", $style);
	}
	else {
		$style = $style_pref;
		if(!array_key_exists($style, $style_options))
			unset($style);
	}
	if(empty($style))
		$style = $style_default;
	
	foreach($themeInstance->get_theme_css() as $inc_path) {
		if(is_array($inc_path)) {
			$tpars = $inc_path[1];
			$inc_path = $inc_path[0];
		} else {
			$tpars = null;
		}
		$pageInstance->add_css_include($inc_path, $tpars, LOAD_PRIORITY_THEME);		
	}	
	$pageInstance->add_css_include("themes/Default/theme-icons.css", null, LOAD_PRIORITY_THEME);
	$pageInstance->add_css_include("themes/{$theme}/default.css", null, LOAD_PRIORITY_THEME);
	$info['CURRENT'] = $style;
	$pfx = css_prefix();
	$sfx = css_suffix();
	$colors = array();
	foreach($style_options as $id => $opt) {
		$href = "themes/{$theme}/".$opt['css'];
		if($id == $style)
			$pageInstance->add_css_include($href, array('title' => $opt['title'], 'attrs' => 'id="theme:color"'), LOAD_PRIORITY_THEME);
		$opt['href'] = $pfx.$href.$sfx;
		$colors[$id] = $opt;
	}
	$pageInstance->set('color_styles', $colors);
	return $info;
}

?>
