{*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************}

<!DOCTYPE html PUBLIC "-//W3C//DTD html 4.01 Strict//EN">
<html {$DIR}>
<head>
<base href="{$BASE_URL}" >
{$FAVICON}
<meta http-equiv="Content-Type" content="{$CONTENT_TYPE}">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<title>{$PAGE_TITLE}</title>
{$HEADER_INCLUDES}
<script type="text/javascript">
SUGAR.themes.imagePath = '{$IMAGE_PATH}';
{if $ONLOAD}
YAHOO.util.Event.onDOMReady(function() {ldelim} {$ONLOAD} {rdelim});
{/if}

{literal}

var windowWidth;
var updateLayout = function() {
	if(windowWidth != window.innerWidth) {
		windowWidth = window.innerWidth;
		var orient = (windowWidth > window.innerHeight) ? 'landscape' : 'portrait';
		document.body.setAttribute('orient', orient);
		window.scrollTo(0, 1);
	}
}
YAHOO.util.Event.onDOMReady(updateLayout);
window.addEventListener('resize', updateLayout, false);

{/literal}

</script>

</head>

<body class="mobile color-{$current_color_style}{if $texture_enabled} textured{/if}">

	{if ! $disableFloat}
	<div class="floating-tbar" id="tbarDiv">
	<table class="tbar-table" border="0" cellpadding="0" cellspacing="0" width="100%" onclick="window.scroll(0, 0);">
	<tr>
		<td class="tbar-cell" id="app-link" width="60">
		<a class="box" href="index.php">
		{iah_icon_image path="include/images/iah/tlr-mini32.png" width=16 height=16}
		</a>
		</td>
		<td>&nbsp;</td>
		{if $IAH_SEARCH_LINK}
		<td class="tbar-cell" width="60">
		<a class="box with-popup" id="tbar-search" href="index.php?module=Home&action=UnifiedSearch"><div class="input-icon icon-search active"></div></a>
		</td>
		{/if}
		{if $USER_ID}
		<td class="tbar-cell" id="tbar-module" width="60">
		<a class="box with-popup" href="#" onclick="return false;"><div class="input-icon theme-icon module-{$MODULE_NAME}"></div></a>
		</td>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.registerMenuSource('tbar-module', {options: {/literal}{$menu_modules}{literal}, icon_key: 'icon', target_offset: {align: 'center', outer_margin: 0}}, null, 'system-toolbar');
		{/literal}{/iah_script}
		{/if}
		<td class="tbar-cell" id="tbar-system" width="60">
		<a class="box with-popup" href="#" onclick="return false;"><div class="input-icon icon-action active"></div></a>
		</td>
		{iah_script priority='foot'}{literal}
			SUGAR.ui.registerMenuSource('tbar-system', {options: {/literal}{$menu_system}{literal}, icon_key: 'icon', target_offset: {align: 'center', outer_margin: 0}}, null, 'system-toolbar');
		{/literal}{/iah_script}
	</tr>
	</table>
	</div>
	{/if}

	{if $module_tabs.more_tabs}
	<div id="MoreMenu" class="menu" onmouseover="window.clearTimeout(SUGAR.themes.resetSubTabsTimer);" onmouseout="SUGAR.themes.setResetTimer();">
	{foreach from=$module_tabs.more_tabs key=module_key item=tab}
		{if $tab.more}
			<a href="{$tab.url}" class="menuItem" id="{$tab.key}Handle" parentid="MoreMenu" onclick="SUGAR.themes.chooseTab('{$tab.key}'); return true;">{$tab.label}</a>
		{/if}
	{/foreach}
	</div>
	{/if}

	{if $hide_side_menu != 'complete'}
	<div id="HideMenu" class="subDmenu" style="position: absolute; width: 180px; z-index:500; display: none"></div>
	{/if}
	
	{if ! $hide_tab_bar && $module_tabs.use_group_tabs && $module_tabs.tabs}
		{assign var=group_tabs_visible value=1}{/if}

	<div class="headerBg{if $group_tabs_visible} overTabs{/if}">
	</div>
	
<div id="all-page">


<table width="100%" cellspacing="0" cellpadding="0" border="0" style="margin-top: 8px">
<tr>
	<td style="padding-right: 10px; padding-left: 8px; padding-top: 16px; width: 100%;" valign="top">
	{if $MODULE_NAME == 'Home' && $ACTION == 'index'}
	<div id="mod_menu_container">
	{foreach from=$MOBILE_MODULES key=modName item=modLabel}
	<div class="mod-menu-item">
		<a href="index.php?module={$modName}" class="tabDetailViewDFLink">
		<div class="input-icon theme-icon module-{$modName}" style="margin-bottom: -1px"></div>
		{$modLabel}
		</a>
	</div>
	{/foreach}
	<div style="clear:both"></div>
	</div>
	{/if}
