<?php

require_once('include/layout/BaseTheme.php');

class MobileTheme extends BaseTheme {
	var $theme_name = 'Mobile';
	var $custom_max_tabs = -1;
	var $custom_max_subtabs = -1;
	var $hide_dupe_list_shortcuts = true;
	var $texture_support = true;
	var $support_color_styles = true;
	var $support_font_styles = true;
	
	function get_global_links() {
		global $current_user;
		$l = parent::get_global_links();
		$ban = array('admin', 'myaccount', 'directory', 'logout');
		foreach(array_keys($l) as $key)
			if(in_array($key, $ban) || (! empty($current_user->id) && $key == 'about'))
				unset($l[$key]);
		return $l;
	}
	
	function populate_header(&$tpl, $currentModule = null) {
		global $app_list_strings, $pageInstance;
		parent::populate_header($tpl, $currentModule);
		if(! isset($currentModule))
			$currentModule = $pageInstance->module;
		$modules = array();
		$mods = AppConfig::setting("modinfo.mobile_modules", array());
		foreach ($mods as $mod) {
			if (ACLController::checkAccess($mod, 'list')) {
				$modules[$mod] = array_get_default($app_list_strings['moduleList'], $mod, $mod);
			}
		}
		asort($modules);
		$tpl->assign('MOBILE_MODULES', $modules);
		$tpl->assign('MODULE_LABEL', $app_list_strings['moduleList'][$currentModule]);

		$menu = array('keys' => array(), 'values' => array(), 'icon_key' => 'icon');
		foreach($modules as $k => $m) {
			$menu['keys'][] = $k;
			$menu['values'][$k] = array(
				'icon' => 'input-icon theme-icon module-' . $k, 'label' => $m,
				'perform' => 'SUGAR.util.loadUrl("index.php?module=' . $k . '&action=index")',
				);
		}
		$json = getJSONobj();
		$tpl->assign('menu_modules', $json->encode($menu));		
	}

	function populate_footer(&$tpl)
	{
		$tpl->assign('tabGroups', $this->tabGroups);
	}

}

?>
