<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  Contains a variety of utility functions used to display UI
 * components such as form headers and footers.  Intended to be modified on a per
 * theme basis.
 ********************************************************************************/

require_once('XTemplate/xtpl.php');
require_once("data/Tracker.php");
require_once("include/utils.php");
require_once("include/globalControlLinks.php");

global $currentModule;
global $moduleList;
global $theme;
global $max_tabs;
$theme_path="themes/".$theme."/";
$image_path=$theme_path."images/";
require_once($theme_path.'layout_utils.php');

$cfg = AppConfig::get_theme_config();
unset($cfg['name']); unset($cfg['description']);
extract($cfg);

global $app_strings;
$default_charset = AppConfig::charset();
$xtpl=new XTemplate ($theme_path."header.html");
$xtpl->assign("APP", $app_strings);


$xtpl->assign("LBL_CHARSET", $default_charset);
$xtpl->assign("THEME", $theme);
$xtpl->assign("IMAGE_PATH", $image_path);
$xtpl->assign("PRINT_URL", "index.php?".$GLOBALS['request_string']);
$xtpl->assign("MODULE_NAME", $currentModule);
$xtpl->assign("DATE", date("Y-m-d"));
assign_calendar_links($xtpl);
$xtpl->assign("TITLE", $app_strings['LBL_SEARCH']);
if(isset($_REQUEST['RTL']) && $_REQUEST['RTL'] == 'RTL'){
		$_SESSION['RTL'] = true;
	}
	if(isset($_REQUEST['LTR']) && $_REQUEST['LTR'] == 'LTR'){
		unset($_SESSION['RTL']);
	}
	if(isset($_SESSION['RTL']) && $_SESSION['RTL']){
		$xtpl->assign("DIR", 'dir="RTL"');
	}
if ($current_user->first_name != '') $xtpl->assign("CURRENT_USER", $current_user->first_name);
else $xtpl->assign("CURRENT_USER", $current_user->user_name);

$xtpl->assign("CURRENT_USER_ID", $current_user->id);


// longreach - start added
$realModule = $currentModule;
theme_template_setup($xtpl);
// longreach - end added


$i = 0;
foreach($global_control_links as $key => $value) {
	foreach ($value as $linkattribute => $attributevalue) {
		if($linkattribute == 'linkinfo') {
			foreach ($attributevalue as $label => $url) {
				$xtpl->assign("GCL_LABEL", $label);
				$xtpl->assign("GCL_URL", $url);
				if (isset($sub_menu[$key]) && $sub_menu[$key]) {
					$xtpl->assign("GCL_MENU", "id='".$key."Handle' onmouseover=' tbButtonMouseOver(this.id,18,\"\",0);'");
					$xtpl->assign("MENU_ARROW", "<img src='".$image_path."menuarrow.gif' alt='' align='absmiddle' id='".$key."Handle' style='margin-bottom: 1px; margin-left:2px; cursor: pointer;' align='absmiddle' onmouseover='tbButtonMouseOver(this.id,18,\"\",0);'>");
				} else {
					$xtpl->assign("GCL_MENU", "");
					$xtpl->assign("MENU_ARROW", "");
				}
				if($i < sizeof($global_control_links)-1) {
					$xtpl->assign("SEPARATOR", "|");
				} else {
					$xtpl->assign("SEPARATOR", "");
				}
			}
		}

		if($linkattribute == 'submenu') {
			if (is_array($attributevalue)) {
				foreach ($attributevalue as $submenulinkkey => $submenulinkinfo) {
					foreach ($submenulinkinfo as $submenulinklabel => $submenulinkurl) {
					$xtpl->assign("GCL_SUBMENU_LINK_LABEL", $submenulinklabel);
					$xtpl->assign("GCL_SUBMENU_LINK_URL", $submenulinkurl);
					}
					$xtpl->assign("GCL_SUBMENU_KEY", $key);
					$xtpl->assign("GCL_SUBMENU_LINK_KEY", $submenulinkkey);
					$xtpl->parse("main.gcl_submenu.gcl_submenu_items");
				}

			}
			$xtpl->assign("GCL_SUBMENU_KEY", $key);
			$xtpl->parse("main.gcl_submenu");
		}
	}
	$xtpl->parse("main.global_control_links");
	$i++;
}

if (isset($_REQUEST['query_string'])) $xtpl->assign("SEARCH", $_REQUEST['query_string']);

$xtpl->assign("ONLOAD", $GLOBALS['pageInstance']->get_onload());

// Loop through the module list.
// For each tab that is off, parse a tab_off.
// For the current tab, parse a tab_on
$modListHeader = $moduleList;


if(empty($current_user->id))
    $modListHeader = array();
else
    $modListHeader = query_module_access_list($current_user);


if(isset($current_user->id))
{
	$user_max_tabs = $current_user->getPreference('max_tabs');
	if($user_max_tabs > 0)
		$max_tabs = $user_max_tabs;
    elseif(!isset($max_tabs) || $max_tabs <= 0)
        $max_tabs = AppConfig::setting('layout.defaults.max_tabs');
}

$modListHeader = get_val_array($modListHeader);


/* Select navigation paradigm */
$user_navigation_paradigm = $current_user->getPreference('navigation_paradigm');
if(!isset($user_navigation_paradigm)) $user_navigation_paradigm = AppConfig::setting('layout.defaults.navigation_paradigm');
$useGroupTabs = $user_navigation_paradigm == 'gm';


require_once('include/GroupedTabs/GroupedTabStructure.php');
$tabManager = new GroupedTabStructure();
$currentMenu = $currentModule;

// jostrow: fixes bug #9712, by making sure not to build the groupTabs list on the Login screen when login_nav==false
if($useGroupTabs && !empty($modListHeader))
{
    $max_subtabs = $current_user->getPreference('max_subtabs');
    if(!isset($max_subtabs) || $max_subtabs <= 0)
    	$max_subtabs = AppConfig::setting('layout.defaults.max_subtabs');
    $groupedTabStructure = $tabManager->get_grouped_tabs($currentModule, null, $max_tabs, $max_subtabs);

	$xtpl->parse('main.subtabBar');

    $xtpl->assign('MAIN_MORE_TAB', '');
    reset($groupedTabStructure);
    $xtpl->assign('PARENT_TAB', addcslashes(key($groupedTabStructure), "\r\n'\""));

	$showMore = false;
    foreach($groupedTabStructure as $mainTab => $subModules)
    {
        if(empty($subModules['modules']))
            continue;
        
        $activeTab = array_get_default($subModules, 'active');

        $tabId = preg_replace("~\W~", '', $mainTab);
		$xtpl->assign("TAB_ID", $tabId);
        $xtpl->assign("TAB_NAME", $mainTab);
        $xtpl->assign("MODULE_KEY", $mainTab);
        if($activeTab) {
        	$xtpl->assign("TAB_CLASS", "currentTab");
        	$xtpl->assign('PARENT_TAB', $tabId);
        	$currentMenu = $subModules['modules'][$activeTab]['module'];
        }
        else
	        $xtpl->assign("TAB_CLASS", "otherTab");
        $xtpl->assign("OTHER_TAB", "currentTab");
        
        $j = $showSubMore = 0;

        foreach($subModules['modules'] as $subModule => $tabInfo) {
            if($subModule == $activeTab) {
                $xtpl->assign("SUB_LINK_CLASS", 'activeSubTabLink');
                $xtpl->assign("SUB_CLASS", 'activeSubTab');
            }
            else {
            	$xtpl->assign("SUB_CLASS", 'subTab');
            	$xtpl->assign("SUB_LINK_CLASS", 'subTabLink');
            }
            $xtpl->assign("SUB_URL", $tabInfo['url']);
            $xtpl->assign("SUB_NAME", addslashes($tabInfo['label']));
            if($j++ == 0)
            	$xtpl->assign("TAB_URL", $tabInfo['url']);
            
            if(! empty($tabInfo['final'])) {
				$xtpl->assign("SUB_MORE", "<li nowrap=\"nowrap\">&nbsp;<span class=\"subTabMore\" id=\\'MoreSub{$tabId}Handle\\' style=\\' margin-left:2px; cursor: pointer;\\' align=\\'absmiddle\\' onmouseover=\\'SUGAR.popups.showPopup(this,\"MoreSub{$tabId}Menu\",{left:10});\\'>&gt;&gt;</span></li>");
				$showSubMore = true;
			} else
				$xtpl->assign("SUB_MORE", '');

			if(! empty($tabInfo['more']))
				$xtpl->parse("main.moresubmenu.moresubmenuitem");
			else
				$xtpl->parse("main.group_tabs_js.js_subtabs.js_subtabs_html");
        }

        $xtpl->parse("main.group_tabs_js.js_subtabs");
        if($showSubMore) {
        	$xtpl->assign("MENU_NAME", $mainTab);
        	$xtpl->parse("main.moresubmenu");
        }
		
        if(! empty($subModules['more'])) {
			$xtpl->assign("MODULE_NAME", $mainTab);
			$xtpl->assign("MODULE_KEY", $mainTab);
			$xtpl->parse("main.more");
        	if(! $showMore) {
                $xtpl->assign("MORE_HANDLE_CLASS", 'otherTab');
                $xtpl->parse("main.tabBar.moreHandle");
				$xtpl->assign('MAIN_MORE_TAB', $tabId);
                $showMore = true;
            }
        }
        else
        	$xtpl->parse("main.tabBar.tab");
    }

    if(!empty($groupedTabStructure))
    {
        $xtpl->parse("main.group_tabs_js");
        $xtpl->parse("main.group_subtabs_js");
    }
    else
    {
    	$xtpl->parse("main.no_group_placeholder_js");
    }
}
else
{
	$tabStructure = $tabManager->get_flat_tabs($currentModule, $max_tabs);

	foreach($tabStructure as $tabKey => $tabInfo) {
		if(! empty($tabInfo['active'])) {
			$currentMenu = $tabInfo['module'];
			$tabClass = 'currentTab';
		} else
			$tabClass = 'otherTab';
		$xtpl->assign("TAB_CLASS", $tabClass);
		$xtpl->assign("MODULE_NAME", $tabInfo['label']);
		$xtpl->assign("MODULE_KEY", $tabKey);
		$xtpl->assign("TAB_URL", $tabInfo['url']);

		if(! empty($tabInfo['more']))
			$xtpl->parse("main.more");
		else {
			if(! empty($tabInfo['final'])) {
				$xtpl->assign("MORE_HANDLE_CLASS", 'otherTab');
				$xtpl->parse("main.tabBar.moreHandle");
			}
			$xtpl->parse("main.tabBar.module_tab");
		}
    }

    $xtpl->parse("main.no_group_placeholder_js");
}

// longreach - added
if(! empty($current_user->id))
	$xtpl->parse('main.tabBar');

// foreach color
$ii = 1;
if(!empty($theme_colors))
{
    foreach($theme_colors as $color)
    {
        $xtpl->assign('COLOR_NAME', $color);
        $xtpl->assign('TOP', - $ii * 15);
		$xtpl->parse("main.color");
		$ii++;
    }
}
// foreach font
if(!empty($theme_fonts))
{
    foreach($theme_fonts as $font)
    {
        $xtpl->assign('FONT_NAME', $font);
        $xtpl->assign('TOP', - $ii * 15);
        $xtpl->parse("main.font");
        $ii++;
    }
}


unset($name);
unset($id);

//include('modules/iFrames/header.php');
// Assign the module name back to the current module.
$xtpl->assign("MODULE_NAME", $currentModule);

/* Get preference for shortcuts and last_viewed list placement */
$last_view_swap = $current_user->getPreference('swap_last_viewed');
if(!isset($last_view_swap)) $last_view_swap = AppConfig::setting('layout.defaults.swap_last_viewed');
$shortcuts_swap = $current_user->getPreference('swap_shortcuts');
if(!isset($shortcuts_swap)) $shortcuts_swap = AppConfig::setting('layout.defaults.swap_shortcuts');

if($currentMenu == 'Administration' && $currentModule != $currentMenu)
	$currentMenu = $currentModule;
$module_menu = $pageController->get_menu_shortcuts($currentMenu);

$i = 0;
foreach($module_menu as $menu_item)
{
    	$after_this = current($module_menu);

    	if ($menu_item[1] != 'Deleted Items')
        {
    		$xtpl->assign("URL", $menu_item[0]);
    		$xtpl->assign("LABEL", $menu_item[1]);
    		$xtpl->assign("SC_MODULE_NAME", $menu_item[2]);
            $xtpl->assign("SC_ID", $i++);
    		$xtpl->assign("SC_IMAGE", get_image($image_path.$menu_item[2],"alt='".$menu_item[1]."'  border='0' align='absmiddle'"));
    		if (empty($after_this)) $xtpl->assign("SEPARATOR", "");
    		else $xtpl->assign("SEPARATOR", "</br>");
    	}
        else
        {
    		$xtpl->assign("DELETED_ITEMS_URL", $menu_item[0]);
    		$xtpl->assign("DELETED_ITEMS_LABEL", $menu_item[1]);
    	}

        if(!$shortcuts_swap)
        {
            if($menu_item[0] !== "#")
            {
                $xtpl->parse("main.hide_shortcut.hide_shortcut_item");
                $xtpl->parse("main.left_form.sub_menu.sub_menu_item");
            }
            else
            {
                $xtpl->parse("main.hide_shortcut.hide_shortcut_special");
                $xtpl->parse("main.left_form.sub_menu.sub_menu_special");
            }
        }
        else
        {
            $xtpl->parse("main.left_form_shortcuts.shortcut_item");
        }
}

if(!$shortcuts_swap)
{
    $xtpl->parse("main.left_form.sub_menu");
}

$xtpl->assign("SHORTCUTS", $app_strings['LBL_SHORTCUTS']);

if (isset($_SESSION["authenticated_user_id"]))
{
    $xtpl->assign("TITLE_LAST_VIEW", $app_strings['LBL_LAST_VIEWED']);
    $xtpl->parse("main.left_form_search");
    $xtpl->parse("main.welcome");
    
    if(empty($theme_hide_side_complete)) {
		if(!$shortcuts_swap)
		{
			$xtpl->parse("main.left_form");
			$xtpl->parse("main.hide_shortcut");
		}
		else
		{
			$xtpl->parse("main.left_form_shortcuts");
		}
	}



    $history = Tracker::get_recently_viewed($current_user->id);

    $current_row=1;

    if (count($history) > 0)
    {
    	$i = 0;
        foreach($history as $row)
        {
    		$xtpl->assign("RECENT_LABEL", to_html(getTrackerSubstring($row['item_summary'], 30, true)));
    		$xtpl->assign("RECENT_LABEL_FULL",to_html($row['item_summary']));
    		$xtpl->assign("MODULE_NAME",$row['module_name']);
    		$xtpl->assign("ROW_NUMBER",$current_row);
            $xtpl->assign("RL_ID", $i++);
    		$xtpl->assign("RL_IMAGE",get_image($image_path.$row['module_name'],'border="0" align="absmiddle" title="'.htmlspecialchars($row['item_summary'], ENT_QUOTES, 'UTF-8').'"'));
    		$xtpl->assign("RECENT_URL","index.php?module=$row[module_name]&action=DetailView&record=$row[item_id]");

    		if ($current_row < 9)
            {
    			if(!$last_view_swap || ! empty($theme_hide_side_complete))
                {
					$xtpl->parse("main.recent_view_menu.row");		
					if($current_row == 1)
						$xtpl->parse("main.recent_view_menu.first");
                }
                else
                {
                    $xtpl->parse("main.left_form_recent.sub_menu.sub_menu_item");
                    $xtpl->parse("main.hide_recent.hide_recent_item");
                }
    		}
    		$current_row++;
    	}
    }
    else
    {
        $xtpl->assign("RL_ID", 0);
        if(!$last_view_swap || ! empty($theme_hide_side_complete))
        {
            $xtpl->parse("main.recent_view_menu.empty");
        }
        else
        {
            $xtpl->parse("main.left_form_recent.sub_menu.left_form_recent_view_empty");
            $xtpl->parse("main.hide_recent.left_form_recent_view_empty");
        }
    }

    if(!$last_view_swap || ! empty($theme_hide_side_complete))
    {
        $xtpl->parse("main.recent_view_menu");
    }
    else
    {
        $xtpl->parse("main.left_form_recent.sub_menu");
        $xtpl->parse("main.left_form_recent");
        $xtpl->parse("main.hide_recent");
    }

	if(empty($theme_hide_side_complete)) {
		if(!$shortcuts_swap || $last_view_swap)
		{
			if(!$shortcuts_swap || $last_view_swap)
			{
				$xtpl->parse("main.left_form_otd.left_form_otd_icon");
			}
			else
			{
				$xtpl->parse("main.left_form_otd.left_form_otd_noicon");
			}
			$xtpl->parse("main.left_form_otd");

			if(! empty($theme_hide_side_menu)) {
				$xtpl->assign('OVERRIDE_LEFT_COL', "showLeftCol = 'false';");
			}

			$xtpl->parse("main.left_form_ctd");
		}
		else
		{
			$xtpl->parse("main.left_form_empty_td");
		}
	}
}
else
{
	$xtpl->parse("main.left_form_search_placeholder");
}

$xtpl->parse("main");
$xtpl->out("main");

?>
