<?php
if(!defined('sugarEntry') || !sugarEntry) die('Not A Valid Entry Point');
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/
/*********************************************************************************

 * Description:  Contains a variety of utility functions used to display UI
 * components such as form headers and footers.  Intended to be modified on a per
 * theme basis.
 ********************************************************************************/

global $even_bg, $odd_bg, $hilite_bg, $barChartColors, $pieChartColors;

// list view colors
$even_bg = "#ffffff";
$odd_bg = "#ffffff";
$hilite_bg = "#f0f0f0";
//$click_bg = "#FCB670";

//graph colors
$barChartColors = array(
"docBorder"=>"0xffffff",
"docBg1"=>"0xffffff",
"docBg2"=>"0xffffff",
"xText"=>"0x33485c",
"yText"=>"0x33485c",
"title"=>"0x333333",
"misc"=>"0x999999",
"altBorder"=>"0xffffff",
"altBg"=>"0xffffff",
"altText"=>"0x666666",
"graphBorder"=>"0xcccccc",
"graphBg1"=>"0xf6f6f6",
"graphBg2"=>"0xf6f6f6",
"graphLines"=>"0xcccccc",
"graphText"=>"0x333333",
"graphTextShadow"=>"0xf9f9f9",
"barBorder"=>"0xeeeeee",
"barBorderHilite"=>"0x333333",
"legendBorder"=>"0xffffff",
"legendBg1"=>"0xffffff",
"legendBg2"=>"0xffffff",
"legendText"=>"0x444444",
"legendColorKeyBorder"=>"0x777777",
"scrollBar"=>"0xcccccc",
"scrollBarBorder"=>"0xeeeeee",
"scrollBarTrack"=>"0xeeeeee",
"scrollBarTrackBorder"=>"0xcccccc"
);

$pieChartColors = array(
"docBorder"=>"0xffffff",
"docBg1"=>"0xffffff",
"docBg2"=>"0xffffff",
"title"=>"0x333333",
"subtitle"=>"0x666666",
"misc"=>"0x999999",
"altBorder"=>"0xffffff",
"altBg"=>"0xffffff",
"altText"=>"0x666666",
"graphText"=>"0x33485c",
"graphTextShadow"=>"0xf9f9f9",
"pieBorder"=>"0xffffff",
"pieBorderHilite"=>"0x333333",
"legendBorder"=>"0xffffff",
"legendBg1"=>"0xffffff",
"legendBg2"=>"0xffffff",
"legendText"=>"0x444444",
"legendColorKeyBorder"=>"0x777777",
"scrollBar"=>"0xdfdfdf",
"scrollBarBorder"=>"0xfafafa",
"scrollBarTrack"=>"0xeeeeee",
"scrollBarTrackBorder"=>"0xcccccc"
);


/**
 * Create HTML to display formatted form title of a form in the left pane
 * param $left_title - the string to display as the title in the header
 */
function get_left_form_header ($left_title)
{
global $image_path;

$the_header = "";
       	$the_header .='<table cellpadding="0" cellspacing="0" border="0" width="100%" class="leftColumnModuleHead">';
		$the_header .='<tr>';
		$the_header .='<th width="100%" class="leftColumnModuleName">'.$left_title.'</th></tr>';
		$the_header .='</table>';
		$the_header .='<table width="100%" cellpadding="3" cellspacing="0" border="0"><tr><td align="left" class="leftColumnModuleS3">';


return $the_header;
}

/**
 * Create HTML to display formatted form footer of form in the left pane.
 */
function get_left_form_footer() {
return ("</td></tr></table>\n");
}

/**
 * Create HTML to display formatted form title.
 * param $form_title - the string to display as the title in the header
 * param $other_text - the string to next to the title.  Typically used for form buttons.
 * param $show_help - the boolean which determines if the print and help links are shown.
 */
function get_form_header ($form_title, $other_text, $show_help, $icon='')
{
global $image_path;
global $app_strings;

$the_form = '';
$the_form .= '<table width="100%" cellpadding="0" cellspacing="0" border="0" class="h3Row"><tr>';
$is_min_max = strpos($other_text,"_search.gif");

if($icon) {
	if(strpos($icon, '<') === false) {
		if(strpos($icon, '/') === false)
			$icon = $GLOBALS['image_path'].$icon;
		$icon = get_image($icon, ' alt="" title="" border="0" style="margin-top: -2px"');
	}
	$form_title = $icon .'&nbsp;'. $form_title;
}

if($is_min_max === false) {
	$the_form .= '<td nowrap><h3>'.$form_title.'</h3></td>';
} else {
	$the_form .= "<td nowrap><h3>{$other_text}&nbsp;{$form_title}</h3></td>";
}


$keywords = array("/class=\"button\"/","/class='button'/","/class=button/","/<\/form>/");
$match="";

	foreach ($keywords as $left) {
		 if (preg_match($left,$other_text)) {$match=true;}
	}
if ($other_text && $match) {
$the_form .= "<td colspan='10' width='100%'><img height='1' width='1' src='include/images/blank.gif' alt=''></td>\n";
	$the_form .= "</tr><tr>\n";
	$the_form .= "<td align='left' valign='middle' nowrap style='padding-bottom: 2px;'>$other_text</td>\n";
	$the_form .= "<td width='100%'><img height='1' width='1' src='include/images/blank.gif' alt=''></td>\n";

	if ($show_help==true) {
		$the_form .= "<td align='right' nowrap>";
	    
	    // longreach - replaced Help link
	    $help_link = get_help_link();
	    $the_form .= "&nbsp;<a href='$help_link' target='_blank' class='utilsLink'><div class='input-icon icon-help active-icon'></div>&nbsp;{$app_strings['LNK_HELP']}</a></td>\n";

	}


} else {
	if ($other_text && $is_min_max === false) {
		$the_form .= "<td width='20'><IMG height='1' width='20' src='include/images/blank.gif' alt=''></td>\n";
		$the_form .= "<td valign='middle' nowrap width='100%'>$other_text</td>\n";
	}
	else {
		$the_form .= "<td width='100%'><IMG height='1' width='1' src='include/images/blank.gif' alt=''></td>\n";
	}

	if ($show_help==true) {
		$the_form .= "<td align='right' nowrap>";
	    
	    // longreach - replaced Help link
	    $help_link = get_help_link();
	    $the_form .= "&nbsp;<a href='$help_link' target='_blank' class='utilsLink'><div class='input-icon icon-help active-icon'></div>&nbsp;{$app_strings['LNK_HELP']}</a></td>\n";

	}


}



$the_form .= <<<EOQ
	  </tr>
</table>


EOQ;

return $the_form;
}

/**
 * Create HTML to display formatted form footer
 */
function get_form_footer() {
}

/**
 * Create HTML to display formatted module title.
 * param $module - the string to next to the title.  Typically used for form buttons.
 * param $module_title - the string to display as the module title
 * param $show_help - the boolean which determines if the print and help links are shown.
 */
function get_module_title ($module, $module_title, $show_help)
{
global $image_path;
global $app_strings;

$the_title = "<table width='100%' cellpadding='0' cellspacing='0' border='0' class='moduleTitle'><tr valign='top'><td>\n";
$module = preg_replace("/ /","",$module);


/* longreach - removed
if (is_file($image_path.$module.".gif")) {
	$the_title .= "<IMG src='".$image_path.$module.".gif' width='16' height='16' border='0' style='margin-top: 3px; margin-right: 3px;' alt='".$module."'>&nbsp;</td><td width='100%'>";
}
*/
// longreach - added
$icon = get_module_header_icon($module, $module_title);
if($icon)  $the_title .= $icon . '</td><td width="100%">';


$the_title .= "<h2>".$module_title."</h2></td>\n";

if ($show_help) {

		$the_title .= "<td valign='top' align='right' nowrap style='padding-top:3px; padding-left: 5px;'>";

	    // longreach - replaced Help link
	    $help_link = get_help_link();
	    $the_title .= "&nbsp;<a href='$help_link' target='_blank' class='utilsLink'><div class='input-icon icon-help active-icon'></div>&nbsp;{$app_strings['LNK_HELP']}</a></td>\n";

	}



$the_title .= "</tr></table>\n";

return $the_title;

}


function add_theme_styles($theme) {
	global $theme_colors, $theme_fonts;
	global $pageInstance, $themeInstance;
	$cfg = AppConfig::get_theme_config($theme);
	$colors = array();
	foreach($cfg['theme_colors'] as $c)
		$colors[$c] = array('title' => $c, 'href' => "themes/$theme/colors.$c.css");
	$fonts = array();
	foreach($cfg['theme_fonts'] as $f)
		$fonts[$f] = array('title' => $f, 'href' => "themes/$theme/fonts.$f.css");
	$selColor = array_get_default($_COOKIE, $theme.'_color_style');
	if(! $selColor || ! isset($colors[$selColor]))
		$selColor = key($colors);
	$selFont = array_get_default($_COOKIE, $theme.'_font_style');
	if(! $selFont || ! isset($fonts[$selFont]))
		$selFont = key($fonts);
	
	foreach($themeInstance->get_theme_css() as $inc_path) {
		if(is_array($inc_path)) {
			$tpars = array_get_default($inc_path, 'params');
			$inc_path = $inc_path['value'];
		} else {
			$tpars = null;
		}
		$pageInstance->add_css_include($inc_path, $tpars, LOAD_PRIORITY_THEME);		
	}	
	$pageInstance->add_css_include("themes/Default/theme-icons.css", null, LOAD_PRIORITY_THEME);
	$pageInstance->add_css_include("themes/$theme/style.css", null, LOAD_PRIORITY_THEME);
	$pageInstance->add_css_include($colors[$selColor]['href'], array('attrs' => 'id="theme:color"'), LOAD_PRIORITY_THEME);
	$pageInstance->add_css_include($fonts[$selFont]['href'], array('attrs' => 'id="theme:font"'), LOAD_PRIORITY_THEME);
	
	$pfx = css_prefix();
	$sfx = css_suffix();
	foreach($colors as $i => $c)
		$colors[$i]['href'] = $pfx.$colors[$i]['href'].$sfx;
	foreach($fonts as $i => $f)
		$fonts[$i]['href'] = $pfx.$fonts[$i]['href'].$sfx;
	$pageInstance->set('color_styles', $colors);
	$pageInstance->set('font_styles', $fonts);
}


/**
 * Create a header for a popup.
 * param $theme - The name of the current theme
 */
function insert_popup_header($theme)
{
global $app_strings;

$charset = AppConfig::charset();
$out  = '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Strict//EN">'."\n";
$out .=	'<html><head>';
$out .= get_favicon();
$out .=	'<meta http-equiv="Content-Type" content="text/html; charset='.$charset.'">';
$out .=	'<title>'.$app_strings['LBL_BROWSER_TITLE'].'</title>';
$out .= get_header_includes('popup');
$out .=	'</head><body style="margin: 10px">';

echo $out;
}

/**
 * Create a footer for a popup.
 */
function insert_popup_footer()
{
echo <<< EOQ
	</body>
	</html>
EOQ;
}

?>
