<?php
chdir('..');
define('sugarEntry', 1);
define('IAH_NO_DATABASE', 1);
require_once('include/entryPoint.php');

if(! empty($_REQUEST['preview'])) {
	$theme = $_REQUEST['preview'];
	$base_css = ($theme == 'LongReach' ? 'default.css' : 'style.css');
?>
<html>
<head>
	<link type="text/css" rel="stylesheet" href="<?php echo $theme . '/' . $base_css . '?' . time(); ?>">
	<link type="text/css" rel="stylesheet" href="<?php echo $theme; ?>/theme-icons.css?<?php echo time(); ?>">
	<style type="text/css">
		.theme-icon { margin: 2px; }
	</style>
</head>
<body style="background-color: #eee">
<?php
	$fc = file_get_contents("themes/$theme/theme-icons.css");
	if(preg_match_all('~\.(?:module|bean|create|ticon)\-[A-Za-z0-9_]+~', $fc, $m)) {
		$all = array_unique($m[0]);
		sort($all);
		$icons = array();
		foreach($all as $i) {
			list($pfx, $i2) = explode('-', $i, 2);
			$icons[$pfx][] = $i;
		}
		foreach($icons as $cls => $is) {
			foreach($is as $i) {
				$i = substr($i, 1);
				echo "<div class=\"theme-icon $i\" title=\"$i\"></div>";
				echo "<div class=\"theme-icon $i grey\" title=\"$i grey\"></div>";
			}
			echo '<br /><br />';
		}
	}
	echo '</body></html>';
	return;
}

foreach(array('Default') as $theme) { //'Delight', 'Spectrum', 'LongReach', 'ClassicSide', 'Mobile') as $theme) {
	include("themes/$theme/theme-icons-base.php");
	
	$modules = AppConfig::setting("modinfo.index.all");
	$beans = AppConfig::setting("modinfo.primary_beans");
	
	$offsets = array();
	$output_dims = array();
	$seen = array();
	$src = array();
	$custom = array();
	$imgs = array_flip($icon_defs['images']);
	$imgs_dims = $icon_defs['dims'];
	$imgs_spacer = array_get_default($icon_defs, 'spacer', 0);
	$imgs_offset = 16 + $imgs_spacer;
	$imgs_length = array_get_default($icon_defs, 'length', 1000);
	
	// fill in .module-* CSS classes
	foreach($modules as $m) {
		$cls = '.module-'.$m;
		if(isset($imgs[$m])) {
			$offs = $imgs[$m];
			$dims = array_get_default($imgs_dims, $m);
			$custom[] = $cls;
		}
		else {
			$missing[] = $cls;
			continue;
		}
		$seen[$m] = $cls;
		$src[$cls] = $m;
		$offsets[$offs][] = $cls;
		if($dims)
			$output_dims[$dims][] = $cls;
	}
	
	// fill in .bean-* CSS classes
	foreach($beans as $module => $bean) {
		$cls = '.bean-'.$bean;
		if(isset($imgs[$bean])) {
			$offs = $imgs[$bean];
			$dims = array_get_default($imgs_dims, $bean);
			$src[$cls] = $bean;
			$custom[] = $cls;
		}
		else if(isset($imgs[$module])) {
			$offs = $imgs[$module];
			$dims = array_get_default($imgs_dims, $module);
			$src[$cls] = $module;
			$custom[] = $cls;
		}
		else {
			$missing[] = $cls;
			continue;
		}
		if(! isset($seen[$module]))
			$seen[$module] = $cls;
		if(! isset($seen[$bean]))
			$seen[$bean] = $cls;
		$offsets[$offs][] = $cls;
		if($dims)
			$output_dims[$dims][] = $cls;
	}
	
	// fill in .create-* CSS classes
	foreach($beans as $module => $bean) {
		$cls = '.create-'.$bean;
		$bean = 'Create'.$bean;
		$module = 'Create'.$module;
		if(isset($imgs[$bean])) {
			$offs = $imgs[$bean];
			$dims = array_get_default($imgs_dims, $bean);
			$src[$cls] = $bean;
			$custom[] = $cls;
		}
		else if(isset($imgs[$module])) {
			$offs = $imgs[$module];
			$dims = array_get_default($imgs_dims, $module);
			$src[$cls] = $module;
			$custom[] = $cls;
		}
		else {
			$missing[] = $cls;
			continue;
		}
		if(! isset($seen[$module]))
			$seen[$module] = $cls;
		if(! isset($seen[$bean]))
			$seen[$bean] = $cls;
		$offsets[$offs][] = $cls;
		if($dims)
			$output_dims[$dims][] = $cls;
	}
	
	// add remaining icons as .icon-* CSS classes
	foreach($imgs as $icon => $offs) {
		if($icon && empty($seen[$icon])) {
			$cls = '.ticon-'.$icon;
			$offsets[$offs][] = $cls;
			$dims = array_get_default($imgs_dims, $icon);
			if($dims)
				$output_dims[$dims][] = $cls;
			$custom[] = $cls;
			$seen[$icon] = $cls;
			$src[$cls] = $icon;
		}
	}
	
	if(! empty($imgs['Log'])) {
		$cls = '.module-ActivityLog';
		$offsets[$imgs['Log']][] = $cls;
		$custom[] = $cls;
		$seen['ActivityLog'] = $cls;
		$src[$cls] = 'Log';
	}
	
	$ret = array();
	$cls_norm = implode(',', array(
		'.theme-icon',
		'.theme-icon.active','.theme-icon.grey.active',
		'button:hover .theme-icon',
		'.menu-option.current .theme-icon',
		'.menu-option.color .theme-icon',
		'.tab-current .theme-icon',
	));
	$ret[] = $cls_norm . '{background-image:url(images/theme-icons.png);opacity:1.0}';
	$cls_grey = implode(',', array(
		'button .theme-icon',
		'.menu-option .theme-icon',
		'.theme-icon.grey',
	));
	$ret[] = $cls_grey . '{background-image:url(images/theme-icons-grey.png);opacity:0.9}';

	foreach($offsets as $o => $classes) {
		$cls = implode(',', $classes);
		$x = $o % $imgs_length * $imgs_offset;
		$y = floor($o / $imgs_length) * $imgs_offset;
		if($x) $x = "-{$x}px";
		if($y) $y = "-{$y}px";
		$ret[] = "$cls{background-position:{$x} {$y}}";
	}
	//$ret[] = wordwrap(implode(', ', $custom), 100) . '{background-image:url(images/theme-icons.png)}';
	
	foreach($output_dims as $dim => $classes) {
		$cls = implode(',', $classes);
		list($w, $h) = explode(',', $dim, 2);
		$ret[] = "$cls{width:{$w}px;height:{$h}px;line-height:{$h}px}";
	}
	
	$height = ceil((count($imgs) + 1) / $imgs_length) * $imgs_offset;
	$ret[] = <<<EOF
@media only screen and (-webkit-min-device-pixel-ratio: 1.5),
	only screen and (min-device-pixel-ratio: 1.5),
	only screen and (min-resolution: 1.5dppx) {
	$cls_norm{background-image: url(images32/theme-icons.png);background-size:auto {$height}px}
	$cls_grey{background-image: url(images32/theme-icons-grey.png);background-size:auto {$height}px}
}
EOF;
	
	$ret[] = '';
	
	file_put_contents("themes/$theme/theme-icons.css", implode("\n", $ret));
	
	$ret = array();
	$ret[] = '.theme-icon{background:none}';

	foreach($src as $k => $v) {
		$path =  in_array($k, $custom) ? '' : '../Default/';
		$ret[] = "$k:after{content:url({$path}images/$v.gif)}";
	}
	
	file_put_contents("themes/$theme/print-icons.css", implode("\n", $ret));
	
	foreach($seen as $k => &$v)
		$v = substr($v, 1);
	$seen_php = var_export($seen, true);
	file_put_contents("themes/$theme/theme-icons.php", "<?php return $seen_php; ?>");
	
	echo "<h3>$theme</h3>";
	echo "<iframe src=\"?preview=$theme\" width=800 height=300 style=\"border: none\"></iframe><br />";
}


?>
