<?php
 if(!defined('sugarEntry'))define('sugarEntry', true);
/*********************************************************************************
 * The contents of this file are subject to the SugarCRM Public License Version
 * 1.1.3 ("License"); You may not use this file except in compliance with the
 * License. You may obtain a copy of the License at http://www.sugarcrm.com/SPL
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied.  See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * All copies of the Covered Code must include on each user interface screen:
 *    (i) the "Powered by SugarCRM" logo and
 *    (ii) the SugarCRM copyright notice
 * in the same form as they appear in the distribution.  See full license for
 * requirements.
 *
 * The Original Code is: SugarCRM Open Source
 * The Initial Developer of the Original Code is SugarCRM, Inc.
 * Portions created by SugarCRM are Copyright (C) 2004-2006 SugarCRM, Inc.;
 * All Rights Reserved.
 * Contributor(s): ______________________________________.
 ********************************************************************************/

require_once('include/entryPoint.php');
define('ONECRM_CSRF_PROTECT', 'none');
require_once('include/vCard.php');

AppConfig::restrict_entry_point();

$authController = new AuthenticationController();

if(! AppConfig::session_start()) {
	header('HTTP/1.1 503 Service Unavailable');
	die('Error starting session');
}

$current_user = new User();

if(empty($_SESSION['authenticated_user_id']))
	$not_auth = true;
else {
	if(! $authController->sessionAuthenticate()) {
		session_destroy();
		$not_auth = true;
	}
}
if(! empty($not_auth)) {
	$GLOBALS['log']->warn('Cancel vCard request: user not authenticated');
	header('HTTP/1.1 401 Not Authorized');
	die('User is not authenticated');
}


if(isset($_SESSION['authenticated_user_language']) && $_SESSION['authenticated_user_language'] != '')
{
	$current_language = $_SESSION['authenticated_user_language'];
}
else
{
	$current_language = AppConfig::setting('locale.defaults.language');
}


//set module and application string arrays based upon selected language

$app_strings = return_application_language($current_language);
$app_list_strings = return_app_list_strings_language($current_language);

$vcard = new vCard();
$bean = 'Contact';
if(isset($_REQUEST['bean_name']))
	$bean_name = clean_string($_REQUEST['bean_name']);
else if(isset($_REQUEST['module']))
	$bean_name = AppConfig::module_primary_bean($_REQUEST['module']);

$vcard->loadRecord($_REQUEST['record'], $bean_name);

$vcard->saveVCard();
sugar_cleanup();

?>
